/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Re=["exports","require","vs/base/common/uri","vs/workbench/api/common/extHost.protocol","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/async","vs/base/common/network","vs/base/common/strings","vs/platform/log/common/log","vs/base/common/errors","vs/base/common/types","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/base/common/path","vs/platform/extensions/common/extensions","vs/base/common/platform","vs/base/common/cancellation","vs/workbench/services/extensions/common/extensions","vs/base/common/buffer","vs/base/common/resources","vs/base/common/objects","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/editor/common/core/range","vs/platform/registry/common/platform","vs/workbench/api/common/extHostCommands","vs/base/common/severity","vs/base/common/uuid","vs/base/common/errorMessage","vs/base/common/glob","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/lazy","vs/base/common/themables","vs/platform/files/common/files","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/services/search/common/search","vs/base/common/extpath","vs/platform/configuration/common/configuration","vs/platform/workspace/common/workspace","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/base/common/ternarySearchTree","vs/base/common/iterator","vs/base/common/marshalling","vs/base/common/htmlContent","vs/platform/instantiation/common/extensions","vs/base/common/assert","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostWebview","vs/workbench/api/common/extHostFileSystemConsumer","vs/base/common/stopwatch","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/decorators","vs/base/common/mime","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/serviceCollection","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/base/common/process","vs/workbench/api/common/cache","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostTunnelService","vs/editor/common/languages","vs/base/common/performance","vs/base/common/idGenerator","vs/base/common/codicons","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/editor/common/core/position","vs/editor/common/model","vs/editor/common/model/textModelSearch","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/hash","vs/platform/markers/common/markers","vs/platform/progress/common/progress","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/implicitActivationEvents","vs/workbench/common/editor","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/authentication/common/authentication","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/numbers","vs/base/common/stream","vs/base/common/filters","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/editor/common/core/eolCounter","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/services/treeViewsDnd","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/languageSelector","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChatAgents2","vs/nls!vs/workbench/api/common/extHostChatProvider","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/configuration","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/editor/common/editorResolverService","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/log/common/logService","vs/platform/notification/common/notification","vs/platform/product/common/productService","vs/platform/configuration/common/configurationModels","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/notebook/common/notebookKernelService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostChat","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/notebook/common/notebookDocumentService","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostIssueReporter","vs/workbench/api/common/extHostTheming","vs/base/common/functional","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatProvider","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostDocuments","vs/base/common/collections","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/editor/common/model/mirrorTextModel","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/workbench/api/worker/extensionHostWorker"],Ae=function(fe){for(var e=[],S=0,F=fe.length;S<F;S++)e[S]=Re[fe[S]];return e};define(Re[68],Ae([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kh=e.$Jh=e.$Ih=void 0;function S(R){return(g,f,D)=>{let M=null,k=null;if(typeof D.value=="function"?(M="value",k=D.value):typeof D.get=="function"&&(M="get",k=D.get),!k)throw new Error("not supported");D[M]=R(k,f)}}function F(R,g,f){let D=null,M=null;if(typeof f.value=="function"?(D="value",M=f.value,M.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof f.get=="function"&&(D="get",M=f.get),!M)throw new Error("not supported");const k=`$memoize$${g}`;f[D]=function(...l){return this.hasOwnProperty(k)||Object.defineProperty(this,k,{configurable:!1,enumerable:!1,writable:!1,value:M.apply(this,l)}),this[k]}}e.$Ih=F;function P(R,g,f){return S((D,M)=>{const k=`$debounce$${M}`,l=`$debounce$result$${M}`;return function(...v){this[l]||(this[l]=f?f():void 0),clearTimeout(this[k]),g&&(this[l]=g(this[l],...v),v=[this[l]]),this[k]=setTimeout(()=>{D.apply(this,v),this[l]=f?f():void 0},R)}})}e.$Jh=P;function L(R,g,f){return S((D,M)=>{const k=`$throttle$timer$${M}`,l=`$throttle$result$${M}`,v=`$throttle$lastRun$${M}`,$=`$throttle$pending$${M}`;return function(...s){if(this[l]||(this[l]=f?f():void 0),(this[v]===null||this[v]===void 0)&&(this[v]=-Number.MAX_VALUE),g&&(this[l]=g(this[l],...s)),this[$])return;const c=this[v]+R;c<=Date.now()?(this[v]=Date.now(),D.apply(this,[this[l]]),this[l]=f?f():void 0):(this[$]=!0,this[k]=setTimeout(()=>{this[$]=!1,this[v]=Date.now(),D.apply(this,[this[l]]),this[l]=f?f():void 0},c-Date.now()))}})}e.$Kh=L}),define(Re[88],Ae([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kO=e.$jO=void 0;class S{constructor(P){this.a=P,this.b=0}nextId(){return this.a+ ++this.b}}e.$jO=S,e.$kO=new S("id#")}),define(Re[120],Ae([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xn=e.$wn=e.$vn=e.$un=e.$tn=e.$sn=e.$rn=e.$qn=e.$pn=e.$on=e.$nn=e.$mn=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var S;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(S||(e.ScanError=S={}));var F;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(F||(e.SyntaxKind=F={}));var P;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(P||(e.ParseErrorCode=P={}));var L;(function(i){i.DEFAULT={allowTrailingComma:!0}})(L||(e.ParseOptions=L={}));function R(i,p=!1){let u=0;const o=i.length;let E="",w=0,m=16,I=0;function d(U){let C=0,O=0;for(;C<U;){const V=i.charCodeAt(u);if(V>=48&&V<=57)O=O*16+V-48;else if(V>=65&&V<=70)O=O*16+V-65+10;else if(V>=97&&V<=102)O=O*16+V-97+10;else break;u++,C++}return C<U&&(O=-1),O}function y(U){u=U,E="",w=0,m=16,I=0}function b(){const U=u;if(i.charCodeAt(u)===48)u++;else for(u++;u<i.length&&D(i.charCodeAt(u));)u++;if(u<i.length&&i.charCodeAt(u)===46)if(u++,u<i.length&&D(i.charCodeAt(u)))for(u++;u<i.length&&D(i.charCodeAt(u));)u++;else return I=3,i.substring(U,u);let C=u;if(u<i.length&&(i.charCodeAt(u)===69||i.charCodeAt(u)===101))if(u++,(u<i.length&&i.charCodeAt(u)===43||i.charCodeAt(u)===45)&&u++,u<i.length&&D(i.charCodeAt(u))){for(u++;u<i.length&&D(i.charCodeAt(u));)u++;C=u}else I=3;return i.substring(U,C)}function A(){let U="",C=u;for(;;){if(u>=o){U+=i.substring(C,u),I=2;break}const O=i.charCodeAt(u);if(O===34){U+=i.substring(C,u),u++;break}if(O===92){if(U+=i.substring(C,u),u++,u>=o){I=2;break}switch(i.charCodeAt(u++)){case 34:U+='"';break;case 92:U+="\\";break;case 47:U+="/";break;case 98:U+="\b";break;case 102:U+="\f";break;case 110:U+=`
`;break;case 114:U+="\r";break;case 116:U+="	";break;case 117:{const re=d(4);re>=0?U+=String.fromCharCode(re):I=4;break}default:I=5}C=u;continue}if(O>=0&&O<=31)if(f(O)){U+=i.substring(C,u),I=2;break}else I=6;u++}return U}function T(){if(E="",I=0,w=u,u>=o)return w=o,m=17;let U=i.charCodeAt(u);if(g(U)){do u++,E+=String.fromCharCode(U),U=i.charCodeAt(u);while(g(U));return m=15}if(f(U))return u++,E+=String.fromCharCode(U),U===13&&i.charCodeAt(u)===10&&(u++,E+=`
`),m=14;switch(U){case 123:return u++,m=1;case 125:return u++,m=2;case 91:return u++,m=3;case 93:return u++,m=4;case 58:return u++,m=6;case 44:return u++,m=5;case 34:return u++,E=A(),m=10;case 47:{const C=u-1;if(i.charCodeAt(u+1)===47){for(u+=2;u<o&&!f(i.charCodeAt(u));)u++;return E=i.substring(C,u),m=12}if(i.charCodeAt(u+1)===42){u+=2;const O=o-1;let V=!1;for(;u<O;){if(i.charCodeAt(u)===42&&i.charCodeAt(u+1)===47){u+=2,V=!0;break}u++}return V||(u++,I=1),E=i.substring(C,u),m=13}return E+=String.fromCharCode(U),u++,m=16}case 45:if(E+=String.fromCharCode(U),u++,u===o||!D(i.charCodeAt(u)))return m=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return E+=b(),m=11;default:for(;u<o&&G(U);)u++,U=i.charCodeAt(u);if(w!==u){switch(E=i.substring(w,u),E){case"true":return m=8;case"false":return m=9;case"null":return m=7}return m=16}return E+=String.fromCharCode(U),u++,m=16}}function G(U){if(g(U)||f(U))return!1;switch(U){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function W(){let U;do U=T();while(U>=12&&U<=15);return U}return{setPosition:y,getPosition:()=>u,scan:p?W:T,getToken:()=>m,getTokenValue:()=>E,getTokenOffset:()=>w,getTokenLength:()=>u-w,getTokenError:()=>I}}e.$mn=R;function g(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function f(i){return i===10||i===13||i===8232||i===8233}function D(i){return i>=48&&i<=57}var M;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(M||(M={}));function k(i,p){const u=[],o=new Object;let E;const w={value:{},offset:0,length:0,type:"object",parent:void 0};let m=!1;function I(d,y,b,A){w.value=d,w.offset=y,w.length=b,w.type=A,w.colonOffset=void 0,E=w}try{r(i,{onObjectBegin:(d,y)=>{if(p<=d)throw o;E=void 0,m=p>d,u.push("")},onObjectProperty:(d,y,b)=>{if(p<y||(I(d,y,b,"property"),u[u.length-1]=d,p<=y+b))throw o},onObjectEnd:(d,y)=>{if(p<=d)throw o;E=void 0,u.pop()},onArrayBegin:(d,y)=>{if(p<=d)throw o;E=void 0,u.push(0)},onArrayEnd:(d,y)=>{if(p<=d)throw o;E=void 0,u.pop()},onLiteralValue:(d,y,b)=>{if(p<y||(I(d,y,b,h(d)),p<=y+b))throw o},onSeparator:(d,y,b)=>{if(p<=y)throw o;if(d===":"&&E&&E.type==="property")E.colonOffset=y,m=!1,E=void 0;else if(d===","){const A=u[u.length-1];typeof A=="number"?u[u.length-1]=A+1:(m=!0,u[u.length-1]=""),E=void 0}}})}catch(d){if(d!==o)throw d}return{path:u,previousNode:E,isAtPropertyKey:m,matches:d=>{let y=0;for(let b=0;y<d.length&&b<u.length;b++)if(d[y]===u[b]||d[y]==="*")y++;else if(d[y]!=="**")return!1;return y===d.length}}}e.$nn=k;function l(i,p=[],u=L.DEFAULT){let o=null,E=[];const w=[];function m(d){Array.isArray(E)?E.push(d):o!==null&&(E[o]=d)}return r(i,{onObjectBegin:()=>{const d={};m(d),w.push(E),E=d,o=null},onObjectProperty:d=>{o=d},onObjectEnd:()=>{E=w.pop()},onArrayBegin:()=>{const d=[];m(d),w.push(E),E=d,o=null},onArrayEnd:()=>{E=w.pop()},onLiteralValue:m,onError:(d,y,b)=>{p.push({error:d,offset:y,length:b})}},u),E[0]}e.$on=l;function v(i,p=[],u=L.DEFAULT){let o={type:"array",offset:-1,length:-1,children:[],parent:void 0};function E(d){o.type==="property"&&(o.length=d-o.offset,o=o.parent)}function w(d){return o.children.push(d),d}r(i,{onObjectBegin:d=>{o=w({type:"object",offset:d,length:-1,parent:o,children:[]})},onObjectProperty:(d,y,b)=>{o=w({type:"property",offset:y,length:-1,parent:o,children:[]}),o.children.push({type:"string",value:d,offset:y,length:b,parent:o})},onObjectEnd:(d,y)=>{o.length=d+y-o.offset,o=o.parent,E(d+y)},onArrayBegin:(d,y)=>{o=w({type:"array",offset:d,length:-1,parent:o,children:[]})},onArrayEnd:(d,y)=>{o.length=d+y-o.offset,o=o.parent,E(d+y)},onLiteralValue:(d,y,b)=>{w({type:h(d),offset:y,length:b,parent:o,value:d}),E(y+b)},onSeparator:(d,y,b)=>{o.type==="property"&&(d===":"?o.colonOffset=y:d===","&&E(y))},onError:(d,y,b)=>{p.push({error:d,offset:y,length:b})}},u);const I=o.children[0];return I&&delete I.parent,I}e.$pn=v;function $(i,p){if(!i)return;let u=i;for(const o of p)if(typeof o=="string"){if(u.type!=="object"||!Array.isArray(u.children))return;let E=!1;for(const w of u.children)if(Array.isArray(w.children)&&w.children[0].value===o){u=w.children[1],E=!0;break}if(!E)return}else{const E=o;if(u.type!=="array"||E<0||!Array.isArray(u.children)||E>=u.children.length)return;u=u.children[E]}return u}e.$qn=$;function s(i){if(!i.parent||!i.parent.children)return[];const p=s(i.parent);if(i.parent.type==="property"){const u=i.parent.children[0].value;p.push(u)}else if(i.parent.type==="array"){const u=i.parent.children.indexOf(i);u!==-1&&p.push(u)}return p}e.$rn=s;function c(i){switch(i.type){case"array":return i.children.map(c);case"object":{const p=Object.create(null);for(const u of i.children){const o=u.children[1];o&&(p[u.children[0].value]=c(o))}return p}case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.$sn=c;function t(i,p,u=!1){return p>=i.offset&&p<i.offset+i.length||u&&p===i.offset+i.length}e.$tn=t;function n(i,p,u=!1){if(t(i,p,u)){const o=i.children;if(Array.isArray(o))for(let E=0;E<o.length&&o[E].offset<=p;E++){const w=n(o[E],p,u);if(w)return w}return i}}e.$un=n;function r(i,p,u=L.DEFAULT){const o=R(i,!1);function E(se){return se?()=>se(o.getTokenOffset(),o.getTokenLength()):()=>!0}function w(se){return se?$e=>se($e,o.getTokenOffset(),o.getTokenLength()):()=>!0}const m=E(p.onObjectBegin),I=w(p.onObjectProperty),d=E(p.onObjectEnd),y=E(p.onArrayBegin),b=E(p.onArrayEnd),A=w(p.onLiteralValue),T=w(p.onSeparator),G=E(p.onComment),W=w(p.onError),U=u&&u.disallowComments,C=u&&u.allowTrailingComma;function O(){for(;;){const se=o.scan();switch(o.getTokenError()){case 4:V(14);break;case 5:V(15);break;case 3:V(13);break;case 1:U||V(11);break;case 2:V(12);break;case 6:V(16);break}switch(se){case 12:case 13:U?V(10):G();break;case 16:V(1);break;case 15:case 14:break;default:return se}}}function V(se,$e=[],ee=[]){if(W(se),$e.length+ee.length>0){let Q=o.getToken();for(;Q!==17;){if($e.indexOf(Q)!==-1){O();break}else if(ee.indexOf(Q)!==-1)break;Q=O()}}}function re(se){const $e=o.getTokenValue();return se?A($e):I($e),O(),!0}function ue(){switch(o.getToken()){case 11:{let se=0;try{se=JSON.parse(o.getTokenValue()),typeof se!="number"&&(V(2),se=0)}catch{V(2)}A(se);break}case 7:A(null);break;case 8:A(!0);break;case 9:A(!1);break;default:return!1}return O(),!0}function ye(){return o.getToken()!==10?(V(3,[],[2,5]),!1):(re(!1),o.getToken()===6?(T(":"),O(),ve()||V(4,[],[2,5])):V(5,[],[2,5]),!0)}function De(){m(),O();let se=!1;for(;o.getToken()!==2&&o.getToken()!==17;){if(o.getToken()===5){if(se||V(4,[],[]),T(","),O(),o.getToken()===2&&C)break}else se&&V(6,[],[]);ye()||V(4,[],[2,5]),se=!0}return d(),o.getToken()!==2?V(7,[2],[]):O(),!0}function he(){y(),O();let se=!1;for(;o.getToken()!==4&&o.getToken()!==17;){if(o.getToken()===5){if(se||V(4,[],[]),T(","),O(),o.getToken()===4&&C)break}else se&&V(6,[],[]);ve()||V(4,[],[4,5]),se=!0}return b(),o.getToken()!==4?V(8,[4],[]):O(),!0}function ve(){switch(o.getToken()){case 3:return he();case 1:return De();case 10:return re(!0);default:return ue()}}return O(),o.getToken()===17?u.allowEmptyContent?!0:(V(4,[],[]),!1):ve()?(o.getToken()!==17&&V(9,[],[]),!0):(V(4,[],[]),!1)}e.$vn=r;function a(i,p){const u=R(i),o=[];let E,w=0,m;do switch(m=u.getPosition(),E=u.scan(),E){case 12:case 13:case 17:w!==m&&o.push(i.substring(w,m)),p!==void 0&&o.push(u.getTokenValue().replace(/[^\r\n]/g,p)),w=u.getPosition();break}while(E!==17);return o.join("")}e.$wn=a;function h(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.$xn=h}),function(fe,e){typeof define=="function"&&define.amd?define(Re[121],Ae([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(fe=typeof globalThis<"u"?globalThis:fe||self,e(fe.marked={}))}(this,function(fe){"use strict";function e(Ce,we){for(var ge=0;ge<we.length;ge++){var J=we[ge];J.enumerable=J.enumerable||!1,J.configurable=!0,"value"in J&&(J.writable=!0),Object.defineProperty(Ce,J.key,J)}}function S(Ce,we,ge){return we&&e(Ce.prototype,we),ge&&e(Ce,ge),Object.defineProperty(Ce,"prototype",{writable:!1}),Ce}function F(Ce,we){if(Ce){if(typeof Ce=="string")return P(Ce,we);var ge=Object.prototype.toString.call(Ce).slice(8,-1);if(ge==="Object"&&Ce.constructor&&(ge=Ce.constructor.name),ge==="Map"||ge==="Set")return Array.from(Ce);if(ge==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ge))return P(Ce,we)}}function P(Ce,we){(we==null||we>Ce.length)&&(we=Ce.length);for(var ge=0,J=new Array(we);ge<we;ge++)J[ge]=Ce[ge];return J}function L(Ce,we){var ge=typeof Symbol<"u"&&Ce[Symbol.iterator]||Ce["@@iterator"];if(ge)return(ge=ge.call(Ce)).next.bind(ge);if(Array.isArray(Ce)||(ge=F(Ce))||we&&Ce&&typeof Ce.length=="number"){ge&&(Ce=ge);var J=0;return function(){return J>=Ce.length?{done:!0}:{done:!1,value:Ce[J++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function R(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}fe.defaults=R();function g(Ce){fe.defaults=Ce}var f=/[&<>"']/,D=/[&<>"']/g,M=/[<>"']|&(?!#?\w+;)/,k=/[<>"']|&(?!#?\w+;)/g,l={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},v=function(we){return l[we]};function $(Ce,we){if(we){if(f.test(Ce))return Ce.replace(D,v)}else if(M.test(Ce))return Ce.replace(k,v);return Ce}var s=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function c(Ce){return Ce.replace(s,function(we,ge){return ge=ge.toLowerCase(),ge==="colon"?":":ge.charAt(0)==="#"?ge.charAt(1)==="x"?String.fromCharCode(parseInt(ge.substring(2),16)):String.fromCharCode(+ge.substring(1)):""})}var t=/(^|[^\[])\^/g;function n(Ce,we){Ce=typeof Ce=="string"?Ce:Ce.source,we=we||"";var ge={replace:function(x,le){return le=le.source||le,le=le.replace(t,"$1"),Ce=Ce.replace(x,le),ge},getRegex:function(){return new RegExp(Ce,we)}};return ge}var r=/[^\w:]/g,a=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function h(Ce,we,ge){if(Ce){var J;try{J=decodeURIComponent(c(ge)).replace(r,"").toLowerCase()}catch{return null}if(J.indexOf("javascript:")===0||J.indexOf("vbscript:")===0||J.indexOf("data:")===0)return null}we&&!a.test(ge)&&(ge=E(we,ge));try{ge=encodeURI(ge).replace(/%25/g,"%")}catch{return null}return ge}var i={},p=/^[^:]+:\/*[^/]*$/,u=/^([^:]+:)[\s\S]*$/,o=/^([^:]+:\/*[^/]*)[\s\S]*$/;function E(Ce,we){i[" "+Ce]||(p.test(Ce)?i[" "+Ce]=Ce+"/":i[" "+Ce]=d(Ce,"/",!0)),Ce=i[" "+Ce];var ge=Ce.indexOf(":")===-1;return we.substring(0,2)==="//"?ge?we:Ce.replace(u,"$1")+we:we.charAt(0)==="/"?ge?we:Ce.replace(o,"$1")+we:Ce+we}var w={exec:function(){}};function m(Ce){for(var we=1,ge,J;we<arguments.length;we++){ge=arguments[we];for(J in ge)Object.prototype.hasOwnProperty.call(ge,J)&&(Ce[J]=ge[J])}return Ce}function I(Ce,we){var ge=Ce.replace(/\|/g,function(le,de,Pe){for(var me=!1,Ie=de;--Ie>=0&&Pe[Ie]==="\\";)me=!me;return me?"|":" |"}),J=ge.split(/ \|/),x=0;if(J[0].trim()||J.shift(),J.length>0&&!J[J.length-1].trim()&&J.pop(),J.length>we)J.splice(we);else for(;J.length<we;)J.push("");for(;x<J.length;x++)J[x]=J[x].trim().replace(/\\\|/g,"|");return J}function d(Ce,we,ge){var J=Ce.length;if(J===0)return"";for(var x=0;x<J;){var le=Ce.charAt(J-x-1);if(le===we&&!ge)x++;else if(le!==we&&ge)x++;else break}return Ce.slice(0,J-x)}function y(Ce,we){if(Ce.indexOf(we[1])===-1)return-1;for(var ge=Ce.length,J=0,x=0;x<ge;x++)if(Ce[x]==="\\")x++;else if(Ce[x]===we[0])J++;else if(Ce[x]===we[1]&&(J--,J<0))return x;return-1}function b(Ce){Ce&&Ce.sanitize&&!Ce.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function A(Ce,we){if(we<1)return"";for(var ge="";we>1;)we&1&&(ge+=Ce),we>>=1,Ce+=Ce;return ge+Ce}function T(Ce,we,ge,J){var x=we.href,le=we.title?$(we.title):null,de=Ce[1].replace(/\\([\[\]])/g,"$1");if(Ce[0].charAt(0)!=="!"){J.state.inLink=!0;var Pe={type:"link",raw:ge,href:x,title:le,text:de,tokens:J.inlineTokens(de)};return J.state.inLink=!1,Pe}return{type:"image",raw:ge,href:x,title:le,text:$(de)}}function G(Ce,we){var ge=Ce.match(/^(\s+)(?:```)/);if(ge===null)return we;var J=ge[1];return we.split(`
`).map(function(x){var le=x.match(/^\s+/);if(le===null)return x;var de=le[0];return de.length>=J.length?x.slice(J.length):x}).join(`
`)}var W=function(){function Ce(ge){this.options=ge||fe.defaults}var we=Ce.prototype;return we.space=function(J){var x=this.rules.block.newline.exec(J);if(x&&x[0].length>0)return{type:"space",raw:x[0]}},we.code=function(J){var x=this.rules.block.code.exec(J);if(x){var le=x[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:x[0],codeBlockStyle:"indented",text:this.options.pedantic?le:d(le,`
`)}}},we.fences=function(J){var x=this.rules.block.fences.exec(J);if(x){var le=x[0],de=G(le,x[3]||"");return{type:"code",raw:le,lang:x[2]?x[2].trim():x[2],text:de}}},we.heading=function(J){var x=this.rules.block.heading.exec(J);if(x){var le=x[2].trim();if(/#$/.test(le)){var de=d(le,"#");(this.options.pedantic||!de||/ $/.test(de))&&(le=de.trim())}return{type:"heading",raw:x[0],depth:x[1].length,text:le,tokens:this.lexer.inline(le)}}},we.hr=function(J){var x=this.rules.block.hr.exec(J);if(x)return{type:"hr",raw:x[0]}},we.blockquote=function(J){var x=this.rules.block.blockquote.exec(J);if(x){var le=x[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:x[0],tokens:this.lexer.blockTokens(le,[]),text:le}}},we.list=function(J){var x=this.rules.block.list.exec(J);if(x){var le,de,Pe,me,Ie,Me,ze,N,z,K,H,te,oe=x[1].trim(),Oe=oe.length>1,Ve={type:"list",raw:"",ordered:Oe,start:Oe?+oe.slice(0,-1):"",loose:!1,items:[]};oe=Oe?"\\d{1,9}\\"+oe.slice(-1):"\\"+oe,this.options.pedantic&&(oe=Oe?oe:"[*+-]");for(var He=new RegExp("^( {0,3}"+oe+")((?:[	 ][^\\n]*)?(?:\\n|$))");J&&(te=!1,!(!(x=He.exec(J))||this.rules.block.hr.test(J)));){if(le=x[0],J=J.substring(le.length),N=x[2].split(`
`,1)[0],z=J.split(`
`,1)[0],this.options.pedantic?(me=2,H=N.trimLeft()):(me=x[2].search(/[^ ]/),me=me>4?1:me,H=N.slice(me),me+=x[1].length),Me=!1,!N&&/^ *$/.test(z)&&(le+=z+`
`,J=J.substring(z.length+1),te=!0),!te)for(var xe=new RegExp("^ {0,"+Math.min(3,me-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),tt=new RegExp("^ {0,"+Math.min(3,me-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),lt=new RegExp("^ {0,"+Math.min(3,me-1)+"}(?:```|~~~)"),rt=new RegExp("^ {0,"+Math.min(3,me-1)+"}#");J&&(K=J.split(`
`,1)[0],N=K,this.options.pedantic&&(N=N.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(lt.test(N)||rt.test(N)||xe.test(N)||tt.test(J)));){if(N.search(/[^ ]/)>=me||!N.trim())H+=`
`+N.slice(me);else if(!Me)H+=`
`+N;else break;!Me&&!N.trim()&&(Me=!0),le+=K+`
`,J=J.substring(K.length+1)}Ve.loose||(ze?Ve.loose=!0:/\n *\n *$/.test(le)&&(ze=!0)),this.options.gfm&&(de=/^\[[ xX]\] /.exec(H),de&&(Pe=de[0]!=="[ ] ",H=H.replace(/^\[[ xX]\] +/,""))),Ve.items.push({type:"list_item",raw:le,task:!!de,checked:Pe,loose:!1,text:H}),Ve.raw+=le}Ve.items[Ve.items.length-1].raw=le.trimRight(),Ve.items[Ve.items.length-1].text=H.trimRight(),Ve.raw=Ve.raw.trimRight();var it=Ve.items.length;for(Ie=0;Ie<it;Ie++){this.lexer.state.top=!1,Ve.items[Ie].tokens=this.lexer.blockTokens(Ve.items[Ie].text,[]);var ot=Ve.items[Ie].tokens.filter(function(et){return et.type==="space"}),Be=ot.every(function(et){for(var Y=et.raw.split(""),X=0,pe=L(Y),We;!(We=pe()).done;){var Xe=We.value;if(Xe===`
`&&(X+=1),X>1)return!0}return!1});!Ve.loose&&ot.length&&Be&&(Ve.loose=!0,Ve.items[Ie].loose=!0)}return Ve}},we.html=function(J){var x=this.rules.block.html.exec(J);if(x){var le={type:"html",raw:x[0],pre:!this.options.sanitizer&&(x[1]==="pre"||x[1]==="script"||x[1]==="style"),text:x[0]};if(this.options.sanitize){var de=this.options.sanitizer?this.options.sanitizer(x[0]):$(x[0]);le.type="paragraph",le.text=de,le.tokens=this.lexer.inline(de)}return le}},we.def=function(J){var x=this.rules.block.def.exec(J);if(x){x[3]&&(x[3]=x[3].substring(1,x[3].length-1));var le=x[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:le,raw:x[0],href:x[2],title:x[3]}}},we.table=function(J){var x=this.rules.block.table.exec(J);if(x){var le={type:"table",header:I(x[1]).map(function(ze){return{text:ze}}),align:x[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:x[3]&&x[3].trim()?x[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(le.header.length===le.align.length){le.raw=x[0];var de=le.align.length,Pe,me,Ie,Me;for(Pe=0;Pe<de;Pe++)/^ *-+: *$/.test(le.align[Pe])?le.align[Pe]="right":/^ *:-+: *$/.test(le.align[Pe])?le.align[Pe]="center":/^ *:-+ *$/.test(le.align[Pe])?le.align[Pe]="left":le.align[Pe]=null;for(de=le.rows.length,Pe=0;Pe<de;Pe++)le.rows[Pe]=I(le.rows[Pe],le.header.length).map(function(ze){return{text:ze}});for(de=le.header.length,me=0;me<de;me++)le.header[me].tokens=this.lexer.inline(le.header[me].text);for(de=le.rows.length,me=0;me<de;me++)for(Me=le.rows[me],Ie=0;Ie<Me.length;Ie++)Me[Ie].tokens=this.lexer.inline(Me[Ie].text);return le}}},we.lheading=function(J){var x=this.rules.block.lheading.exec(J);if(x)return{type:"heading",raw:x[0],depth:x[2].charAt(0)==="="?1:2,text:x[1],tokens:this.lexer.inline(x[1])}},we.paragraph=function(J){var x=this.rules.block.paragraph.exec(J);if(x){var le=x[1].charAt(x[1].length-1)===`
`?x[1].slice(0,-1):x[1];return{type:"paragraph",raw:x[0],text:le,tokens:this.lexer.inline(le)}}},we.text=function(J){var x=this.rules.block.text.exec(J);if(x)return{type:"text",raw:x[0],text:x[0],tokens:this.lexer.inline(x[0])}},we.escape=function(J){var x=this.rules.inline.escape.exec(J);if(x)return{type:"escape",raw:x[0],text:$(x[1])}},we.tag=function(J){var x=this.rules.inline.tag.exec(J);if(x)return!this.lexer.state.inLink&&/^<a /i.test(x[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(x[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(x[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(x[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:x[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(x[0]):$(x[0]):x[0]}},we.link=function(J){var x=this.rules.inline.link.exec(J);if(x){var le=x[2].trim();if(!this.options.pedantic&&/^</.test(le)){if(!/>$/.test(le))return;var de=d(le.slice(0,-1),"\\");if((le.length-de.length)%2===0)return}else{var Pe=y(x[2],"()");if(Pe>-1){var me=x[0].indexOf("!")===0?5:4,Ie=me+x[1].length+Pe;x[2]=x[2].substring(0,Pe),x[0]=x[0].substring(0,Ie).trim(),x[3]=""}}var Me=x[2],ze="";if(this.options.pedantic){var N=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Me);N&&(Me=N[1],ze=N[3])}else ze=x[3]?x[3].slice(1,-1):"";return Me=Me.trim(),/^</.test(Me)&&(this.options.pedantic&&!/>$/.test(le)?Me=Me.slice(1):Me=Me.slice(1,-1)),T(x,{href:Me&&Me.replace(this.rules.inline._escapes,"$1"),title:ze&&ze.replace(this.rules.inline._escapes,"$1")},x[0],this.lexer)}},we.reflink=function(J,x){var le;if((le=this.rules.inline.reflink.exec(J))||(le=this.rules.inline.nolink.exec(J))){var de=(le[2]||le[1]).replace(/\s+/g," ");if(de=x[de.toLowerCase()],!de||!de.href){var Pe=le[0].charAt(0);return{type:"text",raw:Pe,text:Pe}}return T(le,de,le[0],this.lexer)}},we.emStrong=function(J,x,le){le===void 0&&(le="");var de=this.rules.inline.emStrong.lDelim.exec(J);if(de&&!(de[3]&&le.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Pe=de[1]||de[2]||"";if(!Pe||Pe&&(le===""||this.rules.inline.punctuation.exec(le))){var me=de[0].length-1,Ie,Me,ze=me,N=0,z=de[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(z.lastIndex=0,x=x.slice(-1*J.length+me);(de=z.exec(x))!=null;)if(Ie=de[1]||de[2]||de[3]||de[4]||de[5]||de[6],!!Ie){if(Me=Ie.length,de[3]||de[4]){ze+=Me;continue}else if((de[5]||de[6])&&me%3&&!((me+Me)%3)){N+=Me;continue}if(ze-=Me,!(ze>0)){if(Me=Math.min(Me,Me+ze+N),Math.min(me,Me)%2){var K=J.slice(1,me+de.index+Me);return{type:"em",raw:J.slice(0,me+de.index+Me+1),text:K,tokens:this.lexer.inlineTokens(K)}}var H=J.slice(2,me+de.index+Me-1);return{type:"strong",raw:J.slice(0,me+de.index+Me+1),text:H,tokens:this.lexer.inlineTokens(H)}}}}}},we.codespan=function(J){var x=this.rules.inline.code.exec(J);if(x){var le=x[2].replace(/\n/g," "),de=/[^ ]/.test(le),Pe=/^ /.test(le)&&/ $/.test(le);return de&&Pe&&(le=le.substring(1,le.length-1)),le=$(le,!0),{type:"codespan",raw:x[0],text:le}}},we.br=function(J){var x=this.rules.inline.br.exec(J);if(x)return{type:"br",raw:x[0]}},we.del=function(J){var x=this.rules.inline.del.exec(J);if(x)return{type:"del",raw:x[0],text:x[2],tokens:this.lexer.inlineTokens(x[2])}},we.autolink=function(J,x){var le=this.rules.inline.autolink.exec(J);if(le){var de,Pe;return le[2]==="@"?(de=$(this.options.mangle?x(le[1]):le[1]),Pe="mailto:"+de):(de=$(le[1]),Pe=de),{type:"link",raw:le[0],text:de,href:Pe,tokens:[{type:"text",raw:de,text:de}]}}},we.url=function(J,x){var le;if(le=this.rules.inline.url.exec(J)){var de,Pe;if(le[2]==="@")de=$(this.options.mangle?x(le[0]):le[0]),Pe="mailto:"+de;else{var me;do me=le[0],le[0]=this.rules.inline._backpedal.exec(le[0])[0];while(me!==le[0]);de=$(le[0]),le[1]==="www."?Pe="http://"+de:Pe=de}return{type:"link",raw:le[0],text:de,href:Pe,tokens:[{type:"text",raw:de,text:de}]}}},we.inlineText=function(J,x){var le=this.rules.inline.text.exec(J);if(le){var de;return this.lexer.state.inRawBlock?de=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(le[0]):$(le[0]):le[0]:de=$(this.options.smartypants?x(le[0]):le[0]),{type:"text",raw:le[0],text:de}}},Ce}(),U={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:w,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};U._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,U._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,U.def=n(U.def).replace("label",U._label).replace("title",U._title).getRegex(),U.bullet=/(?:[*+-]|\d{1,9}[.)])/,U.listItemStart=n(/^( *)(bull) */).replace("bull",U.bullet).getRegex(),U.list=n(U.list).replace(/bull/g,U.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+U.def.source+")").getRegex(),U._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",U._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,U.html=n(U.html,"i").replace("comment",U._comment).replace("tag",U._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),U.paragraph=n(U._paragraph).replace("hr",U.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",U._tag).getRegex(),U.blockquote=n(U.blockquote).replace("paragraph",U.paragraph).getRegex(),U.normal=m({},U),U.gfm=m({},U.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),U.gfm.table=n(U.gfm.table).replace("hr",U.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",U._tag).getRegex(),U.gfm.paragraph=n(U._paragraph).replace("hr",U.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",U.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",U._tag).getRegex(),U.pedantic=m({},U.normal,{html:n(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",U._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:w,paragraph:n(U.normal._paragraph).replace("hr",U.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",U.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var C={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:w,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:w,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};C._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",C.punctuation=n(C.punctuation).replace(/punctuation/g,C._punctuation).getRegex(),C.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,C.escapedEmSt=/\\\*|\\_/g,C._comment=n(U._comment).replace("(?:-->|$)","-->").getRegex(),C.emStrong.lDelim=n(C.emStrong.lDelim).replace(/punct/g,C._punctuation).getRegex(),C.emStrong.rDelimAst=n(C.emStrong.rDelimAst,"g").replace(/punct/g,C._punctuation).getRegex(),C.emStrong.rDelimUnd=n(C.emStrong.rDelimUnd,"g").replace(/punct/g,C._punctuation).getRegex(),C._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,C._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,C._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,C.autolink=n(C.autolink).replace("scheme",C._scheme).replace("email",C._email).getRegex(),C._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,C.tag=n(C.tag).replace("comment",C._comment).replace("attribute",C._attribute).getRegex(),C._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,C._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,C._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,C.link=n(C.link).replace("label",C._label).replace("href",C._href).replace("title",C._title).getRegex(),C.reflink=n(C.reflink).replace("label",C._label).replace("ref",U._label).getRegex(),C.nolink=n(C.nolink).replace("ref",U._label).getRegex(),C.reflinkSearch=n(C.reflinkSearch,"g").replace("reflink",C.reflink).replace("nolink",C.nolink).getRegex(),C.normal=m({},C),C.pedantic=m({},C.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:n(/^!?\[(label)\]\((.*?)\)/).replace("label",C._label).getRegex(),reflink:n(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",C._label).getRegex()}),C.gfm=m({},C.normal,{escape:n(C.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),C.gfm.url=n(C.gfm.url,"i").replace("email",C.gfm._extended_email).getRegex(),C.breaks=m({},C.gfm,{br:n(C.br).replace("{2,}","*").getRegex(),text:n(C.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function O(Ce){return Ce.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function V(Ce){var we="",ge,J,x=Ce.length;for(ge=0;ge<x;ge++)J=Ce.charCodeAt(ge),Math.random()>.5&&(J="x"+J.toString(16)),we+="&#"+J+";";return we}var re=function(){function Ce(ge){this.tokens=[],this.tokens.links=Object.create(null),this.options=ge||fe.defaults,this.options.tokenizer=this.options.tokenizer||new W,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var J={block:U.normal,inline:C.normal};this.options.pedantic?(J.block=U.pedantic,J.inline=C.pedantic):this.options.gfm&&(J.block=U.gfm,this.options.breaks?J.inline=C.breaks:J.inline=C.gfm),this.tokenizer.rules=J}Ce.lex=function(J,x){var le=new Ce(x);return le.lex(J)},Ce.lexInline=function(J,x){var le=new Ce(x);return le.inlineTokens(J)};var we=Ce.prototype;return we.lex=function(J){J=J.replace(/\r\n|\r/g,`
`),this.blockTokens(J,this.tokens);for(var x;x=this.inlineQueue.shift();)this.inlineTokens(x.src,x.tokens);return this.tokens},we.blockTokens=function(J,x){var le=this;x===void 0&&(x=[]),this.options.pedantic?J=J.replace(/\t/g,"    ").replace(/^ +$/gm,""):J=J.replace(/^( *)(\t+)/gm,function(ze,N,z){return N+"    ".repeat(z.length)});for(var de,Pe,me,Ie;J;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(ze){return(de=ze.call({lexer:le},J,x))?(J=J.substring(de.raw.length),x.push(de),!0):!1}))){if(de=this.tokenizer.space(J)){J=J.substring(de.raw.length),de.raw.length===1&&x.length>0?x[x.length-1].raw+=`
`:x.push(de);continue}if(de=this.tokenizer.code(J)){J=J.substring(de.raw.length),Pe=x[x.length-1],Pe&&(Pe.type==="paragraph"||Pe.type==="text")?(Pe.raw+=`
`+de.raw,Pe.text+=`
`+de.text,this.inlineQueue[this.inlineQueue.length-1].src=Pe.text):x.push(de);continue}if(de=this.tokenizer.fences(J)){J=J.substring(de.raw.length),x.push(de);continue}if(de=this.tokenizer.heading(J)){J=J.substring(de.raw.length),x.push(de);continue}if(de=this.tokenizer.hr(J)){J=J.substring(de.raw.length),x.push(de);continue}if(de=this.tokenizer.blockquote(J)){J=J.substring(de.raw.length),x.push(de);continue}if(de=this.tokenizer.list(J)){J=J.substring(de.raw.length),x.push(de);continue}if(de=this.tokenizer.html(J)){J=J.substring(de.raw.length),x.push(de);continue}if(de=this.tokenizer.def(J)){J=J.substring(de.raw.length),Pe=x[x.length-1],Pe&&(Pe.type==="paragraph"||Pe.type==="text")?(Pe.raw+=`
`+de.raw,Pe.text+=`
`+de.raw,this.inlineQueue[this.inlineQueue.length-1].src=Pe.text):this.tokens.links[de.tag]||(this.tokens.links[de.tag]={href:de.href,title:de.title});continue}if(de=this.tokenizer.table(J)){J=J.substring(de.raw.length),x.push(de);continue}if(de=this.tokenizer.lheading(J)){J=J.substring(de.raw.length),x.push(de);continue}if(me=J,this.options.extensions&&this.options.extensions.startBlock&&function(){var ze=1/0,N=J.slice(1),z=void 0;le.options.extensions.startBlock.forEach(function(K){z=K.call({lexer:this},N),typeof z=="number"&&z>=0&&(ze=Math.min(ze,z))}),ze<1/0&&ze>=0&&(me=J.substring(0,ze+1))}(),this.state.top&&(de=this.tokenizer.paragraph(me))){Pe=x[x.length-1],Ie&&Pe.type==="paragraph"?(Pe.raw+=`
`+de.raw,Pe.text+=`
`+de.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Pe.text):x.push(de),Ie=me.length!==J.length,J=J.substring(de.raw.length);continue}if(de=this.tokenizer.text(J)){J=J.substring(de.raw.length),Pe=x[x.length-1],Pe&&Pe.type==="text"?(Pe.raw+=`
`+de.raw,Pe.text+=`
`+de.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Pe.text):x.push(de);continue}if(J){var Me="Infinite loop on byte: "+J.charCodeAt(0);if(this.options.silent){console.error(Me);break}else throw new Error(Me)}}return this.state.top=!0,x},we.inline=function(J,x){return x===void 0&&(x=[]),this.inlineQueue.push({src:J,tokens:x}),x},we.inlineTokens=function(J,x){var le=this;x===void 0&&(x=[]);var de,Pe,me,Ie=J,Me,ze,N;if(this.tokens.links){var z=Object.keys(this.tokens.links);if(z.length>0)for(;(Me=this.tokenizer.rules.inline.reflinkSearch.exec(Ie))!=null;)z.includes(Me[0].slice(Me[0].lastIndexOf("[")+1,-1))&&(Ie=Ie.slice(0,Me.index)+"["+A("a",Me[0].length-2)+"]"+Ie.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Me=this.tokenizer.rules.inline.blockSkip.exec(Ie))!=null;)Ie=Ie.slice(0,Me.index)+"["+A("a",Me[0].length-2)+"]"+Ie.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Me=this.tokenizer.rules.inline.escapedEmSt.exec(Ie))!=null;)Ie=Ie.slice(0,Me.index)+"++"+Ie.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;J;)if(ze||(N=""),ze=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(H){return(de=H.call({lexer:le},J,x))?(J=J.substring(de.raw.length),x.push(de),!0):!1}))){if(de=this.tokenizer.escape(J)){J=J.substring(de.raw.length),x.push(de);continue}if(de=this.tokenizer.tag(J)){J=J.substring(de.raw.length),Pe=x[x.length-1],Pe&&de.type==="text"&&Pe.type==="text"?(Pe.raw+=de.raw,Pe.text+=de.text):x.push(de);continue}if(de=this.tokenizer.link(J)){J=J.substring(de.raw.length),x.push(de);continue}if(de=this.tokenizer.reflink(J,this.tokens.links)){J=J.substring(de.raw.length),Pe=x[x.length-1],Pe&&de.type==="text"&&Pe.type==="text"?(Pe.raw+=de.raw,Pe.text+=de.text):x.push(de);continue}if(de=this.tokenizer.emStrong(J,Ie,N)){J=J.substring(de.raw.length),x.push(de);continue}if(de=this.tokenizer.codespan(J)){J=J.substring(de.raw.length),x.push(de);continue}if(de=this.tokenizer.br(J)){J=J.substring(de.raw.length),x.push(de);continue}if(de=this.tokenizer.del(J)){J=J.substring(de.raw.length),x.push(de);continue}if(de=this.tokenizer.autolink(J,V)){J=J.substring(de.raw.length),x.push(de);continue}if(!this.state.inLink&&(de=this.tokenizer.url(J,V))){J=J.substring(de.raw.length),x.push(de);continue}if(me=J,this.options.extensions&&this.options.extensions.startInline&&function(){var H=1/0,te=J.slice(1),oe=void 0;le.options.extensions.startInline.forEach(function(Oe){oe=Oe.call({lexer:this},te),typeof oe=="number"&&oe>=0&&(H=Math.min(H,oe))}),H<1/0&&H>=0&&(me=J.substring(0,H+1))}(),de=this.tokenizer.inlineText(me,O)){J=J.substring(de.raw.length),de.raw.slice(-1)!=="_"&&(N=de.raw.slice(-1)),ze=!0,Pe=x[x.length-1],Pe&&Pe.type==="text"?(Pe.raw+=de.raw,Pe.text+=de.text):x.push(de);continue}if(J){var K="Infinite loop on byte: "+J.charCodeAt(0);if(this.options.silent){console.error(K);break}else throw new Error(K)}}return x},S(Ce,null,[{key:"rules",get:function(){return{block:U,inline:C}}}]),Ce}(),ue=function(){function Ce(ge){this.options=ge||fe.defaults}var we=Ce.prototype;return we.code=function(J,x,le){var de=(x||"").match(/\S*/)[0];if(this.options.highlight){var Pe=this.options.highlight(J,de);Pe!=null&&Pe!==J&&(le=!0,J=Pe)}return J=J.replace(/\n$/,"")+`
`,de?'<pre><code class="'+this.options.langPrefix+$(de,!0)+'">'+(le?J:$(J,!0))+`</code></pre>
`:"<pre><code>"+(le?J:$(J,!0))+`</code></pre>
`},we.blockquote=function(J){return`<blockquote>
`+J+`</blockquote>
`},we.html=function(J){return J},we.heading=function(J,x,le,de){if(this.options.headerIds){var Pe=this.options.headerPrefix+de.slug(le);return"<h"+x+' id="'+Pe+'">'+J+"</h"+x+`>
`}return"<h"+x+">"+J+"</h"+x+`>
`},we.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},we.list=function(J,x,le){var de=x?"ol":"ul",Pe=x&&le!==1?' start="'+le+'"':"";return"<"+de+Pe+`>
`+J+"</"+de+`>
`},we.listitem=function(J){return"<li>"+J+`</li>
`},we.checkbox=function(J){return"<input "+(J?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},we.paragraph=function(J){return"<p>"+J+`</p>
`},we.table=function(J,x){return x&&(x="<tbody>"+x+"</tbody>"),`<table>
<thead>
`+J+`</thead>
`+x+`</table>
`},we.tablerow=function(J){return`<tr>
`+J+`</tr>
`},we.tablecell=function(J,x){var le=x.header?"th":"td",de=x.align?"<"+le+' align="'+x.align+'">':"<"+le+">";return de+J+("</"+le+`>
`)},we.strong=function(J){return"<strong>"+J+"</strong>"},we.em=function(J){return"<em>"+J+"</em>"},we.codespan=function(J){return"<code>"+J+"</code>"},we.br=function(){return this.options.xhtml?"<br/>":"<br>"},we.del=function(J){return"<del>"+J+"</del>"},we.link=function(J,x,le){if(J=h(this.options.sanitize,this.options.baseUrl,J),J===null)return le;var de='<a href="'+$(J)+'"';return x&&(de+=' title="'+x+'"'),de+=">"+le+"</a>",de},we.image=function(J,x,le){if(J=h(this.options.sanitize,this.options.baseUrl,J),J===null)return le;var de='<img src="'+J+'" alt="'+le+'"';return x&&(de+=' title="'+x+'"'),de+=this.options.xhtml?"/>":">",de},we.text=function(J){return J},Ce}(),ye=function(){function Ce(){}var we=Ce.prototype;return we.strong=function(J){return J},we.em=function(J){return J},we.codespan=function(J){return J},we.del=function(J){return J},we.html=function(J){return J},we.text=function(J){return J},we.link=function(J,x,le){return""+le},we.image=function(J,x,le){return""+le},we.br=function(){return""},Ce}(),De=function(){function Ce(){this.seen={}}var we=Ce.prototype;return we.serialize=function(J){return J.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},we.getNextSafeSlug=function(J,x){var le=J,de=0;if(this.seen.hasOwnProperty(le)){de=this.seen[J];do de++,le=J+"-"+de;while(this.seen.hasOwnProperty(le))}return x||(this.seen[J]=de,this.seen[le]=0),le},we.slug=function(J,x){x===void 0&&(x={});var le=this.serialize(J);return this.getNextSafeSlug(le,x.dryrun)},Ce}(),he=function(){function Ce(ge){this.options=ge||fe.defaults,this.options.renderer=this.options.renderer||new ue,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new ye,this.slugger=new De}Ce.parse=function(J,x){var le=new Ce(x);return le.parse(J)},Ce.parseInline=function(J,x){var le=new Ce(x);return le.parseInline(J)};var we=Ce.prototype;return we.parse=function(J,x){x===void 0&&(x=!0);var le="",de,Pe,me,Ie,Me,ze,N,z,K,H,te,oe,Oe,Ve,He,xe,tt,lt,rt,it=J.length;for(de=0;de<it;de++){if(H=J[de],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[H.type]&&(rt=this.options.extensions.renderers[H.type].call({parser:this},H),rt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(H.type))){le+=rt||"";continue}switch(H.type){case"space":continue;case"hr":{le+=this.renderer.hr();continue}case"heading":{le+=this.renderer.heading(this.parseInline(H.tokens),H.depth,c(this.parseInline(H.tokens,this.textRenderer)),this.slugger);continue}case"code":{le+=this.renderer.code(H.text,H.lang,H.escaped);continue}case"table":{for(z="",N="",Ie=H.header.length,Pe=0;Pe<Ie;Pe++)N+=this.renderer.tablecell(this.parseInline(H.header[Pe].tokens),{header:!0,align:H.align[Pe]});for(z+=this.renderer.tablerow(N),K="",Ie=H.rows.length,Pe=0;Pe<Ie;Pe++){for(ze=H.rows[Pe],N="",Me=ze.length,me=0;me<Me;me++)N+=this.renderer.tablecell(this.parseInline(ze[me].tokens),{header:!1,align:H.align[me]});K+=this.renderer.tablerow(N)}le+=this.renderer.table(z,K);continue}case"blockquote":{K=this.parse(H.tokens),le+=this.renderer.blockquote(K);continue}case"list":{for(te=H.ordered,oe=H.start,Oe=H.loose,Ie=H.items.length,K="",Pe=0;Pe<Ie;Pe++)He=H.items[Pe],xe=He.checked,tt=He.task,Ve="",He.task&&(lt=this.renderer.checkbox(xe),Oe?He.tokens.length>0&&He.tokens[0].type==="paragraph"?(He.tokens[0].text=lt+" "+He.tokens[0].text,He.tokens[0].tokens&&He.tokens[0].tokens.length>0&&He.tokens[0].tokens[0].type==="text"&&(He.tokens[0].tokens[0].text=lt+" "+He.tokens[0].tokens[0].text)):He.tokens.unshift({type:"text",text:lt}):Ve+=lt),Ve+=this.parse(He.tokens,Oe),K+=this.renderer.listitem(Ve,tt,xe);le+=this.renderer.list(K,te,oe);continue}case"html":{le+=this.renderer.html(H.text);continue}case"paragraph":{le+=this.renderer.paragraph(this.parseInline(H.tokens));continue}case"text":{for(K=H.tokens?this.parseInline(H.tokens):H.text;de+1<it&&J[de+1].type==="text";)H=J[++de],K+=`
`+(H.tokens?this.parseInline(H.tokens):H.text);le+=x?this.renderer.paragraph(K):K;continue}default:{var ot='Token with "'+H.type+'" type was not found.';if(this.options.silent){console.error(ot);return}else throw new Error(ot)}}}return le},we.parseInline=function(J,x){x=x||this.renderer;var le="",de,Pe,me,Ie=J.length;for(de=0;de<Ie;de++){if(Pe=J[de],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Pe.type]&&(me=this.options.extensions.renderers[Pe.type].call({parser:this},Pe),me!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Pe.type))){le+=me||"";continue}switch(Pe.type){case"escape":{le+=x.text(Pe.text);break}case"html":{le+=x.html(Pe.text);break}case"link":{le+=x.link(Pe.href,Pe.title,this.parseInline(Pe.tokens,x));break}case"image":{le+=x.image(Pe.href,Pe.title,Pe.text);break}case"strong":{le+=x.strong(this.parseInline(Pe.tokens,x));break}case"em":{le+=x.em(this.parseInline(Pe.tokens,x));break}case"codespan":{le+=x.codespan(Pe.text);break}case"br":{le+=x.br();break}case"del":{le+=x.del(this.parseInline(Pe.tokens,x));break}case"text":{le+=x.text(Pe.text);break}default:{var Me='Token with "'+Pe.type+'" type was not found.';if(this.options.silent){console.error(Me);return}else throw new Error(Me)}}}return le},Ce}();function ve(Ce,we,ge){if(typeof Ce>"u"||Ce===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Ce!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Ce)+", string expected");if(typeof we=="function"&&(ge=we,we=null),we=m({},ve.defaults,we||{}),b(we),ge){var J=we.highlight,x;try{x=re.lex(Ce,we)}catch(Ie){return ge(Ie)}var le=function(Me){var ze;if(!Me)try{we.walkTokens&&ve.walkTokens(x,we.walkTokens),ze=he.parse(x,we)}catch(N){Me=N}return we.highlight=J,Me?ge(Me):ge(null,ze)};if(!J||J.length<3||(delete we.highlight,!x.length))return le();var de=0;ve.walkTokens(x,function(Ie){Ie.type==="code"&&(de++,setTimeout(function(){J(Ie.text,Ie.lang,function(Me,ze){if(Me)return le(Me);ze!=null&&ze!==Ie.text&&(Ie.text=ze,Ie.escaped=!0),de--,de===0&&le()})},0))}),de===0&&le();return}function Pe(Ie){if(Ie.message+=`
Please report this to https://github.com/markedjs/marked.`,we.silent)return"<p>An error occurred:</p><pre>"+$(Ie.message+"",!0)+"</pre>";throw Ie}try{var me=re.lex(Ce,we);if(we.walkTokens){if(we.async)return Promise.all(ve.walkTokens(me,we.walkTokens)).then(function(){return he.parse(me,we)}).catch(Pe);ve.walkTokens(me,we.walkTokens)}return he.parse(me,we)}catch(Ie){Pe(Ie)}}ve.options=ve.setOptions=function(Ce){return m(ve.defaults,Ce),g(ve.defaults),ve},ve.getDefaults=R,ve.defaults=fe.defaults,ve.use=function(){for(var Ce=arguments.length,we=new Array(Ce),ge=0;ge<Ce;ge++)we[ge]=arguments[ge];var J=m.apply(void 0,[{}].concat(we)),x=ve.defaults.extensions||{renderers:{},childTokens:{}},le;we.forEach(function(de){if(de.extensions&&(le=!0,de.extensions.forEach(function(me){if(!me.name)throw new Error("extension name required");if(me.renderer){var Ie=x.renderers?x.renderers[me.name]:null;Ie?x.renderers[me.name]=function(){for(var Me=arguments.length,ze=new Array(Me),N=0;N<Me;N++)ze[N]=arguments[N];var z=me.renderer.apply(this,ze);return z===!1&&(z=Ie.apply(this,ze)),z}:x.renderers[me.name]=me.renderer}if(me.tokenizer){if(!me.level||me.level!=="block"&&me.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");x[me.level]?x[me.level].unshift(me.tokenizer):x[me.level]=[me.tokenizer],me.start&&(me.level==="block"?x.startBlock?x.startBlock.push(me.start):x.startBlock=[me.start]:me.level==="inline"&&(x.startInline?x.startInline.push(me.start):x.startInline=[me.start]))}me.childTokens&&(x.childTokens[me.name]=me.childTokens)})),de.renderer&&function(){var me=ve.defaults.renderer||new ue,Ie=function(N){var z=me[N];me[N]=function(){for(var K=arguments.length,H=new Array(K),te=0;te<K;te++)H[te]=arguments[te];var oe=de.renderer[N].apply(me,H);return oe===!1&&(oe=z.apply(me,H)),oe}};for(var Me in de.renderer)Ie(Me);J.renderer=me}(),de.tokenizer&&function(){var me=ve.defaults.tokenizer||new W,Ie=function(N){var z=me[N];me[N]=function(){for(var K=arguments.length,H=new Array(K),te=0;te<K;te++)H[te]=arguments[te];var oe=de.tokenizer[N].apply(me,H);return oe===!1&&(oe=z.apply(me,H)),oe}};for(var Me in de.tokenizer)Ie(Me);J.tokenizer=me}(),de.walkTokens){var Pe=ve.defaults.walkTokens;J.walkTokens=function(me){var Ie=[];return Ie.push(de.walkTokens.call(this,me)),Pe&&(Ie=Ie.concat(Pe.call(this,me))),Ie}}le&&(J.extensions=x),ve.setOptions(J)})},ve.walkTokens=function(Ce,we){for(var ge=[],J=function(){var Pe=le.value;switch(ge=ge.concat(we.call(ve,Pe)),Pe.type){case"table":{for(var me=L(Pe.header),Ie;!(Ie=me()).done;){var Me=Ie.value;ge=ge.concat(ve.walkTokens(Me.tokens,we))}for(var ze=L(Pe.rows),N;!(N=ze()).done;)for(var z=N.value,K=L(z),H;!(H=K()).done;){var te=H.value;ge=ge.concat(ve.walkTokens(te.tokens,we))}break}case"list":{ge=ge.concat(ve.walkTokens(Pe.items,we));break}default:ve.defaults.extensions&&ve.defaults.extensions.childTokens&&ve.defaults.extensions.childTokens[Pe.type]?ve.defaults.extensions.childTokens[Pe.type].forEach(function(oe){ge=ge.concat(ve.walkTokens(Pe[oe],we))}):Pe.tokens&&(ge=ge.concat(ve.walkTokens(Pe.tokens,we)))}},x=L(Ce),le;!(le=x()).done;)J();return ge},ve.parseInline=function(Ce,we){if(typeof Ce>"u"||Ce===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Ce!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Ce)+", string expected");we=m({},ve.defaults,we||{}),b(we);try{var ge=re.lexInline(Ce,we);return we.walkTokens&&ve.walkTokens(ge,we.walkTokens),he.parseInline(ge,we)}catch(J){if(J.message+=`
Please report this to https://github.com/markedjs/marked.`,we.silent)return"<p>An error occurred:</p><pre>"+$(J.message+"",!0)+"</pre>";throw J}},ve.Parser=he,ve.parser=he.parse,ve.Renderer=ue,ve.TextRenderer=ye,ve.Lexer=re,ve.lexer=re.lex,ve.Tokenizer=W,ve.Slugger=De,ve.parse=ve;var se=ve.options,$e=ve.setOptions,ee=ve.use,Q=ve.walkTokens,q=ve.parseInline,ne=ve,Se=he.parse,Te=re.lex;fe.Lexer=re,fe.Parser=he,fe.Renderer=ue,fe.Slugger=De,fe.TextRenderer=ye,fe.Tokenizer=W,fe.getDefaults=R,fe.lexer=Te,fe.marked=ve,fe.options=se,fe.parse=ne,fe.parseInline=q,fe.parser=Se,fe.setOptions=$e,fe.use=ee,fe.walkTokens=Q,Object.defineProperty(fe,"__esModule",{value:!0})}),define(Re[122],Ae([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3j=void 0;function S(s){const c=L(s);if(c&&c.length>0)return new Uint32Array(c)}e.$3j=S;let F=0;const P=new Uint32Array(10);function L(s){if(F=0,R(s,k,4352),F>0||(R(s,l,4449),F>0)||(R(s,v,4520),F>0)||(R(s,$,12593),F))return P.subarray(0,F);if(s>=44032&&s<=55203){const c=s-44032,t=c%588,n=Math.floor(c/588),r=Math.floor(t/28),a=t%28-1;if(n<k.length?R(n,k,0):4352+n-12593<$.length&&R(4352+n,$,12593),r<l.length?R(r,l,0):4449+r-12593<$.length&&R(4449+r-12593,$,12593),a>=0&&(a<v.length?R(a,v,0):4520+a-12593<$.length&&R(4520+a-12593,$,12593)),F>0)return P.subarray(0,F)}}function R(s,c,t){s>=t&&s<t+c.length&&g(c[s-t])}function g(s){s!==0&&(P[F++]=s&255,s>>8&&(P[F++]=s>>8&255),s>>16&&(P[F++]=s>>16&255))}var f;(function(s){s[s.InitialConsonant=4352]="InitialConsonant",s[s.Vowel=4449]="Vowel",s[s.FinalConsonant=4520]="FinalConsonant",s[s.CompatibilityJamo=12593]="CompatibilityJamo"})(f||(f={}));var D;(function(s){s[s.NUL=0]="NUL",s[s.A=65]="A",s[s.B=66]="B",s[s.C=67]="C",s[s.D=68]="D",s[s.E=69]="E",s[s.F=70]="F",s[s.G=71]="G",s[s.H=72]="H",s[s.I=73]="I",s[s.J=74]="J",s[s.K=75]="K",s[s.L=76]="L",s[s.M=77]="M",s[s.N=78]="N",s[s.O=79]="O",s[s.P=80]="P",s[s.Q=81]="Q",s[s.R=82]="R",s[s.S=83]="S",s[s.T=84]="T",s[s.U=85]="U",s[s.V=86]="V",s[s.W=87]="W",s[s.X=88]="X",s[s.Y=89]="Y",s[s.Z=90]="Z",s[s.a=97]="a",s[s.b=98]="b",s[s.c=99]="c",s[s.d=100]="d",s[s.e=101]="e",s[s.f=102]="f",s[s.g=103]="g",s[s.h=104]="h",s[s.i=105]="i",s[s.j=106]="j",s[s.k=107]="k",s[s.l=108]="l",s[s.m=109]="m",s[s.n=110]="n",s[s.o=111]="o",s[s.p=112]="p",s[s.q=113]="q",s[s.r=114]="r",s[s.s=115]="s",s[s.t=116]="t",s[s.u=117]="u",s[s.v=118]="v",s[s.w=119]="w",s[s.x=120]="x",s[s.y=121]="y",s[s.z=122]="z"})(D||(D={}));var M;(function(s){s[s.fa=24934]="fa",s[s.fg=26470]="fg",s[s.fq=29030]="fq",s[s.fr=29286]="fr",s[s.ft=29798]="ft",s[s.fv=30310]="fv",s[s.fx=30822]="fx",s[s.hk=27496]="hk",s[s.hl=27752]="hl",s[s.ho=28520]="ho",s[s.ml=27757]="ml",s[s.nj=27246]="nj",s[s.nl=27758]="nl",s[s.np=28782]="np",s[s.qt=29809]="qt",s[s.rt=29810]="rt",s[s.sg=26483]="sg",s[s.sw=30579]="sw"})(M||(M={}));const k=new Uint8Array([114,82,115,101,69,102,97,113,81,116,84,100,119,87,99,122,120,118,103]),l=new Uint16Array([107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108]),v=new Uint16Array([114,82,29810,115,30579,26483,101,102,29286,24934,29030,29798,30822,30310,26470,97,113,29809,116,84,100,119,99,122,120,118,103]),$=new Uint16Array([114,82,29810,115,30579,26483,101,69,102,29286,24934,29030,29798,30822,30310,26470,97,113,81,29809,116,84,100,119,87,99,122,120,118,103,107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108])}),define(Re[123],Ae([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jm=e.$im=e.$hm=e.rot=e.$fm=void 0;function S(g,f,D){return Math.min(Math.max(g,f),D)}e.$fm=S;function F(g,f){return(f+g%f)%f}e.rot=F;class P{constructor(){this.a=0}getNext(){return this.a++}}e.$hm=P;class L{constructor(){this.a=1,this.b=0}update(f){return this.b=this.b+(f-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$im=L;class R{constructor(f){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(f),this.c.fill(0,0,f)}update(f){const D=this.c[this.d];return this.c[this.d]=f,this.d=(this.d+1)%this.c.length,this.e-=D,this.e+=f,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$jm=R}),function(){function fe(P){const L=[];typeof P=="number"&&L.push("code/timeOrigin",P);function R(f){L.push(f,Date.now())}function g(){const f=[];for(let D=0;D<L.length;D+=2)f.push({name:L[D],startTime:L[D+1]});return f}return{mark:R,getMarks:g}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?fe():{mark(P){performance.mark(P)},getMarks(){let P=performance.timeOrigin;typeof P!="number"&&(P=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const L=[{name:"code/timeOrigin",startTime:Math.round(P)}];for(const R of performance.getEntriesByType("mark"))L.push({name:R.name,startTime:Math.round(P+R.startTime)});return L}};if(typeof process=="object"){const P=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return fe(P)}else return console.trace("perf-util loaded in UNKNOWN environment"),fe()}function S(P){return P.MonacoPerformanceMarks||(P.MonacoPerformanceMarks=e()),P.MonacoPerformanceMarks}var F;typeof global=="object"?F=global:typeof self=="object"?F=self:F={},typeof define=="function"?define("vs/base/common/performance",[],function(){return S(F)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=S(F):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),F.perf=S(F))}(),function(fe,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var S=e();for(var F in S)(typeof exports=="object"?exports:fe)[F]=S[F]}}(typeof self<"u"?self:this,function(){return function(fe){var e={};function S(F){if(e[F])return e[F].exports;var P=e[F]={i:F,l:!1,exports:{}};return fe[F].call(P.exports,P,P.exports,S),P.l=!0,P.exports}return S.m=fe,S.c=e,S.d=function(F,P,L){S.o(F,P)||Object.defineProperty(F,P,{enumerable:!0,get:L})},S.r=function(F){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(F,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(F,"__esModule",{value:!0})},S.t=function(F,P){if(1&P&&(F=S(F)),8&P||4&P&&typeof F=="object"&&F&&F.__esModule)return F;var L=Object.create(null);if(S.r(L),Object.defineProperty(L,"default",{enumerable:!0,value:F}),2&P&&typeof F!="string")for(var R in F)S.d(L,R,function(g){return F[g]}.bind(null,R));return L},S.n=function(F){var P=F&&F.__esModule?function(){return F.default}:function(){return F};return S.d(P,"a",P),P},S.o=function(F,P){return Object.prototype.hasOwnProperty.call(F,P)},S.p="",S(S.s=0)}([function(fe,e,S){(function(F){var P;e=fe.exports=ee,P=typeof F=="object"&&F.env&&F.env.NODE_DEBUG&&/\bsemver\b/i.test(F.env.NODE_DEBUG)?function(){var z=Array.prototype.slice.call(arguments,0);z.unshift("SEMVER"),console.log.apply(console,z)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var L=256,R=Number.MAX_SAFE_INTEGER||9007199254740991,g=e.re=[],f=e.src=[],D=0,M=D++;f[M]="0|[1-9]\\d*";var k=D++;f[k]="[0-9]+";var l=D++;f[l]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var v=D++;f[v]="("+f[M]+")\\.("+f[M]+")\\.("+f[M]+")";var $=D++;f[$]="("+f[k]+")\\.("+f[k]+")\\.("+f[k]+")";var s=D++;f[s]="(?:"+f[M]+"|"+f[l]+")";var c=D++;f[c]="(?:"+f[k]+"|"+f[l]+")";var t=D++;f[t]="(?:-("+f[s]+"(?:\\."+f[s]+")*))";var n=D++;f[n]="(?:-?("+f[c]+"(?:\\."+f[c]+")*))";var r=D++;f[r]="[0-9A-Za-z-]+";var a=D++;f[a]="(?:\\+("+f[r]+"(?:\\."+f[r]+")*))";var h=D++,i="v?"+f[v]+f[t]+"?"+f[a]+"?";f[h]="^"+i+"$";var p="[v=\\s]*"+f[$]+f[n]+"?"+f[a]+"?",u=D++;f[u]="^"+p+"$";var o=D++;f[o]="((?:<|>)?=?)";var E=D++;f[E]=f[k]+"|x|X|\\*";var w=D++;f[w]=f[M]+"|x|X|\\*";var m=D++;f[m]="[v=\\s]*("+f[w]+")(?:\\.("+f[w]+")(?:\\.("+f[w]+")(?:"+f[t]+")?"+f[a]+"?)?)?";var I=D++;f[I]="[v=\\s]*("+f[E]+")(?:\\.("+f[E]+")(?:\\.("+f[E]+")(?:"+f[n]+")?"+f[a]+"?)?)?";var d=D++;f[d]="^"+f[o]+"\\s*"+f[m]+"$";var y=D++;f[y]="^"+f[o]+"\\s*"+f[I]+"$";var b=D++;f[b]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var A=D++;f[A]="(?:~>?)";var T=D++;f[T]="(\\s*)"+f[A]+"\\s+",g[T]=new RegExp(f[T],"g");var G=D++;f[G]="^"+f[A]+f[m]+"$";var W=D++;f[W]="^"+f[A]+f[I]+"$";var U=D++;f[U]="(?:\\^)";var C=D++;f[C]="(\\s*)"+f[U]+"\\s+",g[C]=new RegExp(f[C],"g");var O=D++;f[O]="^"+f[U]+f[m]+"$";var V=D++;f[V]="^"+f[U]+f[I]+"$";var re=D++;f[re]="^"+f[o]+"\\s*("+p+")$|^$";var ue=D++;f[ue]="^"+f[o]+"\\s*("+i+")$|^$";var ye=D++;f[ye]="(\\s*)"+f[o]+"\\s*("+p+"|"+f[m]+")",g[ye]=new RegExp(f[ye],"g");var De=D++;f[De]="^\\s*("+f[m]+")\\s+-\\s+("+f[m]+")\\s*$";var he=D++;f[he]="^\\s*("+f[I]+")\\s+-\\s+("+f[I]+")\\s*$";var ve=D++;f[ve]="(<|>)?=?\\s*\\*";for(var se=0;se<35;se++)P(se,f[se]),g[se]||(g[se]=new RegExp(f[se]));function $e(z,K){if(z instanceof ee)return z;if(typeof z!="string"||z.length>L||!(K?g[u]:g[h]).test(z))return null;try{return new ee(z,K)}catch{return null}}function ee(z,K){if(z instanceof ee){if(z.loose===K)return z;z=z.version}else if(typeof z!="string")throw new TypeError("Invalid Version: "+z);if(z.length>L)throw new TypeError("version is longer than "+L+" characters");if(!(this instanceof ee))return new ee(z,K);P("SemVer",z,K),this.loose=K;var H=z.trim().match(K?g[u]:g[h]);if(!H)throw new TypeError("Invalid Version: "+z);if(this.raw=z,this.major=+H[1],this.minor=+H[2],this.patch=+H[3],this.major>R||this.major<0)throw new TypeError("Invalid major version");if(this.minor>R||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>R||this.patch<0)throw new TypeError("Invalid patch version");H[4]?this.prerelease=H[4].split(".").map(function(te){if(/^[0-9]+$/.test(te)){var oe=+te;if(oe>=0&&oe<R)return oe}return te}):this.prerelease=[],this.build=H[5]?H[5].split("."):[],this.format()}e.parse=$e,e.valid=function(z,K){var H=$e(z,K);return H?H.version:null},e.clean=function(z,K){var H=$e(z.trim().replace(/^[=v]+/,""),K);return H?H.version:null},e.SemVer=ee,ee.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},ee.prototype.toString=function(){return this.version},ee.prototype.compare=function(z){return P("SemVer.compare",this.version,this.loose,z),z instanceof ee||(z=new ee(z,this.loose)),this.compareMain(z)||this.comparePre(z)},ee.prototype.compareMain=function(z){return z instanceof ee||(z=new ee(z,this.loose)),q(this.major,z.major)||q(this.minor,z.minor)||q(this.patch,z.patch)},ee.prototype.comparePre=function(z){if(z instanceof ee||(z=new ee(z,this.loose)),this.prerelease.length&&!z.prerelease.length)return-1;if(!this.prerelease.length&&z.prerelease.length)return 1;if(!this.prerelease.length&&!z.prerelease.length)return 0;var K=0;do{var H=this.prerelease[K],te=z.prerelease[K];if(P("prerelease compare",K,H,te),H===void 0&&te===void 0)return 0;if(te===void 0)return 1;if(H===void 0)return-1;if(H!==te)return q(H,te)}while(++K)},ee.prototype.inc=function(z,K){switch(z){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",K);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",K);break;case"prepatch":this.prerelease.length=0,this.inc("patch",K),this.inc("pre",K);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",K),this.inc("pre",K);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var H=this.prerelease.length;--H>=0;)typeof this.prerelease[H]=="number"&&(this.prerelease[H]++,H=-2);H===-1&&this.prerelease.push(0)}K&&(this.prerelease[0]===K?isNaN(this.prerelease[1])&&(this.prerelease=[K,0]):this.prerelease=[K,0]);break;default:throw new Error("invalid increment argument: "+z)}return this.format(),this.raw=this.version,this},e.inc=function(z,K,H,te){typeof H=="string"&&(te=H,H=void 0);try{return new ee(z,H).inc(K,te).version}catch{return null}},e.diff=function(z,K){if(Ce(z,K))return null;var H=$e(z),te=$e(K);if(H.prerelease.length||te.prerelease.length){for(var oe in H)if((oe==="major"||oe==="minor"||oe==="patch")&&H[oe]!==te[oe])return"pre"+oe;return"prerelease"}for(var oe in H)if((oe==="major"||oe==="minor"||oe==="patch")&&H[oe]!==te[oe])return oe},e.compareIdentifiers=q;var Q=/^[0-9]+$/;function q(z,K){var H=Q.test(z),te=Q.test(K);return H&&te&&(z=+z,K=+K),H&&!te?-1:te&&!H?1:z<K?-1:z>K?1:0}function ne(z,K,H){return new ee(z,H).compare(new ee(K,H))}function Se(z,K,H){return ne(z,K,H)>0}function Te(z,K,H){return ne(z,K,H)<0}function Ce(z,K,H){return ne(z,K,H)===0}function we(z,K,H){return ne(z,K,H)!==0}function ge(z,K,H){return ne(z,K,H)>=0}function J(z,K,H){return ne(z,K,H)<=0}function x(z,K,H,te){var oe;switch(K){case"===":typeof z=="object"&&(z=z.version),typeof H=="object"&&(H=H.version),oe=z===H;break;case"!==":typeof z=="object"&&(z=z.version),typeof H=="object"&&(H=H.version),oe=z!==H;break;case"":case"=":case"==":oe=Ce(z,H,te);break;case"!=":oe=we(z,H,te);break;case">":oe=Se(z,H,te);break;case">=":oe=ge(z,H,te);break;case"<":oe=Te(z,H,te);break;case"<=":oe=J(z,H,te);break;default:throw new TypeError("Invalid operator: "+K)}return oe}function le(z,K){if(z instanceof le){if(z.loose===K)return z;z=z.value}if(!(this instanceof le))return new le(z,K);P("comparator",z,K),this.loose=K,this.parse(z),this.semver===de?this.value="":this.value=this.operator+this.semver.version,P("comp",this)}e.rcompareIdentifiers=function(z,K){return q(K,z)},e.major=function(z,K){return new ee(z,K).major},e.minor=function(z,K){return new ee(z,K).minor},e.patch=function(z,K){return new ee(z,K).patch},e.compare=ne,e.compareLoose=function(z,K){return ne(z,K,!0)},e.rcompare=function(z,K,H){return ne(K,z,H)},e.sort=function(z,K){return z.sort(function(H,te){return e.compare(H,te,K)})},e.rsort=function(z,K){return z.sort(function(H,te){return e.rcompare(H,te,K)})},e.gt=Se,e.lt=Te,e.eq=Ce,e.neq=we,e.gte=ge,e.lte=J,e.cmp=x,e.Comparator=le;var de={};function Pe(z,K){if(z instanceof Pe)return z.loose===K?z:new Pe(z.raw,K);if(z instanceof le)return new Pe(z.value,K);if(!(this instanceof Pe))return new Pe(z,K);if(this.loose=K,this.raw=z,this.set=z.split(/\s*\|\|\s*/).map(function(H){return this.parseRange(H.trim())},this).filter(function(H){return H.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+z);this.format()}function me(z){return!z||z.toLowerCase()==="x"||z==="*"}function Ie(z,K,H,te,oe,Oe,Ve,He,xe,tt,lt,rt,it){return((K=me(H)?"":me(te)?">="+H+".0.0":me(oe)?">="+H+"."+te+".0":">="+K)+" "+(He=me(xe)?"":me(tt)?"<"+(+xe+1)+".0.0":me(lt)?"<"+xe+"."+(+tt+1)+".0":rt?"<="+xe+"."+tt+"."+lt+"-"+rt:"<="+He)).trim()}function Me(z,K){for(var H=0;H<z.length;H++)if(!z[H].test(K))return!1;if(K.prerelease.length){for(H=0;H<z.length;H++)if(P(z[H].semver),z[H].semver!==de&&z[H].semver.prerelease.length>0){var te=z[H].semver;if(te.major===K.major&&te.minor===K.minor&&te.patch===K.patch)return!0}return!1}return!0}function ze(z,K,H){try{K=new Pe(K,H)}catch{return!1}return K.test(z)}function N(z,K,H,te){var oe,Oe,Ve,He,xe;switch(z=new ee(z,te),K=new Pe(K,te),H){case">":oe=Se,Oe=J,Ve=Te,He=">",xe=">=";break;case"<":oe=Te,Oe=ge,Ve=Se,He="<",xe="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(ze(z,K,te))return!1;for(var tt=0;tt<K.set.length;++tt){var lt=K.set[tt],rt=null,it=null;if(lt.forEach(function(ot){ot.semver===de&&(ot=new le(">=0.0.0")),rt=rt||ot,it=it||ot,oe(ot.semver,rt.semver,te)?rt=ot:Ve(ot.semver,it.semver,te)&&(it=ot)}),rt.operator===He||rt.operator===xe||(!it.operator||it.operator===He)&&Oe(z,it.semver)||it.operator===xe&&Ve(z,it.semver))return!1}return!0}le.prototype.parse=function(z){var K=this.loose?g[re]:g[ue],H=z.match(K);if(!H)throw new TypeError("Invalid comparator: "+z);this.operator=H[1],this.operator==="="&&(this.operator=""),H[2]?this.semver=new ee(H[2],this.loose):this.semver=de},le.prototype.toString=function(){return this.value},le.prototype.test=function(z){return P("Comparator.test",z,this.loose),this.semver===de||(typeof z=="string"&&(z=new ee(z,this.loose)),x(z,this.operator,this.semver,this.loose))},le.prototype.intersects=function(z,K){if(!(z instanceof le))throw new TypeError("a Comparator is required");var H;if(this.operator==="")return H=new Pe(z.value,K),ze(this.value,H,K);if(z.operator==="")return H=new Pe(this.value,K),ze(z.semver,H,K);var te=!(this.operator!==">="&&this.operator!==">"||z.operator!==">="&&z.operator!==">"),oe=!(this.operator!=="<="&&this.operator!=="<"||z.operator!=="<="&&z.operator!=="<"),Oe=this.semver.version===z.semver.version,Ve=!(this.operator!==">="&&this.operator!=="<="||z.operator!==">="&&z.operator!=="<="),He=x(this.semver,"<",z.semver,K)&&(this.operator===">="||this.operator===">")&&(z.operator==="<="||z.operator==="<"),xe=x(this.semver,">",z.semver,K)&&(this.operator==="<="||this.operator==="<")&&(z.operator===">="||z.operator===">");return te||oe||Oe&&Ve||He||xe},e.Range=Pe,Pe.prototype.format=function(){return this.range=this.set.map(function(z){return z.join(" ").trim()}).join("||").trim(),this.range},Pe.prototype.toString=function(){return this.range},Pe.prototype.parseRange=function(z){var K=this.loose;z=z.trim(),P("range",z,K);var H=K?g[he]:g[De];z=z.replace(H,Ie),P("hyphen replace",z),z=z.replace(g[ye],"$1$2$3"),P("comparator trim",z,g[ye]),z=(z=(z=z.replace(g[T],"$1~")).replace(g[C],"$1^")).split(/\s+/).join(" ");var te=K?g[re]:g[ue],oe=z.split(" ").map(function(Oe){return function(Ve,He){return P("comp",Ve),Ve=function(xe,tt){return xe.trim().split(/\s+/).map(function(lt){return function(rt,it){P("caret",rt,it);var ot=it?g[V]:g[O];return rt.replace(ot,function(Be,et,Y,X,pe){var We;return P("caret",rt,Be,et,Y,X,pe),me(et)?We="":me(Y)?We=">="+et+".0.0 <"+(+et+1)+".0.0":me(X)?We=et==="0"?">="+et+"."+Y+".0 <"+et+"."+(+Y+1)+".0":">="+et+"."+Y+".0 <"+(+et+1)+".0.0":pe?(P("replaceCaret pr",pe),pe.charAt(0)!=="-"&&(pe="-"+pe),We=et==="0"?Y==="0"?">="+et+"."+Y+"."+X+pe+" <"+et+"."+Y+"."+(+X+1):">="+et+"."+Y+"."+X+pe+" <"+et+"."+(+Y+1)+".0":">="+et+"."+Y+"."+X+pe+" <"+(+et+1)+".0.0"):(P("no pr"),We=et==="0"?Y==="0"?">="+et+"."+Y+"."+X+" <"+et+"."+Y+"."+(+X+1):">="+et+"."+Y+"."+X+" <"+et+"."+(+Y+1)+".0":">="+et+"."+Y+"."+X+" <"+(+et+1)+".0.0"),P("caret return",We),We})}(lt,tt)}).join(" ")}(Ve,He),P("caret",Ve),Ve=function(xe,tt){return xe.trim().split(/\s+/).map(function(lt){return function(rt,it){var ot=it?g[W]:g[G];return rt.replace(ot,function(Be,et,Y,X,pe){var We;return P("tilde",rt,Be,et,Y,X,pe),me(et)?We="":me(Y)?We=">="+et+".0.0 <"+(+et+1)+".0.0":me(X)?We=">="+et+"."+Y+".0 <"+et+"."+(+Y+1)+".0":pe?(P("replaceTilde pr",pe),pe.charAt(0)!=="-"&&(pe="-"+pe),We=">="+et+"."+Y+"."+X+pe+" <"+et+"."+(+Y+1)+".0"):We=">="+et+"."+Y+"."+X+" <"+et+"."+(+Y+1)+".0",P("tilde return",We),We})}(lt,tt)}).join(" ")}(Ve,He),P("tildes",Ve),Ve=function(xe,tt){return P("replaceXRanges",xe,tt),xe.split(/\s+/).map(function(lt){return function(rt,it){rt=rt.trim();var ot=it?g[y]:g[d];return rt.replace(ot,function(Be,et,Y,X,pe,We){P("xRange",rt,Be,et,Y,X,pe,We);var Xe=me(Y),st=Xe||me(X),Le=st||me(pe);return et==="="&&Le&&(et=""),Xe?Be=et===">"||et==="<"?"<0.0.0":"*":et&&Le?(st&&(X=0),Le&&(pe=0),et===">"?(et=">=",st?(Y=+Y+1,X=0,pe=0):Le&&(X=+X+1,pe=0)):et==="<="&&(et="<",st?Y=+Y+1:X=+X+1),Be=et+Y+"."+X+"."+pe):st?Be=">="+Y+".0.0 <"+(+Y+1)+".0.0":Le&&(Be=">="+Y+"."+X+".0 <"+Y+"."+(+X+1)+".0"),P("xRange return",Be),Be})}(lt,tt)}).join(" ")}(Ve,He),P("xrange",Ve),Ve=function(xe,tt){return P("replaceStars",xe,tt),xe.trim().replace(g[ve],"")}(Ve,He),P("stars",Ve),Ve}(Oe,K)}).join(" ").split(/\s+/);return this.loose&&(oe=oe.filter(function(Oe){return!!Oe.match(te)})),oe=oe.map(function(Oe){return new le(Oe,K)})},Pe.prototype.intersects=function(z,K){if(!(z instanceof Pe))throw new TypeError("a Range is required");return this.set.some(function(H){return H.every(function(te){return z.set.some(function(oe){return oe.every(function(Oe){return te.intersects(Oe,K)})})})})},e.toComparators=function(z,K){return new Pe(z,K).set.map(function(H){return H.map(function(te){return te.value}).join(" ").trim().split(" ")})},Pe.prototype.test=function(z){if(!z)return!1;typeof z=="string"&&(z=new ee(z,this.loose));for(var K=0;K<this.set.length;K++)if(Me(this.set[K],z))return!0;return!1},e.satisfies=ze,e.maxSatisfying=function(z,K,H){var te=null,oe=null;try{var Oe=new Pe(K,H)}catch{return null}return z.forEach(function(Ve){Oe.test(Ve)&&(te&&oe.compare(Ve)!==-1||(oe=new ee(te=Ve,H)))}),te},e.minSatisfying=function(z,K,H){var te=null,oe=null;try{var Oe=new Pe(K,H)}catch{return null}return z.forEach(function(Ve){Oe.test(Ve)&&(te&&oe.compare(Ve)!==1||(oe=new ee(te=Ve,H)))}),te},e.validRange=function(z,K){try{return new Pe(z,K).range||"*"}catch{return null}},e.ltr=function(z,K,H){return N(z,K,"<",H)},e.gtr=function(z,K,H){return N(z,K,">",H)},e.outside=N,e.prerelease=function(z,K){var H=$e(z,K);return H&&H.prerelease.length?H.prerelease:null},e.intersects=function(z,K,H){return z=new Pe(z,H),K=new Pe(K,H),z.intersects(K)},e.coerce=function(z){if(z instanceof ee)return z;if(typeof z!="string")return null;var K=z.match(g[b]);return K==null?null:$e((K[1]||"0")+"."+(K[2]||"0")+"."+(K[3]||"0"))}}).call(this,S(1))},function(fe,e){var S,F,P=fe.exports={};function L(){throw new Error("setTimeout has not been defined")}function R(){throw new Error("clearTimeout has not been defined")}function g(c){if(S===setTimeout)return setTimeout(c,0);if((S===L||!S)&&setTimeout)return S=setTimeout,setTimeout(c,0);try{return S(c,0)}catch{try{return S.call(null,c,0)}catch{return S.call(this,c,0)}}}(function(){try{S=typeof setTimeout=="function"?setTimeout:L}catch{S=L}try{F=typeof clearTimeout=="function"?clearTimeout:R}catch{F=R}})();var f,D=[],M=!1,k=-1;function l(){M&&f&&(M=!1,f.length?D=f.concat(D):k=-1,D.length&&v())}function v(){if(!M){var c=g(l);M=!0;for(var t=D.length;t;){for(f=D,D=[];++k<t;)f&&f[k].run();k=-1,t=D.length}f=null,M=!1,function(n){if(F===clearTimeout)return clearTimeout(n);if((F===R||!F)&&clearTimeout)return F=clearTimeout,clearTimeout(n);try{F(n)}catch{try{return F.call(null,n)}catch{return F.call(this,n)}}}(c)}}function $(c,t){this.fun=c,this.array=t}function s(){}P.nextTick=function(c){var t=new Array(arguments.length-1);if(arguments.length>1)for(var n=1;n<arguments.length;n++)t[n-1]=arguments[n];D.push(new $(c,t)),D.length!==1||M||g(v)},$.prototype.run=function(){this.fun.apply(null,this.array)},P.title="browser",P.browser=!0,P.env={},P.argv=[],P.version="",P.versions={},P.on=s,P.addListener=s,P.once=s,P.off=s,P.removeListener=s,P.removeAllListeners=s,P.emit=s,P.prependListener=s,P.prependOnceListener=s,P.listeners=function(c){return[]},P.binding=function(c){throw new Error("process.binding is not supported")},P.cwd=function(){return"/"},P.chdir=function(c){throw new Error("process.chdir is not supported")},P.umask=function(){return 0}}])}),define(Re[124],Ae([1,0,15,6]),function(fe,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$de=void 0;function P(a){const h=a;return h?typeof h.read=="function":!1}e.$de=P;function L(a){const h=a;return h?[h.on,h.pause,h.resume,h.destroy].every(i=>typeof i=="function"):!1}e.$ee=L;function R(a){const h=a;return h?L(h.stream)&&Array.isArray(h.buffer)&&typeof h.ended=="boolean":!1}e.$fe=R;function g(a,h){return new f(a,h)}e.$ge=g;class f{constructor(h,i){this.e=h,this.f=i,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(h){if(!this.a.destroyed){if(this.a.flowing)this.g(h);else if(this.b.data.push(h),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(i=>this.d.push(i))}}error(h){this.a.destroyed||(this.a.flowing?this.h(h):this.b.error.push(h))}end(h){this.a.destroyed||(typeof h<"u"&&this.write(h),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(h){this.c.data.slice(0).forEach(i=>i(h))}h(h){this.c.error.length===0?(0,S.$1)(h):this.c.error.slice(0).forEach(i=>i(h))}i(){this.c.end.slice(0).forEach(h=>h())}on(h,i){if(!this.a.destroyed)switch(h){case"data":this.c.data.push(i),this.resume();break;case"end":this.c.end.push(i),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(i),this.a.flowing&&this.k();break}}removeListener(h,i){if(this.a.destroyed)return;let p;switch(h){case"data":p=this.c.data;break;case"end":p=this.c.end;break;case"error":p=this.c.error;break}if(p){const u=p.indexOf(i);u>=0&&p.splice(u,1)}}j(){if(this.b.data.length>0){const h=this.e(this.b.data);this.g(h),this.b.data.length=0;const i=[...this.d];this.d.length=0,i.forEach(p=>p())}}k(){if(this.c.error.length>0){for(const h of this.b.error)this.h(h);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function D(a,h){const i=[];let p;for(;(p=a.read())!==null;)i.push(p);return h(i)}e.$he=D;function M(a,h,i){const p=[];let u;for(;(u=a.read())!==null&&p.length<i;)p.push(u);return u===null&&p.length>0?h(p):{read:()=>{if(p.length>0)return p.shift();if(typeof u<"u"){const o=u;return u=void 0,o}return a.read()}}}e.$ie=M;function k(a,h){return new Promise((i,p)=>{const u=[];l(a,{onData:o=>{h&&u.push(o)},onError:o=>{h?p(o):i(void 0)},onEnd:()=>{i(h?h(u):void 0)}})})}e.$je=k;function l(a,h,i){a.on("error",p=>{i?.isCancellationRequested||h.onError(p)}),a.on("end",()=>{i?.isCancellationRequested||h.onEnd()}),a.on("data",p=>{i?.isCancellationRequested||h.onData(p)})}e.$ke=l;function v(a,h){return new Promise((i,p)=>{const u=new F.$Sc,o=[],E=I=>{if(o.push(I),o.length>h)return u.dispose(),a.pause(),i({stream:a,buffer:o,ended:!1})},w=I=>(u.dispose(),p(I)),m=()=>(u.dispose(),i({stream:a,buffer:o,ended:!0}));u.add((0,F.$Rc)(()=>a.removeListener("error",w))),a.on("error",w),u.add((0,F.$Rc)(()=>a.removeListener("end",m))),a.on("end",m),u.add((0,F.$Rc)(()=>a.removeListener("data",E))),a.on("data",E)})}e.$le=v;function $(a,h){const i=g(h);return i.end(a),i}e.$me=$;function s(){const a=g(()=>{throw new Error("not supported")});return a.end(),a}e.$ne=s;function c(a){let h=!1;return{read:()=>h?null:(h=!0,a)}}e.$oe=c;function t(a,h,i){const p=g(i);return l(a,{onData:u=>p.write(h.data(u)),onError:u=>p.error(h.error?h.error(u):u),onEnd:()=>p.end()}),p}e.$pe=t;function n(a,h,i){let p=!1;return{read:()=>{const u=h.read();return p?u:(p=!0,u!==null?i([a,u]):a)}}}e.$qe=n;function r(a,h,i){let p=!1;const u=g(i);return l(h,{onData:o=>p?u.write(o):(p=!0,u.write(i([a,o]))),onError:o=>u.error(o),onEnd:()=>{p||(p=!0,u.write(a)),u.end()}}),u}e.$re=r}),define(Re[24],Ae([1,0,40,124]),function(fe,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Me=e.$Le=e.$Ke=e.$Je=e.$Ie=e.$He=e.$Ge=e.$Fe=e.$Ee=e.$De=e.$Ce=e.$Be=e.$Ae=e.$ze=e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=void 0;const P=typeof Buffer<"u",L=new S.$V(()=>new Uint8Array(256));let R,g;class f{static alloc(b){return P?new f(Buffer.allocUnsafe(b)):new f(new Uint8Array(b))}static wrap(b){return P&&!Buffer.isBuffer(b)&&(b=Buffer.from(b.buffer,b.byteOffset,b.byteLength)),new f(b)}static fromString(b,A){return!(A?.dontUseNodeBuffer||!1)&&P?new f(Buffer.from(b)):(R||(R=new TextEncoder),new f(R.encode(b)))}static fromByteArray(b){const A=f.alloc(b.length);for(let T=0,G=b.length;T<G;T++)A.buffer[T]=b[T];return A}static concat(b,A){if(typeof A>"u"){A=0;for(let W=0,U=b.length;W<U;W++)A+=b[W].byteLength}const T=f.alloc(A);let G=0;for(let W=0,U=b.length;W<U;W++){const C=b[W];T.set(C,G),G+=C.byteLength}return T}constructor(b){this.buffer=b,this.byteLength=this.buffer.byteLength}clone(){const b=f.alloc(this.byteLength);return b.set(this),b}toString(){return P?this.buffer.toString():(g||(g=new TextDecoder),g.decode(this.buffer))}slice(b,A){return new f(this.buffer.subarray(b,A))}set(b,A){if(b instanceof f)this.buffer.set(b.buffer,A);else if(b instanceof Uint8Array)this.buffer.set(b,A);else if(b instanceof ArrayBuffer)this.buffer.set(new Uint8Array(b),A);else if(ArrayBuffer.isView(b))this.buffer.set(new Uint8Array(b.buffer,b.byteOffset,b.byteLength),A);else throw new Error("Unknown argument 'array'")}readUInt32BE(b){return l(this.buffer,b)}writeUInt32BE(b,A){v(this.buffer,b,A)}readUInt32LE(b){return $(this.buffer,b)}writeUInt32LE(b,A){s(this.buffer,b,A)}readUInt8(b){return c(this.buffer,b)}writeUInt8(b,A){t(this.buffer,b,A)}indexOf(b,A=0){return D(this.buffer,b instanceof f?b.buffer:b,A)}}e.$se=f;function D(y,b,A=0){const T=b.byteLength,G=y.byteLength;if(T===0)return 0;if(T===1)return y.indexOf(b[0]);if(T>G-A)return-1;const W=L.value;W.fill(b.length);for(let V=0;V<b.length;V++)W[b[V]]=b.length-V-1;let U=A+b.length-1,C=U,O=-1;for(;U<G;)if(y[U]===b[C]){if(C===0){O=U;break}U--,C--}else U+=Math.max(b.length-C,W[y[U]]),C=b.length-1;return O}e.$te=D;function M(y,b){return y[b+0]<<0>>>0|y[b+1]<<8>>>0}e.$ue=M;function k(y,b,A){y[A+0]=b&255,b=b>>>8,y[A+1]=b&255}e.$ve=k;function l(y,b){return y[b]*2**24+y[b+1]*2**16+y[b+2]*2**8+y[b+3]}e.$we=l;function v(y,b,A){y[A+3]=b,b=b>>>8,y[A+2]=b,b=b>>>8,y[A+1]=b,b=b>>>8,y[A]=b}e.$xe=v;function $(y,b){return y[b+0]<<0>>>0|y[b+1]<<8>>>0|y[b+2]<<16>>>0|y[b+3]<<24>>>0}e.$ye=$;function s(y,b,A){y[A+0]=b&255,b=b>>>8,y[A+1]=b&255,b=b>>>8,y[A+2]=b&255,b=b>>>8,y[A+3]=b&255}e.$ze=s;function c(y,b){return y[b]}e.$Ae=c;function t(y,b,A){y[A]=b}e.$Be=t;function n(y){return F.$he(y,b=>f.concat(b))}e.$Ce=n;function r(y){return F.$oe(y)}e.$De=r;function a(y){return F.$je(y,b=>f.concat(b))}e.$Ee=a;async function h(y){return y.ended?f.concat(y.buffer):f.concat([...y.buffer,await a(y.stream)])}e.$Fe=h;function i(y){return F.$me(y,b=>f.concat(b))}e.$Ge=i;function p(y){return F.$pe(y,{data:b=>typeof b=="string"?f.fromString(b):f.wrap(b)},b=>f.concat(b))}e.$He=p;function u(y){return F.$ge(b=>f.concat(b),y)}e.$Ie=u;function o(y,b){return F.$qe(y,b,A=>f.concat(A))}e.$Je=o;function E(y,b){return F.$re(y,b,A=>f.concat(A))}e.$Ke=E;function w(y){let b=0,A=0,T=0;const G=new Uint8Array(Math.floor(y.length/4*3)),W=C=>{switch(A){case 3:G[T++]=b|C,A=0;break;case 2:G[T++]=b|C>>>2,b=C<<6,A=3;break;case 1:G[T++]=b|C>>>4,b=C<<4,A=2;break;default:b=C<<2,A=1}};for(let C=0;C<y.length;C++){const O=y.charCodeAt(C);if(O>=65&&O<=90)W(O-65);else if(O>=97&&O<=122)W(O-97+26);else if(O>=48&&O<=57)W(O-48+52);else if(O===43||O===45)W(62);else if(O===47||O===95)W(63);else{if(O===61)break;throw new SyntaxError(`Unexpected base64 character ${y[C]}`)}}const U=T;for(;A>0;)W(0);return f.wrap(G).slice(0,U)}e.$Le=w;const m="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",I="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function d({buffer:y},b=!0,A=!1){const T=A?I:m;let G="";const W=y.byteLength%3;let U=0;for(;U<y.byteLength-W;U+=3){const C=y[U+0],O=y[U+1],V=y[U+2];G+=T[C>>>2],G+=T[(C<<4|O>>>4)&63],G+=T[(O<<2|V>>>6)&63],G+=T[V&63]}if(W===1){const C=y[U+0];G+=T[C>>>2],G+=T[C<<4&63],b&&(G+="==")}else if(W===2){const C=y[U+0],O=y[U+1];G+=T[C>>>2],G+=T[(C<<4|O>>>4)&63],G+=T[O<<2&63],b&&(G+="=")}return G}e.$Me=d}),define(Re[125],Ae([1,0,28,122,13]),function(fe,e,S,F,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hk=e.$gk=e.$fk=e.$ek=e.FuzzyScore=e.$dk=e.$ck=e.$bk=e.$ak=e.$_j=e.$$j=e.$0j=e.$9j=e.$8j=e.$7j=e.$6j=e.$5j=e.or=void 0;function L(...me){return function(Ie,Me){for(let ze=0,N=me.length;ze<N;ze++){const z=me[ze](Ie,Me);if(z)return z}return null}}e.or=L,e.$5j=R.bind(void 0,!1),e.$6j=R.bind(void 0,!0);function R(me,Ie,Me){if(!Me||Me.length<Ie.length)return null;let ze;return me?ze=P.$kf(Me,Ie):ze=Me.indexOf(Ie)===0,ze?Ie.length>0?[{start:0,end:Ie.length}]:[]:null}function g(me,Ie){const Me=Ie.toLowerCase().indexOf(me.toLowerCase());return Me===-1?null:[{start:Me,end:Me+me.length}]}e.$7j=g;function f(me,Ie){return D(me.toLowerCase(),Ie.toLowerCase(),0,0)}e.$8j=f;function D(me,Ie,Me,ze){if(Me===me.length)return[];if(ze===Ie.length)return null;if(me[Me]===Ie[ze]){let N=null;return(N=D(me,Ie,Me+1,ze+1))?a({start:ze,end:ze+1},N):null}return D(me,Ie,Me,ze+1)}function M(me){return 97<=me&&me<=122}function k(me){return 65<=me&&me<=90}e.$9j=k;function l(me){return 48<=me&&me<=57}function v(me){return me===32||me===9||me===10||me===13}const $=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(me=>$.add(me.charCodeAt(0)));function s(me){return v(me)||$.has(me)}function c(me,Ie){return me===Ie||s(me)&&s(Ie)}const t=new Map;function n(me){if(t.has(me))return t.get(me);let Ie;const Me=(0,F.$3j)(me);return Me&&(Ie=Me),t.set(me,Ie),Ie}function r(me){return M(me)||k(me)||l(me)}function a(me,Ie){return Ie.length===0?Ie=[me]:me.end===Ie[0].start?Ie[0].start=me.start:Ie.unshift(me),Ie}function h(me,Ie){for(let Me=Ie;Me<me.length;Me++){const ze=me.charCodeAt(Me);if(k(ze)||l(ze)||Me>0&&!r(me.charCodeAt(Me-1)))return Me}return me.length}function i(me,Ie,Me,ze){if(Me===me.length)return[];if(ze===Ie.length)return null;if(me[Me]!==Ie[ze].toLowerCase())return null;{let N=null,z=ze+1;for(N=i(me,Ie,Me+1,ze+1);!N&&(z=h(Ie,z))<Ie.length;)N=i(me,Ie,Me+1,z),z++;return N===null?null:a({start:ze,end:ze+1},N)}}function p(me){let Ie=0,Me=0,ze=0,N=0,z=0;for(let Oe=0;Oe<me.length;Oe++)z=me.charCodeAt(Oe),k(z)&&Ie++,M(z)&&Me++,r(z)&&ze++,l(z)&&N++;const K=Ie/me.length,H=Me/me.length,te=ze/me.length,oe=N/me.length;return{upperPercent:K,lowerPercent:H,alphaPercent:te,numericPercent:oe}}function u(me){const{upperPercent:Ie,lowerPercent:Me}=me;return Me===0&&Ie>.6}function o(me){const{upperPercent:Ie,lowerPercent:Me,alphaPercent:ze,numericPercent:N}=me;return Me>.2&&Ie<.8&&ze>.6&&N<.2}function E(me){let Ie=0,Me=0,ze=0,N=0;for(let z=0;z<me.length;z++)ze=me.charCodeAt(z),k(ze)&&Ie++,M(ze)&&Me++,v(ze)&&N++;return(Ie===0||Me===0)&&N===0?me.length<=30:Ie<=5}function w(me,Ie){if(!Ie||(Ie=Ie.trim(),Ie.length===0)||!E(me))return null;Ie.length>60&&(Ie=Ie.substring(0,60));const Me=p(Ie);if(!o(Me)){if(!u(Me))return null;Ie=Ie.toLowerCase()}let ze=null,N=0;for(me=me.toLowerCase();N<Ie.length&&(ze=i(me,Ie,0,N))===null;)N=h(Ie,N+1);return ze}e.$0j=w;function m(me,Ie,Me=!1){if(!Ie||Ie.length===0)return null;let ze=null,N=0;for(me=me.toLowerCase(),Ie=Ie.toLowerCase();N<Ie.length&&(ze=I(me,Ie,0,N,Me),ze===null);)N=d(Ie,N+1);return ze}e.$$j=m;function I(me,Ie,Me,ze,N){let z=0;if(Me===me.length)return[];if(ze===Ie.length)return null;if(!c(me.charCodeAt(Me),Ie.charCodeAt(ze))){const te=n(me.charCodeAt(Me));if(!te)return null;for(let oe=0;oe<te.length;oe++)if(!c(te[oe],Ie.charCodeAt(ze+oe)))return null;z+=te.length-1}let K=null,H=ze+z+1;if(K=I(me,Ie,Me+1,H,N),!N)for(;!K&&(H=d(Ie,H))<Ie.length;)K=I(me,Ie,Me+1,H,N),H++;if(!K)return null;if(me.charCodeAt(Me)!==Ie.charCodeAt(ze)){const te=n(me.charCodeAt(Me));if(!te)return K;for(let oe=0;oe<te.length;oe++)if(te[oe]!==Ie.charCodeAt(ze+oe))return K}return a({start:ze,end:ze+z+1},K)}function d(me,Ie){for(let Me=Ie;Me<me.length;Me++)if(s(me.charCodeAt(Me))||Me>0&&s(me.charCodeAt(Me-1)))return Me;return me.length}const y=L(e.$6j,w,g),b=L(e.$6j,w,f),A=new S.$Dc(1e4);function T(me,Ie,Me=!1){if(typeof me!="string"||typeof Ie!="string")return null;let ze=A.get(me);ze||(ze=new RegExp(P.$5e(me),"i"),A.set(me,ze));const N=ze.exec(Ie);return N?[{start:N.index,end:N.index+N[0].length}]:Me?b(me,Ie):y(me,Ie)}e.$_j=T;function G(me,Ie){const Me=we(me,me.toLowerCase(),0,Ie,Ie.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Me?U(Me):null}e.$ak=G;function W(me,Ie,Me,ze,N,z){const K=Math.min(13,me.length);for(;Me<K;Me++){const H=we(me,Ie,Me,ze,N,z,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(H)return H}return[0,z]}e.$bk=W;function U(me){if(typeof me>"u")return[];const Ie=[],Me=me[1];for(let ze=me.length-1;ze>1;ze--){const N=me[ze]+Me,z=Ie[Ie.length-1];z&&z.end===N?z.end=N+1:Ie.push({start:N,end:N+1})}return Ie}e.$ck=U;const C=128;function O(){const me=[],Ie=[];for(let Me=0;Me<=C;Me++)Ie[Me]=0;for(let Me=0;Me<=C;Me++)me.push(Ie.slice(0));return me}function V(me){const Ie=[];for(let Me=0;Me<=me;Me++)Ie[Me]=0;return Ie}const re=V(2*C),ue=V(2*C),ye=O(),De=O(),he=O(),ve=!1;function se(me,Ie,Me,ze,N){function z(H,te,oe=" "){for(;H.length<te;)H=oe+H;return H}let K=` |   |${ze.split("").map(H=>z(H,3)).join("|")}
`;for(let H=0;H<=Me;H++)H===0?K+=" |":K+=`${Ie[H-1]}|`,K+=me[H].slice(0,N+1).map(te=>z(te.toString(),3)).join("|")+`
`;return K}function $e(me,Ie,Me,ze){me=me.substr(Ie),Me=Me.substr(ze),console.log(se(De,me,me.length,Me,Me.length)),console.log(se(he,me,me.length,Me,Me.length)),console.log(se(ye,me,me.length,Me,Me.length))}function ee(me,Ie){if(Ie<0||Ie>=me.length)return!1;const Me=me.codePointAt(Ie);switch(Me){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!P.$Cf(Me)}}function Q(me,Ie){if(Ie<0||Ie>=me.length)return!1;switch(me.charCodeAt(Ie)){case 32:case 9:return!0;default:return!1}}function q(me,Ie,Me){return Ie[me]!==Me[me]}function ne(me,Ie,Me,ze,N,z,K=!1){for(;Ie<Me&&N<z;)me[Ie]===ze[N]&&(K&&(re[Ie]=N),Ie+=1),N+=1;return Ie===Me}e.$dk=ne;var Se;(function(me){me[me.Diag=1]="Diag",me[me.Left=2]="Left",me[me.LeftLeft=3]="LeftLeft"})(Se||(Se={}));var Te;(function(me){me.Default=[-100,0];function Ie(Me){return!Me||Me.length===2&&Me[0]===-100&&Me[1]===0}me.isDefault=Ie})(Te||(e.FuzzyScore=Te={}));class Ce{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(Ie,Me){this.firstMatchCanBeWeak=Ie,this.boostFullMatch=Me}}e.$ek=Ce;function we(me,Ie,Me,ze,N,z,K=Ce.default){const H=me.length>C?C:me.length,te=ze.length>C?C:ze.length;if(Me>=H||z>=te||H-Me>te-z||!ne(Ie,Me,H,N,z,te,!0))return;ge(H,te,Me,z,Ie,N);let oe=1,Oe=1,Ve=Me,He=z;const xe=[!1];for(oe=1,Ve=Me;Ve<H;oe++,Ve++){const ot=re[Ve],Be=ue[Ve],et=Ve+1<H?ue[Ve+1]:te;for(Oe=ot-z+1,He=ot;He<et;Oe++,He++){let Y=Number.MIN_SAFE_INTEGER,X=!1;He<=Be&&(Y=J(me,Ie,Ve,Me,ze,N,He,te,z,ye[oe-1][Oe-1]===0,xe));let pe=0;Y!==Number.MAX_SAFE_INTEGER&&(X=!0,pe=Y+De[oe-1][Oe-1]);const We=He>ot,Xe=We?De[oe][Oe-1]+(ye[oe][Oe-1]>0?-5:0):0,st=He>ot+1&&ye[oe][Oe-1]>0,Le=st?De[oe][Oe-2]+(ye[oe][Oe-2]>0?-5:0):0;if(st&&(!We||Le>=Xe)&&(!X||Le>=pe))De[oe][Oe]=Le,he[oe][Oe]=3,ye[oe][Oe]=0;else if(We&&(!X||Xe>=pe))De[oe][Oe]=Xe,he[oe][Oe]=2,ye[oe][Oe]=0;else if(X)De[oe][Oe]=pe,he[oe][Oe]=1,ye[oe][Oe]=ye[oe-1][Oe-1]+1;else throw new Error("not possible")}}if(ve&&$e(me,Me,ze,z),!xe[0]&&!K.firstMatchCanBeWeak)return;oe--,Oe--;const tt=[De[oe][Oe],z];let lt=0,rt=0;for(;oe>=1;){let ot=Oe;do{const Be=he[oe][ot];if(Be===3)ot=ot-2;else if(Be===2)ot=ot-1;else break}while(ot>=1);lt>1&&Ie[Me+oe-1]===N[z+Oe-1]&&!q(ot+z-1,ze,N)&&lt+1>ye[oe][ot]&&(ot=Oe),ot===Oe?lt++:lt=1,rt||(rt=ot),oe--,Oe=ot-1,tt.push(Oe)}te===H&&K.boostFullMatch&&(tt[0]+=2);const it=rt-H;return tt[0]-=it,tt}e.$fk=we;function ge(me,Ie,Me,ze,N,z){let K=me-1,H=Ie-1;for(;K>=Me&&H>=ze;)N[K]===z[H]&&(ue[K]=H,K--),H--}function J(me,Ie,Me,ze,N,z,K,H,te,oe,Oe){if(Ie[Me]!==z[K])return Number.MIN_SAFE_INTEGER;let Ve=1,He=!1;return K===Me-ze?Ve=me[Me]===N[K]?7:5:q(K,N,z)&&(K===0||!q(K-1,N,z))?(Ve=me[Me]===N[K]?7:5,He=!0):ee(z,K)&&(K===0||!ee(z,K-1))?Ve=5:(ee(z,K-1)||Q(z,K-1))&&(Ve=5,He=!0),Ve>1&&Me===ze&&(Oe[0]=!0),He||(He=q(K,N,z)||ee(z,K-1)||Q(z,K-1)),Me===ze?K>te&&(Ve-=He?3:5):oe?Ve+=He?2:0:Ve+=He?0:1,K+1===H&&(Ve-=He?3:5),Ve}function x(me,Ie,Me,ze,N,z,K){return de(me,Ie,Me,ze,N,z,!0,K)}e.$gk=x;function le(me,Ie,Me,ze,N,z,K){return de(me,Ie,Me,ze,N,z,!1,K)}e.$hk=le;function de(me,Ie,Me,ze,N,z,K,H){let te=we(me,Ie,Me,ze,N,z,H);if(te&&!K)return te;if(me.length>=3){const oe=Math.min(7,me.length-1);for(let Oe=Me+1;Oe<oe;Oe++){const Ve=Pe(me,Oe);if(Ve){const He=we(Ve,Ve.toLowerCase(),Me,ze,N,z,H);He&&(He[0]-=3,(!te||He[0]>te[0])&&(te=He))}}}return te}function Pe(me,Ie){if(Ie+1>=me.length)return;const Me=me[Ie],ze=me[Ie+1];if(Me!==ze)return me.slice(0,Ie)+ze+Me+me.slice(Ie+2)}}),define(Re[32],Ae([1,0,13]),function(fe,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var F;(function(P){P[P.Ignore=0]="Ignore",P[P.Info=1]="Info",P[P.Warning=2]="Warning",P[P.Error=3]="Error"})(F||(F={})),function(P){const L="error",R="warning",g="warn",f="info",D="ignore";function M(l){return l?S.$jf(L,l)?P.Error:S.$jf(R,l)||S.$jf(g,l)?P.Warning:S.$jf(f,l)?P.Info:P.Ignore:P.Ignore}P.fromValue=M;function k(l){switch(l){case P.Error:return L;case P.Warning:return R;case P.Info:return f;default:return D}}P.toString=k}(F||(F={})),e.default=F}),define(Re[126],Ae([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2d=void 0,e.$2d=Symbol("MicrotaskDelay")}),define(Re[50],Ae([1,0,18,13]),function(fe,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ki=e.$ji=e.$ii=e.$hi=e.$gi=void 0;class P{constructor(){this.b="",this.c=0}reset(v){return this.b=v,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(v){const $=v.charCodeAt(0),s=this.b.charCodeAt(this.c);return $-s}value(){return this.b[this.c]}}e.$gi=P;class L{constructor(v=!0){this.e=v}reset(v){return this.b=v,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let v=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(v)this.c++;else break;else v=!1;return this}cmp(v){return this.e?(0,F.$df)(v,this.b,0,v.length,this.c,this.d):(0,F.$ff)(v,this.b,0,v.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$hi=L;class R{constructor(v=!0,$=!0){this.f=v,this.g=$}reset(v){this.d=0,this.e=0,this.b=v,this.c=v.length;for(let $=v.length-1;$>=0;$--,this.c--){const s=this.b.charCodeAt($);if(!(s===47||this.f&&s===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let v=!0;for(;this.e<this.c;this.e++){const $=this.b.charCodeAt(this.e);if($===47||this.f&&$===92)if(v)this.d++;else break;else v=!1}return this}cmp(v){return this.g?(0,F.$df)(v,this.b,0,v.length,this.d,this.e):(0,F.$ff)(v,this.b,0,v.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$ii=R;var g;(function(l){l[l.Scheme=1]="Scheme",l[l.Authority=2]="Authority",l[l.Path=3]="Path",l[l.Query=4]="Query",l[l.Fragment=5]="Fragment"})(g||(g={}));class f{constructor(v,$){this.f=v,this.g=$,this.d=[],this.e=0}reset(v){return this.c=v,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new R(!1,!this.f(v)),this.b.reset(v.path),this.b.value()&&this.d.push(3)),this.g(v)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(v){if(this.d[this.e]===1)return(0,F.$ef)(v,this.c.scheme);if(this.d[this.e]===2)return(0,F.$ef)(v,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(v);if(this.d[this.e]===4)return(0,F.$cf)(v,this.c.query);if(this.d[this.e]===5)return(0,F.$cf)(v,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$ji=f;class D{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const v=this.right;return this.right=v.left,v.left=this,this.updateHeight(),v.updateHeight(),v}rotateRight(){const v=this.left;return this.left=v.right,v.right=this,this.updateHeight(),v.updateHeight(),v}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var M;(function(l){l[l.Left=-1]="Left",l[l.Mid=0]="Mid",l[l.Right=1]="Right"})(M||(M={}));class k{static forUris(v=()=>!1,$=()=>!1){return new k(new f(v,$))}static forPaths(v=!1){return new k(new R(void 0,!v))}static forStrings(){return new k(new P)}static forConfigKeys(){return new k(new L)}constructor(v){this.b=v}clear(){this.c=void 0}fill(v,$){if($){const s=$.slice(0);(0,S.$Xb)(s);for(const c of s)this.set(c,v)}else{const s=v.slice(0);(0,S.$Xb)(s);for(const c of s)this.set(c[0],c[1])}}set(v,$){const s=this.b.reset(v);let c;this.c||(this.c=new D,this.c.segment=s.value());const t=[];for(c=this.c;;){const r=s.cmp(c.segment);if(r>0)c.left||(c.left=new D,c.left.segment=s.value()),t.push([-1,c]),c=c.left;else if(r<0)c.right||(c.right=new D,c.right.segment=s.value()),t.push([1,c]),c=c.right;else if(s.hasNext())s.next(),c.mid||(c.mid=new D,c.mid.segment=s.value()),t.push([0,c]),c=c.mid;else break}const n=c.value;c.value=$,c.key=v;for(let r=t.length-1;r>=0;r--){const a=t[r][1];a.updateHeight();const h=a.balanceFactor();if(h<-1||h>1){const i=t[r][0],p=t[r+1][0];if(i===1&&p===1)t[r][1]=a.rotateLeft();else if(i===-1&&p===-1)t[r][1]=a.rotateRight();else if(i===1&&p===-1)a.right=t[r+1][1]=t[r+1][1].rotateRight(),t[r][1]=a.rotateLeft();else if(i===-1&&p===1)a.left=t[r+1][1]=t[r+1][1].rotateLeft(),t[r][1]=a.rotateRight();else throw new Error;if(r>0)switch(t[r-1][0]){case-1:t[r-1][1].left=t[r][1];break;case 1:t[r-1][1].right=t[r][1];break;case 0:t[r-1][1].mid=t[r][1];break}else this.c=t[0][1]}}return n}get(v){return this.d(v)?.value}d(v){const $=this.b.reset(v);let s=this.c;for(;s;){const c=$.cmp(s.segment);if(c>0)s=s.left;else if(c<0)s=s.right;else if($.hasNext())$.next(),s=s.mid;else break}return s}has(v){const $=this.d(v);return!($?.value===void 0&&$?.mid===void 0)}delete(v){return this.e(v,!1)}deleteSuperstr(v){return this.e(v,!0)}e(v,$){const s=this.b.reset(v),c=[];let t=this.c;for(;t;){const n=s.cmp(t.segment);if(n>0)c.push([-1,t]),t=t.left;else if(n<0)c.push([1,t]),t=t.right;else if(s.hasNext())s.next(),c.push([0,t]),t=t.mid;else break}if(t){if($?(t.left=void 0,t.mid=void 0,t.right=void 0,t.height=1):(t.key=void 0,t.value=void 0),!t.mid&&!t.value)if(t.left&&t.right){const n=this.f(t.right);if(n.key){const{key:r,value:a,segment:h}=n;this.e(n.key,!1),t.key=r,t.value=a,t.segment=h}}else{const n=t.left??t.right;if(c.length>0){const[r,a]=c[c.length-1];switch(r){case-1:a.left=n;break;case 0:a.mid=n;break;case 1:a.right=n;break}}else this.c=n}for(let n=c.length-1;n>=0;n--){const r=c[n][1];r.updateHeight();const a=r.balanceFactor();if(a>1?(r.right.balanceFactor()>=0||(r.right=r.right.rotateRight()),c[n][1]=r.rotateLeft()):a<-1&&(r.left.balanceFactor()<=0||(r.left=r.left.rotateLeft()),c[n][1]=r.rotateRight()),n>0)switch(c[n-1][0]){case-1:c[n-1][1].left=c[n][1];break;case 1:c[n-1][1].right=c[n][1];break;case 0:c[n-1][1].mid=c[n][1];break}else this.c=c[0][1]}}}f(v){for(;v.left;)v=v.left;return v}findSubstr(v){const $=this.b.reset(v);let s=this.c,c;for(;s;){const t=$.cmp(s.segment);if(t>0)s=s.left;else if(t<0)s=s.right;else if($.hasNext())$.next(),c=s.value||c,s=s.mid;else break}return s&&s.value||c}findSuperstr(v){return this.g(v,!1)}g(v,$){const s=this.b.reset(v);let c=this.c;for(;c;){const t=s.cmp(c.segment);if(t>0)c=c.left;else if(t<0)c=c.right;else if(s.hasNext())s.next(),c=c.mid;else return c.mid?this.h(c.mid):$?c.value:void 0}}hasElementOrSubtree(v){return this.g(v,!0)!==void 0}forEach(v){for(const[$,s]of this)v(s,$)}*[Symbol.iterator](){yield*this.h(this.c)}h(v){const $=[];return this.j(v,$),$[Symbol.iterator]()}j(v,$){v&&(v.left&&this.j(v.left,$),v.value&&$.push([v.key,v.value]),v.mid&&this.j(v.mid,$),v.right&&this.j(v.right,$))}_isBalanced(){const v=$=>{if(!$)return!0;const s=$.balanceFactor();return s<-1||s>1?!1:v($.left)&&v($.right)};return v(this.c)}}e.$ki=k}),define(Re[41],Ae([1,0,89]),function(fe,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$lk=e.ThemeColor=void 0;var F;(function(R){function g(f){return f&&typeof f=="object"&&typeof f.id=="string"}R.isThemeColor=g})(F||(e.ThemeColor=F={}));function P(R){return{id:R}}e.$lk=P;var L;(function(R){R.iconNameSegment="[A-Za-z0-9]+",R.iconNameExpression="[A-Za-z0-9-]+",R.iconModifierExpression="~[A-Za-z]+",R.iconNameCharacter="[A-Za-z0-9~-]";const g=new RegExp(`^(${R.iconNameExpression})(${R.iconModifierExpression})?$`);function f(n){const r=g.exec(n.id);if(!r)return f(S.$kk.error);const[,a,h]=r,i=["codicon","codicon-"+a];return h&&i.push("codicon-modifier-"+h.substring(1)),i}R.asClassNameArray=f;function D(n){return f(n).join(" ")}R.asClassName=D;function M(n){return"."+f(n).join(".")}R.asCSSSelector=M;function k(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(typeof n.color>"u"||F.isThemeColor(n.color))}R.isThemeIcon=k;const l=new RegExp(`^\\$\\((${R.iconNameExpression}(?:${R.iconModifierExpression})?)\\)$`);function v(n){const r=l.exec(n);if(!r)return;const[,a]=r;return{id:a}}R.fromString=v;function $(n){return{id:n}}R.fromId=$;function s(n,r){let a=n.id;const h=a.lastIndexOf("~");return h!==-1&&(a=a.substring(0,h)),r&&(a=`${a}~${r}`),{id:a}}R.modify=s;function c(n){const r=n.id.lastIndexOf("~");if(r!==-1)return n.id.substring(r+1)}R.getModifier=c;function t(n,r){return n.id===r.id&&n.color?.id===r.color?.id}R.isEqual=t})(L||(e.ThemeIcon=L={}))}),define(Re[127],Ae([1,0,125,13,41]),function(fe,e,S,F,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rk=e.$qk=e.$pk=e.$ok=e.$nk=e.$mk=void 0;const L="$(",R=new RegExp(`\\$\\(${P.ThemeIcon.iconNameExpression}(?:${P.ThemeIcon.iconModifierExpression})?\\)`,"g"),g=new RegExp(`(\\\\)?${R.source}`,"g");function f(t){return t.replace(g,(n,r)=>r?n:`\\${n}`)}e.$mk=f;const D=new RegExp(`\\\\${R.source}`,"g");function M(t){return t.replace(D,n=>`\\${n}`)}e.$nk=M;const k=new RegExp(`(\\s)?(\\\\)?${R.source}(\\s)?`,"g");function l(t){return t.indexOf(L)===-1?t:t.replace(k,(n,r,a,h)=>a?n:r||h||"")}e.$ok=l;function v(t){return t?t.replace(/\$\((.*?)\)/g,(n,r)=>` ${r} `).trim():""}e.$pk=v;const $=new RegExp(`\\$\\(${P.ThemeIcon.iconNameCharacter}+\\)`,"g");function s(t){$.lastIndex=0;let n="";const r=[];let a=0;for(;;){const h=$.lastIndex,i=$.exec(t),p=t.substring(h,i?.index);if(p.length>0){n+=p;for(let u=0;u<p.length;u++)r.push(a)}if(!i)break;a+=i[0].length}return{text:n,iconOffsets:r}}e.$qk=s;function c(t,n,r=!1){const{text:a,iconOffsets:h}=n;if(!h||h.length===0)return(0,S.$_j)(t,a,r);const i=(0,F.$3e)(a," "),p=a.length-i.length,u=(0,S.$_j)(t,i,r);if(u)for(const o of u){const E=h[o.start+p]+p;o.start+=E,o.end+=E}return u}e.$rk=c}),define(Re[33],Ae([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ag=e.$zg=void 0;const S=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function F(P){return S.test(P)}e.$zg=F,e.$Ag=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let P;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?P=crypto.getRandomValues.bind(crypto):P=function(g){for(let f=0;f<g.length;f++)g[f]=Math.floor(Math.random()*256);return g};const L=new Uint8Array(16),R=[];for(let g=0;g<256;g++)R.push(g.toString(16).padStart(2,"0"));return function(){P(L),L[6]=L[6]&15|64,L[8]=L[8]&63|128;let f=0,D="";return D+=R[L[f++]],D+=R[L[f++]],D+=R[L[f++]],D+=R[L[f++]],D+="-",D+=R[L[f++]],D+=R[L[f++]],D+="-",D+=R[L[f++]],D+=R[L[f++]],D+="-",D+=R[L[f++]],D+=R[L[f++]],D+="-",D+=R[L[f++]],D+=R[L[f++]],D+=R[L[f++]],D+=R[L[f++]],D+=R[L[f++]],D+=R[L[f++]],D}}()}),define(Re[128],Ae([1,0,18,51,33]),function(fe,e,S,F,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ct=e.$Bt=e.$At=e.$zt=e.$yt=void 0;function L(k){return{asString:async()=>k,asFile:()=>{},value:typeof k=="string"?k:void 0}}e.$yt=L;function R(k,l,v){const $={id:(0,P.$Ag)(),name:k,uri:l,data:v};return{asString:async()=>"",asFile:()=>$,value:void 0}}e.$zt=R;class g{constructor(){this.a=new Map}get size(){let l=0;for(const v of this.a)l++;return l}has(l){return this.a.has(this.b(l))}matches(l){const v=[...this.a.keys()];return F.Iterable.some(this,([$,s])=>s.asFile())&&v.push("files"),M(f(l),v)}get(l){return this.a.get(this.b(l))?.[0]}append(l,v){const $=this.a.get(l);$?$.push(v):this.a.set(this.b(l),[v])}replace(l,v){this.a.set(this.b(l),[v])}delete(l){this.a.delete(this.b(l))}*[Symbol.iterator](){for(const[l,v]of this.a)for(const $ of v)yield[l,$]}b(l){return f(l)}}e.$At=g;function f(k){return k.toLowerCase()}function D(k,l){return M(f(k),l.map(f))}e.$Bt=D;function M(k,l){if(k==="*/*")return l.length>0;if(l.includes(k))return!0;const v=k.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!v)return!1;const[$,s,c]=v;return c==="*"?l.some(t=>t.startsWith(s+"/")):!1}e.$Ct=Object.freeze({create:k=>(0,S.$Mb)(k.map(l=>l.toString())).join(`\r
`),split:k=>k.split(`\r
`),parse:k=>e.$Ct.split(k).filter(l=>!l.startsWith("#"))})}),define(Re[129],Ae([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ft=e.StringEOL=void 0;var S;(function(P){P[P.Unknown=0]="Unknown",P[P.Invalid=3]="Invalid",P[P.LF=1]="LF",P[P.CRLF=2]="CRLF"})(S||(e.StringEOL=S={}));function F(P){let L=0,R=0,g=0,f=0;for(let D=0,M=P.length;D<M;D++){const k=P.charCodeAt(D);k===13?(L===0&&(R=D),L++,D+1<M&&P.charCodeAt(D+1)===10?(f|=2,D++):f|=3,g=D+1):k===10&&(f|=1,L===0&&(R=D),L++,g=D+1)}return L===0&&(R=P.length),[L,R,P.length-g,f]}e.$Ft=F}),define(Re[130],Ae([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ds=void 0,e.$Ds={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Re[131],Ae([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5t=e.$4t=e.IndentAction=void 0;var S;(function(R){R[R.None=0]="None",R[R.Indent=1]="Indent",R[R.IndentOutdent=2]="IndentOutdent",R[R.Outdent=3]="Outdent"})(S||(e.IndentAction=S={}));class F{constructor(g){if(this.e=null,this.f=!1,this.open=g.open,this.close=g.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(g.notIn))for(let f=0,D=g.notIn.length;f<D;f++)switch(g.notIn[f]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(g){switch(g){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(g,f){if(g.getTokenCount()===0)return!0;const D=g.findTokenIndexAtOffset(f-2),M=g.getStandardTokenType(D);return this.isOK(M)}g(g,f){for(let D=g;D<=f;D++){const M=String.fromCharCode(D);if(!this.open.includes(M)&&!this.close.includes(M))return M}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$4t=F;class P{constructor(g){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const f of g)L(this.autoClosingPairsOpenByStart,f.open.charAt(0),f),L(this.autoClosingPairsOpenByEnd,f.open.charAt(f.open.length-1),f),L(this.autoClosingPairsCloseByStart,f.close.charAt(0),f),L(this.autoClosingPairsCloseByEnd,f.close.charAt(f.close.length-1),f),f.close.length===1&&f.open.length===1&&L(this.autoClosingPairsCloseSingleChar,f.close,f)}}e.$5t=P;function L(R,g,f){R.has(g)?R.get(g).push(f):R.set(g,[f])}}),define(Re[132],Ae([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bC=e.$aC=e.$_B=e.$$B=e.$0B=e.$9B=e.$8B=e.$7B=e.$6B=e.NodeColor=e.$5B=void 0;class S{constructor(c,t){this.piece=c,this.color=t,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$6B)return P(this.right);let c=this;for(;c.parent!==e.$6B&&c.parent.left!==c;)c=c.parent;return c.parent===e.$6B?e.$6B:c.parent}prev(){if(this.left!==e.$6B)return L(this.left);let c=this;for(;c.parent!==e.$6B&&c.parent.right!==c;)c=c.parent;return c.parent===e.$6B?e.$6B:c.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$5B=S;var F;(function(s){s[s.Black=0]="Black",s[s.Red=1]="Red"})(F||(e.NodeColor=F={})),e.$6B=new S(null,0),e.$6B.parent=e.$6B,e.$6B.left=e.$6B,e.$6B.right=e.$6B,e.$6B.color=0;function P(s){for(;s.left!==e.$6B;)s=s.left;return s}e.$7B=P;function L(s){for(;s.right!==e.$6B;)s=s.right;return s}e.$8B=L;function R(s){return s===e.$6B?0:s.size_left+s.piece.length+R(s.right)}function g(s){return s===e.$6B?0:s.lf_left+s.piece.lineFeedCnt+g(s.right)}function f(){e.$6B.parent=e.$6B}function D(s,c){const t=c.right;t.size_left+=c.size_left+(c.piece?c.piece.length:0),t.lf_left+=c.lf_left+(c.piece?c.piece.lineFeedCnt:0),c.right=t.left,t.left!==e.$6B&&(t.left.parent=c),t.parent=c.parent,c.parent===e.$6B?s.root=t:c.parent.left===c?c.parent.left=t:c.parent.right=t,t.left=c,c.parent=t}e.$9B=D;function M(s,c){const t=c.left;c.left=t.right,t.right!==e.$6B&&(t.right.parent=c),t.parent=c.parent,c.size_left-=t.size_left+(t.piece?t.piece.length:0),c.lf_left-=t.lf_left+(t.piece?t.piece.lineFeedCnt:0),c.parent===e.$6B?s.root=t:c===c.parent.right?c.parent.right=t:c.parent.left=t,t.right=c,c.parent=t}e.$0B=M;function k(s,c){let t,n;if(c.left===e.$6B?(n=c,t=n.right):c.right===e.$6B?(n=c,t=n.left):(n=P(c.right),t=n.right),n===s.root){s.root=t,t.color=0,c.detach(),f(),s.root.parent=e.$6B;return}const r=n.color===1;if(n===n.parent.left?n.parent.left=t:n.parent.right=t,n===c?(t.parent=n.parent,$(s,t)):(n.parent===c?t.parent=n:t.parent=n.parent,$(s,t),n.left=c.left,n.right=c.right,n.parent=c.parent,n.color=c.color,c===s.root?s.root=n:c===c.parent.left?c.parent.left=n:c.parent.right=n,n.left!==e.$6B&&(n.left.parent=n),n.right!==e.$6B&&(n.right.parent=n),n.size_left=c.size_left,n.lf_left=c.lf_left,$(s,n)),c.detach(),t.parent.left===t){const h=R(t),i=g(t);if(h!==t.parent.size_left||i!==t.parent.lf_left){const p=h-t.parent.size_left,u=i-t.parent.lf_left;t.parent.size_left=h,t.parent.lf_left=i,v(s,t.parent,p,u)}}if($(s,t.parent),r){f();return}let a;for(;t!==s.root&&t.color===0;)t===t.parent.left?(a=t.parent.right,a.color===1&&(a.color=0,t.parent.color=1,D(s,t.parent),a=t.parent.right),a.left.color===0&&a.right.color===0?(a.color=1,t=t.parent):(a.right.color===0&&(a.left.color=0,a.color=1,M(s,a),a=t.parent.right),a.color=t.parent.color,t.parent.color=0,a.right.color=0,D(s,t.parent),t=s.root)):(a=t.parent.left,a.color===1&&(a.color=0,t.parent.color=1,M(s,t.parent),a=t.parent.left),a.left.color===0&&a.right.color===0?(a.color=1,t=t.parent):(a.left.color===0&&(a.right.color=0,a.color=1,D(s,a),a=t.parent.left),a.color=t.parent.color,t.parent.color=0,a.left.color=0,M(s,t.parent),t=s.root));t.color=0,f()}e.$$B=k;function l(s,c){for($(s,c);c!==s.root&&c.parent.color===1;)if(c.parent===c.parent.parent.left){const t=c.parent.parent.right;t.color===1?(c.parent.color=0,t.color=0,c.parent.parent.color=1,c=c.parent.parent):(c===c.parent.right&&(c=c.parent,D(s,c)),c.parent.color=0,c.parent.parent.color=1,M(s,c.parent.parent))}else{const t=c.parent.parent.left;t.color===1?(c.parent.color=0,t.color=0,c.parent.parent.color=1,c=c.parent.parent):(c===c.parent.left&&(c=c.parent,M(s,c)),c.parent.color=0,c.parent.parent.color=1,D(s,c.parent.parent))}s.root.color=0}e.$_B=l;function v(s,c,t,n){for(;c!==s.root&&c!==e.$6B;)c.parent.left===c&&(c.parent.size_left+=t,c.parent.lf_left+=n),c=c.parent}e.$aC=v;function $(s,c){let t=0,n=0;if(c!==s.root){for(;c!==s.root&&c===c.parent.right;)c=c.parent;if(c!==s.root)for(c=c.parent,t=R(c.left)-c.size_left,n=g(c.left)-c.lf_left,c.size_left+=t,c.lf_left+=n;c!==s.root&&(t!==0||n!==0);)c.parent.left===c&&(c.parent.size_left+=t,c.parent.lf_left+=n),c=c.parent}}e.$bC=$}),define(Re[90],Ae([1,0,91,29,92,132,93]),function(fe,e,S,F,P,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mC=e.$lC=e.$kC=e.$jC=e.$iC=void 0;const g=65535;function f(t){let n;return t[t.length-1]<65536?n=new Uint16Array(t.length):n=new Uint32Array(t.length),n.set(t,0),n}class D{constructor(n,r,a,h,i){this.lineStarts=n,this.cr=r,this.lf=a,this.crlf=h,this.isBasicASCII=i}}function M(t,n=!0){const r=[0];let a=1;for(let h=0,i=t.length;h<i;h++){const p=t.charCodeAt(h);p===13?h+1<i&&t.charCodeAt(h+1)===10?(r[a++]=h+2,h++):r[a++]=h+1:p===10&&(r[a++]=h+1)}return n?f(r):r}e.$iC=M;function k(t,n){t.length=0,t[0]=0;let r=1,a=0,h=0,i=0,p=!0;for(let o=0,E=n.length;o<E;o++){const w=n.charCodeAt(o);w===13?o+1<E&&n.charCodeAt(o+1)===10?(i++,t[r++]=o+2,o++):(a++,t[r++]=o+1):w===10?(h++,t[r++]=o+1):p&&w!==9&&(w<32||w>126)&&(p=!1)}const u=new D(f(t),a,h,i,p);return t.length=0,u}e.$jC=k;class l{constructor(n,r,a,h,i){this.bufferIndex=n,this.start=r,this.end=a,this.lineFeedCnt=h,this.length=i}}e.$kC=l;class v{constructor(n,r){this.buffer=n,this.lineStarts=r}}e.$lC=v;class ${constructor(n,r){this.a=[],this.c=n,this.d=r,this.b=0,n.root!==L.$6B&&n.iterate(n.root,a=>(a!==L.$6B&&this.a.push(a.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class s{constructor(n){this.a=n,this.b=[]}get(n){for(let r=this.b.length-1;r>=0;r--){const a=this.b[r];if(a.nodeStartOffset<=n&&a.nodeStartOffset+a.node.piece.length>=n)return a}return null}get2(n){for(let r=this.b.length-1;r>=0;r--){const a=this.b[r];if(a.nodeStartLineNumber&&a.nodeStartLineNumber<n&&a.nodeStartLineNumber+a.node.piece.lineFeedCnt>=n)return a}return null}set(n){this.b.length>=this.a&&this.b.shift(),this.b.push(n)}validate(n){let r=!1;const a=this.b;for(let h=0;h<a.length;h++){const i=a[h];if(i.node.parent===null||i.nodeStartOffset>=n){a[h]=null,r=!0;continue}}if(r){const h=[];for(const i of a)i!==null&&h.push(i);this.b=h}}}class c{constructor(n,r,a){this.create(n,r,a)}create(n,r,a){this.a=[new v("",[0])],this.g={line:0,column:0},this.root=L.$6B,this.b=1,this.c=0,this.d=r,this.e=r.length,this.f=a;let h=null;for(let i=0,p=n.length;i<p;i++)if(n[i].buffer.length>0){n[i].lineStarts||(n[i].lineStarts=M(n[i].buffer));const u=new l(i+1,{line:0,column:0},{line:n[i].lineStarts.length-1,column:n[i].buffer.length-n[i].lineStarts[n[i].lineStarts.length-1]},n[i].lineStarts.length-1,n[i].buffer.length);this.a.push(n[i]),h=this.S(h,u)}this.h=new s(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(n){const r=g,a=r-Math.floor(r/3),h=a*2;let i="",p=0;const u=[];if(this.iterate(this.root,o=>{const E=this.R(o),w=E.length;if(p<=a||p+w<h)return i+=E,p+=w,!0;const m=i.replace(/\r\n|\r|\n/g,n);return u.push(new v(m,M(m))),i=E,p=w,!0}),p>0){const o=i.replace(/\r\n|\r|\n/g,n);u.push(new v(o,M(o)))}this.create(u,n,!0)}getEOL(){return this.d}setEOL(n){this.d=n,this.e=this.d.length,this.normalizeEOL(n)}createSnapshot(n){return new $(this,n)}equal(n){if(this.getLength()!==n.getLength()||this.getLineCount()!==n.getLineCount())return!1;let r=0;return this.iterate(this.root,h=>{if(h===L.$6B)return!0;const i=this.R(h),p=i.length,u=n.G(r),o=n.G(r+p),E=n.getValueInRange2(u,o);return r+=p,i===E})}getOffsetAt(n,r){let a=0,h=this.root;for(;h!==L.$6B;)if(h.left!==L.$6B&&h.lf_left+1>=n)h=h.left;else if(h.lf_left+h.piece.lineFeedCnt+1>=n){a+=h.size_left;const i=this.B(h,n-h.lf_left-2);return a+=i+r-1}else n-=h.lf_left+h.piece.lineFeedCnt,a+=h.size_left+h.piece.length,h=h.right;return a}getPositionAt(n){n=Math.floor(n),n=Math.max(0,n);let r=this.root,a=0;const h=n;for(;r!==L.$6B;)if(r.size_left!==0&&r.size_left>=n)r=r.left;else if(r.size_left+r.piece.length>=n){const i=this.A(r,n-r.size_left);if(a+=r.lf_left+i.index,i.index===0){const p=this.getOffsetAt(a+1,1),u=h-p;return new S.$5s(a+1,u+1)}return new S.$5s(a+1,i.remainder+1)}else if(n-=r.size_left+r.piece.length,a+=r.lf_left+r.piece.lineFeedCnt,r.right===L.$6B){const i=this.getOffsetAt(a+1,1),p=h-n-i;return new S.$5s(a+1,p+1)}else r=r.right;return new S.$5s(1,1)}getValueInRange(n,r){if(n.startLineNumber===n.endLineNumber&&n.startColumn===n.endColumn)return"";const a=this.H(n.startLineNumber,n.startColumn),h=this.H(n.endLineNumber,n.endColumn),i=this.getValueInRange2(a,h);return r?r!==this.d||!this.f?i.replace(/\r\n|\r|\n/g,r):r===this.getEOL()&&this.f?i:i.replace(/\r\n|\r|\n/g,r):i}getValueInRange2(n,r){if(n.node===r.node){const u=n.node,o=this.a[u.piece.bufferIndex].buffer,E=this.u(u.piece.bufferIndex,u.piece.start);return o.substring(E+n.remainder,E+r.remainder)}let a=n.node;const h=this.a[a.piece.bufferIndex].buffer,i=this.u(a.piece.bufferIndex,a.piece.start);let p=h.substring(i+n.remainder,i+a.piece.length);for(a=a.next();a!==L.$6B;){const u=this.a[a.piece.bufferIndex].buffer,o=this.u(a.piece.bufferIndex,a.piece.start);if(a===r.node){p+=u.substring(o,o+r.remainder);break}else p+=u.substr(o,a.piece.length);a=a.next()}return p}getLinesContent(){const n=[];let r=0,a="",h=!1;return this.iterate(this.root,i=>{if(i===L.$6B)return!0;const p=i.piece;let u=p.length;if(u===0)return!0;const o=this.a[p.bufferIndex].buffer,E=this.a[p.bufferIndex].lineStarts,w=p.start.line,m=p.end.line;let I=E[w]+p.start.column;if(h&&(o.charCodeAt(I)===10&&(I++,u--),n[r++]=a,a="",h=!1,u===0))return!0;if(w===m)return!this.f&&o.charCodeAt(I+u-1)===13?(h=!0,a+=o.substr(I,u-1)):a+=o.substr(I,u),!0;a+=this.f?o.substring(I,Math.max(I,E[w+1]-this.e)):o.substring(I,E[w+1]).replace(/(\r\n|\r|\n)$/,""),n[r++]=a;for(let d=w+1;d<m;d++)a=this.f?o.substring(E[d],E[d+1]-this.e):o.substring(E[d],E[d+1]).replace(/(\r\n|\r|\n)$/,""),n[r++]=a;return!this.f&&o.charCodeAt(E[m]+p.end.column-1)===13?(h=!0,p.end.column===0?r--:a=o.substr(E[m],p.end.column-1)):a=o.substr(E[m],p.end.column),!0}),h&&(n[r++]=a,a=""),n[r++]=a,n}getLength(){return this.c}getLineCount(){return this.b}getLineContent(n){return this.j.lineNumber===n?this.j.value:(this.j.lineNumber=n,n===this.b?this.j.value=this.getLineRawContent(n):this.f?this.j.value=this.getLineRawContent(n,this.e):this.j.value=this.getLineRawContent(n).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(n){if(n.remainder===n.node.piece.length){const r=n.node.next();if(!r)return 0;const a=this.a[r.piece.bufferIndex],h=this.u(r.piece.bufferIndex,r.piece.start);return a.buffer.charCodeAt(h)}else{const r=this.a[n.node.piece.bufferIndex],h=this.u(n.node.piece.bufferIndex,n.node.piece.start)+n.remainder;return r.buffer.charCodeAt(h)}}getLineCharCode(n,r){const a=this.H(n,r+1);return this.l(a)}getLineLength(n){if(n===this.getLineCount()){const r=this.getOffsetAt(n,1);return this.getLength()-r}return this.getOffsetAt(n+1,1)-this.getOffsetAt(n,1)-this.e}getCharCode(n){const r=this.G(n);return this.l(r)}findMatchesInNode(n,r,a,h,i,p,u,o,E,w,m){const I=this.a[n.piece.bufferIndex],d=this.u(n.piece.bufferIndex,n.piece.start),y=this.u(n.piece.bufferIndex,i),b=this.u(n.piece.bufferIndex,p);let A;const T={line:0,column:0};let G,W;r._wordSeparators?(G=I.buffer.substring(y,b),W=U=>U+y,r.reset(0)):(G=I.buffer,W=U=>U,r.reset(y));do if(A=r.next(G),A){if(W(A.index)>=b)return w;this.s(n,W(A.index)-d,T);const U=this.t(n.piece.bufferIndex,i,T),C=T.line===i.line?T.column-i.column+h:T.column+1,O=C+A[0].length;if(m[w++]=(0,R.$eC)(new F.$6s(a+U,C,a+U,O),A,o),W(A.index)+A[0].length>=b||w>=E)return w}while(A);return w}findMatchesLineByLine(n,r,a,h){const i=[];let p=0;const u=new R.$hC(r.wordSeparators,r.regex);let o=this.H(n.startLineNumber,n.startColumn);if(o===null)return[];const E=this.H(n.endLineNumber,n.endColumn);if(E===null)return[];let w=this.s(o.node,o.remainder);const m=this.s(E.node,E.remainder);if(o.node===E.node)return this.findMatchesInNode(o.node,u,n.startLineNumber,n.startColumn,w,m,r,a,h,p,i),i;let I=n.startLineNumber,d=o.node;for(;d!==E.node;){const b=this.t(d.piece.bufferIndex,w,d.piece.end);if(b>=1){const T=this.a[d.piece.bufferIndex].lineStarts,G=this.u(d.piece.bufferIndex,d.piece.start),W=T[w.line+b],U=I===n.startLineNumber?n.startColumn:1;if(p=this.findMatchesInNode(d,u,I,U,w,this.s(d,W-G),r,a,h,p,i),p>=h)return i;I+=b}const A=I===n.startLineNumber?n.startColumn-1:0;if(I===n.endLineNumber){const T=this.getLineContent(I).substring(A,n.endColumn-1);return p=this.n(r,u,T,n.endLineNumber,A,p,i,a,h),i}if(p=this.n(r,u,this.getLineContent(I).substr(A),I,A,p,i,a,h),p>=h)return i;I++,o=this.H(I,1),d=o.node,w=this.s(o.node,o.remainder)}if(I===n.endLineNumber){const b=I===n.startLineNumber?n.startColumn-1:0,A=this.getLineContent(I).substring(b,n.endColumn-1);return p=this.n(r,u,A,n.endLineNumber,b,p,i,a,h),i}const y=I===n.startLineNumber?n.startColumn:1;return p=this.findMatchesInNode(E.node,u,I,y,w,m,r,a,h,p,i),i}n(n,r,a,h,i,p,u,o,E){const w=n.wordSeparators;if(!o&&n.simpleSearch){const I=n.simpleSearch,d=I.length,y=a.length;let b=-d;for(;(b=a.indexOf(I,b+d))!==-1;)if((!w||(0,R.$gC)(w,a,y,b,d))&&(u[p++]=new P.$mv(new F.$6s(h,b+1+i,h,b+1+d+i),null),p>=E))return p;return p}let m;r.reset(0);do if(m=r.next(a),m&&(u[p++]=(0,R.$eC)(new F.$6s(h,m.index+1+i,h,m.index+1+m[0].length+i),m,o),p>=E))return p;while(m);return p}insert(n,r,a=!1){if(this.f=this.f&&a,this.j.lineNumber=0,this.j.value="",this.root!==L.$6B){const{node:h,remainder:i,nodeStartOffset:p}=this.G(n),u=h.piece,o=u.bufferIndex,E=this.s(h,i);if(h.piece.bufferIndex===0&&u.end.line===this.g.line&&u.end.column===this.g.column&&p+u.length===n&&r.length<g){this.F(h,r),this.y();return}if(p===n)this.o(r,h),this.h.validate(n);else if(p+h.piece.length>n){const w=[];let m=new l(u.bufferIndex,E,u.end,this.t(u.bufferIndex,E,u.end),this.u(o,u.end)-this.u(o,E));if(this.K()&&this.M(r)&&this.I(h,i)===10){const b={line:m.start.line+1,column:0};m=new l(m.bufferIndex,b,m.end,this.t(m.bufferIndex,b,m.end),m.length-1),r+=`
`}if(this.K()&&this.L(r))if(this.I(h,i-1)===13){const b=this.s(h,i-1);this.C(h,b),r="\r"+r,h.piece.length===0&&w.push(h)}else this.C(h,E);else this.C(h,E);const I=this.w(r);m.length>0&&this.S(h,m);let d=h;for(let y=0;y<I.length;y++)d=this.S(d,I[y]);this.v(w)}else this.q(r,h)}else{const h=this.w(r);let i=this.T(null,h[0]);for(let p=1;p<h.length;p++)i=this.S(i,h[p])}this.y()}delete(n,r){if(this.j.lineNumber=0,this.j.value="",r<=0||this.root===L.$6B)return;const a=this.G(n),h=this.G(n+r),i=a.node,p=h.node;if(i===p){const I=this.s(i,a.remainder),d=this.s(i,h.remainder);if(a.nodeStartOffset===n){if(r===i.piece.length){const y=i.next();(0,L.$$B)(this,i),this.N(y),this.y();return}this.D(i,d),this.h.validate(n),this.N(i),this.y();return}if(a.nodeStartOffset+i.piece.length===n+r){this.C(i,I),this.O(i),this.y();return}this.E(i,I,d),this.y();return}const u=[],o=this.s(i,a.remainder);this.C(i,o),this.h.validate(n),i.piece.length===0&&u.push(i);const E=this.s(p,h.remainder);this.D(p,E),p.piece.length===0&&u.push(p);const w=i.next();for(let I=w;I!==L.$6B&&I!==p;I=I.next())u.push(I);const m=i.piece.length===0?i.prev():i;this.v(u),this.O(m),this.y()}o(n,r){const a=[];if(this.K()&&this.M(n)&&this.L(r)){const p=r.piece,u={line:p.start.line+1,column:0},o=new l(p.bufferIndex,u,p.end,this.t(p.bufferIndex,u,p.end),p.length-1);r.piece=o,n+=`
`,(0,L.$aC)(this,r,-1,-1),r.piece.length===0&&a.push(r)}const h=this.w(n);let i=this.T(r,h[h.length-1]);for(let p=h.length-2;p>=0;p--)i=this.T(i,h[p]);this.N(i),this.v(a)}q(n,r){this.Q(n,r)&&(n+=`
`);const a=this.w(n),h=this.S(r,a[0]);let i=h;for(let p=1;p<a.length;p++)i=this.S(i,a[p]);this.N(h)}s(n,r,a){const h=n.piece,i=n.piece.bufferIndex,p=this.a[i].lineStarts,o=p[h.start.line]+h.start.column+r;let E=h.start.line,w=h.end.line,m=0,I=0,d=0;for(;E<=w&&(m=E+(w-E)/2|0,d=p[m],m!==w);)if(I=p[m+1],o<d)w=m-1;else if(o>=I)E=m+1;else break;return a?(a.line=m,a.column=o-d,null):{line:m,column:o-d}}t(n,r,a){if(a.column===0)return a.line-r.line;const h=this.a[n].lineStarts;if(a.line===h.length-1)return a.line-r.line;const i=h[a.line+1],p=h[a.line]+a.column;if(i>p+1)return a.line-r.line;const u=p-1;return this.a[n].buffer.charCodeAt(u)===13?a.line-r.line+1:a.line-r.line}u(n,r){return this.a[n].lineStarts[r.line]+r.column}v(n){for(let r=0;r<n.length;r++)(0,L.$$B)(this,n[r])}w(n){if(n.length>g){const w=[];for(;n.length>g;){const I=n.charCodeAt(g-1);let d;I===13||I>=55296&&I<=56319?(d=n.substring(0,g-1),n=n.substring(g-1)):(d=n.substring(0,g),n=n.substring(g));const y=M(d);w.push(new l(this.a.length,{line:0,column:0},{line:y.length-1,column:d.length-y[y.length-1]},y.length-1,d.length)),this.a.push(new v(d,y))}const m=M(n);return w.push(new l(this.a.length,{line:0,column:0},{line:m.length-1,column:n.length-m[m.length-1]},m.length-1,n.length)),this.a.push(new v(n,m)),w}let r=this.a[0].buffer.length;const a=M(n,!1);let h=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===r&&r!==0&&this.L(n)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},h=this.g;for(let w=0;w<a.length;w++)a[w]+=r+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(a.slice(1)),this.a[0].buffer+="_"+n,r+=1}else{if(r!==0)for(let w=0;w<a.length;w++)a[w]+=r;this.a[0].lineStarts=this.a[0].lineStarts.concat(a.slice(1)),this.a[0].buffer+=n}const i=this.a[0].buffer.length,p=this.a[0].lineStarts.length-1,u=i-this.a[0].lineStarts[p],o={line:p,column:u},E=new l(0,h,o,this.t(0,h,o),i-r);return this.g=o,[E]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(n,r=0){let a=this.root,h="";const i=this.h.get2(n);if(i){a=i.node;const p=this.B(a,n-i.nodeStartLineNumber-1),u=this.a[a.piece.bufferIndex].buffer,o=this.u(a.piece.bufferIndex,a.piece.start);if(i.nodeStartLineNumber+a.piece.lineFeedCnt===n)h=u.substring(o+p,o+a.piece.length);else{const E=this.B(a,n-i.nodeStartLineNumber);return u.substring(o+p,o+E-r)}}else{let p=0;const u=n;for(;a!==L.$6B;)if(a.left!==L.$6B&&a.lf_left>=n-1)a=a.left;else if(a.lf_left+a.piece.lineFeedCnt>n-1){const o=this.B(a,n-a.lf_left-2),E=this.B(a,n-a.lf_left-1),w=this.a[a.piece.bufferIndex].buffer,m=this.u(a.piece.bufferIndex,a.piece.start);return p+=a.size_left,this.h.set({node:a,nodeStartOffset:p,nodeStartLineNumber:u-(n-1-a.lf_left)}),w.substring(m+o,m+E-r)}else if(a.lf_left+a.piece.lineFeedCnt===n-1){const o=this.B(a,n-a.lf_left-2),E=this.a[a.piece.bufferIndex].buffer,w=this.u(a.piece.bufferIndex,a.piece.start);h=E.substring(w+o,w+a.piece.length);break}else n-=a.lf_left+a.piece.lineFeedCnt,p+=a.size_left+a.piece.length,a=a.right}for(a=a.next();a!==L.$6B;){const p=this.a[a.piece.bufferIndex].buffer;if(a.piece.lineFeedCnt>0){const u=this.B(a,0),o=this.u(a.piece.bufferIndex,a.piece.start);return h+=p.substring(o,o+u-r),h}else{const u=this.u(a.piece.bufferIndex,a.piece.start);h+=p.substr(u,a.piece.length)}a=a.next()}return h}y(){let n=this.root,r=1,a=0;for(;n!==L.$6B;)r+=n.lf_left+n.piece.lineFeedCnt,a+=n.size_left+n.piece.length,n=n.right;this.b=r,this.c=a,this.h.validate(this.c)}A(n,r){const a=n.piece,h=this.s(n,r),i=h.line-a.start.line;if(this.u(a.bufferIndex,a.end)-this.u(a.bufferIndex,a.start)===r){const p=this.t(n.piece.bufferIndex,a.start,h);if(p!==i)return{index:p,remainder:0}}return{index:i,remainder:h.column}}B(n,r){if(r<0)return 0;const a=n.piece,h=this.a[a.bufferIndex].lineStarts,i=a.start.line+r+1;return i>a.end.line?h[a.end.line]+a.end.column-h[a.start.line]-a.start.column:h[i]-h[a.start.line]-a.start.column}C(n,r){const a=n.piece,h=a.lineFeedCnt,i=this.u(a.bufferIndex,a.end),p=r,u=this.u(a.bufferIndex,p),o=this.t(a.bufferIndex,a.start,p),E=o-h,w=u-i,m=a.length+w;n.piece=new l(a.bufferIndex,a.start,p,o,m),(0,L.$aC)(this,n,w,E)}D(n,r){const a=n.piece,h=a.lineFeedCnt,i=this.u(a.bufferIndex,a.start),p=r,u=this.t(a.bufferIndex,p,a.end),o=this.u(a.bufferIndex,p),E=u-h,w=i-o,m=a.length+w;n.piece=new l(a.bufferIndex,p,a.end,u,m),(0,L.$aC)(this,n,w,E)}E(n,r,a){const h=n.piece,i=h.start,p=h.end,u=h.length,o=h.lineFeedCnt,E=r,w=this.t(h.bufferIndex,h.start,E),m=this.u(h.bufferIndex,r)-this.u(h.bufferIndex,i);n.piece=new l(h.bufferIndex,h.start,E,w,m),(0,L.$aC)(this,n,m-u,w-o);const I=new l(h.bufferIndex,a,p,this.t(h.bufferIndex,a,p),this.u(h.bufferIndex,p)-this.u(h.bufferIndex,a)),d=this.S(n,I);this.N(d)}F(n,r){this.Q(r,n)&&(r+=`
`);const a=this.K()&&this.L(r)&&this.M(n),h=this.a[0].buffer.length;this.a[0].buffer+=r;const i=M(r,!1);for(let d=0;d<i.length;d++)i[d]+=h;if(a){const d=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:h-d}}this.a[0].lineStarts=this.a[0].lineStarts.concat(i.slice(1));const p=this.a[0].lineStarts.length-1,u=this.a[0].buffer.length-this.a[0].lineStarts[p],o={line:p,column:u},E=n.piece.length+r.length,w=n.piece.lineFeedCnt,m=this.t(0,n.piece.start,o),I=m-w;n.piece=new l(n.piece.bufferIndex,n.piece.start,o,m,E),this.g=o,(0,L.$aC)(this,n,r.length,I)}G(n){let r=this.root;const a=this.h.get(n);if(a)return{node:a.node,nodeStartOffset:a.nodeStartOffset,remainder:n-a.nodeStartOffset};let h=0;for(;r!==L.$6B;)if(r.size_left>n)r=r.left;else if(r.size_left+r.piece.length>=n){h+=r.size_left;const i={node:r,remainder:n-r.size_left,nodeStartOffset:h};return this.h.set(i),i}else n-=r.size_left+r.piece.length,h+=r.size_left+r.piece.length,r=r.right;return null}H(n,r){let a=this.root,h=0;for(;a!==L.$6B;)if(a.left!==L.$6B&&a.lf_left>=n-1)a=a.left;else if(a.lf_left+a.piece.lineFeedCnt>n-1){const i=this.B(a,n-a.lf_left-2),p=this.B(a,n-a.lf_left-1);return h+=a.size_left,{node:a,remainder:Math.min(i+r-1,p),nodeStartOffset:h}}else if(a.lf_left+a.piece.lineFeedCnt===n-1){const i=this.B(a,n-a.lf_left-2);if(i+r-1<=a.piece.length)return{node:a,remainder:i+r-1,nodeStartOffset:h};r-=a.piece.length-i;break}else n-=a.lf_left+a.piece.lineFeedCnt,h+=a.size_left+a.piece.length,a=a.right;for(a=a.next();a!==L.$6B;){if(a.piece.lineFeedCnt>0){const i=this.B(a,0),p=this.J(a);return{node:a,remainder:Math.min(r-1,i),nodeStartOffset:p}}else if(a.piece.length>=r-1){const i=this.J(a);return{node:a,remainder:r-1,nodeStartOffset:i}}else r-=a.piece.length;a=a.next()}return null}I(n,r){if(n.piece.lineFeedCnt<1)return-1;const a=this.a[n.piece.bufferIndex],h=this.u(n.piece.bufferIndex,n.piece.start)+r;return a.buffer.charCodeAt(h)}J(n){if(!n)return 0;let r=n.size_left;for(;n!==this.root;)n.parent.right===n&&(r+=n.parent.size_left+n.parent.piece.length),n=n.parent;return r}K(){return!(this.f&&this.d===`
`)}L(n){if(typeof n=="string")return n.charCodeAt(0)===10;if(n===L.$6B||n.piece.lineFeedCnt===0)return!1;const r=n.piece,a=this.a[r.bufferIndex].lineStarts,h=r.start.line,i=a[h]+r.start.column;return h===a.length-1||a[h+1]>i+1?!1:this.a[r.bufferIndex].buffer.charCodeAt(i)===10}M(n){return typeof n=="string"?n.charCodeAt(n.length-1)===13:n===L.$6B||n.piece.lineFeedCnt===0?!1:this.I(n,n.piece.length-1)===13}N(n){if(this.K()&&this.L(n)){const r=n.prev();this.M(r)&&this.P(r,n)}}O(n){if(this.K()&&this.M(n)){const r=n.next();this.L(r)&&this.P(n,r)}}P(n,r){const a=[],h=this.a[n.piece.bufferIndex].lineStarts;let i;n.piece.end.column===0?i={line:n.piece.end.line-1,column:h[n.piece.end.line]-h[n.piece.end.line-1]-1}:i={line:n.piece.end.line,column:n.piece.end.column-1};const p=n.piece.length-1,u=n.piece.lineFeedCnt-1;n.piece=new l(n.piece.bufferIndex,n.piece.start,i,u,p),(0,L.$aC)(this,n,-1,-1),n.piece.length===0&&a.push(n);const o={line:r.piece.start.line+1,column:0},E=r.piece.length-1,w=this.t(r.piece.bufferIndex,o,r.piece.end);r.piece=new l(r.piece.bufferIndex,o,r.piece.end,w,E),(0,L.$aC)(this,r,-1,-1),r.piece.length===0&&a.push(r);const m=this.w(`\r
`);this.S(n,m[0]);for(let I=0;I<a.length;I++)(0,L.$$B)(this,a[I])}Q(n,r){if(this.K()&&this.M(n)){const a=r.next();if(this.L(a)){if(n+=`
`,a.piece.length===1)(0,L.$$B)(this,a);else{const h=a.piece,i={line:h.start.line+1,column:0},p=h.length-1,u=this.t(h.bufferIndex,i,h.end);a.piece=new l(h.bufferIndex,i,h.end,u,p),(0,L.$aC)(this,a,-1,-1)}return!0}}return!1}iterate(n,r){if(n===L.$6B)return r(L.$6B);const a=this.iterate(n.left,r);return a&&r(n)&&this.iterate(n.right,r)}R(n){if(n===L.$6B)return"";const r=this.a[n.piece.bufferIndex],a=n.piece,h=this.u(a.bufferIndex,a.start),i=this.u(a.bufferIndex,a.end);return r.buffer.substring(h,i)}getPieceContent(n){const r=this.a[n.bufferIndex],a=this.u(n.bufferIndex,n.start),h=this.u(n.bufferIndex,n.end);return r.buffer.substring(a,h)}S(n,r){const a=new L.$5B(r,1);if(a.left=L.$6B,a.right=L.$6B,a.parent=L.$6B,a.size_left=0,a.lf_left=0,this.root===L.$6B)this.root=a,a.color=0;else if(n.right===L.$6B)n.right=a,a.parent=n;else{const i=(0,L.$7B)(n.right);i.left=a,a.parent=i}return(0,L.$_B)(this,a),a}T(n,r){const a=new L.$5B(r,1);if(a.left=L.$6B,a.right=L.$6B,a.parent=L.$6B,a.size_left=0,a.lf_left=0,this.root===L.$6B)this.root=a,a.color=0;else if(n.left===L.$6B)n.left=a,a.parent=n;else{const h=(0,L.$8B)(n.left);h.right=a,a.parent=h}return(0,L.$_B)(this,a),a}U(n){let r="";return this.iterate(n,a=>(r+=this.R(a),!0)),r}}e.$mC=c}),define(Re[133],Ae([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$D9=e.$C9=void 0;class S{constructor(){this.a=new Map}removeDragOperationTransfer(L){if(L&&this.a.has(L)){const R=this.a.get(L);return this.a.delete(L),R}}addDragOperationTransfer(L,R){this.a.set(L,R)}}e.$C9=S;class F{constructor(L){this.identifier=L}}e.$D9=F}),define(Re[134],Ae([9,10]),function(fe,e){return fe.create("vs/base/common/actions",e)}),define(Re[135],Ae([1,0,5,6,134]),function(fe,e,S,F,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Vi=void 0;class L extends F.$Tc{constructor(l,v="",$="",s=!0,c){super(),this.h=this.B(new S.$5d),this.onDidChange=this.h.event,this.w=!0,this.j=l,this.m=v,this.u=$,this.w=s,this.C=c}get id(){return this.j}get label(){return this.m}set label(l){this.D(l)}D(l){this.m!==l&&(this.m=l,this.h.fire({label:l}))}get tooltip(){return this.n||""}set tooltip(l){this.F(l)}F(l){this.n!==l&&(this.n=l,this.h.fire({tooltip:l}))}get class(){return this.u}set class(l){this.G(l)}G(l){this.u!==l&&(this.u=l,this.h.fire({class:l}))}get enabled(){return this.w}set enabled(l){this.H(l)}H(l){this.w!==l&&(this.w=l,this.h.fire({enabled:l}))}get checked(){return this.z}set checked(l){this.I(l)}I(l){this.z!==l&&(this.z=l,this.h.fire({checked:l}))}async run(l,v){this.C&&await this.C(l)}}e.$Vi=L;class R extends F.$Tc{constructor(){super(...arguments),this.f=this.B(new S.$5d),this.onWillRun=this.f.event,this.m=this.B(new S.$5d),this.onDidRun=this.m.event}async run(l,v){if(!l.enabled)return;this.f.fire({action:l});let $;try{await this.u(l,v)}catch(s){$=s}this.m.fire({action:l,error:$})}async u(l,v){await l.run(v)}}e.$Wi=R;class g{constructor(){this.id=g.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...l){let v=[];for(const $ of l)$.length&&(v.length?v=[...v,new g,...$]:v=$);return v}static{this.ID="vs.actions.separator"}async run(){}}e.$Xi=g;class f{get actions(){return this.a}constructor(l,v,$,s){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=l,this.label=v,this.class=s,this.a=$}async run(){}}e.$Yi=f;class D extends L{static{this.ID="vs.actions.empty"}constructor(){super(D.ID,P.localize(0,null),void 0,!1)}}e.$Zi=D;function M(k){return{id:k.id,label:k.label,class:k.class,enabled:k.enabled??!0,checked:k.checked,run:async(...l)=>k.run(...l),tooltip:k.label}}e.$1i=M}),define(Re[136],Ae([9,10]),function(fe,e){return fe.create("vs/base/common/date",e)}),define(Re[137],Ae([1,0,136]),function(fe,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Im=e.$Hm=e.$Gm=void 0;const F=60,P=F*60,L=P*24,R=L*7,g=L*30,f=L*365;function D(l,v,$,s){typeof l!="number"&&(l=l.getTime());const c=Math.round((new Date().getTime()-l)/1e3);if(c<-30)return(0,S.localize)(0,null,D(new Date().getTime()+c*1e3,!1));if(!s&&c<30)return(0,S.localize)(1,null);let t;return c<F?(t=c,v?t===1?$?(0,S.localize)(2,null,t):(0,S.localize)(3,null,t):$?(0,S.localize)(4,null,t):(0,S.localize)(5,null,t):t===1?$?(0,S.localize)(6,null,t):(0,S.localize)(7,null,t):$?(0,S.localize)(8,null,t):(0,S.localize)(9,null,t)):c<P?(t=Math.floor(c/F),v?t===1?$?(0,S.localize)(10,null,t):(0,S.localize)(11,null,t):$?(0,S.localize)(12,null,t):(0,S.localize)(13,null,t):t===1?$?(0,S.localize)(14,null,t):(0,S.localize)(15,null,t):$?(0,S.localize)(16,null,t):(0,S.localize)(17,null,t)):c<L?(t=Math.floor(c/P),v?t===1?$?(0,S.localize)(18,null,t):(0,S.localize)(19,null,t):$?(0,S.localize)(20,null,t):(0,S.localize)(21,null,t):t===1?$?(0,S.localize)(22,null,t):(0,S.localize)(23,null,t):$?(0,S.localize)(24,null,t):(0,S.localize)(25,null,t)):c<R?(t=Math.floor(c/L),v?t===1?(0,S.localize)(26,null,t):(0,S.localize)(27,null,t):t===1?(0,S.localize)(28,null,t):(0,S.localize)(29,null,t)):c<g?(t=Math.floor(c/R),v?t===1?$?(0,S.localize)(30,null,t):(0,S.localize)(31,null,t):$?(0,S.localize)(32,null,t):(0,S.localize)(33,null,t):t===1?$?(0,S.localize)(34,null,t):(0,S.localize)(35,null,t):$?(0,S.localize)(36,null,t):(0,S.localize)(37,null,t)):c<f?(t=Math.floor(c/g),v?t===1?$?(0,S.localize)(38,null,t):(0,S.localize)(39,null,t):$?(0,S.localize)(40,null,t):(0,S.localize)(41,null,t):t===1?$?(0,S.localize)(42,null,t):(0,S.localize)(43,null,t):$?(0,S.localize)(44,null,t):(0,S.localize)(45,null,t)):(t=Math.floor(c/f),v?t===1?$?(0,S.localize)(46,null,t):(0,S.localize)(47,null,t):$?(0,S.localize)(48,null,t):(0,S.localize)(49,null,t):t===1?$?(0,S.localize)(50,null,t):(0,S.localize)(51,null,t):$?(0,S.localize)(52,null,t):(0,S.localize)(53,null,t))}e.$Gm=D;function M(l,v){const $=Math.abs(l/1e3);return $<1?v?(0,S.localize)(54,null,l):(0,S.localize)(55,null,l):$<F?v?(0,S.localize)(56,null,Math.round(l)/1e3):(0,S.localize)(57,null,Math.round(l)/1e3):$<P?v?(0,S.localize)(58,null,Math.round(l/(1e3*F))):(0,S.localize)(59,null,Math.round(l/(1e3*F))):$<L?v?(0,S.localize)(60,null,Math.round(l/(1e3*P))):(0,S.localize)(61,null,Math.round(l/(1e3*P))):(0,S.localize)(62,null,Math.round(l/(1e3*L)))}e.$Hm=M;function k(l){return l.getFullYear()+"-"+String(l.getMonth()+1).padStart(2,"0")+"-"+String(l.getDate()).padStart(2,"0")+"T"+String(l.getHours()).padStart(2,"0")+":"+String(l.getMinutes()).padStart(2,"0")+":"+String(l.getSeconds()).padStart(2,"0")+"."+(l.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$Im=k}),define(Re[138],Ae([9,10]),function(fe,e){return fe.create("vs/base/common/errorMessage",e)}),define(Re[34],Ae([1,0,18,16,138]),function(fe,e,S,F,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4i=e.$3i=e.$2i=void 0;function L(k,l){return l&&(k.stack||k.stacktrace)?P.localize(0,null,g(k),R(k.stack)||R(k.stacktrace)):g(k)}function R(k){return Array.isArray(k)?k.join(`
`):k}function g(k){return k.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${k.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof k.code=="string"&&typeof k.errno=="number"&&typeof k.syscall=="string"?P.localize(1,null,k.message):k.message||P.localize(2,null)}function f(k=null,l=!1){if(!k)return P.localize(3,null);if(Array.isArray(k)){const v=S.$Hb(k),$=f(v[0],l);return v.length>1?P.localize(4,null,$,v.length):$}if(F.$Sf(k))return k;if(k.detail){const v=k.detail;if(v.error)return L(v.error,l);if(v.exception)return L(v.exception,l)}return k.stack?L(k,l):k.message?k.message:P.localize(5,null)}e.$2i=f;function D(k){const l=k;return l instanceof Error&&Array.isArray(l.actions)}e.$3i=D;function M(k,l){let v;return typeof k=="string"?v=new Error(k):v=k,v.actions=l,v}e.$4i=M}),define(Re[139],Ae([1,0,40,19]),function(fe,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6q=e.$5q=e.$4q=e.$3q=e.$2q=e.$1q=e.$Zq=e.$Yq=e.$Xq=e.$Wq=e.$Vq=e.$Uq=e.$Tq=void 0;const P=new S.$V(()=>{const I=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:I,collatorIsNumeric:I.resolvedOptions().numeric}}),L=new S.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),R=new S.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function g(I,d,y=!1){const b=I||"",A=d||"",T=P.value.collator.compare(b,A);return P.value.collatorIsNumeric&&T===0&&b!==A?b<A?-1:1:T}e.$Tq=g;function f(I,d){const y=L.value.collator;return I=I||"",d=d||"",a(y,I,d)}e.$Uq=f;function D(I,d){const y=L.value.collator;return I=I||"",d=d||"",u(I,d)||a(y,I,d)}e.$Vq=D;function M(I,d){const y=L.value.collator;return I=I||"",d=d||"",p(I,d)||a(y,I,d)}e.$Wq=M;function k(I,d){return I=I||"",d=d||"",I===d?0:I<d?-1:1}e.$Xq=k;function l(I,d){const[y,b]=n(I),[A,T]=n(d);let G=P.value.collator.compare(b,T);if(G===0){if(P.value.collatorIsNumeric&&b!==T)return b<T?-1:1;if(G=P.value.collator.compare(y,A),P.value.collatorIsNumeric&&G===0&&y!==A)return y<A?-1:1}return G}e.$Yq=l;function v(I,d){I=I||"",d=d||"";const y=r(I),b=r(d),A=L.value.collator,T=R.value.collator;return a(T,y,b)||a(A,I,d)}e.$Zq=v;function $(I,d){I=I||"",d=d||"";const y=r(I),b=r(d),A=L.value.collator,T=R.value.collator;return a(T,y,b)||u(I,d)||a(A,I,d)}e.$1q=$;function s(I,d){I=I||"",d=d||"";const y=r(I),b=r(d),A=L.value.collator,T=R.value.collator;return a(T,y,b)||p(I,d)||a(A,I,d)}e.$2q=s;function c(I,d){I=I||"",d=d||"";const y=r(I).toLowerCase(),b=r(d).toLowerCase();return y!==b?y<b?-1:1:I!==d?I<d?-1:1:0}e.$3q=c;const t=/^(.*?)(\.([^.]*))?$/;function n(I,d=!1){const y=I?t.exec(I):[];let b=[y&&y[1]||"",y&&y[3]||""];return d&&(!b[0]&&b[1]||b[0]&&b[0].charAt(0)===".")&&(b=[b[0]+"."+b[1],""]),b}function r(I){const d=I?t.exec(I):[];return d&&d[1]&&d[1].charAt(0)!=="."&&d[3]||""}function a(I,d,y){const b=I.compare(d,y);return b!==0?b:d.length!==y.length?d.length<y.length?-1:1:0}function h(I){const d=I.charAt(0);return d.toLocaleUpperCase()!==d}function i(I){const d=I.charAt(0);return d.toLocaleLowerCase()!==d}function p(I,d){return h(I)&&i(d)?-1:i(I)&&h(d)?1:0}function u(I,d){return i(I)&&h(d)?-1:h(I)&&i(d)?1:0}function o(I,d,y=!1){return y||(I=I&&I.toLowerCase(),d=d&&d.toLowerCase()),I===d?0:I<d?-1:1}function E(I,d,y=!1){const b=I.split(F.sep),A=d.split(F.sep),T=b.length-1,G=A.length-1;let W,U;for(let C=0;;C++){if(W=T===C,U=G===C,W&&U)return g(b[C],A[C],y);if(W)return-1;if(U)return 1;const O=o(b[C],A[C],y);if(O!==0)return O}}e.$4q=E;function w(I,d,y){const b=I.toLowerCase(),A=d.toLowerCase(),T=m(I,d,y);if(T)return T;const G=b.endsWith(y),W=A.endsWith(y);if(G!==W)return G?-1:1;const U=g(b,A);return U!==0?U:b.localeCompare(A)}e.$5q=w;function m(I,d,y){const b=I.toLowerCase(),A=d.toLowerCase(),T=b.startsWith(y),G=A.startsWith(y);if(T!==G)return T?-1:1;if(T&&G){if(b.length<A.length)return-1;if(b.length>A.length)return 1}return 0}e.$6q=m}),define(Re[45],Ae([1,0,19,21,13,16]),function(fe,e,S,F,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ng=e.$mg=e.$lg=e.$kg=e.$jg=e.$ig=e.$hg=e.$gg=e.$fg=e.$eg=e.$dg=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=void 0;function R(w){return w===47||w===92}e.$$f=R;function g(w){return w.replace(/[\\/]/g,S.$gc.sep)}e.$_f=g;function f(w){return w.indexOf("/")===-1&&(w=g(w)),/^[a-zA-Z]:(\/|$)/.test(w)&&(w="/"+w),w}e.$ag=f;function D(w,m=S.$gc.sep){if(!w)return"";const I=w.length,d=w.charCodeAt(0);if(R(d)){if(R(w.charCodeAt(1))&&!R(w.charCodeAt(2))){let b=3;const A=b;for(;b<I&&!R(w.charCodeAt(b));b++);if(A!==b&&!R(w.charCodeAt(b+1))){for(b+=1;b<I;b++)if(R(w.charCodeAt(b)))return w.slice(0,b+1).replace(/[\\/]/g,m)}}return m}else if(t(d)&&w.charCodeAt(1)===58)return R(w.charCodeAt(2))?w.slice(0,2)+m:w.slice(0,2);let y=w.indexOf("://");if(y!==-1){for(y+=3;y<I;y++)if(R(w.charCodeAt(y)))return w.slice(0,y+1)}return""}e.$bg=D;function M(w){if(!F.$i||!w||w.length<5)return!1;let m=w.charCodeAt(0);if(m!==92||(m=w.charCodeAt(1),m!==92))return!1;let I=2;const d=I;for(;I<w.length&&(m=w.charCodeAt(I),m!==92);I++);return!(d===I||(m=w.charCodeAt(I+1),isNaN(m)||m===92))}e.$cg=M;const k=/[\\/:\*\?"<>\|]/g,l=/[\\/]/g,v=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function $(w,m=F.$i){const I=m?k:l;return!(!w||w.length===0||/^\s+$/.test(w)||(I.lastIndex=0,I.test(w))||m&&v.test(w)||w==="."||w===".."||m&&w[w.length-1]==="."||m&&w.length!==w.trim().length||w.length>255)}e.$dg=$;function s(w,m,I){const d=w===m;return!I||d?d:!w||!m?!1:(0,P.$jf)(w,m)}e.$eg=s;function c(w,m,I,d=S.sep){if(w===m)return!0;if(!w||!m||m.length>w.length)return!1;if(I){if(!(0,P.$kf)(w,m))return!1;if(m.length===w.length)return!0;let b=m.length;return m.charAt(m.length-1)===d&&b--,w.charAt(b)===d}return m.charAt(m.length-1)!==d&&(m+=d),w.indexOf(m)===0}e.$fg=c;function t(w){return w>=65&&w<=90||w>=97&&w<=122}e.$gg=t;function n(w,m){return F.$i&&w.endsWith(":")&&(w+=S.sep),(0,S.$ic)(w)||(w=(0,S.$jc)(m,w)),w=(0,S.$hc)(w),F.$i?(w=(0,P.$4e)(w,S.sep),w.endsWith(":")&&(w+=S.sep)):(w=(0,P.$4e)(w,S.sep),w||(w=S.sep)),w}e.$hg=n;function r(w){const m=(0,S.$hc)(w);return F.$i?w.length>3?!1:a(m)&&(w.length===2||m.charCodeAt(2)===92):m===S.$gc.sep}e.$ig=r;function a(w,m=F.$i){return m?t(w.charCodeAt(0))&&w.charCodeAt(1)===58:!1}e.$jg=a;function h(w,m=F.$i){return a(w,m)?w[0]:void 0}e.$kg=h;function i(w,m,I){return m.length>w.length?-1:w===m?0:(I&&(w=w.toLowerCase(),m=m.toLowerCase()),w.indexOf(m))}e.$lg=i;function p(w){const m=w.split(":");let I,d,y;for(const b of m){const A=Number(b);(0,L.$Wf)(A)?d===void 0?d=A:y===void 0&&(y=A):I=I?[I,b].join(":"):b}if(!I)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:I,line:d!==void 0?d:void 0,column:y!==void 0?y:d!==void 0?1:void 0}}e.$mg=p;const u="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",o="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function E(w,m,I=8){let d="";for(let b=0;b<I;b++){let A;b===0&&F.$i&&!m&&(I===3||I===4)?A=o:A=u,d+=A.charAt(Math.floor(Math.random()*A.length))}let y;return m?y=`${m}-${d}`:y=d,w?(0,S.$jc)(w,y):y}e.$ng=E}),define(Re[69],Ae([1,0,19]),function(fe,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$us=e.$ts=e.$ss=e.$rs=e.$qs=void 0,e.$qs=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const F={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},P={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function L(M){const k=(0,S.$oc)(M),l=F[k.toLowerCase()];return l!==void 0?l:R(M)}e.$rs=L;function R(M){const k=(0,S.$oc)(M);return P[k.toLowerCase()]}e.$ss=R;function g(M){for(const k in P)if(P[k]===M)return k}e.$ts=g;const f=/^(.+)\/(.+?)(;.+)?$/;function D(M,k){const l=f.exec(M);return l?`${l[1].toLowerCase()}/${l[2].toLowerCase()}${l[3]??""}`:k?void 0:M}e.$us=D}),define(Re[52],Ae([1,0,24,2]),function(fe,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nh=e.$Mh=e.$Lh=void 0;function P(f){return JSON.stringify(f,R)}e.$Lh=P;function L(f){let D=JSON.parse(f);return D=g(D),D}e.$Mh=L;function R(f,D){return D instanceof RegExp?{$mid:2,source:D.source,flags:D.flags}:D}function g(f,D=0){if(!f||D>200)return f;if(typeof f=="object"){switch(f.$mid){case 1:return F.URI.revive(f);case 2:return new RegExp(f.source,f.flags);case 17:return new Date(f.source)}if(f instanceof S.$se||f instanceof Uint8Array)return f;if(Array.isArray(f))for(let M=0;M<f.length;++M)f[M]=g(f[M],D+1);else for(const M in f)Object.hasOwnProperty.call(f,M)&&(f[M]=g(f[M],D+1))}return f}e.$Nh=g}),define(Re[12],Ae([1,0,15,21,13,2]),function(fe,e,S,F,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=e.$qg=e.$pg=e.$og=e.Schemas=void 0;var R;(function(l){l.inMemory="inmemory",l.vscode="vscode",l.internal="private",l.walkThrough="walkThrough",l.walkThroughSnippet="walkThroughSnippet",l.http="http",l.https="https",l.file="file",l.mailto="mailto",l.untitled="untitled",l.data="data",l.command="command",l.vscodeRemote="vscode-remote",l.vscodeRemoteResource="vscode-remote-resource",l.vscodeManagedRemoteResource="vscode-managed-remote-resource",l.vscodeUserData="vscode-userdata",l.vscodeCustomEditor="vscode-custom-editor",l.vscodeNotebookCell="vscode-notebook-cell",l.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",l.vscodeNotebookCellOutput="vscode-notebook-cell-output",l.vscodeInteractiveInput="vscode-interactive-input",l.vscodeSettings="vscode-settings",l.vscodeWorkspaceTrust="vscode-workspace-trust",l.vscodeTerminal="vscode-terminal",l.vscodeChatCodeBlock="vscode-chat-code-block",l.vscodeChatSesssion="vscode-chat-editor",l.webviewPanel="webview-panel",l.vscodeWebview="vscode-webview",l.extension="extension",l.vscodeFileResource="vscode-file",l.tmp="tmp",l.vsls="vsls",l.vscodeSourceControl="vscode-scm",l.codeSetting="code-setting",l.codeFeature="code-feature"})(R||(e.Schemas=R={}));function g(l,v){return L.URI.isUri(l)?(0,P.$jf)(l.scheme,v):(0,P.$kf)(l,v+":")}e.$og=g;function f(l,...v){return v.some($=>g(l,$))}e.$pg=f,e.$qg="vscode-tkn",e.$rg="tkn";class D{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${R.vscodeRemoteResource}`}setPreferredWebSchema(v){this.d=v}setDelegate(v){this.e=v}setServerRootPath(v){this.f=`${v}/${R.vscodeRemoteResource}`}set(v,$,s){this.a[v]=$,this.b[v]=s}setConnectionToken(v,$){this.c[v]=$}getPreferredWebSchema(){return this.d}rewrite(v){if(this.e)try{return this.e(v)}catch(r){return S.$1(r),v}const $=v.authority;let s=this.a[$];s&&s.indexOf(":")!==-1&&s.indexOf("[")===-1&&(s=`[${s}]`);const c=this.b[$],t=this.c[$];let n=`path=${encodeURIComponent(v.path)}`;return typeof t=="string"&&(n+=`&${e.$rg}=${encodeURIComponent(t)}`),L.URI.from({scheme:F.$o?this.d:R.vscodeRemoteResource,authority:`${s}:${c}`,path:this.f,query:n})}}e.$sg=new D,e.$tg="vs/../../extensions",e.$ug="vs/../../node_modules",e.$vg="vs/../../node_modules.asar",e.$wg="vs/../../node_modules.asar.unpacked",e.$xg="vscode-app";class M{static{this.a=e.$xg}asBrowserUri(v){const $=this.b(v,fe);return this.uriToBrowserUri($)}uriToBrowserUri(v){return v.scheme===R.vscodeRemote?e.$sg.rewrite(v):v.scheme===R.file&&(F.$m||F.$q===`${R.vscodeFileResource}://${M.a}`)?v.with({scheme:R.vscodeFileResource,authority:v.authority||M.a,query:null,fragment:null}):v}asFileUri(v){const $=this.b(v,fe);return this.uriToFileUri($)}uriToFileUri(v){return v.scheme===R.vscodeFileResource?v.with({scheme:R.file,authority:v.authority!==M.a?v.authority:null,query:null,fragment:null}):v}b(v,$){return L.URI.isUri(v)?v:L.URI.parse($.toUrl(v))}}e.$yg=new M;var k;(function(l){const v=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);l.CoopAndCoep=Object.freeze(v.get("3"));const $="vscode-coi";function s(t){let n;typeof t=="string"?n=new URL(t).searchParams:t instanceof URL?n=t.searchParams:L.URI.isUri(t)&&(n=new URL(t.toString(!0)).searchParams);const r=n?.get($);if(r)return v.get(r)}l.getHeadersFromQuery=s;function c(t,n,r){if(!globalThis.crossOriginIsolated)return;const a=n&&r?"3":r?"2":"1";t instanceof URLSearchParams?t.set($,a):t[$]=a}l.addSearchParam=c})(k||(e.COI=k={}))}),define(Re[25],Ae([1,0,45,12,19,21,13,2]),function(fe,e,S,F,P,L,R,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2g=e.DataUri=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=void 0;function f(v){return(0,g.$wc)(v,!0)}e.$Fg=f;class D{constructor($){this.a=$}compare($,s,c=!1){return $===s?0:(0,R.$cf)(this.getComparisonKey($,c),this.getComparisonKey(s,c))}isEqual($,s,c=!1){return $===s?!0:!$||!s?!1:this.getComparisonKey($,c)===this.getComparisonKey(s,c)}getComparisonKey($,s=!1){return $.with({path:this.a($)?$.path.toLowerCase():void 0,fragment:s?null:void 0}).toString()}ignorePathCasing($){return this.a($)}isEqualOrParent($,s,c=!1){if($.scheme===s.scheme){if($.scheme===F.Schemas.file)return S.$fg(f($),f(s),this.a($))&&$.query===s.query&&(c||$.fragment===s.fragment);if((0,e.$Wg)($.authority,s.authority))return S.$fg($.path,s.path,this.a($),"/")&&$.query===s.query&&(c||$.fragment===s.fragment)}return!1}joinPath($,...s){return g.URI.joinPath($,...s)}basenameOrAuthority($){return(0,e.$Og)($)||$.authority}basename($){return P.$gc.basename($.path)}extname($){return P.$gc.extname($.path)}dirname($){if($.path.length===0)return $;let s;return $.scheme===F.Schemas.file?s=g.URI.file(P.$mc(f($))).path:(s=P.$gc.dirname($.path),$.authority&&s.length&&s.charCodeAt(0)!==47&&(console.error(`dirname("${$.toString})) resulted in a relative path`),s="/")),$.with({path:s})}normalizePath($){if(!$.path.length)return $;let s;return $.scheme===F.Schemas.file?s=g.URI.file(P.$hc(f($))).path:s=P.$gc.normalize($.path),$.with({path:s})}relativePath($,s){if($.scheme!==s.scheme||!(0,e.$Wg)($.authority,s.authority))return;if($.scheme===F.Schemas.file){const n=P.$lc(f($),f(s));return L.$i?S.$_f(n):n}let c=$.path||"/";const t=s.path||"/";if(this.a($)){let n=0;for(const r=Math.min(c.length,t.length);n<r&&!(c.charCodeAt(n)!==t.charCodeAt(n)&&c.charAt(n).toLowerCase()!==t.charAt(n).toLowerCase());n++);c=t.substr(0,n)+c.substr(n)}return P.$gc.relative(c,t)}resolvePath($,s){if($.scheme===F.Schemas.file){const c=g.URI.file(P.$kc(f($),s));return $.with({authority:c.authority,path:c.path})}return s=S.$ag(s),$.with({path:P.$gc.resolve($.path,s)})}isAbsolutePath($){return!!$.path&&$.path[0]==="/"}isEqualAuthority($,s){return $===s||$!==void 0&&s!==void 0&&(0,R.$jf)($,s)}hasTrailingPathSeparator($,s=P.sep){if($.scheme===F.Schemas.file){const c=f($);return c.length>S.$bg(c).length&&c[c.length-1]===s}else{const c=$.path;return c.length>1&&c.charCodeAt(c.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test($.fsPath)}}removeTrailingPathSeparator($,s=P.sep){return(0,e.$Xg)($,s)?$.with({path:$.path.substr(0,$.path.length-1)}):$}addTrailingPathSeparator($,s=P.sep){let c=!1;if($.scheme===F.Schemas.file){const t=f($);c=t!==void 0&&t.length===S.$bg(t).length&&t[t.length-1]===s}else{s="/";const t=$.path;c=t.length===1&&t.charCodeAt(t.length-1)===47}return!c&&!(0,e.$Xg)($,s)?$.with({path:$.path+"/"}):$}}e.$Gg=D,e.$Hg=new D(()=>!1),e.$Ig=new D(v=>v.scheme===F.Schemas.file?!L.$k:!0),e.$Jg=new D(v=>!0),e.$Kg=e.$Hg.isEqual.bind(e.$Hg),e.$Lg=e.$Hg.isEqualOrParent.bind(e.$Hg),e.$Mg=e.$Hg.getComparisonKey.bind(e.$Hg),e.$Ng=e.$Hg.basenameOrAuthority.bind(e.$Hg),e.$Og=e.$Hg.basename.bind(e.$Hg),e.$Pg=e.$Hg.extname.bind(e.$Hg),e.$Qg=e.$Hg.dirname.bind(e.$Hg),e.$Rg=e.$Hg.joinPath.bind(e.$Hg),e.$Sg=e.$Hg.normalizePath.bind(e.$Hg),e.$Tg=e.$Hg.relativePath.bind(e.$Hg),e.$Ug=e.$Hg.resolvePath.bind(e.$Hg),e.$Vg=e.$Hg.isAbsolutePath.bind(e.$Hg),e.$Wg=e.$Hg.isEqualAuthority.bind(e.$Hg),e.$Xg=e.$Hg.hasTrailingPathSeparator.bind(e.$Hg),e.$Yg=e.$Hg.removeTrailingPathSeparator.bind(e.$Hg),e.$Zg=e.$Hg.addTrailingPathSeparator.bind(e.$Hg);function M(v,$){const s=[];for(let c=0;c<v.length;c++){const t=$(v[c]);v.some((n,r)=>r===c?!1:(0,e.$Lg)(t,$(n)))||s.push(v[c])}return s}e.$1g=M;var k;(function(v){v.META_DATA_LABEL="label",v.META_DATA_DESCRIPTION="description",v.META_DATA_SIZE="size",v.META_DATA_MIME="mime";function $(s){const c=new Map;s.path.substring(s.path.indexOf(";")+1,s.path.lastIndexOf(";")).split(";").forEach(r=>{const[a,h]=r.split(":");a&&h&&c.set(a,h)});const n=s.path.substring(0,s.path.indexOf(";"));return n&&c.set(v.META_DATA_MIME,n),c}v.parseMetaData=$})(k||(e.DataUri=k={}));function l(v,$,s){if($){let c=v.path;return c&&c[0]!==P.$gc.sep&&(c=P.$gc.sep+c),v.with({scheme:s,authority:$,path:c})}return v.with({scheme:s})}e.$2g=l}),define(Re[11],Ae([1,0,22,15,5,6,25,21,126,40]),function(fe,e,S,F,P,L,R,g,f,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hh=e.$Gh=e.$Fh=e.$Eh=e.$Dh=e.$Ch=e.Promises=e.$Bh=e.$Ah=e.$zh=e.$yh=e.$xh=e.$wh=e.$vh=e.$uh=e.$th=e.$sh=e.$rh=e.$qh=e.$ph=e.$oh=e.$nh=e.$mh=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=void 0;function M(ge){return!!ge&&typeof ge.then=="function"}e.$3g=M;function k(ge){const J=new S.$ce,x=ge(J.token),le=new Promise((de,Pe)=>{const me=J.token.onCancellationRequested(()=>{me.dispose(),Pe(new F.$5)});Promise.resolve(x).then(Ie=>{me.dispose(),J.dispose(),de(Ie)},Ie=>{me.dispose(),J.dispose(),Pe(Ie)})});return new class{cancel(){J.cancel(),J.dispose()}then(de,Pe){return le.then(de,Pe)}catch(de){return this.then(void 0,de)}finally(de){return le.finally(de)}}}e.$4g=k;function l(ge,J,x){return new Promise((le,de)=>{const Pe=J.onCancellationRequested(()=>{Pe.dispose(),le(x)});ge.then(le,de).finally(()=>Pe.dispose())})}e.$5g=l;function v(ge,J){return new Promise((x,le)=>{const de=J.onCancellationRequested(()=>{de.dispose(),le(new F.$5)});ge.then(x,le).finally(()=>de.dispose())})}e.$6g=v;async function $(ge){let J=-1;const x=ge.map((le,de)=>le.then(Pe=>(J=de,Pe)));try{return await Promise.race(x)}finally{ge.forEach((le,de)=>{de!==J&&le.cancel()})}}e.$7g=$;function s(ge,J,x){let le;const de=setTimeout(()=>{le?.(void 0),x?.()},J);return Promise.race([ge.finally(()=>clearTimeout(de)),new Promise(Pe=>le=Pe)])}e.$8g=s;function c(ge){return new Promise((J,x)=>{const le=ge();M(le)?le.then(J,x):J(le)})}e.$9g=c;function t(){let ge,J;return{promise:new Promise((le,de)=>{ge=le,J=de}),resolve:ge,reject:J}}e.$0g=t;class n{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(J){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=J,!this.b){const x=()=>{if(this.b=null,this.f)return;const le=this.queue(this.d);return this.d=null,le};this.b=new Promise(le=>{this.a.then(x,x).then(le)})}return new Promise((x,le)=>{this.b.then(x,le)})}return this.a=J(),new Promise((x,le)=>{this.a.then(de=>{this.a=null,x(de)},de=>{this.a=null,le(de)})})}dispose(){this.f=!0}}e.$$g=n;class r{constructor(){this.a=Promise.resolve(null)}queue(J){return this.a=this.a.then(()=>J(),()=>J())}}e.$_g=r;class a{constructor(){this.a=new Map}queue(J,x){const de=(this.a.get(J)??Promise.resolve()).catch(()=>{}).then(x).finally(()=>{this.a.get(J)===de&&this.a.delete(J)});return this.a.set(J,de),de}}e.$ah=a;const h=(ge,J)=>{let x=!0;const le=setTimeout(()=>{x=!1,J()},ge);return{isTriggered:()=>x,dispose:()=>{clearTimeout(le),x=!1}}},i=ge=>{let J=!0;return queueMicrotask(()=>{J&&(J=!1,ge())}),{isTriggered:()=>J,dispose:()=>{J=!1}}};class p{constructor(J){this.defaultDelay=J,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(J,x=this.defaultDelay){this.g=J,this.h(),this.b||(this.b=new Promise((de,Pe)=>{this.d=de,this.f=Pe}).then(()=>{if(this.b=null,this.d=null,this.g){const de=this.g;return this.g=null,de()}}));const le=()=>{this.a=null,this.d?.(null)};return this.a=x===f.$2d?i(le):h(x,le),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new F.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$bh=p;class u{constructor(J){this.a=new p(J),this.b=new n}trigger(J,x){return this.a.trigger(()=>this.b.queue(J),x)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$ch=u;class o{constructor(){this.a=!1,this.b=new Promise((J,x)=>{this.d=J})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$dh=o;class E extends o{constructor(J){super(),this.f=setTimeout(()=>this.open(),J)}open(){clearTimeout(this.f),super.open()}}e.$eh=E;function w(ge,J){return J?new Promise((x,le)=>{const de=setTimeout(()=>{Pe.dispose(),x()},ge),Pe=J.onCancellationRequested(()=>{clearTimeout(de),Pe.dispose(),le(new F.$5)})}):k(x=>w(ge,x))}e.$fh=w;function m(ge,J=0,x){const le=setTimeout(()=>{ge(),x&&de.dispose()},J),de=(0,L.$Rc)(()=>{clearTimeout(le),x?.deleteAndLeak(de)});return x?.add(de),de}e.$gh=m;function I(ge){const J=[];let x=0;const le=ge.length;function de(){return x<le?ge[x++]():null}function Pe(me){me!=null&&J.push(me);const Ie=de();return Ie?Ie.then(Pe):Promise.resolve(J)}return Promise.resolve(null).then(Pe)}e.$hh=I;function d(ge,J=le=>!!le,x=null){let le=0;const de=ge.length,Pe=()=>{if(le>=de)return Promise.resolve(x);const me=ge[le++];return Promise.resolve(me()).then(Me=>J(Me)?Promise.resolve(Me):Pe())};return Pe()}e.$ih=d;function y(ge,J=le=>!!le,x=null){if(ge.length===0)return Promise.resolve(x);let le=ge.length;const de=()=>{le=-1;for(const Pe of ge)Pe.cancel?.()};return new Promise((Pe,me)=>{for(const Ie of ge)Ie.then(Me=>{--le>=0&&J(Me)?(de(),Pe(Me)):le===0&&Pe(x)}).catch(Me=>{--le>=0&&(de(),me(Me))})})}e.$jh=y;class b{constructor(J){this.a=0,this.b=!1,this.f=J,this.g=[],this.d=0,this.h=new P.$5d}whenIdle(){return this.size>0?P.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(J){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((x,le)=>{this.g.push({factory:J,c:x,e:le}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const J=this.g.shift();this.d++;const x=J.factory();x.then(J.c,J.e),x.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$kh=b;class A extends b{constructor(){super(1)}}e.$lh=A;class T{constructor(){this.a=new he,this.b=0}queue(J){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,J())):this.a.run(this.b++,J())}}e.$mh=T;class G{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const J=new $e;return this.b.add(J),J.p}g(){for(const[,J]of this.a)if(J.size>0)return!1;return!0}queueSize(J,x=R.$Hg){const le=x.getComparisonKey(J);return this.a.get(le)?.size??0}queueFor(J,x,le=R.$Hg){const de=le.getComparisonKey(J);let Pe=this.a.get(de);if(!Pe){Pe=new A;const me=this.f++,Ie=P.Event.once(Pe.onDrained)(()=>{Pe?.dispose(),this.a.delete(de),this.h(),this.d?.deleteAndDispose(me),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new L.$3c),this.d.set(me,Ie),this.a.set(de,Pe)}return Pe.queue(x)}h(){this.g()&&this.j()}j(){for(const J of this.b)J.complete();this.b.clear()}dispose(){for(const[,J]of this.a)J.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$nh=G;class W{constructor(J,x){this.a=-1,typeof J=="function"&&typeof x=="number"&&this.setIfNotSet(J,x)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(J,x){this.cancel(),this.a=setTimeout(()=>{this.a=-1,J()},x)}setIfNotSet(J,x){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,J()},x))}}e.$oh=W;class U{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(J,x,le=globalThis){this.cancel();const de=le.setInterval(()=>{J()},x);this.d=(0,L.$Rc)(()=>{le.clearInterval(de),this.d=void 0})}dispose(){this.cancel()}}e.$ph=U;class C{constructor(J,x){this.b=-1,this.a=J,this.d=x,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(J=this.d){this.cancel(),this.b=setTimeout(this.f,J)}get delay(){return this.d}set delay(J){this.d=J}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$qh=C;class O{constructor(J,x){x%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${x}ms is not a multiple of 1000ms.`),this.a=J,this.b=x,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(J=this.b){J%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${J}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(J/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$rh=O;class V extends C{constructor(J,x){super(J,x),this.j=[]}work(J){this.j.push(J),this.isScheduled()||this.schedule()}h(){const J=this.j;this.j=[],this.a?.(J)}dispose(){this.j=[],super.dispose()}}e.$sh=V;class re extends L.$Tc{constructor(J,x){super(),this.g=J,this.h=x,this.a=[],this.b=this.B(new L.$Uc),this.f=!1}get pending(){return this.a.length}work(J){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+J.length>this.g.maxBufferedWork)return!1}else if(this.pending+J.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const x of J)this.a.push(x);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new C(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$th=re,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$vh=(ge,J)=>{(0,g.$B)(()=>{if(x)return;const le=Date.now()+15;J(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,le-Date.now())}}))});let x=!1;return{dispose(){x||(x=!0)}}}:e.$vh=(ge,J,x)=>{const le=ge.requestIdleCallback(J,typeof x=="number"?{timeout:x}:void 0);let de=!1;return{dispose(){de||(de=!0,ge.cancelIdleCallback(le))}}},e.$uh=ge=>(0,e.$vh)(globalThis,ge)}();class ue{constructor(J,x){this.g=!1,this.d=()=>{try{this.j=x()}catch(le){this.l=le}finally{this.g=!0}},this.f=(0,e.$vh)(J,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$wh=ue;class ye extends ue{constructor(J){super(globalThis,J)}}e.$xh=ye;async function De(ge,J,x){let le;for(let de=0;de<x;de++)try{return await ge()}catch(Pe){le=Pe,await w(J)}throw le}e.$yh=De;class he{isRunning(J){return typeof J=="number"?this.a?.taskId===J:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(J,x,le){return this.a={taskId:J,cancel:()=>le?.(),promise:x},x.then(()=>this.d(J),()=>this.d(J)),x}d(J){this.a&&J===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const J=this.b;this.b=void 0,J.run().then(J.promiseResolve,J.promiseReject)}}queue(J){if(this.b)this.b.run=J;else{const{promise:x,resolve:le,reject:de}=t();this.b={run:J,promise:x,promiseResolve:le,promiseReject:de}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$zh=he;class ve{constructor(J,x=()=>Date.now()){this.d=J,this.f=x,this.a=0,this.b=0}increment(){const J=this.f();return J-this.a>this.d&&(this.a=J,this.b=0),this.b++,this.b}}e.$Ah=ve;var se;(function(ge){ge[ge.Resolved=0]="Resolved",ge[ge.Rejected=1]="Rejected"})(se||(se={}));class $e{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((J,x)=>{this.a=J,this.b=x})}complete(J){return new Promise(x=>{this.a(J),this.d={outcome:0,value:J},x()})}error(J){return new Promise(x=>{this.b(J),this.d={outcome:1,value:J},x()})}cancel(){return this.error(new F.$5)}}e.$Bh=$e;var ee;(function(ge){async function J(le){let de;const Pe=await Promise.all(le.map(me=>me.then(Ie=>Ie,Ie=>{de||(de=Ie)})));if(typeof de<"u")throw de;return Pe}ge.settled=J;function x(le){return new Promise(async(de,Pe)=>{try{await le(de,Pe)}catch(me){Pe(me)}})}ge.withAsyncBody=x})(ee||(e.Promises=ee={}));class Q{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(J){this.a=void 0,this.b=void 0,this.d=!1,this.promise=J.then(x=>(this.a=x,this.d=!0,x),x=>{throw this.b=x,this.d=!0,x})}requireValue(){if(!this.d)throw new F.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$Ch=Q;class q{constructor(J){this.b=J,this.a=new D.$V(()=>new Q(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$Dh=q;var ne;(function(ge){ge[ge.Initial=0]="Initial",ge[ge.DoneOK=1]="DoneOK",ge[ge.DoneError=2]="DoneError"})(ne||(ne={}));class Se{static fromArray(J){return new Se(x=>{x.emitMany(J)})}static fromPromise(J){return new Se(async x=>{x.emitMany(await J)})}static fromPromises(J){return new Se(async x=>{await Promise.all(J.map(async le=>x.emitOne(await le)))})}static merge(J){return new Se(async x=>{await Promise.all(J.map(async le=>{for await(const de of le)x.emitOne(de)}))})}static{this.EMPTY=Se.fromArray([])}constructor(J){this.a=0,this.b=[],this.d=null,this.f=new P.$5d,queueMicrotask(async()=>{const x={emitOne:le=>this.g(le),emitMany:le=>this.h(le),reject:le=>this.k(le)};try{await Promise.resolve(J(x)),this.j()}catch(le){this.k(le)}finally{x.emitOne=void 0,x.emitMany=void 0,x.reject=void 0}})}[Symbol.asyncIterator](){let J=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(J<this.b.length)return{done:!1,value:this.b[J++]};if(this.a===1)return{done:!0,value:void 0};await P.Event.toPromise(this.f.event)}while(!0)}}}static map(J,x){return new Se(async le=>{for await(const de of J)le.emitOne(x(de))})}map(J){return Se.map(this,J)}static filter(J,x){return new Se(async le=>{for await(const de of J)x(de)&&le.emitOne(de)})}filter(J){return Se.filter(this,J)}static coalesce(J){return Se.filter(J,x=>!!x)}coalesce(){return Se.coalesce(this)}static async toPromise(J){const x=[];for await(const le of J)x.push(le);return x}toPromise(){return Se.toPromise(this)}g(J){this.a===0&&(this.b.push(J),this.f.fire())}h(J){this.a===0&&(this.b=this.b.concat(J),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(J){this.a===0&&(this.a=2,this.d=J,this.f.fire())}}e.$Eh=Se;class Te extends Se{constructor(J,x){super(x),this.l=J}cancel(){this.l.cancel()}}e.$Fh=Te;function Ce(ge){const J=new S.$ce,x=ge(J.token);return new Te(J,async le=>{const de=J.token.onCancellationRequested(()=>{de.dispose(),J.dispose(),le.reject(new F.$5)});try{for await(const Pe of x){if(J.token.isCancellationRequested)return;le.emitOne(Pe)}de.dispose(),J.dispose()}catch(Pe){de.dispose(),J.dispose(),le.reject(Pe)}})}e.$Gh=Ce;class we{constructor(){this.a=new $e,this.b=new Se(le=>{if(J){le.reject(J);return}return x&&le.emitMany(x),this.d=de=>le.reject(de),this.f=de=>le.emitOne(de),this.a.p});let J,x;this.f=le=>{x||(x=[]),x.push(le)},this.d=le=>{J||(J=le)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(J){this.d(J),this.a.complete()}emitOne(J){this.f(J)}}e.$Hh=we}),define(Re[35],Ae([1,0,18,11,45,28,19,21,13]),function(fe,e,S,F,P,L,R,g,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2j=e.$1j=e.$Zj=e.$Yj=e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.$Tj=e.$Sj=void 0;function D(){return Object.create(null)}e.$Sj=D,e.$Tj="**",e.$Uj="/";const M="[/\\\\]",k="[^/\\\\]",l=/\//g;function v(ue,ye){switch(ue){case 0:return"";case 1:return`${k}*?`;default:return`(?:${M}|${k}+${M}${ye?`|${M}${k}+`:""})*?`}}function $(ue,ye){if(!ue)return[];const De=[];let he=!1,ve=!1,se="";for(const $e of ue){switch($e){case ye:if(!he&&!ve){De.push(se),se="";continue}break;case"{":he=!0;break;case"}":he=!1;break;case"[":ve=!0;break;case"]":ve=!1;break}se+=$e}return se&&De.push(se),De}e.$Vj=$;function s(ue){if(!ue)return"";let ye="";const De=$(ue,e.$Uj);if(De.every(he=>he===e.$Tj))ye=".*";else{let he=!1;De.forEach((ve,se)=>{if(ve===e.$Tj){if(he)return;ye+=v(2,se===De.length-1)}else{let $e=!1,ee="",Q=!1,q="";for(const ne of ve){if(ne!=="}"&&$e){ee+=ne;continue}if(Q&&(ne!=="]"||!q)){let Se;ne==="-"?Se=ne:(ne==="^"||ne==="!")&&!q?Se="^":ne===e.$Uj?Se="":Se=(0,f.$Xe)(ne),q+=Se;continue}switch(ne){case"{":$e=!0;continue;case"[":Q=!0;continue;case"}":{const Te=`(?:${$(ee,",").map(Ce=>s(Ce)).join("|")})`;ye+=Te,$e=!1,ee="";break}case"]":{ye+="["+q+"]",Q=!1,q="";break}case"?":ye+=k;continue;case"*":ye+=v(1);continue;default:ye+=(0,f.$Xe)(ne)}}se<De.length-1&&(De[se+1]!==e.$Tj||se+2<De.length)&&(ye+=M)}he=ve===e.$Tj})}return ye}const c=/^\*\*\/\*\.[\w\.-]+$/,t=/^\*\*\/([\w\.-]+)\/?$/,n=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,r=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,a=/^\*\*((\/[\w\.-]+)+)\/?$/,h=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new L.$Dc(1e4),p=function(){return!1},u=function(){return null};function o(ue,ye){if(!ue)return u;let De;typeof ue!="string"?De=ue.pattern:De=ue,De=De.trim();const he=`${De}_${!!ye.trimForExclusions}`;let ve=i.get(he);if(ve)return E(ve,ue);let se;return c.test(De)?ve=m(De.substr(4),De):(se=t.exec(w(De,ye)))?ve=I(se[1],De):(ye.trimForExclusions?r:n).test(De)?ve=d(De,ye):(se=a.exec(w(De,ye)))?ve=y(se[1].substr(1),De,!0):(se=h.exec(w(De,ye)))?ve=y(se[1],De,!1):ve=b(De),i.set(he,ve),E(ve,ue)}function E(ue,ye){if(typeof ye=="string")return ue;const De=function(he,ve){return(0,P.$fg)(he,ye.base,!g.$k)?ue((0,f.$3e)(he.substr(ye.base.length),R.sep),ve):null};return De.allBasenames=ue.allBasenames,De.allPaths=ue.allPaths,De.basenames=ue.basenames,De.patterns=ue.patterns,De}function w(ue,ye){return ye.trimForExclusions&&ue.endsWith("/**")?ue.substr(0,ue.length-2):ue}function m(ue,ye){return function(De,he){return typeof De=="string"&&De.endsWith(ue)?ye:null}}function I(ue,ye){const De=`/${ue}`,he=`\\${ue}`,ve=function($e,ee){return typeof $e!="string"?null:ee?ee===ue?ye:null:$e===ue||$e.endsWith(De)||$e.endsWith(he)?ye:null},se=[ue];return ve.basenames=se,ve.patterns=[ye],ve.allBasenames=se,ve}function d(ue,ye){const De=V(ue.slice(1,-1).split(",").map(ee=>o(ee,ye)).filter(ee=>ee!==u),ue),he=De.length;if(!he)return u;if(he===1)return De[0];const ve=function(ee,Q){for(let q=0,ne=De.length;q<ne;q++)if(De[q](ee,Q))return ue;return null},se=De.find(ee=>!!ee.allBasenames);se&&(ve.allBasenames=se.allBasenames);const $e=De.reduce((ee,Q)=>Q.allPaths?ee.concat(Q.allPaths):ee,[]);return $e.length&&(ve.allPaths=$e),ve}function y(ue,ye,De){const he=R.sep===R.$gc.sep,ve=he?ue:ue.replace(l,R.sep),se=R.sep+ve,$e=R.$gc.sep+ue;let ee;return De?ee=function(Q,q){return typeof Q=="string"&&(Q===ve||Q.endsWith(se)||!he&&(Q===ue||Q.endsWith($e)))?ye:null}:ee=function(Q,q){return typeof Q=="string"&&(Q===ve||!he&&Q===ue)?ye:null},ee.allPaths=[(De?"*/":"./")+ue],ee}function b(ue){try{const ye=new RegExp(`^${s(ue)}$`);return function(De){return ye.lastIndex=0,typeof De=="string"&&ye.test(De)?ue:null}}catch{return u}}function A(ue,ye,De){return!ue||typeof ye!="string"?!1:T(ue)(ye,void 0,De)}e.$Wj=A;function T(ue,ye={}){if(!ue)return p;if(typeof ue=="string"||G(ue)){const De=o(ue,ye);if(De===u)return p;const he=function(ve,se){return!!De(ve,se)};return De.allBasenames&&(he.allBasenames=De.allBasenames),De.allPaths&&(he.allPaths=De.allPaths),he}return C(ue,ye)}e.$Xj=T;function G(ue){const ye=ue;return ye?typeof ye.base=="string"&&typeof ye.pattern=="string":!1}e.$Yj=G;function W(ue){return ue.allBasenames||[]}e.$Zj=W;function U(ue){return ue.allPaths||[]}e.$1j=U;function C(ue,ye){const De=V(Object.getOwnPropertyNames(ue).map(ee=>O(ee,ue[ee],ye)).filter(ee=>ee!==u)),he=De.length;if(!he)return u;if(!De.some(ee=>!!ee.requiresSiblings)){if(he===1)return De[0];const ee=function(ne,Se){let Te;for(let Ce=0,we=De.length;Ce<we;Ce++){const ge=De[Ce](ne,Se);if(typeof ge=="string")return ge;(0,F.$3g)(ge)&&(Te||(Te=[]),Te.push(ge))}return Te?(async()=>{for(const Ce of Te){const we=await Ce;if(typeof we=="string")return we}return null})():null},Q=De.find(ne=>!!ne.allBasenames);Q&&(ee.allBasenames=Q.allBasenames);const q=De.reduce((ne,Se)=>Se.allPaths?ne.concat(Se.allPaths):ne,[]);return q.length&&(ee.allPaths=q),ee}const ve=function(ee,Q,q){let ne,Se;for(let Te=0,Ce=De.length;Te<Ce;Te++){const we=De[Te];we.requiresSiblings&&q&&(Q||(Q=(0,R.$nc)(ee)),ne||(ne=Q.substr(0,Q.length-(0,R.$oc)(ee).length)));const ge=we(ee,Q,ne,q);if(typeof ge=="string")return ge;(0,F.$3g)(ge)&&(Se||(Se=[]),Se.push(ge))}return Se?(async()=>{for(const Te of Se){const Ce=await Te;if(typeof Ce=="string")return Ce}return null})():null},se=De.find(ee=>!!ee.allBasenames);se&&(ve.allBasenames=se.allBasenames);const $e=De.reduce((ee,Q)=>Q.allPaths?ee.concat(Q.allPaths):ee,[]);return $e.length&&(ve.allPaths=$e),ve}function O(ue,ye,De){if(ye===!1)return u;const he=o(ue,De);if(he===u)return u;if(typeof ye=="boolean")return he;if(ye){const ve=ye.when;if(typeof ve=="string"){const se=($e,ee,Q,q)=>{if(!q||!he($e,ee))return null;const ne=ve.replace("$(basename)",()=>Q),Se=q(ne);return(0,F.$3g)(Se)?Se.then(Te=>Te?ue:null):Se?ue:null};return se.requiresSiblings=!0,se}}return he}function V(ue,ye){const De=ue.filter(ee=>!!ee.basenames);if(De.length<2)return ue;const he=De.reduce((ee,Q)=>{const q=Q.basenames;return q?ee.concat(q):ee},[]);let ve;if(ye){ve=[];for(let ee=0,Q=he.length;ee<Q;ee++)ve.push(ye)}else ve=De.reduce((ee,Q)=>{const q=Q.patterns;return q?ee.concat(q):ee},[]);const se=function(ee,Q){if(typeof ee!="string")return null;if(!Q){let ne;for(ne=ee.length;ne>0;ne--){const Se=ee.charCodeAt(ne-1);if(Se===47||Se===92)break}Q=ee.substr(ne)}const q=he.indexOf(Q);return q!==-1?ve[q]:null};se.basenames=he,se.patterns=ve,se.allBasenames=he;const $e=ue.filter(ee=>!ee.basenames);return $e.push(se),$e}function re(ue,ye){return(0,S.$ub)(ue,ye,(De,he)=>typeof De=="string"&&typeof he=="string"?De===he:typeof De!="string"&&typeof he!="string"?De.base===he.base&&De.pattern===he.pattern:!1)}e.$2j=re}),define(Re[53],Ae([1,0,15,127,25,13,2]),function(fe,e,S,F,P,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ak=e.$zk=e.$yk=e.$xk=e.$wk=e.$vk=e.$uk=e.$tk=e.$sk=e.MarkdownStringTextNewlineStyle=void 0;var g;(function(t){t[t.Paragraph=0]="Paragraph",t[t.Break=1]="Break"})(g||(e.MarkdownStringTextNewlineStyle=g={}));class f{constructor(n="",r=!1){if(this.value=n,typeof this.value!="string")throw(0,S.$7)("value");typeof r=="boolean"?(this.isTrusted=r,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=r.isTrusted??void 0,this.supportThemeIcons=r.supportThemeIcons??!1,this.supportHtml=r.supportHtml??!1)}appendText(n,r=0){return this.value+=l(this.supportThemeIcons?(0,F.$mk)(n):n).replace(/([ \t]+)/g,(a,h)=>"&nbsp;".repeat(h.length)).replace(/\>/gm,"\\>").replace(/\n/g,r===1?`\\
`:`

`),this}appendMarkdown(n){return this.value+=n,this}appendCodeblock(n,r){return this.value+=`
${v(r,n)}
`,this}appendLink(n,r,a){return this.value+="[",this.value+=this.c(r,"]"),this.value+="](",this.value+=this.c(String(n),")"),a&&(this.value+=` "${this.c(this.c(a,'"'),")")}"`),this.value+=")",this}c(n,r){const a=new RegExp((0,L.$Xe)(r),"g");return n.replace(a,(h,i)=>n.charAt(i-1)!=="\\"?`\\${h}`:h)}}e.$sk=f;function D(t){return M(t)?!t.value:Array.isArray(t)?t.every(D):!0}e.$tk=D;function M(t){return t instanceof f?!0:t&&typeof t=="object"?typeof t.value=="string"&&(typeof t.isTrusted=="boolean"||typeof t.isTrusted=="object"||t.isTrusted===void 0)&&(typeof t.supportThemeIcons=="boolean"||t.supportThemeIcons===void 0):!1}e.$uk=M;function k(t,n){return t===n?!0:!t||!n?!1:t.value===n.value&&t.isTrusted===n.isTrusted&&t.supportThemeIcons===n.supportThemeIcons&&t.supportHtml===n.supportHtml&&(t.baseUri===n.baseUri||!!t.baseUri&&!!n.baseUri&&(0,P.$Kg)(R.URI.from(t.baseUri),R.URI.from(n.baseUri)))}e.$vk=k;function l(t){return t.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.$wk=l;function v(t,n){const r=t.match(/^`+/gm)?.reduce((h,i)=>h.length>i.length?h:i).length??0,a=r>=3?r+1:3;return[`${"`".repeat(a)}${n}`,t,`${"`".repeat(a)}`].join(`
`)}e.$xk=v;function $(t){return t.replace(/"/g,"&quot;")}e.$yk=$;function s(t){return t&&t.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.$zk=s;function c(t){const n=[],r=t.split("|").map(h=>h.trim());t=r[0];const a=r[1];if(a){const h=/height=(\d+)/.exec(a),i=/width=(\d+)/.exec(a),p=h?h[1]:"",u=i?i[1]:"",o=isFinite(parseInt(u)),E=isFinite(parseInt(p));o&&n.push(`width="${u}"`),E&&n.push(`height="${p}"`)}return{href:t,dimensions:n}}e.$Ak=c}),define(Re[94],Ae([1,0,18,45,19,21,25,13]),function(fe,e,S,F,P,L,R,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ew=e.$dw=e.$cw=e.$bw=e.$aw=e.$_v=e.$$v=e.$0v=e.$9v=e.$8v=void 0;function f(o,E){const{os:w,tildify:m,relative:I}=E;if(I){const b=D(o,I,w);if(typeof b=="string")return b}let d=o.fsPath;if(w===1&&!L.$i?d=d.replace(/\//g,"\\"):w!==1&&L.$i&&(d=d.replace(/\\/g,"/")),w!==1&&m?.userHome){const b=m.userHome.fsPath;let A;o.scheme!==m.userHome.scheme&&o.path[0]===P.$gc.sep&&o.path[1]!==P.$gc.sep?A=m.userHome.with({path:o.path}).fsPath:A=d,d=l(A,b,w)}return(w===1?P.$fc:P.$gc).normalize(M(d,w===1))}e.$8v=f;function D(o,E,w){const m=w===1?P.$fc:P.$gc,I=w===3?R.$Hg:R.$Jg,d=E.getWorkspace(),y=(0,S.$Ob)(d.folders);if(!y)return;o.scheme!==y.uri.scheme&&o.path[0]===P.$gc.sep&&o.path[1]!==P.$gc.sep&&(o=y.uri.with({path:o.path}));const b=E.getWorkspaceFolder(o);if(!b)return;let A;if(I.isEqual(b.uri,o)?A="":A=I.relativePath(b.uri,o)??"",A&&(A=m.normalize(A)),d.folders.length>1&&!E.noPrefix){const T=b.name?b.name:I.basenameOrAuthority(b.uri);A=A?`${T} \u2022 ${A}`:T}return A}function M(o,E=L.$i){return(0,F.$jg)(o,E)?o.charAt(0).toUpperCase()+o.slice(1):o}e.$9v=M;let k=Object.create(null);function l(o,E,w=L.OS){if(w===1||!o||!E)return o;let m=k.original===E?k.normalized:void 0;m||(m=E,L.$i&&(m=(0,F.$_f)(m)),m=`${(0,g.$4e)(m,P.$gc.sep)}${P.$gc.sep}`,k={original:E,normalized:m});let I=o;return L.$i&&(I=(0,F.$_f)(I)),(w===3?I.startsWith(m):(0,g.$kf)(I,m))?`~/${I.substr(m.length)}`:o}e.$0v=l;function v(o,E){return o.replace(/^~($|\/|\\)/,`${E}$1`)}e.$$v=v;const $="\u2026",s="\\\\",c="~";function t(o,E=P.sep){const w=new Array(o.length);let m=!1;for(let I=0;I<o.length;I++){const d=o[I];if(d===""){w[I]=`.${E}`;continue}if(!d){w[I]=d;continue}m=!0;let y="",b=d;b.indexOf(s)===0?(y=b.substr(0,b.indexOf(s)+s.length),b=b.substr(b.indexOf(s)+s.length)):b.indexOf(E)===0?(y=b.substr(0,b.indexOf(E)+E.length),b=b.substr(b.indexOf(E)+E.length)):b.indexOf(c)===0&&(y=b.substr(0,b.indexOf(c)+c.length),b=b.substr(b.indexOf(c)+c.length));const A=b.split(E);for(let T=1;m&&T<=A.length;T++)for(let G=A.length-T;m&&G>=0;G--){m=!1;let W=A.slice(G,G+T).join(E);for(let U=0;!m&&U<o.length;U++)if(U!==I&&o[U]&&o[U].indexOf(W)>-1){const C=G+T===A.length,O=G>0&&o[U].indexOf(E)>-1?E+W:W,V=o[U].endsWith(O);m=!C||V}if(!m){let U="";(A[0].endsWith(":")||y!=="")&&(G===1&&(G=0,T++,W=A[0]+E+W),G>0&&(U=A[0]+E),U=y+U),G>0&&(U=U+$+E),U=U+W,G+T<A.length&&(U=U+E+$),w[I]=U}}m&&(w[I]=d)}return w}e.$_v=t;var n;(function(o){o[o.TEXT=0]="TEXT",o[o.VARIABLE=1]="VARIABLE",o[o.SEPARATOR=2]="SEPARATOR"})(n||(n={}));function r(o,E=Object.create(null)){const w=[];let m=!1,I="";for(const d of o)if(d==="$"||m&&d==="{")I&&w.push({value:I,type:n.TEXT}),I="",m=!0;else if(d==="}"&&m){const y=E[I];if(typeof y=="string")y.length&&w.push({value:y,type:n.VARIABLE});else if(y){const b=w[w.length-1];(!b||b.type!==n.SEPARATOR)&&w.push({value:y.label,type:n.SEPARATOR})}I="",m=!1}else I+=d;return I&&!m&&w.push({value:I,type:n.TEXT}),w.filter((d,y)=>{if(d.type===n.SEPARATOR){const b=w[y-1],A=w[y+1];return[b,A].every(T=>T&&(T.type===n.VARIABLE||T.type===n.TEXT)&&T.value.length>0)}return!0}).map(d=>d.value).join("")}e.$aw=r;function a(o,E){return L.$j||E?o.replace(/\(&&\w\)|&&/g,"").replace(/&/g,L.$j?"&":"&&"):o.replace(/&&|&/g,w=>w==="&"?"&&":"&")}e.$bw=a;function h(o,E){return L.$j||E?o.replace(/\(&&\w\)|&&/g,""):L.$i?o.replace(/&&|&/g,w=>w==="&"?"&&":"&"):o.replace(/&&/g,"_")}e.$cw=h;function i(o){return o.replace(/&/g,"&&")}e.$dw=i;function p(o){if(o.endsWith("]")){const E=o.lastIndexOf(" [",o.length-2);if(E!==-1){const w=u(o.substring(0,E)),m=o.substring(E);return{name:w.name+m,parentPath:w.parentPath}}}return u(o)}e.$ew=p;function u(o){const E=o.indexOf("/")!==-1?P.$gc:P.$fc,w=E.basename(o),m=E.dirname(o);return w.length?{name:w,parentPath:m}:{name:m,parentPath:""}}}),define(Re[140],Ae([1,0,24,2]),function(fe,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hn=e.$gn=e.$fn=e.$en=e.$dn=void 0;function P(k){return k.toJSON()}class L{constructor(l){this.a=l}transformIncoming(l){const v=this.a.transformIncoming(l);return v===l?l:P(F.URI.from(v))}transformOutgoing(l){const v=this.a.transformOutgoing(l);return v===l?l:P(F.URI.from(v))}transformOutgoingURI(l){const v=this.a.transformOutgoing(l);return v===l?l:F.URI.from(v)}transformOutgoingScheme(l){return this.a.transformOutgoingScheme(l)}}e.$dn=L,e.$en=new class{transformIncoming(k){return k}transformOutgoing(k){return k}transformOutgoingURI(k){return k}transformOutgoingScheme(k){return k}};function R(k,l,v){if(!k||v>200)return null;if(typeof k=="object"){if(k instanceof F.URI)return l.transformOutgoing(k);for(const $ in k)if(Object.hasOwnProperty.call(k,$)){const s=R(k[$],l,v+1);s!==null&&(k[$]=s)}}return null}function g(k,l){const v=R(k,l,0);return v===null?k:v}e.$fn=g;function f(k,l,v,$){if(!k||$>200)return null;if(typeof k=="object"){if(k.$mid===1)return v?F.URI.revive(l.transformIncoming(k)):l.transformIncoming(k);if(k instanceof S.$se)return null;for(const s in k)if(Object.hasOwnProperty.call(k,s)){const c=f(k[s],l,v,$+1);c!==null&&(k[s]=c)}}return null}function D(k,l){const v=f(k,l,!1,0);return v===null?k:v}e.$gn=D;function M(k,l){const v=f(k,l,!0,0);return v===null?k:v}e.$hn=M}),define(Re[141],Ae([1,0,13,21,24]),function(fe,e,S,F,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nt=e.$mt=e.$lt=void 0;let L;function R(){return L||(L=new TextDecoder("UTF-16LE")),L}let g;function f(){return g||(g=new TextDecoder("UTF-16BE")),g}let D;function M(){return D||(D=F.$D()?R():f()),D}e.$lt=M;function k($,s,c){const t=new Uint16Array($.buffer,s,c);return c>0&&(t[0]===65279||t[0]===65534)?l($,s,c):R().decode(t)}e.$mt=k;function l($,s,c){const t=[];let n=0;for(let r=0;r<c;r++){const a=P.$ue($,s);s+=2,t[n++]=String.fromCharCode(a)}return t.join("")}class v{constructor(s){this.a=s|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const s=new Uint16Array(this.b.buffer,0,this.d);return M().decode(s)}f(){const s=this.e();this.d=0,this.c===null?this.c=[s]:this.c[this.c.length]=s}appendCharCode(s){const c=this.a-this.d;c<=1&&(c===0||S.$nf(s))&&this.f(),this.b[this.d++]=s}appendASCIICharCode(s){this.d===this.a&&this.f(),this.b[this.d++]=s}appendString(s){const c=s.length;if(this.d+c>=this.a){this.f(),this.c[this.c.length]=s;return}for(let t=0;t<c;t++)this.b[this.d++]=s.charCodeAt(t)}}e.$nt=v}),define(Re[142],Ae([1,0,24,141]),function(fe,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pt=e.$ot=void 0;function P(f){return f.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class L{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(D,M,k,l){this.oldPosition=D,this.oldText=M,this.newPosition=k,this.newText=l}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${P(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${P(this.oldText)}")`:`(replace@${this.oldPosition} "${P(this.oldText)}" with "${P(this.newText)}")`}static a(D){return 4+2*D.length}static c(D,M,k){const l=M.length;S.$xe(D,l,k),k+=4;for(let v=0;v<l;v++)S.$ve(D,M.charCodeAt(v),k),k+=2;return k}static d(D,M){const k=S.$we(D,M);return M+=4,(0,F.$mt)(D,M,k)}writeSize(){return 8+L.a(this.oldText)+L.a(this.newText)}write(D,M){return S.$xe(D,this.oldPosition,M),M+=4,S.$xe(D,this.newPosition,M),M+=4,M=L.c(D,this.oldText,M),M=L.c(D,this.newText,M),M}static read(D,M,k){const l=S.$we(D,M);M+=4;const v=S.$we(D,M);M+=4;const $=L.d(D,M);M+=L.a($);const s=L.d(D,M);return M+=L.a(s),k.push(new L(l,$,v,s)),M}}e.$ot=L;function R(f,D){return f===null||f.length===0?D:new g(f,D).compress()}e.$pt=R;class g{constructor(D,M){this.a=D,this.c=M,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let D=0,M=0,k=this.n(D),l=this.l(M);for(;D<this.f||M<this.h;){if(k===null){this.k(l),l=this.l(++M);continue}if(l===null){this.m(k),k=this.n(++D);continue}if(l.oldEnd<=k.newPosition){this.k(l),l=this.l(++M);continue}if(k.newEnd<=l.oldPosition){this.m(k),k=this.n(++D);continue}if(l.oldPosition<k.newPosition){const[t,n]=g.r(l,k.newPosition-l.oldPosition);this.k(t),l=n;continue}if(k.newPosition<l.oldPosition){const[t,n]=g.q(k,l.oldPosition-k.newPosition);this.m(t),k=n;continue}let s,c;if(l.oldEnd===k.newEnd)s=k,c=l,k=this.n(++D),l=this.l(++M);else if(l.oldEnd<k.newEnd){const[t,n]=g.q(k,l.oldLength);s=t,c=l,k=n,l=this.l(++M)}else{const[t,n]=g.r(l,k.newLength);s=k,c=t,k=this.n(++D),l=n}this.d[this.e++]=new L(s.oldPosition,s.oldText,c.newPosition,c.newText),this.g+=s.newLength-s.oldLength,this.j+=c.newLength-c.oldLength}const v=g.s(this.d);return g.t(v)}k(D){this.d[this.e++]=g.o(this.g,D),this.j+=D.newLength-D.oldLength}l(D){return D<this.h?this.c[D]:null}m(D){this.d[this.e++]=g.p(this.j,D),this.g+=D.newLength-D.oldLength}n(D){return D<this.f?this.a[D]:null}static o(D,M){return new L(M.oldPosition-D,M.oldText,M.newPosition,M.newText)}static p(D,M){return new L(M.oldPosition,M.oldText,M.newPosition+D,M.newText)}static q(D,M){const k=D.newText.substr(0,M),l=D.newText.substr(M);return[new L(D.oldPosition,D.oldText,D.newPosition,k),new L(D.oldEnd,"",D.newPosition+M,l)]}static r(D,M){const k=D.oldText.substr(0,M),l=D.oldText.substr(M);return[new L(D.oldPosition,k,D.newPosition,D.newText),new L(D.oldPosition+M,l,D.newEnd,"")]}static s(D){if(D.length===0)return D;const M=[];let k=0,l=D[0];for(let v=1;v<D.length;v++){const $=D[v];l.oldEnd===$.oldPosition?l=new L(l.oldPosition,l.oldText+$.oldText,l.newPosition,l.newText+$.newText):(M[k++]=l,l=$)}return M[k++]=l,M}static t(D){if(D.length===0)return D;const M=[];let k=0;for(let l=0;l<D.length;l++){const v=D[l];v.oldText!==v.newText&&(M[k++]=v)}return M}}}),define(Re[143],Ae([1,0,35,19]),function(fe,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nt=e.$Mt=void 0;function P(R,g,f,D,M,k){if(Array.isArray(R)){let l=0;for(const v of R){const $=P(v,g,f,D,M,k);if($===10)return $;$>l&&(l=$)}return l}else{if(typeof R=="string")return D?R==="*"?5:R===f?10:0:0;if(R){const{language:l,pattern:v,scheme:$,hasAccessToAllModels:s,notebookType:c}=R;if(!D&&!s)return 0;c&&M&&(g=M);let t=0;if($)if($===g.scheme)t=10;else if($==="*")t=5;else return 0;if(l)if(l===f)t=10;else if(l==="*")t=Math.max(t,5);else return 0;if(c)if(c===k)t=10;else if(c==="*"&&k!==void 0)t=Math.max(t,5);else return 0;if(v){let n;if(typeof v=="string"?n=v:n={...v,base:(0,F.$hc)(v.base)},n===g.fsPath||(0,S.$Wj)(n,g.fsPath))t=10;else return 0}return t}else return 0}}e.$Mt=P;function L(R){return typeof R=="string"?!1:Array.isArray(R)?R.some(L):!!R.notebookType}e.$Nt=L}),define(Re[144],Ae([1,0,5,13,29,92,90,129,142,6]),function(fe,e,S,F,P,L,R,g,f,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nC=void 0;class M extends D.$Tc{constructor(l,v,$,s,c,t,n){super(),this.m=this.B(new S.$5d),this.onDidChangeContent=this.m.event,this.f=v,this.j=!t,this.g=s,this.h=c,this.c=new R.$mC(l,$,n)}equals(l){return!(l instanceof M)||this.f!==l.f||this.getEOL()!==l.getEOL()?!1:this.c.equal(l.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot(l){return this.c.createSnapshot(l?this.f:"")}getOffsetAt(l,v){return this.c.getOffsetAt(l,v)}getPositionAt(l){return this.c.getPositionAt(l)}getRangeAt(l,v){const $=l+v,s=this.getPositionAt(l),c=this.getPositionAt($);return new P.$6s(s.lineNumber,s.column,c.lineNumber,c.column)}getValueInRange(l,v=0){if(l.isEmpty())return"";const $=this.n(v);return this.c.getValueInRange(l,$)}getValueLengthInRange(l,v=0){if(l.isEmpty())return 0;if(l.startLineNumber===l.endLineNumber)return l.endColumn-l.startColumn;const $=this.getOffsetAt(l.startLineNumber,l.startColumn),s=this.getOffsetAt(l.endLineNumber,l.endColumn);let c=0;const t=this.n(v),n=this.getEOL();if(t.length!==n.length){const r=t.length-n.length,a=l.endLineNumber-l.startLineNumber;c=r*a}return s-$+c}getCharacterCountInRange(l,v=0){if(this.j){let $=0;const s=l.startLineNumber,c=l.endLineNumber;for(let t=s;t<=c;t++){const n=this.getLineContent(t),r=t===s?l.startColumn-1:0,a=t===c?l.endColumn-1:n.length;for(let h=r;h<a;h++)F.$nf(n.charCodeAt(h))?($=$+1,h=h+1):$=$+1}return $+=this.n(v).length*(c-s),$}return this.getValueLengthInRange(l,v)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent(l){return this.c.getLineContent(l)}getLineCharCode(l,v){return this.c.getLineCharCode(l,v)}getCharCode(l){return this.c.getCharCode(l)}getLineLength(l){return this.c.getLineLength(l)}getLineMinColumn(l){return 1}getLineMaxColumn(l){return this.getLineLength(l)+1}getLineFirstNonWhitespaceColumn(l){const v=F.$$e(this.getLineContent(l));return v===-1?0:v+1}getLineLastNonWhitespaceColumn(l){const v=F.$af(this.getLineContent(l));return v===-1?0:v+2}n(l){switch(l){case 1:return`
`;case 2:return`\r
`;case 0:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(l){this.c.setEOL(l)}applyEdits(l,v,$){let s=this.g,c=this.h,t=this.j,n=!0,r=[];for(let E=0;E<l.length;E++){const w=l[E];n&&w._isTracked&&(n=!1);const m=w.range;if(w.text){let A=!0;t||(A=!F.$yf(w.text),t=A),!s&&A&&(s=F.$xf(w.text)),!c&&A&&(c=F.$Af(w.text))}let I="",d=0,y=0,b=0;if(w.text){let A;[d,y,b,A]=(0,g.$Ft)(w.text);const T=this.getEOL();A===0||A===(T===`\r
`?2:1)?I=w.text:I=w.text.replace(/\r\n|\r|\n/g,T)}r[E]={sortIndex:E,identifier:w.identifier||null,range:m,rangeOffset:this.getOffsetAt(m.startLineNumber,m.startColumn),rangeLength:this.getValueLengthInRange(m),text:I,eolCount:d,firstLineLength:y,lastLineLength:b,forceMoveMarkers:!!w.forceMoveMarkers,isAutoWhitespaceEdit:w.isAutoWhitespaceEdit||!1}}r.sort(M.u);let a=!1;for(let E=0,w=r.length-1;E<w;E++){const m=r[E].range.getEndPosition(),I=r[E+1].range.getStartPosition();if(I.isBeforeOrEqual(m)){if(I.isBefore(m))throw new Error("Overlapping ranges are not allowed!");a=!0}}n&&(r=this.s(r));const h=$||v?M._getInverseEditRanges(r):[],i=[];if(v)for(let E=0;E<r.length;E++){const w=r[E],m=h[E];if(w.isAutoWhitespaceEdit&&w.range.isEmpty())for(let I=m.startLineNumber;I<=m.endLineNumber;I++){let d="";I===m.startLineNumber&&(d=this.getLineContent(w.range.startLineNumber),F.$$e(d)!==-1)||i.push({lineNumber:I,oldContent:d})}}let p=null;if($){let E=0;p=[];for(let w=0;w<r.length;w++){const m=r[w],I=h[w],d=this.getValueInRange(m.range),y=m.rangeOffset+E;E+=m.text.length-d.length,p[w]={sortIndex:m.sortIndex,identifier:m.identifier,range:I,text:d,textChange:new f.$ot(m.rangeOffset,d,y,m.text)}}a||p.sort((w,m)=>w.sortIndex-m.sortIndex)}this.g=s,this.h=c,this.j=t;const u=this.t(r);let o=null;if(v&&i.length>0){i.sort((E,w)=>w.lineNumber-E.lineNumber),o=[];for(let E=0,w=i.length;E<w;E++){const m=i[E].lineNumber;if(E>0&&i[E-1].lineNumber===m)continue;const I=i[E].oldContent,d=this.getLineContent(m);d.length===0||d===I||F.$$e(d)!==-1||o.push(m)}}return this.m.fire(),new L.$qv(p,u,o)}s(l){return l.length<1e3?l:[this._toSingleEditOperation(l)]}_toSingleEditOperation(l){let v=!1;const $=l[0].range,s=l[l.length-1].range,c=new P.$6s($.startLineNumber,$.startColumn,s.endLineNumber,s.endColumn);let t=$.startLineNumber,n=$.startColumn;const r=[];for(let u=0,o=l.length;u<o;u++){const E=l[u],w=E.range;v=v||E.forceMoveMarkers,r.push(this.getValueInRange(new P.$6s(t,n,w.startLineNumber,w.startColumn))),E.text.length>0&&r.push(E.text),t=w.endLineNumber,n=w.endColumn}const a=r.join(""),[h,i,p]=(0,g.$Ft)(a);return{sortIndex:0,identifier:l[0].identifier,range:c,rangeOffset:this.getOffsetAt(c.startLineNumber,c.startColumn),rangeLength:this.getValueLengthInRange(c,0),text:a,eolCount:h,firstLineLength:i,lastLineLength:p,forceMoveMarkers:v,isAutoWhitespaceEdit:!1}}t(l){l.sort(M.w);const v=[];for(let $=0;$<l.length;$++){const s=l[$],c=s.range.startLineNumber,t=s.range.startColumn,n=s.range.endLineNumber,r=s.range.endColumn;if(c===n&&t===r&&s.text.length===0)continue;s.text?(this.c.delete(s.rangeOffset,s.rangeLength),this.c.insert(s.rangeOffset,s.text,!0)):this.c.delete(s.rangeOffset,s.rangeLength);const a=new P.$6s(c,t,n,r);v.push({range:a,rangeLength:s.rangeLength,text:s.text,rangeOffset:s.rangeOffset,forceMoveMarkers:s.forceMoveMarkers})}return v}findMatchesLineByLine(l,v,$,s){return this.c.findMatchesLineByLine(l,v,$,s)}getPieceTree(){return this.c}static _getInverseEditRange(l,v){const $=l.startLineNumber,s=l.startColumn,[c,t,n]=(0,g.$Ft)(v);let r;if(v.length>0){const a=c+1;a===1?r=new P.$6s($,s,$,s+t):r=new P.$6s($,s,$+a-1,n+1)}else r=new P.$6s($,s,$,s);return r}static _getInverseEditRanges(l){const v=[];let $=0,s=0,c=null;for(let t=0,n=l.length;t<n;t++){const r=l[t];let a,h;c?c.range.endLineNumber===r.range.startLineNumber?(a=$,h=s+(r.range.startColumn-c.range.endColumn)):(a=$+(r.range.startLineNumber-c.range.endLineNumber),h=r.range.startColumn):(a=r.range.startLineNumber,h=r.range.startColumn);let i;if(r.text.length>0){const p=r.eolCount+1;p===1?i=new P.$6s(a,h,a,h+r.firstLineLength):i=new P.$6s(a,h,a+p-1,r.lastLineLength+1)}else i=new P.$6s(a,h,a,h);$=i.endLineNumber,s=i.endColumn,v.push(i),c=r}return v}static u(l,v){const $=P.$6s.compareRangesUsingEnds(l.range,v.range);return $===0?l.sortIndex-v.sortIndex:$}static w(l,v){const $=P.$6s.compareRangesUsingEnds(l.range,v.range);return $===0?v.sortIndex-l.sortIndex:-$}}e.$nC=M}),define(Re[145],Ae([1,0,13,90,144]),function(fe,e,S,F,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oC=void 0;class L{constructor(f,D,M,k,l,v,$,s,c){this.a=f,this.b=D,this.c=M,this.d=k,this.e=l,this.f=v,this.g=$,this.h=s,this.j=c}k(f){const D=this.c+this.d+this.e,M=this.c+this.e;return D===0?f===1?`
`:`\r
`:M>D/2?`\r
`:`
`}create(f){const D=this.k(f),M=this.a;if(this.j&&(D===`\r
`&&(this.c>0||this.d>0)||D===`
`&&(this.c>0||this.e>0)))for(let l=0,v=M.length;l<v;l++){const $=M[l].buffer.replace(/\r\n|\r|\n/g,D),s=(0,F.$iC)($);M[l]=new F.$lC($,s)}const k=new P.$nC(M,this.b,D,this.f,this.g,this.h,this.j);return{textBuffer:k,disposable:k}}getFirstLineText(f){return this.a[0].buffer.substr(0,f).split(/\r\n|\r|\n/)[0]}}class R{constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk(f){if(f.length===0)return;this.a.length===0&&S.$Gf(f)&&(this.b=S.$Ff,f=f.substr(1));const D=f.charCodeAt(f.length-1);D===13||D>=55296&&D<=56319?(this.m(f.substr(0,f.length-1),!1),this.c=!0,this.d=D):(this.m(f,!1),this.c=!1,this.d=D)}m(f,D){!D&&f.length===0||(this.c?this.n(String.fromCharCode(this.d)+f):this.n(f))}n(f){const D=(0,F.$jC)(this.e,f);this.a.push(new F.$lC(f,D.lineStarts)),this.f+=D.cr,this.g+=D.lf,this.h+=D.crlf,D.isBasicASCII||(this.l=!1,this.j||(this.j=S.$xf(f)),this.k||(this.k=S.$Af(f)))}finish(f=!0){return this.o(),new L(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,f)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const f=this.a[this.a.length-1];f.buffer+=String.fromCharCode(this.d);const D=(0,F.$iC)(f.buffer);f.lineStarts=D,this.d===13&&this.f++}}}e.$oC=R}),define(Re[95],Ae([1,0,24,21]),function(fe,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9_=e.$8_=void 0;var P;(function(k){k[k.Full=1]="Full",k[k.Delta=2]="Delta"})(P||(P={}));function L(k){for(let l=0,v=k.length;l<v;l+=4){const $=k[l+0],s=k[l+1],c=k[l+2],t=k[l+3];k[l+0]=t,k[l+1]=c,k[l+2]=s,k[l+3]=$}}function R(k){const l=new Uint8Array(k.buffer,k.byteOffset,k.length*4);return F.$D()||L(l),S.$se.wrap(l)}function g(k){const l=k.buffer;if(F.$D()||L(l),l.byteOffset%4===0)return new Uint32Array(l.buffer,l.byteOffset,l.length/4);{const v=new Uint8Array(l.byteLength);return v.set(l),new Uint32Array(v.buffer,v.byteOffset,v.length/4)}}function f(k){const l=new Uint32Array(D(k));let v=0;if(l[v++]=k.id,k.type==="full")l[v++]=1,l[v++]=k.data.length,l.set(k.data,v),v+=k.data.length;else{l[v++]=2,l[v++]=k.deltas.length;for(const $ of k.deltas)l[v++]=$.start,l[v++]=$.deleteCount,$.data?(l[v++]=$.data.length,l.set($.data,v),v+=$.data.length):l[v++]=0}return R(l)}e.$8_=f;function D(k){let l=0;if(l+=2,k.type==="full")l+=1+k.data.length;else{l+=1,l+=3*k.deltas.length;for(const v of k.deltas)v.data&&(l+=v.data.length)}return l}function M(k){const l=g(k);let v=0;const $=l[v++];if(l[v++]===1){const n=l[v++],r=l.subarray(v,v+n);return v+=n,{id:$,type:"full",data:r}}const c=l[v++],t=[];for(let n=0;n<c;n++){const r=l[v++],a=l[v++],h=l[v++];let i;h>0&&(i=l.subarray(v,v+h),v+=h),t[n]={start:r,deleteCount:a,data:i}}return{id:$,type:"delta",deltas:t}}e.$9_=M}),define(Re[146],Ae([9,10]),function(fe,e){return fe.create("vs/editor/common/config/editorOptions",e)}),define(Re[147],Ae([1,0,18,26,21,130,148,146]),function(fe,e,S,F,P,L,R,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.ShowLightbulbIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedFloat=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var f;(function(Y){Y[Y.None=0]="None",Y[Y.Keep=1]="Keep",Y[Y.Brackets=2]="Brackets",Y[Y.Advanced=3]="Advanced",Y[Y.Full=4]="Full"})(f||(e.EditorAutoIndentStrategy=f={})),e.MINIMAP_GUTTER_WIDTH=8;class D{constructor(X){this.c=X}hasChanged(X){return this.c[X]}}e.ConfigurationChangedEvent=D;class M{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=M;class k{constructor(X,pe,We,Xe){this.id=X,this.name=pe,this.defaultValue=We,this.schema=Xe}applyUpdate(X,pe){return v(X,pe)}compute(X,pe,We){return We}}class l{constructor(X,pe){this.newValue=X,this.didChange=pe}}e.ApplyUpdateResult=l;function v(Y,X){if(typeof Y!="object"||typeof X!="object"||!Y||!X)return new l(X,Y!==X);if(Array.isArray(Y)||Array.isArray(X)){const We=Array.isArray(Y)&&Array.isArray(X)&&S.$ub(Y,X);return new l(X,!We)}let pe=!1;for(const We in X)if(X.hasOwnProperty(We)){const Xe=v(Y[We],X[We]);Xe.didChange&&(Y[We]=Xe.newValue,pe=!0)}return new l(Y,pe)}class ${constructor(X){this.schema=void 0,this.id=X,this.name="_never_",this.defaultValue=void 0}applyUpdate(X,pe){return v(X,pe)}validate(X){return this.defaultValue}}class s{constructor(X,pe,We,Xe){this.id=X,this.name=pe,this.defaultValue=We,this.schema=Xe}applyUpdate(X,pe){return v(X,pe)}validate(X){return typeof X>"u"?this.defaultValue:X}compute(X,pe,We){return We}}function c(Y,X){return typeof Y>"u"?X:Y==="false"?!1:!!Y}e.boolean=c;class t extends s{constructor(X,pe,We,Xe=void 0){typeof Xe<"u"&&(Xe.type="boolean",Xe.default=We),super(X,pe,We,Xe)}validate(X){return c(X,this.defaultValue)}}function n(Y,X,pe,We){if(typeof Y>"u")return X;let Xe=parseInt(Y,10);return isNaN(Xe)?X:(Xe=Math.max(pe,Xe),Xe=Math.min(We,Xe),Xe|0)}e.clampedInt=n;class r extends s{static clampedInt(X,pe,We,Xe){return n(X,pe,We,Xe)}constructor(X,pe,We,Xe,st,Le=void 0){typeof Le<"u"&&(Le.type="integer",Le.default=We,Le.minimum=Xe,Le.maximum=st),super(X,pe,We,Le),this.minimum=Xe,this.maximum=st}validate(X){return r.clampedInt(X,this.defaultValue,this.minimum,this.maximum)}}function a(Y,X,pe,We){if(typeof Y>"u")return X;const Xe=h.float(Y,X);return h.clamp(Xe,pe,We)}e.clampedFloat=a;class h extends s{static clamp(X,pe,We){return X<pe?pe:X>We?We:X}static float(X,pe){if(typeof X=="number")return X;if(typeof X>"u")return pe;const We=parseFloat(X);return isNaN(We)?pe:We}constructor(X,pe,We,Xe,st){typeof st<"u"&&(st.type="number",st.default=We),super(X,pe,We,st),this.validationFn=Xe}validate(X){return this.validationFn(h.float(X,this.defaultValue))}}class i extends s{static string(X,pe){return typeof X!="string"?pe:X}constructor(X,pe,We,Xe=void 0){typeof Xe<"u"&&(Xe.type="string",Xe.default=We),super(X,pe,We,Xe)}validate(X){return i.string(X,this.defaultValue)}}function p(Y,X,pe,We){return typeof Y!="string"?X:We&&Y in We?We[Y]:pe.indexOf(Y)===-1?X:Y}e.stringSet=p;class u extends s{constructor(X,pe,We,Xe,st=void 0){typeof st<"u"&&(st.type="string",st.enum=Xe,st.default=We),super(X,pe,We,st),this.c=Xe}validate(X){return p(X,this.defaultValue,this.c)}}class o extends k{constructor(X,pe,We,Xe,st,Le,Dt=void 0){typeof Dt<"u"&&(Dt.type="string",Dt.enum=st,Dt.default=Xe),super(X,pe,We,Dt),this.c=st,this.d=Le}validate(X){return typeof X!="string"?this.defaultValue:this.c.indexOf(X)===-1?this.defaultValue:this.d(X)}}function E(Y){switch(Y){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class w extends k{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[g.localize(0,null),g.localize(1,null),g.localize(2,null)],default:"auto",tags:["accessibility"],description:g.localize(3,null)})}validate(X){switch(X){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(X,pe,We){return We===0?X.accessibilitySupport:We}}class m extends k{constructor(){const X={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",X,{"editor.comments.insertSpace":{type:"boolean",default:X.insertSpace,description:g.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:X.ignoreEmptyLines,description:g.localize(5,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X;return{insertSpace:c(pe.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:c(pe.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var I;(function(Y){Y[Y.Hidden=0]="Hidden",Y[Y.Blink=1]="Blink",Y[Y.Smooth=2]="Smooth",Y[Y.Phase=3]="Phase",Y[Y.Expand=4]="Expand",Y[Y.Solid=5]="Solid"})(I||(e.TextEditorCursorBlinkingStyle=I={}));function d(Y){switch(Y){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var y;(function(Y){Y[Y.Line=1]="Line",Y[Y.Block=2]="Block",Y[Y.Underline=3]="Underline",Y[Y.LineThin=4]="LineThin",Y[Y.BlockOutline=5]="BlockOutline",Y[Y.UnderlineThin=6]="UnderlineThin"})(y||(e.TextEditorCursorStyle=y={}));function b(Y){switch(Y){case y.Line:return"line";case y.Block:return"block";case y.Underline:return"underline";case y.LineThin:return"line-thin";case y.BlockOutline:return"block-outline";case y.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=b;function A(Y){switch(Y){case"line":return y.Line;case"block":return y.Block;case"underline":return y.Underline;case"line-thin":return y.LineThin;case"block-outline":return y.BlockOutline;case"underline-thin":return y.UnderlineThin}}class T extends ${constructor(){super(141)}compute(X,pe,We){const Xe=["monaco-editor"];return pe.get(39)&&Xe.push(pe.get(39)),X.extraEditorClassName&&Xe.push(X.extraEditorClassName),pe.get(74)==="default"?Xe.push("mouse-default"):pe.get(74)==="copy"&&Xe.push("mouse-copy"),pe.get(111)&&Xe.push("showUnused"),pe.get(139)&&Xe.push("showDeprecated"),Xe.join(" ")}}class G extends t{constructor(){super(37,"emptySelectionClipboard",!0,{description:g.localize(6,null)})}compute(X,pe,We){return We&&X.emptySelectionClipboard}}class W extends k{constructor(){const X={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",X,{"editor.find.cursorMoveOnType":{type:"boolean",default:X.cursorMoveOnType,description:g.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:X.seedSearchStringFromSelection,enumDescriptions:[g.localize(8,null),g.localize(9,null),g.localize(10,null)],description:g.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:X.autoFindInSelection,enumDescriptions:[g.localize(12,null),g.localize(13,null),g.localize(14,null)],description:g.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:X.globalFindClipboard,description:g.localize(16,null),included:P.$j},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:X.addExtraSpaceOnTop,description:g.localize(17,null)},"editor.find.loop":{type:"boolean",default:X.loop,description:g.localize(18,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X;return{cursorMoveOnType:c(pe.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof X.seedSearchStringFromSelection=="boolean"?X.seedSearchStringFromSelection?"always":"never":p(pe.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof X.autoFindInSelection=="boolean"?X.autoFindInSelection?"always":"never":p(pe.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:c(pe.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:c(pe.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:c(pe.loop,this.defaultValue.loop)}}}class U extends k{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",U.OFF,{anyOf:[{type:"boolean",description:g.localize(19,null)},{type:"string",description:g.localize(20,null)}],description:g.localize(21,null),default:!1})}validate(X){return typeof X>"u"?this.defaultValue:typeof X=="string"?X==="false"||X.length===0?U.OFF:X==="true"?U.ON:X:X?U.ON:U.OFF}}e.EditorFontLigatures=U;class C extends k{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",C.OFF,{anyOf:[{type:"boolean",description:g.localize(22,null)},{type:"string",description:g.localize(23,null)}],description:g.localize(24,null),default:!1})}validate(X){return typeof X>"u"?this.defaultValue:typeof X=="string"?X==="false"?C.OFF:X==="true"?C.TRANSLATE:X:X?C.TRANSLATE:C.OFF}compute(X,pe,We){return X.fontInfo.fontVariationSettings}}e.EditorFontVariations=C;class O extends ${constructor(){super(50)}compute(X,pe,We){return X.fontInfo}}class V extends s{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:g.localize(25,null)})}validate(X){const pe=h.float(X,this.defaultValue);return pe===0?e.EDITOR_FONT_DEFAULTS.fontSize:h.clamp(pe,6,100)}compute(X,pe,We){return X.fontInfo.fontSize}}class re extends k{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:re.d,maximum:re.e,errorMessage:g.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:re.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:g.localize(27,null)})}validate(X){return X==="normal"||X==="bold"?X:String(r.clampedInt(X,e.EDITOR_FONT_DEFAULTS.fontWeight,re.d,re.e))}}class ue extends k{constructor(){const X={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},pe={type:"string",enum:["peek","gotoAndPeek","goto"],default:X.multiple,enumDescriptions:[g.localize(28,null),g.localize(29,null),g.localize(30,null)]},We=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",X,{"editor.gotoLocation.multiple":{deprecationMessage:g.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:g.localize(32,null),...pe},"editor.gotoLocation.multipleTypeDefinitions":{description:g.localize(33,null),...pe},"editor.gotoLocation.multipleDeclarations":{description:g.localize(34,null),...pe},"editor.gotoLocation.multipleImplementations":{description:g.localize(35,null),...pe},"editor.gotoLocation.multipleReferences":{description:g.localize(36,null),...pe},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:X.alternativeDefinitionCommand,enum:We,description:g.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:X.alternativeTypeDefinitionCommand,enum:We,description:g.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:X.alternativeDeclarationCommand,enum:We,description:g.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:X.alternativeImplementationCommand,enum:We,description:g.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:X.alternativeReferenceCommand,enum:We,description:g.localize(41,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X;return{multiple:p(pe.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:pe.multipleDefinitions??p(pe.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:pe.multipleTypeDefinitions??p(pe.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:pe.multipleDeclarations??p(pe.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:pe.multipleImplementations??p(pe.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:pe.multipleReferences??p(pe.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:i.string(pe.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:i.string(pe.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:i.string(pe.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:i.string(pe.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:i.string(pe.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class ye extends k{constructor(){const X={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",X,{"editor.hover.enabled":{type:"boolean",default:X.enabled,description:g.localize(42,null)},"editor.hover.delay":{type:"number",default:X.delay,minimum:0,maximum:1e4,description:g.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:X.sticky,description:g.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:X.hidingDelay,description:g.localize(45,null)},"editor.hover.above":{type:"boolean",default:X.above,description:g.localize(46,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X;return{enabled:c(pe.enabled,this.defaultValue.enabled),delay:r.clampedInt(pe.delay,this.defaultValue.delay,0,1e4),sticky:c(pe.sticky,this.defaultValue.sticky),hidingDelay:r.clampedInt(pe.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:c(pe.above,this.defaultValue.above)}}}var De;(function(Y){Y[Y.None=0]="None",Y[Y.Text=1]="Text",Y[Y.Blocks=2]="Blocks"})(De||(e.RenderMinimap=De={}));class he extends ${constructor(){super(144)}compute(X,pe,We){return he.computeLayout(pe,{memory:X.memory,outerWidth:X.outerWidth,outerHeight:X.outerHeight,isDominatedByLongLines:X.isDominatedByLongLines,lineHeight:X.fontInfo.lineHeight,viewLineCount:X.viewLineCount,lineNumbersDigitCount:X.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:X.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:X.fontInfo.maxDigitWidth,pixelRatio:X.pixelRatio,glyphMarginDecorationLaneCount:X.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(X){const pe=X.height/X.lineHeight,We=Math.floor(X.paddingTop/X.lineHeight);let Xe=Math.floor(X.paddingBottom/X.lineHeight);X.scrollBeyondLastLine&&(Xe=Math.max(Xe,pe-1));const st=(We+X.viewLineCount+Xe)/(X.pixelRatio*X.height),Le=Math.floor(X.viewLineCount/st);return{typicalViewportLineCount:pe,extraLinesBeforeFirstLine:We,extraLinesBeyondLastLine:Xe,desiredRatio:st,minimapLineCount:Le}}static c(X,pe){const We=X.outerWidth,Xe=X.outerHeight,st=X.pixelRatio;if(!X.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(st*Xe),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Xe};const Le=pe.stableMinimapLayoutInput,Dt=Le&&X.outerHeight===Le.outerHeight&&X.lineHeight===Le.lineHeight&&X.typicalHalfwidthCharacterWidth===Le.typicalHalfwidthCharacterWidth&&X.pixelRatio===Le.pixelRatio&&X.scrollBeyondLastLine===Le.scrollBeyondLastLine&&X.paddingTop===Le.paddingTop&&X.paddingBottom===Le.paddingBottom&&X.minimap.enabled===Le.minimap.enabled&&X.minimap.side===Le.minimap.side&&X.minimap.size===Le.minimap.size&&X.minimap.showSlider===Le.minimap.showSlider&&X.minimap.renderCharacters===Le.minimap.renderCharacters&&X.minimap.maxColumn===Le.minimap.maxColumn&&X.minimap.scale===Le.minimap.scale&&X.verticalScrollbarWidth===Le.verticalScrollbarWidth&&X.isViewportWrapping===Le.isViewportWrapping,Ht=X.lineHeight,Tt=X.typicalHalfwidthCharacterWidth,Qt=X.scrollBeyondLastLine,Xt=X.minimap.renderCharacters;let It=st>=2?Math.round(X.minimap.scale*2):X.minimap.scale;const Kt=X.minimap.maxColumn,Gt=X.minimap.size,xt=X.minimap.side,ii=X.verticalScrollbarWidth,Ye=X.viewLineCount,Nt=X.remainingWidth,_t=X.isViewportWrapping,ft=Xt?2:3;let vt=Math.floor(st*Xe);const ei=vt/st;let Bt=!1,jt=!1,dt=ft*It,Rt=It/st,ti=1;if(Gt==="fill"||Gt==="fit"){const{typicalViewportLineCount:Lt,extraLinesBeforeFirstLine:Ct,extraLinesBeyondLastLine:Ut,desiredRatio:ri,minimapLineCount:Ot}=he.computeContainedMinimapLineCount({viewLineCount:Ye,scrollBeyondLastLine:Qt,paddingTop:X.paddingTop,paddingBottom:X.paddingBottom,height:Xe,lineHeight:Ht,pixelRatio:st});if(Ye/Ot>1)Bt=!0,jt=!0,It=1,dt=1,Rt=It/st;else{let Pt=!1,kt=It+1;if(Gt==="fit"){const $t=Math.ceil((Ct+Ye+Ut)*dt);_t&&Dt&&Nt<=pe.stableFitRemainingWidth?(Pt=!0,kt=pe.stableFitMaxMinimapScale):Pt=$t>vt}if(Gt==="fill"||Pt){Bt=!0;const $t=It;dt=Math.min(Ht*st,Math.max(1,Math.floor(1/ri))),_t&&Dt&&Nt<=pe.stableFitRemainingWidth&&(kt=pe.stableFitMaxMinimapScale),It=Math.min(kt,Math.max(1,Math.floor(dt/ft))),It>$t&&(ti=Math.min(2,It/$t)),Rt=It/st/ti,vt=Math.ceil(Math.max(Lt,Ct+Ye+Ut)*dt),_t?(pe.stableMinimapLayoutInput=X,pe.stableFitRemainingWidth=Nt,pe.stableFitMaxMinimapScale=It):(pe.stableMinimapLayoutInput=null,pe.stableFitRemainingWidth=0)}}}const Yt=Math.floor(Kt*Rt),Ke=Math.min(Yt,Math.max(0,Math.floor((Nt-ii-2)*Rt/(Tt+Rt)))+e.MINIMAP_GUTTER_WIDTH);let Ft=Math.floor(st*Ke);const zt=Ft/st;Ft=Math.floor(Ft*ti);const ni=Xt?1:2,gt=xt==="left"?0:We-Ke-ii;return{renderMinimap:ni,minimapLeft:gt,minimapWidth:Ke,minimapHeightIsEditorHeight:Bt,minimapIsSampling:jt,minimapScale:It,minimapLineHeight:dt,minimapCanvasInnerWidth:Ft,minimapCanvasInnerHeight:vt,minimapCanvasOuterWidth:zt,minimapCanvasOuterHeight:ei}}static computeLayout(X,pe){const We=pe.outerWidth|0,Xe=pe.outerHeight|0,st=pe.lineHeight|0,Le=pe.lineNumbersDigitCount|0,Dt=pe.typicalHalfwidthCharacterWidth,Ht=pe.maxDigitWidth,Tt=pe.pixelRatio,Qt=pe.viewLineCount,Xt=X.get(136),It=Xt==="inherit"?X.get(135):Xt,Kt=It==="inherit"?X.get(131):It,Gt=X.get(134),xt=pe.isDominatedByLongLines,ii=X.get(57),Ye=X.get(68).renderType!==0,Nt=X.get(69),_t=X.get(105),ft=X.get(84),vt=X.get(73),ei=X.get(103),Bt=ei.verticalScrollbarSize,jt=ei.verticalHasArrows,dt=ei.arrowSize,Rt=ei.horizontalScrollbarSize,ti=X.get(43),Yt=X.get(110)!=="never";let Ke=X.get(66);ti&&Yt&&(Ke+=16);let Ft=0;if(Ye){const wt=Math.max(Le,Nt);Ft=Math.round(wt*Ht)}let zt=0;ii&&(zt=st*pe.glyphMarginDecorationLaneCount);let ni=0,gt=ni+zt,Lt=gt+Ft,Ct=Lt+Ke;const Ut=We-zt-Ft-Ke;let ri=!1,Ot=!1,Vt=-1;It==="inherit"&&xt?(ri=!0,Ot=!0):Kt==="on"||Kt==="bounded"?Ot=!0:Kt==="wordWrapColumn"&&(Vt=Gt);const Pt=he.c({outerWidth:We,outerHeight:Xe,lineHeight:st,typicalHalfwidthCharacterWidth:Dt,pixelRatio:Tt,scrollBeyondLastLine:_t,paddingTop:ft.top,paddingBottom:ft.bottom,minimap:vt,verticalScrollbarWidth:Bt,viewLineCount:Qt,remainingWidth:Ut,isViewportWrapping:Ot},pe.memory||new M);Pt.renderMinimap!==0&&Pt.minimapLeft===0&&(ni+=Pt.minimapWidth,gt+=Pt.minimapWidth,Lt+=Pt.minimapWidth,Ct+=Pt.minimapWidth);const kt=Ut-Pt.minimapWidth,$t=Math.max(1,Math.floor((kt-Bt-2)/Dt)),St=jt?dt:0;return Ot&&(Vt=Math.max(1,$t),Kt==="bounded"&&(Vt=Math.min(Vt,Gt))),{width:We,height:Xe,glyphMarginLeft:ni,glyphMarginWidth:zt,glyphMarginDecorationLaneCount:pe.glyphMarginDecorationLaneCount,lineNumbersLeft:gt,lineNumbersWidth:Ft,decorationsLeft:Lt,decorationsWidth:Ke,contentLeft:Ct,contentWidth:kt,minimap:Pt,viewportColumn:$t,isWordWrapMinified:ri,isViewportWrapping:Ot,wrappingColumn:Vt,verticalScrollbarWidth:Bt,horizontalScrollbarHeight:Rt,overviewRuler:{top:St,width:Bt,height:Xe-2*St,right:0}}}}e.EditorLayoutInfoComputer=he;class ve extends k{constructor(){super(138,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[g.localize(47,null),g.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:g.localize(49,null)}})}validate(X){return p(X,"simple",["simple","advanced"])}compute(X,pe,We){return pe.get(2)===2?"advanced":We}}var se;(function(Y){Y.Off="off",Y.OnCode="onCode",Y.On="on"})(se||(e.ShowLightbulbIconMode=se={}));class $e extends k{constructor(){const X={enabled:se.OnCode};super(65,"lightbulb",X,{"editor.lightbulb.enabled":{type:"string",tags:["experimental"],enum:[se.Off,se.OnCode,se.On],default:X.enabled,enumDescriptions:[g.localize(50,null),g.localize(51,null),g.localize(52,null)],description:g.localize(53,null)}})}validate(X){return!X||typeof X!="object"?this.defaultValue:{enabled:p(X.enabled,this.defaultValue.enabled,[se.Off,se.OnCode,se.On])}}}class ee extends k{constructor(){const X={enabled:!0,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(115,"stickyScroll",X,{"editor.stickyScroll.enabled":{type:"boolean",default:X.enabled,description:g.localize(54,null),tags:["experimental"]},"editor.stickyScroll.maxLineCount":{type:"number",default:X.maxLineCount,minimum:1,maximum:20,description:g.localize(55,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:X.defaultModel,description:g.localize(56,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:X.scrollWithEditor,description:g.localize(57,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X;return{enabled:c(pe.enabled,this.defaultValue.enabled),maxLineCount:r.clampedInt(pe.maxLineCount,this.defaultValue.maxLineCount,1,20),defaultModel:p(pe.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:c(pe.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class Q extends k{constructor(){const X={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(140,"inlayHints",X,{"editor.inlayHints.enabled":{type:"string",default:X.enabled,description:g.localize(58,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[g.localize(59,null),g.localize(60,null,P.$j?"Ctrl+Option":"Ctrl+Alt"),g.localize(61,null,P.$j?"Ctrl+Option":"Ctrl+Alt"),g.localize(62,null)]},"editor.inlayHints.fontSize":{type:"number",default:X.fontSize,markdownDescription:g.localize(63,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:X.fontFamily,markdownDescription:g.localize(64,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:X.padding,description:g.localize(65,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X;return typeof pe.enabled=="boolean"&&(pe.enabled=pe.enabled?"on":"off"),{enabled:p(pe.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:r.clampedInt(pe.fontSize,this.defaultValue.fontSize,0,100),fontFamily:i.string(pe.fontFamily,this.defaultValue.fontFamily),padding:c(pe.padding,this.defaultValue.padding)}}}class q extends k{constructor(){super(66,"lineDecorationsWidth",10)}validate(X){return typeof X=="string"&&/^\d+(\.\d+)?ch$/.test(X)?-parseFloat(X.substring(0,X.length-2)):r.clampedInt(X,this.defaultValue,0,1e3)}compute(X,pe,We){return We<0?r.clampedInt(-We*X.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):We}}class ne extends h{constructor(){super(67,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,X=>h.clamp(X,0,150),{markdownDescription:g.localize(66,null)})}compute(X,pe,We){return X.fontInfo.lineHeight}}class Se extends k{constructor(){const X={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(73,"minimap",X,{"editor.minimap.enabled":{type:"boolean",default:X.enabled,description:g.localize(67,null)},"editor.minimap.autohide":{type:"boolean",default:X.autohide,description:g.localize(68,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[g.localize(69,null),g.localize(70,null),g.localize(71,null)],default:X.size,description:g.localize(72,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:X.side,description:g.localize(73,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:X.showSlider,description:g.localize(74,null)},"editor.minimap.scale":{type:"number",default:X.scale,minimum:1,maximum:3,enum:[1,2,3],description:g.localize(75,null)},"editor.minimap.renderCharacters":{type:"boolean",default:X.renderCharacters,description:g.localize(76,null)},"editor.minimap.maxColumn":{type:"number",default:X.maxColumn,description:g.localize(77,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X;return{enabled:c(pe.enabled,this.defaultValue.enabled),autohide:c(pe.autohide,this.defaultValue.autohide),size:p(pe.size,this.defaultValue.size,["proportional","fill","fit"]),side:p(pe.side,this.defaultValue.side,["right","left"]),showSlider:p(pe.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:c(pe.renderCharacters,this.defaultValue.renderCharacters),scale:r.clampedInt(pe.scale,1,1,3),maxColumn:r.clampedInt(pe.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function Te(Y){return Y==="ctrlCmd"?P.$j?"metaKey":"ctrlKey":"altKey"}class Ce extends k{constructor(){super(84,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:g.localize(78,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:g.localize(79,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X;return{top:r.clampedInt(pe.top,0,0,1e3),bottom:r.clampedInt(pe.bottom,0,0,1e3)}}}class we extends k{constructor(){const X={enabled:!0,cycle:!0};super(86,"parameterHints",X,{"editor.parameterHints.enabled":{type:"boolean",default:X.enabled,description:g.localize(80,null)},"editor.parameterHints.cycle":{type:"boolean",default:X.cycle,description:g.localize(81,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X;return{enabled:c(pe.enabled,this.defaultValue.enabled),cycle:c(pe.cycle,this.defaultValue.cycle)}}}class ge extends ${constructor(){super(142)}compute(X,pe,We){return X.pixelRatio}}class J extends k{constructor(){const X={other:"on",comments:"off",strings:"off"},pe=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[g.localize(82,null),g.localize(83,null),g.localize(84,null)]}];super(89,"quickSuggestions",X,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:pe,default:X.strings,description:g.localize(85,null)},comments:{anyOf:pe,default:X.comments,description:g.localize(86,null)},other:{anyOf:pe,default:X.other,description:g.localize(87,null)}},default:X,markdownDescription:g.localize(88,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=X}validate(X){if(typeof X=="boolean"){const Tt=X?"on":"off";return{comments:Tt,strings:Tt,other:Tt}}if(!X||typeof X!="object")return this.defaultValue;const{other:pe,comments:We,strings:Xe}=X,st=["on","inline","off"];let Le,Dt,Ht;return typeof pe=="boolean"?Le=pe?"on":"off":Le=p(pe,this.defaultValue.other,st),typeof We=="boolean"?Dt=We?"on":"off":Dt=p(We,this.defaultValue.comments,st),typeof Xe=="boolean"?Ht=Xe?"on":"off":Ht=p(Xe,this.defaultValue.strings,st),{other:Le,comments:Dt,strings:Ht}}}var x;(function(Y){Y[Y.Off=0]="Off",Y[Y.On=1]="On",Y[Y.Relative=2]="Relative",Y[Y.Interval=3]="Interval",Y[Y.Custom=4]="Custom"})(x||(e.RenderLineNumbersType=x={}));class le extends k{constructor(){super(68,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[g.localize(89,null),g.localize(90,null),g.localize(91,null),g.localize(92,null)],default:"on",description:g.localize(93,null)})}validate(X){let pe=this.defaultValue.renderType,We=this.defaultValue.renderFn;return typeof X<"u"&&(typeof X=="function"?(pe=4,We=X):X==="interval"?pe=3:X==="relative"?pe=2:X==="on"?pe=1:pe=0),{renderType:pe,renderFn:We}}}function de(Y){const X=Y.get(98);return X==="editable"?Y.get(91):X!=="on"}e.filterValidationDecorations=de;class Pe extends k{constructor(){const X=[],pe={type:"number",description:g.localize(94,null)};super(102,"rulers",X,{type:"array",items:{anyOf:[pe,{type:["object"],properties:{column:pe,color:{type:"string",description:g.localize(95,null),format:"color-hex"}}}]},default:X,description:g.localize(96,null)})}validate(X){if(Array.isArray(X)){const pe=[];for(const We of X)if(typeof We=="number")pe.push({column:r.clampedInt(We,0,0,1e4),color:null});else if(We&&typeof We=="object"){const Xe=We;pe.push({column:r.clampedInt(Xe.column,0,0,1e4),color:Xe.color})}return pe.sort((We,Xe)=>We.column-Xe.column),pe}return this.defaultValue}}class me extends k{constructor(){super(92,"readOnlyMessage",void 0)}validate(X){return!X||typeof X!="object"?this.defaultValue:X}}function Ie(Y,X){if(typeof Y!="string")return X;switch(Y){case"hidden":return 2;case"visible":return 3;default:return 1}}class Me extends k{constructor(){const X={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(103,"scrollbar",X,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[g.localize(97,null),g.localize(98,null),g.localize(99,null)],default:"auto",description:g.localize(100,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[g.localize(101,null),g.localize(102,null),g.localize(103,null)],default:"auto",description:g.localize(104,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:X.verticalScrollbarSize,description:g.localize(105,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:X.horizontalScrollbarSize,description:g.localize(106,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:X.scrollByPage,description:g.localize(107,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:X.ignoreHorizontalScrollbarInContentHeight,description:g.localize(108,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X,We=r.clampedInt(pe.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Xe=r.clampedInt(pe.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:r.clampedInt(pe.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Ie(pe.vertical,this.defaultValue.vertical),horizontal:Ie(pe.horizontal,this.defaultValue.horizontal),useShadows:c(pe.useShadows,this.defaultValue.useShadows),verticalHasArrows:c(pe.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:c(pe.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:c(pe.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:c(pe.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:We,horizontalSliderSize:r.clampedInt(pe.horizontalSliderSize,We,0,1e3),verticalScrollbarSize:Xe,verticalSliderSize:r.clampedInt(pe.verticalSliderSize,Xe,0,1e3),scrollByPage:c(pe.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:c(pe.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class ze extends k{constructor(){const X={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(125,"unicodeHighlight",X,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:X.nonBasicASCII,description:g.localize(109,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:X.invisibleCharacters,description:g.localize(110,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:X.ambiguousCharacters,description:g.localize(111,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:X.includeComments,description:g.localize(112,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:X.includeStrings,description:g.localize(113,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:X.allowedCharacters,description:g.localize(114,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:X.allowedLocales,description:g.localize(115,null)}})}applyUpdate(X,pe){let We=!1;pe.allowedCharacters&&X&&(F.$Ln(X.allowedCharacters,pe.allowedCharacters)||(X={...X,allowedCharacters:pe.allowedCharacters},We=!0)),pe.allowedLocales&&X&&(F.$Ln(X.allowedLocales,pe.allowedLocales)||(X={...X,allowedLocales:pe.allowedLocales},We=!0));const Xe=super.applyUpdate(X,pe);return We?new l(Xe.newValue,!0):Xe}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X;return{nonBasicASCII:te(pe.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:c(pe.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:c(pe.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:te(pe.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:te(pe.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(X.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(X.allowedLocales,this.defaultValue.allowedLocales)}}c(X,pe){if(typeof X!="object"||!X)return pe;const We={};for(const[Xe,st]of Object.entries(X))st===!0&&(We[Xe]=!0);return We}}class N extends k{constructor(){const X={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1,fontFamily:"default"};super(62,"inlineSuggest",X,{"editor.inlineSuggest.enabled":{type:"boolean",default:X.enabled,description:g.localize(116,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:X.showToolbar,enum:["always","onHover","never"],enumDescriptions:[g.localize(117,null),g.localize(118,null),g.localize(119,null)],description:g.localize(120,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:X.suppressSuggestions,description:g.localize(121,null)},"editor.inlineSuggest.fontFamily":{type:"string",default:X.fontFamily,description:g.localize(122,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X;return{enabled:c(pe.enabled,this.defaultValue.enabled),mode:p(pe.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:p(pe.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:c(pe.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:c(pe.keepOnBlur,this.defaultValue.keepOnBlur),fontFamily:i.string(pe.fontFamily,this.defaultValue.fontFamily)}}}class z extends k{constructor(){const X={enabled:!1,showToolbar:"onHover",fontFamily:"default",keepOnBlur:!1,backgroundColoring:!1};super(63,"experimentalInlineEdit",X,{"editor.experimentalInlineEdit.enabled":{type:"boolean",default:X.enabled,description:g.localize(123,null)},"editor.experimentalInlineEdit.showToolbar":{type:"string",default:X.showToolbar,enum:["always","onHover","never"],enumDescriptions:[g.localize(124,null),g.localize(125,null),g.localize(126,null)],description:g.localize(127,null)},"editor.experimentalInlineEdit.fontFamily":{type:"string",default:X.fontFamily,description:g.localize(128,null)},"editor.experimentalInlineEdit.backgroundColoring":{type:"boolean",default:X.backgroundColoring,description:g.localize(129,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X;return{enabled:c(pe.enabled,this.defaultValue.enabled),showToolbar:p(pe.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),fontFamily:i.string(pe.fontFamily,this.defaultValue.fontFamily),keepOnBlur:c(pe.keepOnBlur,this.defaultValue.keepOnBlur),backgroundColoring:c(pe.backgroundColoring,this.defaultValue.backgroundColoring)}}}class K extends k{constructor(){const X={enabled:L.$Ds.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:L.$Ds.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",X,{"editor.bracketPairColorization.enabled":{type:"boolean",default:X.enabled,markdownDescription:g.localize(130,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:X.independentColorPoolPerBracketType,description:g.localize(131,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X;return{enabled:c(pe.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:c(pe.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class H extends k{constructor(){const X={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",X,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[g.localize(132,null),g.localize(133,null),g.localize(134,null)],default:X.bracketPairs,description:g.localize(135,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[g.localize(136,null),g.localize(137,null),g.localize(138,null)],default:X.bracketPairsHorizontal,description:g.localize(139,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:X.highlightActiveBracketPair,description:g.localize(140,null)},"editor.guides.indentation":{type:"boolean",default:X.indentation,description:g.localize(141,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[g.localize(142,null),g.localize(143,null),g.localize(144,null)],default:X.highlightActiveIndentation,description:g.localize(145,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X;return{bracketPairs:te(pe.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:te(pe.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:c(pe.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:c(pe.indentation,this.defaultValue.indentation),highlightActiveIndentation:te(pe.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function te(Y,X,pe){const We=pe.indexOf(Y);return We===-1?X:pe[We]}class oe extends k{constructor(){const X={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(118,"suggest",X,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[g.localize(146,null),g.localize(147,null)],default:X.insertMode,description:g.localize(148,null)},"editor.suggest.filterGraceful":{type:"boolean",default:X.filterGraceful,description:g.localize(149,null)},"editor.suggest.localityBonus":{type:"boolean",default:X.localityBonus,description:g.localize(150,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:X.shareSuggestSelections,markdownDescription:g.localize(151,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[g.localize(152,null),g.localize(153,null),g.localize(154,null),g.localize(155,null)],default:X.selectionMode,markdownDescription:g.localize(156,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:X.snippetsPreventQuickSuggestions,description:g.localize(157,null)},"editor.suggest.showIcons":{type:"boolean",default:X.showIcons,description:g.localize(158,null)},"editor.suggest.showStatusBar":{type:"boolean",default:X.showStatusBar,description:g.localize(159,null)},"editor.suggest.preview":{type:"boolean",default:X.preview,description:g.localize(160,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:X.showInlineDetails,description:g.localize(161,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:g.localize(162,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:g.localize(163,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:g.localize(164,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:g.localize(165,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:g.localize(166,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:g.localize(167,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:g.localize(168,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:g.localize(169,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:g.localize(170,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:g.localize(171,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:g.localize(172,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:g.localize(173,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:g.localize(174,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:g.localize(175,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:g.localize(176,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:g.localize(177,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:g.localize(178,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:g.localize(179,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:g.localize(180,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:g.localize(181,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:g.localize(182,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:g.localize(183,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:g.localize(184,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:g.localize(185,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:g.localize(186,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:g.localize(187,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:g.localize(188,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:g.localize(189,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:g.localize(190,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:g.localize(191,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:g.localize(192,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:g.localize(193,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X;return{insertMode:p(pe.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:c(pe.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:c(pe.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:c(pe.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:c(pe.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:p(pe.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:c(pe.showIcons,this.defaultValue.showIcons),showStatusBar:c(pe.showStatusBar,this.defaultValue.showStatusBar),preview:c(pe.preview,this.defaultValue.preview),previewMode:p(pe.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:c(pe.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:c(pe.showMethods,this.defaultValue.showMethods),showFunctions:c(pe.showFunctions,this.defaultValue.showFunctions),showConstructors:c(pe.showConstructors,this.defaultValue.showConstructors),showDeprecated:c(pe.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:c(pe.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:c(pe.showFields,this.defaultValue.showFields),showVariables:c(pe.showVariables,this.defaultValue.showVariables),showClasses:c(pe.showClasses,this.defaultValue.showClasses),showStructs:c(pe.showStructs,this.defaultValue.showStructs),showInterfaces:c(pe.showInterfaces,this.defaultValue.showInterfaces),showModules:c(pe.showModules,this.defaultValue.showModules),showProperties:c(pe.showProperties,this.defaultValue.showProperties),showEvents:c(pe.showEvents,this.defaultValue.showEvents),showOperators:c(pe.showOperators,this.defaultValue.showOperators),showUnits:c(pe.showUnits,this.defaultValue.showUnits),showValues:c(pe.showValues,this.defaultValue.showValues),showConstants:c(pe.showConstants,this.defaultValue.showConstants),showEnums:c(pe.showEnums,this.defaultValue.showEnums),showEnumMembers:c(pe.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:c(pe.showKeywords,this.defaultValue.showKeywords),showWords:c(pe.showWords,this.defaultValue.showWords),showColors:c(pe.showColors,this.defaultValue.showColors),showFiles:c(pe.showFiles,this.defaultValue.showFiles),showReferences:c(pe.showReferences,this.defaultValue.showReferences),showFolders:c(pe.showFolders,this.defaultValue.showFolders),showTypeParameters:c(pe.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:c(pe.showSnippets,this.defaultValue.showSnippets),showUsers:c(pe.showUsers,this.defaultValue.showUsers),showIssues:c(pe.showIssues,this.defaultValue.showIssues)}}}class Oe extends k{constructor(){super(113,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:g.localize(194,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:g.localize(195,null),default:!0,type:"boolean"}})}validate(X){return!X||typeof X!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:c(X.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:c(X.selectSubwords,this.defaultValue.selectSubwords)}}}var Ve;(function(Y){Y[Y.None=0]="None",Y[Y.Same=1]="Same",Y[Y.Indent=2]="Indent",Y[Y.DeepIndent=3]="DeepIndent"})(Ve||(e.WrappingIndent=Ve={}));class He extends k{constructor(){super(137,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[g.localize(196,null),g.localize(197,null),g.localize(198,null),g.localize(199,null)],description:g.localize(200,null),default:"same"}})}validate(X){switch(X){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(X,pe,We){return pe.get(2)===2?0:We}}class xe extends ${constructor(){super(145)}compute(X,pe,We){const Xe=pe.get(144);return{isDominatedByLongLines:X.isDominatedByLongLines,isWordWrapMinified:Xe.isWordWrapMinified,isViewportWrapping:Xe.isViewportWrapping,wrappingColumn:Xe.wrappingColumn}}}class tt extends k{constructor(){const X={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",X,{"editor.dropIntoEditor.enabled":{type:"boolean",default:X.enabled,markdownDescription:g.localize(201,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:g.localize(202,null),enum:["afterDrop","never"],enumDescriptions:[g.localize(203,null),g.localize(204,null)],default:"afterDrop"}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X;return{enabled:c(pe.enabled,this.defaultValue.enabled),showDropSelector:p(pe.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class lt extends k{constructor(){const X={enabled:!0,showPasteSelector:"afterPaste"};super(85,"pasteAs",X,{"editor.pasteAs.enabled":{type:"boolean",default:X.enabled,markdownDescription:g.localize(205,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:g.localize(206,null),enum:["afterPaste","never"],enumDescriptions:[g.localize(207,null),g.localize(208,null)],default:"afterPaste"}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X;return{enabled:c(pe.enabled,this.defaultValue.enabled),showPasteSelector:p(pe.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const rt="Consolas, 'Courier New', monospace",it="Menlo, Monaco, 'Courier New', monospace",ot="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:P.$j?it:P.$k?ot:rt,fontWeight:"normal",fontSize:P.$j?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Be(Y){return e.editorOptionsRegistry[Y.id]=Y,Y}var et;(function(Y){Y[Y.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",Y[Y.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",Y[Y.accessibilitySupport=2]="accessibilitySupport",Y[Y.accessibilityPageSize=3]="accessibilityPageSize",Y[Y.ariaLabel=4]="ariaLabel",Y[Y.ariaRequired=5]="ariaRequired",Y[Y.autoClosingBrackets=6]="autoClosingBrackets",Y[Y.autoClosingComments=7]="autoClosingComments",Y[Y.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",Y[Y.autoClosingDelete=9]="autoClosingDelete",Y[Y.autoClosingOvertype=10]="autoClosingOvertype",Y[Y.autoClosingQuotes=11]="autoClosingQuotes",Y[Y.autoIndent=12]="autoIndent",Y[Y.automaticLayout=13]="automaticLayout",Y[Y.autoSurround=14]="autoSurround",Y[Y.bracketPairColorization=15]="bracketPairColorization",Y[Y.guides=16]="guides",Y[Y.codeLens=17]="codeLens",Y[Y.codeLensFontFamily=18]="codeLensFontFamily",Y[Y.codeLensFontSize=19]="codeLensFontSize",Y[Y.colorDecorators=20]="colorDecorators",Y[Y.colorDecoratorsLimit=21]="colorDecoratorsLimit",Y[Y.columnSelection=22]="columnSelection",Y[Y.comments=23]="comments",Y[Y.contextmenu=24]="contextmenu",Y[Y.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",Y[Y.cursorBlinking=26]="cursorBlinking",Y[Y.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",Y[Y.cursorStyle=28]="cursorStyle",Y[Y.cursorSurroundingLines=29]="cursorSurroundingLines",Y[Y.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",Y[Y.cursorWidth=31]="cursorWidth",Y[Y.disableLayerHinting=32]="disableLayerHinting",Y[Y.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",Y[Y.domReadOnly=34]="domReadOnly",Y[Y.dragAndDrop=35]="dragAndDrop",Y[Y.dropIntoEditor=36]="dropIntoEditor",Y[Y.emptySelectionClipboard=37]="emptySelectionClipboard",Y[Y.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",Y[Y.extraEditorClassName=39]="extraEditorClassName",Y[Y.fastScrollSensitivity=40]="fastScrollSensitivity",Y[Y.find=41]="find",Y[Y.fixedOverflowWidgets=42]="fixedOverflowWidgets",Y[Y.folding=43]="folding",Y[Y.foldingStrategy=44]="foldingStrategy",Y[Y.foldingHighlight=45]="foldingHighlight",Y[Y.foldingImportsByDefault=46]="foldingImportsByDefault",Y[Y.foldingMaximumRegions=47]="foldingMaximumRegions",Y[Y.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",Y[Y.fontFamily=49]="fontFamily",Y[Y.fontInfo=50]="fontInfo",Y[Y.fontLigatures=51]="fontLigatures",Y[Y.fontSize=52]="fontSize",Y[Y.fontWeight=53]="fontWeight",Y[Y.fontVariations=54]="fontVariations",Y[Y.formatOnPaste=55]="formatOnPaste",Y[Y.formatOnType=56]="formatOnType",Y[Y.glyphMargin=57]="glyphMargin",Y[Y.gotoLocation=58]="gotoLocation",Y[Y.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",Y[Y.hover=60]="hover",Y[Y.inDiffEditor=61]="inDiffEditor",Y[Y.inlineSuggest=62]="inlineSuggest",Y[Y.inlineEdit=63]="inlineEdit",Y[Y.letterSpacing=64]="letterSpacing",Y[Y.lightbulb=65]="lightbulb",Y[Y.lineDecorationsWidth=66]="lineDecorationsWidth",Y[Y.lineHeight=67]="lineHeight",Y[Y.lineNumbers=68]="lineNumbers",Y[Y.lineNumbersMinChars=69]="lineNumbersMinChars",Y[Y.linkedEditing=70]="linkedEditing",Y[Y.links=71]="links",Y[Y.matchBrackets=72]="matchBrackets",Y[Y.minimap=73]="minimap",Y[Y.mouseStyle=74]="mouseStyle",Y[Y.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",Y[Y.mouseWheelZoom=76]="mouseWheelZoom",Y[Y.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",Y[Y.multiCursorModifier=78]="multiCursorModifier",Y[Y.multiCursorPaste=79]="multiCursorPaste",Y[Y.multiCursorLimit=80]="multiCursorLimit",Y[Y.occurrencesHighlight=81]="occurrencesHighlight",Y[Y.overviewRulerBorder=82]="overviewRulerBorder",Y[Y.overviewRulerLanes=83]="overviewRulerLanes",Y[Y.padding=84]="padding",Y[Y.pasteAs=85]="pasteAs",Y[Y.parameterHints=86]="parameterHints",Y[Y.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",Y[Y.definitionLinkOpensInPeek=88]="definitionLinkOpensInPeek",Y[Y.quickSuggestions=89]="quickSuggestions",Y[Y.quickSuggestionsDelay=90]="quickSuggestionsDelay",Y[Y.readOnly=91]="readOnly",Y[Y.readOnlyMessage=92]="readOnlyMessage",Y[Y.renameOnType=93]="renameOnType",Y[Y.renderControlCharacters=94]="renderControlCharacters",Y[Y.renderFinalNewline=95]="renderFinalNewline",Y[Y.renderLineHighlight=96]="renderLineHighlight",Y[Y.renderLineHighlightOnlyWhenFocus=97]="renderLineHighlightOnlyWhenFocus",Y[Y.renderValidationDecorations=98]="renderValidationDecorations",Y[Y.renderWhitespace=99]="renderWhitespace",Y[Y.revealHorizontalRightPadding=100]="revealHorizontalRightPadding",Y[Y.roundedSelection=101]="roundedSelection",Y[Y.rulers=102]="rulers",Y[Y.scrollbar=103]="scrollbar",Y[Y.scrollBeyondLastColumn=104]="scrollBeyondLastColumn",Y[Y.scrollBeyondLastLine=105]="scrollBeyondLastLine",Y[Y.scrollPredominantAxis=106]="scrollPredominantAxis",Y[Y.selectionClipboard=107]="selectionClipboard",Y[Y.selectionHighlight=108]="selectionHighlight",Y[Y.selectOnLineNumbers=109]="selectOnLineNumbers",Y[Y.showFoldingControls=110]="showFoldingControls",Y[Y.showUnused=111]="showUnused",Y[Y.snippetSuggestions=112]="snippetSuggestions",Y[Y.smartSelect=113]="smartSelect",Y[Y.smoothScrolling=114]="smoothScrolling",Y[Y.stickyScroll=115]="stickyScroll",Y[Y.stickyTabStops=116]="stickyTabStops",Y[Y.stopRenderingLineAfter=117]="stopRenderingLineAfter",Y[Y.suggest=118]="suggest",Y[Y.suggestFontSize=119]="suggestFontSize",Y[Y.suggestLineHeight=120]="suggestLineHeight",Y[Y.suggestOnTriggerCharacters=121]="suggestOnTriggerCharacters",Y[Y.suggestSelection=122]="suggestSelection",Y[Y.tabCompletion=123]="tabCompletion",Y[Y.tabIndex=124]="tabIndex",Y[Y.unicodeHighlighting=125]="unicodeHighlighting",Y[Y.unusualLineTerminators=126]="unusualLineTerminators",Y[Y.useShadowDOM=127]="useShadowDOM",Y[Y.useTabStops=128]="useTabStops",Y[Y.wordBreak=129]="wordBreak",Y[Y.wordSeparators=130]="wordSeparators",Y[Y.wordWrap=131]="wordWrap",Y[Y.wordWrapBreakAfterCharacters=132]="wordWrapBreakAfterCharacters",Y[Y.wordWrapBreakBeforeCharacters=133]="wordWrapBreakBeforeCharacters",Y[Y.wordWrapColumn=134]="wordWrapColumn",Y[Y.wordWrapOverride1=135]="wordWrapOverride1",Y[Y.wordWrapOverride2=136]="wordWrapOverride2",Y[Y.wrappingIndent=137]="wrappingIndent",Y[Y.wrappingStrategy=138]="wrappingStrategy",Y[Y.showDeprecated=139]="showDeprecated",Y[Y.inlayHints=140]="inlayHints",Y[Y.editorClassName=141]="editorClassName",Y[Y.pixelRatio=142]="pixelRatio",Y[Y.tabFocusMode=143]="tabFocusMode",Y[Y.layoutInfo=144]="layoutInfo",Y[Y.wrappingInfo=145]="wrappingInfo",Y[Y.defaultColorDecorators=146]="defaultColorDecorators",Y[Y.colorDecoratorsActivatedOn=147]="colorDecoratorsActivatedOn",Y[Y.inlineCompletionsAccessibilityVerbose=148]="inlineCompletionsAccessibilityVerbose"})(et||(e.EditorOption=et={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Be(new t(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:g.localize(209,null)})),acceptSuggestionOnEnter:Be(new u(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",g.localize(210,null),""],markdownDescription:g.localize(211,null)})),accessibilitySupport:Be(new w),accessibilityPageSize:Be(new r(3,"accessibilityPageSize",10,1,1073741824,{description:g.localize(212,null),tags:["accessibility"]})),ariaLabel:Be(new i(4,"ariaLabel",g.localize(213,null))),ariaRequired:Be(new t(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:Be(new t(8,"screenReaderAnnounceInlineSuggestion",!0,{description:g.localize(214,null),tags:["accessibility"]})),autoClosingBrackets:Be(new u(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",g.localize(215,null),g.localize(216,null),""],description:g.localize(217,null)})),autoClosingComments:Be(new u(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",g.localize(218,null),g.localize(219,null),""],description:g.localize(220,null)})),autoClosingDelete:Be(new u(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",g.localize(221,null),""],description:g.localize(222,null)})),autoClosingOvertype:Be(new u(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",g.localize(223,null),""],description:g.localize(224,null)})),autoClosingQuotes:Be(new u(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",g.localize(225,null),g.localize(226,null),""],description:g.localize(227,null)})),autoIndent:Be(new o(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],E,{enumDescriptions:[g.localize(228,null),g.localize(229,null),g.localize(230,null),g.localize(231,null),g.localize(232,null)],description:g.localize(233,null)})),automaticLayout:Be(new t(13,"automaticLayout",!1)),autoSurround:Be(new u(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[g.localize(234,null),g.localize(235,null),g.localize(236,null),""],description:g.localize(237,null)})),bracketPairColorization:Be(new K),bracketPairGuides:Be(new H),stickyTabStops:Be(new t(116,"stickyTabStops",!1,{description:g.localize(238,null)})),codeLens:Be(new t(17,"codeLens",!0,{description:g.localize(239,null)})),codeLensFontFamily:Be(new i(18,"codeLensFontFamily","",{description:g.localize(240,null)})),codeLensFontSize:Be(new r(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:g.localize(241,null)})),colorDecorators:Be(new t(20,"colorDecorators",!0,{description:g.localize(242,null)})),colorDecoratorActivatedOn:Be(new u(147,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[g.localize(243,null),g.localize(244,null),g.localize(245,null)],description:g.localize(246,null)})),colorDecoratorsLimit:Be(new r(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:g.localize(247,null)})),columnSelection:Be(new t(22,"columnSelection",!1,{description:g.localize(248,null)})),comments:Be(new m),contextmenu:Be(new t(24,"contextmenu",!0)),copyWithSyntaxHighlighting:Be(new t(25,"copyWithSyntaxHighlighting",!0,{description:g.localize(249,null)})),cursorBlinking:Be(new o(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],d,{description:g.localize(250,null)})),cursorSmoothCaretAnimation:Be(new u(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[g.localize(251,null),g.localize(252,null),g.localize(253,null)],description:g.localize(254,null)})),cursorStyle:Be(new o(28,"cursorStyle",y.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],A,{description:g.localize(255,null)})),cursorSurroundingLines:Be(new r(29,"cursorSurroundingLines",0,0,1073741824,{description:g.localize(256,null)})),cursorSurroundingLinesStyle:Be(new u(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[g.localize(257,null),g.localize(258,null)],markdownDescription:g.localize(259,null)})),cursorWidth:Be(new r(31,"cursorWidth",0,0,1073741824,{markdownDescription:g.localize(260,null)})),disableLayerHinting:Be(new t(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:Be(new t(33,"disableMonospaceOptimizations",!1)),domReadOnly:Be(new t(34,"domReadOnly",!1)),dragAndDrop:Be(new t(35,"dragAndDrop",!0,{description:g.localize(261,null)})),emptySelectionClipboard:Be(new G),dropIntoEditor:Be(new tt),stickyScroll:Be(new ee),experimentalWhitespaceRendering:Be(new u(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[g.localize(262,null),g.localize(263,null),g.localize(264,null)],description:g.localize(265,null)})),extraEditorClassName:Be(new i(39,"extraEditorClassName","")),fastScrollSensitivity:Be(new h(40,"fastScrollSensitivity",5,Y=>Y<=0?5:Y,{markdownDescription:g.localize(266,null)})),find:Be(new W),fixedOverflowWidgets:Be(new t(42,"fixedOverflowWidgets",!1)),folding:Be(new t(43,"folding",!0,{description:g.localize(267,null)})),foldingStrategy:Be(new u(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[g.localize(268,null),g.localize(269,null)],description:g.localize(270,null)})),foldingHighlight:Be(new t(45,"foldingHighlight",!0,{description:g.localize(271,null)})),foldingImportsByDefault:Be(new t(46,"foldingImportsByDefault",!1,{description:g.localize(272,null)})),foldingMaximumRegions:Be(new r(47,"foldingMaximumRegions",5e3,10,65e3,{description:g.localize(273,null)})),unfoldOnClickAfterEndOfLine:Be(new t(48,"unfoldOnClickAfterEndOfLine",!1,{description:g.localize(274,null)})),fontFamily:Be(new i(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:g.localize(275,null)})),fontInfo:Be(new O),fontLigatures2:Be(new U),fontSize:Be(new V),fontWeight:Be(new re),fontVariations:Be(new C),formatOnPaste:Be(new t(55,"formatOnPaste",!1,{description:g.localize(276,null)})),formatOnType:Be(new t(56,"formatOnType",!1,{description:g.localize(277,null)})),glyphMargin:Be(new t(57,"glyphMargin",!0,{description:g.localize(278,null)})),gotoLocation:Be(new ue),hideCursorInOverviewRuler:Be(new t(59,"hideCursorInOverviewRuler",!1,{description:g.localize(279,null)})),hover:Be(new ye),inDiffEditor:Be(new t(61,"inDiffEditor",!1)),letterSpacing:Be(new h(64,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,Y=>h.clamp(Y,-5,20),{description:g.localize(280,null)})),lightbulb:Be(new $e),lineDecorationsWidth:Be(new q),lineHeight:Be(new ne),lineNumbers:Be(new le),lineNumbersMinChars:Be(new r(69,"lineNumbersMinChars",5,1,300)),linkedEditing:Be(new t(70,"linkedEditing",!1,{description:g.localize(281,null)})),links:Be(new t(71,"links",!0,{description:g.localize(282,null)})),matchBrackets:Be(new u(72,"matchBrackets","always",["always","near","never"],{description:g.localize(283,null)})),minimap:Be(new Se),mouseStyle:Be(new u(74,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Be(new h(75,"mouseWheelScrollSensitivity",1,Y=>Y===0?1:Y,{markdownDescription:g.localize(284,null)})),mouseWheelZoom:Be(new t(76,"mouseWheelZoom",!1,{markdownDescription:P.$j?g.localize(285,null):g.localize(286,null)})),multiCursorMergeOverlapping:Be(new t(77,"multiCursorMergeOverlapping",!0,{description:g.localize(287,null)})),multiCursorModifier:Be(new o(78,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],Te,{markdownEnumDescriptions:[g.localize(288,null),g.localize(289,null)],markdownDescription:g.localize(290,null)})),multiCursorPaste:Be(new u(79,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[g.localize(291,null),g.localize(292,null)],markdownDescription:g.localize(293,null)})),multiCursorLimit:Be(new r(80,"multiCursorLimit",1e4,1,1e5,{markdownDescription:g.localize(294,null)})),occurrencesHighlight:Be(new u(81,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[g.localize(295,null),g.localize(296,null),g.localize(297,null)],markdownDescription:g.localize(298,null)})),overviewRulerBorder:Be(new t(82,"overviewRulerBorder",!0,{description:g.localize(299,null)})),overviewRulerLanes:Be(new r(83,"overviewRulerLanes",3,0,3)),padding:Be(new Ce),pasteAs:Be(new lt),parameterHints:Be(new we),peekWidgetDefaultFocus:Be(new u(87,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[g.localize(300,null),g.localize(301,null)],description:g.localize(302,null)})),definitionLinkOpensInPeek:Be(new t(88,"definitionLinkOpensInPeek",!1,{description:g.localize(303,null)})),quickSuggestions:Be(new J),quickSuggestionsDelay:Be(new r(90,"quickSuggestionsDelay",10,0,1073741824,{description:g.localize(304,null)})),readOnly:Be(new t(91,"readOnly",!1)),readOnlyMessage:Be(new me),renameOnType:Be(new t(93,"renameOnType",!1,{description:g.localize(305,null),markdownDeprecationMessage:g.localize(306,null)})),renderControlCharacters:Be(new t(94,"renderControlCharacters",!0,{description:g.localize(307,null),restricted:!0})),renderFinalNewline:Be(new u(95,"renderFinalNewline",P.$k?"dimmed":"on",["off","on","dimmed"],{description:g.localize(308,null)})),renderLineHighlight:Be(new u(96,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",g.localize(309,null)],description:g.localize(310,null)})),renderLineHighlightOnlyWhenFocus:Be(new t(97,"renderLineHighlightOnlyWhenFocus",!1,{description:g.localize(311,null)})),renderValidationDecorations:Be(new u(98,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Be(new u(99,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",g.localize(312,null),g.localize(313,null),g.localize(314,null),""],description:g.localize(315,null)})),revealHorizontalRightPadding:Be(new r(100,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Be(new t(101,"roundedSelection",!0,{description:g.localize(316,null)})),rulers:Be(new Pe),scrollbar:Be(new Me),scrollBeyondLastColumn:Be(new r(104,"scrollBeyondLastColumn",4,0,1073741824,{description:g.localize(317,null)})),scrollBeyondLastLine:Be(new t(105,"scrollBeyondLastLine",!0,{description:g.localize(318,null)})),scrollPredominantAxis:Be(new t(106,"scrollPredominantAxis",!0,{description:g.localize(319,null)})),selectionClipboard:Be(new t(107,"selectionClipboard",!0,{description:g.localize(320,null),included:P.$k})),selectionHighlight:Be(new t(108,"selectionHighlight",!0,{description:g.localize(321,null)})),selectOnLineNumbers:Be(new t(109,"selectOnLineNumbers",!0)),showFoldingControls:Be(new u(110,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[g.localize(322,null),g.localize(323,null),g.localize(324,null)],description:g.localize(325,null)})),showUnused:Be(new t(111,"showUnused",!0,{description:g.localize(326,null)})),showDeprecated:Be(new t(139,"showDeprecated",!0,{description:g.localize(327,null)})),inlayHints:Be(new Q),snippetSuggestions:Be(new u(112,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[g.localize(328,null),g.localize(329,null),g.localize(330,null),g.localize(331,null)],description:g.localize(332,null)})),smartSelect:Be(new Oe),smoothScrolling:Be(new t(114,"smoothScrolling",!1,{description:g.localize(333,null)})),stopRenderingLineAfter:Be(new r(117,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Be(new oe),inlineSuggest:Be(new N),inlineEdit:Be(new z),inlineCompletionsAccessibilityVerbose:Be(new t(148,"inlineCompletionsAccessibilityVerbose",!1,{description:g.localize(334,null)})),suggestFontSize:Be(new r(119,"suggestFontSize",0,0,1e3,{markdownDescription:g.localize(335,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Be(new r(120,"suggestLineHeight",0,0,1e3,{markdownDescription:g.localize(336,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Be(new t(121,"suggestOnTriggerCharacters",!0,{description:g.localize(337,null)})),suggestSelection:Be(new u(122,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[g.localize(338,null),g.localize(339,null),g.localize(340,null)],description:g.localize(341,null)})),tabCompletion:Be(new u(123,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[g.localize(342,null),g.localize(343,null),g.localize(344,null)],description:g.localize(345,null)})),tabIndex:Be(new r(124,"tabIndex",0,-1,1073741824)),unicodeHighlight:Be(new ze),unusualLineTerminators:Be(new u(126,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[g.localize(346,null),g.localize(347,null),g.localize(348,null)],description:g.localize(349,null)})),useShadowDOM:Be(new t(127,"useShadowDOM",!0)),useTabStops:Be(new t(128,"useTabStops",!0,{description:g.localize(350,null)})),wordBreak:Be(new u(129,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[g.localize(351,null),g.localize(352,null)],description:g.localize(353,null)})),wordSeparators:Be(new i(130,"wordSeparators",R.$Es,{description:g.localize(354,null)})),wordWrap:Be(new u(131,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[g.localize(355,null),g.localize(356,null),g.localize(357,null),g.localize(358,null)],description:g.localize(359,null)})),wordWrapBreakAfterCharacters:Be(new i(132,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Be(new i(133,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Be(new r(134,"wordWrapColumn",80,1,1073741824,{markdownDescription:g.localize(360,null)})),wordWrapOverride1:Be(new u(135,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Be(new u(136,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Be(new T),defaultColorDecorators:Be(new t(146,"defaultColorDecorators",!1,{markdownDescription:g.localize(361,null)})),pixelRatio:Be(new ge),tabFocusMode:Be(new t(143,"tabFocusMode",!1,{markdownDescription:g.localize(362,null)})),layoutInfo:Be(new he),wrappingInfo:Be(new xe),wrappingIndent:Be(new He),wrappingStrategy:Be(new ve)}}),define(Re[149],Ae([9,10]),function(fe,e){return fe.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Re[150],Ae([9,10]),function(fe,e){return fe.create("vs/platform/contextkey/common/contextkey",e)}),define(Re[151],Ae([9,10]),function(fe,e){return fe.create("vs/platform/contextkey/common/scanner",e)}),define(Re[152],Ae([9,10]),function(fe,e){return fe.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Re[153],Ae([9,10]),function(fe,e){return fe.create("vs/platform/extensions/common/extensionValidator",e)}),define(Re[154],Ae([9,10]),function(fe,e){return fe.create("vs/platform/files/common/files",e)}),define(Re[155],Ae([9,10]),function(fe,e){return fe.create("vs/platform/markers/common/markers",e)}),define(Re[156],Ae([9,10]),function(fe,e){return fe.create("vs/platform/theme/common/iconRegistry",e)}),define(Re[157],Ae([9,10]),function(fe,e){return fe.create("vs/platform/workspace/common/workspace",e)}),define(Re[158],Ae([9,10]),function(fe,e){return fe.create("vs/workbench/api/common/extHostChatAgents2",e)}),define(Re[159],Ae([9,10]),function(fe,e){return fe.create("vs/workbench/api/common/extHostChatProvider",e)}),define(Re[160],Ae([9,10]),function(fe,e){return fe.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Re[161],Ae([9,10]),function(fe,e){return fe.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Re[162],Ae([9,10]),function(fe,e){return fe.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(Re[163],Ae([9,10]),function(fe,e){return fe.create("vs/workbench/api/common/extHostLogService",e)}),define(Re[164],Ae([9,10]),function(fe,e){return fe.create("vs/workbench/api/common/extHostNotebook",e)}),define(Re[165],Ae([9,10]),function(fe,e){return fe.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Re[166],Ae([9,10]),function(fe,e){return fe.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Re[167],Ae([9,10]),function(fe,e){return fe.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Re[168],Ae([9,10]),function(fe,e){return fe.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Re[169],Ae([9,10]),function(fe,e){return fe.create("vs/workbench/api/common/extHostTunnelService",e)}),define(Re[170],Ae([9,10]),function(fe,e){return fe.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Re[171],Ae([9,10]),function(fe,e){return fe.create("vs/workbench/common/configuration",e)}),define(Re[172],Ae([9,10]),function(fe,e){return fe.create("vs/workbench/common/editor",e)}),define(Re[173],Ae([9,10]),function(fe,e){return fe.create("vs/workbench/common/views",e)}),define(Re[174],Ae([9,10]),function(fe,e){return fe.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Re[175],Ae([9,10]),function(fe,e){return fe.create("vs/workbench/contrib/debug/common/debug",e)}),define(Re[176],Ae([9,10]),function(fe,e){return fe.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Re[177],Ae([9,10]),function(fe,e){return fe.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Re[178],Ae([9,10]),function(fe,e){return fe.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Re[179],Ae([9,10]),function(fe,e){return fe.create("vs/workbench/services/editor/common/editorResolverService",e)}),define(Re[180],Ae([9,10]),function(fe,e){return fe.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Re[181],Ae([9,10]),function(fe,e){return fe.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Re[182],Ae([1,0,15,151]),function(fe,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_i=e.TokenType=void 0;var P;(function(D){D[D.LParen=0]="LParen",D[D.RParen=1]="RParen",D[D.Neg=2]="Neg",D[D.Eq=3]="Eq",D[D.NotEq=4]="NotEq",D[D.Lt=5]="Lt",D[D.LtEq=6]="LtEq",D[D.Gt=7]="Gt",D[D.GtEq=8]="GtEq",D[D.RegexOp=9]="RegexOp",D[D.RegexStr=10]="RegexStr",D[D.True=11]="True",D[D.False=12]="False",D[D.In=13]="In",D[D.Not=14]="Not",D[D.And=15]="And",D[D.Or=16]="Or",D[D.Str=17]="Str",D[D.QuotedStr=18]="QuotedStr",D[D.Error=19]="Error",D[D.EOF=20]="EOF"})(P||(e.TokenType=P={}));function L(...D){switch(D.length){case 1:return(0,F.localize)(0,null,D[0]);case 2:return(0,F.localize)(1,null,D[0],D[1]);case 3:return(0,F.localize)(2,null,D[0],D[1],D[2]);default:return}}const R=(0,F.localize)(3,null),g=(0,F.localize)(4,null);class f{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(M){switch(M.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return M.isTripleEq?"===":"==";case 4:return M.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return M.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return M.lexeme;case 18:return M.lexeme;case 19:return M.lexeme;case 20:return"EOF";default:throw(0,S.$8)(`unhandled token type: ${JSON.stringify(M)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(M=>M.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(M){return this.c=M,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const k=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:k})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const k=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:k})}else this.h(126)?this.k(9):this.l(L("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(L("&&"));break;case 124:this.h(124)?this.k(16):this.l(L("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(M){return this.r()||this.c.charCodeAt(this.e)!==M?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(M){this.f.push({type:M,offset:this.d})}l(M){const k=this.d,l=this.c.substring(this.d,this.e),v={type:19,offset:this.d,lexeme:l};this.g.push({offset:k,lexeme:l,additionalInfo:M}),this.f.push(v)}n(){this.m.lastIndex=this.d;const M=this.m.exec(this.c);if(M){this.e=this.d+M[0].length;const k=this.c.substring(this.d,this.e),l=f.b.get(k);l?this.k(l):this.f.push({type:17,lexeme:k,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(R);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let M=this.e,k=!1,l=!1;for(;;){if(M>=this.c.length){this.e=M,this.l(g);return}const $=this.c.charCodeAt(M);if(k)k=!1;else if($===47&&!l){M++;break}else $===91?l=!0:$===92?k=!0:$===93&&(l=!1);M++}for(;M<this.c.length&&f.a.has(this.c.charCodeAt(M));)M++;this.e=M;const v=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:v,offset:this.d})}r(){return this.e>=this.c.length}}e.$_i=f}),define(Re[183],Ae([1,0,25,32,153,297]),function(fe,e,S,F,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rp=e.$qp=e.$pp=e.$op=e.$np=e.$mp=e.$lp=void 0;const R=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,g=/^-(\d{4})(\d{2})(\d{2})$/;function f(t){return t=t.trim(),t==="*"||R.test(t)}e.$lp=f;function D(t){if(!f(t))return null;if(t=t.trim(),t==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const n=t.match(R);return n?{hasCaret:n[1]==="^",hasGreaterEquals:n[1]===">=",majorBase:n[2]==="x"?0:parseInt(n[2],10),majorMustEqual:n[2]!=="x",minorBase:n[4]==="x"?0:parseInt(n[4],10),minorMustEqual:n[4]!=="x",patchBase:n[6]==="x"?0:parseInt(n[6],10),patchMustEqual:n[6]!=="x",preRelease:n[8]||null}:null}e.$mp=D;function M(t){if(!t)return null;const n=t.majorBase,r=t.majorMustEqual,a=t.minorBase;let h=t.minorMustEqual;const i=t.patchBase;let p=t.patchMustEqual;t.hasCaret&&(n===0||(h=!1),p=!1);let u=0;if(t.preRelease){const o=g.exec(t.preRelease);if(o){const[,E,w,m]=o;u=Date.UTC(Number(E),Number(w)-1,Number(m))}}return{majorBase:n,majorMustEqual:r,minorBase:a,minorMustEqual:h,patchBase:i,patchMustEqual:p,isMinimum:t.hasGreaterEquals,notBefore:u}}e.$np=M;function k(t,n,r){let a;typeof t=="string"?a=M(D(t)):a=t;let h;n instanceof Date?h=n.getTime():typeof n=="string"&&(h=new Date(n).getTime());let i;if(typeof r=="string"?i=M(D(r)):i=r,!a||!i)return!1;const p=a.majorBase,u=a.minorBase,o=a.patchBase;let E=i.majorBase,w=i.minorBase,m=i.patchBase;const I=i.notBefore;let d=i.majorMustEqual,y=i.minorMustEqual,b=i.patchMustEqual;return i.isMinimum?p>E?!0:p<E?!1:u>w?!0:u<w||h&&h<I?!1:o>=m:(p===1&&E===0&&(!d||!y||!b)&&(E=1,w=0,m=0,d=!0,y=!1,b=!1),p<E?!1:p>E?!d:u<w?!1:u>w?!y:o<m?!1:o>m?!b:!(h&&h<I))}e.$op=k;function l(t,n,r,a,h){const i=[];if(typeof a.publisher<"u"&&typeof a.publisher!="string")return i.push([F.default.Error,P.localize(0,null)]),i;if(typeof a.name!="string")return i.push([F.default.Error,P.localize(1,null,"name")]),i;if(typeof a.version!="string")return i.push([F.default.Error,P.localize(2,null,"version")]),i;if(!a.engines)return i.push([F.default.Error,P.localize(3,null,"engines")]),i;if(typeof a.engines.vscode!="string")return i.push([F.default.Error,P.localize(4,null,"engines.vscode")]),i;if(typeof a.extensionDependencies<"u"&&!c(a.extensionDependencies))return i.push([F.default.Error,P.localize(5,null,"extensionDependencies")]),i;if(typeof a.activationEvents<"u"){if(!c(a.activationEvents))return i.push([F.default.Error,P.localize(6,null,"activationEvents")]),i;if(typeof a.main>"u"&&typeof a.browser>"u")return i.push([F.default.Error,P.localize(7,null,"activationEvents","main","browser")]),i}if(typeof a.extensionKind<"u"&&typeof a.main>"u"&&i.push([F.default.Warning,P.localize(8,null,"extensionKind")]),typeof a.main<"u"){if(typeof a.main!="string")return i.push([F.default.Error,P.localize(9,null,"main")]),i;{const o=(0,S.$Rg)(r,a.main);(0,S.$Lg)(o,r)||i.push([F.default.Warning,P.localize(10,null,o.path,r.path)])}}if(typeof a.browser<"u"){if(typeof a.browser!="string")return i.push([F.default.Error,P.localize(11,null,"browser")]),i;{const o=(0,S.$Rg)(r,a.browser);(0,S.$Lg)(o,r)||i.push([F.default.Warning,P.localize(12,null,o.path,r.path)])}}if(!L.valid(a.version))return i.push([F.default.Error,P.localize(13,null)]),i;const p=[];if(!v(t,n,a,h,p))for(const o of p)i.push([F.default.Error,o]);return i}e.$pp=l;function v(t,n,r,a,h){return a||typeof r.main>"u"&&typeof r.browser>"u"?!0:s(t,n,r.engines.vscode,h)}e.$qp=v;function $(t,n,r){return t==="*"||s(n,r,t)}e.$rp=$;function s(t,n,r,a=[]){const h=M(D(r));if(!h)return a.push(P.localize(14,null,r)),!1;if(h.majorBase===0){if(!h.majorMustEqual||!h.minorMustEqual)return a.push(P.localize(15,null,r)),!1}else if(!h.majorMustEqual)return a.push(P.localize(16,null,r)),!1;return k(t,n,h)?!0:(a.push(P.localize(17,null,t,r)),!1)}function c(t){if(!Array.isArray(t))return!1;for(let n=0,r=t.length;n<r;n++)if(typeof t[n]!="string")return!1;return!0}}),define(Re[70],Ae([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bi=void 0;class S{constructor(P,L=[],R=!1){this.ctor=P,this.staticArguments=L,this.supportsDelayedInstantiation=R}}e.$bi=S}),define(Re[54],Ae([1,0,70]),function(fe,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$r=e.$0r=e.InstantiationType=void 0;const F=[];var P;(function(g){g[g.Eager=0]="Eager",g[g.Delayed=1]="Delayed"})(P||(e.InstantiationType=P={}));function L(g,f,D){f instanceof S.$bi||(f=new S.$bi(f,[],!!D)),F.push([g,f])}e.$0r=L;function R(){return F}e.$$r=R}),define(Re[184],Ae([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oq=e.$Nq=void 0;class S{constructor(L,R){this.key=L,this.data=R,this.incoming=new Map,this.outgoing=new Map}}e.$Nq=S;class F{constructor(L){this.b=L,this.a=new Map}roots(){const L=[];for(const R of this.a.values())R.outgoing.size===0&&L.push(R);return L}insertEdge(L,R){const g=this.lookupOrInsertNode(L),f=this.lookupOrInsertNode(R);g.outgoing.set(f.key,f),f.incoming.set(g.key,g)}removeNode(L){const R=this.b(L);this.a.delete(R);for(const g of this.a.values())g.outgoing.delete(R),g.incoming.delete(R)}lookupOrInsertNode(L){const R=this.b(L);let g=this.a.get(R);return g||(g=new S(R,L),this.a.set(R,g)),g}lookup(L){return this.a.get(this.b(L))}isEmpty(){return this.a.size===0}toString(){const L=[];for(const[R,g]of this.a)L.push(`${R}
	(-> incoming)[${[...g.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...g.outgoing.keys()].join(",")}]
`);return L.join(`
`)}findCycleSlow(){for(const[L,R]of this.a){const g=new Set([L]),f=this.c(R,g);if(f)return f}}c(L,R){for(const[g,f]of L.outgoing){if(R.has(g))return[...R,g].join(" -> ");R.add(g);const D=this.c(f,R);if(D)return D;R.delete(g)}}}e.$Oq=F}),define(Re[4],Ae([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fi=e.$ei=e.$di=e._util=void 0;var S;(function(R){R.serviceIds=new Map,R.DI_TARGET="$di$target",R.DI_DEPENDENCIES="$di$dependencies";function g(f){return f[R.DI_DEPENDENCIES]||[]}R.getServiceDependencies=g})(S||(e._util=S={})),e.$di=P("instantiationService");function F(R,g,f){g[S.DI_TARGET]===g?g[S.DI_DEPENDENCIES].push({id:R,index:f}):(g[S.DI_DEPENDENCIES]=[{id:R,index:f}],g[S.DI_TARGET]=g)}function P(R){if(S.serviceIds.has(R))return S.serviceIds.get(R);const g=function(f,D,M){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");F(g,f,M)};return g.toString=()=>R,S.serviceIds.set(R,g),g}e.$ei=P;function L(R){return R}e.$fi=L}),define(Re[46],Ae([1,0,16,2,4]),function(fe,e,S,F,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ui=e.$Ti=e.$Si=e.$Ri=e.$Qi=e.$Pi=e.$Oi=e.$Ni=e.ConfigurationTarget=e.$Mi=e.$Li=e.$Ki=void 0,e.$Ki=(0,P.$ei)("configurationService");function L(t){return t&&typeof t=="object"&&(!t.overrideIdentifier||typeof t.overrideIdentifier=="string")&&(!t.resource||t.resource instanceof F.URI)}e.$Li=L;function R(t){return t&&typeof t=="object"&&(!t.overrideIdentifiers||Array.isArray(t.overrideIdentifiers))&&!t.overrideIdentifier&&(!t.resource||t.resource instanceof F.URI)}e.$Mi=R;var g;(function(t){t[t.APPLICATION=1]="APPLICATION",t[t.USER=2]="USER",t[t.USER_LOCAL=3]="USER_LOCAL",t[t.USER_REMOTE=4]="USER_REMOTE",t[t.WORKSPACE=5]="WORKSPACE",t[t.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",t[t.DEFAULT=7]="DEFAULT",t[t.MEMORY=8]="MEMORY"})(g||(e.ConfigurationTarget=g={}));function f(t){switch(t){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$Ni=f;function D(t){return t.applicationValue!==void 0||t.userValue!==void 0||t.userLocalValue!==void 0||t.userRemoteValue!==void 0||t.workspaceValue!==void 0||t.workspaceFolderValue!==void 0}e.$Oi=D;function M(t,n){const r=Object.create(null);for(const a in t)k(r,a,t[a],n);return r}e.$Pi=M;function k(t,n,r,a){const h=n.split("."),i=h.pop();let p=t;for(let u=0;u<h.length;u++){const o=h[u];let E=p[o];switch(typeof E){case"undefined":E=p[o]=Object.create(null);break;case"object":break;default:a(`Ignoring ${n} as ${h.slice(0,u+1).join(".")} is ${JSON.stringify(E)}`);return}p=E}if(typeof p=="object"&&p!==null)try{p[i]=r}catch{a(`Ignoring ${n} as ${h.join(".")} is ${JSON.stringify(p)}`)}else a(`Ignoring ${n} as ${h.join(".")} is ${JSON.stringify(p)}`)}e.$Qi=k;function l(t,n){const r=n.split(".");v(t,r)}e.$Ri=l;function v(t,n){const r=n.shift();if(n.length===0){delete t[r];return}if(Object.keys(t).indexOf(r)!==-1){const a=t[r];typeof a=="object"&&!Array.isArray(a)&&(v(a,n),Object.keys(a).length===0&&delete t[r])}}function $(t,n,r){function a(p,u){let o=p;for(const E of u){if(typeof o!="object"||o===null)return;o=o[E]}return o}const h=n.split("."),i=a(t,h);return typeof i>"u"?r:i}e.$Si=$;function s(t,n,r){Object.keys(n).forEach(a=>{a!=="__proto__"&&(a in t?S.$Uf(t[a])&&S.$Uf(n[a])?s(t[a],n[a],r):r&&(t[a]=n[a]):t[a]=n[a])})}e.$Ti=s;function c(t){return t.replace(/[\[\]]/g,"")}e.$Ui=c}),define(Re[36],Ae([1,0,21,13,182,4,150,15]),function(fe,e,S,F,P,L,R,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=e.$oj=e.$nj=e.$mj=e.$lj=e.$kj=e.$jj=e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=e.ContextKeyExprType=e.$aj=void 0;const f=new Map;f.set("false",!1),f.set("true",!0),f.set("isMac",S.$j),f.set("isLinux",S.$k),f.set("isWindows",S.$i),f.set("isWeb",S.$o),f.set("isMacNative",S.$j&&!S.$o),f.set("isEdge",S.$H),f.set("isFirefox",S.$F),f.set("isChrome",S.$E),f.set("isSafari",S.$G);function D(Q,q){if(f.get(Q)!==void 0)throw(0,g.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");f.set(Q,q)}e.$aj=D;const M=Object.prototype.hasOwnProperty;var k;(function(Q){Q[Q.False=0]="False",Q[Q.True=1]="True",Q[Q.Defined=2]="Defined",Q[Q.Not=3]="Not",Q[Q.Equals=4]="Equals",Q[Q.NotEquals=5]="NotEquals",Q[Q.And=6]="And",Q[Q.Regex=7]="Regex",Q[Q.NotRegex=8]="NotRegex",Q[Q.Or=9]="Or",Q[Q.In=10]="In",Q[Q.NotIn=11]="NotIn",Q[Q.Greater=12]="Greater",Q[Q.GreaterEquals=13]="GreaterEquals",Q[Q.Smaller=14]="Smaller",Q[Q.SmallerEquals=15]="SmallerEquals"})(k||(e.ContextKeyExprType=k={}));const l={regexParsingWithErrorRecovery:!0},v=(0,R.localize)(0,null),$=(0,R.localize)(1,null),s=(0,R.localize)(2,null),c=(0,R.localize)(3,null),t=(0,R.localize)(4,null),n=(0,R.localize)(5,null),r=(0,R.localize)(6,null),a=(0,R.localize)(7,null);class h{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(q=l){this.k=q,this.d=new P.$_i,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(q){if(q===""){this.h.push({message:v,offset:0,lexeme:"",additionalInfo:$});return}this.f=this.d.reset(q).scan(),this.g=0,this.h=[];try{const ne=this.l();if(!this.E()){const Se=this.D(),Te=Se.type===17?n:void 0;throw this.h.push({message:t,offset:Se.offset,lexeme:P.$_i.getLexeme(Se),additionalInfo:Te}),h.c}return ne}catch(ne){if(ne!==h.c)throw ne;return}}l(){return this.m()}m(){const q=[this.o()];for(;this.y(16);){const ne=this.o();q.push(ne)}return q.length===1?q[0]:i.or(...q)}o(){const q=[this.s()];for(;this.y(15);){const ne=this.s();q.push(ne)}return q.length===1?q[0]:i.and(...q)}s(){if(this.y(2)){const q=this.D();switch(q.type){case 11:return this.z(),E.INSTANCE;case 12:return this.z(),w.INSTANCE;case 0:{this.z();const ne=this.l();return this.A(1,c),ne?.negate()}case 17:return this.z(),A.create(q.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",q)}}return this.t()}t(){const q=this.D();switch(q.type){case 11:return this.z(),i.true();case 12:return this.z(),i.false();case 0:{this.z();const ne=this.l();return this.A(1,c),ne}case 17:{const ne=q.lexeme;if(this.z(),this.y(9)){const Te=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),Te.type!==10)throw this.B("REGEX",Te);const Ce=Te.lexeme,we=Ce.lastIndexOf("/"),ge=we===Ce.length-1?void 0:this.w(Ce.substring(we+1));let J;try{J=new RegExp(Ce.substring(1,we),ge)}catch{throw this.B("REGEX",Te)}return O.create(ne,J)}switch(Te.type){case 10:case 19:{const Ce=[Te.lexeme];this.z();let we=this.D(),ge=0;for(let Pe=0;Pe<Te.lexeme.length;Pe++)Te.lexeme.charCodeAt(Pe)===40?ge++:Te.lexeme.charCodeAt(Pe)===41&&ge--;for(;!this.E()&&we.type!==15&&we.type!==16;){switch(we.type){case 0:ge++;break;case 1:ge--;break;case 10:case 18:for(let Pe=0;Pe<we.lexeme.length;Pe++)we.lexeme.charCodeAt(Pe)===40?ge++:Te.lexeme.charCodeAt(Pe)===41&&ge--}if(ge<0)break;Ce.push(P.$_i.getLexeme(we)),this.z(),we=this.D()}const J=Ce.join(""),x=J.lastIndexOf("/"),le=x===J.length-1?void 0:this.w(J.substring(x+1));let de;try{de=new RegExp(J.substring(1,x),le)}catch{throw this.B("REGEX",Te)}return i.regex(ne,de)}case 18:{const Ce=Te.lexeme;this.z();let we=null;if(!(0,F.$Se)(Ce)){const ge=Ce.indexOf("/"),J=Ce.lastIndexOf("/");if(ge!==J&&ge>=0){const x=Ce.slice(ge+1,J),le=Ce[J+1]==="i"?"i":"";try{we=new RegExp(x,le)}catch{throw this.B("REGEX",Te)}}}if(we===null)throw this.B("REGEX",Te);return O.create(ne,we)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,s);const Te=this.u();return i.notIn(ne,Te)}switch(this.D().type){case 3:{this.z();const Te=this.u();if(this.x().type===18)return i.equals(ne,Te);switch(Te){case"true":return i.has(ne);case"false":return i.not(ne);default:return i.equals(ne,Te)}}case 4:{this.z();const Te=this.u();if(this.x().type===18)return i.notEquals(ne,Te);switch(Te){case"true":return i.not(ne);case"false":return i.has(ne);default:return i.notEquals(ne,Te)}}case 5:return this.z(),U.create(ne,this.u());case 6:return this.z(),C.create(ne,this.u());case 7:return this.z(),G.create(ne,this.u());case 8:return this.z(),W.create(ne,this.u());case 13:return this.z(),i.in(ne,this.u());default:return i.has(ne)}}case 20:throw this.h.push({message:r,offset:q.offset,lexeme:"",additionalInfo:a}),h.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const q=this.D();switch(q.type){case 17:case 18:return this.z(),q.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(q){return q.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(q){return this.C(q)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(q,ne){if(this.C(q))return this.z();throw this.B(ne,this.D())}B(q,ne,Se){const Te=(0,R.localize)(8,null,q,P.$_i.getLexeme(ne)),Ce=ne.offset,we=P.$_i.getLexeme(ne);return this.h.push({message:Te,offset:Ce,lexeme:we,additionalInfo:Se}),h.c}C(q){return this.D().type===q}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$bj=h;class i{static false(){return E.INSTANCE}static true(){return w.INSTANCE}static has(q){return m.create(q)}static equals(q,ne){return I.create(q,ne)}static notEquals(q,ne){return b.create(q,ne)}static regex(q,ne){return O.create(q,ne)}static in(q,ne){return d.create(q,ne)}static notIn(q,ne){return y.create(q,ne)}static not(q){return A.create(q)}static and(...q){return ue.create(q,null,!0)}static or(...q){return ye.create(q,null,!0)}static greater(q,ne){return G.create(q,ne)}static greaterEquals(q,ne){return W.create(q,ne)}static smaller(q,ne){return U.create(q,ne)}static smallerEquals(q,ne){return C.create(q,ne)}static{this.c=new h({regexParsingWithErrorRecovery:!1})}static deserialize(q){return q==null?void 0:this.c.parse(q)}}e.$cj=i;function p(Q){const q=new h({regexParsingWithErrorRecovery:!1});return Q.map(ne=>(q.parse(ne),q.lexingErrors.length>0?q.lexingErrors.map(Se=>({errorMessage:Se.additionalInfo?(0,R.localize)(9,null,Se.additionalInfo):(0,R.localize)(10,null),offset:Se.offset,length:Se.lexeme.length})):q.parsingErrors.length>0?q.parsingErrors.map(Se=>({errorMessage:Se.additionalInfo?`${Se.message}. ${Se.additionalInfo}`:Se.message,offset:Se.offset,length:Se.lexeme.length})):[]))}e.$dj=p;function u(Q,q){const ne=Q?Q.substituteConstants():void 0,Se=q?q.substituteConstants():void 0;return!ne&&!Se?!0:!ne||!Se?!1:ne.equals(Se)}e.$ej=u;function o(Q,q){return Q.cmp(q)}class E{static{this.INSTANCE=new E}constructor(){this.type=0}cmp(q){return this.type-q.type}equals(q){return q.type===this.type}substituteConstants(){return this}evaluate(q){return!1}serialize(){return"false"}keys(){return[]}map(q){return this}negate(){return w.INSTANCE}}e.$fj=E;class w{static{this.INSTANCE=new w}constructor(){this.type=1}cmp(q){return this.type-q.type}equals(q){return q.type===this.type}substituteConstants(){return this}evaluate(q){return!0}serialize(){return"true"}keys(){return[]}map(q){return this}negate(){return E.INSTANCE}}e.$gj=w;class m{static create(q,ne=null){const Se=f.get(q);return typeof Se=="boolean"?Se?w.INSTANCE:E.INSTANCE:new m(q,ne)}constructor(q,ne){this.key=q,this.c=ne,this.type=2}cmp(q){return q.type!==this.type?this.type-q.type:he(this.key,q.key)}equals(q){return q.type===this.type?this.key===q.key:!1}substituteConstants(){const q=f.get(this.key);return typeof q=="boolean"?q?w.INSTANCE:E.INSTANCE:this}evaluate(q){return!!q.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(q){return q.mapDefined(this.key)}negate(){return this.c||(this.c=A.create(this.key,this)),this.c}}e.$hj=m;class I{static create(q,ne,Se=null){if(typeof ne=="boolean")return ne?m.create(q,Se):A.create(q,Se);const Te=f.get(q);return typeof Te=="boolean"?ne===(Te?"true":"false")?w.INSTANCE:E.INSTANCE:new I(q,ne,Se)}constructor(q,ne,Se){this.c=q,this.d=ne,this.f=Se,this.type=4}cmp(q){return q.type!==this.type?this.type-q.type:ve(this.c,this.d,q.c,q.d)}equals(q){return q.type===this.type?this.c===q.c&&this.d===q.d:!1}substituteConstants(){const q=f.get(this.c);if(typeof q=="boolean"){const ne=q?"true":"false";return this.d===ne?w.INSTANCE:E.INSTANCE}return this}evaluate(q){return q.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(q){return q.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=b.create(this.c,this.d,this)),this.f}}e.$ij=I;class d{static create(q,ne){return new d(q,ne)}constructor(q,ne){this.d=q,this.f=ne,this.type=10,this.c=null}cmp(q){return q.type!==this.type?this.type-q.type:ve(this.d,this.f,q.d,q.f)}equals(q){return q.type===this.type?this.d===q.d&&this.f===q.f:!1}substituteConstants(){return this}evaluate(q){const ne=q.getValue(this.f),Se=q.getValue(this.d);return Array.isArray(ne)?ne.includes(Se):typeof Se=="string"&&typeof ne=="object"&&ne!==null?M.call(ne,Se):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(q){return q.mapIn(this.d,this.f)}negate(){return this.c||(this.c=y.create(this.d,this.f)),this.c}}e.$jj=d;class y{static create(q,ne){return new y(q,ne)}constructor(q,ne){this.d=q,this.f=ne,this.type=11,this.c=d.create(q,ne)}cmp(q){return q.type!==this.type?this.type-q.type:this.c.cmp(q.c)}equals(q){return q.type===this.type?this.c.equals(q.c):!1}substituteConstants(){return this}evaluate(q){return!this.c.evaluate(q)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(q){return q.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$kj=y;class b{static create(q,ne,Se=null){if(typeof ne=="boolean")return ne?A.create(q,Se):m.create(q,Se);const Te=f.get(q);return typeof Te=="boolean"?ne===(Te?"true":"false")?E.INSTANCE:w.INSTANCE:new b(q,ne,Se)}constructor(q,ne,Se){this.c=q,this.d=ne,this.f=Se,this.type=5}cmp(q){return q.type!==this.type?this.type-q.type:ve(this.c,this.d,q.c,q.d)}equals(q){return q.type===this.type?this.c===q.c&&this.d===q.d:!1}substituteConstants(){const q=f.get(this.c);if(typeof q=="boolean"){const ne=q?"true":"false";return this.d===ne?E.INSTANCE:w.INSTANCE}return this}evaluate(q){return q.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(q){return q.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=I.create(this.c,this.d,this)),this.f}}e.$lj=b;class A{static create(q,ne=null){const Se=f.get(q);return typeof Se=="boolean"?Se?E.INSTANCE:w.INSTANCE:new A(q,ne)}constructor(q,ne){this.c=q,this.d=ne,this.type=3}cmp(q){return q.type!==this.type?this.type-q.type:he(this.c,q.c)}equals(q){return q.type===this.type?this.c===q.c:!1}substituteConstants(){const q=f.get(this.c);return typeof q=="boolean"?q?E.INSTANCE:w.INSTANCE:this}evaluate(q){return!q.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(q){return q.mapNot(this.c)}negate(){return this.d||(this.d=m.create(this.c,this)),this.d}}e.$mj=A;function T(Q,q){if(typeof Q=="string"){const ne=parseFloat(Q);isNaN(ne)||(Q=ne)}return typeof Q=="string"||typeof Q=="number"?q(Q):E.INSTANCE}class G{static create(q,ne,Se=null){return T(ne,Te=>new G(q,Te,Se))}constructor(q,ne,Se){this.c=q,this.d=ne,this.f=Se,this.type=12}cmp(q){return q.type!==this.type?this.type-q.type:ve(this.c,this.d,q.c,q.d)}equals(q){return q.type===this.type?this.c===q.c&&this.d===q.d:!1}substituteConstants(){return this}evaluate(q){return typeof this.d=="string"?!1:parseFloat(q.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(q){return q.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=C.create(this.c,this.d,this)),this.f}}e.$nj=G;class W{static create(q,ne,Se=null){return T(ne,Te=>new W(q,Te,Se))}constructor(q,ne,Se){this.c=q,this.d=ne,this.f=Se,this.type=13}cmp(q){return q.type!==this.type?this.type-q.type:ve(this.c,this.d,q.c,q.d)}equals(q){return q.type===this.type?this.c===q.c&&this.d===q.d:!1}substituteConstants(){return this}evaluate(q){return typeof this.d=="string"?!1:parseFloat(q.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(q){return q.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=U.create(this.c,this.d,this)),this.f}}e.$oj=W;class U{static create(q,ne,Se=null){return T(ne,Te=>new U(q,Te,Se))}constructor(q,ne,Se){this.c=q,this.d=ne,this.f=Se,this.type=14}cmp(q){return q.type!==this.type?this.type-q.type:ve(this.c,this.d,q.c,q.d)}equals(q){return q.type===this.type?this.c===q.c&&this.d===q.d:!1}substituteConstants(){return this}evaluate(q){return typeof this.d=="string"?!1:parseFloat(q.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(q){return q.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=W.create(this.c,this.d,this)),this.f}}e.$pj=U;class C{static create(q,ne,Se=null){return T(ne,Te=>new C(q,Te,Se))}constructor(q,ne,Se){this.c=q,this.d=ne,this.f=Se,this.type=15}cmp(q){return q.type!==this.type?this.type-q.type:ve(this.c,this.d,q.c,q.d)}equals(q){return q.type===this.type?this.c===q.c&&this.d===q.d:!1}substituteConstants(){return this}evaluate(q){return typeof this.d=="string"?!1:parseFloat(q.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(q){return q.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=G.create(this.c,this.d,this)),this.f}}e.$qj=C;class O{static create(q,ne){return new O(q,ne)}constructor(q,ne){this.d=q,this.f=ne,this.type=7,this.c=null}cmp(q){if(q.type!==this.type)return this.type-q.type;if(this.d<q.d)return-1;if(this.d>q.d)return 1;const ne=this.f?this.f.source:"",Se=q.f?q.f.source:"";return ne<Se?-1:ne>Se?1:0}equals(q){if(q.type===this.type){const ne=this.f?this.f.source:"",Se=q.f?q.f.source:"";return this.d===q.d&&ne===Se}return!1}substituteConstants(){return this}evaluate(q){const ne=q.getValue(this.d);return this.f?this.f.test(ne):!1}serialize(){const q=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${q}`}keys(){return[this.d]}map(q){return q.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=V.create(this)),this.c}}e.$rj=O;class V{static create(q){return new V(q)}constructor(q){this.c=q,this.type=8}cmp(q){return q.type!==this.type?this.type-q.type:this.c.cmp(q.c)}equals(q){return q.type===this.type?this.c.equals(q.c):!1}substituteConstants(){return this}evaluate(q){return!this.c.evaluate(q)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(q){return new V(this.c.map(q))}negate(){return this.c}}e.$sj=V;function re(Q){let q=null;for(let ne=0,Se=Q.length;ne<Se;ne++){const Te=Q[ne].substituteConstants();if(Q[ne]!==Te&&q===null){q=[];for(let Ce=0;Ce<ne;Ce++)q[Ce]=Q[Ce]}q!==null&&(q[ne]=Te)}return q===null?Q:q}class ue{static create(q,ne,Se){return ue.d(q,ne,Se)}constructor(q,ne){this.expr=q,this.c=ne,this.type=6}cmp(q){if(q.type!==this.type)return this.type-q.type;if(this.expr.length<q.expr.length)return-1;if(this.expr.length>q.expr.length)return 1;for(let ne=0,Se=this.expr.length;ne<Se;ne++){const Te=o(this.expr[ne],q.expr[ne]);if(Te!==0)return Te}return 0}equals(q){if(q.type===this.type){if(this.expr.length!==q.expr.length)return!1;for(let ne=0,Se=this.expr.length;ne<Se;ne++)if(!this.expr[ne].equals(q.expr[ne]))return!1;return!0}return!1}substituteConstants(){const q=re(this.expr);return q===this.expr?this:ue.create(q,this.c,!1)}evaluate(q){for(let ne=0,Se=this.expr.length;ne<Se;ne++)if(!this.expr[ne].evaluate(q))return!1;return!0}static d(q,ne,Se){const Te=[];let Ce=!1;for(const we of q)if(we){if(we.type===1){Ce=!0;continue}if(we.type===0)return E.INSTANCE;if(we.type===6){Te.push(...we.expr);continue}Te.push(we)}if(Te.length===0&&Ce)return w.INSTANCE;if(Te.length!==0){if(Te.length===1)return Te[0];Te.sort(o);for(let we=1;we<Te.length;we++)Te[we-1].equals(Te[we])&&(Te.splice(we,1),we--);if(Te.length===1)return Te[0];for(;Te.length>1;){const we=Te[Te.length-1];if(we.type!==9)break;Te.pop();const ge=Te.pop(),J=Te.length===0,x=ye.create(we.expr.map(le=>ue.create([le,ge],null,Se)),null,J);x&&(Te.push(x),Te.sort(o))}if(Te.length===1)return Te[0];if(Se){for(let we=0;we<Te.length;we++)for(let ge=we+1;ge<Te.length;ge++)if(Te[we].negate().equals(Te[ge]))return E.INSTANCE;if(Te.length===1)return Te[0]}return new ue(Te,ne)}}serialize(){return this.expr.map(q=>q.serialize()).join(" && ")}keys(){const q=[];for(const ne of this.expr)q.push(...ne.keys());return q}map(q){return new ue(this.expr.map(ne=>ne.map(q)),null)}negate(){if(!this.c){const q=[];for(const ne of this.expr)q.push(ne.negate());this.c=ye.create(q,this,!0)}return this.c}}e.$tj=ue;class ye{static create(q,ne,Se){return ye.d(q,ne,Se)}constructor(q,ne){this.expr=q,this.c=ne,this.type=9}cmp(q){if(q.type!==this.type)return this.type-q.type;if(this.expr.length<q.expr.length)return-1;if(this.expr.length>q.expr.length)return 1;for(let ne=0,Se=this.expr.length;ne<Se;ne++){const Te=o(this.expr[ne],q.expr[ne]);if(Te!==0)return Te}return 0}equals(q){if(q.type===this.type){if(this.expr.length!==q.expr.length)return!1;for(let ne=0,Se=this.expr.length;ne<Se;ne++)if(!this.expr[ne].equals(q.expr[ne]))return!1;return!0}return!1}substituteConstants(){const q=re(this.expr);return q===this.expr?this:ye.create(q,this.c,!1)}evaluate(q){for(let ne=0,Se=this.expr.length;ne<Se;ne++)if(this.expr[ne].evaluate(q))return!0;return!1}static d(q,ne,Se){let Te=[],Ce=!1;if(q){for(let we=0,ge=q.length;we<ge;we++){const J=q[we];if(J){if(J.type===0){Ce=!0;continue}if(J.type===1)return w.INSTANCE;if(J.type===9){Te=Te.concat(J.expr);continue}Te.push(J)}}if(Te.length===0&&Ce)return E.INSTANCE;Te.sort(o)}if(Te.length!==0){if(Te.length===1)return Te[0];for(let we=1;we<Te.length;we++)Te[we-1].equals(Te[we])&&(Te.splice(we,1),we--);if(Te.length===1)return Te[0];if(Se){for(let we=0;we<Te.length;we++)for(let ge=we+1;ge<Te.length;ge++)if(Te[we].negate().equals(Te[ge]))return w.INSTANCE;if(Te.length===1)return Te[0]}return new ye(Te,ne)}}serialize(){return this.expr.map(q=>q.serialize()).join(" || ")}keys(){const q=[];for(const ne of this.expr)q.push(...ne.keys());return q}map(q){return new ye(this.expr.map(ne=>ne.map(q)),null)}negate(){if(!this.c){const q=[];for(const ne of this.expr)q.push(ne.negate());for(;q.length>1;){const ne=q.shift(),Se=q.shift(),Te=[];for(const Ce of ee(ne))for(const we of ee(Se))Te.push(ue.create([Ce,we],null,!1));q.unshift(ye.create(Te,null,!1))}this.c=ye.create(q,this,!0)}return this.c}}e.$uj=ye;class De extends m{static{this.d=[]}static all(){return De.d.values()}constructor(q,ne,Se){super(q,null),this.f=ne,typeof Se=="object"?De.d.push({...Se,key:q}):Se!==!0&&De.d.push({key:q,description:Se,type:ne!=null?typeof ne:void 0})}bindTo(q){return q.createKey(this.key,this.f)}getValue(q){return q.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(q){return I.create(this.key,q)}notEqualsTo(q){return b.create(this.key,q)}}e.$vj=De,e.$wj=(0,L.$ei)("contextKeyService");function he(Q,q){return Q<q?-1:Q>q?1:0}function ve(Q,q,ne,Se){return Q<ne?-1:Q>ne?1:q<Se?-1:q>Se?1:0}function se(Q,q){if(Q.type===0||q.type===1)return!0;if(Q.type===9)return q.type===9?$e(Q.expr,q.expr):!1;if(q.type===9){for(const ne of q.expr)if(se(Q,ne))return!0;return!1}if(Q.type===6){if(q.type===6)return $e(q.expr,Q.expr);for(const ne of Q.expr)if(se(ne,q))return!0;return!1}return Q.equals(q)}e.$xj=se;function $e(Q,q){let ne=0,Se=0;for(;ne<Q.length&&Se<q.length;){const Te=Q[ne].cmp(q[Se]);if(Te<0)return!1;Te===0&&ne++,Se++}return ne===Q.length}function ee(Q){return Q.type===9?Q.expr:[Q]}}),define(Re[185],Ae([1,0,4]),function(fe,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mi=e.$li=void 0,e.$li=(0,S.$ei)("environmentService"),e.$mi=(0,S.$fi)(e.$li)}),define(Re[96],Ae([1,0,152,4]),function(fe,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$To=e.$So=e.$Ro=e.$Qo=e.$Po=e.$Oo=e.$No=e.$Mo=e.ExtensionGalleryErrorCode=e.$Lo=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$Ko=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$Jo=e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=void 0,e.$yo="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$zo=new RegExp(e.$yo),e.$Ao="__web_extension",e.$Bo="skipWalkthrough",e.$Co="extensionsSync",e.$Do="dependecyOrPackExtensionInstall";function P(r){switch(r){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$Eo=P;function L(r){switch(r){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$Fo=L;function R(r,a){switch(r){case 3:return a==="x64"?"win32-x64":a==="arm64"?"win32-arm64":"unknown";case 2:return a==="x64"?"linux-x64":a==="arm64"?"linux-arm64":a==="arm"?"linux-armhf":"unknown";case"alpine":return a==="x64"?"alpine-x64":a==="arm64"?"alpine-arm64":"unknown";case 1:return a==="x64"?"darwin-x64":a==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$Go=R;function g(r,a){return a==="web"&&!r.includes("web")}e.$Ho=g;function f(r,a,h){return g(a,h)?!1:r==="undefined"||r==="universal"?!0:r==="unknown"?!1:r===h}e.$Io=f;function D(r){return r&&typeof r=="object"&&typeof r.id=="string"&&(!r.uuid||typeof r.uuid=="string")}e.$Jo=D;var M;(function(r){r[r.NoneOrRelevance=0]="NoneOrRelevance",r[r.LastUpdatedDate=1]="LastUpdatedDate",r[r.Title=2]="Title",r[r.PublisherName=3]="PublisherName",r[r.InstallCount=4]="InstallCount",r[r.PublishedDate=10]="PublishedDate",r[r.AverageRating=6]="AverageRating",r[r.WeightedRating=12]="WeightedRating"})(M||(e.SortBy=M={}));var k;(function(r){r[r.Default=0]="Default",r[r.Ascending=1]="Ascending",r[r.Descending=2]="Descending"})(k||(e.SortOrder=k={}));var l;(function(r){r.Install="install",r.Uninstall="uninstall"})(l||(e.StatisticType=l={}));var v;(function(r){r[r.None=1]="None",r[r.Install=2]="Install",r[r.Update=3]="Update",r[r.Migrate=4]="Migrate"})(v||(e.InstallOperation=v={})),e.$Ko=(0,F.$ei)("extensionGalleryService");var $;(function(r){r.Unsupported="Unsupported",r.Deprecated="Deprecated",r.Malicious="Malicious",r.Incompatible="Incompatible",r.IncompatibleTargetPlatform="IncompatibleTargetPlatform",r.ReleaseVersionNotFound="ReleaseVersionNotFound",r.Invalid="Invalid",r.Download="Download",r.DownloadSignature="DownloadSignature",r.UpdateMetadata="UpdateMetadata",r.Extract="Extract",r.Scanning="Scanning",r.Delete="Delete",r.Rename="Rename",r.CorruptZip="CorruptZip",r.IncompleteZip="IncompleteZip",r.Signature="Signature",r.NotAllowed="NotAllowed",r.Gallery="Gallery",r.Unknown="Unknown",r.Internal="Internal"})($||(e.ExtensionManagementErrorCode=$={}));var s;(function(r){r.UnknownError="UnknownError",r.PackageIsInvalidZip="PackageIsInvalidZip",r.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(s||(e.ExtensionSignaturetErrorCode=s={}));class c extends Error{constructor(a,h){super(a),this.code=h,this.name=h}}e.$Lo=c;var t;(function(r){r.Timeout="Timeout",r.Cancelled="Cancelled",r.Failed="Failed"})(t||(e.ExtensionGalleryErrorCode=t={}));class n extends Error{constructor(a,h){super(a),this.code=h,this.name=h}}e.$Mo=n,e.$No=(0,F.$ei)("extensionManagementService"),e.$Oo="extensionsIdentifiers/disabled",e.$Po="extensionsIdentifiers/enabled",e.$Qo=(0,F.$ei)("IGlobalExtensionEnablementService"),e.$Ro=(0,F.$ei)("IExtensionTipsService"),e.$So=(0,S.localize2)(0,"Extensions"),e.$To=(0,S.localize2)(1,"Preferences")}),define(Re[42],Ae([1,0,50,19,13,16,2,154,4,21,12,40]),function(fe,e,S,F,P,L,R,g,f,D,M,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$k=e.$0k=e.$9k=e.$8k=e.$7k=e.FileKind=e.$6k=e.$5k=e.$4k=e.$3k=e.$2k=e.$1k=e.$Zk=e.FileOperationResult=e.$Yk=e.$Xk=e.$Wk=e.$Vk=e.$Uk=e.FileChangeType=e.$Tk=e.FileOperation=e.$Sk=e.$Rk=e.$Qk=e.$Pk=e.$Ok=e.$Nk=e.FileSystemProviderErrorCode=e.$Mk=e.$Lk=e.$Kk=e.$Jk=e.$Ik=e.$Hk=e.$Gk=e.$Fk=e.$Ek=e.FileSystemProviderCapabilities=e.$Dk=e.FilePermission=e.FileType=e.$Ck=e.$Bk=void 0,e.$Bk=(0,f.$ei)("fileService");function l(se){return se.create===!0}e.$Ck=l;var v;(function(se){se[se.Unknown=0]="Unknown",se[se.File=1]="File",se[se.Directory=2]="Directory",se[se.SymbolicLink=64]="SymbolicLink"})(v||(e.FileType=v={}));var $;(function(se){se[se.Readonly=1]="Readonly",se[se.Locked=2]="Locked"})($||(e.FilePermission=$={}));function s(se){const $e=se;return!!$e&&typeof $e.onDidChange=="function"}e.$Dk=s;var c;(function(se){se[se.None=0]="None",se[se.FileReadWrite=2]="FileReadWrite",se[se.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",se[se.FileReadStream=16]="FileReadStream",se[se.FileFolderCopy=8]="FileFolderCopy",se[se.PathCaseSensitive=1024]="PathCaseSensitive",se[se.Readonly=2048]="Readonly",se[se.Trash=4096]="Trash",se[se.FileWriteUnlock=8192]="FileWriteUnlock",se[se.FileAtomicRead=16384]="FileAtomicRead",se[se.FileAtomicWrite=32768]="FileAtomicWrite",se[se.FileAtomicDelete=65536]="FileAtomicDelete",se[se.FileClone=131072]="FileClone"})(c||(e.FileSystemProviderCapabilities=c={}));function t(se){return!!(se.capabilities&2)}e.$Ek=t;function n(se){return!!(se.capabilities&8)}e.$Fk=n;function r(se){return!!(se.capabilities&131072)}e.$Gk=r;function a(se){return!!(se.capabilities&4)}e.$Hk=a;function h(se){return!!(se.capabilities&16)}e.$Ik=h;function i(se){return t(se)?!!(se.capabilities&16384):!1}e.$Jk=i;function p(se){return t(se)?!!(se.capabilities&32768):!1}e.$Kk=p;function u(se){return!!(se.capabilities&65536)}e.$Lk=u;function o(se){return!!(se.capabilities&2048)}e.$Mk=o;var E;(function(se){se.FileExists="EntryExists",se.FileNotFound="EntryNotFound",se.FileNotADirectory="EntryNotADirectory",se.FileIsADirectory="EntryIsADirectory",se.FileExceedsStorageQuota="EntryExceedsStorageQuota",se.FileTooLarge="EntryTooLarge",se.FileWriteLocked="EntryWriteLocked",se.NoPermissions="NoPermissions",se.Unavailable="Unavailable",se.Unknown="Unknown"})(E||(e.FileSystemProviderErrorCode=E={}));class w extends Error{static create($e,ee){const Q=new w($e.toString(),ee);return d(Q,ee),Q}constructor($e,ee){super($e),this.code=ee}}e.$Nk=w;function m(se,$e){return w.create(se,$e)}e.$Ok=m;function I(se){return se||m((0,g.localize)(0,null),E.Unknown)}e.$Pk=I;function d(se,$e){return se.name=$e?`${$e} (FileSystemError)`:"FileSystemError",se}e.$Qk=d;function y(se){if(!se)return E.Unknown;if(se instanceof w)return se.code;const $e=/^(.+) \(FileSystemError\)$/.exec(se.name);if(!$e)return E.Unknown;switch($e[1]){case E.FileExists:return E.FileExists;case E.FileIsADirectory:return E.FileIsADirectory;case E.FileNotADirectory:return E.FileNotADirectory;case E.FileNotFound:return E.FileNotFound;case E.FileTooLarge:return E.FileTooLarge;case E.FileWriteLocked:return E.FileWriteLocked;case E.NoPermissions:return E.NoPermissions;case E.Unavailable:return E.Unavailable}return E.Unknown}e.$Rk=y;function b(se){if(se instanceof C)return se.fileOperationResult;switch(y(se)){case E.FileNotFound:return 1;case E.FileIsADirectory:return 0;case E.FileNotADirectory:return 9;case E.FileWriteLocked:return 5;case E.NoPermissions:return 6;case E.FileExists:return 4;case E.FileTooLarge:return 7;default:return 10}}e.$Sk=b;var A;(function(se){se[se.CREATE=0]="CREATE",se[se.DELETE=1]="DELETE",se[se.MOVE=2]="MOVE",se[se.COPY=3]="COPY",se[se.WRITE=4]="WRITE"})(A||(e.FileOperation=A={}));class T{constructor($e,ee,Q){this.resource=$e,this.operation=ee,this.target=Q}isOperation($e){return this.operation===$e}}e.$Tk=T;var G;(function(se){se[se.UPDATED=0]="UPDATED",se[se.ADDED=1]="ADDED",se[se.DELETED=2]="DELETED"})(G||(e.FileChangeType=G={}));class W{static{this.a=null}constructor($e,ee){this.c=ee,this.b=void 0,this.d=new k.$V(()=>{const Q=S.$ki.forUris(()=>this.c);return Q.fill(this.rawAdded.map(q=>[q,!0])),Q}),this.f=new k.$V(()=>{const Q=S.$ki.forUris(()=>this.c);return Q.fill(this.rawUpdated.map(q=>[q,!0])),Q}),this.g=new k.$V(()=>{const Q=S.$ki.forUris(()=>this.c);return Q.fill(this.rawDeleted.map(q=>[q,!0])),Q}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const Q of $e){switch(Q.type){case 1:this.rawAdded.push(Q.resource);break;case 0:this.rawUpdated.push(Q.resource);break;case 2:this.rawDeleted.push(Q.resource);break}this.b!==W.a&&(typeof Q.cId=="number"?this.b===void 0?this.b=Q.cId:this.b!==Q.cId&&(this.b=W.a):this.b!==void 0&&(this.b=W.a))}}contains($e,...ee){return this.h($e,{includeChildren:!1},...ee)}affects($e,...ee){return this.h($e,{includeChildren:!0},...ee)}h($e,ee,...Q){if(!$e)return!1;const q=Q.length>0;return!!((!q||Q.includes(1))&&(this.d.value.get($e)||ee.includeChildren&&this.d.value.findSuperstr($e))||(!q||Q.includes(0))&&(this.f.value.get($e)||ee.includeChildren&&this.f.value.findSuperstr($e))||(!q||Q.includes(2))&&(this.g.value.findSubstr($e)||ee.includeChildren&&this.g.value.findSuperstr($e)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates($e){return this.b===$e}hasCorrelation(){return typeof this.b=="number"}}e.$Uk=W;function U(se,$e,ee){return!se||!$e||se===$e||$e.length>se.length?!1:($e.charAt($e.length-1)!==F.sep&&($e+=F.sep),ee?(0,P.$kf)(se,$e):se.indexOf($e)===0)}e.$Vk=U;class C extends Error{constructor($e,ee,Q){super($e),this.fileOperationResult=ee,this.options=Q}}e.$Wk=C;class O extends C{constructor($e,ee,Q,q){super($e,ee,q),this.fileOperationResult=ee,this.size=Q}}e.$Xk=O;class V extends C{constructor($e,ee,Q){super($e,2,Q),this.stat=ee}}e.$Yk=V;var re;(function(se){se[se.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",se[se.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",se[se.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",se[se.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",se[se.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",se[se.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",se[se.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",se[se.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",se[se.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",se[se.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",se[se.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(re||(e.FileOperationResult=re={})),e.$Zk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$1k={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$2k="files.associations",e.$3k="files.exclude",e.$4k="files.readonlyInclude",e.$5k="files.readonlyExclude",e.$6k="files.readonlyFromPermissions";var ue;(function(se){se[se.FILE=0]="FILE",se[se.FOLDER=1]="FOLDER",se[se.ROOT_FOLDER=2]="ROOT_FOLDER"})(ue||(e.FileKind=ue={})),e.$7k="";function ye(se){if(!(typeof se.size!="number"||typeof se.mtime!="number"))return se.mtime.toString(29)+se.size.toString(31)}e.$8k=ye;async function De(se,$e){if(!$e.hasProvider(R.URI.from({scheme:se.scheme})))return new Promise(ee=>{const Q=$e.onDidChangeFileSystemProviderRegistrations(q=>{q.scheme===se.scheme&&q.added&&(Q.dispose(),ee())})})}e.$9k=De;class he{static{this.KB=1024}static{this.MB=he.KB*he.KB}static{this.GB=he.MB*he.KB}static{this.TB=he.GB*he.KB}static formatSize($e){return(0,L.$Wf)($e)||($e=0),$e<he.KB?(0,g.localize)(1,null,$e.toFixed(0)):$e<he.MB?(0,g.localize)(2,null,($e/he.KB).toFixed(2)):$e<he.GB?(0,g.localize)(3,null,($e/he.MB).toFixed(2)):$e<he.TB?(0,g.localize)(4,null,($e/he.GB).toFixed(2)):(0,g.localize)(5,null,($e/he.TB).toFixed(2))}}e.$0k=he;function ve(se){const $e=typeof se=="string"||se?.scheme===M.Schemas.vscodeRemote;return typeof se!="string"&&se?.scheme===M.Schemas.file?1024*he.MB:$e?10*he.MB:D.$o?50*he.MB:1024*he.MB}e.$$k=ve}),define(Re[71],Ae([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ci=void 0;class S{constructor(...P){this.a=new Map;for(const[L,R]of P)this.set(L,R)}set(P,L){const R=this.a.get(P);return this.a.set(P,L),R}has(P){return this.a.has(P)}get(P){return this.a.get(P)}}e.$ci=S}),define(Re[186],Ae([1,0,11,15,6,70,184,4,71,187]),function(fe,e,S,F,P,L,R,g,f,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qq=e.$Pq=void 0;const M=!1;class k extends Error{constructor(c){super("cyclic dependency between services"),this.message=c.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${c.toString()}`}}class l{constructor(c=new f.$ci,t=!1,n,r=M){this.f=c,this.g=t,this.h=n,this.i=r,this.o=new Set,this.f.set(g.$di,this),this._globalGraph=r?n?._globalGraph??new R.$Oq(a=>a):void 0}createChild(c){return new l(c,this.g,this,this.i)}invokeFunction(c,...t){const n=$.traceInvocation(this.i,c);let r=!1;try{return c({get:h=>{if(r)throw(0,F.$8)("service accessor is only valid during the invocation of its target method");const i=this.m(h,n);if(!i)throw new Error(`[invokeFunction] unknown service '${h}'`);return i}},...t)}finally{r=!0,n.stop()}}createInstance(c,...t){let n,r;return c instanceof L.$bi?(n=$.traceCreation(this.i,c.ctor),r=this.j(c.ctor,c.staticArguments.concat(t),n)):(n=$.traceCreation(this.i,c),r=this.j(c,t,n)),n.stop(),r}j(c,t=[],n){const r=g._util.getServiceDependencies(c).sort((i,p)=>i.index-p.index),a=[];for(const i of r){const p=this.m(i.id,n);p||this.u(`[createInstance] ${c.name} depends on UNKNOWN service ${i.id}.`,!1),a.push(p)}const h=r.length>0?r[0].index:t.length;if(t.length!==h){console.trace(`[createInstance] First service dependency of ${c.name} at position ${h+1} conflicts with ${t.length} static arguments`);const i=h-t.length;i>0?t=t.concat(new Array(i)):t=t.slice(0,h)}return Reflect.construct(c,t.concat(a))}k(c,t){if(this.f.get(c)instanceof L.$bi)this.f.set(c,t);else if(this.h)this.h.k(c,t);else throw new Error("illegalState - setting UNKNOWN service instance")}l(c){const t=this.f.get(c);return!t&&this.h?this.h.l(c):t}m(c,t){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(c));const n=this.l(c);return n instanceof L.$bi?this.q(c,n,t.branch(c,!0)):(t.branch(c,!1),n)}q(c,t,n){if(this.o.has(c))throw new Error(`illegal state - RECURSIVELY instantiating service '${c}'`);this.o.add(c);try{return this.r(c,t,n)}finally{this.o.delete(c)}}r(c,t,n){const r=new R.$Oq(i=>i.id.toString());let a=0;const h=[{id:c,desc:t,_trace:n}];for(;h.length;){const i=h.pop();if(r.lookupOrInsertNode(i),a++>1e3)throw new k(r);for(const p of g._util.getServiceDependencies(i.desc.ctor)){const u=this.l(p.id);if(u||this.u(`[createInstance] ${c} depends on ${p.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String(p.id)),u instanceof L.$bi){const o={id:p.id,desc:u,_trace:i._trace.branch(p.id,!0)};r.insertEdge(i,o),h.push(o)}}}for(;;){const i=r.roots();if(i.length===0){if(!r.isEmpty())throw new k(r);break}for(const{data:p}of i){if(this.l(p.id)instanceof L.$bi){const o=this.s(p.id,p.desc.ctor,p.desc.staticArguments,p.desc.supportsDelayedInstantiation,p._trace);this.k(p.id,o)}r.removeNode(p)}}return this.l(c)}s(c,t,n=[],r,a){if(this.f.get(c)instanceof L.$bi)return this.t(c,t,n,r,a);if(this.h)return this.h.s(c,t,n,r,a);throw new Error(`illegalState - creating UNKNOWN service instance ${t.name}`)}t(c,t,n=[],r,a){if(r){const h=new l(void 0,this.g,this,this.i);h.c=String(c);const i=new Map,p=new S.$xh(()=>{const u=h.j(t,n,a);for(const[o,E]of i){const w=u[o];if(typeof w=="function")for(const m of E)m.disposable=w.apply(u,m.listener)}return i.clear(),u});return new Proxy(Object.create(null),{get(u,o){if(!p.isInitialized&&typeof o=="string"&&(o.startsWith("onDid")||o.startsWith("onWill"))){let m=i.get(o);return m||(m=new D.$4c,i.set(o,m)),(d,y,b)=>{if(p.isInitialized)return p.value[o](d,y,b);{const A={listener:[d,y,b],disposable:void 0},T=m.push(A);return(0,P.$Rc)(()=>{T(),A.disposable?.dispose()})}}}if(o in u)return u[o];const E=p.value;let w=E[o];return typeof w!="function"||(w=w.bind(E),u[o]=w),w},set(u,o,E){return p.value[o]=E,!0},getPrototypeOf(u){return t.prototype}})}else return this.j(t,n,a)}u(c,t){if(t&&console.warn(c),this.g)throw new Error(c)}}e.$Pq=l;var v;(function(s){s[s.None=0]="None",s[s.Creation=1]="Creation",s[s.Invocation=2]="Invocation",s[s.Branch=3]="Branch"})(v||(v={}));class ${static{this.all=new Set}static{this.c=new class extends ${constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(c,t){return c?new $(2,t.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):$.c}static traceCreation(c,t){return c?new $(1,t.name):$.c}static{this.f=0}constructor(c,t){this.type=c,this.name=t,this.g=Date.now(),this.h=[]}branch(c,t){const n=new $(3,c.toString());return this.h.push([c,t,n]),n}stop(){const c=Date.now()-this.g;$.f+=c;let t=!1;function n(a,h){const i=[],p=new Array(a+1).join("	");for(const[u,o,E]of h.h)if(o&&E){t=!0,i.push(`${p}CREATES -> ${u}`);const w=n(a+1,E);w&&i.push(w)}else i.push(`${p}uses -> ${u}`);return i.join(`
`)}const r=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${n(1,this)}`,`DONE, took ${c.toFixed(2)}ms (grand total ${$.f.toFixed(2)}ms)`];(c>2||t)&&$.all.add(r.join(`
`))}}e.$Qq=$}),define(Re[14],Ae([1,0,34,5,97,6,28,21,25,16,2,36,4]),function(fe,e,S,F,P,L,R,g,f,D,M,k,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.log=e.$Bj=e.LogLevel=e.$Aj=e.$zj=e.$yj=void 0,e.$yj=(0,l.$ei)("logService"),e.$zj=(0,l.$ei)("loggerService");function v(){return new Date().toISOString()}function $(d){return(0,D.$Wf)(d)}e.$Aj=$;var s;(function(d){d[d.Off=0]="Off",d[d.Trace=1]="Trace",d[d.Debug=2]="Debug",d[d.Info=3]="Info",d[d.Warning=4]="Warning",d[d.Error=5]="Error"})(s||(e.LogLevel=s={})),e.$Bj=s.Info;function c(d,y,b){switch(y){case s.Trace:d.trace(b);break;case s.Debug:d.debug(b);break;case s.Info:d.info(b);break;case s.Warning:d.warn(b);break;case s.Error:d.error(b);break;case s.Off:break;default:throw new Error(`Invalid log level ${y}`)}}e.log=c;function t(d,y=!1){let b="";for(let A=0;A<d.length;A++){let T=d[A];if(T instanceof Error&&(T=(0,S.$2i)(T,y)),typeof T=="object")try{T=JSON.stringify(T)}catch{}b+=(A>0?" ":"")+T}return b}class n extends L.$Tc{constructor(){super(...arguments),this.b=e.$Bj,this.c=this.B(new F.$5d),this.onDidChangeLogLevel=this.c.event}setLevel(y){this.b!==y&&(this.b=y,this.c.fire(this.b))}getLevel(){return this.b}f(y){return this.b!==s.Off&&this.b<=y}}e.$Dj=n;class r extends n{constructor(y){super(),this.h=y}f(y){return this.h||super.f(y)}trace(y,...b){this.f(s.Trace)&&this.g(s.Trace,t([y,...b],!0))}debug(y,...b){this.f(s.Debug)&&this.g(s.Debug,t([y,...b]))}info(y,...b){this.f(s.Info)&&this.g(s.Info,t([y,...b]))}warn(y,...b){this.f(s.Warning)&&this.g(s.Warning,t([y,...b]))}error(y,...b){if(this.f(s.Error))if(y instanceof Error){const A=Array.prototype.slice.call(arguments);A[0]=y.stack,this.g(s.Error,t(A))}else this.g(s.Error,t([y,...b]))}flush(){}}e.$Ej=r;class a extends n{constructor(y=e.$Bj){super(),this.setLevel(y),this.g=!g.$i}trace(y,...b){this.f(s.Trace)&&(this.g?console.log(`\x1B[90m[main ${v()}]\x1B[0m`,y,...b):console.log(`[main ${v()}]`,y,...b))}debug(y,...b){this.f(s.Debug)&&(this.g?console.log(`\x1B[90m[main ${v()}]\x1B[0m`,y,...b):console.log(`[main ${v()}]`,y,...b))}info(y,...b){this.f(s.Info)&&(this.g?console.log(`\x1B[90m[main ${v()}]\x1B[0m`,y,...b):console.log(`[main ${v()}]`,y,...b))}warn(y,...b){this.f(s.Warning)&&(this.g?console.warn(`\x1B[93m[main ${v()}]\x1B[0m`,y,...b):console.warn(`[main ${v()}]`,y,...b))}error(y,...b){this.f(s.Error)&&(this.g?console.error(`\x1B[91m[main ${v()}]\x1B[0m`,y,...b):console.error(`[main ${v()}]`,y,...b))}flush(){}}e.$Fj=a;class h extends n{constructor(y=e.$Bj,b=!0){super(),this.g=b,this.setLevel(y)}trace(y,...b){this.f(s.Trace)&&(this.g?console.log("%cTRACE","color: #888",y,...b):console.log(y,...b))}debug(y,...b){this.f(s.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",y,...b):console.log(y,...b))}info(y,...b){this.f(s.Info)&&(this.g?console.log("%c INFO","color: #33f",y,...b):console.log(y,...b))}warn(y,...b){this.f(s.Warning)&&(this.g?console.log("%c WARN","color: #993",y,...b):console.log(y,...b))}error(y,...b){this.f(s.Error)&&(this.g?console.log("%c  ERR","color: #f33",y,...b):console.error(y,...b))}flush(){}}e.$Gj=h;class i extends n{constructor(y,b=e.$Bj){super(),this.g=y,this.setLevel(b)}trace(y,...b){this.f(s.Trace)&&this.g.log(s.Trace,[this.h(y),...b])}debug(y,...b){this.f(s.Debug)&&this.g.log(s.Debug,[this.h(y),...b])}info(y,...b){this.f(s.Info)&&this.g.log(s.Info,[this.h(y),...b])}warn(y,...b){this.f(s.Warning)&&this.g.log(s.Warning,[this.h(y),...b])}error(y,...b){this.f(s.Error)&&this.g.log(s.Error,[this.h(y),...b])}h(y){return typeof y=="string"?y:(0,S.$2i)(y,this.f(s.Trace))}flush(){}}e.$Hj=i;class p extends n{constructor(y){super(),this.g=y,y.length&&this.setLevel(y[0].getLevel())}setLevel(y){for(const b of this.g)b.setLevel(y);super.setLevel(y)}trace(y,...b){for(const A of this.g)A.trace(y,...b)}debug(y,...b){for(const A of this.g)A.debug(y,...b)}info(y,...b){for(const A of this.g)A.info(y,...b)}warn(y,...b){for(const A of this.g)A.warn(y,...b)}error(y,...b){for(const A of this.g)A.error(y,...b)}flush(){for(const y of this.g)y.flush()}dispose(){for(const y of this.g)y.dispose();super.dispose()}}e.$Ij=p;class u extends L.$Tc{constructor(y,b,A){if(super(),this.h=y,this.j=b,this.b=new R.$Ac,this.c=this.B(new F.$5d),this.onDidChangeLoggers=this.c.event,this.f=this.B(new F.$5d),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new F.$5d),this.onDidChangeVisibility=this.g.event,A)for(const T of A)this.b.set(T.resource,{logger:void 0,info:T})}m(y){return(0,D.$Sf)(y)?[...this.b.values()].find(b=>b.info.id===y):this.b.get(y)}getLogger(y){return this.m(y)?.logger}createLogger(y,b){const A=this.n(y),T=(0,D.$Sf)(y)?y:b?.id??(0,P.$5i)(A.toString()).toString(16);let G=this.b.get(A)?.logger;const W=b?.logLevel==="always"?s.Trace:b?.logLevel;G||(G=this.s(A,W??this.getLogLevel(A)??this.h,{...b,id:T}));const U={logger:G,info:{resource:A,id:T,logLevel:W,name:b?.name,hidden:b?.hidden,extensionId:b?.extensionId,when:b?.when}};return this.registerLogger(U.info),this.b.set(A,U),G}n(y){return(0,D.$Sf)(y)?(0,f.$Rg)(this.j,`${y}.log`):y}setLogLevel(y,b){if(M.URI.isUri(y)){const A=y,T=b,G=this.b.get(A);G&&T!==G.info.logLevel&&(G.info.logLevel=T===this.h?void 0:T,G.logger?.setLevel(T),this.b.set(G.info.resource,G),this.f.fire([A,T]))}else{this.h=y;for(const[A,T]of this.b.entries())this.b.get(A)?.info.logLevel===void 0&&T.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(y,b){const A=this.m(y);A&&b!==!A.info.hidden&&(A.info.hidden=!b,this.b.set(A.info.resource,A),this.g.fire([A.info.resource,b]))}getLogLevel(y){let b;return y&&(b=this.b.get(y)?.info.logLevel),b??this.h}registerLogger(y){const b=this.b.get(y.resource);b?b.info.hidden!==y.hidden&&this.setVisibility(y.resource,!y.hidden):(this.b.set(y.resource,{info:y,logger:void 0}),this.c.fire({added:[y],removed:[]}))}deregisterLogger(y){const b=this.b.get(y);b&&(b.logger&&b.logger.dispose(),this.b.delete(y),this.c.fire({added:[],removed:[b.info]}))}*getRegisteredLoggers(){for(const y of this.b.values())yield y.info}getRegisteredLogger(y){return this.b.get(y)?.info}dispose(){this.b.forEach(y=>y.logger?.dispose()),this.b.clear(),super.dispose()}}e.$Jj=u;class o{constructor(){this.onDidChangeLogLevel=new F.$5d().event}setLevel(y){}getLevel(){return s.Info}trace(y,...b){}debug(y,...b){}info(y,...b){}warn(y,...b){}error(y,...b){}critical(y,...b){}dispose(){}flush(){}}e.$Kj=o;class E extends o{}e.$Lj=E;function w(d){if(d.verbose)return s.Trace;if(typeof d.logLevel=="string"){const y=I(d.logLevel.toLowerCase());if(y!==void 0)return y}return e.$Bj}e.$Mj=w;function m(d){switch(d){case s.Trace:return"trace";case s.Debug:return"debug";case s.Info:return"info";case s.Warning:return"warn";case s.Error:return"error";case s.Off:return"off"}}e.$Nj=m;function I(d){switch(d){case"trace":return s.Trace;case"debug":return s.Debug;case"info":return s.Info;case"warn":return s.Warning;case"error":return s.Error;case"critical":return s.Error;case"off":return s.Off}}e.$Oj=I,e.$Pj=new k.$vj("logLevel",m(s.Info))}),define(Re[188],Ae([1,0,6,14]),function(fe,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BP=void 0;class P extends S.$Tc{constructor(R,g=[]){super(),this.a=new F.$Ij([R,...g]),this.B(R.onDidChangeLogLevel(f=>this.setLevel(f)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(R){this.a.setLevel(R)}getLevel(){return this.a.getLevel()}trace(R,...g){this.a.trace(R,...g)}debug(R,...g){this.a.debug(R,...g)}info(R,...g){this.a.info(R,...g)}warn(R,...g){this.a.warn(R,...g)}error(R,...g){this.a.error(R,...g)}flush(){this.a.flush()}}e.$BP=P}),define(Re[98],Ae([1,0,32,155,4]),function(fe,e,S,F,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lt=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var L;(function(f){f[f.Unnecessary=1]="Unnecessary",f[f.Deprecated=2]="Deprecated"})(L||(e.MarkerTag=L={}));var R;(function(f){f[f.Hint=1]="Hint",f[f.Info=2]="Info",f[f.Warning=4]="Warning",f[f.Error=8]="Error"})(R||(e.MarkerSeverity=R={})),function(f){function D($,s){return s-$}f.compare=D;const M=Object.create(null);M[f.Error]=(0,F.localize)(0,null),M[f.Warning]=(0,F.localize)(1,null),M[f.Info]=(0,F.localize)(2,null);function k($){return M[$]||""}f.toString=k;function l($){switch($){case S.default.Error:return f.Error;case S.default.Warning:return f.Warning;case S.default.Info:return f.Info;case S.default.Ignore:return f.Hint}}f.fromSeverity=l;function v($){switch($){case f.Error:return S.default.Error;case f.Warning:return S.default.Warning;case f.Info:return S.default.Info;case f.Hint:return S.default.Ignore}}f.toSeverity=v}(R||(e.MarkerSeverity=R={}));var g;(function(f){const D="";function M(l){return k(l,!0)}f.makeKey=M;function k(l,v){const $=[D];return l.source?$.push(l.source.replace("\xA6","\\\xA6")):$.push(D),l.code?typeof l.code=="string"?$.push(l.code.replace("\xA6","\\\xA6")):$.push(l.code.value.replace("\xA6","\\\xA6")):$.push(D),l.severity!==void 0&&l.severity!==null?$.push(R.toString(l.severity)):$.push(D),l.message&&v?$.push(l.message.replace("\xA6","\\\xA6")):$.push(D),l.startLineNumber!==void 0&&l.startLineNumber!==null?$.push(l.startLineNumber.toString()):$.push(D),l.startColumn!==void 0&&l.startColumn!==null?$.push(l.startColumn.toString()):$.push(D),l.endLineNumber!==void 0&&l.endLineNumber!==null?$.push(l.endLineNumber.toString()):$.push(D),l.endColumn!==void 0&&l.endColumn!==null?$.push(l.endColumn.toString()):$.push(D),$.push(D),$.join("\xA6")}f.makeKeyOptionalMessage=k})(g||(e.IMarkerData=g={})),e.$Lt=(0,P.$ei)("markerService")}),define(Re[189],Ae([1,0,5,32,4]),function(fe,e,S,F,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ev=e.$Dv=e.NotificationsFilter=e.$Cv=e.NeverShowAgainScope=e.NotificationPriority=e.$Bv=e.Severity=void 0,e.Severity=F.default,e.$Bv=(0,P.$ei)("notificationService");var L;(function(k){k[k.DEFAULT=0]="DEFAULT",k[k.SILENT=1]="SILENT",k[k.URGENT=2]="URGENT"})(L||(e.NotificationPriority=L={}));var R;(function(k){k[k.WORKSPACE=0]="WORKSPACE",k[k.PROFILE=1]="PROFILE",k[k.APPLICATION=2]="APPLICATION"})(R||(e.NeverShowAgainScope=R={}));function g(k){if(k){const l=k;return typeof l.id=="string"&&typeof l.label=="string"}return!1}e.$Cv=g;var f;(function(k){k[k.OFF=0]="OFF",k[k.ERROR=1]="ERROR"})(f||(e.NotificationsFilter=f={}));class D{constructor(){this.progress=new M,this.onDidClose=S.Event.None,this.onDidChangeVisibility=S.Event.None}updateSeverity(l){}updateMessage(l){}updateActions(l){}close(){}}e.$Dv=D;class M{infinite(){}done(){}total(l){}worked(l){}}e.$Ev=M}),define(Re[190],Ae([1,0,4]),function(fe,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rj=e.$Qj=void 0,e.$Qj=(0,S.$ei)("productService"),e.$Rj="vscode://schemas/vscode-product"});var Ze=this&&this.__decorate||function(fe,e,S,F){var P=arguments.length,L=P<3?e:F===null?F=Object.getOwnPropertyDescriptor(e,S):F,R;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")L=Reflect.decorate(fe,e,S,F);else for(var g=fe.length-1;g>=0;g--)(R=fe[g])&&(L=(P<3?R(L):P>3?R(e,S,L):R(e,S))||L);return P>3&&L&&Object.defineProperty(e,S,L),L},qe=this&&this.__param||function(fe,e){return function(S,F){e(S,F,fe)}};define(Re[99],Ae([1,0,11,22,6,4]),function(fe,e,S,F,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lv=e.$Kv=e.$Jv=e.$Iv=e.$Hv=e.$Gv=e.ProgressLocation=e.$Fv=void 0,e.$Fv=(0,L.$ei)("progressService");var R;(function(k){k[k.Explorer=1]="Explorer",k[k.Scm=3]="Scm",k[k.Extensions=5]="Extensions",k[k.Window=10]="Window",k[k.Notification=15]="Notification",k[k.Dialog=20]="Dialog"})(R||(e.ProgressLocation=R={})),e.$Gv=Object.freeze({total(){},worked(){},done(){}});class g{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(l){this.b=l}report(l){this.a=l,this.b(this.a)}}e.$Hv=g;class f{get value(){return this.a}constructor(l){this.e=l}report(l){this.b?this.b.push(l):this.b=[l],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const l=this.b.shift();this.a=l,await this.e(this.a)}}finally{this.c=!1;const l=this.d;this.d=void 0,l?.()}}drain(){return this.c?new Promise(l=>{const v=this.d;this.d=()=>{v?.(),l()}}):Promise.resolve()}}e.$Iv=f;let D=class extends P.$Tc{constructor(l,v){super(),this.a=new S.$Bh,v.withProgress(l,$=>(this.b=$,this.c&&$.report(this.c),this.a.p)),this.B((0,P.$Rc)(()=>this.a.complete()))}report(l){this.b?this.b.report(l):this.c=l}};e.$Jv=D,e.$Jv=D=Ze([qe(1,e.$Fv)],D);class M extends P.$Tc{constructor(l){super(),this.g=l,this.a=0,this.b=this.B(new P.$Sc)}start(l){this.stop();const v=++this.a,$=new F.$ce;return this.f=setTimeout(()=>{v===this.a&&(this.c=this.g.show(!0))},l),this.b.add((0,P.$Rc)(()=>clearTimeout(this.f))),this.b.add((0,P.$Rc)(()=>$.cancel())),this.b.add((0,P.$Rc)(()=>this.c?this.c.done():void 0)),{id:v,token:$.token,stop:()=>this.h(v),isCurrent:()=>this.a===v}}stop(){this.h(this.a)}h(l){this.a===l&&this.b.clear()}}e.$Kv=M,e.$Lv=(0,L.$ei)("editorProgressService")}),define(Re[30],Ae([1,0,55,16]),function(fe,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tn=void 0;class P{constructor(){this.a=new Map}add(R,g){S.ok(F.$Sf(R)),S.ok(F.$Uf(g)),S.ok(!this.a.has(R),"There is already an extension with this id"),this.a.set(R,g)}knows(R){return this.a.has(R)}as(R){return this.a.get(R)||null}}e.$Tn=new P}),define(Re[72],Ae([1,0,5,30]),function(fe,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Un=void 0,e.$Un={JSONContribution:"base.contributions.json"};function P(g){return g.length>0&&g.charAt(g.length-1)==="#"?g.substring(0,g.length-1):g}class L{constructor(){this.b=new S.$5d,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(f,D){this.a[P(f)]=D,this.b.fire(f)}notifySchemaChanged(f){this.b.fire(f)}getSchemaContributions(){return{schemas:this.a}}}const R=new L;F.$Tn.add(e.$Un.JSONContribution,R)}),define(Re[56],Ae([1,0,18,5,16,149,46,72,30]),function(fe,e,S,F,P,L,R,g,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bo=e.$ao=e.$_n=e.$$n=e.$0n=e.$9n=e.$8n=e.$7n=e.$6n=e.$5n=e.$4n=e.$3n=e.$2n=e.$1n=e.$Zn=e.ConfigurationScope=e.$Yn=e.EditPresentationTypes=void 0;var D;(function(h){h.Multiline="multilineText",h.Singleline="singlelineText"})(D||(e.EditPresentationTypes=D={})),e.$Yn={Configuration:"base.contributions.configuration"};var M;(function(h){h[h.APPLICATION=1]="APPLICATION",h[h.MACHINE=2]="MACHINE",h[h.WINDOW=3]="WINDOW",h[h.RESOURCE=4]="RESOURCE",h[h.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",h[h.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(M||(e.ConfigurationScope=M={})),e.$Zn={properties:{},patternProperties:{}},e.$1n={properties:{},patternProperties:{}},e.$2n={properties:{},patternProperties:{}},e.$3n={properties:{},patternProperties:{}},e.$4n={properties:{},patternProperties:{}},e.$5n={properties:{},patternProperties:{}},e.$6n="vscode://schemas/settings/resourceLanguage",e.$7n="vscode://schemas/settings/configurationDefaults";const k=f.$Tn.as(g.$Un.JSONContribution);class l{constructor(){this.h=new Set,this.i=new F.$5d,this.onDidSchemaChange=this.i.event,this.j=new F.$5d,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:L.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},k.registerSchema(e.$6n,this.g),this.v()}registerConfiguration(i,p=!0){this.registerConfigurations([i],p)}registerConfigurations(i,p=!0){const u=new Set;this.n(i,p,u),k.registerSchema(e.$6n,this.g),this.i.fire(),this.j.fire({properties:u})}deregisterConfigurations(i){const p=new Set;this.o(i,p),k.registerSchema(e.$6n,this.g),this.i.fire(),this.j.fire({properties:p})}updateConfigurations({add:i,remove:p}){const u=new Set;this.o(p,u),this.n(i,!1,u),k.registerSchema(e.$6n,this.g),this.i.fire(),this.j.fire({properties:u})}registerDefaultConfigurations(i){const p=new Set;this.k(i,p),this.i.fire(),this.j.fire({properties:p,defaultsOverrides:!0})}k(i,p){const u=[];for(const{overrides:o,source:E}of i)for(const w in o)if(p.add(w),e.$9n.test(w)){const m=this.a.get(w),I=m?.valuesSources??new Map;if(E)for(const A of Object.keys(o[w]))I.set(A,E);const d={...m?.value||{},...o[w]};this.a.set(w,{source:E,value:d,valuesSources:I});const y=(0,R.$Ui)(w),b={type:"object",default:d,description:L.localize(1,null,y),$ref:e.$6n,defaultDefaultValue:d,source:P.$Sf(E)?void 0:E,defaultValueSource:E};u.push(...s(w)),this.d[w]=b,this.b.properties[w]=b}else{this.a.set(w,{value:o[w],source:E});const m=this.d[w];m&&(this.w(w,m),this.r(w,m))}this.m(u)}deregisterDefaultConfigurations(i){const p=new Set;this.l(i,p),this.i.fire(),this.j.fire({properties:p,defaultsOverrides:!0})}l(i,p){for(const{overrides:u,source:o}of i)for(const E in u){const w=this.a.get(E),m=P.$Sf(o)?o:o?.id,I=P.$Sf(w?.source)?w?.source:w?.source?.id;if(m===I)if(p.add(E),this.a.delete(E),e.$9n.test(E))delete this.d[E],delete this.b.properties[E];else{const d=this.d[E];d&&(this.w(E,d),this.r(E,d))}}this.u()}deltaConfiguration(i){let p=!1;const u=new Set;i.removedDefaults&&(this.l(i.removedDefaults,u),p=!0),i.addedDefaults&&(this.k(i.addedDefaults,u),p=!0),i.removedConfigurations&&this.o(i.removedConfigurations,u),i.addedConfigurations&&this.n(i.addedConfigurations,!1,u),this.i.fire(),this.j.fire({properties:u,defaultsOverrides:p})}notifyConfigurationSchemaUpdated(...i){this.i.fire()}registerOverrideIdentifiers(i){this.m(i),this.i.fire()}m(i){for(const p of i)this.h.add(p);this.u()}n(i,p,u){i.forEach(o=>{this.p(o,p,o.extensionInfo,o.restrictedProperties,void 0,u),this.c.push(o),this.q(o)})}o(i,p){const u=o=>{if(o.properties)for(const E in o.properties){p.add(E);const w=this.d[E];w?.policy?.name&&this.e.delete(w.policy.name),delete this.d[E],this.s(E,o.properties[E])}o.allOf?.forEach(E=>u(E))};for(const o of i){u(o);const E=this.c.indexOf(o);E!==-1&&this.c.splice(E,1)}}p(i,p=!0,u,o,E=3,w){E=P.$2f(i.scope)?E:i.scope;const m=i.properties;if(m)for(const d in m){const y=m[d];if(p&&r(d,y)){delete m[d];continue}if(y.source=u,y.defaultDefaultValue=m[d].default,this.w(d,y),e.$9n.test(d)?y.scope=void 0:(y.scope=P.$2f(y.scope)?E:y.scope,y.restricted=P.$2f(y.restricted)?!!o?.includes(d):y.restricted),m[d].hasOwnProperty("included")&&!m[d].included){this.f[d]=m[d],delete m[d];continue}else this.d[d]=m[d],m[d].policy?.name&&this.e.set(m[d].policy.name,d);!m[d].deprecationMessage&&m[d].markdownDeprecationMessage&&(m[d].deprecationMessage=m[d].markdownDeprecationMessage),w.add(d)}const I=i.allOf;if(I)for(const d of I)this.p(d,p,u,o,E,w)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(i){const p=u=>{const o=u.properties;if(o)for(const w in o)this.r(w,o[w]);u.allOf?.forEach(p)};p(i)}r(i,p){switch(e.$Zn.properties[i]=p,p.scope){case 1:e.$1n.properties[i]=p;break;case 2:e.$2n.properties[i]=p;break;case 6:e.$3n.properties[i]=p;break;case 3:e.$4n.properties[i]=p;break;case 4:e.$5n.properties[i]=p;break;case 5:e.$5n.properties[i]=p,this.g.properties[i]=p;break}}s(i,p){switch(delete e.$Zn.properties[i],p.scope){case 1:delete e.$1n.properties[i];break;case 2:delete e.$2n.properties[i];break;case 6:delete e.$3n.properties[i];break;case 3:delete e.$4n.properties[i];break;case 4:case 5:delete e.$5n.properties[i],delete this.g.properties[i];break}}u(){for(const i of this.h.values()){const p=`[${i}]`,u={type:"object",description:L.localize(2,null),errorMessage:L.localize(3,null),$ref:e.$6n};this.w(p,u),e.$Zn.properties[p]=u,e.$1n.properties[p]=u,e.$2n.properties[p]=u,e.$3n.properties[p]=u,e.$4n.properties[p]=u,e.$5n.properties[p]=u}}v(){const i={type:"object",description:L.localize(4,null),errorMessage:L.localize(5,null),$ref:e.$6n};e.$Zn.patternProperties[e.$8n]=i,e.$1n.patternProperties[e.$8n]=i,e.$2n.patternProperties[e.$8n]=i,e.$3n.patternProperties[e.$8n]=i,e.$4n.patternProperties[e.$8n]=i,e.$5n.patternProperties[e.$8n]=i,this.i.fire()}w(i,p){const u=this.a.get(i);let o=u?.value,E=u?.source;P.$Zf(o)&&(o=p.defaultDefaultValue,E=void 0),P.$Zf(o)&&(o=t(p.type)),p.default=o,p.defaultValueSource=E}}const v="\\[([^\\]]+)\\]",$=new RegExp(v,"g");e.$8n=`^(${v})+$`,e.$9n=new RegExp(e.$8n);function s(h){const i=[];if(e.$9n.test(h)){let p=$.exec(h);for(;p?.length;){const u=p[1].trim();u&&i.push(u),p=$.exec(h)}}return(0,S.$Mb)(i)}e.$0n=s;function c(h){return h.reduce((i,p)=>`${i}[${p}]`,"")}e.$$n=c;function t(h){switch(Array.isArray(h)?h[0]:h){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$_n=t;const n=new l;f.$Tn.add(e.$Yn.Configuration,n);function r(h,i){return h.trim()?e.$9n.test(h)?L.localize(7,null,h):n.getConfigurationProperties()[h]!==void 0?L.localize(8,null,h):i.policy?.name&&n.getPolicyConfigurations().get(i.policy?.name)!==void 0?L.localize(9,null,h,i.policy?.name,n.getPolicyConfigurations().get(i.policy?.name)):null:L.localize(6,null)}e.$ao=r;function a(){const h=[],i=n.getConfigurationProperties();for(const p of Object.keys(i))h.push([p,i[p].scope]);return h.push(["launch",4]),h.push(["task",4]),h}e.$bo=a}),define(Re[191],Ae([1,0,18,5,120,6,28,26,16,2,46,56,30]),function(fe,e,S,F,P,L,R,g,f,D,M,k,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ho=e.$go=e.$fo=e.$eo=e.$do=e.$co=void 0;function v(p){return Object.isFrozen(p)?p:g.$In(p)}class ${constructor(u={},o=[],E=[],w){this.b=u,this.c=o,this.d=E,this.raw=w,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const u=this.raw.map(o=>{if(o instanceof $)return o;const E=new s("");return E.parseRaw(o),E.configurationModel});this.f=u.reduce((o,E)=>E===o?E:o.merge(E),u[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(u){return u?(0,M.$Si)(this.contents,u):this.contents}inspect(u,o){const E=this;return{get value(){return v(E.rawConfiguration.getValue(u))},get override(){return o?v(E.rawConfiguration.getOverrideValue(u,o)):void 0},get merged(){return v(o?E.rawConfiguration.override(o).getValue(u):E.rawConfiguration.getValue(u))},get overrides(){const w=[];for(const{contents:m,identifiers:I,keys:d}of E.rawConfiguration.overrides){const y=new $(m,d).getValue(u);y!==void 0&&w.push({identifiers:I,value:y})}return w.length?v(w):void 0}}}getOverrideValue(u,o){const E=this.i(o);return E?u?(0,M.$Si)(E,u):E:void 0}getKeysForOverrideIdentifier(u){const o=[];for(const E of this.overrides)E.identifiers.includes(u)&&o.push(...E.keys);return S.$Mb(o)}getAllOverrideIdentifiers(){const u=[];for(const o of this.overrides)u.push(...o.identifiers);return S.$Mb(u)}override(u){let o=this.a.get(u);return o||(o=this.g(u),this.a.set(u,o)),o}merge(...u){const o=g.$Hn(this.contents),E=g.$Hn(this.overrides),w=[...this.keys],m=this.raw?.length?[...this.raw]:[this];for(const I of u)if(m.push(...I.raw?.length?I.raw:[I]),!I.isEmpty()){this.h(o,I.contents);for(const d of I.overrides){const[y]=E.filter(b=>S.$ub(b.identifiers,d.identifiers));y?(this.h(y.contents,d.contents),y.keys.push(...d.keys),y.keys=S.$Mb(y.keys)):E.push(g.$Hn(d))}for(const d of I.keys)w.indexOf(d)===-1&&w.push(d)}return new $(o,w,E,m.every(I=>I instanceof $)?void 0:m)}g(u){const o=this.i(u);if(!o||typeof o!="object"||!Object.keys(o).length)return this;const E={};for(const w of S.$Mb([...Object.keys(this.contents),...Object.keys(o)])){let m=this.contents[w];const I=o[w];I&&(typeof m=="object"&&typeof I=="object"?(m=g.$Hn(m),this.h(m,I)):m=I),E[w]=m}return new $(E,this.keys,this.overrides)}h(u,o){for(const E of Object.keys(o)){if(E in u&&f.$Uf(u[E])&&f.$Uf(o[E])){this.h(u[E],o[E]);continue}u[E]=g.$Hn(o[E])}}i(u){let o=null,E=null;const w=m=>{m&&(E?this.h(E,m):E=g.$Hn(m))};for(const m of this.overrides)m.identifiers.length===1&&m.identifiers[0]===u?o=m.contents:m.identifiers.includes(u)&&w(m.contents);return w(o),E}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(u,o){this.j(u,o,!0)}setValue(u,o){this.j(u,o,!1)}removeValue(u){const o=this.keys.indexOf(u);o!==-1&&(this.keys.splice(o,1),(0,M.$Ri)(this.contents,u),k.$9n.test(u)&&this.overrides.splice(this.overrides.findIndex(E=>S.$ub(E.identifiers,(0,k.$0n)(u))),1))}j(u,o,E){(0,M.$Qi)(this.contents,u,o,w=>console.error(w)),E=E||this.keys.indexOf(u)===-1,E&&this.keys.push(u),k.$9n.test(u)&&this.overrides.push({identifiers:(0,k.$0n)(u),keys:Object.keys(this.contents[u]),contents:(0,M.$Pi)(this.contents[u],w=>console.error(w))})}}e.$co=$;class s{constructor(u){this.f=u,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new $}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(u,o){if(!f.$2f(u)){const E=this.g(u);this.parseRaw(E,o)}}reparse(u){this.a&&this.parseRaw(this.a,u)}parseRaw(u,o){this.a=u;const{contents:E,keys:w,overrides:m,restricted:I,hasExcludedProperties:d}=this.h(u,o);this.b=new $(E,w,m,d?[u]:void 0),this.c=I||[]}g(u){let o={},E=null,w=[];const m=[],I=[];function d(b){Array.isArray(w)?w.push(b):E!==null&&(w[E]=b)}const y={onObjectBegin:()=>{const b={};d(b),m.push(w),w=b,E=null},onObjectProperty:b=>{E=b},onObjectEnd:()=>{w=m.pop()},onArrayBegin:()=>{const b=[];d(b),m.push(w),w=b,E=null},onArrayEnd:()=>{w=m.pop()},onLiteralValue:d,onError:(b,A,T)=>{I.push({error:b,offset:A,length:T})}};if(u)try{P.$vn(u,y),o=w[0]||{}}catch(b){console.error(`Error while parsing settings file ${this.f}: ${b}`),this.d=[b]}return o}h(u,o){const E=l.$Tn.as(k.$Yn.Configuration).getConfigurationProperties(),w=this.i(u,E,!0,o);u=w.raw;const m=(0,M.$Pi)(u,y=>console.error(`Conflict in settings file ${this.f}: ${y}`)),I=Object.keys(u),d=this.j(u,y=>console.error(`Conflict in settings file ${this.f}: ${y}`));return{contents:m,keys:I,overrides:d,restricted:w.restricted,hasExcludedProperties:w.hasExcludedProperties}}i(u,o,E,w){let m=!1;if(!w?.scopes&&!w?.skipRestricted&&!w?.exclude?.length)return{raw:u,restricted:[],hasExcludedProperties:m};const I={},d=[];for(const y in u)if(k.$9n.test(y)&&E){const b=this.i(u[y],o,!1,w);I[y]=b.raw,m=m||b.hasExcludedProperties,d.push(...b.restricted)}else{const b=o[y],A=b?typeof b.scope<"u"?b.scope:3:void 0;b?.restricted&&d.push(y),!w.exclude?.includes(y)&&(w.include?.includes(y)||(A===void 0||w.scopes===void 0||w.scopes.includes(A))&&!(w.skipRestricted&&b?.restricted))?I[y]=u[y]:m=!0}return{raw:I,restricted:d,hasExcludedProperties:m}}j(u,o){const E=[];for(const w of Object.keys(u))if(k.$9n.test(w)){const m={};for(const I in u[w])m[I]=u[w][I];E.push({identifiers:(0,k.$0n)(w),keys:Object.keys(m),contents:(0,M.$Pi)(m,o)})}return E}}e.$do=s;class c extends L.$Tc{constructor(u,o,E,w){super(),this.c=u,this.f=o,this.g=w,this.b=this.B(new F.$5d),this.onDidChange=this.b.event,this.a=new s(this.c.toString()),this.B(this.g.watch(E.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(F.Event.any(F.Event.filter(this.g.onDidFilesChange,m=>m.contains(this.c)),F.Event.filter(this.g.onDidRunOperation,m=>(m.isOperation(0)||m.isOperation(3)||m.isOperation(1)||m.isOperation(4))&&E.isEqual(m.resource,u)))(()=>this.b.fire()))}async loadConfiguration(){try{const u=await this.g.readFile(this.c);return this.a.parse(u.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new $}}reparse(u){return u&&(this.f=u),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$eo=c;class t{constructor(u,o,E,w,m,I,d,y,b,A,T,G,W){this.a=u,this.b=o,this.c=E,this.overrideIdentifiers=w,this.d=m,this.f=I,this.g=d,this.h=y,this.i=b,this.j=A,this.k=T,this.l=G,this.m=W}get value(){return v(this.c)}n(u){return u?.value!==void 0||u?.override!==void 0||u?.overrides!==void 0?u:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class n{constructor(u,o,E,w,m=new $,I=new $,d=new R.$Ac,y=new $,b=new R.$Ac){this.c=u,this.d=o,this.f=E,this.g=w,this.h=m,this.i=I,this.j=d,this.l=y,this.m=b,this.a=null,this.b=new R.$Ac,this.n=null}getValue(u,o,E){return this.p(u,o,E).getValue(u)}updateValue(u,o,E={}){let w;E.resource?(w=this.m.get(E.resource),w||(w=new $,this.m.set(E.resource,w))):w=this.l,o===void 0?w.removeValue(u):w.setValue(u,o),E.resource||(this.a=null)}inspect(u,o,E){const w=this.p(u,o,E),m=this.t(o.resource,E),I=o.resource?this.m.get(o.resource)||this.l:this.l,d=new Set;for(const y of w.overrides)for(const b of y.identifiers)w.getOverrideValue(u,b)!==void 0&&d.add(b);return new t(u,o,w.getValue(u),d.size?[...d]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,E?this.i:void 0,m||void 0,I)}keys(u){const o=this.t(void 0,u);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:o?o.keys.slice(0):[]}}updateDefaultConfiguration(u){this.c=u,this.a=null,this.b.clear()}updatePolicyConfiguration(u){this.d=u}updateApplicationConfiguration(u){this.f=u,this.a=null,this.b.clear()}updateLocalUserConfiguration(u){this.g=u,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(u){this.h=u,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(u){this.i=u,this.a=null,this.b.clear()}updateFolderConfiguration(u,o){this.j.set(u,o),this.b.delete(u)}deleteFolderConfiguration(u){this.folderConfigurations.delete(u),this.b.delete(u)}compareAndUpdateDefaultConfiguration(u,o){const E=[];if(!o){const{added:w,updated:m,removed:I}=h(this.c,u);o=[...w,...m,...I]}for(const w of o)for(const m of(0,k.$0n)(w)){const I=this.c.getKeysForOverrideIdentifier(m),d=u.getKeysForOverrideIdentifier(m),y=[...d.filter(b=>I.indexOf(b)===-1),...I.filter(b=>d.indexOf(b)===-1),...I.filter(b=>!g.$Ln(this.c.override(m).getValue(b),u.override(m).getValue(b)))];E.push([m,y])}return this.updateDefaultConfiguration(u),{keys:o,overrides:E}}compareAndUpdatePolicyConfiguration(u){const{added:o,updated:E,removed:w}=h(this.d,u),m=[...o,...E,...w];return m.length&&this.updatePolicyConfiguration(u),{keys:m,overrides:[]}}compareAndUpdateApplicationConfiguration(u){const{added:o,updated:E,removed:w,overrides:m}=h(this.applicationConfiguration,u),I=[...o,...E,...w];return I.length&&this.updateApplicationConfiguration(u),{keys:I,overrides:m}}compareAndUpdateLocalUserConfiguration(u){const{added:o,updated:E,removed:w,overrides:m}=h(this.localUserConfiguration,u),I=[...o,...E,...w];return I.length&&this.updateLocalUserConfiguration(u),{keys:I,overrides:m}}compareAndUpdateRemoteUserConfiguration(u){const{added:o,updated:E,removed:w,overrides:m}=h(this.remoteUserConfiguration,u),I=[...o,...E,...w];return I.length&&this.updateRemoteUserConfiguration(u),{keys:I,overrides:m}}compareAndUpdateWorkspaceConfiguration(u){const{added:o,updated:E,removed:w,overrides:m}=h(this.workspaceConfiguration,u),I=[...o,...E,...w];return I.length&&this.updateWorkspaceConfiguration(u),{keys:I,overrides:m}}compareAndUpdateFolderConfiguration(u,o){const E=this.folderConfigurations.get(u),{added:w,updated:m,removed:I,overrides:d}=h(E,o),y=[...w,...m,...I];return(y.length||!E)&&this.updateFolderConfiguration(u,o),{keys:y,overrides:d}}compareAndDeleteFolderConfiguration(u){const o=this.folderConfigurations.get(u);if(!o)throw new Error("Unknown folder");this.deleteFolderConfiguration(u);const{added:E,updated:w,removed:m,overrides:I}=h(o,void 0);return{keys:[...E,...w,...m],overrides:I}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get folderConfigurations(){return this.j}p(u,o,E){let w=this.q(o,E);return o.overrideIdentifier&&(w=w.override(o.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(u)!==void 0&&(w=w.merge(this.d)),w}q({resource:u},o){let E=this.r();if(o&&u){const w=o.getFolder(u);w&&(E=this.s(w.uri)||E);const m=this.m.get(u);m&&(E=E.merge(m))}return E}r(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}s(u){let o=this.b.get(u);if(!o){const E=this.r(),w=this.j.get(u);w?(o=E.merge(w),this.b.set(u,o)):o=E}return o}t(u,o){if(o&&u){const E=o.getFolder(u);if(E)return this.j.get(E.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((u,o)=>{const{contents:E,overrides:w,keys:m}=this.j.get(o);return u.push([o,{contents:E,overrides:w,keys:m}]),u},[])}}allKeys(){const u=new Set;return this.c.keys.forEach(o=>u.add(o)),this.userConfiguration.keys.forEach(o=>u.add(o)),this.i.keys.forEach(o=>u.add(o)),this.j.forEach(o=>o.keys.forEach(E=>u.add(E))),[...u.values()]}u(){const u=new Set;return this.c.getAllOverrideIdentifiers().forEach(o=>u.add(o)),this.userConfiguration.getAllOverrideIdentifiers().forEach(o=>u.add(o)),this.i.getAllOverrideIdentifiers().forEach(o=>u.add(o)),this.j.forEach(o=>o.getAllOverrideIdentifiers().forEach(E=>u.add(E))),[...u.values()]}v(u){const o=new Set;return this.c.getKeysForOverrideIdentifier(u).forEach(E=>o.add(E)),this.userConfiguration.getKeysForOverrideIdentifier(u).forEach(E=>o.add(E)),this.i.getKeysForOverrideIdentifier(u).forEach(E=>o.add(E)),this.j.forEach(E=>E.getKeysForOverrideIdentifier(u).forEach(w=>o.add(w))),[...o.values()]}static parse(u){const o=this.w(u.defaults),E=this.w(u.policy),w=this.w(u.application),m=this.w(u.user),I=this.w(u.workspace),d=u.folders.reduce((y,b)=>(y.set(D.URI.revive(b[0]),this.w(b[1])),y),new R.$Ac);return new n(o,E,w,m,new $,I,d,new $,new R.$Ac)}static w(u){return new $(u.contents,u.keys,u.overrides)}}e.$fo=n;function r(...p){if(p.length===0)return{keys:[],overrides:[]};if(p.length===1)return p[0];const u=new Set,o=new Map;for(const w of p)w.keys.forEach(m=>u.add(m)),w.overrides.forEach(([m,I])=>{const d=(0,R.$xc)(o,m,new Set);I.forEach(y=>d.add(y))});const E=[];return o.forEach((w,m)=>E.push([m,[...w.values()]])),{keys:[...u.values()],overrides:E}}e.$go=r;class a{constructor(u,o,E,w){this.change=u,this.f=o,this.g=E,this.h=w,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.i=void 0;for(const m of u.keys)this.affectedKeys.add(m);for(const[,m]of u.overrides)for(const I of m)this.affectedKeys.add(I);this.d=this.a;for(const m of this.affectedKeys)this.d+=m+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=n.parse(this.f.data)),this.i}affectsConfiguration(u,o){const E=this.a+u,w=this.d.indexOf(E);if(w<0)return!1;const m=w+E.length;if(m>=this.d.length)return!1;const I=this.d.charCodeAt(m);if(I!==this.b&&I!==this.c)return!1;if(o){const d=this.previousConfiguration?this.previousConfiguration.getValue(u,o,this.f?.workspace):void 0,y=this.g.getValue(u,o,this.h);return!g.$Ln(d,y)}return!0}}e.$ho=a;function h(p,u){const{added:o,removed:E,updated:w}=i(u?.rawConfiguration,p?.rawConfiguration),m=[],I=p?.getAllOverrideIdentifiers()||[],d=u?.getAllOverrideIdentifiers()||[];if(u){const y=d.filter(b=>!I.includes(b));for(const b of y)m.push([b,u.getKeysForOverrideIdentifier(b)])}if(p){const y=I.filter(b=>!d.includes(b));for(const b of y)m.push([b,p.getKeysForOverrideIdentifier(b)])}if(u&&p){for(const y of I)if(d.includes(y)){const b=i({contents:p.getOverrideValue(void 0,y)||{},keys:p.getKeysForOverrideIdentifier(y)},{contents:u.getOverrideValue(void 0,y)||{},keys:u.getKeysForOverrideIdentifier(y)});m.push([y,[...b.added,...b.removed,...b.updated]])}}return{added:o,removed:E,updated:w,overrides:m}}function i(p,u){const o=p?u?p.keys.filter(m=>u.keys.indexOf(m)===-1):[...p.keys]:[],E=u?p?u.keys.filter(m=>p.keys.indexOf(m)===-1):[...u.keys]:[],w=[];if(p&&u){for(const m of u.keys)if(p.keys.indexOf(m)!==-1){const I=(0,M.$Si)(u.contents,m),d=(0,M.$Si)(p.contents,m);g.$Ln(I,d)||w.push(m)}}return{added:o,removed:E,updated:w}}}),define(Re[100],Ae([1,0,15,4]),function(fe,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kl=e.$jl=e.RemoteAuthorityResolverErrorCode=e.$il=e.$hl=e.RemoteConnectionType=e.$gl=void 0,e.$gl=(0,F.$ei)("remoteAuthorityResolverService");var P;(function(M){M[M.WebSocket=0]="WebSocket",M[M.Managed=1]="Managed"})(P||(e.RemoteConnectionType=P={}));class L{constructor(k){this.id=k,this.type=1}toString(){return`Managed(${this.id})`}}e.$hl=L;class R{constructor(k,l){this.host=k,this.port=l,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$il=R;var g;(function(M){M.Unknown="Unknown",M.NotAvailable="NotAvailable",M.TemporarilyNotAvailable="TemporarilyNotAvailable",M.NoResolverFound="NoResolverFound",M.InvalidAuthority="InvalidAuthority"})(g||(e.RemoteAuthorityResolverErrorCode=g={}));class f extends S.$bb{static isNotAvailable(k){return k instanceof f&&k._code===g.NotAvailable}static isTemporarilyNotAvailable(k){return k instanceof f&&k._code===g.TemporarilyNotAvailable}static isNoResolverFound(k){return k instanceof f&&k._code===g.NoResolverFound}static isInvalidAuthority(k){return k instanceof f&&k._code===g.InvalidAuthority}static isHandled(k){return k instanceof f&&k.isHandled}constructor(k,l=g.Unknown,v){super(k),this._message=k,this._code=l,this._detail=v,this.isHandled=l===g.NotAvailable&&v===!0,Object.setPrototypeOf(this,f.prototype)}}e.$jl=f;function D(M){const k=M.indexOf("+");return k===-1?M:M.substring(0,k)}e.$kl=D}),define(Re[57],Ae([1,0,12]),function(fe,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pl=e.$ol=e.$nl=e.$ml=e.$ll=void 0;function F(D){return D.scheme===S.Schemas.vscodeRemote?D.authority:void 0}e.$ll=F;function P(D){if(!D)return;const M=D.indexOf("+");return M<0?D:D.substr(0,M)}e.$ml=P;function L(D){return`/${D.quality??"oss"}-${D.commit??"dev"}`}e.$nl=L;function R(D){const{host:M,port:k}=f(D);if(typeof k>"u")throw new Error(`Invalid remote authority: ${D}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:M,port:k}}e.$ol=R;function g(D,M){let{host:k,port:l}=f(D);return typeof l>"u"&&(l=M),{host:k,port:l}}e.$pl=g;function f(D){const M=D.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(M)return{host:M[1],port:parseInt(M[2],10)};const k=D.match(/^(\[[0-9a-z:]+\])$/);if(k)return{host:k[1],port:void 0};const l=D.match(/(.*):(\d+)$/);return l?{host:l[1],port:parseInt(l[2],10)}:{host:D,port:void 0}}}),define(Re[20],Ae([1,0,13,4,57]),function(fe,e,S,F,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dm=e.$Cm=e.$Bm=e.$Am=e.$zm=e.$ym=e.$xm=e.$wm=e.TargetPlatform=e.ExtensionType=e.$vm=e.$um=e.$tm=e.$sm=e.$rm=e.$qm=void 0,e.$qm="extensions.user.cache",e.$rm="extensions.builtin.cache",e.$sm="undefined_publisher",e.$tm=["ui","workspace","web"];function L(s){if(typeof s=="object"&&s!==null&&s.supported!==!0)return s.description}e.$um=L,e.$vm=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var R;(function(s){s[s.System=0]="System",s[s.User=1]="User"})(R||(e.ExtensionType=R={}));var g;(function(s){s.WIN32_X64="win32-x64",s.WIN32_ARM64="win32-arm64",s.LINUX_X64="linux-x64",s.LINUX_ARM64="linux-arm64",s.LINUX_ARMHF="linux-armhf",s.ALPINE_X64="alpine-x64",s.ALPINE_ARM64="alpine-arm64",s.DARWIN_X64="darwin-x64",s.DARWIN_ARM64="darwin-arm64",s.WEB="web",s.UNIVERSAL="universal",s.UNKNOWN="unknown",s.UNDEFINED="undefined"})(g||(e.TargetPlatform=g={}));class f{constructor(c){this.value=c,this._lower=c.toLowerCase()}static equals(c,t){if(typeof c>"u"||c===null)return typeof t>"u"||t===null;if(typeof t>"u"||t===null)return!1;if(typeof c=="string"||typeof t=="string"){const n=typeof c=="string"?c:c.value,r=typeof t=="string"?t:t.value;return S.$jf(n,r)}return c._lower===t._lower}static toKey(c){return typeof c=="string"?c.toLowerCase():c._lower}}e.$wm=f;class D{get size(){return this.c.size}constructor(c){if(this.c=new Set,c)for(const t of c)this.add(t)}add(c){this.c.add(f.toKey(c))}delete(c){return this.c.delete(f.toKey(c))}has(c){return this.c.has(f.toKey(c))}}e.$xm=D;class M{constructor(){this.c=new Map}clear(){this.c.clear()}delete(c){this.c.delete(f.toKey(c))}get(c){return this.c.get(f.toKey(c))}has(c){return this.c.has(f.toKey(c))}set(c,t){this.c.set(f.toKey(c),t)}values(){return this.c.values()}forEach(c){this.c.forEach(c)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$ym=M;function k(s){return l(s)}e.$zm=k;function l(s){return s.contributes&&s.contributes.localizations?s.contributes.localizations.length>0:!1}e.$Am=l;function v(s){return s.contributes&&s.contributes.authentication?s.contributes.authentication.length>0:!1}e.$Bm=v;function $(s,c){if(c){const t=`onResolveRemoteAuthority:${(0,P.$ml)(c)}`;return!!s.activationEvents?.includes(t)}return!1}e.$Cm=$,e.$Dm=(0,F.$ei)("IBuiltinExtensionsScannerService")}),define(Re[101],Ae([1,0,15,20]),function(fe,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AF=e.$zF=void 0;class P{constructor(){this.a=new Map,this.b=new WeakMap}register(R,g){this.a.set(R,g)}readActivationEvents(R){return this.b.has(R)||this.b.set(R,this.c(R)),this.b.get(R)}createActivationEventsMap(R){const g=Object.create(null);for(const f of R){const D=this.readActivationEvents(f);D.length>0&&(g[F.$wm.toKey(f.identifier)]=D)}return g}c(R){if(typeof R.main>"u"&&typeof R.browser>"u")return[];const g=Array.isArray(R.activationEvents)?R.activationEvents.slice(0):[];for(let f=0;f<g.length;f++)g[f]==="onUri"&&(g[f]=`onUri:${F.$wm.toKey(R.identifier)}`);if(!R.contributes)return g;for(const f in R.contributes){const D=this.a.get(f);if(!D)continue;const M=R.contributes[f],k=Array.isArray(M)?M:[M];try{D(k,g)}catch(l){(0,S.$1)(l)}}return g}}e.$zF=P,e.$AF=new P}),define(Re[192],Ae([1,0,21,73,33]),function(fe,e,S,F,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vo=e.$Uo=void 0;function L(f){if(S.$u===2&&/^penguin(\.|$)/i.test(f))return"chromebook"}function R(f,D,M,k,l,v,$,s,c){const t=Object.create(null);t["common.machineId"]=v,t["common.sqmId"]=$,t.sessionID=(0,P.$Ag)()+Date.now(),t.commitHash=k,t.version=l,t["common.platformVersion"]=(f||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),t["common.platform"]=(0,S.$h)(S.$u),t["common.nodePlatform"]=F.$dc,t["common.nodeArch"]=M,t["common.product"]=c||"desktop",s&&(t["common.msftInternal"]=s);let n=0;const r=Date.now();Object.defineProperties(t,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-r,enumerable:!0},"common.sequence":{get:()=>n++,enumerable:!0}}),S.$l&&(t["common.snap"]="true");const a=L(D);return a&&(t["common.platformDetail"]=a),t}e.$Uo=R;function g(f){const D=F.env.USERDNSDOMAIN;if(!D)return!1;const M=D.toLowerCase();return f.some(k=>M===k)}e.$Vo=g}),define(Re[193],Ae([1,0,4]),function(fe,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$Pl=e.$Ol=e.$Nl=e.$Ml=e.$Ll=e.$Kl=e.$Jl=e.$Il=e.$Hl=e.$Gl=e.$Fl=void 0,e.$Fl=(0,S.$ei)("telemetryService"),e.$Gl=(0,S.$ei)("customEndpointTelemetryService"),e.$Hl="telemetry.currentSessionDate",e.$Il="telemetry.firstSessionDate",e.$Jl="telemetry.lastSessionDate",e.$Kl="telemetry.machineId",e.$Ll="telemetry.sqmId",e.$Ml="telemetry",e.$Nl="telemetry.telemetryLevel",e.$Ol="telemetry.enableCrashReporter",e.$Pl="telemetry.enableTelemetry";var F;(function(L){L[L.NONE=0]="NONE",L[L.CRASH=1]="CRASH",L[L.ERROR=2]="ERROR",L[L.USAGE=3]="USAGE"})(F||(e.TelemetryLevel=F={}));var P;(function(L){L.OFF="off",L.CRASH="crash",L.ERROR="error",L.ON="all"})(P||(e.TelemetryConfiguration=P={}))}),define(Re[58],Ae([1,0,26,16,57,192,193]),function(fe,e,S,F,P,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$o=e.$0o=e.$9o=e.$8o=e.$7o=e.$6o=e.$5o=e.$4o=e.$3o=e.$2o=e.$1o=e.$Zo=e.$Yo=e.$Xo=e.$Wo=void 0;class g{constructor(p){this.value=p,this.isTrustedTelemetryValue=!0}}e.$Wo=g;class f{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$Xo=f,e.$Yo=new f;class D{async publicLog(p,u,o){}async publicLogError(p,u,o){}}e.$Zo=D,e.$1o="telemetry",e.$2o="extensionTelemetryLog",e.$3o={log:()=>null,flush:()=>Promise.resolve(null)};function M(i,p){return!p.isBuilt&&!p.disableTelemetry?!0:!(p.disableTelemetry||!i.enableTelemetry)}e.$4o=M;function k(i,p){return p.extensionTestsLocationURI?!0:!(p.isBuilt||p.disableTelemetry||i.enableTelemetry&&i.aiConfig?.ariaKey)}e.$5o=k;function l(i){const p=i.getValue(R.$Nl),u=i.getValue(R.$Ol);if(i.getValue(R.$Pl)===!1||u===!1)return 0;switch(p??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$6o=l;function v(i){const p={},u={},o={};c(i,o);for(let E in o){E=E.length>150?E.substr(E.length-149):E;const w=o[E];typeof w=="number"?u[E]=w:typeof w=="boolean"?u[E]=w?1:0:typeof w=="string"?(w.length>8192&&console.warn(`Telemetry property: ${E} has been trimmed to 8192, the original length is ${w.length}`),p[E]=w.substring(0,8191)):typeof w<"u"&&w!==null&&(p[E]=w)}return{properties:p,measurements:u}}e.$7o=v;const $=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function s(i){if(!i)return"none";const p=(0,P.$ml)(i);return $.has(p)?p:"other"}e.$8o=s;function c(i,p,u=0,o){if(i)for(const E of Object.getOwnPropertyNames(i)){const w=i[E],m=o?o+E:E;Array.isArray(w)?p[m]=(0,S.$Mn)(w):w instanceof Date?p[m]=w.toISOString():(0,F.$Uf)(w)?u<2?c(w,p,u+1,m+"."):p[m]=(0,S.$Mn)(w):p[m]=w}}function t(i,p){const u=i.msftInternalDomains||[],o=p.getValue("telemetry.internalTesting");return(0,L.$Vo)(u)||o}e.$9o=t;function n(i){return[i.appRoot,i.extensionsPath,i.userHome.fsPath,i.tmpDir.fsPath,i.userDataPath]}e.$0o=n;function r(i,p){if(!i||!i.includes("/")&&!i.includes("\\"))return i;let u=i;const o=[];for(const I of p)for(;;){const d=I.exec(i);if(!d)break;o.push([d.index,I.lastIndex])}const E=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,w=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let m=0;for(u="";;){const I=w.exec(i);if(!I)break;const d=o.some(([y,b])=>I.index<b&&y<w.lastIndex);!E.test(I[0])&&!d&&(u+=i.substring(m,I.index)+"<REDACTED: user-file-path>",m=w.lastIndex)}return m<i.length&&(u+=i.substr(m)),u}function a(i){if(!i)return i;const p=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const u of p)if(u.regex.test(i))return`<REDACTED: ${u.label}>`;return i}function h(i,p){return(0,S.$Jn)(i,u=>{if(u instanceof g||Object.hasOwnProperty.call(u,"isTrustedTelemetryValue"))return u.value;if(typeof u=="string"){let o=u.replaceAll("%20"," ");o=r(o,p);for(const E of p)o=o.replace(E,"");return o=a(o),o}})}e.$$o=h}),define(Re[194],Ae([1,0,13,96,20,21,2,15,73,58]),function(fe,e,S,F,P,L,R,g,f,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kp=e.$jp=e.$ip=e.$hp=e.$gp=e.$fp=e.$ep=e.$dp=e.$cp=e.$bp=e.$ap=e.$_o=void 0;function M(u,o){return u.uuid&&o.uuid?u.uuid===o.uuid:u.id===o.id?!0:(0,S.$ef)(u.id,o.id)===0}e.$_o=M;const k=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class l{static create(o){const E=o.manifest?o.manifest.version:o.version,w=o.manifest?o.targetPlatform:o.properties.targetPlatform;return new l(o.identifier,E,w)}static parse(o){const E=k.exec(o);return E&&E[1]&&E[2]?new l({id:E[1]},E[2],E[4]||void 0):null}constructor(o,E,w="undefined"){this.version=E,this.targetPlatform=w,this.id=o.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(o){return o instanceof l?M(this,o)&&this.version===o.version&&this.targetPlatform===o.targetPlatform:!1}}e.$ap=l;const v=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function $(u){const o=v.exec(u);return o&&o[1]?[c(o[1]),o[2]]:[c(u),void 0]}e.$bp=$;function s(u,o){return`${u}.${o}`}e.$cp=s;function c(u){return u.toLowerCase()}e.$dp=c;function t(u,o){return c(s(u??P.$sm,o))}e.$ep=t;function n(u,o){const E=[],w=m=>{for(const I of E)if(I.some(d=>M(o(d),o(m))))return I;return null};for(const m of u){const I=w(m);I?I.push(m):E.push([m])}return E}e.$fp=n;function r(u){return{id:u.identifier.id,name:u.manifest.name,galleryId:null,publisherId:u.publisherId,publisherName:u.manifest.publisher,publisherDisplayName:u.publisherDisplayName,dependencies:u.manifest.extensionDependencies&&u.manifest.extensionDependencies.length>0}}e.$gp=r;function a(u){return{id:new D.$Wo(u.identifier.id),name:new D.$Wo(u.name),galleryId:u.identifier.uuid,publisherId:u.publisherId,publisherName:u.publisher,publisherDisplayName:u.publisherDisplayName,isPreReleaseVersion:u.properties.isPreReleaseVersion,dependencies:!!(u.properties.dependencies&&u.properties.dependencies.length>0),isSigned:u.isSigned,...u.telemetryData}}e.$hp=a,e.$ip=new P.$wm("pprice.better-merge");function h(u,o){const E=[],w=o.manifest.extensionDependencies?.slice(0)??[];for(;w.length;){const m=w.shift();if(m&&E.every(I=>!M(I.identifier,{id:m}))){const I=u.filter(d=>M(d.identifier,{id:m}));I.length===1&&(E.push(I[0]),w.push(...I[0].manifest.extensionDependencies?.slice(0)??[]))}}return E}e.$jp=h;async function i(u,o){if(!L.$k)return!1;let E;try{E=(await u.readFile(R.URI.file("/etc/os-release"))).value.toString()}catch{try{E=(await u.readFile(R.URI.file("/usr/lib/os-release"))).value.toString()}catch(m){o.debug("Error while getting the os-release file.",(0,g.$0)(m))}}return!!E&&(E.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function p(u,o){const E=await i(u,o),w=(0,F.$Go)(E?"alpine":L.$u,f.$ec);return o.debug("ComputeTargetPlatform:",w),w}e.$kp=p}),define(Re[195],Ae([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3r=e.$2r=e.$1r=e.$Zr=e.$Yr=e.$Xr=void 0;function S(f){return[...f.entries()]}e.$Xr=S;function F(f){return f?[...f.entries()]:[]}e.$Yr=F;function P(f){return new Map(f)}e.$Zr=P;function L(f){return new Map(f??[])}e.$1r=L;function R(f){return Array.from(f.entries()).map(D=>[D[0],S(D[1].map),F(D[1].descriptionMap)])}e.$2r=R;function g(f){return new Map(f.map(D=>[D[0],{map:P(D[1]),descriptionMap:L(D[2])}]))}e.$3r=g}),define(Re[196],Ae([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gtb=void 0;class S{constructor(P){this.b=P,this.a=new Map}dispose(){for(const P of this.a.values())P.dispose()}startBuffering(P,L,R=5){const g=L(f=>{const D=typeof f=="string"?f:f.data;let M=this.a.get(P);if(M){M.data.push(D);return}const k=setTimeout(()=>this.flushBuffer(P),R);M={data:[D],timeoutId:k,dispose:()=>{clearTimeout(k),this.flushBuffer(P),g.dispose()}},this.a.set(P,M)});return g}stopBuffering(P){this.a.get(P)?.dispose()}flushBuffer(P){const L=this.a.get(P);L&&(this.a.delete(P),this.b(P,L.data.join("")))}}e.$Gtb=S}),define(Re[197],Ae([1,0,11,89,41,5,16,2,156,72,30]),function(fe,e,S,F,P,L,R,g,f,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qw=e.$Pw=e.$Ow=e.$Nw=e.$Mw=e.$Lw=e.$Kw=e.$Jw=e.IconFontDefinition=e.IconContribution=e.$Iw=void 0,e.$Iw={IconContribution:"base.contributions.icons"};var k;(function(a){function h(i,p){let u=i.defaults;for(;P.ThemeIcon.isThemeIcon(u);){const o=$.getIcon(u.id);if(!o)return;u=o.defaults}return u}a.getDefinition=h})(k||(e.IconContribution=k={}));var l;(function(a){function h(p){return{weight:p.weight,style:p.style,src:p.src.map(u=>({format:u.format,location:u.location.toString()}))}}a.toJSONObject=h;function i(p){const u=o=>(0,R.$Sf)(o)?o:void 0;if(p&&Array.isArray(p.src)&&p.src.every(o=>(0,R.$Sf)(o.format)&&(0,R.$Sf)(o.location)))return{weight:u(p.weight),style:u(p.style),src:p.src.map(o=>({format:o.format,location:g.URI.parse(o.location)}))}}a.fromJSONObject=i})(l||(e.IconFontDefinition=l={}));class v{constructor(){this.a=new L.$5d,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,f.localize)(0,null)},fontCharacter:{type:"string",description:(0,f.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${P.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(h,i,p,u){const o=this.b[h];if(o){if(p&&!o.description){o.description=p,this.d.properties[h].markdownDescription=`${p} $(${h})`;const m=this.e.enum.indexOf(h);m!==-1&&(this.e.enumDescriptions[m]=p),this.a.fire()}return o}const E={id:h,description:p,defaults:i,deprecationMessage:u};this.b[h]=E;const w={$ref:"#/definitions/icons"};return u&&(w.deprecationMessage=u),p&&(w.markdownDescription=`${p}: $(${h})`),this.d.properties[h]=w,this.e.enum.push(h),this.e.enumDescriptions.push(p||""),this.a.fire(),{id:h}}deregisterIcon(h){delete this.b[h],delete this.d.properties[h];const i=this.e.enum.indexOf(h);i!==-1&&(this.e.enum.splice(i,1),this.e.enumDescriptions.splice(i,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(h=>this.b[h])}getIcon(h){return this.b[h]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(h,i){const p=this.f[h];return p||(this.f[h]=i,this.a.fire(),i)}deregisterIconFont(h){delete this.f[h]}getIconFont(h){return this.f[h]}toString(){const h=(o,E)=>o.id.localeCompare(E.id),i=o=>{for(;P.ThemeIcon.isThemeIcon(o.defaults);)o=this.b[o.defaults.id];return`codicon codicon-${o?o.id:""}`},p=[];p.push("| preview     | identifier                        | default codicon ID                | description"),p.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const u=Object.keys(this.b).map(o=>this.b[o]);for(const o of u.filter(E=>!!E.description).sort(h))p.push(`|<i class="${i(o)}"></i>|${o.id}|${P.ThemeIcon.isThemeIcon(o.defaults)?o.defaults.id:o.id}|${o.description||""}|`);p.push("| preview     | identifier                        "),p.push("| ----------- | --------------------------------- |");for(const o of u.filter(E=>!P.ThemeIcon.isThemeIcon(E.defaults)).sort(h))p.push(`|<i class="${i(o)}"></i>|${o.id}|`);return p.join(`
`)}}const $=new v;M.$Tn.add(e.$Iw.IconContribution,$);function s(a,h,i,p){return $.registerIcon(a,h,i,p)}e.$Jw=s;function c(){return $}e.$Kw=c;function t(){const a=(0,F.$ik)();for(const h in a){const i="\\"+a[h].toString(16);$.registerIcon(h,{fontCharacter:i})}}t(),e.$Lw="vscode://schemas/icons";const n=M.$Tn.as(D.$Un.JSONContribution);n.registerSchema(e.$Lw,$.getIconSchema());const r=new S.$qh(()=>n.notifySchemaChanged(e.$Lw),200);$.onDidChange(()=>{r.isScheduled()||r.schedule()}),e.$Mw=s("widget-close",F.$kk.close,(0,f.localize)(2,null)),e.$Nw=s("goto-previous-location",F.$kk.arrowUp,(0,f.localize)(3,null)),e.$Ow=s("goto-next-location",F.$kk.arrowDown,(0,f.localize)(4,null)),e.$Pw=P.ThemeIcon.modify(F.$kk.sync,"spin"),e.$Qw=P.ThemeIcon.modify(F.$kk.loading,"spin")}),define(Re[198],Ae([1,0,5,46,4,14]),function(fe,e,S,F,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wv=e.$Vv=e.$Uv=e.$Tv=e.$Sv=e.$Rv=e.$Qv=e.$Pv=e.ProvidedOnAutoForward=e.$Ov=e.TunnelPrivacyId=e.TunnelProtocol=e.$Nv=e.$Mv=void 0,e.$Mv=(0,P.$ei)("tunnelService"),e.$Nv=(0,P.$ei)("sharedTunnelsService");var R;(function(c){c.Http="http",c.Https="https"})(R||(e.TunnelProtocol=R={}));var g;(function(c){c.ConstantPrivate="constantPrivate",c.Private="private",c.Public="public"})(g||(e.TunnelPrivacyId=g={}));function f(c){return!!c.forwardPort}e.$Ov=f;var D;(function(c){c[c.Notify=1]="Notify",c[c.OpenBrowser=2]="OpenBrowser",c[c.OpenPreview=3]="OpenPreview",c[c.Silent=4]="Silent",c[c.Ignore=5]="Ignore",c[c.OpenBrowserOnce=6]="OpenBrowserOnce"})(D||(e.ProvidedOnAutoForward=D={}));function M(c){if(c.scheme!=="http"&&c.scheme!=="https")return;const t=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(c.authority);if(t)return{address:t[1],port:+t[2]}}e.$Pv=M,e.$Qv=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function k(c){return e.$Qv.indexOf(c)>=0}e.$Rv=k,e.$Sv=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function l(c){return e.$Sv.indexOf(c)>=0}e.$Tv=l;function v(c,t,n,r){if(n===1)return!1;if(n===2&&l(t)){const a=/(\d+)\.(\d+)\.(\d+)/g.exec(r);if(a?.length===4&&parseInt(a[1])>=18)return!1}return c<1024}e.$Uv=v;class ${constructor(t,n,r){this.remoteAddress=t,this.localAddress=n,this.b=r,this.a=new S.$5d,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$Vv=$;let s=class{constructor(t,n){this.k=t,this.l=n,this.a=new S.$5d,this.onTunnelOpened=this.a.event,this.b=new S.$5d,this.onTunnelClosed=this.b.event,this.c=new S.$5d,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=!0,this.i=[],this.j=new Set}get hasTunnelProvider(){return!!this.f}get m(){const t=this.l.getValue("remote.localPortHost");return!t||t==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(t){return this.f=t,t?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.i=[]}}):(this.g=!1,this.i=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(t){this.g=t.elevation,this.i=t.privacyOptions,this.h=t.protocol}get canChangeProtocol(){return this.h}get canElevate(){return this.g}get canChangePrivacy(){return this.i.length>0}get privacyOptions(){return this.i}get tunnels(){return this.n()}async n(){const t=[],n=Array.from(this.e.values());for(const r of n){const a=Array.from(r.values());for(const h of a){const i=await h.value;i&&typeof i!="string"&&t.push(i)}}return t}async dispose(){for(const t of this.e.values()){for(const{value:n}of t.values())await n.then(r=>typeof r!="string"?r?.dispose():void 0);t.clear()}this.e.clear()}setEnvironmentTunnel(t,n,r,a,h){this.q(t,n,Promise.resolve({tunnelRemoteHost:t,tunnelRemotePort:n,localAddress:r,privacy:a,protocol:h,dispose:()=>Promise.resolve()}))}async getExistingTunnel(t,n){(l(t)||k(t))&&(t=e.$Qv[0]);const r=this.s(t,n);if(r)return++r.refcount,r.value}openTunnel(t,n,r,a,h,i=!1,p,u){this.k.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${n}:${r} on local port ${h}.`);const o=this.f??t;if(!o)return;if(n||(n="localhost"),a||(a=this.m),this.f&&this.j.has(r)){this.k.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const E=this.t(o,n,r,a,h,i,p,u);return E?E.then(w=>{if(w){if(typeof w=="string")return this.k.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.r(n,r),w}else{this.k.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.r(n,r);return}this.k.trace("ForwardedPorts: (TunnelService) New tunnel established.");const m=this.o(w);return(w.tunnelRemoteHost!==n||w.tunnelRemotePort!==r)&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),p&&w.privacy!==p&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(m),m}):(this.k.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),E)}o(t){return{tunnelRemotePort:t.tunnelRemotePort,tunnelRemoteHost:t.tunnelRemoteHost,tunnelLocalPort:t.tunnelLocalPort,localAddress:t.localAddress,privacy:t.privacy,protocol:t.protocol,dispose:async()=>{this.k.trace(`ForwardedPorts: (TunnelService) dispose request for ${t.tunnelRemoteHost}:${t.tunnelRemotePort} `);const n=this.e.get(t.tunnelRemoteHost);if(n){const r=n.get(t.tunnelRemotePort);r&&(r.refcount--,await this.p(t.tunnelRemoteHost,t.tunnelRemotePort,r))}}}}async p(t,n,r){if(r.refcount<=0){this.k.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${t}:${n}.`);const a=r.value.then(async h=>{h&&typeof h!="string"&&(await h.dispose(!0),this.b.fire({host:h.tunnelRemoteHost,port:h.tunnelRemotePort}))});return this.e.has(t)&&this.e.get(t).delete(n),a}}async closeTunnel(t,n){this.k.trace(`ForwardedPorts: (TunnelService) close request for ${t}:${n} `);const r=this.e.get(t);if(r&&r.has(n)){const a=r.get(n);a.refcount=0,await this.p(t,n,a)}}q(t,n,r){this.e.has(t)||this.e.set(t,new Map),this.e.get(t).set(n,{refcount:1,value:r})}async r(t,n){const r=this.e.get(t);if(r){const a=r.get(n),h=a?await a.value:void 0;(!h||typeof h=="string")&&r.delete(n),r.size===0&&this.e.delete(t)}}s(t,n){const r=[t];k(t)?(r.push(...e.$Qv),r.push(...e.$Sv)):l(t)&&r.push(...e.$Sv);const a=r.map(h=>this.e.get(h));for(const h of a){const i=h?.get(n);if(i)return i}}canTunnel(t){return!!M(t)}u(t,n,r,a,h,i,p){this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${n}:${r} on local port ${a}.`);const u=r;this.j.add(u);const o=a===void 0?r:a,E={elevationRequired:h?this.isPortPrivileged(o):!1},w={remoteAddress:{host:n,port:r},localAddressPort:a,privacy:i,public:i?i!==g.Private:void 0,protocol:p},m=t.forwardPort(w,E);return m?(this.q(n,r,m),m.finally(()=>{this.k.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.j.delete(u)})):this.j.delete(u),m}};e.$Wv=s,e.$Wv=s=Ze([qe(0,L.$yj),qe(1,F.$Ki)],s)}),define(Re[199],Ae([1,0,4]),function(fe,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$Xv=void 0,e.$Xv=(0,S.$ei)("editSessionIdentityService");var F;(function(P){P[P.Complete=100]="Complete",P[P.Partial=50]="Partial",P[P.None=0]="None"})(F||(e.EditSessionIdentityMatch=F={}))}),define(Re[200],Ae([1,0,12]),function(fe,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AL=e.$zL=e.$yL=e.$xL=e.$wL=void 0;function F(f){return f.scheme!==S.Schemas.file&&f.scheme!==S.Schemas.vscodeRemote}e.$wL=F;function P(f){if(f.folders.length)return f.folders.every(D=>F(D.uri))?f.folders[0].uri:void 0;if(f.configuration&&F(f.configuration))return f.configuration}e.$xL=P;function L(f){return P(f)?.scheme}e.$yL=L;function R(f){return P(f)?.authority}e.$zL=R;function g(f){return P(f)!==void 0}e.$AL=g}),define(Re[47],Ae([1,0,157,19,50,25,2,4,12]),function(fe,e,S,F,P,L,R,g,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ji=e.$Ii=e.$Hi=e.$Gi=e.$Fi=e.$Ei=e.$Di=e.$Ci=e.$Bi=e.$Ai=e.$zi=e.$yi=e.$xi=e.$wi=e.$vi=e.WorkbenchState=e.$ui=e.$ti=e.$si=e.$ri=e.$qi=e.$pi=e.$oi=e.$ni=void 0,e.$ni=(0,g.$ei)("contextService");function D(o){const E=o;return typeof E?.id=="string"&&R.URI.isUri(E.uri)}e.$oi=D;function M(o){return typeof o?.id=="string"&&!D(o)&&!l(o)}e.$pi=M,e.$qi={id:"ext-dev"},e.$ri={id:"empty-window"};function k(o,E){if(typeof o=="string"||typeof o>"u")return typeof o=="string"?{id:(0,F.$nc)(o)}:E?e.$qi:e.$ri;const w=o;return w.configuration?{id:w.id,configPath:w.configuration}:w.folders.length===1?{id:w.id,uri:w.folders[0].uri}:{id:w.id}}e.$si=k;function l(o){const E=o;return typeof E?.id=="string"&&R.URI.isUri(E.configPath)}e.$ti=l;function v(o){const E=o;if(E?.uri)return{id:E.id,uri:R.URI.revive(E.uri)};const w=o;if(w?.configPath)return{id:w.id,configPath:R.URI.revive(w.configPath)};if(o?.id)return{id:o.id}}e.$ui=v;var $;(function(o){o[o.EMPTY=1]="EMPTY",o[o.FOLDER=2]="FOLDER",o[o.WORKSPACE=3]="WORKSPACE"})($||(e.WorkbenchState=$={}));function s(o){const E=o;return!!(E&&typeof E=="object"&&typeof E.id=="string"&&Array.isArray(E.folders))}e.$vi=s;function c(o){const E=o;return!!(E&&typeof E=="object"&&R.URI.isUri(E.uri)&&typeof E.name=="string"&&typeof E.toResource=="function")}e.$wi=c;class t{constructor(E,w,m,I,d){this.h=E,this.j=m,this.k=I,this.l=d,this.c=P.$ki.forUris(this.l,()=>!0),this.folders=w}update(E){this.h=E.id,this.k=E.configuration,this.j=E.transient,this.l=E.l,this.folders=E.folders}get folders(){return this.g}set folders(E){this.g=E,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(E){this.k=E}getFolder(E){return E&&this.c.findSubstr(E)||null}n(){this.c=P.$ki.forUris(this.l,()=>!0);for(const E of this.folders)this.c.set(E.uri,E)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$xi=t;class n{constructor(E,w){this.raw=w,this.uri=E.uri,this.index=E.index,this.name=E.name}toResource(E){return(0,L.$Rg)(this.uri,E)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$yi=n;function r(o){return new n({uri:o,index:0,name:(0,L.$Ng)(o)},{uri:o.toString()})}e.$zi=r,e.$Ai="code-workspace",e.$Bi=`.${e.$Ai}`,e.$Ci=[{name:(0,S.localize)(0,null),extensions:[e.$Ai]}],e.$Di="workspace.json";function a(o,E){return L.$Ig.isEqualOrParent(o,E.untitledWorkspacesHome)}e.$Ei=a;function h(o){let E;return R.URI.isUri(o)?E=o:E=o.configuration,E?.scheme===f.Schemas.tmp}e.$Fi=h,e.$Gi="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function i(o){return o.id===e.$Gi}e.$Hi=i;function p(o,E){return!a(o,E)&&!h(o)}e.$Ii=p;function u(o){return(typeof o=="string"?(0,F.$oc)(o):(0,L.$Pg)(o))===e.$Bi}e.$Ji=u}),define(Re[74],Ae([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dhc=void 0;class S{static{this.a=!1}constructor(P){this.d=P,this.b=new Map,this.c=1}add(P){const L=this.c++;return this.b.set(L,P),this.e(),L}get(P,L){return this.b.has(P)?this.b.get(P)[L]:void 0}delete(P){this.b.delete(P),this.e()}e(){S.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$Dhc=S}),define(Re[43],Ae([1,0,12,25,4]),function(fe,e,S,F,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jhc=e.$Ihc=void 0;class L{constructor(){this.a=new Set(Object.keys(S.Schemas)),this.b=new Map,this.extUri=new F.$Gg(g=>{const f=this.b.get(g.scheme);return!(f===void 0||f&1024)})}$acceptProviderInfos(g,f){f===null?this.b.delete(g.scheme):this.b.set(g.scheme,f)}isFreeScheme(g){return!this.b.has(g)&&!this.a.has(g)}getCapabilities(g){return this.b.get(g)}}e.$Ihc=L,e.$Jhc=(0,P.$ei)("IExtHostFileSystemInfo")}),define(Re[27],Ae([1,0,4]),function(fe,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uO=void 0,e.$uO=(0,S.$ei)("IExtHostInitDataService")}),define(Re[201],Ae([1,0,163,14,188,27]),function(fe,e,S,F,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Njc=void 0;let R=class extends P.$BP{constructor(f,D,M){const k=M.remote.isRemote?"remoteexthost":f?"workerexthost":"exthost",l=M.remote.isRemote?(0,S.localize)(0,null):f?(0,S.localize)(1,null):(0,S.localize)(2,null);super(D.createLogger(k,{name:l}))}};e.$Njc=R,e.$Njc=R=Ze([qe(1,F.$zj),qe(2,L.$uO)],R)}),define(Re[202],Ae([1,0,11]),function(fe,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qic=e.$pic=void 0;class F{constructor(R,g,f){this.h=new Map,this.a=R,this.b=g,this.c=f,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(D=>(this.f=D,this)),this.g=this.c.onDidChangeStorage(D=>{D.shared===this.b&&D.key===this.a&&(this.f=D.value)}),this.i=new S.$qh(()=>{const D=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const M of D.values())M.complete()}catch(M){for(const k of D.values())k.error(M)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,R])=>R!==void 0).map(([R])=>R)}get whenReady(){return this.d}get(R,g){let f=this.f[R];return typeof f>"u"&&(f=g),f}update(R,g){this.f[R]=g;const f=this.h.get(R);if(f!==void 0)return f.p;const D=new S.$Bh;return this.h.set(R,D),this.i.isScheduled()||this.i.schedule(),D.p}dispose(){this.g.dispose()}}e.$pic=F;class P extends F{setKeysForSync(R){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},R)}constructor(R,g){super(R.identifier.value,!0,g),this.j=R}}e.$qic=P}),define(Re[203],Ae([1,0,5,2]),function(fe,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$djc=void 0;class P{constructor(R){this.c=R,this.a=new S.$5d,this.onDidSaveNotebookDocument=this.a.event,this.b=new S.$5d,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(R,g,f,D){const k=this.c.getNotebookDocument(F.URI.revive(R)).acceptModelChanged(g.value,f,D);this.b.fire(k)}$acceptDirtyStateChanged(R,g){this.c.getNotebookDocument(F.URI.revive(R)).acceptDirty(g)}$acceptModelSaved(R){const g=this.c.getNotebookDocument(F.URI.revive(R));this.a.fire(g.apiNotebook)}}e.$djc=P}),define(Re[17],Ae([1,0,4]),function(fe,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fO=e.$eO=void 0,e.$eO=(0,S.$ei)("IExtHostRpcService");class F{constructor(L){this.getProxy=L.getProxy.bind(L),this.set=L.set.bind(L),this.dispose=L.dispose.bind(L),this.assertRegistered=L.assertRegistered.bind(L),this.drain=L.drain.bind(L)}}e.$fO=F}),define(Re[204],Ae([1,0,20,5]),function(fe,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xic=void 0;class P{#e;constructor(R,g){this.b=new F.$5d,this.onDidChange=this.b.event,this.a=S.$wm.toKey(R.identifier),this.#e=g,this.#e.onDidChangePassword(f=>{f.extensionId===this.a&&this.b.fire({key:f.key})})}get(R){return this.#e.get(this.a,R)}store(R,g){return this.#e.store(this.a,R,g)}delete(R){return this.#e.delete(this.a,R)}}e.$xic=P}),define(Re[59],Ae([1,0,4]),function(fe,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1hc=e.$Zhc=void 0,e.$Zhc=(0,S.$ei)("IURITransformerService");class F{constructor(L){L?(this.transformIncoming=L.transformIncoming.bind(L),this.transformOutgoing=L.transformOutgoing.bind(L),this.transformOutgoingURI=L.transformOutgoingURI.bind(L),this.transformOutgoingScheme=L.transformOutgoingScheme.bind(L)):(this.transformIncoming=R=>R,this.transformOutgoing=R=>R,this.transformOutgoingURI=R=>R,this.transformOutgoingScheme=R=>R)}}e.$1hc=F}),define(Re[205],Ae([1,0,24]),function(fe,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$anb=e.$_mb=void 0;class F{constructor(){this.buffers=[]}add(f){let D=this.buffers.indexOf(f);return D<0&&(D=this.buffers.length,this.buffers.push(f)),D}}function P(g,f){if(f.serializeBuffersForPostMessage){const D=new F,k=JSON.stringify(g,(v,$)=>{if($ instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:D.add($)};if(ArrayBuffer.isView($)){const s=L($);if(s)return{$$vscode_array_buffer_reference$$:!0,index:D.add($.buffer),view:{type:s,byteLength:$.byteLength,byteOffset:$.byteOffset}}}return $}),l=D.buffers.map(v=>{const $=new Uint8Array(v);return S.$se.wrap($)});return{message:k,buffers:l}}else return{message:JSON.stringify(g),buffers:[]}}e.$_mb=P;function L(g){switch(g.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function R(g,f){const D=f.map(l=>{const v=new ArrayBuffer(l.byteLength);return new Uint8Array(v).set(l.buffer),v}),M=f.length?(l,v)=>{if(v&&typeof v=="object"&&v.$$vscode_array_buffer_reference$$){const $=v,{index:s}=$,c=D[s];if($.view)switch($.view.type){case 1:return new Int8Array(c,$.view.byteOffset,$.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(c,$.view.byteOffset,$.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(c,$.view.byteOffset,$.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(c,$.view.byteOffset,$.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(c,$.view.byteOffset,$.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(c,$.view.byteOffset,$.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(c,$.view.byteOffset,$.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(c,$.view.byteOffset,$.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(c,$.view.byteOffset,$.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(c,$.view.byteOffset,$.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(c,$.view.byteOffset,$.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return c}return v}:void 0;return{message:JSON.parse(g,M),arrayBuffers:D}}e.$anb=R}),define(Re[102],Ae([1,0,172,16,2,6,4,30,42,12,34,135,32]),function(fe,e,S,F,P,L,R,g,f,D,M,k,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gF=e.$fF=e.$eF=e.EditorsOrder=e.$dF=e.CloseDirection=e.$cF=e.$bF=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$aF=e.$_E=e.$$E=e.$0E=e.$9E=e.$8E=e.$7E=e.$6E=e.EditorInputCapabilities=e.$5E=e.SaveReason=e.Verbosity=e.$4E=e.$3E=e.$2E=e.$1E=e.$ZE=e.$YE=e.$XE=e.$WE=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$VE=e.$UE=e.$TE=e.$SE=e.$RE=void 0,e.$RE={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$SE={id:"default",displayName:(0,S.localize)(0,null),providerDisplayName:(0,S.localize)(1,null)},e.$TE="workbench.editor.sidebysideEditor",e.$UE="workbench.editors.textDiffEditor",e.$VE="workbench.editors.binaryResourceDiffEditor";var v;(function(ee){ee[ee.PROGRAMMATIC=1]="PROGRAMMATIC",ee[ee.USER=2]="USER",ee[ee.EDIT=3]="EDIT",ee[ee.NAVIGATION=4]="NAVIGATION",ee[ee.JUMP=5]="JUMP"})(v||(e.EditorPaneSelectionChangeReason=v={}));var $;(function(ee){ee[ee.IDENTICAL=1]="IDENTICAL",ee[ee.SIMILAR=2]="SIMILAR",ee[ee.DIFFERENT=3]="DIFFERENT"})($||(e.EditorPaneSelectionCompareResult=$={}));function s(ee){const Q=ee;return!!Q&&typeof Q.getSelection=="function"&&!!Q.onDidChangeSelection}e.$WE=s;function c(ee,Q,q){for(const ne of q.visibleEditorPanes)if(ne.group.id===Q&&ee.matches(ne.input))return ne.getViewState()}e.$XE=c;function t(ee){if(m(ee))return!1;const Q=ee;return P.URI.isUri(Q?.resource)}e.$YE=t;function n(ee){if(m(ee))return!1;const Q=ee;return Q?.original!==void 0&&Q.modified!==void 0}e.$ZE=n;function r(ee){if(m(ee))return!1;const Q=ee;return!Q||Q.resources&&!Array.isArray(Q.resources)?!1:!!Q.resources||!!Q.multiDiffSource}e.$1E=r;function a(ee){if(m(ee)||n(ee))return!1;const Q=ee;return Q?.primary!==void 0&&Q.secondary!==void 0}e.$2E=a;function h(ee){if(m(ee))return!1;const Q=ee;return Q?Q.resource===void 0||Q.resource.scheme===D.Schemas.untitled||Q.forceUntitled===!0:!1}e.$3E=h;function i(ee){if(m(ee))return!1;const Q=ee;return P.URI.isUri(Q?.base?.resource)&&P.URI.isUri(Q?.input1?.resource)&&P.URI.isUri(Q?.input2?.resource)&&P.URI.isUri(Q?.result?.resource)}e.$4E=i;var p;(function(ee){ee[ee.SHORT=0]="SHORT",ee[ee.MEDIUM=1]="MEDIUM",ee[ee.LONG=2]="LONG"})(p||(e.Verbosity=p={}));var u;(function(ee){ee[ee.EXPLICIT=1]="EXPLICIT",ee[ee.AUTO=2]="AUTO",ee[ee.FOCUS_CHANGE=3]="FOCUS_CHANGE",ee[ee.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(u||(e.SaveReason=u={}));class o{constructor(){this.a=new Map}registerSource(Q,q){let ne=this.a.get(Q);return ne||(ne={source:Q,label:q},this.a.set(Q,ne)),ne.source}getSourceLabel(Q){return this.a.get(Q)?.label??Q}}e.$5E=new o;var E;(function(ee){ee[ee.None=0]="None",ee[ee.Readonly=2]="Readonly",ee[ee.Untitled=4]="Untitled",ee[ee.Singleton=8]="Singleton",ee[ee.RequiresTrust=16]="RequiresTrust",ee[ee.CanSplitInGroup=32]="CanSplitInGroup",ee[ee.ForceDescription=64]="ForceDescription",ee[ee.CanDropIntoEditor=128]="CanDropIntoEditor",ee[ee.MultipleEditors=256]="MultipleEditors",ee[ee.Scratchpad=512]="Scratchpad",ee[ee.AuxWindowUnsupported=1024]="AuxWindowUnsupported"})(E||(e.EditorInputCapabilities=E={}));class w extends L.$Tc{}e.$6E=w;function m(ee){return ee instanceof w}e.$7E=m;function I(ee){const Q=ee;return P.URI.isUri(Q?.preferredResource)}function d(ee){const Q=ee;return m(Q?.primary)&&m(Q?.secondary)}e.$8E=d;function y(ee){const Q=ee;return m(Q?.modified)&&m(Q?.original)}e.$9E=y;function b(ee,Q,q,ne,Se){return $e(ne,[(0,k.$1i)({id:"workbench.action.openLargeFile",label:(0,S.localize)(2,null),run:()=>{const Te={...q,limits:{size:Number.MAX_VALUE}};ee.openEditor(Q,Te)}}),(0,k.$1i)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,S.localize)(3,null),run:()=>Se.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:l.default.Warning})}e.$0E=b;function A(ee){return m(ee?.editor)}e.$$E=A;function T(ee){const Q=ee;return A(ee)&&Q?.group!==void 0}e.$_E=T;function G(ee){const Q=ee;return typeof Q?.groupId=="number"&&m(Q.editor)}e.$aF=G;var W;(function(ee){ee[ee.UNKNOWN=0]="UNKNOWN",ee[ee.REPLACE=1]="REPLACE",ee[ee.MOVE=2]="MOVE",ee[ee.UNPIN=3]="UNPIN"})(W||(e.EditorCloseContext=W={}));var U;(function(ee){ee[ee.GROUP_ACTIVE=0]="GROUP_ACTIVE",ee[ee.GROUP_INDEX=1]="GROUP_INDEX",ee[ee.GROUP_LABEL=2]="GROUP_LABEL",ee[ee.GROUP_LOCKED=3]="GROUP_LOCKED",ee[ee.EDITOR_OPEN=4]="EDITOR_OPEN",ee[ee.EDITOR_CLOSE=5]="EDITOR_CLOSE",ee[ee.EDITOR_MOVE=6]="EDITOR_MOVE",ee[ee.EDITOR_ACTIVE=7]="EDITOR_ACTIVE",ee[ee.EDITOR_LABEL=8]="EDITOR_LABEL",ee[ee.EDITOR_CAPABILITIES=9]="EDITOR_CAPABILITIES",ee[ee.EDITOR_PIN=10]="EDITOR_PIN",ee[ee.EDITOR_STICKY=11]="EDITOR_STICKY",ee[ee.EDITOR_DIRTY=12]="EDITOR_DIRTY",ee[ee.EDITOR_WILL_DISPOSE=13]="EDITOR_WILL_DISPOSE"})(U||(e.GroupModelChangeKind=U={}));var C;(function(ee){ee[ee.PRIMARY=1]="PRIMARY",ee[ee.SECONDARY=2]="SECONDARY",ee[ee.BOTH=3]="BOTH",ee[ee.ANY=4]="ANY"})(C||(e.SideBySideEditor=C={}));class O{getOriginalUri(Q,q){if(!Q)return;if(i(Q))return e.$cF.getOriginalUri(Q.result,q);if(q?.supportSideBySide){const{primary:Se,secondary:Te}=this.a(Q);if(Se&&Te){if(q?.supportSideBySide===C.BOTH)return{primary:this.getOriginalUri(Se,{filterByScheme:q.filterByScheme}),secondary:this.getOriginalUri(Te,{filterByScheme:q.filterByScheme})};if(q?.supportSideBySide===C.ANY)return this.getOriginalUri(Se,{filterByScheme:q.filterByScheme})??this.getOriginalUri(Te,{filterByScheme:q.filterByScheme});Q=q.supportSideBySide===C.PRIMARY?Se:Te}}if(n(Q)||r(Q)||a(Q)||i(Q))return;const ne=I(Q)?Q.preferredResource:Q.resource;return!ne||!q||!q.filterByScheme?ne:this.b(ne,q.filterByScheme)}a(Q){return d(Q)||a(Q)?{primary:Q.primary,secondary:Q.secondary}:y(Q)||n(Q)?{primary:Q.modified,secondary:Q.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(Q,q){if(!Q)return;if(i(Q))return e.$cF.getCanonicalUri(Q.result,q);if(q?.supportSideBySide){const{primary:Se,secondary:Te}=this.a(Q);if(Se&&Te){if(q?.supportSideBySide===C.BOTH)return{primary:this.getCanonicalUri(Se,{filterByScheme:q.filterByScheme}),secondary:this.getCanonicalUri(Te,{filterByScheme:q.filterByScheme})};if(q?.supportSideBySide===C.ANY)return this.getCanonicalUri(Se,{filterByScheme:q.filterByScheme})??this.getCanonicalUri(Te,{filterByScheme:q.filterByScheme});Q=q.supportSideBySide===C.PRIMARY?Se:Te}}if(n(Q)||r(Q)||a(Q)||i(Q))return;const ne=Q.resource;return!ne||!q||!q.filterByScheme?ne:this.b(ne,q.filterByScheme)}b(Q,q){if(Array.isArray(q)){if(q.some(ne=>Q.scheme===ne))return Q}else if(q===Q.scheme)return Q}}var V;(function(ee){ee[ee.UNKNOWN=0]="UNKNOWN",ee[ee.KEYBOARD=1]="KEYBOARD",ee[ee.MOUSE=2]="MOUSE"})(V||(e.EditorCloseMethod=V={}));function re(ee,Q,q,ne){if(!ee.isSticky(Q))return!1;switch(ne.preventPinnedEditorClose){case"keyboardAndMouse":return q===V.MOUSE||q===V.KEYBOARD;case"mouse":return q===V.MOUSE;case"keyboard":return q===V.KEYBOARD}return!1}e.$bF=re,e.$cF=new O;var ue;(function(ee){ee[ee.LEFT=0]="LEFT",ee[ee.RIGHT=1]="RIGHT"})(ue||(e.CloseDirection=ue={}));class ye{constructor(){this.c=new Map,this.d=new Map}start(Q){const q=this.a=Q.get(R.$di);for(const[ne,Se]of this.c)this.e(ne,Se,q);this.c.clear()}e(Q,q,ne){const Se=ne.createInstance(q);this.d.set(Q,Se)}registerFileEditorFactory(Q){if(this.b)throw new Error("Can only register one file editor factory.");this.b=Q}getFileEditorFactory(){return(0,F.$4f)(this.b)}registerEditorSerializer(Q,q){if(this.c.has(Q)||this.d.has(Q))throw new Error(`A editor serializer with type ID '${Q}' was already registered.`);return this.a?this.e(Q,q,this.a):this.c.set(Q,q),(0,L.$Rc)(()=>{this.c.delete(Q),this.d.delete(Q)})}getEditorSerializer(Q){return this.d.get(typeof Q=="string"?Q:Q.typeId)}}g.$Tn.add(e.$RE.EditorFactory,new ye);async function De(ee,Q,q){return!ee||!ee.length?[]:await Promise.all(ee.map(async ne=>{const Se=P.URI.revive(ne.fileUri);if(!Se){q.info("Cannot resolve the path because it is not valid.",ne);return}if(!await Q.canHandleResource(Se)){q.info("Cannot resolve the path because it cannot be handled",ne);return}let Ce=ne.exists,we=ne.type;if(typeof Ce!="boolean"||typeof we!="number")try{we=(await Q.stat(Se)).isDirectory?f.FileType.Directory:f.FileType.Unknown,Ce=!0}catch(J){q.error(J),Ce=!1}if(!Ce&&ne.openOnlyIfExists){q.info("Cannot resolve the path because it does not exist",ne);return}if(we===f.FileType.Directory){q.info("Cannot resolve the path because it is a directory",ne);return}const ge={...ne.options,pinned:!0};return Ce?{resource:Se,options:ge}:{resource:Se,options:ge,forceUntitled:!0}}))}e.$dF=De;var he;(function(ee){ee[ee.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",ee[ee.SEQUENTIAL=1]="SEQUENTIAL"})(he||(e.EditorsOrder=he={}));function ve(ee){const Q=ee;if(!Q)return!1;const q=Q;if(q.modified)return ve(q.modified);const ne=Q;return!!(ne.contributionsState&&ne.viewState&&Array.isArray(ne.cursorState))}e.$eF=ve;function se(ee){return(0,M.$3i)(ee)}e.$fF=se;function $e(ee,Q,q){const ne=(0,M.$4i)(ee,Q);return ne.forceMessage=q?.forceMessage,ne.forceSeverity=q?.forceSeverity,ne.allowDialog=q?.allowDialog,ne}e.$gF=$e}),define(Re[206],Ae([1,0,5,173,4,6,28,30,18,26,89,197]),function(fe,e,S,F,P,L,R,g,f,D,M,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oF=e.$nF=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$mF=e.ViewContentGroups=e.$lF=e.$kF=e.ViewContainerLocation=e.Extensions=e.$jF=e.$iF=e.$hF=void 0,e.$hF="views",e.$iF=(0,F.localize)(0,null),e.$jF=(0,k.$Jw)("default-view-icon",M.$kk.window,(0,F.localize)(1,null));var l;(function(p){p.ViewContainersRegistry="workbench.registry.view.containers",p.ViewsRegistry="workbench.registry.view"})(l||(e.Extensions=l={}));var v;(function(p){p[p.Sidebar=0]="Sidebar",p[p.Panel=1]="Panel",p[p.AuxiliaryBar=2]="AuxiliaryBar"})(v||(e.ViewContainerLocation=v={})),e.$kF=[0,1,2];function $(p){switch(p){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.$lF=$;class s extends L.$Tc{constructor(){super(...arguments),this.c=this.B(new S.$5d),this.onDidRegister=this.c.event,this.f=this.B(new S.$5d),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,f.$Rb)([...this.g.values()])}registerViewContainer(u,o,E){const w=this.get(u.id);if(w)return w;const m=u;return m.openCommandActionDescriptor=E?.doNotRegisterOpenCommand?void 0:m.openCommandActionDescriptor??{id:m.id},(0,R.$xc)(this.g,o,[]).push(m),E?.isDefault&&this.h.push(m),this.c.fire({viewContainer:m,viewContainerLocation:o}),m}deregisterViewContainer(u){for(const o of this.g.keys()){const E=this.g.get(o),w=E?.indexOf(u);if(w!==-1){E?.splice(w,1),E.length===0&&this.g.delete(o),this.f.fire({viewContainer:u,viewContainerLocation:o});return}}}get(u){return this.all.filter(o=>o.id===u)[0]}getViewContainers(u){return[...this.g.get(u)||[]]}getViewContainerLocation(u){return[...this.g.keys()].filter(o=>this.getViewContainers(o).filter(E=>E?.id===u.id).length>0)[0]}getDefaultViewContainer(u){return this.h.find(o=>this.getViewContainerLocation(o)===u)}}g.$Tn.add(l.ViewContainersRegistry,new s);var c;(function(p){p.Open="2_open",p.Debug="4_debug",p.SCM="5_scm",p.More="9_more"})(c||(e.ViewContentGroups=c={}));function t(p,u){const o=p.group??c.More,E=u.group??c.More;return o!==E?o.localeCompare(E):(p.order??5)-(u.order??5)}class n extends L.$Tc{constructor(){super(...arguments),this.c=this.B(new S.$5d),this.onViewsRegistered=this.c.event,this.f=this.B(new S.$5d),this.onViewsDeregistered=this.f.event,this.g=this.B(new S.$5d),this.onDidChangeContainer=this.g.event,this.h=this.B(new S.$5d),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new R.$Gc}registerViews(u,o){this.registerViews2([{views:u,viewContainer:o}])}registerViews2(u){u.forEach(({views:o,viewContainer:E})=>this.r(o,E)),this.c.fire(u)}deregisterViews(u,o){const E=this.s(u,o);E.length&&this.f.fire({views:E,viewContainer:o})}moveViews(u,o){for(const E of this.m.keys())if(E!==o){const w=this.s(u,E);w.length&&(this.r(w,o),this.g.fire({views:w,from:E,to:o}))}}getViews(u){return this.m.get(u)||[]}getView(u){for(const o of this.j){const E=(this.m.get(o)||[]).filter(w=>w.id===u)[0];if(E)return E}return null}getViewContainer(u){for(const o of this.j)if((this.m.get(o)||[]).filter(w=>w.id===u)[0])return o;return null}registerViewWelcomeContent(u,o){return this.n.add(u,o),this.h.fire(u),(0,L.$Rc)(()=>{this.n.delete(u,o),this.h.fire(u)})}registerViewWelcomeContent2(u,o){const E=new Map;for(const[w,m]of o)this.n.add(u,m),E.set(w,(0,L.$Rc)(()=>{this.n.delete(u,m),this.h.fire(u)}));return this.h.fire(u),E}getViewWelcomeContent(u){const o=[];return this.n.forEach(u,E=>o.push(E)),o.sort(t)}r(u,o){let E=this.m.get(o);E||(E=[],this.m.set(o,E),this.j.push(o));for(const w of u){if(this.getView(w.id)!==null)throw new Error((0,F.localize)(2,null,w.id));E.push(w)}}s(u,o){const E=this.m.get(o);if(!E)return[];const w=[],m=[];for(const I of E)u.includes(I)?w.push(I):m.push(I);return w.length&&(m.length?this.m.set(o,m):(this.m.delete(o),this.j.splice(this.j.indexOf(o),1))),w}}g.$Tn.add(l.ViewsRegistry,new n),e.$mF=(0,P.$ei)("viewDescriptorService");var r;(function(p){p[p.Default=0]="Default",p[p.Expand=1]="Expand"})(r||(e.ViewVisibilityState=r={}));var a;(function(p){p[p.None=0]="None",p[p.Collapsed=1]="Collapsed",p[p.Expanded=2]="Expanded"})(a||(e.TreeItemCollapsibleState=a={}));class h{constructor(u,o){this.c=!1,this.d=!1,(0,D.$Kn)(this,u),this.d=!!o,this.resolve=async E=>{if(o&&!this.c){const w=await o(E);w&&(this.tooltip=this.tooltip??w.tooltip,this.command=this.command??w.command)}E.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$nF=h;class i extends Error{constructor(u){super((0,F.localize)(3,null,u)),this.name="NoTreeViewError"}static is(u){return u.name==="NoTreeViewError"}}e.$oF=i}),define(Re[207],Ae([1,0,2,29,4]),function(fe,e,S,F,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yF=e.$xF=e.ChatCopyKind=e.InteractiveSessionVoteDirection=e.$wF=e.$vF=void 0;function L(D){return!!D&&typeof D=="object"&&"uri"in D&&D.uri instanceof S.URI&&"version"in D&&typeof D.version=="number"&&"ranges"in D&&Array.isArray(D.ranges)&&D.ranges.every(F.$6s.isIRange)}e.$vF=L;function R(D){return!!D&&typeof D=="object"&&"documents"in D&&Array.isArray(D.documents)&&D.documents.every(L)}e.$wF=R;var g;(function(D){D[D.Down=0]="Down",D[D.Up=1]="Up"})(g||(e.InteractiveSessionVoteDirection=g={}));var f;(function(D){D[D.Action=1]="Action",D[D.Toolbar=2]="Toolbar"})(f||(e.ChatCopyKind=f={})),e.$xF=(0,P.$ei)("IChatService"),e.$yF="accessibility.voice.keywordActivation"}),define(Re[208],Ae([1,0,5,11,174]),function(fe,e,S,F,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fnb=void 0;class L{constructor(){this.f=new Map,this.m=[],this.n=new S.$5d,this.o=new S.$5d,this.d=1}get onError(){return this.n.event}get onExit(){return this.o.event}onMessage(g){this.k&&this.n.fire(new Error("attempt to set more than one 'Message' callback")),this.k=g}onEvent(g){this.j&&this.n.fire(new Error("attempt to set more than one 'Event' callback")),this.j=g}onRequest(g){this.g&&this.n.fire(new Error("attempt to set more than one 'Request' callback")),this.g=g}sendResponse(g){g.seq>0?this.n.fire(new Error(`attempt to send more than one response for command ${g.command}`)):this.u("response",g)}sendRequest(g,f,D,M){const k={command:g};if(f&&Object.keys(f).length>0&&(k.arguments=f),this.u("request",k),typeof M=="number"){const l=setTimeout(()=>{clearTimeout(l);const v=this.f.get(k.seq);if(v){this.f.delete(k.seq);const $={type:"response",seq:0,request_seq:k.seq,success:!1,command:g,message:(0,P.localize)(0,null,M,g)};v($)}},M)}return D&&this.f.set(k.seq,D),k.seq}acceptMessage(g){this.k?this.k(g):(this.m.push(g),this.m.length===1&&this.s())}q(g,f){return g.type!=="event"||f.type!=="event"}async s(){let g;for(;this.m.length;){if((!g||this.q(this.m[0],g))&&await(0,F.$fh)(0),g=this.m.shift(),!g)return;switch(g.type){case"event":this.j?.(g);break;case"request":this.g?.(g);break;case"response":{const f=g,D=this.f.get(f.request_seq);D&&(this.f.delete(f.request_seq),D(f));break}}}}u(g,f){f.type=g,f.seq=this.d++,this.sendMessage(f)}async w(){if(this.f.size===0)return Promise.resolve();const g=new Map;this.f.forEach((f,D)=>g.set(D,f)),await(0,F.$fh)(500),g.forEach((f,D)=>{f({type:"response",seq:0,request_seq:D,success:!1,command:"canceled",message:"canceled"}),this.f.delete(D)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.m=[]}}e.$Fnb=L}),define(Re[209],Ae([1,0,2,175,36,4]),function(fe,e,S,F,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDebugVisualization=e.IDebugVisualizationTreeItem=e.DebugTreeItemCollapsibleState=e.DebugVisualizationType=e.BreakpointWidgetContext=e.$yI=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.$xI=e.MemoryRangeType=e.$wI=e.State=e.$vI=e.$uI=e.$tI=e.$sI=e.$rI=e.$qI=e.$pI=e.$oI=e.$nI=e.$mI=e.$lI=e.$kI=e.$jI=e.$iI=e.$hI=e.$gI=e.$fI=e.$eI=e.$dI=e.$cI=e.$bI=e.$aI=e.$_H=e.$$H=e.$0H=e.$9H=e.$8H=e.$7H=e.$6H=e.$5H=e.$4H=e.$3H=e.$2H=e.$1H=e.$ZH=e.$YH=e.$XH=e.$WH=e.$VH=e.$UH=e.$TH=e.$SH=e.$RH=e.$QH=e.$PH=e.$OH=e.$NH=e.$MH=e.$LH=e.$KH=e.$JH=e.$IH=e.$HH=e.$GH=e.$FH=e.$EH=e.$DH=e.$CH=e.$BH=e.$AH=e.$zH=e.$yH=e.$xH=e.$wH=e.$vH=e.$uH=e.$tH=e.$sH=e.$rH=e.$qH=e.$pH=e.$oH=e.$nH=void 0,e.$nH="workbench.view.debug",e.$oH="workbench.debug.variablesView",e.$pH="workbench.debug.watchExpressionsView",e.$qH="workbench.debug.callStackView",e.$rH="workbench.debug.loadedScriptsView",e.$sH="workbench.debug.breakPointsView",e.$tH="workbench.debug.disassemblyView",e.$uH="workbench.panel.repl",e.$vH="workbench.panel.repl.view",e.$wH=new P.$vj("debugType",void 0,{type:"string",description:F.localize(0,null)}),e.$xH=new P.$vj("debugConfigurationType",void 0,{type:"string",description:F.localize(1,null)}),e.$yH=new P.$vj("debugState","inactive",{type:"string",description:F.localize(2,null)}),e.$zH="debugUx",e.$AH=new P.$vj(e.$zH,"default",{type:"string",description:F.localize(3,null)}),e.$BH=new P.$vj("hasDebugged",!1,{type:"boolean",description:F.localize(4,null)}),e.$CH=new P.$vj("inDebugMode",!1,{type:"boolean",description:F.localize(5,null)}),e.$DH=new P.$vj("inDebugRepl",!1,{type:"boolean",description:F.localize(6,null)}),e.$EH=new P.$vj("breakpointWidgetVisible",!1,{type:"boolean",description:F.localize(7,null)}),e.$FH=new P.$vj("inBreakpointWidget",!1,{type:"boolean",description:F.localize(8,null)}),e.$GH=new P.$vj("breakpointsFocused",!0,{type:"boolean",description:F.localize(9,null)}),e.$HH=new P.$vj("watchExpressionsFocused",!0,{type:"boolean",description:F.localize(10,null)}),e.$IH=new P.$vj("watchExpressionsExist",!1,{type:"boolean",description:F.localize(11,null)}),e.$JH=new P.$vj("variablesFocused",!0,{type:"boolean",description:F.localize(12,null)}),e.$KH=new P.$vj("expressionSelected",!1,{type:"boolean",description:F.localize(13,null)}),e.$LH=new P.$vj("breakpointInputFocused",!1,{type:"boolean",description:F.localize(14,null)}),e.$MH=new P.$vj("callStackItemType",void 0,{type:"string",description:F.localize(15,null)}),e.$NH=new P.$vj("callStackSessionIsAttach",!1,{type:"boolean",description:F.localize(16,null)}),e.$OH=new P.$vj("callStackItemStopped",!1,{type:"boolean",description:F.localize(17,null)}),e.$PH=new P.$vj("callStackSessionHasOneThread",!1,{type:"boolean",description:F.localize(18,null)}),e.$QH=new P.$vj("watchItemType",void 0,{type:"string",description:F.localize(19,null)}),e.$RH=new P.$vj("canViewMemory",void 0,{type:"boolean",description:F.localize(20,null)}),e.$SH=new P.$vj("breakpointItemType",void 0,{type:"string",description:F.localize(21,null)}),e.$TH=new P.$vj("breakpointHasModes",!1,{type:"boolean",description:F.localize(22,null)}),e.$UH=new P.$vj("breakpointSupportsCondition",!1,{type:"boolean",description:F.localize(23,null)}),e.$VH=new P.$vj("loadedScriptsSupported",!1,{type:"boolean",description:F.localize(24,null)}),e.$WH=new P.$vj("loadedScriptsItemType",void 0,{type:"string",description:F.localize(25,null)}),e.$XH=new P.$vj("focusedSessionIsAttach",!1,{type:"boolean",description:F.localize(26,null)}),e.$YH=new P.$vj("focusedSessionIsNoDebug",!1,{type:"boolean",description:F.localize(27,null)}),e.$ZH=new P.$vj("stepBackSupported",!1,{type:"boolean",description:F.localize(28,null)}),e.$1H=new P.$vj("restartFrameSupported",!1,{type:"boolean",description:F.localize(29,null)}),e.$2H=new P.$vj("stackFrameSupportsRestart",!1,{type:"boolean",description:F.localize(30,null)}),e.$3H=new P.$vj("jumpToCursorSupported",!1,{type:"boolean",description:F.localize(31,null)}),e.$4H=new P.$vj("stepIntoTargetsSupported",!1,{type:"boolean",description:F.localize(32,null)}),e.$5H=new P.$vj("breakpointsExist",!1,{type:"boolean",description:F.localize(33,null)}),e.$6H=new P.$vj("debuggersAvailable",!1,{type:"boolean",description:F.localize(34,null)}),e.$7H=new P.$vj("debugExtensionAvailable",!0,{type:"boolean",description:F.localize(35,null)}),e.$8H=new P.$vj("debugProtocolVariableMenuContext",void 0,{type:"string",description:F.localize(36,null)}),e.$9H=new P.$vj("debugSetVariableSupported",!1,{type:"boolean",description:F.localize(37,null)}),e.$0H=new P.$vj("debugSetExpressionSupported",!1,{type:"boolean",description:F.localize(38,null)}),e.$$H=new P.$vj("breakWhenValueChangesSupported",!1,{type:"boolean",description:F.localize(39,null)}),e.$_H=new P.$vj("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:F.localize(40,null)}),e.$aI=new P.$vj("breakWhenValueIsReadSupported",!1,{type:"boolean",description:F.localize(41,null)}),e.$bI=new P.$vj("terminateDebuggeeSupported",!1,{type:"boolean",description:F.localize(42,null)}),e.$cI=new P.$vj("suspendDebuggeeSupported",!1,{type:"boolean",description:F.localize(43,null)}),e.$dI=new P.$vj("variableEvaluateNamePresent",!1,{type:"boolean",description:F.localize(44,null)}),e.$eI=new P.$vj("variableIsReadonly",!1,{type:"boolean",description:F.localize(45,null)}),e.$fI=new P.$vj("variableValue",!1,{type:"string",description:F.localize(46,null)}),e.$gI=new P.$vj("variableType",!1,{type:"string",description:F.localize(47,null)}),e.$hI=new P.$vj("variableName",!1,{type:"string",description:F.localize(48,null)}),e.$iI=new P.$vj("variableLanguage",!1,{type:"string",description:F.localize(49,null)}),e.$jI=new P.$vj("variableExtensionId",!1,{type:"string",description:F.localize(50,null)}),e.$kI=new P.$vj("exceptionWidgetVisible",!1,{type:"boolean",description:F.localize(51,null)}),e.$lI=new P.$vj("multiSessionRepl",!1,{type:"boolean",description:F.localize(52,null)}),e.$mI=new P.$vj("multiSessionDebug",!1,{type:"boolean",description:F.localize(53,null)}),e.$nI=new P.$vj("disassembleRequestSupported",!1,{type:"boolean",description:F.localize(54,null)}),e.$oI=new P.$vj("disassemblyViewFocus",!1,{type:"boolean",description:F.localize(55,null)}),e.$pI=new P.$vj("languageSupportsDisassembleRequest",!1,{type:"boolean",description:F.localize(56,null)}),e.$qI=new P.$vj("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:F.localize(57,null)});const R=t=>F.localize(58,null,t);e.$rI=R,e.$sI="editor.contrib.debug",e.$tI="editor.contrib.breakpoint",e.$uI="debug",e.$vI={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:F.localize(59,null)};var g;(function(t){t[t.Inactive=0]="Inactive",t[t.Initializing=1]="Initializing",t[t.Stopped=2]="Stopped",t[t.Running=3]="Running"})(g||(e.State=g={}));function f(t){switch(t){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.$wI=f;var D;(function(t){t[t.Valid=0]="Valid",t[t.Unreadable=1]="Unreadable",t[t.Error=2]="Error"})(D||(e.MemoryRangeType=D={})),e.$xI="vscode-debug-memory";var M;(function(t){t[t.Initial=1]="Initial",t[t.Dynamic=2]="Dynamic"})(M||(e.DebugConfigurationProviderTriggerKind=M={}));var k;(function(t){t.UnverifiedBreakpoints="unverifiedBreakpoints"})(k||(e.DebuggerString=k={})),e.$yI=(0,L.$ei)("debugService");var l;(function(t){t[t.CONDITION=0]="CONDITION",t[t.HIT_COUNT=1]="HIT_COUNT",t[t.LOG_MESSAGE=2]="LOG_MESSAGE",t[t.TRIGGER_POINT=3]="TRIGGER_POINT"})(l||(e.BreakpointWidgetContext=l={}));var v;(function(t){t[t.Command=0]="Command",t[t.Tree=1]="Tree"})(v||(e.DebugVisualizationType=v={}));var $;(function(t){t[t.None=0]="None",t[t.Collapsed=1]="Collapsed",t[t.Expanded=2]="Expanded"})($||(e.DebugTreeItemCollapsibleState=$={}));var s;(function(t){t.deserialize=n=>n,t.serialize=n=>n})(s||(e.IDebugVisualizationTreeItem=s={}));var c;(function(t){t.deserialize=n=>({id:n.id,name:n.name,iconPath:n.iconPath&&{light:S.URI.revive(n.iconPath.light),dark:S.URI.revive(n.iconPath.dark)},iconClass:n.iconClass,visualization:n.visualization}),t.serialize=n=>n})(c||(e.IDebugVisualization=c={}))}),define(Re[210],Ae([1,0,13,2,19,26,12,29,22,18]),function(fe,e,S,F,P,L,R,g,f,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BG=e.$AG=e.$zG=e.$yG=e.$xG=e.$wG=e.$vG=e.$uG=e.$tG=e.$sG=e.$rG=e.$qG=e.$pG=void 0;const M=/{([^}]+)}/g;function k(I,d,y){return I.replace(M,function(b,A){return d&&A.length>0&&A[0]!=="_"?b:y&&y.hasOwnProperty(A)?y[A]:b})}e.$pG=k;function l(I){const d={};for(const y of Object.keys(I))y.startsWith("!")||(d[y]=I[y]);return d}e.$qG=l;function v(I){return I.configuration.request==="attach"&&!$(I)&&(!I.parentSession||v(I.parentSession))}e.$rG=v;function $(I){let d=I.configuration.type;if(d)return d==="vslsShare"&&(d=I.configuration.adapterProxy.configuration.type),(0,S.$jf)(d,"extensionhost")||(0,S.$jf)(d,"pwa-extensionhost")?I:I.parentSession?$(I.parentSession):void 0}e.$sG=$;function s(I){return I.type&&(I.label||I.program||I.runtime)}e.$tG=s;function c(I,d,y){let b,A=0;const T=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let G=null;for(;G=T.exec(I);){const W=G.index+1,U=W+G[0].length;if(W<=d&&U>=y){b=G[0],A=W;break}}if(b){const W=/\w+/g;let U=null;for(;(U=W.exec(b))&&!(U.index+1+A+U[0].length>=y););U&&(b=b.substring(0,W.lastIndex))}return b?{start:A,end:A+b.length-1}:{start:0,end:0}}e.$uG=c;async function t(I,d,y,b){if(I.evaluatableExpressionProvider.has(d)){const A=I.evaluatableExpressionProvider.ordered(d),T=(0,D.$Hb)(await Promise.all(A.map(async G=>{try{return await G.provideEvaluatableExpression(d,y,b??f.CancellationToken.None)}catch{return}})));if(T.length>0){let G=T[0].expression;const W=T[0].range;return G||(G=d.getLineContent(y.lineNumber).substring(W.startColumn-1,W.endColumn-1)),{range:W,matchingExpression:G}}}else{const A=d.getLineContent(y.lineNumber),{start:T,end:G}=c(A,y.column,y.column),W=A.substring(T-1,G);return{matchingExpression:W,range:new g.$6s(y.lineNumber,T,y.lineNumber,T+W.length)}}return null}e.$vG=t;const n=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function r(I){return!!(I&&I.match(n))}e.$wG=r;function a(I){if(typeof I.path=="string"&&!(typeof I.sourceReference=="number"&&I.sourceReference>0)){if(r(I.path))return F.URI.parse(I.path);if((0,P.$ic)(I.path))return F.URI.file(I.path)}return I.path}function h(I){if(typeof I.path=="object"){const d=F.URI.revive(I.path);if(d)return d.scheme===R.Schemas.file?d.fsPath:d.toString()}return I.path}function i(I,d){const y=d?a:h,b=(0,L.$Hn)(I);return u(b,(A,T)=>{A&&T&&(T.path=y(T))}),b}e.$xG=i;function p(I,d){const y=d?a:h,b=(0,L.$Hn)(I);return u(b,(A,T)=>{!A&&T&&(T.path=y(T))}),b}e.$yG=p;function u(I,d){switch(I.type){case"event":{const y=I;switch(y.event){case"output":d(!1,y.body.source);break;case"loadedSource":d(!1,y.body.source);break;case"breakpoint":d(!1,y.body.breakpoint.source);break;default:break}break}case"request":{const y=I;switch(y.command){case"setBreakpoints":d(!0,y.arguments.source);break;case"breakpointLocations":d(!0,y.arguments.source);break;case"source":d(!0,y.arguments.source);break;case"gotoTargets":d(!0,y.arguments.source);break;case"launchVSCode":y.arguments.args.forEach(b=>d(!1,b));break;default:break}break}case"response":{const y=I;if(y.success&&y.body)switch(y.command){case"stackTrace":y.body.stackFrames.forEach(b=>d(!1,b.source));break;case"loadedSources":y.body.sources.forEach(b=>d(!1,b));break;case"scopes":y.body.scopes.forEach(b=>d(!1,b.source));break;case"setFunctionBreakpoints":y.body.breakpoints.forEach(b=>d(!1,b.source));break;case"setBreakpoints":y.body.breakpoints.forEach(b=>d(!1,b.source));break;case"disassemble":y.body?.instructions.forEach(A=>d(!1,A.location));break;default:break}break}}}function o(I){return I.filter(d=>!d.presentation?.hidden).sort((d,y)=>d.presentation?y.presentation?d.presentation.group?y.presentation.group?d.presentation.group!==y.presentation.group?d.presentation.group.localeCompare(y.presentation.group):E(d.presentation.order,y.presentation.order):-1:y.presentation.group?1:E(d.presentation.order,y.presentation.order):-1:y.presentation?1:0)}e.$zG=o;function E(I,d){return typeof I!="number"?typeof d!="number"?0:1:typeof d!="number"?-1:I-d}async function w(I,d){const y=I.getValue("debug.saveBeforeStart",{overrideIdentifier:d.activeTextEditorLanguageId});if(y!=="none"&&(await d.saveAll(),y==="allEditorsInActiveGroup")){const b=d.activeEditorPane;b&&b.input.resource?.scheme===R.Schemas.untitled&&await d.save({editor:b.input,groupId:b.group.id})}await I.reloadConfiguration()}e.$AG=w;const m=(I,d)=>!I||!d?I===d:I.name===d.name&&I.path===d.path&&I.sourceReference===d.sourceReference;e.$BG=m}),define(Re[211],Ae([1,0,4]),function(fe,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7J=e.CellExecutionUpdateType=void 0;var F;(function(P){P[P.Output=1]="Output",P[P.OutputItems=2]="OutputItems",P[P.ExecutionState=3]="ExecutionState"})(F||(e.CellExecutionUpdateType=F={})),e.$7J=(0,S.$ei)("INotebookExecutionService")}),define(Re[212],Ae([1,0,4]),function(fe,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2gb=e.$1gb=e.ProxyKernelState=e.$Zgb=void 0,e.$Zgb=100;var F;(function(P){P[P.Disconnected=1]="Disconnected",P[P.Connected=2]="Connected",P[P.Initializing=3]="Initializing"})(F||(e.ProxyKernelState=F={})),e.$1gb=(0,S.$ei)("INotebookKernelService"),e.$2gb=(0,S.$ei)("INotebookKernelHistoryService")}),define(Re[213],Ae([1,0,6,29,145,93]),function(fe,e,S,F,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mTb=void 0;class R extends S.$Tc{constructor(f,D,M){super(),this._source=f,this.b=D,this.c=M,this.a=void 0}f(f){const D=f.getLineCount();return new F.$6s(1,1,D,this.g(f,D))}g(f,D){if(D<1||D>f.getLineCount())throw new Error("Illegal value for lineNumber");return f.getLineLength(D)+1}get inputTextBuffer(){if(!this.b){const f=new P.$oC;f.acceptChunk(this._source);const D=f.finish(!0),{textBuffer:M,disposable:k}=D.create(1);this.b=M,this.B(k)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map(f=>{const D=new P.$oC;D.acceptChunk(f);const M=D.finish(!0),{textBuffer:k,disposable:l}=M.create(1);return this.B(l),k})),this.a}findInInputs(f){const M=new L.$cC(f,!1,!1,null).parseSearchRequest();if(!M)return[];const k=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(k,M,!0,5e3)}findInOutputs(f){const M=new L.$cC(f,!1,!1,null).parseSearchRequest();return M?this.outputTextBuffers.map(k=>{const l=k.findMatchesLineByLine(this.f(k),M,!0,5e3);if(l.length!==0)return{textBuffer:k,matches:l}}).filter(k=>!!k):[]}}e.$mTb=R}),define(Re[48],Ae([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QK=e.TestPosition=e.TestIdPathParts=void 0;var S;(function(L){L.Delimiter="\0"})(S||(e.TestIdPathParts=S={}));var F;(function(L){L[L.IsSame=0]="IsSame",L[L.Disconnected=1]="Disconnected",L[L.IsChild=2]="IsChild",L[L.IsParent=3]="IsParent"})(F||(e.TestPosition=F={}));class P{static fromExtHostTestItem(R,g,f=R.parent){if(R._isRoot)return new P([g]);const D=[R.id];for(let M=f;M&&M.id!==g;M=M.parent)D.push(M.id);return D.push(g),new P(D.reverse())}static isRoot(R){return!R.includes("\0")}static root(R){const g=R.indexOf("\0");return g===-1?R:R.slice(0,g)}static fromString(R){return new P(R.split("\0"))}static join(R,g){return new P([...R.path,g])}static joinToString(R,g){return R.toString()+"\0"+g}static parentId(R){const g=R.lastIndexOf("\0");return g===-1?void 0:R.slice(0,g)}static localId(R){const g=R.lastIndexOf("\0");return g===-1?R:R.slice(g+1)}static isChild(R,g){return g.startsWith(R)&&g[R.length]==="\0"}static compare(R,g){return R===g?0:P.isChild(R,g)?2:P.isChild(g,R)?3:1}constructor(R,g=R.length){if(this.path=R,this.d=g,R.length===0||g<1)throw new Error("cannot create test with empty path")}get rootId(){return new P(this.path,1)}get parentId(){return this.d>1?new P(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let R=1;R<=this.d;R++)yield new P(this.path,R)}*idsToRoot(){for(let R=this.d;R>0;R--)yield new P(this.path,R)}compare(R){if(typeof R=="string")return P.compare(this.toString(),R);for(let g=0;g<R.d&&g<this.d;g++)if(R.path[g]!==this.path[g])return 1;return R.d>this.d?2:R.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let R=1;R<this.d;R++)this.c+="\0",this.c+=this.path[R]}return this.c}}e.$QK=P}),define(Re[60],Ae([1,0,2,91,29,48]),function(fe,e,S,F,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YK=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IDeclarationCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$XK=e.IFileCoverage=e.ICoveredCount=e.TestResultItem=e.$WK=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$VK=e.$UK=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$TK=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$SK=e.$RK=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.TestResultState=void 0;var R;(function(C){C[C.Unset=0]="Unset",C[C.Queued=1]="Queued",C[C.Running=2]="Running",C[C.Passed=3]="Passed",C[C.Failed=4]="Failed",C[C.Skipped=5]="Skipped",C[C.Errored=6]="Errored"})(R||(e.TestResultState=R={}));var g;(function(C){C[C.Run=1]="Run",C[C.Debug=2]="Debug",C[C.Coverage=3]="Coverage"})(g||(e.ExtTestRunProfileKind=g={}));var f;(function(C){C[C.Run=2]="Run",C[C.Debug=4]="Debug",C[C.Coverage=8]="Coverage",C[C.HasNonDefaultProfile=16]="HasNonDefaultProfile",C[C.HasConfigurable=32]="HasConfigurable",C[C.SupportsContinuousRun=64]="SupportsContinuousRun"})(f||(e.TestRunProfileBitset=f={})),e.$RK=[2,4,8,16,32,64];const D=C=>"runId"in C;e.$SK=D;var M;(function(C){C.serialize=O=>({range:O.range.toJSON(),uri:O.uri.toJSON()}),C.deserialize=(O,V)=>({range:P.$6s.lift(V.range),uri:O.asCanonicalUri(S.URI.revive(V.uri))})})(M||(e.IRichLocation=M={}));var k;(function(C){C[C.Error=0]="Error",C[C.Output=1]="Output"})(k||(e.TestMessageType=k={}));var l;(function(C){C.serialize=O=>({message:O.message,type:0,expected:O.expected,actual:O.actual,contextValue:O.contextValue,location:O.location&&M.serialize(O.location)}),C.deserialize=(O,V)=>({message:V.message,type:0,expected:V.expected,actual:V.actual,contextValue:V.contextValue,location:V.location&&M.deserialize(O,V.location)})})(l||(e.ITestErrorMessage=l={}));const v=(C,O)=>`${O?"s":"e"}${C}`;e.$TK=v;var $;(function(C){C.serialize=O=>({message:O.message,type:1,offset:O.offset,length:O.length,location:O.location&&M.serialize(O.location)}),C.deserialize=(O,V)=>({message:V.message,type:1,offset:V.offset,length:V.length,location:V.location&&M.deserialize(O,V.location)})})($||(e.ITestOutputMessage=$={}));var s;(function(C){C.serialize=O=>O.type===0?l.serialize(O):$.serialize(O),C.deserialize=(O,V)=>V.type===0?l.deserialize(O,V):$.deserialize(O,V)})(s||(e.ITestMessage=s={}));var c;(function(C){C.serializeWithoutMessages=O=>({state:O.state,duration:O.duration,messages:[]}),C.serialize=O=>({state:O.state,duration:O.duration,messages:O.messages.map(s.serialize)}),C.deserialize=(O,V)=>({state:V.state,duration:V.duration,messages:V.messages.map(re=>s.deserialize(O,re))})})(c||(e.ITestTaskState=c={}));const t="\0",n=(C,O)=>C+t+O;e.$UK=n;const r=C=>{const O=C.indexOf(t);return{ctrlId:C.slice(0,O),tagId:C.slice(O+1)}};e.$VK=r;var a;(function(C){C.serialize=O=>({extId:O.extId,label:O.label,tags:O.tags,busy:O.busy,children:void 0,uri:O.uri?.toJSON(),range:O.range?.toJSON()||null,description:O.description,error:O.error,sortText:O.sortText}),C.deserialize=(O,V)=>({extId:V.extId,label:V.label,tags:V.tags,busy:V.busy,children:void 0,uri:V.uri?O.asCanonicalUri(S.URI.revive(V.uri)):void 0,range:V.range?P.$6s.lift(V.range):null,description:V.description,error:V.error,sortText:V.sortText})})(a||(e.ITestItem=a={}));var h;(function(C){C[C.NotExpandable=0]="NotExpandable",C[C.Expandable=1]="Expandable",C[C.BusyExpanding=2]="BusyExpanding",C[C.Expanded=3]="Expanded"})(h||(e.TestItemExpandState=h={}));var i;(function(C){C.serialize=O=>({expand:O.expand,item:a.serialize(O.item)}),C.deserialize=(O,V)=>({controllerId:L.$QK.root(V.item.extId),expand:V.expand,item:a.deserialize(O,V.item)})})(i||(e.InternalTestItem=i={}));var p;(function(C){C.serialize=O=>{let V;return O.item&&(V={},O.item.label!==void 0&&(V.label=O.item.label),O.item.tags!==void 0&&(V.tags=O.item.tags),O.item.busy!==void 0&&(V.busy=O.item.busy),O.item.uri!==void 0&&(V.uri=O.item.uri?.toJSON()),O.item.range!==void 0&&(V.range=O.item.range?.toJSON()),O.item.description!==void 0&&(V.description=O.item.description),O.item.error!==void 0&&(V.error=O.item.error),O.item.sortText!==void 0&&(V.sortText=O.item.sortText)),{extId:O.extId,expand:O.expand,item:V}},C.deserialize=O=>{let V;return O.item&&(V={},O.item.label!==void 0&&(V.label=O.item.label),O.item.tags!==void 0&&(V.tags=O.item.tags),O.item.busy!==void 0&&(V.busy=O.item.busy),O.item.range!==void 0&&(V.range=O.item.range?P.$6s.lift(O.item.range):null),O.item.description!==void 0&&(V.description=O.item.description),O.item.error!==void 0&&(V.error=O.item.error),O.item.sortText!==void 0&&(V.sortText=O.item.sortText)),{extId:O.extId,expand:O.expand,item:V}}})(p||(e.ITestItemUpdate=p={}));const u=(C,O)=>{O.expand!==void 0&&(C.expand=O.expand),O.item!==void 0&&(C.item=C.item?Object.assign(C.item,O.item):O.item)};e.$WK=u;var o;(function(C){C.serializeWithoutMessages=O=>({...i.serialize(O),ownComputedState:O.ownComputedState,computedState:O.computedState,tasks:O.tasks.map(c.serializeWithoutMessages)}),C.serialize=O=>({...i.serialize(O),ownComputedState:O.ownComputedState,computedState:O.computedState,tasks:O.tasks.map(c.serialize)}),C.deserialize=(O,V)=>({...i.deserialize(O,V),ownComputedState:V.ownComputedState,computedState:V.computedState,tasks:V.tasks.map(re=>c.deserialize(O,re)),retired:!0})})(o||(e.TestResultItem=o={}));var E;(function(C){C.empty=()=>({covered:0,total:0}),C.sum=(O,V)=>{O.covered+=V.covered,O.total+=V.total}})(E||(e.ICoveredCount=E={}));var w;(function(C){C.serialize=O=>({statement:O.statement,branch:O.branch,declaration:O.declaration,details:O.details?.map(y.serialize),uri:O.uri.toJSON()}),C.deserialize=(O,V)=>({statement:V.statement,branch:V.branch,declaration:V.declaration,details:V.details?.map(y.deserialize),uri:O.asCanonicalUri(S.URI.revive(V.uri))})})(w||(e.IFileCoverage=w={}));function m(C){return{...C,location:C.location?.toJSON()}}function I(C){return C.location=C.location?F.$5s.isIPosition(C.location)?F.$5s.lift(C.location):P.$6s.lift(C.location):void 0,C}e.$XK=3;var d;(function(C){C[C.Declaration=0]="Declaration",C[C.Statement=1]="Statement",C[C.Branch=2]="Branch"})(d||(e.DetailType=d={}));var y;(function(C){C.serialize=O=>O.type===0?A.serialize(O):T.serialize(O),C.deserialize=O=>O.type===0?A.deserialize(O):T.deserialize(O)})(y||(e.CoverageDetails=y={}));var b;(function(C){C.serialize=m,C.deserialize=I})(b||(e.IBranchCoverage=b={}));var A;(function(C){C.serialize=m,C.deserialize=I})(A||(e.IDeclarationCoverage=A={}));var T;(function(C){C.serialize=O=>({...m(O),branches:O.branches?.map(b.serialize)}),C.deserialize=O=>({...I(O),branches:O.branches?.map(b.deserialize)})})(T||(e.IStatementCoverage=T={}));var G;(function(C){C[C.Add=0]="Add",C[C.Update=1]="Update",C[C.DocumentSynced=2]="DocumentSynced",C[C.Remove=3]="Remove",C[C.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",C[C.Retire=5]="Retire",C[C.AddTag=6]="AddTag",C[C.RemoveTag=7]="RemoveTag"})(G||(e.TestDiffOpType=G={}));var W;(function(C){C.deserialize=(O,V)=>V.op===0?{op:V.op,item:i.deserialize(O,V.item)}:V.op===1?{op:V.op,item:p.deserialize(V.item)}:V.op===2?{op:V.op,uri:O.asCanonicalUri(S.URI.revive(V.uri)),docv:V.docv}:V,C.serialize=O=>O.op===0?{op:O.op,item:i.serialize(O.item)}:O.op===1?{op:O.op,item:p.serialize(O.item)}:O})(W||(e.TestsDiffOp=W={}));class U{constructor(O){this.k=O,this.c=new Map,this.f=new Map,this.g=new Set,this.h=0,this.j=0,this.tags=this.c}apply(O){const V=this.v();for(const re of O)switch(re.op){case 0:this.l(i.deserialize(this.k,re.item),V);break;case 1:this.o(p.deserialize(re.item),V);break;case 3:this.p(re.itemId,V);break;case 5:this.q(re.itemId);break;case 4:this.updatePendingRoots(re.amount);break;case 6:this.c.set(re.tag.id,re.tag);break;case 7:this.c.delete(re.id);break}V.complete?.()}l(O,V){const re=L.$QK.parentId(O.item.extId)?.toString();let ue;if(!re)ue=this.w(O),this.g.add(ue),this.f.set(O.item.extId,ue);else if(this.f.has(re)){const ye=this.f.get(re);ye.children.add(O.item.extId),ue=this.w(O,ye),this.f.set(O.item.extId,ue)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(O)}`);return}return V.add?.(ue),O.expand===2&&this.h++,ue}o(O,V){const re=this.f.get(O.extId);if(re)return O.expand!==void 0&&(re.expand===2&&this.h--,O.expand===2&&this.h++),(0,e.$WK)(re,O),V.update?.(re),re}p(O,V){const re=this.f.get(O);if(!re)return;const ue=L.$QK.parentId(re.item.extId)?.toString();ue?this.f.get(ue).children.delete(re.item.extId):this.g.delete(re);const ye=[[O]];for(;ye.length;)for(const De of ye.pop()){const he=this.f.get(De);he&&(ye.push(he.children),this.f.delete(De),V.remove?.(he,he!==re),he.expand===2&&this.h--)}}q(O){}updatePendingRoots(O){this.j+=O}v(){return{}}}e.$YK=U}),define(Re[75],Ae([1,0,11,5,6,55,60,48]),function(fe,e,S,F,P,L,R,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$N=e.$0N=e.$9N=e.$8N=e.$7N=e.TestItemEventOp=void 0;var f;(function(n){n[n.Upsert=0]="Upsert",n[n.SetTags=1]="SetTags",n[n.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",n[n.RemoveChild=3]="RemoveChild",n[n.SetProp=4]="SetProp",n[n.Bulk=5]="Bulk",n[n.DocumentSynced=6]="DocumentSynced"})(f||(e.TestItemEventOp=f={}));const D=(n,r)=>n===r,k=Object.entries({range:(n,r)=>n===r?!0:!n||!r?!1:n.equalsRange(r),busy:D,label:D,description:D,error:D,sortText:D,tags:(n,r)=>!(n.length!==r.length||n.some(a=>!r.includes(a)))}),l=(n,r)=>{let a;for(const[h,i]of k)i(n[h],r[h])||(a?a[h]=r[h]:a={[h]:r[h]});return a};class v extends P.$Tc{get root(){return this.s.root}constructor(r){super(),this.s=r,this.f=this.B(new S.$qh(()=>this.flushDiff(),200)),this.g=this.B(new F.$5d),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.z(this.root,void 0)}set resolveHandler(r){this.h=r;for(const a of this.tree.values())this.J(a)}get resolveHandler(){return this.h}collectDiff(){const r=this.m;return this.m=[],r}pushDiff(r){switch(r.op){case 2:{for(const a of this.m)if(a.op===2&&a.uri===r.uri){a.docv=r.docv;return}break}case 1:{const a=this.m[this.m.length-1];if(a){if(a.op===1&&a.item.extId===r.item.extId){(0,R.$WK)(a.item,r.item);return}if(a.op===0&&a.item.item.extId===r.item.extId){(0,R.$WK)(a.item,r.item);return}}break}}this.m.push(r),this.f.isScheduled()||this.f.schedule()}expand(r,a){const h=this.tree.get(r);if(h){if((h.expandLevels===void 0||a>h.expandLevels)&&(h.expandLevels=a),h.expand===1){const i=this.M(h);return i.isOpen()?this.L(h,a-1):i.wait().then(()=>this.L(h,a-1))}else if(h.expand===3)return h.resolveBarrier?.isOpen()===!1?h.resolveBarrier.wait().then(()=>this.L(h,a-1)):this.L(h,a-1)}}dispose(){for(const r of this.tree.values())this.s.getApiFor(r.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}w(r,a){switch(a.op){case 3:this.O(g.$QK.joinToString(r.fullId,a.id));break;case 0:this.z(a.item,r);break;case 5:for(const h of a.ops)this.w(r,h);break;case 1:this.C(a.new,a.old,r.fullId.toString());break;case 2:this.J(r);break;case 4:this.pushDiff({op:1,item:{extId:r.fullId.toString(),item:a.update}});break;case 6:this.y(r.actual.uri);break;default:(0,L.$9c)(a)}}y(r){r&&this.pushDiff({op:2,uri:r,docv:this.s.getDocumentVersion(r)})}z(r,a){const h=g.$QK.fromExtHostTestItem(r,this.root.id,a?.actual),i=this.s.getApiFor(r);i.parent&&i.parent!==a?.actual&&this.s.getChildren(i.parent).delete(r.id);let p=this.tree.get(h.toString());if(!p){p={fullId:h,actual:r,expandLevels:a?.expandLevels?a.expandLevels-1:void 0,expand:0},r.tags.forEach(this.D,this),this.tree.set(p.fullId.toString(),p),this.G(r,a),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:p.expand,item:this.s.toITestItem(r)}}),this.I(r,p,a);return}if(p.actual===r){this.H(r,p,a);return}if(p.actual.uri?.toString()!==r.uri?.toString())return this.O(h.toString()),this.z(r,a);const u=this.s.getChildren(p.actual),o=p.actual,E=l(this.s.toITestItem(o),this.s.toITestItem(r));this.s.getApiFor(o).listener=void 0,p.actual=r,p.expand=0,E&&(E.hasOwnProperty("tags")&&(this.C(r.tags,o.tags,h.toString()),delete E.tags),this.w(p,{op:4,update:E})),this.I(r,p,a);for(const[w,m]of u)this.s.getChildren(r).get(m.id)||this.O(g.$QK.joinToString(h,m.id));this.y(p.actual.uri)}C(r,a,h){const i=new Set(a.map(p=>p.id));for(const p of r)i.delete(p.id)||this.D(p);this.pushDiff({op:1,item:{extId:h,item:{tags:r.map(p=>(0,R.$UK)(this.s.controllerId,p.id))}}}),i.forEach(this.F,this)}D(r){const a=this.j.get(r.id);a?a.refCount++:(this.j.set(r.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,R.$UK)(this.s.controllerId,r.id)}}))}F(r){const a=this.j.get(r);a&&!--a.refCount&&(this.j.delete(r),this.pushDiff({op:7,id:(0,R.$UK)(this.s.controllerId,r)}))}G(r,a){this.s.getApiFor(r).parent=a&&a.actual!==this.root?a.actual:void 0}H(r,a,h){this.G(r,h);const i=this.s.getApiFor(r);i.parent=h?.actual,i.listener=p=>this.w(a,p),this.J(a)}I(r,a,h){this.H(r,a,h);for(const[i,p]of this.s.getChildren(r))this.z(p,a)}J(r){let a;this.h?r.resolveBarrier?a=r.resolveBarrier.isOpen()?3:2:a=r.actual.canResolveChildren?1:0:a=0,a!==r.expand&&(r.expand=a,this.pushDiff({op:1,item:{extId:r.fullId.toString(),expand:a}}),a===1&&r.expandLevels!==void 0&&this.M(r))}L(r,a){if(a<0)return;const h=[];for(const[i,p]of this.s.getChildren(r.actual)){const u=this.expand(g.$QK.joinToString(r.fullId,p.id),a);(0,S.$3g)(u)&&h.push(u)}if(h.length)return Promise.all(h).then(()=>{})}M(r){if(r.resolveBarrier)return r.resolveBarrier;if(!this.h){const p=new S.$dh;return p.open(),p}r.expand=2,this.N(r);const a=r.resolveBarrier=new S.$dh,h=p=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,p)};let i;try{i=this.h(r.actual===this.root?void 0:r.actual)}catch(p){h(p)}return(0,S.$3g)(i)?i.catch(h).then(()=>{a.open(),this.J(r)}):(a.open(),this.J(r)),r.resolveBarrier}N(r){this.pushDiff({op:1,item:{extId:r.fullId.toString(),expand:r.expand}})}O(r){const a=this.tree.get(r);if(!a)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:r});const h=[a];for(;h.length;){const i=h.pop();if(i){this.s.getApiFor(i.actual).listener=void 0;for(const p of i.actual.tags)this.F(p.id);this.tree.delete(i.fullId.toString());for(const[p,u]of this.s.getChildren(i.actual))h.push(this.tree.get(g.$QK.joinToString(i.fullId,u.id)))}}}flushDiff(){const r=this.collectDiff();r.length&&this.g.fire(r)}}e.$7N=v;class $ extends Error{constructor(r){super(`Attempted to insert a duplicate test item ID ${r}`)}}e.$8N=$;class s extends Error{constructor(r){super(`TestItem with ID "${r}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$9N=s;class c extends Error{constructor(r,a,h){super(`TestItem with ID "${r}" is from controller "${a}" and cannot be added as a child of an item from controller "${h}".`)}}e.$0N=c;const t=(n,r,a)=>{let h=new Map;return{get size(){return h.size},forEach(i,p){for(const u of h.values())i.call(p,u,this)},[Symbol.iterator](){return h.entries()},replace(i){const p=new Map,u=new Set(h.keys()),o={op:5,ops:[]};for(const E of i){if(!(E instanceof a))throw new s(E.id);const w=r(E).controllerId;if(w!==n.controllerId)throw new c(E.id,w,n.controllerId);if(p.has(E.id))throw new $(E.id);p.set(E.id,E),u.delete(E.id),o.ops.push({op:0,item:E})}for(const E of u.keys())o.ops.push({op:3,id:E});n.listener?.(o),h=p},add(i){if(!(i instanceof a))throw new s(i.id);h.set(i.id,i),n.listener?.({op:0,item:i})},delete(i){h.delete(i)&&n.listener?.({op:3,id:i})},get(i){return h.get(i)},toJSON(){return Array.from(h.values())}}};e.$$N=t}),define(Re[103],Ae([1,0,75]),function(fe,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aO=e.$_N=void 0;const F=new WeakMap,P=(R,g)=>{const f={controllerId:g};return F.set(R,f),f};e.$_N=P;const L=R=>{const g=F.get(R);if(!g)throw new S.$9N(R?.id||"<unknown>");return g};e.$aO=L}),define(Re[76],Ae([1,0,12,2]),function(fe,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bxb=e.$Axb=e.$zxb=e.$yxb=e.$xxb=void 0,e.$xxb="vscode-cdn.net",e.$yxb=`vscode-resource.${e.$xxb}`,e.$zxb=`'self' https://*.${e.$xxb}`;function P(g,f){return g.scheme===S.Schemas.http||g.scheme===S.Schemas.https?g:(f&&f.authority&&f.isRemote&&g.scheme===S.Schemas.file&&(g=F.URI.from({scheme:S.Schemas.vscodeRemote,authority:f.authority,path:g.path})),F.URI.from({scheme:S.Schemas.https,authority:`${g.scheme}+${L(g.authority)}.${e.$yxb}`,path:g.path,fragment:g.fragment,query:g.query}))}e.$Axb=P;function L(g){return g.replace(/./g,f=>{const D=f.charCodeAt(0);return D>=97&&D<=122||D>=65&&D<=90||D>=48&&D<=57?f:"-"+D.toString(16).padStart(4,"0")})}function R(g){return g.replace(/-([0-9a-f]{4})/g,(f,D)=>String.fromCharCode(parseInt(D,16)))}e.$Bxb=R}),define(Re[214],Ae([1,0,5,6,76]),function(fe,e,S,F,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xhc=void 0;class L{constructor(g,f,D){this.d=g,this.e=f,this.f=D,this.a=0,this.b=new F.$Sc,this.c=new Map,this.b.add(f.onDidChangeVisibleTextEditors(()=>{const M=f.getVisibleTextEditors();for(const k of this.c.values())M.indexOf(k.editor)<0&&k.inset.dispose()}))}dispose(){this.c.forEach(g=>g.inset.dispose()),this.b.dispose()}createWebviewEditorInset(g,f,D,M,k){let l;for(const r of this.e.getVisibleTextEditors(!0))if(r.value===g){l=r;break}if(!l)throw new Error("not a visible editor");const v=this,$=this.a++,s=new S.$5d,c=new S.$5d,t=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(r){return(0,P.$Axb)(r,v.f)}get cspSource(){return P.$zxb}set options(r){this.b=r,v.d.$setOptions($,r)}get options(){return this.b}set html(r){this.a=r,v.d.$setHtml($,r)}get html(){return this.a}get onDidReceiveMessage(){return s.event}postMessage(r){return v.d.$postMessage($,r)}},n=new class{constructor(){this.editor=g,this.line=f,this.height=D,this.webview=t,this.onDidDispose=c.event}dispose(){v.c.has($)&&(v.c.delete($),v.d.$disposeEditorInset($),c.fire(),c.dispose(),s.dispose())}};return this.d.$createEditorInset($,l.id,l.value.document.uri,f+1,D,M||{},k.identifier,k.extensionLocation),this.c.set($,{editor:g,inset:n,onDidReceiveMessage:s}),n}$onDidDispose(g){const f=this.c.get(g);f&&f.inset.dispose()}$onDidReceiveMessage(g,f){this.c.get(g)?.onDidReceiveMessage.fire(f)}}e.$Xhc=L}),define(Re[104],Ae([1,0,4]),function(fe,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7K=e.$6K=void 0,e.$6K="__",e.$7K=(0,S.$ei)("IAuthenticationService")}),define(Re[215],Ae([1,0,4]),function(fe,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4O=e.VariableKind=e.$3O=void 0,e.$3O=(0,S.$ei)("configurationResolverService");var F;(function(L){L.Unknown="unknown",L.Env="env",L.Config="config",L.Command="command",L.Input="input",L.ExtensionInstallFolder="extensionInstallFolder",L.WorkspaceFolder="workspaceFolder",L.Cwd="cwd",L.WorkspaceFolderBasename="workspaceFolderBasename",L.UserHome="userHome",L.LineNumber="lineNumber",L.SelectedText="selectedText",L.File="file",L.FileWorkspaceFolder="fileWorkspaceFolder",L.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",L.RelativeFile="relativeFile",L.RelativeFileDirname="relativeFileDirname",L.FileDirname="fileDirname",L.FileExtname="fileExtname",L.FileBasename="fileBasename",L.FileBasenameNoExtension="fileBasenameNoExtension",L.FileDirnameBasename="fileDirnameBasename",L.ExecPath="execPath",L.ExecInstallFolder="execInstallFolder",L.PathSeparator="pathSeparator",L.PathSeparatorAlias="/"})(F||(e.VariableKind=F={}));class P extends Error{constructor(R,g){super(g),this.variable=R}}e.$4O=P}),define(Re[216],Ae([1,0,19,73,16,26,21,94,178,215,13]),function(fe,e,S,F,P,L,R,g,f,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fP=void 0;class k{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(v,$,s,c){this.h=new Map,this.a=v,this.b=$,this.g=s,c&&(this.c=c.then(t=>this.i(t)))}i(v){if(R.$i){const $=Object.create(null);return Object.keys(v).forEach(s=>{$[s.toLowerCase()]=v[s]}),$}return v}resolveWithEnvironment(v,$,s){return this.l({env:this.i(v),userHome:void 0},$?$.uri:void 0,s)}async resolveAsync(v,$){const s={env:await this.c,userHome:await this.g};return this.l(s,v?v.uri:void 0,$)}async j(v,$,s,c){const t=L.$Hn($);R.$i&&t.windows?Object.keys(t.windows).forEach(r=>t[r]=t.windows[r]):R.$j&&t.osx?Object.keys(t.osx).forEach(r=>t[r]=t.osx[r]):R.$k&&t.linux&&Object.keys(t.linux).forEach(r=>t[r]=t.linux[r]),delete t.windows,delete t.osx,delete t.linux;const n={env:await this.c,userHome:await this.g};return this.l(n,v?v.uri:void 0,t,s,c)}async resolveAnyAsync(v,$,s){return this.j(v,$,s)}async resolveAnyMap(v,$,s){const c=new Map;return{newConfig:await this.j(v,$,s,c),resolvedVariables:c}}resolveWithInteractionReplace(v,$,s,c){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(v,$,s,c){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(v,$){if(this.h.has(v))throw new Error("Variable "+v+" is contributed twice.");this.h.set(v,$)}async l(v,$,s,c,t){if(P.$Sf(s))return this.m(v,$,s,c,t);if(Array.isArray(s))return Promise.all(s.map(n=>this.l(v,$,n,c,t)));if(P.$Uf(s)){const n=Object.create(null),r=await Promise.all(Object.keys(s).map(async a=>[await this.m(v,$,a,c,t),await this.l(v,$,s[a],c,t)]));for(const[a,h]of r)n[a]=h;return n}return s}m(v,$,s,c,t){return(0,M.$bf)(s,k.VARIABLE_REGEXP,async(n,r)=>{if(r.includes(k.VARIABLE_LHS))return n;let a=await this.o(v,n,r,$,c);return t?.set(r,a),a!==n&&P.$Sf(a)&&a.match(k.VARIABLE_REGEXP)&&(a=await this.m(v,$,a,c,t)),a})}n(v){return this.b?this.b.getUriLabel(v,{noPrefix:!0}):v.fsPath}async o(v,$,s,c,t){let n;const r=s.split(":");r.length>1&&(s=r[0],n=r[1]);const a=p=>{const u=this.a.getFilePath();if(u)return(0,g.$9v)(u);throw new D.$4O(p,(0,f.localize)(0,null,$))},h=p=>{const u=a(p);if(this.a.getWorkspaceFolderPathForFile){const o=this.a.getWorkspaceFolderPathForFile();if(o)return(0,g.$9v)(o)}throw new D.$4O(p,(0,f.localize)(1,null,$,S.$nc(u)))},i=p=>{if(n){const u=this.a.getFolderUri(n);if(u)return u;throw new D.$4O(p,(0,f.localize)(2,null,$,n))}if(c)return c;throw this.a.getWorkspaceFolderCount()>1?new D.$4O(p,(0,f.localize)(3,null,$)):new D.$4O(p,(0,f.localize)(4,null,$))};switch(s){case"env":if(n){if(v.env){const p=v.env[R.$i?n.toLowerCase():n];if(P.$Sf(p))return p}return""}throw new D.$4O(D.VariableKind.Env,(0,f.localize)(5,null,$));case"config":if(n){const p=this.a.getConfigurationValue(c,n);if(P.$2f(p))throw new D.$4O(D.VariableKind.Config,(0,f.localize)(6,null,$,n));if(P.$Uf(p))throw new D.$4O(D.VariableKind.Config,(0,f.localize)(7,null,$,n));return p}throw new D.$4O(D.VariableKind.Config,(0,f.localize)(8,null,$));case"command":return this.p(D.VariableKind.Command,$,n,t,"command");case"input":return this.p(D.VariableKind.Input,$,n,t,"input");case"extensionInstallFolder":if(n){const p=await this.a.getExtension(n);if(!p)throw new D.$4O(D.VariableKind.ExtensionInstallFolder,(0,f.localize)(9,null,$,n));return this.n(p.extensionLocation)}throw new D.$4O(D.VariableKind.ExtensionInstallFolder,(0,f.localize)(10,null,$));default:switch(s){case"workspaceRoot":case"workspaceFolder":return(0,g.$9v)(this.n(i(D.VariableKind.WorkspaceFolder)));case"cwd":return c||n?(0,g.$9v)(this.n(i(D.VariableKind.Cwd))):F.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,g.$9v)(S.$nc(this.n(i(D.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(v.userHome)return v.userHome;throw new D.$4O(D.VariableKind.UserHome,(0,f.localize)(11,null,$))}case"lineNumber":{const p=this.a.getLineNumber();if(p)return p;throw new D.$4O(D.VariableKind.LineNumber,(0,f.localize)(12,null,$))}case"selectedText":{const p=this.a.getSelectedText();if(p)return p;throw new D.$4O(D.VariableKind.SelectedText,(0,f.localize)(13,null,$))}case"file":return a(D.VariableKind.File);case"fileWorkspaceFolder":return h(D.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return S.$nc(h(D.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return c||n?S.$lc(this.n(i(D.VariableKind.RelativeFile)),a(D.VariableKind.RelativeFile)):a(D.VariableKind.RelativeFile);case"relativeFileDirname":{const p=S.$mc(a(D.VariableKind.RelativeFileDirname));if(c||n){const u=S.$lc(this.n(i(D.VariableKind.RelativeFileDirname)),p);return u.length===0?".":u}return p}case"fileDirname":return S.$mc(a(D.VariableKind.FileDirname));case"fileExtname":return S.$oc(a(D.VariableKind.FileExtname));case"fileBasename":return S.$nc(a(D.VariableKind.FileBasename));case"fileBasenameNoExtension":{const p=S.$nc(a(D.VariableKind.FileBasenameNoExtension));return p.slice(0,p.length-S.$oc(p).length)}case"fileDirnameBasename":return S.$nc(S.$mc(a(D.VariableKind.FileDirnameBasename)));case"execPath":{const p=this.a.getExecPath();return p||$}case"execInstallFolder":{const p=this.a.getAppRoot();return p||$}case"pathSeparator":case"/":return S.sep;default:try{const p=n?`${s}:${n}`:s;return this.p(D.VariableKind.Unknown,$,p,t,void 0)}catch{return $}}}}p(v,$,s,c,t){if(s&&c){const n=t===void 0?c[s]:c[t+":"+s];if(typeof n=="string")return n;throw new D.$4O(v,(0,f.localize)(14,null,$))}return $}}e.$fP=k}),define(Re[105],Ae([1,0,4,102]),function(fe,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nD=e.$mD=e.OpenEditorContext=e.GroupsOrder=e.$lD=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$kD=void 0,e.$kD=(0,S.$ei)("editorGroupsService");var P;(function($){$[$.UP=0]="UP",$[$.DOWN=1]="DOWN",$[$.LEFT=2]="LEFT",$[$.RIGHT=3]="RIGHT"})(P||(e.GroupDirection=P={}));var L;(function($){$[$.HORIZONTAL=0]="HORIZONTAL",$[$.VERTICAL=1]="VERTICAL"})(L||(e.GroupOrientation=L={}));var R;(function($){$[$.FIRST=0]="FIRST",$[$.LAST=1]="LAST",$[$.NEXT=2]="NEXT",$[$.PREVIOUS=3]="PREVIOUS"})(R||(e.GroupLocation=R={}));var g;(function($){$[$.MAXIMIZE=0]="MAXIMIZE",$[$.EXPAND=1]="EXPAND",$[$.EVEN=2]="EVEN"})(g||(e.GroupsArrangement=g={}));var f;(function($){$[$.COPY_EDITORS=0]="COPY_EDITORS",$[$.MOVE_EDITORS=1]="MOVE_EDITORS"})(f||(e.MergeGroupMode=f={}));function D($){const s=$;return(0,F.$7E)(s?.editor)&&(0,F.$7E)(s?.replacement)}e.$lD=D;var M;(function($){$[$.CREATION_TIME=0]="CREATION_TIME",$[$.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",$[$.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(M||(e.GroupsOrder=M={}));var k;(function($){$[$.NEW_EDITOR=1]="NEW_EDITOR",$[$.MOVE_EDITOR=2]="MOVE_EDITOR",$[$.COPY_EDITOR=3]="COPY_EDITOR"})(k||(e.OpenEditorContext=k={}));function l($){const s=$;return!!s&&typeof s.id=="number"&&Array.isArray(s.editors)}e.$mD=l;function v($){return $.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.$nD=v}),define(Re[217],Ae([1,0,4,105]),function(fe,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sD=e.$rD=e.$qD=e.$pD=e.$oD=void 0,e.$oD=(0,S.$ei)("editorService"),e.$pD=-1,e.$qD=-2,e.$rD=-3;function P(L){const R=L;return typeof L=="number"||(0,F.$mD)(R)}e.$sD=P}),define(Re[218],Ae([1,0,4,185]),function(fe,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kL=void 0,e.$kL=(0,S.$fi)(F.$li)}),define(Re[106],Ae([1,0,20,5,19,6,11]),function(fe,e,S,F,P,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$G9b=e.$F9b=e.$E9b=e.$D9b=e.$C9b=void 0;class g{constructor(n,r){this.versionId=n,this.removedDueToLooping=r}}e.$C9b=g;class f{static isHostExtension(n,r,a){if(r.getExtensionDescription(n))return!1;const h=a.getExtensionDescription(n);return h?!!((h.main||h.browser)&&h.api==="none"):!1}constructor(n,r){this.j=n,this.c=new F.$5d,this.onDidChange=this.c.event,this.d=0,this.e=r,this.k()}k(){this.e.sort(s),this.f=new S.$ym,this.g=[],this.h=new Map;for(const n of this.e){if(this.f.has(n.identifier)){console.error("Extension `"+n.identifier.value+"` is already registered");continue}this.f.set(n.identifier,n),this.g.push(n);const r=this.j.readActivationEvents(n);for(const a of r)this.h.has(a)||this.h.set(a,[]),this.h.get(a).push(n)}}set(n){return this.e=n,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(n,r){this.e=c(this.e,r),this.e=this.e.concat(n);const a=f.l(this.e);return this.e=c(this.e,a.map(h=>h.identifier)),this.k(),this.d++,this.c.fire(void 0),new g(this.d,a)}static l(n){const r=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(u){this.d.has(u)||(this.d.add(u),this.e.push(u))}addArc(u,o){this.addNode(u),this.addNode(o),this.c.has(u)?this.c.get(u).push(o):this.c.set(u,[o])}getArcs(u){return this.c.has(u)?this.c.get(u):[]}hasOnlyGoodArcs(u,o){const E=r.getArcs(u);for(let w=0;w<E.length;w++)if(!o.has(E[w]))return!1;return!0}getNodes(){return this.e}},a=new S.$ym;for(const u of n)if(a.set(u.identifier,u),u.extensionDependencies)for(const o of u.extensionDependencies)r.addArc(S.$wm.toKey(u.identifier),S.$wm.toKey(o));const h=new Set;r.getNodes().filter(u=>r.getArcs(u).length===0).forEach(u=>h.add(u));const i=r.getNodes().filter(u=>!h.has(u));let p;do{p=!1;for(let u=0;u<i.length;u++){const o=i[u];r.hasOnlyGoodArcs(o,h)&&(i.splice(u,1),u--,h.add(o),p=!0)}}while(p);return i.map(u=>a.get(u))}containsActivationEvent(n){return this.h.has(n)}containsExtension(n){return this.f.has(n)}getExtensionDescriptionsForActivationEvent(n){const r=this.h.get(n);return r?r.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new D(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(n){const r=this.f.get(n);return r||void 0}getExtensionDescriptionByUUID(n){for(const r of this.g)if(r.uuid===n)return r}getExtensionDescriptionByIdOrUUID(n,r){return this.getExtensionDescription(n)??(r?this.getExtensionDescriptionByUUID(r):void 0)}}e.$D9b=f;class D{constructor(n,r){this.versionId=n,this.extensions=r}}e.$E9b=D;class M{constructor(n){this.d=new v,this.c=new f(n,[])}async acquireLock(n){const r=await this.d.acquire(n);return new k(this,r)}deltaExtensions(n,r,a){if(!n.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(r,a)}containsActivationEvent(n){return this.c.containsActivationEvent(n)}containsExtension(n){return this.c.containsExtension(n)}getExtensionDescriptionsForActivationEvent(n){return this.c.getExtensionDescriptionsForActivationEvent(n)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(n){return this.c.getExtensionDescription(n)}getExtensionDescriptionByUUID(n){return this.c.getExtensionDescriptionByUUID(n)}getExtensionDescriptionByIdOrUUID(n,r){return this.c.getExtensionDescriptionByIdOrUUID(n,r)}}e.$F9b=M;class k extends L.$Tc{constructor(n,r){super(),this.f=n,this.c=!1,this.B(r)}isAcquiredFor(n){return!this.c&&this.f===n}}e.$G9b=k;class l{constructor(n){this.name=n;const r=(0,R.$0g)();this.promise=r.promise,this.c=r.resolve}resolve(n){this.c(n)}}class v{constructor(){this.c=[],this.d=!1}async acquire(n){const r=new l(n);return this.c.push(r),this.e(),r.promise}e(){if(this.d||this.c.length===0)return;const n=this.c.shift();this.d=!0;let r=!0;const a=setTimeout(()=>{r&&console.warn(`The customer named ${n.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),h=()=>{r&&(clearTimeout(a),r=!1,this.d=!1,this.e())};n.resolve((0,L.$Rc)(h))}}var $;(function(t){t[t.Builtin=0]="Builtin",t[t.User=1]="User",t[t.Dev=2]="Dev"})($||($={}));function s(t,n){const r=t.isBuiltin?0:t.isUnderDevelopment?2:1,a=n.isBuiltin?0:n.isUnderDevelopment?2:1;if(r!==a)return r-a;const h=P.$gc.basename(t.extensionLocation.path),i=P.$gc.basename(n.extensionLocation.path);return h<i?-1:h>i?1:0}function c(t,n){const r=new S.$xm(n);return t.filter(a=>!r.has(a.identifier))}}),define(Re[77],Ae([1,0,24]),function(fe,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.$Fm=e.$Em=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var F;(function(D){D[D.Desktop=1]="Desktop",D[D.Web=2]="Web"})(F||(e.UIKind=F={}));var P;(function(D){D[D.VersionMismatch=55]="VersionMismatch",D[D.UnexpectedError=81]="UnexpectedError"})(P||(e.ExtensionHostExitCode=P={}));var L;(function(D){D[D.Initialized=0]="Initialized",D[D.Ready=1]="Ready",D[D.Terminate=2]="Terminate"})(L||(e.MessageType=L={}));function R(D){const M=S.$se.alloc(1);switch(D){case 0:M.writeUInt8(1,0);break;case 1:M.writeUInt8(2,0);break;case 2:M.writeUInt8(3,0);break}return M}e.$Em=R;function g(D,M){if(D.byteLength!==1)return!1;switch(D.readUInt8(0)){case 1:return M===0;case 2:return M===1;case 3:return M===2;default:return!1}}e.$Fm=g;var f;(function(D){D.Start="START_NATIVE_LOG",D.End="END_NATIVE_LOG"})(f||(e.NativeLogMarkers=f={}))}),define(Re[61],Ae([1,0,4,5,14,27,77,57,58,26,2,6,166]),function(fe,e,S,F,P,L,R,g,f,D,M,k,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yO=e.$xO=e.$wO=e.$vO=void 0;let v=class extends k.$Tc{constructor(t,n){super(),this.s=t,this.t=n,this.a=this.B(new F.$5d),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new F.$5d),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=M.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=n.createLogger(this.m,{id:f.$2o,name:(0,l.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(this.n),this.B(n.onDidChangeLogLevel(r=>{(0,P.$Aj)(r)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===P.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(t,n,r){const a=this.getTelemetryDetails(),h=new $(n,r,t,this.n,this.j,this.getBuiltInCommonProperties(t),{isUsageEnabled:a.isUsageEnabled,isErrorsEnabled:a.isErrorsEnabled}),i=this.r.get(t.identifier.value)??[];return this.r.set(t.identifier.value,[...i,h]),h.apiTelemetryLogger}$initializeTelemetryLevel(t,n,r){this.f=t,this.g=n,this.c=r??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(t){const n=Object.create(null);switch(n["common.extname"]=`${t.publisher}.${t.name}`,n["common.extversion"]=t.version,n["common.vscodemachineid"]=this.s.telemetryInfo.machineId,n["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,n["common.sqmid"]=this.s.telemetryInfo.sqmId,n["common.vscodeversion"]=this.s.version,n["common.isnewappinstall"]=s(this.s.telemetryInfo.firstSessionDate),n["common.product"]=this.s.environment.appHost,this.s.uiKind){case R.UIKind.Web:n["common.uikind"]="web";break;case R.UIKind.Desktop:n["common.uikind"]="desktop";break;default:n["common.uikind"]="unknown"}return n["common.remotename"]=(0,g.$ml)((0,f.$8o)(this.s.remote.authority)),n}$onDidChangeTelemetryLevel(t){this.h=this.getTelemetryConfiguration(),this.f=t;const n=this.getTelemetryDetails();this.r.forEach((r,a)=>{const h=r.filter(i=>!i.isDisposed);h.length===0?this.r.delete(a):this.r.set(a,h)}),this.r.forEach(r=>{for(const a of r)a.updateTelemetryEnablements(n.isUsageEnabled,n.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(t,n){const a=this.r.get(t.value)?.filter(i=>!i.isDisposed);if(!a)return this.r.delete(t.value),!1;let h=!1;for(const i of a)i.ignoreUnhandledExtHostErrors||(i.logError(n),h=!0);return h}};e.$vO=v,e.$vO=v=Ze([qe(0,L.$uO),qe(1,P.$zj)],v);class ${static validateSender(t){if(typeof t!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof t.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof t.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof t.flush<"u"&&typeof t.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(t,n,r,a,h,i,p){this.g=r,this.h=a,this.i=h,this.j=i,this.a=new F.$5d,this.ignoreUnhandledExtHostErrors=n?.ignoreUnhandledErrors??!1,this.b=n?.ignoreBuiltInCommonProperties??!1,this.c=n?.additionalCommonProperties,this.f=t,this.d={isUsageEnabled:p.isUsageEnabled,isErrorsEnabled:p.isErrorsEnabled}}updateTelemetryEnablements(t,n){this.e&&(this.d={isUsageEnabled:t,isErrorsEnabled:n},this.a.fire(this.e))}mixInCommonPropsAndCleanData(t){let n="properties"in t?t.properties??{}:t;return n=(0,f.$$o)(n,[]),this.c&&(n=(0,D.$Kn)(n,this.c)),this.b||(n=(0,D.$Kn)(n,this.j)),"properties"in t?t.properties=n:t=n,t}k(t,n){this.f&&(this.g.publisher==="vscode"?t=this.g.name+"/"+t:t=this.g.identifier.value+"/"+t,n=this.mixInCommonPropsAndCleanData(n||{}),this.i||this.f?.sendEventData(t,n),this.h.trace(t,n))}logUsage(t,n){this.d.isUsageEnabled&&this.k(t,n)}logError(t,n){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof t=="string")this.k(t,n);else{const r={name:t.name,message:t.message,stack:t.stack,cause:t.cause},a=(0,f.$$o)(r,[]),h=new Error(a.message,{cause:a.cause});h.stack=a.stack,h.name=a.name,n=this.mixInCommonPropsAndCleanData(n||{}),this.i||this.f.sendErrorData(h,n),this.h.trace("exception",n)}}get apiTelemetryLogger(){if(!this.e){const t=this,n={logUsage:t.logUsage.bind(t),get isUsageEnabled(){return t.d.isUsageEnabled},get isErrorsEnabled(){return t.d.isErrorsEnabled},logError:t.logError.bind(t),dispose:t.dispose.bind(t),onDidChangeEnableStates:t.a.event.bind(t)};this.e=Object.freeze(n)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let t=this.f;this.f=void 0,Promise.resolve(t.flush()).then(t=void 0),this.e=void 0}else this.f=void 0}}e.$wO=$;function s(c){const t=Date.now()-new Date(c).getTime();return isNaN(t)?!1:t<1e3*60*60*24}e.$xO=s,e.$yO=(0,S.$ei)("IExtHostTelemetry")}),define(Re[23],Ae([1,0,5,2,194,101,20,4]),function(fe,e,S,F,P,L,R,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1F=e.$ZF=e.$YF=e.ActivationKind=e.$XF=e.$WF=e.$VF=e.$UF=e.$TF=e.ExtensionHostStartup=e.$SF=e.$RF=e.$QF=e.$PF=void 0,e.$PF=Object.freeze({identifier:new R.$wm("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:F.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$QF="extensions.webWorker",e.$RF=(0,g.$ei)("extensionService");class f{constructor(h){this.dependency=h}}e.$SF=f;var D;(function(a){a[a.EagerAutoStart=1]="EagerAutoStart",a[a.EagerManualStart=2]="EagerManualStart",a[a.Lazy=3]="Lazy"})(D||(e.ExtensionHostStartup=D={}));class M{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(h,i,p){this.c=h,this.d=i.slice(0),this.e=p.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:L.$AF.createActivationEventsMap(this.d)}}set(h,i,p){if(this.c>h)throw new Error(`ExtensionHostExtensions: invalid versionId ${h} (current: ${this.c})`);const u=[],o=[],E=[],w=[],m=k(this.d),I=k(i),d=(G,W)=>G.extensionLocation.toString()===W.extensionLocation.toString()||G.isBuiltin===W.isBuiltin||G.isUserBuiltin===W.isUserBuiltin||G.isUnderDevelopment===W.isUnderDevelopment;for(const G of this.d){const W=I.get(G.identifier);if(!W){u.push(G.identifier),m.delete(G.identifier);continue}if(!d(G,W)){u.push(G.identifier),m.delete(G.identifier);continue}}for(const G of i){const W=m.get(G.identifier);if(!W){o.push(G);continue}if(!d(W,G)){u.push(W.identifier),m.delete(W.identifier);continue}}const y=new R.$xm(this.e),b=new R.$xm(p);for(const G of this.e)b.has(G)||E.push(G);for(const G of p)y.has(G)||w.push(G);const A=L.$AF.createActivationEventsMap(o),T={versionId:h,toRemove:u,toAdd:o,addActivationEvents:A,myToRemove:E,myToAdd:w};return this.delta(T),T}delta(h){if(this.c>=h.versionId)return null;const{toRemove:i,toAdd:p,myToRemove:u,myToAdd:o}=h,E=new R.$xm(i),w=new R.$xm(u);for(let m=0;m<this.d.length;m++)E.has(this.d[m].identifier)&&(this.d.splice(m,1),m--);for(let m=0;m<this.e.length;m++)w.has(this.e[m])&&(this.e.splice(m,1),m--);for(const m of p)this.d.push(m);for(const m of o)this.e.push(m);return this.f=null,h}containsExtension(h){for(const i of this.e)if(R.$wm.equals(i,h))return!0;return!1}containsActivationEvent(h){return this.f||(this.f=this.g()),this.f.has(h)}g(){const h=new Set;for(const i of this.d){if(!this.containsExtension(i.identifier))continue;const p=L.$AF.readActivationEvents(i);for(const u of p)h.add(u)}return h}}e.$TF=M;function k(a){const h=new R.$ym;for(const i of a)h.set(i.identifier,i);return h}function l(a,h){return a.enabledApiProposals?a.enabledApiProposals.includes(h):!1}e.$UF=l;function v(a,h){if(!l(a,h))throw new Error(`Extension '${a.identifier.value}' CANNOT use API proposal: ${h}.
Its package.json#enabledApiProposals-property declares: ${a.enabledApiProposals?.join(", ")??"[]"} but NOT ${h}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${a.identifier.value}`)}e.$VF=v;class ${constructor(h,i,p,u){this.codeLoadingTime=h,this.activateCallTime=i,this.activateResolvedTime=p,this.activationReason=u}}e.$WF=$;class s{constructor(h,i){this.description=h,this.value=i}}e.$XF=s;var c;(function(a){a[a.Normal=0]="Normal",a[a.Immediate=1]="Immediate"})(c||(e.ActivationKind=c={}));function t(a){return{type:a.isBuiltin?0:1,isBuiltin:a.isBuiltin||a.isUserBuiltin,identifier:{id:(0,P.$ep)(a.publisher,a.name),uuid:a.uuid},manifest:a,location:a.extensionLocation,targetPlatform:a.targetPlatform,validations:[],isValid:!0}}e.$YF=t;function n(a,h){return{identifier:new R.$wm((0,P.$cp)(a.manifest.publisher,a.manifest.name)),isBuiltin:a.type===0,isUserBuiltin:a.type===1&&a.isBuiltin,isUnderDevelopment:!!h,extensionLocation:a.location,...a.manifest,uuid:a.identifier.uuid,targetPlatform:a.targetPlatform}}e.$ZF=n;class r{constructor(){this.onDidRegisterExtensions=S.Event.None,this.onDidChangeExtensionsStatus=S.Event.None,this.onDidChangeExtensions=S.Event.None,this.onWillActivateByEvent=S.Event.None,this.onDidChangeResponsiveChange=S.Event.None,this.onWillStop=S.Event.None,this.extensions=[]}activateByEvent(h){return Promise.resolve(void 0)}activateById(h,i){return Promise.resolve(void 0)}activationEventIsDone(h){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(h){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(h,i){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(h){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$1F=r}),define(Re[219],Ae([1,0,15,106,20,23,14,11]),function(fe,e,S,F,P,L,R,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mic=e.$lic=e.$kic=e.$jic=e.$iic=e.$hic=void 0;class f{static{this.NONE=new f(!1,-1,-1,-1)}constructor(t,n,r,a){this.startup=t,this.codeLoadingTime=n,this.activateCallTime=r,this.activateResolvedTime=a}}e.$hic=f;class D{constructor(t){this.a=t,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(t,n){return t===-1||n===-1?-1:n-t}build(){return new f(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$iic=D;class M{constructor(t,n,r,a,h,i){this.activationFailed=t,this.activationFailedError=n,this.activationTimes=r,this.module=a,this.exports=h,this.subscriptions=i}}e.$jic=M;class k extends M{constructor(t){super(!1,null,t,{activate:void 0,deactivate:void 0},void 0,[])}}e.$kic=k;class l extends M{constructor(){super(!1,null,f.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$lic=l;class v extends M{constructor(t){super(!0,t,f.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let $=class{constructor(t,n,r,a){this.g=a,this.a=t,this.b=n,this.c=r,this.d=new P.$ym,this.f=Object.create(null)}dispose(){for(const[t,n]of this.d)n.dispose()}async waitForActivatingExtensions(){const t=[];for(const[n,r]of this.d)t.push(r.wait());await Promise.all(t)}isActivated(t){const n=this.d.get(t);return!!(n&&n.value)}getActivatedExtension(t){const n=this.d.get(t);if(!n||!n.value)throw new Error(`Extension '${t.value}' is not known or not activated`);return n.value}async activateByEvent(t,n){if(this.f[t])return;const r=this.a.getExtensionDescriptionsForActivationEvent(t);await this.h(r.map(a=>({id:a.identifier,reason:{startup:n,extensionId:a.identifier,activationEvent:t}}))),this.f[t]=!0}activateById(t,n){const r=this.a.getExtensionDescription(t);if(!r)throw new Error(`Extension '${t}' is not known`);return this.h([{id:r.identifier,reason:n}])}async h(t){const n=t.filter(r=>!this.isActivated(r.id)).map(r=>this.j(r));await Promise.all(n.map(r=>r.wait()))}j(t){if(this.d.has(t.id))return this.d.get(t.id);if(this.l(t.id))return this.k(t,null,[],null);const n=this.a.getExtensionDescription(t.id);if(!n){const h=new Error(`Cannot activate unknown extension '${t.id.value}'`),i=this.k(t,null,[],new v(h));return this.c.onExtensionActivationError(t.id,h,new L.$SF(t.id.value)),i}const r=[],a=typeof n.extensionDependencies>"u"?[]:n.extensionDependencies;for(const h of a){if(this.m(h))continue;const i=this.d.get(h);if(i){r.push(i);continue}if(this.l(h)){r.push(this.j({id:this.b.getExtensionDescription(h).identifier,reason:t.reason}));continue}const p=this.a.getExtensionDescription(h);if(p){if(!p.main&&!p.browser)continue;r.push(this.j({id:p.identifier,reason:t.reason}));continue}const u=n.displayName||n.identifier.value,o=new Error(`Cannot activate the '${u}' extension because it depends on unknown extension '${h}'`),E=this.k(t,n.displayName,[],new v(o));return this.c.onExtensionActivationError(n.identifier,o,new L.$SF(h)),E}return this.k(t,n.displayName,r,null)}k(t,n,r,a){const h=new s(t.id,n,t.reason,r,a,this.c,this.g);return this.d.set(t.id,h),h}l(t){return F.$D9b.isHostExtension(t,this.a,this.b)}m(t){const n=this.b.getExtensionDescription(t);return n?!n.main&&!n.browser:!1}};e.$mic=$,e.$mic=$=Ze([qe(3,R.$yj)],$);let s=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(t,n,r,a,h,i,p){this.c=t,this.d=n,this.f=r,this.g=a,this.h=h,this.j=i,this.k=p,this.a=new g.$dh,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let t=0;t<this.g.length;t++){const n=this.g[t];if(n.value&&!n.value.activationFailed){this.g.splice(t,1),t--;continue}if(n.value&&n.value.activationFailed){const r=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${n.friendlyName}' failed to activate`);r.detail=n.value.activationFailedError,this.h=new v(r),this.j.onExtensionActivationError(this.c,r,null);return}}this.g.length>0&&await Promise.race(this.g.map(t=>t.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(t){const n=new Error;if(t&&t.name&&(n.name=t.name),t&&t.message?n.message=`Activating extension '${this.c.value}' failed: ${t.message}.`:n.message=`Activating extension '${this.c.value}' failed: ${t}.`,t&&t.stack&&(n.stack=t.stack),this.h=new v(n),this.b&&S.$4(t))return;this.j.onExtensionActivationError(this.c,n,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(t)}}};s=Ze([qe(6,R.$yj)],s)}),define(Re[220],Ae([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({activeComment:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts",aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chatParticipant:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipant.d.ts",chatParticipantAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatTab:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts",chatVariableResolver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codeActionRanges:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentReactor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribIssueReporter:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribMultiDiffEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribSourceControlHistoryItemGroupMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts",contribSourceControlHistoryItemMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts",contribSourceControlInputBoxMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts",contribSourceControlTitleMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",debugVisualization:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts",defaultChatParticipant:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",dropMetadata:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dropMetadata.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findFiles2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",handleIssueUri:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.handleIssueUri.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",inlineEdit:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageModels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModels.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",multiDocumentHighlightProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts",newSymbolNamesProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",notebookVariableProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmMultiDiffEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Re[221],Ae([1,0,180,15,32,96,72,30,20,220,190,101]),function(fe,e,S,F,P,L,R,g,f,D,M,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OF=e.$NF=e.$MF=e.$LF=e.$KF=e.$JF=void 0;const l=g.$Tn.as(R.$Un.JSONContribution);class v{constructor(h,i,p){this.a=h,this.b=i,this.c=p}d(h,i){this.a({type:h,message:i,extensionId:this.b.identifier,extensionPointId:this.c})}error(h){this.d(P.default.Error,h)}warn(h){this.d(P.default.Warning,h)}info(h){this.d(P.default.Info,h)}}e.$JF=v;class ${static a(h){const i=new f.$xm;for(let p=0,u=h.length;p<u;p++)i.add(h[p].description.identifier);return i}static compute(h,i){if(!h||!h.length)return new $(i,[]);if(!i||!i.length)return new $([],h);const p=this.a(h),u=this.a(i),o=i.filter(w=>!p.has(w.description.identifier)),E=h.filter(w=>!u.has(w.description.identifier));return new $(o,E)}constructor(h,i){this.added=h,this.removed=i}}e.$KF=$;class s{constructor(h,i){this.name=h,this.defaultExtensionKind=i,this.a=null,this.b=null,this.c=null}setHandler(h){if(this.a!==null)throw new Error("Handler already set!");this.a=h,this.d()}acceptUsers(h){this.c=$.compute(this.b,h),this.b=h,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(h){(0,F.$1)(h)}}}e.$LF=s;const c={type:"string",enum:["ui","workspace"],enumDescriptions:[S.localize(0,null),S.localize(1,null)]},t="vscode://schemas/vscode-extensions";e.$MF={properties:{engines:{type:"object",description:S.localize(2,null),properties:{vscode:{type:"string",description:S.localize(3,null),default:"^1.22.0"}}},publisher:{description:S.localize(4,null),type:"string"},displayName:{description:S.localize(5,null),type:"string"},categories:{description:S.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:f.$vm},{type:"string",const:"Languages",deprecationMessage:S.localize(7,null)}]}},galleryBanner:{type:"object",description:S.localize(8,null),properties:{color:{description:S.localize(9,null),type:"string"},theme:{description:S.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:S.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:S.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:S.localize(13,null)},enabledApiProposals:{markdownDescription:S.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(D.allApiProposals),markdownEnumDescriptions:Object.values(D.allApiProposals)}},api:{markdownDescription:S.localize(15,null),type:"string",enum:["none"],enumDescriptions:[S.localize(16,null)]},activationEvents:{description:S.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:S.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:S.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:S.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:S.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:S.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:S.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:S.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:S.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:S.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:S.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:S.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:S.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:S.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:S.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:S.localize(32,null)},{label:"onUri",body:"onUri",description:S.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:S.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:S.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:S.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:S.localize(37,null)},{label:"onRenderer",description:S.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:S.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:S.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:S.localize(41,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:S.localize(42,null)},{label:"*",description:S.localize(43,null),body:"*"}]}},badges:{type:"array",description:S.localize(44,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:S.localize(45,null)},href:{type:"string",description:S.localize(46,null)},description:{type:"string",description:S.localize(47,null)}}}},markdown:{type:"string",description:S.localize(48,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:S.localize(49,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:S.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:L.$yo}},extensionPack:{description:S.localize(51,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:L.$yo}},extensionKind:{description:S.localize(52,null),type:"array",items:c,default:["workspace"],defaultSnippets:[{body:["ui"],description:S.localize(53,null)},{body:["workspace"],description:S.localize(54,null)},{body:["ui","workspace"],description:S.localize(55,null)},{body:["workspace","ui"],description:S.localize(56,null)},{body:[],description:S.localize(57,null)}]},capabilities:{description:S.localize(58,null),type:"object",properties:{virtualWorkspaces:{description:S.localize(59,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:S.localize(60,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[S.localize(61,null),S.localize(62,null),S.localize(63,null)]},description:{type:"string",markdownDescription:S.localize(64,null)}}},untrustedWorkspaces:{description:S.localize(65,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:S.localize(66,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[S.localize(67,null),S.localize(68,null),S.localize(69,null)]},restrictedConfigurations:{description:S.localize(70,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:S.localize(71,null)}}}}},sponsor:{description:S.localize(72,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:S.localize(73,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:S.localize(74,null),type:"string"},"vscode:uninstall":{description:S.localize(75,null),type:"string"}}},icon:{type:"string",description:S.localize(76,null)},l10n:{type:"string",description:S.localize(77,null)},pricing:{type:"string",markdownDescription:S.localize(78,null),enum:["Free","Trial"],default:"Free"}}};class n{constructor(){this.a=new Map}registerExtensionPoint(h){if(this.a.has(h.extensionPoint))throw new Error("Duplicate extension point: "+h.extensionPoint);const i=new s(h.extensionPoint,h.defaultExtensionKind);return this.a.set(h.extensionPoint,i),h.activationEventsGenerator&&k.$AF.register(h.extensionPoint,h.activationEventsGenerator),e.$MF.properties.contributes.properties[h.extensionPoint]=h.jsonSchema,l.registerSchema(t,e.$MF),i}getExtensionPoints(){return Array.from(this.a.values())}}e.$NF=n;const r={ExtensionsRegistry:"ExtensionsRegistry"};g.$Tn.add(r.ExtensionsRegistry,new n),e.$OF=g.$Tn.as(r.ExtensionsRegistry),l.registerSchema(t,e.$MF),l.registerSchema(M.$Rj,{properties:{extensionEnabledApiProposals:{description:S.localize(79,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(D.allApiProposals),markdownEnumDescriptions:Object.values(D.allApiProposals)}}]}}}})}),define(Re[222],Ae([1,0,176,16,26,221,36,5]),function(fe,e,S,F,P,L,R,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cH=void 0;const f={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:S.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:S.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:S.localize(2,null),default:""}}};var D;(function(l){function v($,s,c){if(!$)return;const t=F.$Sf($.type)?$.type:void 0;if(!t||t.length===0){c.error(S.localize(3,null));return}const n=[];if(Array.isArray($.required))for(const r of $.required)F.$Sf(r)&&n.push(r);return{extensionId:s.value,taskType:t,required:n,properties:$.properties?P.$Hn($.properties):{},when:$.when?R.$cj.deserialize($.when):void 0}}l.from=v})(D||(D={}));const M=L.$OF.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(l,v)=>{for(const $ of l)$.type&&v.push(`onTaskType:${$.type}`)},jsonSchema:{description:S.localize(4,null),type:"array",items:f}});class k{constructor(){this.d=new g.$5d,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((v,$)=>{M.setHandler((s,c)=>{this.c=void 0;try{for(const t of c.removed){const n=t.value;for(const r of n)this.a&&r.type&&this.a[r.type]&&delete this.a[r.type]}for(const t of c.added){const n=t.value;for(const r of n){const a=D.from(r,t.description.identifier,t.collector);a&&(this.a[a.taskType]=a)}}(c.removed.length>0||c.added.length>0)&&this.d.fire()}catch{}v(void 0)})})}onReady(){return this.b}get(v){return this.a[v]}all(){return Object.keys(this.a).map(v=>this.a[v])}getJsonSchema(){if(this.c===void 0){const v=[];for(const $ of this.all()){const s={type:"object",additionalProperties:!1};$.required.length>0&&(s.required=$.required.slice(0)),$.properties!==void 0?s.properties=P.$Hn($.properties):s.properties=Object.create(null),s.properties.type={type:"string",enum:[$.taskType]},v.push(s)}this.c={oneOf:v}}return this.c}}e.$cH=new k}),define(Re[223],Ae([1,0,177,16,25,26,36,222]),function(fe,e,S,F,P,L,R,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$mH=e.JsonSchemaVersion=e.ExecutionEngine=e.$lH=e.$kH=e.$jH=e.$iH=e.$hH=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$gH=e.ShellQuoting=e.$fH=e.$eH=e.$dH=void 0,e.$dH="settings",e.$eH=new R.$vj("taskRunning",!1,S.localize(0,null)),e.$fH=S.localize2(2,"Tasks");var f;(function(C){C[C.Escape=1]="Escape",C[C.Strong=2]="Strong",C[C.Weak=3]="Weak"})(f||(e.ShellQuoting=f={})),e.$gH="$customized",function(C){function O(V){if(!V)return C.Strong;switch(V.toLowerCase()){case"escape":return C.Escape;case"strong":return C.Strong;case"weak":return C.Weak;default:return C.Strong}}C.from=O}(f||(e.ShellQuoting=f={}));var D;(function(C){C.defaults={cwd:"${workspaceFolder}"}})(D||(e.CommandOptions=D={}));var M;(function(C){C[C.Always=1]="Always",C[C.Silent=2]="Silent",C[C.Never=3]="Never"})(M||(e.RevealKind=M={})),function(C){function O(V){switch(V.toLowerCase()){case"always":return C.Always;case"silent":return C.Silent;case"never":return C.Never;default:return C.Always}}C.fromString=O}(M||(e.RevealKind=M={}));var k;(function(C){C[C.Never=1]="Never",C[C.OnProblem=2]="OnProblem",C[C.Always=3]="Always"})(k||(e.RevealProblemKind=k={})),function(C){function O(V){switch(V.toLowerCase()){case"always":return C.Always;case"never":return C.Never;case"onproblem":return C.OnProblem;default:return C.OnProblem}}C.fromString=O}(k||(e.RevealProblemKind=k={}));var l;(function(C){C[C.Shared=1]="Shared",C[C.Dedicated=2]="Dedicated",C[C.New=3]="New"})(l||(e.PanelKind=l={})),function(C){function O(V){switch(V.toLowerCase()){case"shared":return C.Shared;case"dedicated":return C.Dedicated;case"new":return C.New;default:return C.Shared}}C.fromString=O}(l||(e.PanelKind=l={}));var v;(function(C){C.defaults={echo:!0,reveal:M.Always,revealProblems:k.Never,focus:!1,panel:l.Shared,showReuseMessage:!0,clear:!1}})(v||(e.PresentationOptions=v={}));var $;(function(C){C[C.Shell=1]="Shell",C[C.Process=2]="Process",C[C.CustomExecution=3]="CustomExecution"})($||(e.RuntimeType=$={})),function(C){function O(re){switch(re.toLowerCase()){case"shell":return C.Shell;case"process":return C.Process;case"customExecution":return C.CustomExecution;default:return C.Process}}C.fromString=O;function V(re){switch(re){case C.Shell:return"shell";case C.Process:return"process";case C.CustomExecution:return"customExecution";default:return"process"}}C.toString=V}($||(e.RuntimeType=$={}));var s;(function(C){function O(V){return F.$Sf(V)?V:V.value}C.value=O})(s||(e.CommandString=s={}));var c;(function(C){C.Clean={_id:"clean",isDefault:!1},C.Build={_id:"build",isDefault:!1},C.Rebuild={_id:"rebuild",isDefault:!1},C.Test={_id:"test",isDefault:!1};function O(re){return re===C.Clean._id||re===C.Build._id||re===C.Rebuild._id||re===C.Test._id}C.is=O;function V(re){if(re!==void 0)return F.$Sf(re)?O(re)?{_id:re,isDefault:!1}:void 0:re}C.from=V})(c||(e.TaskGroup=c={}));var t;(function(C){C[C.Global=1]="Global",C[C.Workspace=2]="Workspace",C[C.Folder=3]="Folder"})(t||(e.TaskScope=t={}));var n;(function(C){C.Workspace="workspace",C.Extension="extension",C.InMemory="inMemory",C.WorkspaceFile="workspaceFile",C.User="user";function O(V){switch(V){case C.User:return 2;case C.WorkspaceFile:return 5;default:return 6}}C.toConfigurationTarget=O})(n||(e.TaskSourceKind=n={}));var r;(function(C){C.parallel="parallel",C.sequence="sequence"})(r||(e.DependsOrder=r={}));var a;(function(C){C[C.default=1]="default",C[C.folderOpen=2]="folderOpen"})(a||(e.RunOnOptions=a={}));var h;(function(C){C.defaults={reevaluateOnRerun:!0,runOn:a.default,instanceLimit:1}})(h||(e.RunOptions=h={}));class i{constructor(O,V,re,ue,ye,De){this._label="",this._id=O,V&&(this._label=V),re&&(this.type=re),this.runOptions=ue,this.configurationProperties=ye,this._source=De}getDefinition(O){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const O={folder:this.d(),id:this._id};return JSON.stringify(O)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(O,V=!1){if(O===void 0)return!1;if(F.$Sf(O))return O===this._label||O===this.configurationProperties.identifier||V&&O===this._id;const re=this.getDefinition(!0);return re!==void 0&&re._key===O._key}getQualifiedLabel(){const O=this.getWorkspaceFolder();return O?`${this._label} (${O.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(O){this.c===void 0&&(this.c=[]),O&&(this.c=this.c.concat(O))}get taskLoadMessages(){return this.c}}e.$hH=i;class p extends i{constructor(O,V,re,ue,ye,De,he,ve){super(O,re,void 0,he,ve,V),this.command={},this._source=V,this.hasDefinedMatchers=De,ye&&(this.command=ye)}clone(){return new p(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(O=!1){if(O&&this._source.customizes!==void 0)return this._source.customizes;{let V;switch(this.command?this.command.runtime:void 0){case $.Shell:V="shell";break;case $.Process:V="process";break;case $.CustomExecution:V="customExecution";break;case void 0:V="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:V,_key:this._id,id:this._id}}}static is(O){return O instanceof p}getMapKey(){const O=this._source.config.workspaceFolder;return O?`${O.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===n.User?e.$dH:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const O=this.d();if(!O)return;let V=this.configurationProperties.identifier;this._source.kind!==n.Workspace&&(V+=this._source.kind);const re={type:e.$gH,folder:O,id:V};return JSON.stringify(re)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?P.$Og(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(O){return new p(O._id,O._source,O._label,O.type,O.command,O.hasDefinedMatchers,O.runOptions,O.configurationProperties)}}e.$iH=p;class u extends i{constructor(O,V,re,ue,ye,De,he){super(O,re,ue,De,he,V),this._source=V,this.configures=ye}static is(O){return O instanceof u}f(O){return O}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?P.$Og(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===n.User?e.$dH:this._source.config.workspaceFolder?.uri.toString()}getKey(){const O=this.d();if(!O)return;let V=this.configurationProperties.identifier;this._source.kind!==n.Workspace&&(V+=this._source.kind);const re={type:e.$gH,folder:O,id:V};return JSON.stringify(re)}}e.$jH=u;class o extends i{constructor(O,V,re,ue,ye,De,he,ve,se){super(O,re,ue,ve,se,V),this.defines=ye,this.hasDefinedMatchers=he,this.command=De,this.icon=se.icon,this.hide=se.hide}clone(){return new o(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(O){return O instanceof o}getMapKey(){const O=this._source.workspaceFolder;return O?`${this._source.scope.toString()}|${O.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const O={type:"contributed",scope:this._source.scope,id:this._id};return O.folder=this.d(),JSON.stringify(O)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(O){return new o(O._id,O._source,O._label,O.type,O.defines,O.command,O.hasDefinedMatchers,O.runOptions,O.configurationProperties)}}e.$kH=o;class E extends i{constructor(O,V,re,ue,ye,De){super(O,re,ue,ye,De,V),this._source=V}clone(){return new E(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(O){return O instanceof E}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(O){return new E(O._id,O._source,O._label,O.type,O.runOptions,O.configurationProperties)}}e.$lH=E;var w;(function(C){C[C.Process=1]="Process",C[C.Terminal=2]="Terminal"})(w||(e.ExecutionEngine=w={})),function(C){C._default=C.Terminal}(w||(e.ExecutionEngine=w={}));var m;(function(C){C[C.V0_1_0=1]="V0_1_0",C[C.V2_0_0=2]="V2_0_0"})(m||(e.JsonSchemaVersion=m={}));class I{constructor(O){this.c=new Map;for(let V=0;V<O.length;V++)this.c.set(O[V].uri.toString(),V)}compare(O,V){const re=O.getWorkspaceFolder(),ue=V.getWorkspaceFolder();if(re&&ue){let ye=this.c.get(re.uri.toString());ye=ye===void 0?0:ye+1;let De=this.c.get(ue.uri.toString());return De=De===void 0?0:De+1,ye===De?O._label.localeCompare(V._label):ye-De}else return!re&&ue?-1:re&&!ue?1:0}}e.$mH=I;var d;(function(C){C.DependsOnStarted="dependsOnStarted",C.AcquiredInput="acquiredInput",C.Start="start",C.ProcessStarted="processStarted",C.Active="active",C.Inactive="inactive",C.Changed="changed",C.Terminated="terminated",C.ProcessEnded="processEnded",C.End="end"})(d||(e.TaskEventKind=d={}));var y;(function(C){C.SingleRun="singleRun",C.Background="background"})(y||(e.TaskRunType=y={}));var b;(function(C){C[C.System=0]="System",C[C.User=1]="User",C[C.FolderOpen=2]="FolderOpen",C[C.ConfigurationChange=3]="ConfigurationChange",C[C.Reconnect=4]="Reconnect"})(b||(e.TaskRunSource=b={}));var A;(function(C){function O(ve){return{taskId:ve._id,taskName:ve.configurationProperties.name,runType:ve.configurationProperties.isBackground?"background":"singleRun",group:ve.configurationProperties.group,__task:ve}}function V(ve,se,$e){return{...O(ve),kind:"start",terminalId:se,resolvedVariables:$e}}C.start=V;function re(ve,se,$e){return{...O(ve),kind:"processStarted",terminalId:se,processId:$e}}C.processStarted=re;function ue(ve,se,$e){return{...O(ve),kind:"processEnded",terminalId:se,exitCode:$e}}C.processEnded=ue;function ye(ve,se,$e){return{...O(ve),kind:"terminated",exitReason:$e,terminalId:se}}C.terminated=ye;function De(ve,se,$e){return{...O(se),kind:ve,terminalId:$e}}C.general=De;function he(){return{kind:"changed"}}C.changed=he})(A||(e.TaskEvent=A={}));var T;(function(C){function O(re){const ue=Object.keys(re).sort();let ye="";for(const De of ue){let he=re[De];he instanceof Object?he=O(he):typeof he=="string"&&(he=he.replace(/,/g,",,")),ye+=De+","+he+","}return ye}function V(re){const ye={_key:O(re),type:re.taskType};return Object.assign(ye,re),ye}C.create=V})(T||(e.KeyedTaskIdentifier=T={}));var G;(function(C){C.AutoDetect="task.autoDetect",C.SaveBeforeRun="task.saveBeforeRun",C.ShowDecorations="task.showDecorations",C.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",C.SlowProviderWarning="task.slowProviderWarning",C.QuickOpenHistory="task.quickOpen.history",C.QuickOpenDetail="task.quickOpen.detail",C.QuickOpenSkip="task.quickOpen.skip",C.QuickOpenShowAll="task.quickOpen.showAll",C.AllowAutomaticTasks="task.allowAutomaticTasks",C.Reconnection="task.reconnection",C.VerboseLogging="task.verboseLogging"})(G||(e.TaskSettingId=G={}));var W;(function(C){C.Tasks="tasks",C.SuppressTaskName="tasks.suppressTaskName",C.Windows="tasks.windows",C.Osx="tasks.osx",C.Linux="tasks.linux",C.ShowOutput="tasks.showOutput",C.IsShellCommand="tasks.isShellCommand",C.ServiceTestSetting="tasks.service.testSetting"})(W||(e.TasksSchemaProperties=W={}));var U;(function(C){function O(V,re){const ue=g.$cH.get(V.type);if(ue===void 0){const ve=L.$Hn(V);return delete ve._key,T.create(ve)}const ye=Object.create(null);ye.type=ue.taskType;const De=new Set;ue.required.forEach(ve=>De.add(ve));const he=ue.properties;for(const ve of Object.keys(he)){const se=V[ve];if(se!=null)ye[ve]=se;else if(De.has(ve)){const $e=he[ve];if($e.default!==void 0)ye[ve]=L.$Hn($e.default);else switch($e.type){case"boolean":ye[ve]=!1;break;case"number":case"integer":ye[ve]=0;break;case"string":ye[ve]="";break;default:re.error(S.localize(1,null,JSON.stringify(V,void 0,0),ve));return}}}return T.create(ye)}C.createTaskIdentifier=O})(U||(e.TaskDefinition=U={}))}),define(Re[224],Ae([1,0,15]),function(fe,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I9b=e.$H9b=void 0;class F{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((R,g)=>{this.b=R,this.d=g,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(R){this.f||this.h||(this.f=!0,this.g=R,this.a&&this.b(R))}resolveErr(R){this.f||this.h||(this.h=!0,this.i=R,this.a?this.d(R):(0,S.$1)(R))}then(R,g){return this.j().then(R,g)}catch(R){return this.j().then(void 0,R)}finally(R){return this.j().finally(R)}}e.$H9b=F;class P extends F{constructor(){super(),this.h=!0,this.i=new S.$5}}e.$I9b=P}),define(Re[49],Ae([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6v=e.$5v=e.$4v=e.$3v=void 0;class S{static{this.count=0}constructor(f){this._proxyIdentifierBrand=void 0,this.sid=f,this.nid=++S.count}}e.$3v=S;const F=[];function P(g){const f=new S(g);return F[f.nid]=f,f}e.$4v=P;function L(g){return F[g].sid}e.$5v=L;class R{constructor(f){this.value=f}}e.$6v=R}),define(Re[3],Ae([1,0,49]),function(fe,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1L=e.$ZL=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$YL=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var F;(function(s){s[s.Default=0]="Default",s[s.InCenter=1]="InCenter",s[s.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",s[s.AtTop=3]="AtTop"})(F||(e.TextEditorRevealType=F={}));var P;(function(s){s[s.UnknownInput=0]="UnknownInput",s[s.TextInput=1]="TextInput",s[s.TextDiffInput=2]="TextDiffInput",s[s.TextMergeInput=3]="TextMergeInput",s[s.NotebookInput=4]="NotebookInput",s[s.NotebookDiffInput=5]="NotebookDiffInput",s[s.CustomEditorInput=6]="CustomEditorInput",s[s.WebviewEditorInput=7]="WebviewEditorInput",s[s.TerminalEditorInput=8]="TerminalEditorInput",s[s.InteractiveEditorInput=9]="InteractiveEditorInput",s[s.ChatEditorInput=10]="ChatEditorInput"})(P||(e.TabInputKind=P={}));var L;(function(s){s[s.TAB_OPEN=0]="TAB_OPEN",s[s.TAB_CLOSE=1]="TAB_CLOSE",s[s.TAB_UPDATE=2]="TAB_UPDATE",s[s.TAB_MOVE=3]="TAB_MOVE"})(L||(e.TabModelOperationKind=L={}));var R;(function(s){s[s.Editable=0]="Editable",s[s.SupportsHotExit=1]="SupportsHotExit"})(R||(e.WebviewEditorCapabilities=R={}));var g;(function(s){s[s.Int8Array=1]="Int8Array",s[s.Uint8Array=2]="Uint8Array",s[s.Uint8ClampedArray=3]="Uint8ClampedArray",s[s.Int16Array=4]="Int16Array",s[s.Uint16Array=5]="Uint16Array",s[s.Int32Array=6]="Int32Array",s[s.Uint32Array=7]="Uint32Array",s[s.Float32Array=8]="Float32Array",s[s.Float64Array=9]="Float64Array",s[s.BigInt64Array=10]="BigInt64Array",s[s.BigUint64Array=11]="BigUint64Array"})(g||(e.WebviewMessageArrayBufferViewType=g={}));var f;(function(s){s[s.Text=1]="Text",s[s.Error=2]="Error",s[s.Rich=3]="Rich"})(f||(e.CellOutputKind=f={}));var D;(function(s){s[s.Default=0]="Default",s[s.InCenter=1]="InCenter",s[s.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",s[s.AtTop=3]="AtTop"})(D||(e.NotebookEditorRevealType=D={}));var M;(function(s){s[s.None=0]="None",s[s.Process=1]="Process",s[s.Output=2]="Output"})(M||(e.CandidatePortSource=M={}));class k{static{this.a=0}static mixin(c){return c._id=k.a++,c}}e.$YL=k;var l;(function(s){s.label="a",s.kind="b",s.detail="c",s.documentation="d",s.sortText="e",s.filterText="f",s.preselect="g",s.insertText="h",s.insertTextRules="i",s.range="j",s.commitCharacters="k",s.additionalTextEdits="l",s.kindModifier="m",s.commandIdent="n",s.commandId="o",s.commandArguments="p"})(l||(e.ISuggestDataDtoField=l={}));var v;(function(s){s.defaultRanges="a",s.completions="b",s.isIncomplete="c",s.duration="d"})(v||(e.ISuggestResultDtoField=v={}));var $;(function(s){s[s.Workspace=0]="Workspace",s[s.TextDocument=1]="TextDocument"})($||(e.ExtHostTestingResource=$={})),e.$ZL={MainThreadAuthentication:(0,S.$4v)("MainThreadAuthentication"),MainThreadBulkEdits:(0,S.$4v)("MainThreadBulkEdits"),MainThreadChatProvider:(0,S.$4v)("MainThreadChatProvider"),MainThreadChatAgents2:(0,S.$4v)("MainThreadChatAgents2"),MainThreadChatVariables:(0,S.$4v)("MainThreadChatVariables"),MainThreadClipboard:(0,S.$4v)("MainThreadClipboard"),MainThreadCommands:(0,S.$4v)("MainThreadCommands"),MainThreadComments:(0,S.$4v)("MainThreadComments"),MainThreadConfiguration:(0,S.$4v)("MainThreadConfiguration"),MainThreadConsole:(0,S.$4v)("MainThreadConsole"),MainThreadDebugService:(0,S.$4v)("MainThreadDebugService"),MainThreadDecorations:(0,S.$4v)("MainThreadDecorations"),MainThreadDiagnostics:(0,S.$4v)("MainThreadDiagnostics"),MainThreadDialogs:(0,S.$4v)("MainThreadDiaglogs"),MainThreadDocuments:(0,S.$4v)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,S.$4v)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,S.$4v)("MainThreadTextEditors"),MainThreadEditorInsets:(0,S.$4v)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,S.$4v)("MainThreadEditorTabs"),MainThreadErrors:(0,S.$4v)("MainThreadErrors"),MainThreadTreeViews:(0,S.$4v)("MainThreadTreeViews"),MainThreadDownloadService:(0,S.$4v)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,S.$4v)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,S.$4v)("MainThreadLanguages"),MainThreadLogger:(0,S.$4v)("MainThreadLogger"),MainThreadMessageService:(0,S.$4v)("MainThreadMessageService"),MainThreadOutputService:(0,S.$4v)("MainThreadOutputService"),MainThreadProgress:(0,S.$4v)("MainThreadProgress"),MainThreadQuickDiff:(0,S.$4v)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,S.$4v)("MainThreadQuickOpen"),MainThreadStatusBar:(0,S.$4v)("MainThreadStatusBar"),MainThreadSecretState:(0,S.$4v)("MainThreadSecretState"),MainThreadStorage:(0,S.$4v)("MainThreadStorage"),MainThreadSpeech:(0,S.$4v)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,S.$4v)("MainThreadTelemetry"),MainThreadTerminalService:(0,S.$4v)("MainThreadTerminalService"),MainThreadWebviews:(0,S.$4v)("MainThreadWebviews"),MainThreadWebviewPanels:(0,S.$4v)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,S.$4v)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,S.$4v)("MainThreadCustomEditors"),MainThreadUrls:(0,S.$4v)("MainThreadUrls"),MainThreadUriOpeners:(0,S.$4v)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,S.$4v)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,S.$4v)("MainThreadWorkspace"),MainThreadFileSystem:(0,S.$4v)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,S.$4v)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,S.$4v)("MainThreadExtensionService"),MainThreadSCM:(0,S.$4v)("MainThreadSCM"),MainThreadSearch:(0,S.$4v)("MainThreadSearch"),MainThreadShare:(0,S.$4v)("MainThreadShare"),MainThreadTask:(0,S.$4v)("MainThreadTask"),MainThreadWindow:(0,S.$4v)("MainThreadWindow"),MainThreadLabelService:(0,S.$4v)("MainThreadLabelService"),MainThreadNotebook:(0,S.$4v)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,S.$4v)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,S.$4v)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,S.$4v)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,S.$4v)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,S.$4v)("MainThreadInteractive"),MainThreadChat:(0,S.$4v)("MainThreadChat"),MainThreadInlineChat:(0,S.$4v)("MainThreadInlineChatShape"),MainThreadTheming:(0,S.$4v)("MainThreadTheming"),MainThreadTunnelService:(0,S.$4v)("MainThreadTunnelService"),MainThreadManagedSockets:(0,S.$4v)("MainThreadManagedSockets"),MainThreadTimeline:(0,S.$4v)("MainThreadTimeline"),MainThreadTesting:(0,S.$4v)("MainThreadTesting"),MainThreadLocalization:(0,S.$4v)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,S.$4v)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,S.$4v)("MainThreadAiEmbeddingVector"),MainThreadIssueReporter:(0,S.$4v)("MainThreadIssueReporter")},e.$1L={ExtHostCommands:(0,S.$4v)("ExtHostCommands"),ExtHostConfiguration:(0,S.$4v)("ExtHostConfiguration"),ExtHostDiagnostics:(0,S.$4v)("ExtHostDiagnostics"),ExtHostDebugService:(0,S.$4v)("ExtHostDebugService"),ExtHostDecorations:(0,S.$4v)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,S.$4v)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,S.$4v)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,S.$4v)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,S.$4v)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,S.$4v)("ExtHostEditors"),ExtHostTreeViews:(0,S.$4v)("ExtHostTreeViews"),ExtHostFileSystem:(0,S.$4v)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,S.$4v)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,S.$4v)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,S.$4v)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,S.$4v)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,S.$4v)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,S.$4v)("ExtHostQuickDiff"),ExtHostStatusBar:(0,S.$4v)("ExtHostStatusBar"),ExtHostShare:(0,S.$4v)("ExtHostShare"),ExtHostExtensionService:(0,S.$4v)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,S.$4v)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,S.$4v)("ExtHostTerminalService"),ExtHostSCM:(0,S.$4v)("ExtHostSCM"),ExtHostSearch:(0,S.$4v)("ExtHostSearch"),ExtHostTask:(0,S.$4v)("ExtHostTask"),ExtHostWorkspace:(0,S.$4v)("ExtHostWorkspace"),ExtHostWindow:(0,S.$4v)("ExtHostWindow"),ExtHostWebviews:(0,S.$4v)("ExtHostWebviews"),ExtHostWebviewPanels:(0,S.$4v)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,S.$4v)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,S.$4v)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,S.$4v)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,S.$4v)("ExtHostEditorTabs"),ExtHostProgress:(0,S.$4v)("ExtHostProgress"),ExtHostComments:(0,S.$4v)("ExtHostComments"),ExtHostSecretState:(0,S.$4v)("ExtHostSecretState"),ExtHostStorage:(0,S.$4v)("ExtHostStorage"),ExtHostUrls:(0,S.$4v)("ExtHostUrls"),ExtHostUriOpeners:(0,S.$4v)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,S.$4v)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,S.$4v)("ExtHostOutputService"),ExtHostLabelService:(0,S.$4v)("ExtHostLabelService"),ExtHostNotebook:(0,S.$4v)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,S.$4v)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,S.$4v)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,S.$4v)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,S.$4v)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,S.$4v)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,S.$4v)("ExtHostInteractive"),ExtHostInlineChat:(0,S.$4v)("ExtHostInlineChatShape"),ExtHostChat:(0,S.$4v)("ExtHostChat"),ExtHostChatAgents2:(0,S.$4v)("ExtHostChatAgents"),ExtHostChatVariables:(0,S.$4v)("ExtHostChatVariables"),ExtHostChatProvider:(0,S.$4v)("ExtHostChatProvider"),ExtHostSpeech:(0,S.$4v)("ExtHostSpeech"),ExtHostAiRelatedInformation:(0,S.$4v)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,S.$4v)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,S.$4v)("ExtHostTheming"),ExtHostTunnelService:(0,S.$4v)("ExtHostTunnelService"),ExtHostManagedSockets:(0,S.$4v)("ExtHostManagedSockets"),ExtHostAuthentication:(0,S.$4v)("ExtHostAuthentication"),ExtHostTimeline:(0,S.$4v)("ExtHostTimeline"),ExtHostTesting:(0,S.$4v)("ExtHostTesting"),ExtHostTelemetry:(0,S.$4v)("ExtHostTelemetry"),ExtHostLocalization:(0,S.$4v)("ExtHostLocalization"),ExtHostIssueReporter:(0,S.$4v)("ExtHostIssueReporter")}}),define(Re[78],Ae([1,0,4,14,3,17]),function(fe,e,S,F,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hhc=e.$Ghc=e.$Fhc=void 0,e.$Fhc=(0,S.$ei)("IExtHostApiDeprecationService");let R=class{constructor(f,D){this.c=D,this.a=new Set,this.b=f.getProxy(P.$ZL.MainThreadTelemetry)}report(f,D,M){const k=this.d(f,D);this.a.has(k)||(this.a.add(k),D.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${f}' is deprecated. ${M}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:D.identifier.value,apiId:f}))}d(f,D){return`${f}-${D.identifier.value}`}};e.$Ghc=R,e.$Ghc=R=Ze([qe(0,L.$eO),qe(1,F.$yj)],R),e.$Hhc=Object.freeze(new class{report(g,f,D){}})}),define(Re[225],Ae([1,0,51,6,3]),function(fe,e,S,F,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rhc=void 0;class L{static{this.a=0}constructor(f,D){this.extension=f,this.provider=D,this.handle=L.a++}}class R{static{this.a=0}constructor(f){this.b=new Map,this.c=new Map,this.d=f.getProxy(P.$ZL.MainThreadChat)}registerChatProvider(f,D,M){const k=new L(f,M);return this.b.set(k.handle,k),this.d.$registerChatProvider(k.handle,D),(0,F.$Rc)(()=>{this.d.$unregisterChatProvider(k.handle),this.b.delete(k.handle)})}transferChatSession(f,D){const M=S.Iterable.find(this.c.keys(),k=>this.c.get(k)===f)??0;typeof M=="number"&&this.d.$transferChatSession(M,D)}sendInteractiveRequestToProvider(f,D){this.d.$sendRequestToProvider(f,D)}async $prepareChat(f,D){const M=this.b.get(f);if(!M)return;const k=await M.provider.prepareSession(D);if(!k)return;const l=R.a++;return this.c.set(l,k),{id:l,requesterUsername:k.requester?.name,requesterAvatarIconUri:k.requester?.icon,responderUsername:k.responder?.name,responderAvatarIconUri:k.responder?.icon,inputPlaceholder:k.inputPlaceholder}}$releaseSession(f){this.c.delete(f)}}e.$Rhc=R}),define(Re[226],Ae([1,0,3]),function(fe,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vhc=void 0;class F{constructor(L){const R=L.getProxy(S.$ZL.MainThreadClipboard);this.value=Object.freeze({readText(){return R.$readText()},writeText(g){return R.$writeText(g)}})}}e.$Vhc=F}),define(Re[227],Ae([1,0,26,3,27,17]),function(fe,e,S,F,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mjc=void 0;let R=class{constructor(M,k){this.a=M.getProxy(F.$ZL.MainThreadConsole),this.b=k.consoleForward.includeStack,this.c=k.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("debug","debug"),this.d("error","error")}d(M,k){const l=this,v=console[M];Object.defineProperty(console,M,{set:()=>{},get:()=>function(){l.e(M,k,v,arguments)}})}e(M,k,l,v){this.a.$logExtensionHostMessage({type:"__$console",severity:k,arguments:f(v,this.b)}),this.c&&this.f(M,l,v)}};e.$Mjc=R,e.$Mjc=R=Ze([qe(0,L.$eO),qe(1,P.$uO)],R);const g=1e5;function f(D,M){const k=[];if(D.length)for(let l=0;l<D.length;l++){let v=D[l];if(typeof v>"u")v="undefined";else if(v instanceof Error){const $=v;$.stack?v=$.stack:v=$.toString()}k.push(v)}if(M){const l=new Error().stack;l&&k.push({__$stack:l.split(`
`).slice(3).join(`
`)})}try{const l=(0,S.$Mn)(k);return l.length>g?"Output omitted for a large object that exceeds the limits":l}catch(l){return`Output omitted for an object that cannot be inspected ('${l.toString()}')`}}}),define(Re[228],Ae([1,0,2,3,23]),function(fe,e,S,F,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qic=void 0;class L{constructor(g){this.a=g.getProxy(F.$ZL.MainThreadDialogs)}showOpenDialog(g,f){return f?.allowUIResources&&(0,P.$VF)(g,"showLocal"),this.a.$showOpenDialog(f).then(D=>D?D.map(M=>S.URI.revive(M)):void 0)}showSaveDialog(g){return this.a.$showSaveDialog(g).then(f=>f?S.URI.revive(f):void 0)}}e.$Qic=L}),define(Re[229],Ae([1,0,6,3]),function(fe,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_ic=void 0;class P{constructor(R){this.b=0,this.a=R.getProxy(F.$ZL.MainThreadLabelService)}$registerResourceLabelFormatter(R){const g=this.b++;return this.a.$registerResourceLabelFormatter(g,R),(0,S.$Rc)(()=>{this.a.$unregisterResourceLabelFormatter(g)})}}e.$_ic=P}),define(Re[79],Ae([1,0,21,13,2,4,14,3,27,17]),function(fe,e,S,F,P,L,R,g,f,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zic=e.$yic=void 0;let M=class{constructor(l,v,$){this.f=$,this.d=new Map,this.a=v.getProxy(g.$ZL.MainThreadLocalization),this.b=l.environment.appLanguage,this.c=this.b===S.$g}getMessage(l,v){const{message:$,args:s,comment:c}=v;if(this.c)return(0,F.$Ue)($,s??{});let t=$;c&&c.length>0&&(t+=`/${Array.isArray(c)?c.join(""):c}`);const n=this.d.get(l)?.contents[t];return n||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${t}`),(0,F.$Ue)(n??$,s??{})}getBundle(l){return this.d.get(l)?.contents}getBundleUri(l){return this.d.get(l)?.uri}async initializeLocalizedMessages(l){if(this.c||!l.l10n&&!l.isBuiltin||this.d.has(l.identifier.value))return;let v;const $=await this.g(l);if(!$){this.f.error(`No bundle location found for extension ${l.identifier.value}`);return}try{const s=await this.a.$fetchBundleContents($),c=JSON.parse(s);v=l.isBuiltin?c.contents?.bundle:c}catch(s){this.f.error(`Failed to load translations for ${l.identifier.value} from ${$}: ${s.message}`);return}v&&this.d.set(l.identifier.value,{contents:v,uri:$})}async g(l){if(l.isBuiltin){const v=await this.a.$fetchBuiltInBundleUri(l.identifier.value,this.b);return P.URI.revive(v)}return l.l10n?P.URI.joinPath(l.extensionLocation,l.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$yic=M,e.$yic=M=Ze([qe(0,f.$uO),qe(1,D.$eO),qe(2,R.$yj)],M),e.$zic=(0,L.$ei)("IExtHostLocalizationService")}),define(Re[230],Ae([1,0,14,3,27,17,2,52]),function(fe,e,S,F,P,L,R,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ljc=void 0;let f=class extends S.$Jj{constructor(k,l){super(l.logLevel,l.logsLocation,l.loggers.map(v=>(0,g.$Nh)(v))),this.r=k.getProxy(F.$ZL.MainThreadLogger)}$setLogLevel(k,l){l?this.setLogLevel(R.URI.revive(l),k):this.setLogLevel(k)}setVisibility(k,l){super.setVisibility(k,l),this.r.$setVisibility(k,l)}s(k,l,v){return new D(this.r,k,l,v)}};e.$Ljc=f,e.$Ljc=f=Ze([qe(0,L.$eO),qe(1,P.$uO)],f);class D extends S.$Ej{constructor(k,l,v,$){super($?.logLevel==="always"),this.r=k,this.s=l,this.m=!1,this.n=[],this.setLevel(v),this.r.$createLogger(l,$).then(()=>{this.u(this.n),this.m=!0})}g(k,l){const v=[[k,l]];this.m?this.u(v):this.n.push(...v)}u(k){this.r.$log(this.s,k)}flush(){this.r.$flush(this.s)}}}),define(Re[80],Ae([1,0,3,4,6,17,24]),function(fe,e,S,F,P,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bic=e.$Aic=void 0,e.$Aic=(0,F.$ei)("IExtHostManagedSockets");let g=class{constructor(k){this.b=0,this.c=null,this.d=new Map,this.a=k.getProxy(S.$ZL.MainThreadManagedSockets)}setFactory(k,l){for(const v of this.d.values())v.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new f(k,l),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(k){if(!this.c||this.c.socketFactoryId!==k)throw new Error(`No socket factory with id ${k}`);const l=++this.b,v=await this.c.makeConnection(),$=new P.$Sc;return this.d.set(l,new D(l,v,$)),$.add((0,P.$Rc)(()=>this.d.delete(l))),$.add(v.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(l),$.dispose()})),$.add(v.onDidClose(s=>{this.a.$onDidManagedSocketClose(l,s?.stack??s?.message),$.dispose()})),$.add(v.onDidReceiveMessage(s=>this.a.$onDidManagedSocketHaveData(l,R.$se.wrap(s)))),l}$remoteSocketWrite(k,l){this.d.get(k)?.actual.send(l.buffer)}$remoteSocketEnd(k){const l=this.d.get(k);l&&(l.actual.end(),l.dispose())}async $remoteSocketDrain(k){await this.d.get(k)?.actual.drain?.()}};e.$Bic=g,e.$Bic=g=Ze([qe(0,L.$eO)],g);class f{constructor(k,l){this.socketFactoryId=k,this.makeConnection=l}}class D extends P.$Tc{constructor(k,l,v){super(),this.socketId=k,this.actual=l,this.B(v)}}}),define(Re[231],Ae([1,0,3,14,23]),function(fe,e,S,F,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bjc=void 0;function L(g){return g&&g.title}let R=class{constructor(f,D){this.b=D,this.a=f.getProxy(S.$ZL.MainThreadMessageService)}showMessage(f,D,M,k,l){const v={source:{identifier:f.identifier,label:f.displayName||f.name}};let $;typeof k=="string"||L(k)?$=[k,...l]:(v.modal=k?.modal,v.useCustom=k?.useCustom,v.detail=k?.detail,$=l),v.useCustom&&(0,P.$VF)(f,"resolvers");const s=[];let c=!1;for(let t=0;t<$.length;t++){const n=$[t];if(typeof n=="string")s.push({title:n,handle:t,isCloseAffordance:!1});else if(typeof n=="object"){const{title:r,isCloseAffordance:a}=n;s.push({title:r,isCloseAffordance:!!a,handle:t}),a&&(c?this.b.warn(`[${f.identifier}] Only one message item can have 'isCloseAffordance':`,n):c=!0)}else this.b.warn(`[${f.identifier}] Invalid message item:`,n)}return this.a.$showMessage(D,M,v,s).then(t=>{if(typeof t=="number")return $[t]})}};e.$bjc=R,e.$bjc=R=Ze([qe(1,F.$yj)],R)}),define(Re[232],Ae([1,0,6,16,2,23,3]),function(fe,e,S,F,P,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kjc=void 0;class g{constructor(D){this.b=new Map,this.a=D.getProxy(R.$ZL.MainThreadProfileContentHandlers)}registerProfileContentHandler(D,M,k){if((0,L.$VF)(D,"profileContentHandlers"),this.b.has(M))throw new Error(`Handler with id '${M}' already registered`);return this.b.set(M,k),this.a.$registerProfileContentHandler(M,k.name,k.description,D.identifier.value),(0,S.$Rc)(()=>{this.b.delete(M),this.a.$unregisterProfileContentHandler(M)})}async $saveProfile(D,M,k,l){const v=this.b.get(D);if(!v)throw new Error(`Unknown handler with id: ${D}`);return v.saveProfile(M,k,l)}async $readProfile(D,M,k){const l=this.b.get(D);if(!l)throw new Error(`Unknown handler with id: ${D}`);return l.readProfile((0,F.$Sf)(M)?M:P.URI.revive(M),k)}}e.$kjc=g}),define(Re[81],Ae([1,0,3,5,4]),function(fe,e,S,F,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wic=e.$vic=void 0;class L{constructor(g){this.b=new F.$5d,this.onDidChangePassword=this.b.event,this.a=g.getProxy(S.$ZL.MainThreadSecretState)}async $onDidChangePassword(g){this.b.fire(g)}get(g,f){return this.a.$getPassword(g,f)}store(g,f,D){return this.a.$setPassword(g,f,D)}delete(g,f){return this.a.$deletePassword(g,f)}}e.$vic=L,e.$wic=(0,P.$ei)("IExtHostSecretState")}),define(Re[233],Ae([1,0,22,6,3]),function(fe,e,S,F,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rjc=void 0;class L{static{this.a=1}constructor(g){this.c=new Map,this.d=new Map,this.b=g.getProxy(P.$ZL.MainThreadSpeech)}async $createSpeechToTextSession(g,f,D){const M=this.c.get(g);if(!M)return;const k=new F.$Sc,l=new S.$ce;this.d.set(f,l);const v=k.add(M.provideSpeechToTextSession(l.token,D?{language:D}:void 0));k.add(v.onDidChange($=>{l.token.isCancellationRequested||this.b.$emitSpeechToTextEvent(f,$)})),k.add(l.token.onCancellationRequested(()=>k.dispose()))}async $cancelSpeechToTextSession(g){this.d.get(g)?.dispose(!0),this.d.delete(g)}async $createKeywordRecognitionSession(g,f){const D=this.c.get(g);if(!D)return;const M=new F.$Sc,k=new S.$ce;this.d.set(f,k);const l=M.add(D.provideKeywordRecognitionSession(k.token));M.add(l.onDidChange(v=>{k.token.isCancellationRequested||this.b.$emitKeywordRecognitionEvent(f,v)})),M.add(k.token.onCancellationRequested(()=>M.dispose()))}async $cancelKeywordRecognitionSession(g){this.d.get(g)?.dispose(!0),this.d.delete(g)}registerProvider(g,f,D){const M=L.a++;return this.c.set(M,D),this.b.$registerProvider(M,f,{extension:g,displayName:g.value}),(0,F.$Rc)(()=>{this.b.$unregisterProvider(M),this.c.delete(M)})}}e.$rjc=L}),define(Re[82],Ae([1,0,3,5,4]),function(fe,e,S,F,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oic=e.$nic=void 0;class L{constructor(g,f){this.c=f,this.b=new F.$5d,this.onDidChangeStorage=this.b.event,this.a=g.getProxy(S.$ZL.MainThreadStorage)}registerExtensionStorageKeysToSync(g,f){this.a.$registerExtensionStorageKeysToSync(g,f)}async initializeExtensionStorage(g,f,D){const M=await this.a.$initializeExtensionStorage(g,f);let k;return M&&(k=this.d(g,f,M)),k||D}setValue(g,f,D){return this.a.$setValue(g,f,D)}$acceptValue(g,f,D){const M=this.d(g,f,D);M&&this.b.fire({shared:g,key:f,value:M})}d(g,f,D){try{return JSON.parse(D)}catch(M){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${f}, global: ${g}): ${M}`)}}}e.$nic=L,e.$oic=(0,P.$ei)("IExtHostStorage")}),define(Re[234],Ae([1,0,6,12,2,3]),function(fe,e,S,F,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fjc=void 0;class R{static{this.a=new Set([F.Schemas.http,F.Schemas.https])}constructor(f){this.c=new Map,this.b=f.getProxy(L.$ZL.MainThreadUriOpeners)}registerExternalUriOpener(f,D,M,k){if(this.c.has(D))throw new Error(`Opener with id '${D}' already registered`);const l=k.schemes.find(v=>!R.a.has(v));if(l)throw new Error(`Scheme '${l}' is not supported. Only http and https are currently supported.`);return this.c.set(D,M),this.b.$registerUriOpener(D,k.schemes,f,k.label),(0,S.$Rc)(()=>{this.c.delete(D),this.b.$unregisterUriOpener(D)})}async $canOpenUri(f,D,M){const k=this.c.get(f);if(!k)throw new Error(`Unknown opener with id: ${f}`);const l=P.URI.revive(D);return k.canOpenExternalUri(l,M)}async $openUri(f,D,M){const k=this.c.get(f);if(!k)throw new Error(`Unknown opener id: '${f}'`);return k.openExternalUri(P.URI.revive(D.resolvedUri),{sourceUri:P.URI.revive(D.sourceUri)},M)}}e.$Fjc=R}),define(Re[235],Ae([1,0,3,2,6,15,20]),function(fe,e,S,F,P,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gjc=void 0;class g{static{this.a=0}constructor(D){this.c=new R.$xm,this.d=new Map,this.b=D.getProxy(S.$ZL.MainThreadUrls)}registerUriHandler(D,M){const k=D.identifier;if(this.c.has(k))throw new Error(`Protocol handler already registered for extension ${k}`);const l=g.a++;return this.c.add(k),this.d.set(l,M),this.b.$registerUriHandler(l,k,D.displayName||D.name),(0,P.$Rc)(()=>{this.c.delete(k),this.d.delete(l),this.b.$unregisterUriHandler(l)})}$handleExternalUri(D,M){const k=this.d.get(D);if(!k)return Promise.resolve(void 0);try{k.handleUri(F.URI.revive(M))}catch(l){(0,L.$1)(l)}return Promise.resolve(void 0)}async createAppUri(D){return F.URI.revive(await this.b.$createAppUri(D))}}e.$Gjc=g}),define(Re[62],Ae([1,0,5,6,12,26,2,183,205,76,3]),function(fe,e,S,F,P,L,R,g,f,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cic=e.$bic=e.$aic=e.$_hc=e.$$hc=void 0;class k{#e;#t;#i;#n;#s;#r;#a;#o;#c;#u;#l;#d;constructor(a,h,i,p,u,o,E){this.#a="",this.#c=!1,this.#u=!1,this._onMessageEmitter=new S.$5d,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new S.$5d,this._onDidDispose=this.#h.event,this.#e=a,this.#t=h,this.#o=i,this.#n=p,this.#s=u,this.#r=o,this.#l=l(o),this.#d=v(o),this.#i=E}#h;dispose(){this.#c=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(a){return this.#u=!0,(0,D.$Axb)(a,this.#n)}get cspSource(){const a=this.#r.extensionLocation;if(a.scheme===P.Schemas.https||a.scheme===P.Schemas.http){let h=a.toString();return h.endsWith("/")||(h+="/"),h+" "+D.$zxb}return D.$zxb}get html(){return this.a(),this.#a}set html(a){this.a(),this.#a!==a&&(this.#a=a,this.#d&&!this.#u&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(a)&&(this.#u=!0,this.#i.report("Webview vscode-resource: uris",this.#r,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(a)))}get options(){return this.a(),this.#o}set options(a){this.a(),L.$Ln(this.#o,a)||this.#t.$setOptions(this.#e,c(this.#r,this.#s,a)),this.#o=a}async postMessage(a){if(this.#c)return!1;const h=(0,f.$_mb)(a,{serializeBuffersForPostMessage:this.#l});return this.#t.$postMessage(this.#e,h.message,...h.buffers)}a(){if(this.#c)throw new Error("Webview is disposed")}b(a){if(!this.#d)return a;const h=this.#r.extensionLocation?.scheme===P.Schemas.vscodeRemote,i=this.#r.extensionLocation.scheme===P.Schemas.vscodeRemote?this.#r.extensionLocation.authority:void 0;return a.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(p,u,o,E,w,m)=>{const I=R.URI.from({scheme:E||"file",path:decodeURIComponent(w)}),d=(0,D.$Axb)(I,{isRemote:h,authority:i}).toString();return`${u}${d}${m}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(p,u,o,E,w,m)=>{const I=R.URI.from({scheme:E||"file",path:decodeURIComponent(w)}),d=(0,D.$Axb)(I,{isRemote:h,authority:i}).toString();return`${u}${d}${m}`})}}e.$$hc=k;function l(r){try{const a=(0,g.$np)((0,g.$mp)(r.engines.vscode));return!!a&&a.majorBase>=1&&a.minorBase>=57}catch{return!1}}e.$_hc=l;function v(r){try{const a=(0,g.$np)((0,g.$mp)(r.engines.vscode));return a?a.majorBase<1||a.majorBase===1&&a.minorBase<60:!1}catch{return!1}}class $ extends F.$Tc{constructor(a,h,i,p,u){super(),this.c=h,this.f=i,this.g=p,this.h=u,this.b=new Map,this.a=a.getProxy(M.$ZL.MainThreadWebviews)}dispose(){super.dispose();for(const a of this.b.values())a.dispose();this.b.clear()}$onMessage(a,h,i){const p=this.j(a);if(p){const{message:u}=(0,f.$anb)(h,i.value);p._onMessageEmitter.fire(u)}}$onMissingCsp(a,h){this.g.warn(`${h} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(a,h,i){const p=new k(a,this.a,t(h),this.c,this.f,i,this.h);this.b.set(a,p);const u=p._onDidDispose(()=>{u.dispose(),this.deleteWebview(a)});return p}deleteWebview(a){this.b.delete(a)}j(a){return this.b.get(a)}}e.$aic=$;function s(r){return{id:r.identifier,location:r.extensionLocation}}e.$bic=s;function c(r,a,h){return{enableCommandUris:h.enableCommandUris,enableScripts:h.enableScripts,enableForms:h.enableForms,portMapping:h.portMapping,localResourceRoots:h.localResourceRoots||n(r,a)}}e.$cic=c;function t(r){return{enableCommandUris:r.enableCommandUris,enableScripts:r.enableScripts,enableForms:r.enableForms,portMapping:r.portMapping,localResourceRoots:r.localResourceRoots?.map(a=>R.URI.from(a))}}function n(r,a){return[...(a?.getWorkspaceFolders()||[]).map(h=>h.uri),r.extensionLocation]}}),define(Re[107],Ae([1,0,5,3,2,12,13,4,17,23]),function(fe,e,S,F,P,L,R,g,f,D){"use strict";var M;Object.defineProperty(e,"__esModule",{value:!0}),e.$Jjc=e.$Ijc=void 0;let k=class{static{M=this}static{this.a={focused:!0,active:!0}}getState(v){const $=this.d;return{get focused(){return $.focused},get active(){return(0,D.$VF)(v,"windowActivity"),$.active}}}constructor(v){this.c=new S.$5d,this.onDidChangeWindowState=this.c.event,this.d=M.a,this.b=v.getProxy(F.$ZL.MainThreadWindow),this.b.$getInitialState().then(({isFocused:$,isActive:s})=>{this.onDidChangeWindowProperty("focused",$),this.onDidChangeWindowProperty("active",s)})}$onDidChangeWindowFocus(v){this.onDidChangeWindowProperty("focused",v)}$onDidChangeWindowActive(v){this.onDidChangeWindowProperty("active",v)}onDidChangeWindowProperty(v,$){$!==this.d[v]&&(this.d={...this.d,[v]:$},this.c.fire(this.d))}openUri(v,$){let s;if(typeof v=="string"){s=v;try{v=P.URI.parse(v)}catch{return Promise.reject(`Invalid uri - '${v}'`)}}return(0,R.$Se)(v.scheme)?Promise.reject("Invalid scheme - cannot be empty"):v.scheme===L.Schemas.command?Promise.reject(`Invalid scheme '${v.scheme}'`):this.b.$openUri(v,s,$)}async asExternalUri(v,$){if((0,R.$Se)(v.scheme))return Promise.reject("Invalid scheme - cannot be empty");const s=await this.b.$asExternalUri(v,$);return P.URI.from(s)}};e.$Ijc=k,e.$Ijc=k=M=Ze([qe(0,f.$eO)],k),e.$Jjc=(0,g.$ei)("IExtHostWindow")}),define(Re[236],Ae([1,0,227,27,17]),function(fe,e,S,F,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ulc=void 0;let L=class extends S.$Mjc{constructor(g,f){super(g,f)}f(g,f,D){f.apply(console,D)}};e.$Ulc=L,e.$Ulc=L=Ze([qe(0,P.$eO),qe(1,F.$uO)],L)}),define(Re[237],Ae([1,0,11,24,22,15,5,6,140,224,49]),function(fe,e,S,F,P,L,R,g,f,D,M){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.$L9b=e.ResponsiveState=e.RequestInitiator=e.$K9b=e.$J9b=void 0;function l(b,A){try{return JSON.stringify(b,A)}catch{return"null"}}const v="$$ref$$",$={[v]:-1};class s{constructor(A,T){this.jsonString=A,this.referencedBuffers=T}}function c(b,A=null,T=!1){const G=[];return{jsonString:(T?l:JSON.stringify)(b,(U,C)=>{if(typeof C>"u")return $;if(typeof C=="object"){if(C instanceof F.$se){const O=G.push(C)-1;return{[v]:O}}if(A)return A(U,C)}return C}),referencedBuffers:G}}e.$J9b=c;function t(b,A,T){return JSON.parse(b,(G,W)=>{if(W){const U=W[v];if(typeof U=="number")return A[U];if(T&&W.$mid===1)return T.transformIncoming(W)}return W})}e.$K9b=t;function n(b,A){return JSON.stringify(b,A)}function r(b){return b?(A,T)=>T&&T.$mid===1?b.transformOutgoing(T):T:null}var a;(function(b){b[b.LocalSide=0]="LocalSide",b[b.OtherSide=1]="OtherSide"})(a||(e.RequestInitiator=a={}));var h;(function(b){b[b.Responsive=0]="Responsive",b[b.Unresponsive=1]="Unresponsive"})(h||(e.ResponsiveState=h={}));const i=()=>{},p=Symbol.for("rpcProtocol"),u=Symbol.for("rpcProxy");class o extends g.$Tc{static{k=p}static{this.a=3*1e3}constructor(A,T=null,G=null){super(),this[k]=!0,this.b=this.B(new R.$5d),this.onDidChangeResponsiveState=this.b.event,this.c=A,this.f=T,this.g=G,this.h=r(this.g),this.j=!1,this.m=[],this.s=[];for(let W=0,U=M.$3v.count;W<U;W++)this.m[W]=null,this.s[W]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=0,this.z=0,this.C=0,this.D=this.B(new S.$qh(()=>this.H(),1e3)),this.c.onMessage(W=>this.L(W))}dispose(){this.j=!0,Object.keys(this.w).forEach(A=>{const T=this.w[A];delete this.w[A],T.resolveErr(L.$6())}),super.dispose()}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(A){this.z===0&&(this.C=Date.now()+o.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(A){this.C=Date.now()+o.a,this.z--,this.z===0&&this.D.cancel(),this.I(0)}H(){this.z!==0&&(Date.now()>this.C?this.I(1):this.D.schedule())}I(A){this.y!==A&&(this.y=A,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(A){return this.g?(0,f.$gn)(A,this.g):A}getProxy(A){const{nid:T,sid:G}=A;return this.s[T]||(this.s[T]=this.J(T,G)),this.s[T]}J(A,T){const G={get:(W,U)=>(typeof U=="string"&&!W[U]&&U.charCodeAt(0)===36&&(W[U]=(...C)=>this.U(A,U,C)),U===u?T:W[U])};return new Proxy(Object.create(null),G)}set(A,T){return this.m[A.nid]=T,T}assertRegistered(A){for(let T=0,G=A.length;T<G;T++){const W=A[T];if(!this.m[W.nid])throw new Error(`Missing proxy instance ${W.sid}`)}}L(A){if(this.j)return;const T=A.byteLength,G=w.read(A,0),W=G.readUInt8(),U=G.readUInt32();switch(W){case 1:case 2:{let{rpcId:C,method:O,args:V}=I.deserializeRequestJSONArgs(G);this.g&&(V=(0,f.$gn)(V,this.g)),this.M(T,U,C,O,V,W===2);break}case 3:case 4:{let{rpcId:C,method:O,args:V}=I.deserializeRequestMixedArgs(G);this.g&&(V=(0,f.$gn)(V,this.g)),this.M(T,U,C,O,V,W===4);break}case 5:{this.f?.logIncoming(T,U,0,"ack"),this.G(U);break}case 6:{this.N(T,U);break}case 7:{this.O(T,U,void 0);break}case 9:{let C=I.deserializeReplyOKJSON(G);this.g&&(C=(0,f.$gn)(C,this.g)),this.O(T,U,C);break}case 10:{const C=I.deserializeReplyOKJSONWithBuffers(G,this.g);this.O(T,U,C);break}case 8:{const C=I.deserializeReplyOKVSBuffer(G);this.O(T,U,C);break}case 11:{let C=I.deserializeReplyErrError(G);this.g&&(C=(0,f.$gn)(C,this.g)),this.P(T,U,C);break}case 12:{this.P(T,U,void 0);break}default:console.error("received unexpected message"),console.error(A)}}M(A,T,G,W,U,C){this.f?.logIncoming(A,T,1,`receiveRequest ${(0,M.$5v)(G)}.${W}(`,U);const O=String(T);let V,re;if(C){const ye=new P.$ce;U.push(ye.token),V=this.Q(G,W,U),re=()=>ye.cancel()}else V=this.Q(G,W,U),re=i;this.u[O]=re;const ue=I.serializeAcknowledged(T);this.f?.logOutgoing(ue.byteLength,T,1,"ack"),this.c.send(ue),V.then(ye=>{delete this.u[O];const De=I.serializeReplyOK(T,ye,this.h);this.f?.logOutgoing(De.byteLength,T,1,"reply:",ye),this.c.send(De)},ye=>{delete this.u[O];const De=I.serializeReplyErr(T,ye);this.f?.logOutgoing(De.byteLength,T,1,"replyErr:",ye),this.c.send(De)})}N(A,T){this.f?.logIncoming(A,T,1,"receiveCancel");const G=String(T);this.u[G]?.()}O(A,T,G){this.f?.logIncoming(A,T,0,"receiveReply:",G);const W=String(T);if(!this.w.hasOwnProperty(W))return;const U=this.w[W];delete this.w[W],U.resolveOk(G)}P(A,T,G){this.f?.logIncoming(A,T,0,"receiveReplyErr:",G);const W=String(T);if(!this.w.hasOwnProperty(W))return;const U=this.w[W];delete this.w[W];let C;G&&(G.$isError?(C=new Error,C.name=G.name,C.message=G.message,C.stack=G.stack):C=G),U.resolveErr(C)}Q(A,T,G){try{return Promise.resolve(this.S(A,T,G))}catch(W){return Promise.reject(W)}}S(A,T,G){const W=this.m[A];if(!W)throw new Error("Unknown actor "+(0,M.$5v)(A));const U=W[T];if(typeof U!="function")throw new Error("Unknown method "+T+" on actor "+(0,M.$5v)(A));return U.apply(W,G)}U(A,T,G){if(this.j)return new D.$I9b;let W=null;if(G.length>0&&P.CancellationToken.isCancellationToken(G[G.length-1])&&(W=G.pop()),W&&W.isCancellationRequested)return Promise.reject(L.$6());const U=I.serializeRequestArguments(G,this.h),C=++this.t,O=String(C),V=new D.$H9b,re=new g.$Sc;W&&re.add(W.onCancellationRequested(()=>{const ye=I.serializeCancel(C);this.f?.logOutgoing(ye.byteLength,C,0,"cancel"),this.c.send(I.serializeCancel(C))})),this.w[O]=new E(V,re),this.F(C);const ue=I.serializeRequest(C,A,T,U,!!W);return this.f?.logOutgoing(ue.byteLength,C,0,`request: ${(0,M.$5v)(A)}.${T}(`,G),this.c.send(ue),V}}e.$L9b=o;class E{constructor(A,T){this.a=A,this.b=T}resolveOk(A){this.a.resolveOk(A),this.b.dispose()}resolveErr(A){this.a.resolveErr(A),this.b.dispose()}}class w{static alloc(A,T,G){const W=new w(F.$se.alloc(G+1+4),0);return W.writeUInt8(A),W.writeUInt32(T),W}static read(A,T){return new w(A,T)}get buffer(){return this.a}constructor(A,T){this.a=A,this.b=T}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(A){this.a.writeUInt8(A,this.b),this.b+=1}readUInt8(){const A=this.a.readUInt8(this.b);return this.b+=1,A}writeUInt32(A){this.a.writeUInt32BE(A,this.b),this.b+=4}readUInt32(){const A=this.a.readUInt32BE(this.b);return this.b+=4,A}static sizeShortString(A){return 1+A.byteLength}writeShortString(A){this.a.writeUInt8(A.byteLength,this.b),this.b+=1,this.a.set(A,this.b),this.b+=A.byteLength}readShortString(){const A=this.a.readUInt8(this.b);this.b+=1;const G=this.a.slice(this.b,this.b+A).toString();return this.b+=A,G}static sizeLongString(A){return 4+A.byteLength}writeLongString(A){this.a.writeUInt32BE(A.byteLength,this.b),this.b+=4,this.a.set(A,this.b),this.b+=A.byteLength}readLongString(){const A=this.a.readUInt32BE(this.b);this.b+=4;const G=this.a.slice(this.b,this.b+A).toString();return this.b+=A,G}writeBuffer(A){this.a.writeUInt32BE(A.byteLength,this.b),this.b+=4,this.a.set(A,this.b),this.b+=A.byteLength}static sizeVSBuffer(A){return 4+A.byteLength}writeVSBuffer(A){this.a.writeUInt32BE(A.byteLength,this.b),this.b+=4,this.a.set(A,this.b),this.b+=A.byteLength}readVSBuffer(){const A=this.a.readUInt32BE(this.b);this.b+=4;const T=this.a.slice(this.b,this.b+A);return this.b+=A,T}static sizeMixedArray(A){let T=0;T+=1;for(let G=0,W=A.length;G<W;G++){const U=A[G];switch(T+=1,U.type){case 1:T+=this.sizeLongString(U.value);break;case 2:T+=this.sizeVSBuffer(U.value);break;case 3:T+=this.sizeUInt32,T+=this.sizeLongString(U.value);for(let C=0;C<U.buffers.length;++C)T+=this.sizeVSBuffer(U.buffers[C]);break;case 4:break}}return T}writeMixedArray(A){this.a.writeUInt8(A.length,this.b),this.b+=1;for(let T=0,G=A.length;T<G;T++){const W=A[T];switch(W.type){case 1:this.writeUInt8(1),this.writeLongString(W.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(W.value);break;case 3:this.writeUInt8(3),this.writeUInt32(W.buffers.length),this.writeLongString(W.value);for(let U=0;U<W.buffers.length;++U)this.writeBuffer(W.buffers[U]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const A=this.a.readUInt8(this.b);this.b+=1;const T=new Array(A);for(let G=0;G<A;G++)switch(this.readUInt8()){case 1:T[G]=this.readLongString();break;case 2:T[G]=this.readVSBuffer();break;case 3:{const U=this.readUInt32(),C=this.readLongString(),O=[];for(let V=0;V<U;++V)O.push(this.readVSBuffer());T[G]=new M.$6v(t(C,O,null));break}case 4:T[G]=void 0;break}return T}}var m;(function(b){b[b.Simple=0]="Simple",b[b.Mixed=1]="Mixed"})(m||(m={}));class I{static a(A){for(let T=0,G=A.length;T<G;T++)if(A[T]instanceof F.$se||A[T]instanceof M.$6v||typeof A[T]>"u")return!0;return!1}static serializeRequestArguments(A,T){if(this.a(A)){const G=[];for(let W=0,U=A.length;W<U;W++){const C=A[W];if(C instanceof F.$se)G[W]={type:2,value:C};else if(typeof C>"u")G[W]={type:4};else if(C instanceof M.$6v){const{jsonString:O,referencedBuffers:V}=c(C.value,T);G[W]={type:3,value:F.$se.fromString(O),buffers:V}}else G[W]={type:1,value:F.$se.fromString(n(C,T))}}return{type:1,args:G}}return{type:0,args:n(A,T)}}static serializeRequest(A,T,G,W,U){switch(W.type){case 0:return this.b(A,T,G,W.args,U);case 1:return this.c(A,T,G,W.args,U)}}static b(A,T,G,W,U){const C=F.$se.fromString(G),O=F.$se.fromString(W);let V=0;V+=w.sizeUInt8(),V+=w.sizeShortString(C),V+=w.sizeLongString(O);const re=w.alloc(U?2:1,A,V);return re.writeUInt8(T),re.writeShortString(C),re.writeLongString(O),re.buffer}static deserializeRequestJSONArgs(A){const T=A.readUInt8(),G=A.readShortString(),W=A.readLongString();return{rpcId:T,method:G,args:JSON.parse(W)}}static c(A,T,G,W,U){const C=F.$se.fromString(G);let O=0;O+=w.sizeUInt8(),O+=w.sizeShortString(C),O+=w.sizeMixedArray(W);const V=w.alloc(U?4:3,A,O);return V.writeUInt8(T),V.writeShortString(C),V.writeMixedArray(W),V.buffer}static deserializeRequestMixedArgs(A){const T=A.readUInt8(),G=A.readShortString(),W=A.readMixedArray(),U=new Array(W.length);for(let C=0,O=W.length;C<O;C++){const V=W[C];typeof V=="string"?U[C]=JSON.parse(V):U[C]=V}return{rpcId:T,method:G,args:U}}static serializeAcknowledged(A){return w.alloc(5,A,0).buffer}static serializeCancel(A){return w.alloc(6,A,0).buffer}static serializeReplyOK(A,T,G){if(typeof T>"u")return this.d(A);if(T instanceof F.$se)return this.e(A,T);if(T instanceof M.$6v){const{jsonString:W,referencedBuffers:U}=c(T.value,G,!0);return this.g(A,W,U)}else return this.f(A,l(T,G))}static d(A){return w.alloc(7,A,0).buffer}static e(A,T){let G=0;G+=w.sizeVSBuffer(T);const W=w.alloc(8,A,G);return W.writeVSBuffer(T),W.buffer}static deserializeReplyOKVSBuffer(A){return A.readVSBuffer()}static f(A,T){const G=F.$se.fromString(T);let W=0;W+=w.sizeLongString(G);const U=w.alloc(9,A,W);return U.writeLongString(G),U.buffer}static g(A,T,G){const W=F.$se.fromString(T);let U=0;U+=w.sizeUInt32,U+=w.sizeLongString(W);for(const O of G)U+=w.sizeVSBuffer(O);const C=w.alloc(10,A,U);C.writeUInt32(G.length),C.writeLongString(W);for(const O of G)C.writeBuffer(O);return C.buffer}static deserializeReplyOKJSON(A){const T=A.readLongString();return JSON.parse(T)}static deserializeReplyOKJSONWithBuffers(A,T){const G=A.readUInt32(),W=A.readLongString(),U=[];for(let C=0;C<G;++C)U.push(A.readVSBuffer());return new M.$6v(t(W,U,T))}static serializeReplyErr(A,T){const G=T?l(L.$3(T),null):void 0;if(typeof G!="string")return this.h(A);const W=F.$se.fromString(G);let U=0;U+=w.sizeLongString(W);const C=w.alloc(11,A,U);return C.writeLongString(W),C.buffer}static deserializeReplyErrError(A){const T=A.readLongString();return JSON.parse(T)}static h(A){return w.alloc(12,A,0).buffer}}var d;(function(b){b[b.RequestJSONArgs=1]="RequestJSONArgs",b[b.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",b[b.RequestMixedArgs=3]="RequestMixedArgs",b[b.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",b[b.Acknowledged=5]="Acknowledged",b[b.Cancel=6]="Cancel",b[b.ReplyOKEmpty=7]="ReplyOKEmpty",b[b.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",b[b.ReplyOKJSON=9]="ReplyOKJSON",b[b.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",b[b.ReplyErrError=11]="ReplyErrError",b[b.ReplyErrEmpty=12]="ReplyErrEmpty"})(d||(d={}));var y;(function(b){b[b.String=1]="String",b[b.VSBuffer=2]="VSBuffer",b[b.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",b[b.Undefined=4]="Undefined"})(y||(y={}))}),define(Re[238],Ae([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wlc=void 0;const S=function(L){const R=g=>{globalThis.removeEventListener("message",R);const f=g.data;Object.defineProperties(globalThis,{postMessage:{value(D,M){f.postMessage(D,M)}},onmessage:{get(){return f.onmessage},set(D){f.onmessage=D}}}),f.addEventListener("message",D=>{globalThis.dispatchEvent(new MessageEvent("message",{data:D.data,ports:D.ports?[...D.ports]:void 0}))}),f.start(),globalThis.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(L)};globalThis.addEventListener("message",R)}.toString();class F extends EventTarget{constructor(L,R,g){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const f=`((${S})('${R}'))`,D=new Blob([f],{type:"application/javascript"}),M=URL.createObjectURL(D),k=new MessageChannel,l=M,v={type:"_newWorker",id:l,port:k.port2,url:M,options:g};L(v,[k.port2]),this.postMessage=k.port1.postMessage.bind(k.port1),this.terminate=()=>{L({type:"_terminateWorker",id:l}),URL.revokeObjectURL(M),k.port1.close(),k.port2.close()},Object.defineProperties(this,{onmessage:{get(){return k.port1.onmessage},set($){k.port1.onmessage=$}},onmessageerror:{get(){return k.port1.onmessageerror},set($){k.port1.onmessageerror=$}}}),k.port1.addEventListener("messageerror",$=>{const s=new MessageEvent("messageerror",{data:$.data});this.dispatchEvent(s)}),k.port1.addEventListener("message",$=>{const s=new MessageEvent("message",{data:$.data});this.dispatchEvent(s)}),k.port1.start()}}e.$Wlc=F}),define(Re[239],Ae([1,0,24,28,12,54,4]),function(fe,e,S,F,P,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MJ=e.$LJ=e.$KJ=e.$JJ=void 0,e.$JJ=(0,R.$ei)("notebookDocumentService");const g=["W","X","Y","Z","a","b","c","d","e","f"],f=new RegExp(`^[${g.join("")}]+`),D=7;function M(v){if(v.scheme!==P.Schemas.vscodeNotebookCell)return;const $=v.fragment.indexOf("s");if($<0)return;const s=parseInt(v.fragment.substring(0,$).replace(f,""),D),c=(0,S.$Le)(v.fragment.substring($+1)).toString();if(!isNaN(s))return{handle:s,notebook:v.with({scheme:c,fragment:null})}}e.$KJ=M;function k(v,$){const s=$.toString(D),t=`${s.length<g.length?g[s.length-1]:"z"}${s}s${(0,S.$Me)(S.$se.fromString(v.scheme),!0,!0)}`;return v.with({scheme:P.Schemas.vscodeNotebookCell,fragment:t})}e.$LJ=k;class l{constructor(){this.a=new F.$Ac}getNotebook($){if($.scheme===P.Schemas.vscodeNotebookCell){const s=M($);if(s){const c=this.a.get(s.notebook);if(c)return c}}return this.a.get($)}addNotebookDocument($){this.a.set($.uri,$)}removeNotebookDocument($){this.a.delete($.uri)}}e.$MJ=l,(0,L.$0r)(e.$JJ,l,1)}),define(Re[83],Ae([1,0,24,35,51,69,12,19,21,36,239]),function(fe,e,S,F,P,L,R,g,f,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5J=e.$4J=e.$3J=e.$2J=e.CellStatusbarAlignment=e.$1J=e.$ZJ=e.$YJ=e.NotebookEditorPriority=e.$XJ=e.$WJ=e.$VJ=e.$UJ=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$TJ=e.$SJ=e.$RJ=e.$QJ=e.CellKind=e.$PJ=e.$OJ=e.$NJ=void 0,e.$NJ="workbench.editor.notebook",e.$OJ="workbench.editor.notebookTextDiffEditor",e.$PJ="workbench.editor.interactive";var k;(function(V){V[V.Markup=1]="Markup",V[V.Code=2]="Code"})(k||(e.CellKind=k={})),e.$QJ=["application/json","application/javascript","text/html","image/svg+xml",L.$qs.latex,L.$qs.markdown,"image/png","image/jpeg",L.$qs.text],e.$RJ=[L.$qs.latex,L.$qs.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",L.$qs.text],e.$SJ=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$TJ="_notAvailable";var l;(function(V){V[V.Running=1]="Running",V[V.Idle=2]="Idle"})(l||(e.NotebookRunState=l={}));var v;(function(V){V[V.Unconfirmed=1]="Unconfirmed",V[V.Pending=2]="Pending",V[V.Executing=3]="Executing"})(v||(e.NotebookCellExecutionState=v={}));var $;(function(V){V[V.Unconfirmed=1]="Unconfirmed",V[V.Pending=2]="Pending",V[V.Executing=3]="Executing"})($||(e.NotebookExecutionState=$={}));var s;(function(V){V[V.WithHardKernelDependency=0]="WithHardKernelDependency",V[V.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",V[V.Pure=2]="Pure",V[V.Never=3]="Never"})(s||(e.NotebookRendererMatch=s={}));var c;(function(V){V.Always="always",V.Never="never",V.Optional="optional"})(c||(e.RendererMessagingSpec=c={}));var t;(function(V){V[V.ModelChange=1]="ModelChange",V[V.Move=2]="Move",V[V.ChangeCellLanguage=5]="ChangeCellLanguage",V[V.Initialize=6]="Initialize",V[V.ChangeCellMetadata=7]="ChangeCellMetadata",V[V.Output=8]="Output",V[V.OutputItem=9]="OutputItem",V[V.ChangeCellContent=10]="ChangeCellContent",V[V.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",V[V.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",V[V.ChangeCellMime=13]="ChangeCellMime",V[V.Unknown=100]="Unknown"})(t||(e.NotebookCellsChangeType=t={}));var n;(function(V){V[V.Handle=0]="Handle",V[V.Index=1]="Index"})(n||(e.SelectionStateType=n={}));var r;(function(V){V[V.Replace=1]="Replace",V[V.Output=2]="Output",V[V.Metadata=3]="Metadata",V[V.CellLanguage=4]="CellLanguage",V[V.DocumentMetadata=5]="DocumentMetadata",V[V.Move=6]="Move",V[V.OutputItems=7]="OutputItems",V[V.PartialMetadata=8]="PartialMetadata",V[V.PartialInternalMetadata=9]="PartialInternalMetadata"})(r||(e.CellEditType=r={}));var a;(function(V){V.scheme=R.Schemas.vscodeNotebookCell;function re(se,$e){return(0,M.$LJ)(se,$e)}V.generate=re;function ue(se){return(0,M.$KJ)(se)}V.parse=ue;function ye(se,$e){return se.with({scheme:R.Schemas.vscodeNotebookCellOutput,fragment:`op${$e??""},${se.scheme!==R.Schemas.file?se.scheme:""}`})}V.generateCellOutputUri=ye;function De(se){if(se.scheme!==R.Schemas.vscodeNotebookCellOutput)return;const $e=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(se.fragment);if(!$e)return;const ee=$e[1]&&$e[1]!==""?$e[1]:void 0,Q=$e[2];return{outputId:ee,notebook:se.with({scheme:Q||R.Schemas.file,fragment:null})}}V.parseCellOutputUri=De;function he(se,$e,ee){return V.generate(se,$e).with({scheme:ee})}V.generateCellPropertyUri=he;function ve(se,$e){if(se.scheme===$e)return V.parse(se.with({scheme:V.scheme}))}V.parseCellPropertyUri=ve})(a||(e.CellUri=a={}));const h=V=>f.$i?V.replace(/\//g,"\\"):V;class i{constructor(re=[],ue=e.$QJ){this.e=ue,this.d=[...new Set(re)].map(ye=>({pattern:ye,matches:F.$Xj(h(ye))}))}sort(re){const ue=new Map(P.Iterable.map(re,De=>[De,h(De)]));let ye=[];for(const{matches:De}of this.d)for(const[he,ve]of ue)if(De(ve)){ye.push(he),ue.delete(he);break}return ue.size&&(ye=ye.concat([...ue.keys()].sort((De,he)=>this.e.indexOf(De)-this.e.indexOf(he)))),ye}prioritize(re,ue){const ye=this.f(re);if(ye===-1){this.d.unshift({pattern:re,matches:F.$Xj(h(re))});return}const De=new Set(ue.map(ve=>this.f(ve,ye)));De.delete(-1);const he=Array.from(De).sort();this.d.splice(ye+1,0,...he.map(ve=>this.d[ve]));for(let ve=he.length-1;ve>=0;ve--)this.d.splice(he[ve],1)}toArray(){return this.d.map(re=>re.pattern)}f(re,ue=this.d.length){const ye=h(re);for(let De=0;De<ue;De++)if(this.d[De].matches(ye))return De;return-1}}e.$UJ=i;function p(V,re,ue,ye=(De,he)=>De===he){const De=[];function he($e,ee,Q){if(ee===0&&Q.length===0)return;const q=De[De.length-1];q&&q.start+q.deleteCount===$e?(q.deleteCount+=ee,q.toInsert.push(...Q)):De.push({start:$e,deleteCount:ee,toInsert:Q})}let ve=0,se=0;for(;;){if(ve===V.length){he(ve,0,re.slice(se));break}if(se===re.length){he(ve,V.length-ve,[]);break}const $e=V[ve],ee=re[se];if(ye($e,ee)){ve+=1,se+=1;continue}ue(ee)?(he(ve,1,[]),ve+=1):(he(ve,0,[ee]),se+=1)}return De}e.$VJ=p,e.$WJ=new D.$vj("notebookEditorCursorAtBoundary","none"),e.$XJ=new D.$vj("notebookEditorCursorAtLineBoundary","none");var u;(function(V){V.default="default",V.option="option"})(u||(e.NotebookEditorPriority=u={}));function o(V){const re=V;return!!((typeof re.include=="string"||F.$Yj(re.include))&&(typeof re.exclude=="string"||F.$Yj(re.exclude)))}e.$YJ=o;function E(V,re,ue){if(Array.isArray(V.viewType)&&V.viewType.indexOf(re)>=0||V.viewType===re)return!0;if(V.filenamePattern){const ye=o(V.filenamePattern)?V.filenamePattern.include:V.filenamePattern,De=o(V.filenamePattern)?V.filenamePattern.exclude:void 0;if(F.$Wj(ye,(0,g.$nc)(ue.fsPath).toLowerCase()))return!(De&&F.$Wj(De,(0,g.$nc)(ue.fsPath).toLowerCase()))}return!1}e.$ZJ=E,e.$1J={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScrollEnabled:"notebook.stickyScroll.enabled",stickyScrollMode:"notebook.stickyScroll.mode",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",anchorToFocusedCell:"notebook.scrolling.experimental.anchorToFocusedCell",cellChat:"notebook.experimental.cellChat",notebookVariablesView:"notebook.experimental.variablesView"};var w;(function(V){V[V.Left=1]="Left",V[V.Right=2]="Right"})(w||(e.CellStatusbarAlignment=w={}));class m{static{this.d="notebook/"}static create(re){return`${m.d}${re}`}static parse(re){if(re.startsWith(m.d))return re.substring(m.d.length)}}e.$2J=m;function I(V){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(V)}e.$3J=I;const d=new TextDecoder;function y(V){const re=[];let ue=!1;for(const ve of V)(re.length===0||ue)&&(re.push(ve),ue=!0);let ye=T(re);const De=S.$se.concat(re.map(ve=>S.$se.wrap(ve))),he=O(De);return ye=ye||he.byteLength!==De.byteLength,{data:he,didCompression:ye}}e.$4J=y,e.$5J="\x1B[A";const b=e.$5J.split("").map(V=>V.charCodeAt(0)),A=10;function T(V){let re=!1;return V.forEach((ue,ye)=>{if(ye===0||ue.length<e.$5J.length)return;const De=V[ye-1],he=ue.subarray(0,e.$5J.length);if(he[0]===b[0]&&he[1]===b[1]&&he[2]===b[2]){const ve=De.lastIndexOf(A);if(ve===-1)return;re=!0,V[ye-1]=De.subarray(0,ve),V[ye]=ue.subarray(e.$5J.length)}}),re}function G(V){let re=V;do V=re,re=V.replace(/[^\n]\x08/gm,"");while(re.length<V.length);return V}function W(V){for(V=V.replace(/\r+\n/gm,`
`);V.search(/\r[^$]/g)>-1;){const re=V.match(/^(.*)\r+/m)[1];let ue=V.match(/\r+(.*)$/m)[1];ue=ue+re.slice(ue.length,re.length),V=V.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,ue)}return V}const U=8,C=13;function O(V){return!V.buffer.includes(U)&&!V.buffer.includes(C)?V:S.$se.fromString(W(G(d.decode(V.buffer))))}}),define(Re[7],Ae([1,0,18,15,53,28,69,13,16,2,33,20,42,100,83]),function(fe,e,S,F,P,L,R,g,f,D,M,k,l,v,$){"use strict";var s,c,t,n,r,a,h,i,p,u,o,E,w,m,I,d,y;Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.$6N=e.KeywordRecognitionStatus=e.SpeechToTextStatus=e.RelatedInformationType=e.$5N=e.$4N=e.$3N=e.$2N=e.$1N=e.$ZN=e.$YN=e.$XN=e.$WN=e.$VN=e.$UN=e.ChatResultFeedbackKind=e.InteractiveEditorResponseFeedbackKind=e.$TN=e.ChatVariableLevel=e.ChatCopyKind=e.InteractiveSessionVoteDirection=e.$SN=e.$RN=e.$QN=e.$PN=e.$ON=e.$NN=e.$MN=e.$LN=e.$KN=e.$JN=e.$IN=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$HN=e.$GN=e.$FN=e.$EN=e.$DN=e.$CN=e.$BN=e.$AN=e.TestRunProfileKind=e.TestResultState=e.$zN=e.$yN=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$xN=e.NotebookVariablesRequestKind=e.$wN=e.$vN=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$uN=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$tN=e.$sN=e.$rN=e.$qN=e.$pN=e.ColorThemeKind=e.$oN=e.$nN=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$mN=e.$lN=e.DebugConsoleMode=e.$kN=e.$jN=e.$iN=e.$hN=e.$gN=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$fN=e.$eN=e.FileChangeType=e.$dN=e.NewSymbolNameTag=e.$cN=e.$bN=e.$aN=e.$_M=e.InlineCompletionTriggerKind=e.$$M=e.$0M=e.$9M=e.$8M=e.$7M=e.$6M=e.$5M=e.$4M=e.$3M=e.$2M=e.$1M=e.$ZM=e.$YM=e.ConfigurationTarget=e.$XM=e.$WM=e.$VM=e.$UM=e.$TM=e.$SM=e.$RM=e.$QM=e.$PM=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$OM=e.ViewBadge=e.ProgressLocation=e.$NM=e.$MM=e.TaskScope=e.ShellQuoting=e.$LM=e.$KM=e.$JM=e.TaskPanelKind=e.TaskRevealKind=e.$IM=e.TerminalLocation=e.$HM=e.$GM=e.$FM=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$EM=e.$DM=e.$CM=e.$BM=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.$AM=e.StatusBarAlignment=e.ViewColumn=e.$zM=e.$yM=e.$xM=e.$wM=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$vM=e.$uM=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$tM=e.$sM=e.$rM=e.$qM=e.$pM=e.LanguageStatusSeverity=e.$oM=e.$nM=e.$mM=e.$lM=e.$kM=e.$jM=e.CodeActionTriggerKind=e.$iM=e.$hM=e.SymbolTag=e.SymbolKind=e.$gM=e.$fM=e.DocumentHighlightKind=e.$eM=e.$dM=e.$cM=e.$bM=e.DiagnosticSeverity=e.DiagnosticTag=e.$aM=e.$_L=e.FileEditType=e.$$L=e.$0L=e.$9L=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$8L=e.$7L=e.$6L=e.$5L=e.$4L=e.$3L=e.$2L=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function b(B){return Object.assign(B,{apply:function(...ie){if(ie.length===0)return Reflect.construct(B,[]);{const ke=ie.length===1?[]:ie[1];return Reflect.construct(B,ke,ie[0].constructor)}},call:function(...ie){if(ie.length===0)return Reflect.construct(B,[]);{const[ke,...Je]=ie;return Reflect.construct(B,Je,ke.constructor)}}})}var A;(function(B){B[B.Top=0]="Top",B[B.Bottom=1]="Bottom"})(A||(e.TerminalOutputAnchor=A={}));var T;(function(B){B[B.TerminalCommand=0]="TerminalCommand",B[B.Opener=1]="Opener",B[B.Command=3]="Command"})(T||(e.TerminalQuickFixType=T={}));let G=s=class{static from(...j){let ie=j;return new s(function(){if(ie){for(const ke of ie)ke&&typeof ke.dispose=="function"&&ke.dispose();ie=void 0}})}#e;constructor(j){this.#e=j}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$2L=G,e.$2L=G=s=Ze([b],G);let W=c=class{static Min(...j){if(j.length===0)throw new TypeError;let ie=j[0];for(let ke=1;ke<j.length;ke++){const Je=j[ke];Je.isBefore(ie)&&(ie=Je)}return ie}static Max(...j){if(j.length===0)throw new TypeError;let ie=j[0];for(let ke=1;ke<j.length;ke++){const Je=j[ke];Je.isAfter(ie)&&(ie=Je)}return ie}static isPosition(j){if(!j)return!1;if(j instanceof c)return!0;const{line:ie,character:ke}=j;return typeof ie=="number"&&typeof ke=="number"}static of(j){if(j instanceof c)return j;if(this.isPosition(j))return new c(j.line,j.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(j,ie){if(j<0)throw(0,F.$7)("line must be non-negative");if(ie<0)throw(0,F.$7)("character must be non-negative");this.c=j,this.e=ie}isBefore(j){return this.c<j.c?!0:j.c<this.c?!1:this.e<j.e}isBeforeOrEqual(j){return this.c<j.c?!0:j.c<this.c?!1:this.e<=j.e}isAfter(j){return!this.isBeforeOrEqual(j)}isAfterOrEqual(j){return!this.isBefore(j)}isEqual(j){return this.c===j.c&&this.e===j.e}compareTo(j){return this.c<j.c?-1:this.c>j.line?1:this.e<j.e?-1:this.e>j.e?1:0}translate(j,ie=0){if(j===null||ie===null)throw(0,F.$7)();let ke;return typeof j>"u"?ke=0:typeof j=="number"?ke=j:(ke=typeof j.lineDelta=="number"?j.lineDelta:0,ie=typeof j.characterDelta=="number"?j.characterDelta:0),ke===0&&ie===0?this:new c(this.line+ke,this.character+ie)}with(j,ie=this.character){if(j===null||ie===null)throw(0,F.$7)();let ke;return typeof j>"u"?ke=this.line:typeof j=="number"?ke=j:(ke=typeof j.line=="number"?j.line:this.line,ie=typeof j.character=="number"?j.character:this.character),ke===this.line&&ie===this.character?this:new c(ke,ie)}toJSON(){return{line:this.line,character:this.character}}};e.$3L=W,e.$3L=W=c=Ze([b],W);let U=t=class{static isRange(j){return j instanceof t?!0:j?W.isPosition(j.start)&&W.isPosition(j.end):!1}static of(j){if(j instanceof t)return j;if(this.isRange(j))return new t(j.start,j.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(j,ie,ke,Je){let _e,ut;if(typeof j=="number"&&typeof ie=="number"&&typeof ke=="number"&&typeof Je=="number"?(_e=new W(j,ie),ut=new W(ke,Je)):W.isPosition(j)&&W.isPosition(ie)&&(_e=W.of(j),ut=W.of(ie)),!_e||!ut)throw new Error("Invalid arguments");_e.isBefore(ut)?(this.c=_e,this.e=ut):(this.c=ut,this.e=_e)}contains(j){return t.isRange(j)?this.contains(j.start)&&this.contains(j.end):W.isPosition(j)?!(W.of(j).isBefore(this.c)||this.e.isBefore(j)):!1}isEqual(j){return this.c.isEqual(j.c)&&this.e.isEqual(j.e)}intersection(j){const ie=W.Max(j.start,this.c),ke=W.Min(j.end,this.e);if(!ie.isAfter(ke))return new t(ie,ke)}union(j){if(this.contains(j))return this;if(j.contains(this))return j;const ie=W.Min(j.start,this.c),ke=W.Max(j.end,this.end);return new t(ie,ke)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(j,ie=this.end){if(j===null||ie===null)throw(0,F.$7)();let ke;return j?W.isPosition(j)?ke=j:(ke=j.start||this.start,ie=j.end||this.end):ke=this.start,ke.isEqual(this.c)&&ie.isEqual(this.end)?this:new t(ke,ie)}toJSON(){return[this.start,this.end]}};e.$4L=U,e.$4L=U=t=Ze([b],U);let C=n=class extends U{static isSelection(j){return j instanceof n?!0:j?U.isRange(j)&&W.isPosition(j.anchor)&&W.isPosition(j.active)&&typeof j.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(j,ie,ke,Je){let _e,ut;if(typeof j=="number"&&typeof ie=="number"&&typeof ke=="number"&&typeof Je=="number"?(_e=new W(j,ie),ut=new W(ke,Je)):W.isPosition(j)&&W.isPosition(ie)&&(_e=W.of(j),ut=W.of(ie)),!_e||!ut)throw new Error("Invalid arguments");super(_e,ut),this.f=_e,this.g=ut}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$5L=C,e.$5L=C=n=Ze([b],C);const O=B=>{if(typeof B!="string"||B.length===0||!/^[0-9A-Za-z_\-]+$/.test(B))throw(0,F.$7)("connectionToken")};class V{static isResolvedAuthority(j){return j&&typeof j=="object"&&typeof j.host=="string"&&typeof j.port=="number"&&(j.connectionToken===void 0||typeof j.connectionToken=="string")}constructor(j,ie,ke){if(typeof j!="string"||j.length===0)throw(0,F.$7)("host");if(typeof ie!="number"||ie===0||Math.round(ie)!==ie)throw(0,F.$7)("port");typeof ke<"u"&&O(ke),this.host=j,this.port=Math.round(ie),this.connectionToken=ke}}e.$6L=V;class re{static isManagedResolvedAuthority(j){return j&&typeof j=="object"&&typeof j.makeConnection=="function"&&(j.connectionToken===void 0||typeof j.connectionToken=="string")}constructor(j,ie){this.makeConnection=j,this.connectionToken=ie,typeof ie<"u"&&O(ie)}}e.$7L=re;class ue extends Error{static NotAvailable(j,ie){return new ue(j,v.RemoteAuthorityResolverErrorCode.NotAvailable,ie)}static TemporarilyNotAvailable(j){return new ue(j,v.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(j,ie=v.RemoteAuthorityResolverErrorCode.Unknown,ke){super(j),this._message=j,this._code=ie,this._detail=ke,Object.setPrototypeOf(this,ue.prototype)}}e.$8L=ue;var ye;(function(B){B[B.LF=1]="LF",B[B.CRLF=2]="CRLF"})(ye||(e.EndOfLine=ye={}));var De;(function(B){B[B.Replace=1]="Replace",B[B.Append=2]="Append",B[B.Prepend=3]="Prepend"})(De||(e.EnvironmentVariableMutatorType=De={}));let he=r=class{static isTextEdit(j){return j instanceof r?!0:j?U.isRange(j)&&typeof j.newText=="string":!1}static replace(j,ie){return new r(j,ie)}static insert(j,ie){return r.replace(new U(j,j),ie)}static delete(j){return r.replace(j,"")}static setEndOfLine(j){const ie=new r(new U(new W(0,0),new W(0,0)),"");return ie.newEol=j,ie}get range(){return this.c}set range(j){if(j&&!U.isRange(j))throw(0,F.$7)("range");this.c=j}get newText(){return this.e||""}set newText(j){if(j&&typeof j!="string")throw(0,F.$7)("newText");this.e=j}get newEol(){return this.f}set newEol(j){if(j&&typeof j!="number")throw(0,F.$7)("newEol");this.f=j}constructor(j,ie){this.c=j,this.e=ie}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$9L=he,e.$9L=he=r=Ze([b],he);let ve=a=class{static isNotebookCellEdit(j){return j instanceof a?!0:j?hi.isNotebookRange(j)&&Array.isArray(j.newCells):!1}static replaceCells(j,ie){return new a(j,ie)}static insertCells(j,ie){return new a(new hi(j,j),ie)}static deleteCells(j){return new a(j,[])}static updateCellMetadata(j,ie){const ke=new a(new hi(j,j),[]);return ke.newCellMetadata=ie,ke}static updateNotebookMetadata(j){const ie=new a(new hi(0,0),[]);return ie.newNotebookMetadata=j,ie}constructor(j,ie){this.range=j,this.newCells=ie}};e.$0L=ve,e.$0L=ve=a=Ze([b],ve);class se{static isSnippetTextEdit(j){return j instanceof se?!0:j?U.isRange(j.range)&&Q.isSnippetString(j.snippet):!1}static replace(j,ie){return new se(j,ie)}static insert(j,ie){return se.replace(new U(j,j),ie)}constructor(j,ie){this.range=j,this.snippet=ie}}e.$$L=se;var $e;(function(B){B[B.File=1]="File",B[B.Text=2]="Text",B[B.Cell=3]="Cell",B[B.CellReplace=5]="CellReplace",B[B.Snippet=6]="Snippet"})($e||(e.FileEditType=$e={}));let ee=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(j,ie,ke,Je){this.c.push({_type:1,from:j,to:ie,options:ke,metadata:Je})}createFile(j,ie,ke){this.c.push({_type:1,from:void 0,to:j,options:ie,metadata:ke})}deleteFile(j,ie,ke){this.c.push({_type:1,from:j,to:void 0,options:ie,metadata:ke})}e(j,ie,ke){this.c.push({_type:3,metadata:ke,uri:j,edit:{editType:5,metadata:ie},notebookMetadata:ie})}f(j,ie,ke,Je){const _e=ie.start,ut=ie.end;(_e!==ut||ke.length>0)&&this.c.push({_type:5,uri:j,index:_e,count:ut-_e,cells:ke,metadata:Je})}g(j,ie,ke,Je){this.c.push({_type:3,metadata:Je,uri:j,edit:{editType:3,index:ie,metadata:ke}})}replace(j,ie,ke,Je){this.c.push({_type:2,uri:j,edit:new he(ie,ke),metadata:Je})}insert(j,ie,ke,Je){this.replace(j,new U(ie,ie),ke,Je)}delete(j,ie,ke){this.replace(j,ie,"",ke)}has(j){return this.c.some(ie=>ie._type===2&&ie.uri.toString()===j.toString())}set(j,ie){if(ie)for(const ke of ie){if(!ke)continue;let Je,_e;Array.isArray(ke)?(Je=ke[0],_e=ke[1]):Je=ke,ve.isNotebookCellEdit(Je)?Je.newCellMetadata?this.g(j,Je.range.start,Je.newCellMetadata,_e):Je.newNotebookMetadata?this.e(j,Je.newNotebookMetadata,_e):this.f(j,Je.range,Je.newCells,_e):se.isSnippetTextEdit(Je)?this.c.push({_type:6,uri:j,range:Je.range,edit:Je.snippet,metadata:_e}):this.c.push({_type:2,uri:j,edit:Je,metadata:_e})}else{for(let ke=0;ke<this.c.length;ke++){const Je=this.c[ke];switch(Je._type){case 2:case 6:case 3:case 5:Je.uri.toString()===j.toString()&&(this.c[ke]=void 0);break}}(0,S.$Ib)(this.c)}}get(j){const ie=[];for(const ke of this.c)ke._type===2&&ke.uri.toString()===j.toString()&&ie.push(ke.edit);return ie}entries(){const j=new L.$Ac;for(const ie of this.c)if(ie._type===2){let ke=j.get(ie.uri);ke||(ke=[ie.uri,[]],j.set(ie.uri,ke)),ke[1].push(ie.edit)}return[...j.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$_L=ee,e.$_L=ee=Ze([b],ee);let Q=h=class{static isSnippetString(j){return j instanceof h?!0:j?typeof j.value=="string":!1}static c(j){return j.replace(/\$|}|\\/g,"\\$&")}constructor(j){this.e=1,this.value=j||""}appendText(j){return this.value+=h.c(j),this}appendTabstop(j=this.e++){return this.value+="$",this.value+=j,this}appendPlaceholder(j,ie=this.e++){if(typeof j=="function"){const ke=new h;ke.e=this.e,j(ke),this.e=ke.e,j=ke.value}else j=h.c(j);return this.value+="${",this.value+=ie,this.value+=":",this.value+=j,this.value+="}",this}appendChoice(j,ie=this.e++){const ke=j.map(Je=>Je.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=ie,this.value+="|",this.value+=ke,this.value+="|}",this}appendVariable(j,ie){if(typeof ie=="function"){const ke=new h;ke.e=this.e,ie(ke),this.e=ke.e,ie=ke.value}else typeof ie=="string"&&(ie=ie.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=j,ie&&(this.value+=":",this.value+=ie),this.value+="}",this}};e.$aM=Q,e.$aM=Q=h=Ze([b],Q);var q;(function(B){B[B.Unnecessary=1]="Unnecessary",B[B.Deprecated=2]="Deprecated"})(q||(e.DiagnosticTag=q={}));var ne;(function(B){B[B.Hint=3]="Hint",B[B.Information=2]="Information",B[B.Warning=1]="Warning",B[B.Error=0]="Error"})(ne||(e.DiagnosticSeverity=ne={}));let Se=i=class{static isLocation(j){return j instanceof i?!0:j?U.isRange(j.range)&&D.URI.isUri(j.uri):!1}constructor(j,ie){if(this.uri=j,ie)if(U.isRange(ie))this.range=U.of(ie);else if(W.isPosition(ie))this.range=new U(ie,ie);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$bM=Se,e.$bM=Se=i=Ze([b],Se);let Te=class{static is(j){return j?typeof j.message=="string"&&j.location&&U.isRange(j.location.range)&&D.URI.isUri(j.location.uri):!1}constructor(j,ie){this.location=j,this.message=ie}static isEqual(j,ie){return j===ie?!0:!j||!ie?!1:j.message===ie.message&&j.location.range.isEqual(ie.location.range)&&j.location.uri.toString()===ie.location.uri.toString()}};e.$cM=Te,e.$cM=Te=Ze([b],Te);let Ce=class{constructor(j,ie,ke=ne.Error){if(!U.isRange(j))throw new TypeError("range must be set");if(!ie)throw new TypeError("message must be set");this.range=j,this.message=ie,this.severity=ke}toJSON(){return{severity:ne[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(j,ie){return j===ie?!0:!j||!ie?!1:j.message===ie.message&&j.severity===ie.severity&&j.code===ie.code&&j.severity===ie.severity&&j.source===ie.source&&j.range.isEqual(ie.range)&&(0,S.$ub)(j.tags,ie.tags)&&(0,S.$ub)(j.relatedInformation,ie.relatedInformation,Te.isEqual)}};e.$dM=Ce,e.$dM=Ce=Ze([b],Ce);let we=class{constructor(j,ie){if(!j)throw new Error("Illegal argument, contents must be defined");Array.isArray(j)?this.contents=j:this.contents=[j],this.range=ie}};e.$eM=we,e.$eM=we=Ze([b],we);var ge;(function(B){B[B.Text=0]="Text",B[B.Read=1]="Read",B[B.Write=2]="Write"})(ge||(e.DocumentHighlightKind=ge={}));let J=class{constructor(j,ie=ge.Text){this.range=j,this.kind=ie}toJSON(){return{range:this.range,kind:ge[this.kind]}}};e.$fM=J,e.$fM=J=Ze([b],J);let x=class{constructor(j,ie){this.uri=j,this.highlights=ie}toJSON(){return{uri:this.uri,highlights:this.highlights.map(j=>j.toJSON())}}};e.$gM=x,e.$gM=x=Ze([b],x);var le;(function(B){B[B.File=0]="File",B[B.Module=1]="Module",B[B.Namespace=2]="Namespace",B[B.Package=3]="Package",B[B.Class=4]="Class",B[B.Method=5]="Method",B[B.Property=6]="Property",B[B.Field=7]="Field",B[B.Constructor=8]="Constructor",B[B.Enum=9]="Enum",B[B.Interface=10]="Interface",B[B.Function=11]="Function",B[B.Variable=12]="Variable",B[B.Constant=13]="Constant",B[B.String=14]="String",B[B.Number=15]="Number",B[B.Boolean=16]="Boolean",B[B.Array=17]="Array",B[B.Object=18]="Object",B[B.Key=19]="Key",B[B.Null=20]="Null",B[B.EnumMember=21]="EnumMember",B[B.Struct=22]="Struct",B[B.Event=23]="Event",B[B.Operator=24]="Operator",B[B.TypeParameter=25]="TypeParameter"})(le||(e.SymbolKind=le={}));var de;(function(B){B[B.Deprecated=1]="Deprecated"})(de||(e.SymbolTag=de={}));let Pe=p=class{static validate(j){if(!j.name)throw new Error("name must not be falsy")}constructor(j,ie,ke,Je,_e){this.name=j,this.kind=ie,this.containerName=_e,typeof ke=="string"&&(this.containerName=ke),Je instanceof Se?this.location=Je:ke instanceof U&&(this.location=new Se(Je,ke)),p.validate(this)}toJSON(){return{name:this.name,kind:le[this.kind],location:this.location,containerName:this.containerName}}};e.$hM=Pe,e.$hM=Pe=p=Ze([b],Pe);let me=u=class{static validate(j){if(!j.name)throw new Error("name must not be falsy");if(!j.range.contains(j.selectionRange))throw new Error("selectionRange must be contained in fullRange");j.children?.forEach(u.validate)}constructor(j,ie,ke,Je,_e){this.name=j,this.detail=ie,this.kind=ke,this.range=Je,this.selectionRange=_e,this.children=[],u.validate(this)}};e.$iM=me,e.$iM=me=u=Ze([b],me);var Ie;(function(B){B[B.Invoke=1]="Invoke",B[B.Automatic=2]="Automatic"})(Ie||(e.CodeActionTriggerKind=Ie={}));let Me=class{constructor(j,ie){this.title=j,this.kind=ie}};e.$jM=Me,e.$jM=Me=Ze([b],Me);let ze=class{static{o=this}static{this.c="."}constructor(j){this.value=j}append(j){return new o(this.value?this.value+o.c+j:j)}intersects(j){return this.contains(j)||j.contains(this)}contains(j){return this.value===j.value||j.value.startsWith(this.value+o.c)}};e.$kM=ze,e.$kM=ze=o=Ze([b],ze),ze.Empty=new ze(""),ze.QuickFix=ze.Empty.append("quickfix"),ze.Refactor=ze.Empty.append("refactor"),ze.RefactorExtract=ze.Refactor.append("extract"),ze.RefactorInline=ze.Refactor.append("inline"),ze.RefactorMove=ze.Refactor.append("move"),ze.RefactorRewrite=ze.Refactor.append("rewrite"),ze.Source=ze.Empty.append("source"),ze.SourceOrganizeImports=ze.Source.append("organizeImports"),ze.SourceFixAll=ze.Source.append("fixAll"),ze.Notebook=ze.Empty.append("notebook");let N=class{constructor(j,ie){if(this.range=j,this.parent=ie,ie&&!ie.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$lM=N,e.$lM=N=Ze([b],N);class z{constructor(j,ie,ke,Je,_e,ut){this.kind=j,this.name=ie,this.detail=ke,this.uri=Je,this.range=_e,this.selectionRange=ut}}e.$mM=z;class K{constructor(j,ie){this.fromRanges=ie,this.from=j}}e.$nM=K;class H{constructor(j,ie){this.fromRanges=ie,this.to=j}}e.$oM=H;var te;(function(B){B[B.Information=0]="Information",B[B.Warning=1]="Warning",B[B.Error=2]="Error"})(te||(e.LanguageStatusSeverity=te={}));let oe=class{constructor(j,ie){this.range=j,this.command=ie}get isResolved(){return!!this.command}};e.$pM=oe,e.$pM=oe=Ze([b],oe);let Oe=E=class{#e;static isMarkdownString(j){return j instanceof E?!0:j&&j.appendCodeblock&&j.appendMarkdown&&j.appendText&&j.value!==void 0}constructor(j,ie=!1){this.#e=new P.$sk(j,{supportThemeIcons:ie})}get value(){return this.#e.value}set value(j){this.#e.value=j}get isTrusted(){return this.#e.isTrusted}set isTrusted(j){this.#e.isTrusted=j}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(j){this.#e.supportThemeIcons=j}get supportHtml(){return this.#e.supportHtml}set supportHtml(j){this.#e.supportHtml=j}get baseUri(){return this.#e.baseUri}set baseUri(j){this.#e.baseUri=j}appendText(j){return this.#e.appendText(j),this}appendMarkdown(j){return this.#e.appendMarkdown(j),this}appendCodeblock(j,ie){return this.#e.appendCodeblock(ie??"",j),this}};e.$qM=Oe,e.$qM=Oe=E=Ze([b],Oe);let Ve=class{constructor(j,ie){this.label=j,this.documentation=ie}};e.$rM=Ve,e.$rM=Ve=Ze([b],Ve);let He=class{constructor(j,ie){this.label=j,this.documentation=ie,this.parameters=[]}};e.$sM=He,e.$sM=He=Ze([b],He);let xe=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$tM=xe,e.$tM=xe=Ze([b],xe);var tt;(function(B){B[B.Invoke=1]="Invoke",B[B.TriggerCharacter=2]="TriggerCharacter",B[B.ContentChange=3]="ContentChange"})(tt||(e.SignatureHelpTriggerKind=tt={}));var lt;(function(B){B[B.Type=1]="Type",B[B.Parameter=2]="Parameter"})(lt||(e.InlayHintKind=lt={}));let rt=class{constructor(j){this.value=j}};e.$uM=rt,e.$uM=rt=Ze([b],rt);let it=class{constructor(j,ie,ke){this.position=j,this.label=ie,this.kind=ke}};e.$vM=it,e.$vM=it=Ze([b],it);var ot;(function(B){B[B.Invoke=0]="Invoke",B[B.TriggerCharacter=1]="TriggerCharacter",B[B.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(ot||(e.CompletionTriggerKind=ot={}));var Be;(function(B){B[B.Text=0]="Text",B[B.Method=1]="Method",B[B.Function=2]="Function",B[B.Constructor=3]="Constructor",B[B.Field=4]="Field",B[B.Variable=5]="Variable",B[B.Class=6]="Class",B[B.Interface=7]="Interface",B[B.Module=8]="Module",B[B.Property=9]="Property",B[B.Unit=10]="Unit",B[B.Value=11]="Value",B[B.Enum=12]="Enum",B[B.Keyword=13]="Keyword",B[B.Snippet=14]="Snippet",B[B.Color=15]="Color",B[B.File=16]="File",B[B.Reference=17]="Reference",B[B.Folder=18]="Folder",B[B.EnumMember=19]="EnumMember",B[B.Constant=20]="Constant",B[B.Struct=21]="Struct",B[B.Event=22]="Event",B[B.Operator=23]="Operator",B[B.TypeParameter=24]="TypeParameter",B[B.User=25]="User",B[B.Issue=26]="Issue"})(Be||(e.CompletionItemKind=Be={}));var et;(function(B){B[B.Deprecated=1]="Deprecated"})(et||(e.CompletionItemTag=et={}));let Y=class{constructor(j,ie){this.label=j,this.kind=ie}toJSON(){return{label:this.label,kind:this.kind&&Be[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$wM=Y,e.$wM=Y=Ze([b],Y);let X=class{constructor(j=[],ie=!1){this.items=j,this.isIncomplete=ie}};e.$xM=X,e.$xM=X=Ze([b],X);let pe=class{constructor(j,ie,ke){this.insertText=j,this.range=ie,this.command=ke}};e.$yM=pe,e.$yM=pe=Ze([b],pe);let We=class{constructor(j){this.commands=void 0,this.suppressSuggestions=void 0,this.items=j}};e.$zM=We,e.$zM=We=Ze([b],We);var Xe;(function(B){B[B.Active=-1]="Active",B[B.Beside=-2]="Beside",B[B.One=1]="One",B[B.Two=2]="Two",B[B.Three=3]="Three",B[B.Four=4]="Four",B[B.Five=5]="Five",B[B.Six=6]="Six",B[B.Seven=7]="Seven",B[B.Eight=8]="Eight",B[B.Nine=9]="Nine"})(Xe||(e.ViewColumn=Xe={}));var st;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(st||(e.StatusBarAlignment=st={}));function Le(B,j){return`${k.$wm.toKey(B)}.${j}`}e.$AM=Le;var Dt;(function(B){B[B.Off=0]="Off",B[B.On=1]="On",B[B.Relative=2]="Relative",B[B.Interval=3]="Interval"})(Dt||(e.TextEditorLineNumbersStyle=Dt={}));var Ht;(function(B){B[B.Manual=1]="Manual",B[B.AfterDelay=2]="AfterDelay",B[B.FocusOut=3]="FocusOut"})(Ht||(e.TextDocumentSaveReason=Ht={}));var Tt;(function(B){B[B.Default=0]="Default",B[B.InCenter=1]="InCenter",B[B.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",B[B.AtTop=3]="AtTop"})(Tt||(e.TextEditorRevealType=Tt={}));var Qt;(function(B){B[B.Keyboard=1]="Keyboard",B[B.Mouse=2]="Mouse",B[B.Command=3]="Command"})(Qt||(e.TextEditorSelectionChangeKind=Qt={}));var Xt;(function(B){B[B.Undo=1]="Undo",B[B.Redo=2]="Redo"})(Xt||(e.TextDocumentChangeReason=Xt={}));var It;(function(B){B[B.OpenOpen=0]="OpenOpen",B[B.ClosedClosed=1]="ClosedClosed",B[B.OpenClosed=2]="OpenClosed",B[B.ClosedOpen=3]="ClosedOpen"})(It||(e.DecorationRangeBehavior=It={})),function(B){function j(ie){switch(ie){case"keyboard":return B.Keyboard;case"mouse":return B.Mouse;case"api":return B.Command}}B.fromValue=j}(Qt||(e.TextEditorSelectionChangeKind=Qt={}));var Kt;(function(B){B[B.Other=0]="Other",B[B.Comment=1]="Comment",B[B.String=2]="String",B[B.RegEx=3]="RegEx"})(Kt||(e.SyntaxTokenType=Kt={})),function(B){function j(ie){switch(ie){case B.Other:return"other";case B.Comment:return"comment";case B.String:return"string";case B.RegEx:return"regex"}return"other"}B.toString=j}(Kt||(e.SyntaxTokenType=Kt={}));let Gt=class{constructor(j,ie){if(ie&&!D.URI.isUri(ie))throw(0,F.$7)("target");if(!U.isRange(j)||j.isEmpty)throw(0,F.$7)("range");this.range=j,this.target=ie}};e.$BM=Gt,e.$BM=Gt=Ze([b],Gt);let xt=class{constructor(j,ie,ke,Je){this.red=j,this.green=ie,this.blue=ke,this.alpha=Je}};e.$CM=xt,e.$CM=xt=Ze([b],xt);let ii=class{constructor(j,ie){if(ie&&!(ie instanceof xt))throw(0,F.$7)("color");if(!U.isRange(j)||j.isEmpty)throw(0,F.$7)("range");this.range=j,this.color=ie}};e.$DM=ii,e.$DM=ii=Ze([b],ii);let Ye=class{constructor(j){if(!j||typeof j!="string")throw(0,F.$7)("label");this.label=j}};e.$EM=Ye,e.$EM=Ye=Ze([b],Ye);var Nt;(function(B){B[B.RGB=0]="RGB",B[B.HEX=1]="HEX",B[B.HSL=2]="HSL"})(Nt||(e.ColorFormat=Nt={}));var _t;(function(B){B[B.Error=0]="Error",B[B.Warning=1]="Warning",B[B.Information=2]="Information"})(_t||(e.SourceControlInputBoxValidationType=_t={}));var ft;(function(B){B[B.Unknown=0]="Unknown",B[B.Shutdown=1]="Shutdown",B[B.Process=2]="Process",B[B.User=3]="User",B[B.Extension=4]="Extension"})(ft||(e.TerminalExitReason=ft={}));class vt{constructor(j,ie,ke){if(this.startIndex=j,this.length=ie,this.tooltip=ke,typeof j!="number"||j<0)throw(0,F.$7)("startIndex");if(typeof ie!="number"||ie<1)throw(0,F.$7)("length");if(ke!==void 0&&typeof ke!="string")throw(0,F.$7)("tooltip")}}e.$FM=vt;class ei{constructor(j){this.uri=j}}e.$GM=ei;class Bt{constructor(j){this.terminalCommand=j}}e.$HM=Bt;var jt;(function(B){B[B.Panel=1]="Panel",B[B.Editor=2]="Editor"})(jt||(e.TerminalLocation=jt={}));class dt{constructor(j){if(this.options=j,typeof j!="object")throw(0,F.$7)("options")}}e.$IM=dt;var Rt;(function(B){B[B.Always=1]="Always",B[B.Silent=2]="Silent",B[B.Never=3]="Never"})(Rt||(e.TaskRevealKind=Rt={}));var ti;(function(B){B[B.Shared=1]="Shared",B[B.Dedicated=2]="Dedicated",B[B.New=3]="New"})(ti||(e.TaskPanelKind=ti={}));let Yt=class{static{w=this}static{this.Clean=new w("clean","Clean")}static{this.Build=new w("build","Build")}static{this.Rebuild=new w("rebuild","Rebuild")}static{this.Test=new w("test","Test")}static from(j){switch(j){case"clean":return w.Clean;case"build":return w.Build;case"rebuild":return w.Rebuild;case"test":return w.Test;default:return}}constructor(j,ie){if(this.label=ie,typeof j!="string"||typeof ie!="string")throw(0,F.$7)("name");this.c=j}get id(){return this.c}};e.$JM=Yt,e.$JM=Yt=w=Ze([b],Yt);function Ke(B){let j="";for(let ie=0;ie<B.length;ie++)j+=B[ie].replace(/,/g,",,")+",";return j}let Ft=class{constructor(j,ie,ke){if(typeof j!="string")throw(0,F.$7)("process");this.e=[],this.c=j,ie!==void 0&&(Array.isArray(ie)?(this.e=ie,this.f=ke):this.f=ie)}get process(){return this.c}set process(j){if(typeof j!="string")throw(0,F.$7)("process");this.c=j}get args(){return this.e}set args(j){Array.isArray(j)||(j=[]),this.e=j}get options(){return this.f}set options(j){this.f=j}computeId(){const j=[];if(j.push("process"),this.c!==void 0&&j.push(this.c),this.e&&this.e.length>0)for(const ie of this.e)j.push(ie);return Ke(j)}};e.$KM=Ft,e.$KM=Ft=Ze([b],Ft);let zt=class{constructor(j,ie,ke){if(this.f=[],Array.isArray(ie)){if(!j)throw(0,F.$7)("command can't be undefined or null");if(typeof j!="string"&&typeof j.value!="string")throw(0,F.$7)("command");this.e=j,this.f=ie,this.g=ke}else{if(typeof j!="string")throw(0,F.$7)("commandLine");this.c=j,this.g=ie}}get commandLine(){return this.c}set commandLine(j){if(typeof j!="string")throw(0,F.$7)("commandLine");this.c=j}get command(){return this.e?this.e:""}set command(j){if(typeof j!="string"&&typeof j.value!="string")throw(0,F.$7)("command");this.e=j}get args(){return this.f}set args(j){this.f=j||[]}get options(){return this.g}set options(j){this.g=j}computeId(){const j=[];if(j.push("shell"),this.c!==void 0&&j.push(this.c),this.e!==void 0&&j.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const ie of this.f)j.push(typeof ie=="string"?ie:ie.value);return Ke(j)}};e.$LM=zt,e.$LM=zt=Ze([b],zt);var ni;(function(B){B[B.Escape=1]="Escape",B[B.Strong=2]="Strong",B[B.Weak=3]="Weak"})(ni||(e.ShellQuoting=ni={}));var gt;(function(B){B[B.Global=1]="Global",B[B.Workspace=2]="Workspace"})(gt||(e.TaskScope=gt={}));class Lt{constructor(j){this.c=j}computeId(){return"customExecution"+(0,M.$Ag)()}set callback(j){this.c=j}get callback(){return this.c}}e.$MM=Lt;let Ct=class{static{m=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(j,ie,ke,Je,_e,ut){this.k=!1,this.l=this.definition=j;let mt;typeof ie=="string"?(this.o=this.name=ie,this.w=this.source=ke,this.execution=Je,mt=_e,this.k=!0):ie===gt.Global||ie===gt.Workspace?(this.target=ie,this.o=this.name=ke,this.w=this.source=Je,this.execution=_e,mt=ut):(this.target=ie,this.o=this.name=ke,this.w=this.source=Je,this.execution=_e,mt=ut),typeof mt=="string"?(this.r=[mt],this.t=!0):Array.isArray(mt)?(this.r=mt,this.t=!0):(this.r=[],this.t=!1),this.u=!1,this.y=Object.create(null),this.z=Object.create(null)}get _id(){return this.j}set _id(j){this.j=j}get _deprecated(){return this.k}B(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.C())}C(){this.q instanceof Ft?this.l={type:m.e,id:this.q.computeId()}:this.q instanceof zt?this.l={type:m.f,id:this.q.computeId()}:this.q instanceof Lt?this.l={type:m.c,id:this.q.computeId()}:this.l={type:m.g,id:(0,M.$Ag)()}}get definition(){return this.l}set definition(j){if(j==null)throw(0,F.$7)("Kind can't be undefined or null");this.B(),this.l=j}get scope(){return this.m}set target(j){this.B(),this.m=j}get name(){return this.o}set name(j){if(typeof j!="string")throw(0,F.$7)("name");this.B(),this.o=j}get execution(){return this.q}set execution(j){j===null&&(j=void 0),this.B(),this.q=j;const ie=this.l.type;(m.g===ie||m.e===ie||m.f===ie||m.c===ie)&&this.C()}get problemMatchers(){return this.r}set problemMatchers(j){if(Array.isArray(j))this.B(),this.r=j,this.t=!0;else{this.B(),this.r=[],this.t=!1;return}}get hasDefinedMatchers(){return this.t}get isBackground(){return this.u}set isBackground(j){j!==!0&&j!==!1&&(j=!1),this.B(),this.u=j}get source(){return this.w}set source(j){if(typeof j!="string"||j.length===0)throw(0,F.$7)("source must be a string of length > 0");this.B(),this.w=j}get group(){return this.x}set group(j){j===null&&(j=void 0),this.B(),this.x=j}get detail(){return this.A}set detail(j){j===null&&(j=void 0),this.A=j}get presentationOptions(){return this.y}set presentationOptions(j){j==null&&(j=Object.create(null)),this.B(),this.y=j}get runOptions(){return this.z}set runOptions(j){j==null&&(j=Object.create(null)),this.B(),this.z=j}};e.$NM=Ct,e.$NM=Ct=m=Ze([b],Ct);var Ut;(function(B){B[B.SourceControl=1]="SourceControl",B[B.Window=10]="Window",B[B.Notification=15]="Notification"})(Ut||(e.ProgressLocation=Ut={}));var ri;(function(B){function j(ie){const ke=ie;return(0,f.$Wf)(ke.value)?ke.tooltip&&!(0,f.$Sf)(ke.tooltip)?(console.log("INVALID view badge, invalid tooltip",ke.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",ke.value),!1)}B.isViewBadge=j})(ri||(e.ViewBadge=ri={}));let Ot=I=class{static isTreeItem(j,ie){const ke=j;if(ke.checkboxState!==void 0){const Je=(0,f.$Wf)(ke.checkboxState)?ke.checkboxState:(0,f.$Uf)(ke.checkboxState)&&(0,f.$Wf)(ke.checkboxState.state)?ke.checkboxState.state:void 0,_e=!(0,f.$Wf)(ke.checkboxState)&&(0,f.$Uf)(ke.checkboxState)?ke.checkboxState.tooltip:void 0;if(Je===void 0||Je!==Pt.Checked&&Je!==Pt.Unchecked||_e!==void 0&&!(0,f.$Sf)(_e))return console.log("INVALID tree item, invalid checkboxState",ke.checkboxState),!1}if(j instanceof I)return!0;if(ke.label!==void 0&&!(0,f.$Sf)(ke.label)&&!ke.label?.label)return console.log("INVALID tree item, invalid label",ke.label),!1;if(ke.id!==void 0&&!(0,f.$Sf)(ke.id))return console.log("INVALID tree item, invalid id",ke.id),!1;if(ke.iconPath!==void 0&&!(0,f.$Sf)(ke.iconPath)&&!D.URI.isUri(ke.iconPath)&&(!ke.iconPath||!(0,f.$Sf)(ke.iconPath.id))){const Je=ke.iconPath;if(!Je||!(0,f.$Sf)(Je.light)&&!D.URI.isUri(Je.light)&&!(0,f.$Sf)(Je.dark)&&!D.URI.isUri(Je.dark))return console.log("INVALID tree item, invalid iconPath",ke.iconPath),!1}return ke.description!==void 0&&!(0,f.$Sf)(ke.description)&&typeof ke.description!="boolean"?(console.log("INVALID tree item, invalid description",ke.description),!1):ke.resourceUri!==void 0&&!D.URI.isUri(ke.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",ke.resourceUri),!1):ke.tooltip!==void 0&&!(0,f.$Sf)(ke.tooltip)&&!(ke.tooltip instanceof Oe)?(console.log("INVALID tree item, invalid tooltip",ke.tooltip),!1):ke.command!==void 0&&!ke.command.command?(console.log("INVALID tree item, invalid command",ke.command),!1):ke.collapsibleState!==void 0&&ke.collapsibleState<Vt.None&&ke.collapsibleState>Vt.Expanded?(console.log("INVALID tree item, invalid collapsibleState",ke.collapsibleState),!1):ke.contextValue!==void 0&&!(0,f.$Sf)(ke.contextValue)?(console.log("INVALID tree item, invalid contextValue",ke.contextValue),!1):ke.accessibilityInformation!==void 0&&!ke.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",ke.accessibilityInformation),!1):!0}constructor(j,ie=Vt.None){this.collapsibleState=ie,D.URI.isUri(j)?this.resourceUri=j:this.label=j}};e.$OM=Ot,e.$OM=Ot=I=Ze([b],Ot);var Vt;(function(B){B[B.None=0]="None",B[B.Collapsed=1]="Collapsed",B[B.Expanded=2]="Expanded"})(Vt||(e.TreeItemCollapsibleState=Vt={}));var Pt;(function(B){B[B.Unchecked=0]="Unchecked",B[B.Checked=1]="Checked"})(Pt||(e.TreeItemCheckboxState=Pt={}));let kt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(j){this.value=j}};e.$PM=kt,e.$PM=kt=Ze([b],kt);class $t extends kt{}e.$QM=$t;class St extends $t{#e;constructor(j){super(""),this.#e=j}asFile(){return this.#e}}e.$RM=St;class wt{constructor(j,ie,ke,Je){this.name=j,this.uri=ie,this._itemId=ke,this.c=Je}data(){return this.c()}}e.$SM=wt;let li=class{#e=new Map;constructor(j){for(const[ie,ke]of j??[]){const Je=this.#e.get(this.#t(ie));Je?Je.push(ke):this.#e.set(this.#t(ie),[ke])}}get(j){return this.#e.get(this.#t(j))?.[0]}set(j,ie){this.#e.set(this.#t(j),[ie])}forEach(j,ie){for(const[ke,Je]of this.#e)for(const _e of Je)j.call(ie,_e,ke,this)}*[Symbol.iterator](){for(const[j,ie]of this.#e)for(const ke of ie)yield[j,ke]}#t(j){return j.toLowerCase()}};e.$TM=li,e.$TM=li=Ze([b],li);let Jt=class{constructor(j){this.insertText=j}};e.$UM=Jt,e.$UM=Jt=Ze([b],Jt);let $i=class{constructor(j,ie){this.label=ie,this.insertText=j}};e.$VM=$i,e.$VM=$i=Ze([b],$i);let be=class{constructor(j,ie){this.id=j,this.color=ie}static isThemeIcon(j){return typeof j.id!="string"?(console.log("INVALID ThemeIcon, invalid id",j.id),!1):!0}};e.$WM=be,e.$WM=be=Ze([b],be),be.File=new be("file"),be.Folder=new be("folder");let Fe=class{constructor(j){this.id=j}};e.$XM=Fe,e.$XM=Fe=Ze([b],Fe);var ae;(function(B){B[B.Global=1]="Global",B[B.Workspace=2]="Workspace",B[B.WorkspaceFolder=3]="WorkspaceFolder"})(ae||(e.ConfigurationTarget=ae={}));let Z=class{get base(){return this.c}set base(j){this.c=j,this.e=D.URI.file(j)}get baseUri(){return this.e}set baseUri(j){this.e=j,this.c=j.fsPath}constructor(j,ie){if(typeof j!="string"&&(!j||!D.URI.isUri(j)&&!D.URI.isUri(j.uri)))throw(0,F.$7)("base");if(typeof ie!="string")throw(0,F.$7)("pattern");typeof j=="string"?this.baseUri=D.URI.file(j):D.URI.isUri(j)?this.baseUri=j:this.baseUri=j.uri,this.pattern=ie}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$YM=Z,e.$YM=Z=Ze([b],Z);const Ee=new WeakMap;function Ne(B,j){Ee.set(B,j)}e.$ZM=Ne;let Qe=class{constructor(j,ie,ke,Je,_e){this.enabled=typeof j=="boolean"?j:!0,typeof ie=="string"&&(this.condition=ie),typeof ke=="string"&&(this.hitCondition=ke),typeof Je=="string"&&(this.logMessage=Je),typeof _e=="string"&&(this.mode=_e)}get id(){return this.c||(this.c=Ee.get(this)??(0,M.$Ag)()),this.c}};e.$1M=Qe,e.$1M=Qe=Ze([b],Qe);let Ge=class extends Qe{constructor(j,ie,ke,Je,_e,ut){if(super(ie,ke,Je,_e,ut),j===null)throw(0,F.$7)("location");this.location=j}};e.$2M=Ge,e.$2M=Ge=Ze([b],Ge);let at=class extends Qe{constructor(j,ie,ke,Je,_e,ut){super(ie,ke,Je,_e,ut),this.functionName=j}};e.$3M=at,e.$3M=at=Ze([b],at);let yt=class extends Qe{constructor(j,ie,ke,Je,_e,ut,mt,qt){if(super(Je,_e,ut,mt,qt),!ie)throw(0,F.$7)("dataId");this.label=j,this.dataId=ie,this.canPersist=ke}};e.$4M=yt,e.$4M=yt=Ze([b],yt);let Wt=class{constructor(j,ie,ke){this.command=j,this.args=ie||[],this.options=ke}};e.$5M=Wt,e.$5M=Wt=Ze([b],Wt);let Et=class{constructor(j,ie){this.port=j,this.host=ie}};e.$6M=Et,e.$6M=Et=Ze([b],Et);let At=class{constructor(j){this.path=j}};e.$7M=At,e.$7M=At=Ze([b],At);let Zt=class{constructor(j){this.implementation=j}};e.$8M=Zt,e.$8M=Zt=Ze([b],Zt);let pi=class{constructor(j,ie,ke){this.session=j,this.threadId=ie,this.frameId=ke}};e.$9M=pi,e.$9M=pi=Ze([b],pi);let vi=class{constructor(j,ie){this.session=j,this.threadId=ie}};e.$0M=vi,e.$0M=vi=Ze([b],vi);let ht=class{constructor(j,ie){this.range=j,this.expression=ie}};e.$$M=ht,e.$$M=ht=Ze([b],ht);var Xi;(function(B){B[B.Invoke=0]="Invoke",B[B.Automatic=1]="Automatic"})(Xi||(e.InlineCompletionTriggerKind=Xi={}));let ai=class{constructor(j,ie){this.range=j,this.text=ie}};e.$_M=ai,e.$_M=ai=Ze([b],ai);let fi=class{constructor(j,ie,ke=!0){this.range=j,this.variableName=ie,this.caseSensitiveLookup=ke}};e.$aN=fi,e.$aN=fi=Ze([b],fi);let yi=class{constructor(j,ie){this.range=j,this.expression=ie}};e.$bN=yi,e.$bN=yi=Ze([b],yi);let Ri=class{constructor(j,ie){this.frameId=j,this.stoppedLocation=ie}};e.$cN=Ri,e.$cN=Ri=Ze([b],Ri);var Yi;(function(B){B[B.AIGenerated=1]="AIGenerated"})(Yi||(e.NewSymbolNameTag=Yi={}));class hn{constructor(j,ie){this.newSymbolName=j,this.tags=ie}}e.$dN=hn;var Ai;(function(B){B[B.Changed=1]="Changed",B[B.Created=2]="Created",B[B.Deleted=3]="Deleted"})(Ai||(e.FileChangeType=Ai={}));let Mi=d=class extends Error{static FileExists(j){return new d(j,l.FileSystemProviderErrorCode.FileExists,d.FileExists)}static FileNotFound(j){return new d(j,l.FileSystemProviderErrorCode.FileNotFound,d.FileNotFound)}static FileNotADirectory(j){return new d(j,l.FileSystemProviderErrorCode.FileNotADirectory,d.FileNotADirectory)}static FileIsADirectory(j){return new d(j,l.FileSystemProviderErrorCode.FileIsADirectory,d.FileIsADirectory)}static NoPermissions(j){return new d(j,l.FileSystemProviderErrorCode.NoPermissions,d.NoPermissions)}static Unavailable(j){return new d(j,l.FileSystemProviderErrorCode.Unavailable,d.Unavailable)}constructor(j,ie=l.FileSystemProviderErrorCode.Unknown,ke){super(D.URI.isUri(j)?j.toString(!0):j),this.code=ke?.name??"Unknown",(0,l.$Qk)(this,ie),Object.setPrototypeOf(this,d.prototype),typeof Error.captureStackTrace=="function"&&typeof ke=="function"&&Error.captureStackTrace(this,ke)}};e.$eN=Mi,e.$eN=Mi=d=Ze([b],Mi);let Ei=class{constructor(j,ie,ke){this.start=j,this.end=ie,this.kind=ke}};e.$fN=Ei,e.$fN=Ei=Ze([b],Ei);var gi;(function(B){B[B.Comment=1]="Comment",B[B.Imports=2]="Imports",B[B.Region=3]="Region"})(gi||(e.FoldingRangeKind=gi={}));var xi;(function(B){B[B.Collapsed=0]="Collapsed",B[B.Expanded=1]="Expanded"})(xi||(e.CommentThreadCollapsibleState=xi={}));var Di;(function(B){B[B.Editing=0]="Editing",B[B.Preview=1]="Preview"})(Di||(e.CommentMode=Di={}));var ki;(function(B){B[B.Published=0]="Published",B[B.Draft=1]="Draft"})(ki||(e.CommentState=ki={}));var _i;(function(B){B[B.Unresolved=0]="Unresolved",B[B.Resolved=1]="Resolved"})(_i||(e.CommentThreadState=_i={}));class dn{constructor(j,ie=[]){this.tokenTypes=j,this.tokenModifiers=ie}}e.$gN=dn;function bi(B){return typeof B>"u"||(0,f.$Tf)(B)}class Fi{constructor(j){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,j){this.m=!0;for(let ie=0,ke=j.tokenTypes.length;ie<ke;ie++)this.k.set(j.tokenTypes[ie],ie);for(let ie=0,ke=j.tokenModifiers.length;ie<ke;ie++)this.l.set(j.tokenModifiers[ie],ie)}}push(j,ie,ke,Je,_e){if(typeof j=="number"&&typeof ie=="number"&&typeof ke=="number"&&typeof Je=="number"&&(typeof _e=="number"||typeof _e>"u"))return typeof _e>"u"&&(_e=0),this.q(j,ie,ke,Je,_e);if(U.isRange(j)&&typeof ie=="string"&&bi(ke))return this.o(j,ie,ke);throw(0,F.$7)()}o(j,ie,ke){if(!this.m)throw new Error("Legend must be provided in constructor");if(j.start.line!==j.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has(ie))throw new Error("`tokenType` is not in the provided legend");const Je=j.start.line,_e=j.start.character,ut=j.end.character-j.start.character,mt=this.k.get(ie);let qt=0;if(ke)for(const oi of ke){if(!this.l.has(oi))throw new Error("`tokenModifier` is not in the provided legend");const ui=this.l.get(oi);qt|=1<<ui>>>0}this.q(Je,_e,ut,mt,qt)}q(j,ie,ke,Je,_e){if(this.f&&(j<this.c||j===this.c&&ie<this.e)){this.f=!1;const qt=this.g.length/5|0;let oi=0,ui=0;for(let di=0;di<qt;di++){let mi=this.g[5*di],Zi=this.g[5*di+1];mi===0?(mi=oi,Zi+=ui):mi+=oi,this.g[5*di]=mi,this.g[5*di+1]=Zi,oi=mi,ui=Zi}}let ut=j,mt=ie;this.f&&this.j>0&&(ut-=this.c,ut===0&&(mt-=this.e)),this.g[this.j++]=ut,this.g[this.j++]=mt,this.g[this.j++]=ke,this.g[this.j++]=Je,this.g[this.j++]=_e,this.c=j,this.e=ie}static r(j){const ie=[],ke=j.length/5|0;for(let mt=0;mt<ke;mt++)ie[mt]=mt;ie.sort((mt,qt)=>{const oi=j[5*mt],ui=j[5*qt];if(oi===ui){const di=j[5*mt+1],mi=j[5*qt+1];return di-mi}return oi-ui});const Je=new Uint32Array(j.length);let _e=0,ut=0;for(let mt=0;mt<ke;mt++){const qt=5*ie[mt],oi=j[qt+0],ui=j[qt+1],di=j[qt+2],mi=j[qt+3],Zi=j[qt+4],Pn=oi-_e,xn=Pn===0?ui-ut:ui,Qi=5*mt;Je[Qi+0]=Pn,Je[Qi+1]=xn,Je[Qi+2]=di,Je[Qi+3]=mi,Je[Qi+4]=Zi,_e=oi,ut=ui}return Je}build(j){return this.f?new Li(new Uint32Array(this.g),j):new Li(Fi.r(this.g),j)}}e.$hN=Fi;class Li{constructor(j,ie){this.resultId=ie,this.data=j}}e.$iN=Li;class fn{constructor(j,ie,ke){this.start=j,this.deleteCount=ie,this.data=ke}}e.$jN=fn;class Si{constructor(j,ie){this.resultId=ie,this.edits=j}}e.$kN=Si;var en;(function(B){B[B.Separate=0]="Separate",B[B.MergeWithParent=1]="MergeWithParent"})(en||(e.DebugConsoleMode=en={}));class gn{constructor(j){this.name=j}}e.$lN=gn;let wi=class{static{this.Back={iconPath:new be("arrow-left")}}constructor(){}};e.$mN=wi,e.$mN=wi=Ze([b],wi);var Oi;(function(B){B[B.Separator=-1]="Separator",B[B.Default=0]="Default"})(Oi||(e.QuickPickItemKind=Oi={}));var tn;(function(B){B[B.Info=1]="Info",B[B.Warning=2]="Warning",B[B.Error=3]="Error"})(tn||(e.InputBoxValidationSeverity=tn={}));var Ti;(function(B){B[B.UI=1]="UI",B[B.Workspace=2]="Workspace"})(Ti||(e.ExtensionKind=Ti={}));class nn{static validate(j){if(typeof j.badge=="string"){let ie=(0,g.$tf)(j.badge,0);if(ie<j.badge.length&&(ie+=(0,g.$tf)(j.badge,ie)),j.badge.length>ie)throw new Error("The 'badge'-property must be undefined or a short character")}else if(j.badge&&!be.isThemeIcon(j.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!j.color&&!j.badge&&!j.tooltip)throw new Error("The decoration is empty");return!0}constructor(j,ie,ke){this.badge=j,this.tooltip=ie,this.color=ke}}e.$nN=nn;let Ni=class{constructor(j){this.kind=j}};e.$oN=Ni,e.$oN=Ni=Ze([b],Ni);var rn;(function(B){B[B.Light=1]="Light",B[B.Dark=2]="Dark",B[B.HighContrast=3]="HighContrast",B[B.HighContrastLight=4]="HighContrastLight"})(rn||(e.ColorThemeKind=rn={}));class hi{static isNotebookRange(j){return j instanceof hi?!0:j?typeof j.start=="number"&&typeof j.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(j,ie){if(j<0)throw(0,F.$7)("start must be positive");if(ie<0)throw(0,F.$7)("end must be positive");j<=ie?(this.c=j,this.e=ie):(this.c=ie,this.e=j)}with(j){let ie=this.c,ke=this.e;return j.start!==void 0&&(ie=j.start),j.end!==void 0&&(ke=j.end),ie===this.c&&ke===this.e?this:new hi(ie,ke)}}e.$pN=hi;class Ii{static validate(j){if(typeof j.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof j.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof j.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(j){return Array.isArray(j)&&j.every(ie=>Ii.isNotebookCellData(ie))}static isNotebookCellData(j){return!0}constructor(j,ie,ke,Je,_e,ut,mt){this.kind=j,this.value=ie,this.languageId=ke,this.mime=Je,this.outputs=_e??[],this.metadata=ut,this.executionSummary=mt,Ii.validate(this)}}e.$qN=Ii;class ji{constructor(j){this.cells=j}}e.$rN=ji;class si{static isNotebookCellOutputItem(j){return j instanceof si?!0:j?typeof j.mime=="string"&&j.data instanceof Uint8Array:!1}static error(j){const ie={name:j.name,message:j.message,stack:j.stack};return si.json(ie,"application/vnd.code.notebook.error")}static stdout(j){return si.text(j,"application/vnd.code.notebook.stdout")}static stderr(j){return si.text(j,"application/vnd.code.notebook.stderr")}static bytes(j,ie="application/octet-stream"){return new si(j,ie)}static#e=new TextEncoder;static text(j,ie=R.$qs.text){const ke=si.#e.encode(String(j));return new si(ke,ie)}static json(j,ie="text/x-json"){const ke=JSON.stringify(j,void 0,"	");return si.text(ke,ie)}constructor(j,ie){this.data=j,this.mime=ie;const ke=(0,R.$us)(ie,!0);if(!ke)throw new Error(`INVALID mime type: ${ie}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=ke}}e.$sN=si;class je{static isNotebookCellOutput(j){return j instanceof je?!0:!j||typeof j!="object"?!1:typeof j.id=="string"&&Array.isArray(j.items)}static ensureUniqueMimeTypes(j,ie=!1){const ke=new Set,Je=new Set;for(let _e=0;_e<j.length;_e++){const ut=j[_e],mt=(0,R.$us)(ut.mime);if(!ke.has(mt)||(0,$.$3J)(mt)){ke.add(mt);continue}Je.add(_e),ie&&console.warn(`DUPLICATED mime type '${ut.mime}' will be dropped`)}return Je.size===0?j:j.filter((_e,ut)=>!Je.has(ut))}constructor(j,ie,ke){this.items=je.ensureUniqueMimeTypes(j,!0),typeof ie=="string"?(this.id=ie,this.metadata=ke):(this.id=(0,M.$Ag)(),this.metadata=ie??ke)}}e.$tN=je;var ci;(function(B){B[B.Markup=1]="Markup",B[B.Code=2]="Code"})(ci||(e.NotebookCellKind=ci={}));var zi;(function(B){B[B.Idle=1]="Idle",B[B.Pending=2]="Pending",B[B.Executing=3]="Executing"})(zi||(e.NotebookCellExecutionState=zi={}));var nt;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(nt||(e.NotebookCellStatusBarAlignment=nt={}));var pt;(function(B){B[B.Default=0]="Default",B[B.InCenter=1]="InCenter",B[B.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",B[B.AtTop=3]="AtTop"})(pt||(e.NotebookEditorRevealType=pt={}));class mn{constructor(j,ie){this.text=j,this.alignment=ie}}e.$uN=mn;var sn;(function(B){B[B.Default=1]="Default",B[B.Preferred=2]="Preferred"})(sn||(e.NotebookControllerAffinity=sn={}));var Ui;(function(B){B[B.Default=1]="Default",B[B.Preferred=2]="Preferred",B[B.Hidden=-1]="Hidden"})(Ui||(e.NotebookControllerAffinity2=Ui={}));class $n{constructor(j,ie=[]){this.uri=j,this.provides=(0,S.$3b)(ie)}}e.$vN=$n;class Ci{constructor(j){this.label=j}}e.$wN=Ci;var on;(function(B){B[B.Named=1]="Named",B[B.Indexed=2]="Indexed"})(on||(e.NotebookVariablesRequestKind=on={}));let Bi=class{constructor(j,ie){this.label=j,this.timestamp=ie}};e.$xN=Bi,e.$xN=Bi=Ze([b],Bi);var an;(function(B){B[B.Production=1]="Production",B[B.Development=2]="Development",B[B.Test=3]="Test"})(an||(e.ExtensionMode=an={}));var Vi;(function(B){B[B.Node=1]="Node",B[B.Webworker=2]="Webworker"})(Vi||(e.ExtensionRuntime=Vi={}));var cn;(function(B){B[B.Other=0]="Other",B[B.Comment=1]="Comment",B[B.String=2]="String",B[B.RegEx=3]="RegEx"})(cn||(e.StandardTokenType=cn={}));class pn{constructor(j,ie){this.ranges=j,this.wordPattern=ie}}e.$yN=pn;class vn{constructor(j){this.c=j}get autoForwardAction(){return this.c}}e.$zN=vn;var un;(function(B){B[B.Queued=1]="Queued",B[B.Running=2]="Running",B[B.Passed=3]="Passed",B[B.Failed=4]="Failed",B[B.Skipped=5]="Skipped",B[B.Errored=6]="Errored"})(un||(e.TestResultState=un={}));var ln;(function(B){B[B.Run=1]="Run",B[B.Debug=2]="Debug",B[B.Coverage=3]="Coverage"})(ln||(e.TestRunProfileKind=ln={}));let Wi=class{constructor(j=void 0,ie=void 0,ke=void 0,Je=!1){this.include=j,this.exclude=ie,this.profile=ke,this.continuous=Je}};e.$AN=Wi,e.$AN=Wi=Ze([b],Wi);let qi=y=class{static diff(j,ie,ke){const Je=new y(j);return Je.expectedOutput=ie,Je.actualOutput=ke,Je}constructor(j){this.message=j}};e.$BN=qi,e.$BN=qi=y=Ze([b],qi);let Hi=class{constructor(j){this.id=j}};e.$CN=Hi,e.$CN=Hi=Ze([b],Hi);class Pi{constructor(j,ie){this.covered=j,this.total=ie}}e.$DN=Pi;const Ki=B=>{if(B&&B.covered>B.total)throw new Error(`The total number of covered items (${B.covered}) cannot be greater than the total (${B.total})`)};class Gi{static fromDetails(j,ie){const ke=new Pi(0,0),Je=new Pi(0,0),_e=new Pi(0,0);for(const mt of ie)if("branches"in mt){ke.total+=1,ke.covered+=mt.executed?1:0;for(const qt of mt.branches)Je.total+=1,Je.covered+=qt.executed?1:0}else _e.total+=1,_e.covered+=mt.executed?1:0;const ut=new Gi(j,ke,Je.total>0?Je:void 0,_e.total>0?_e:void 0);return ut.detailedCoverage=ie,ut}constructor(j,ie,ke,Je){this.uri=j,this.statementCoverage=ie,this.branchCoverage=ke,this.declarationCoverage=Je,Ki(ie),Ki(ke),Ki(Je)}}e.$EN=Gi;class _{get executionCount(){return+this.executed}set executionCount(j){this.executed=j}constructor(j,ie,ke=[]){this.executed=j,this.location=ie,this.branches=ke}}e.$FN=_;class ce{get executionCount(){return+this.executed}set executionCount(j){this.executed=j}constructor(j,ie,ke){this.executed=j,this.location=ie,this.label=ke}}e.$GN=ce;class Ue{get executionCount(){return+this.executed}set executionCount(j){this.executed=j}constructor(j,ie,ke){this.name=j,this.executed=ie,this.location=ke}}e.$HN=Ue;var ct;(function(B){B[B.None=0]="None",B[B.Option=1]="Option",B[B.Default=2]="Default",B[B.Preferred=3]="Preferred"})(ct||(e.ExternalUriOpenerPriority=ct={}));var bt;(function(B){B[B.Untrusted=0]="Untrusted",B[B.Trusted=1]="Trusted",B[B.Unspecified=2]="Unspecified"})(bt||(e.WorkspaceTrustState=bt={}));var Mt;(function(B){B[B.Notify=1]="Notify",B[B.OpenBrowser=2]="OpenBrowser",B[B.OpenPreview=3]="OpenPreview",B[B.Silent=4]="Silent",B[B.Ignore=5]="Ignore",B[B.OpenBrowserOnce=6]="OpenBrowserOnce"})(Mt||(e.PortAutoForwardAction=Mt={}));class Ji{constructor(j,ie,ke,Je,_e,ut){this.kind=j,this.name=ie,this.detail=ke,this.uri=Je,this.range=_e,this.selectionRange=ut}}e.$IN=Ji;class Rn{constructor(j){this.uri=j}}e.$JN=Rn;class An{constructor(j,ie){this.original=j,this.modified=ie}}e.$KN=An;class Mn{constructor(j,ie,ke,Je){this.base=j,this.input1=ie,this.input2=ke,this.result=Je}}e.$LN=Mn;class Fn{constructor(j,ie){this.uri=j,this.viewType=ie}}e.$MN=Fn;class Ln{constructor(j){this.viewType=j}}e.$NN=Ln;class On{constructor(j,ie){this.uri=j,this.notebookType=ie}}e.$ON=On;class Tn{constructor(j,ie,ke){this.original=j,this.modified=ie,this.notebookType=ke}}e.$PN=Tn;class Nn{constructor(){}}e.$QN=Nn;class jn{constructor(j,ie){this.uri=j,this.inputBoxUri=ie}}e.$RN=jn;class zn{constructor(j){this.providerId=j}}e.$SN=zn;var bn;(function(B){B[B.Down=0]="Down",B[B.Up=1]="Up"})(bn||(e.InteractiveSessionVoteDirection=bn={}));var wn;(function(B){B[B.Action=1]="Action",B[B.Toolbar=2]="Toolbar"})(wn||(e.ChatCopyKind=wn={}));var yn;(function(B){B[B.Short=1]="Short",B[B.Medium=2]="Medium",B[B.Full=3]="Full"})(yn||(e.ChatVariableLevel=yn={}));class Un{constructor(j,ie){this.label=j,this.values=ie}}e.$TN=Un;var En;(function(B){B[B.Unhelpful=0]="Unhelpful",B[B.Helpful=1]="Helpful",B[B.Undone=2]="Undone",B[B.Accepted=3]="Accepted",B[B.Bug=4]="Bug"})(En||(e.InteractiveEditorResponseFeedbackKind=En={}));var Dn;(function(B){B[B.Unhelpful=0]="Unhelpful",B[B.Helpful=1]="Helpful"})(Dn||(e.ChatResultFeedbackKind=Dn={}));class Bn{constructor(j){this.value=typeof j=="string"?new Oe(j):j}}e.$UN=Bn;class Vn{constructor(j,ie){this.value=j,this.baseUri=ie}}e.$VN=Vn;class Wn{constructor(j,ie){this.value=j,this.title=ie}}e.$WN=Wn;class qn{constructor(j){this.value=j}}e.$XN=qn;class Hn{constructor(j){this.value=j}}e.$YN=Hn;class Kn{constructor(j){this.value=j}}e.$ZN=Kn;class Gn{constructor(j,ie,ke,Je){this.prompt=j,this.command=ie,this.variables=ke,this.participant=Je}}e.$1N=Gn;class Jn{constructor(j,ie,ke,Je){this.response=j,this.result=ie,this.participant=ke,this.command=Je}}e.$2N=Jn;class Zn{constructor(j){this.content=j}}e.$3N=Zn;class Qn{constructor(j,ie){this.content=j,this.name=ie}}e.$4N=Qn;class Xn{constructor(j){this.content=j}}e.$5N=Xn;var kn;(function(B){B[B.SymbolInformation=1]="SymbolInformation",B[B.CommandInformation=2]="CommandInformation",B[B.SearchInformation=3]="SearchInformation",B[B.SettingInformation=4]="SettingInformation"})(kn||(e.RelatedInformationType=kn={}));var Sn;(function(B){B[B.Started=1]="Started",B[B.Recognizing=2]="Recognizing",B[B.Recognized=3]="Recognized",B[B.Stopped=4]="Stopped"})(Sn||(e.SpeechToTextStatus=Sn={}));var In;(function(B){B[B.Recognized=1]="Recognized",B[B.Stopped=2]="Stopped"})(In||(e.KeywordRecognitionStatus=In={}));class Yn{constructor(j,ie){this.text=j,this.range=ie}}e.$6N=Yn;var Cn;(function(B){B[B.Invoke=0]="Invoke",B[B.Automatic=1]="Automatic"})(Cn||(e.InlineEditTriggerKind=Cn={}))}),define(Re[240],Ae([1,0,3,7]),function(fe,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ehc=void 0;class P{constructor(R){this.a=new Map,this.b=0,this.c=R.getProxy(S.$ZL.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(R,g,f){if(this.a.size===0)throw new Error("No related information providers registered");const D=this.a.get(R);if(!D)throw new Error("related information provider not found");return await D.provideRelatedInformation(g,f)??[]}getRelatedInformation(R,g,f){return this.c.$getAiRelatedInformation(g,f)}registerRelatedInformationProvider(R,g,f){const D=this.b;return this.b++,this.a.set(D,f),this.c.$registerAiRelatedInformationProvider(D,g),new F.$2L(()=>{this.c.$unregisterAiRelatedInformationProvider(D),this.a.delete(D)})}}e.$Ehc=P}),define(Re[241],Ae([1,0,5,3,7,20,104]),function(fe,e,S,F,P,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Phc=void 0;class g{constructor(M){this.b=new Map,this.c=new S.$5d,this.onDidChangeSessions=this.c.event,this.d=new f,this.f=new f,this.a=M.getProxy(F.$ZL.MainThreadAuthentication)}async getSession(M,k,l,v={}){const $=L.$wm.toKey(M.identifier),s=[...l].sort().join(" ");return await this.d.getOrCreate(`${$} ${k} ${s}`,async()=>{await this.a.$ensureProvider(k);const c=M.displayName||M.name;return this.a.$getSession(k,l,$,c,v)})}async getSessions(M,k,l){const v=L.$wm.toKey(M.identifier),$=[...l].sort().join(" ");return await this.f.getOrCreate(`${v} ${$}`,async()=>{await this.a.$ensureProvider(k);const s=M.displayName||M.name;return this.a.$getSessions(k,l,v,s)})}async removeSession(M,k){const l=this.b.get(M);return l?l.provider.removeSession(k):this.a.$removeSession(M,k)}registerAuthenticationProvider(M,k,l,v){if(this.b.get(M))throw new Error(`An authentication provider with id '${M}' is already registered.`);this.b.set(M,{label:k,provider:l,options:v??{supportsMultipleAccounts:!1}});const $=l.onDidChangeSessions(s=>this.a.$sendDidChangeSessions(M,s));return this.a.$registerAuthenticationProvider(M,k,v?.supportsMultipleAccounts??!1),new P.$2L(()=>{$.dispose(),this.b.delete(M),this.a.$unregisterAuthenticationProvider(M)})}$createSession(M,k,l){const v=this.b.get(M);if(v)return Promise.resolve(v.provider.createSession(k,l));throw new Error(`Unable to find authentication provider with handle: ${M}`)}$removeSession(M,k){const l=this.b.get(M);if(l)return Promise.resolve(l.provider.removeSession(k));throw new Error(`Unable to find authentication provider with handle: ${M}`)}$getSessions(M,k){const l=this.b.get(M);if(l)return Promise.resolve(l.provider.getSessions(k));throw new Error(`Unable to find authentication provider with handle: ${M}`)}$onDidChangeAuthenticationSessions(M,k){return M.startsWith(R.$6K)||this.c.fire({provider:{id:M,label:k}}),Promise.resolve()}}e.$Phc=g;class f{constructor(){this.a=new Map}getOrCreate(M,k){const l=this.a.get(M);if(l)return l;const v=k().finally(()=>this.a.delete(M));return this.a.set(M,v),v}}}),define(Re[108],Ae([1,0,2,3,7,4,17,14,18,13,19,23]),function(fe,e,S,F,P,L,R,g,f,D,M,k){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.$Pic=e.$Oic=void 0;let v=class{static{l=this}static{this.c=0}static{this.d=250}constructor(s,c){this.h=c,this.f=new Map,this.g=s.getProxy(F.$ZL.MainThreadDecorations)}registerFileDecorationProvider(s,c){const t=l.c++;this.f.set(t,{provider:s,extensionDescription:c}),this.g.$registerDecorationProvider(t,c.identifier.value);const n=s.onDidChangeFileDecorations&&s.onDidChangeFileDecorations(r=>{if(!r){this.g.$onDidChange(t,null);return}const a=(0,f.$3b)(r);if(a.length<=l.d){this.g.$onDidChange(t,a);return}this.h.warn("[Decorations] CAPPING events from decorations provider",c.identifier.value,a.length);const h=a.map(u=>({uri:u,rank:(0,D.$Ye)(u.path,"/")})),i=(0,f.$zb)(h,(u,o)=>u.rank-o.rank||(0,D.$cf)(u.uri.path,o.uri.path)),p=[];e:for(const u of i){let o;for(const E of u){const w=(0,M.$mc)(E.uri.path);if(o!==w&&(o=w,p.push(E.uri)>=l.d))break e}}this.g.$onDidChange(t,p)});return new P.$2L(()=>{n?.dispose(),this.g.$unregisterDecorationProvider(t),this.f.delete(t)})}async $provideDecorations(s,c,t){if(!this.f.has(s))return Object.create(null);const n=Object.create(null),{provider:r,extensionDescription:a}=this.f.get(s);return await Promise.all(c.map(async h=>{try{const{uri:i,id:p}=h,u=await Promise.resolve(r.provideFileDecoration(S.URI.revive(i),t));if(!u)return;try{P.$nN.validate(u),u.badge&&typeof u.badge!="string"&&(0,k.$VF)(a,"codiconDecoration"),n[p]=[u.propagate,u.tooltip,u.badge,u.color]}catch(o){this.h.warn(`INVALID decoration from extension '${a.identifier.value}': ${o}`)}}catch(i){this.h.error(i)}})),n}};e.$Oic=v,e.$Oic=v=l=Ze([qe(0,R.$eO),qe(1,g.$yj)],v),e.$Pic=(0,L.$ei)("IExtHostDecorations")}),define(Re[242],Ae([1,0,15,2,7,3,12,22,13]),function(fe,e,S,F,P,L,R,g,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ric=void 0;class D{static{this.a=0}constructor(k,l,v){this.d=l,this.e=v,this.b=new Map,this.c=k.getProxy(L.$ZL.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(k,l){if(Object.keys(R.Schemas).indexOf(k)>=0)throw new Error(`scheme '${k}' already registered`);const v=D.a++;this.b.set(v,l),this.c.$registerTextContentProvider(v,k);let $;if(typeof l.onDidChange=="function"){let s;$=l.onDidChange(async c=>{if(c.scheme!==k){this.e.warn(`Provider for scheme '${k}' is firing event for schema '${c.scheme}' which will be IGNORED`);return}if(!this.d.getDocument(c))return;s&&await s;const t=this.$provideTextDocumentContent(v,c).then(async n=>{if(!n&&typeof n!="string")return;const r=this.d.getDocument(c);if(!r)return;const a=(0,f.$9e)(n);if(!r.equalLines(a))return this.c.$onVirtualDocumentChange(c,n)}).catch(S.$1).finally(()=>{s===t&&(s=void 0)});s=t})}return new P.$2L(()=>{this.b.delete(v)&&this.c.$unregisterTextContentProvider(v),$&&($.dispose(),$=void 0)})}$provideTextDocumentContent(k,l){const v=this.b.get(k);return v?Promise.resolve(v.provideTextDocumentContent(F.URI.revive(l),g.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${l.scheme}`))}}e.$Ric=D}),define(Re[109],Ae([1,0,55,12,13,298,148,7,18]),function(fe,e,S,F,P,L,R,g,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iO=e.$hO=e.$gO=void 0;const D=new Map;function M($,s){s?D.set($,s):D.delete($)}e.$gO=M;function k($){return D.get($)}class l extends L.$xv{constructor(s,c,t,n,r,a,h){super(c,t,n,r),this.c=s,this.m=a,this.q=h,this.b=!1}dispose(){(0,S.ok)(!this.b),this.b=!0,this.q=!1}equalLines(s){return(0,f.$ub)(this.f,s)}get document(){if(!this.a){const s=this;this.a={get uri(){return s.d},get fileName(){return s.d.fsPath},get isUntitled(){return s.d.scheme===F.Schemas.untitled},get languageId(){return s.m},get version(){return s.h},get isClosed(){return s.b},get isDirty(){return s.q},save(){return s.r()},getText(c){return c?s.s(c):s.getText()},get eol(){return s.g===`
`?g.EndOfLine.LF:g.EndOfLine.CRLF},get lineCount(){return s.f.length},lineAt(c){return s.t(c)},offsetAt(c){return s.u(c)},positionAt(c){return s.v(c)},validateRange(c){return s.w(c)},validatePosition(c){return s.x(c)},getWordRangeAtPosition(c,t){return s.y(c,t)}}}return Object.freeze(this.a)}_acceptLanguageId(s){(0,S.ok)(!this.b),this.m=s}_acceptIsDirty(s){(0,S.ok)(!this.b),this.q=s}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(s){const c=this.w(s);if(c.isEmpty)return"";if(c.isSingleLine)return this.f[c.start.line].substring(c.start.character,c.end.character);const t=this.g,n=c.start.line,r=c.end.line,a=[];a.push(this.f[n].substring(c.start.character));for(let h=n+1;h<r;h++)a.push(this.f[h]);return a.push(this.f[r].substring(0,c.end.character)),a.join(t)}t(s){let c;if(s instanceof g.$3L?c=s.line:typeof s=="number"&&(c=s),typeof c!="number"||c<0||c>=this.f.length||Math.floor(c)!==c)throw new Error("Illegal value for `line`");return new v(c,this.f[c],c===this.f.length-1)}u(s){return s=this.x(s),this.l(),this.j.getPrefixSum(s.line-1)+s.character}v(s){s=Math.floor(s),s=Math.max(0,s),this.l();const c=this.j.getIndexOf(s),t=this.f[c.index].length;return new g.$3L(c.index,Math.min(c.remainder,t))}w(s){if(!(s instanceof g.$4L))throw new Error("Invalid argument");const c=this.x(s.start),t=this.x(s.end);return c===s.start&&t===s.end?s:new g.$4L(c.line,c.character,t.line,t.character)}x(s){if(!(s instanceof g.$3L))throw new Error("Invalid argument");if(this.f.length===0)return s.with(0,0);let{line:c,character:t}=s,n=!1;if(c<0)c=0,t=0,n=!0;else if(c>=this.f.length)c=this.f.length-1,t=this.f[c].length,n=!0;else{const r=this.f[c].length;t<0?(t=0,n=!0):t>r&&(t=r,n=!0)}return n?new g.$3L(c,t):s}y(s,c){const t=this.x(s);if(!c)c=k(this.m);else if((0,P.$8e)(c))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${c.source}' because it matches the empty string.`);const n=(0,R.$Is)(t.character+1,(0,R.$Gs)(c),this.f[t.line],0);if(n)return new g.$4L(t.line,n.startColumn-1,t.line,n.endColumn-1)}}e.$hO=l;class v{constructor(s,c,t){this.a=s,this.b=c,this.c=t}get lineNumber(){return this.a}get text(){return this.b}get range(){return new g.$4L(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new g.$4L(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$iO=v}),define(Re[243],Ae([1,0,3,7]),function(fe,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tic=void 0;class P{constructor(R){this.a=new Map,this.b=0,this.c=R.getProxy(S.$ZL.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(R,g,f){if(this.a.size===0)throw new Error("No embedding vector providers registered");const D=this.a.get(R);if(!D)throw new Error("Embedding vector provider not found");const M=await D.provideEmbeddingVector(g,f);if(!M)throw new Error("Embedding vector provider returned undefined");return M}registerEmbeddingVectorProvider(R,g,f){const D=this.b;return this.b++,this.a.set(D,f),this.c.$registerAiEmbeddingVectorProvider(g,D),new F.$2L(()=>{this.c.$unregisterAiEmbeddingVectorProvider(D),this.a.delete(D)})}}e.$Tic=P}),define(Re[63],Ae([1,0,3,42,7,24,4,17,43,6,11,25,12]),function(fe,e,S,F,P,L,R,g,f,D,M,k,l){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.$8hc=e.$7hc=void 0;let $=v=class{constructor(c,t){this.b=new Map,this.c=new M.$nh,this.a=c.getProxy(S.$ZL.MainThreadFileSystem);const n=this;this.value=Object.freeze({async stat(r){try{let a;const h=n.b.get(r.scheme);return h?(await n.a.$ensureActivation(r.scheme),a=await h.impl.stat(r)):a=await n.a.$stat(r),{type:a.type,ctime:a.ctime,mtime:a.mtime,size:a.size,permissions:a.permissions===F.FilePermission.Readonly?1:void 0}}catch(a){v.e(a)}},async readDirectory(r){try{const a=n.b.get(r.scheme);return a?(await n.a.$ensureActivation(r.scheme),(await a.impl.readDirectory(r)).slice()):await n.a.$readdir(r)}catch(a){return v.e(a)}},async createDirectory(r){try{const a=n.b.get(r.scheme);return a&&!a.isReadonly?(await n.a.$ensureActivation(r.scheme),await n.d(a.impl,a.extUri,r)):await n.a.$mkdir(r)}catch(a){return v.e(a)}},async readFile(r){try{const a=n.b.get(r.scheme);return a?(await n.a.$ensureActivation(r.scheme),(await a.impl.readFile(r)).slice()):(await n.a.$readFile(r)).buffer}catch(a){return v.e(a)}},async writeFile(r,a){try{const h=n.b.get(r.scheme);return h&&!h.isReadonly?(await n.a.$ensureActivation(r.scheme),await n.d(h.impl,h.extUri,h.extUri.dirname(r)),await n.c.queueFor(r,()=>Promise.resolve(h.impl.writeFile(r,a,{create:!0,overwrite:!0})))):await n.a.$writeFile(r,L.$se.wrap(a))}catch(h){return v.e(h)}},async delete(r,a){try{const h=n.b.get(r.scheme);return h&&!h.isReadonly&&!a?.useTrash?(await n.a.$ensureActivation(r.scheme),await h.impl.delete(r,{recursive:!1,...a})):await n.a.$delete(r,{recursive:!1,useTrash:!1,atomic:!1,...a})}catch(h){return v.e(h)}},async rename(r,a,h){try{return await n.a.$rename(r,a,{overwrite:!1,...h})}catch(i){return v.e(i)}},async copy(r,a,h){try{return await n.a.$copy(r,a,{overwrite:!1,...h})}catch(i){return v.e(i)}},isWritableFileSystem(r){const a=t.getCapabilities(r);if(typeof a=="number")return!(a&2048)}})}async d(c,t,n){const r=[];for(;!t.isEqual(n,t.dirname(n));)try{if(!((await c.stat(n)).type&F.FileType.Directory))throw P.$eN.FileExists(`Unable to create folder '${n.scheme===l.Schemas.file?n.fsPath:n.toString(!0)}' that already exists but is not a directory`);break}catch(a){if(F.$Rk(a)!==F.FileSystemProviderErrorCode.FileNotFound)throw a;r.push(t.basename(n)),n=t.dirname(n)}for(let a=r.length-1;a>=0;a--){n=t.joinPath(n,r[a]);try{await c.createDirectory(n)}catch(h){if(F.$Rk(h)!==F.FileSystemProviderErrorCode.FileExists)throw h}}}static e(c){if(c instanceof P.$eN)throw c;if(c instanceof F.$Nk)switch(c.code){case F.FileSystemProviderErrorCode.FileExists:throw P.$eN.FileExists(c.message);case F.FileSystemProviderErrorCode.FileNotFound:throw P.$eN.FileNotFound(c.message);case F.FileSystemProviderErrorCode.FileNotADirectory:throw P.$eN.FileNotADirectory(c.message);case F.FileSystemProviderErrorCode.FileIsADirectory:throw P.$eN.FileIsADirectory(c.message);case F.FileSystemProviderErrorCode.NoPermissions:throw P.$eN.NoPermissions(c.message);case F.FileSystemProviderErrorCode.Unavailable:throw P.$eN.Unavailable(c.message);default:throw new P.$eN(c.message,c.name)}if(!(c instanceof Error))throw new P.$eN(String(c));if(c.name==="ENOPRO"||c.message.includes("ENOPRO"))throw P.$eN.Unavailable(c.message);switch(c.name){case F.FileSystemProviderErrorCode.FileExists:throw P.$eN.FileExists(c.message);case F.FileSystemProviderErrorCode.FileNotFound:throw P.$eN.FileNotFound(c.message);case F.FileSystemProviderErrorCode.FileNotADirectory:throw P.$eN.FileNotADirectory(c.message);case F.FileSystemProviderErrorCode.FileIsADirectory:throw P.$eN.FileIsADirectory(c.message);case F.FileSystemProviderErrorCode.NoPermissions:throw P.$eN.NoPermissions(c.message);case F.FileSystemProviderErrorCode.Unavailable:throw P.$eN.Unavailable(c.message);default:throw new P.$eN(c.message,c.name)}}addFileSystemProvider(c,t,n){return this.b.set(c,{impl:t,extUri:n?.isCaseSensitive?k.$Hg:k.$Jg,isReadonly:!!n?.isReadonly}),(0,D.$Rc)(()=>this.b.delete(c))}getFileSystemProviderExtUri(c){return this.b.get(c)?.extUri??k.$Hg}};e.$7hc=$,e.$7hc=$=v=Ze([qe(0,g.$eO),qe(1,f.$Jhc)],$),e.$8hc=(0,R.$ei)("IExtHostConsumerFileSystem")}),define(Re[244],Ae([1,0,3,7]),function(fe,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$ic=void 0;class P{constructor(R){this.a=new Map,this.b=new Map,this.c=R.getProxy(S.$ZL.MainThreadIssueReporter)}async $getIssueReporterUri(R,g){if(this.a.size===0)throw new Error("No issue request handlers registered");const f=this.a.get(R);if(!f)throw new Error("Issue request handler not found");const D=await f.handleIssueUrlRequest();if(!D)throw new Error("Issue request handler returned no result");return D}async $getIssueReporterData(R,g){if(this.b.size===0)throw new Error("No issue request handlers registered");const f=this.b.get(R);if(!f)throw new Error("Issue data provider not found");const D=await f.provideIssueData(g);if(!D)throw new Error("Issue data provider returned no result");return D}async $getIssueReporterTemplate(R,g){if(this.b.size===0)throw new Error("No issue request handlers registered");const f=this.b.get(R);if(!f)throw new Error("Issue data provider not found");const D=await f.provideIssueTemplate(g);if(!D)throw new Error("Issue template provider returned no result");return D}registerIssueUriRequestHandler(R,g){const f=R.identifier.value;return this.a.set(f,g),this.c.$registerIssueUriRequestHandler(f),new F.$2L(()=>{this.c.$unregisterIssueUriRequestHandler(f),this.a.delete(f)})}registerIssueDataProvider(R,g){const f=R.identifier.value;return this.b.set(f,g),this.c.$registerIssueDataProvider(f),new F.$2L(()=>{this.c.$unregisterIssueDataProvider(f),this.b.delete(f)})}}e.$$ic=P}),define(Re[84],Ae([1,0,4,27,14,63,2]),function(fe,e,S,F,P,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0hc=e.$9hc=void 0,e.$9hc=(0,S.$ei)("IExtensionStoragePaths");let g=class{constructor(D,M,k){this.d=M,this.f=k,this.a=D.workspace??void 0,this.b=D.environment,this.whenReady=this.h().then(l=>this.c=l)}async g(D){return R.URI.joinPath(this.b.workspaceStorageHome,D)}async h(){if(!this.a)return Promise.resolve(void 0);const D=this.a.id,M=await this.g(D);try{return await this.f.value.stat(M),this.d.trace("[ExtHostStorage] storage dir already exists",M),M}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",M),await this.f.value.createDirectory(M),await this.f.value.writeFile(R.URI.joinPath(M,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:R.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),M}catch(k){this.d.error("[ExtHostStorage]",k);return}}workspaceValue(D){if(this.c)return R.URI.joinPath(this.c,D.identifier.value)}globalValue(D){return R.URI.joinPath(this.b.globalStorageHome,D.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$0hc=g,e.$0hc=g=Ze([qe(0,F.$uO),qe(1,P.$yj),qe(2,L.$8hc)],g)}),define(Re[245],Ae([1,0,7,17,5]),function(fe,e,S,F,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bjc=void 0;let L=class{constructor(g){this.a=new S.$oN(S.ColorThemeKind.Dark),this.b=new P.$5d}get activeColorTheme(){return this.a}$onColorThemeChange(g){let f;switch(g){case"light":f=S.ColorThemeKind.Light;break;case"hcDark":f=S.ColorThemeKind.HighContrast;break;case"hcLight":f=S.ColorThemeKind.HighContrastLight;break;default:f=S.ColorThemeKind.Dark}this.a=new S.$oN(f),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$Bjc=L,e.$Bjc=L=Ze([qe(0,F.$eO)],L)}),define(Re[85],Ae([1,0,22,5,6,169,4,14,198,3,27,17,7]),function(fe,e,S,F,P,L,R,g,f,D,M,k,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qAb=e.$pAb=e.TunnelDtoConverter=void 0;class v extends f.$Vv{}var $;(function(c){function t(r){return{remoteAddress:r.remoteAddress,localAddress:r.localAddress,public:!!r.public,privacy:r.privacy??(r.public?f.TunnelPrivacyId.Public:f.TunnelPrivacyId.Private),protocol:r.protocol}}c.fromApiTunnel=t;function n(r){return{remoteAddress:{host:r.tunnelRemoteHost,port:r.tunnelRemotePort},localAddress:r.localAddress,public:r.privacy!==f.TunnelPrivacyId.ConstantPrivate&&r.privacy!==f.TunnelPrivacyId.ConstantPrivate,privacy:r.privacy,protocol:r.protocol}}c.fromServiceTunnel=n})($||(e.TunnelDtoConverter=$={})),e.$pAb=(0,R.$ei)("IExtHostTunnelService");let s=class extends P.$Tc{constructor(t,n,r){super(),this.s=r,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new F.$5d,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=t.getProxy(D.$ZL.MainThreadTunnelService)}async openTunnel(t,n){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${t.identifier.value} called openTunnel API for ${n.remoteAddress.host}:${n.remoteAddress.port}.`);const r=await this.a.$openTunnel(n,t.displayName);if(r){const a=new v(r.remoteAddress,r.localAddress,()=>this.a.$closeTunnel(r.remoteAddress));return this.B(a),a}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(t,n){const r=this.u();return this.r.set(r,{selector:t,provider:n}),this.a.$registerPortsAttributesProvider(t,r),new l.$2L(()=>{this.r.delete(r),this.a.$unregisterPortsAttributesProvider(r)})}async $providePortAttributes(t,n,r,a,h){const i=[];for(const u of t){const o=this.r.get(u);if(!o)return[];i.push(...await Promise.all(n.map(async E=>{let w;try{w=await o.provider.providePortAttributes({port:E,pid:r,commandLine:a},h)}catch{w=await o.provider.providePortAttributes(E,r,a,h)}return{providedAttributes:w,port:E}})))}const p=i.filter(u=>!!u.providedAttributes);return p.length>0?p.map(u=>({autoForwardAction:u.providedAttributes.autoForwardAction,port:u.port})):[]}async $registerCandidateFinder(t){}registerTunnelProvider(t,n){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(a,h)=>await t.provideTunnel(a,h,new S.$ce().token)??void 0;const r=n.tunnelFeatures?{elevation:!!n.tunnelFeatures?.elevation,privacyOptions:n.tunnelFeatures?.privacyOptions,protocol:n.tunnelFeatures.protocol===void 0?!0:n.tunnelFeatures.protocol}:void 0;return this.a.$setTunnelProvider(r),Promise.resolve((0,P.$Rc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(t,n){if(t){t.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(t.candidatePortSource),t.showCandidatePort&&(this.f=t.showCandidatePort,this.a.$setCandidateFilter());const r=t.tunnelFactory??(n?this.w(n):void 0);if(r){this.b=r;let a=t.tunnelFeatures?.privacyOptions??[];t.tunnelFeatures?.public&&a.length===0&&(a=[{id:"private",label:L.localize(0,null),themeIcon:"lock"},{id:"public",label:L.localize(1,null),themeIcon:"eye"}]);const h=t.tunnelFeatures?{elevation:!!t.tunnelFeatures?.elevation,public:!!t.tunnelFeatures?.public,privacyOptions:a,protocol:!0}:void 0;this.a.$setTunnelProvider(h)}}else this.b=void 0;return(0,P.$Rc)(()=>{this.b=void 0})}w(t){}async $closeTunnel(t,n){if(this.g.has(t.host)){const r=this.g.get(t.host);r.has(t.port)&&(n&&r.get(t.port).disposeListener.dispose(),await r.get(t.port).tunnel.dispose(),r.delete(t.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(t,n){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const r=this.b(t,n);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),r!==void 0){const a=await r;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),a===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(t.remoteAddress.host)||this.g.set(t.remoteAddress.host,new Map);const h=this.B(a.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(a.remoteAddress))));return this.g.get(t.remoteAddress.host).set(t.remoteAddress.port,{tunnel:a,disposeListener:h}),$.fromApiTunnel(a)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(r){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),r instanceof Error)return r.message}}async $applyCandidateFilter(t){const n=await Promise.all(t.map(a=>this.f(a.host,a.port,a.detail??""))),r=t.filter((a,h)=>n[h]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${t.map(a=>a.port).join(", ")} to ${r.map(a=>a.port).join(", ")}`),r}};e.$qAb=s,e.$qAb=s=Ze([qe(0,k.$eO),qe(1,M.$uO),qe(2,g.$yj)],s)}),define(Re[8],Ae([1,0,18,24,128,246,53,28,121,52,69,26,25,16,2,29,86,98,103,102,83,48,60,217,23,7]),function(fe,e,S,F,P,L,R,g,f,D,M,k,l,v,$,s,c,t,n,r,a,h,i,p,u,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DebugTreeItem=e.TerminalQuickFix=e.ChatAgentUserActionEvent=e.ChatAgentResult=e.ChatAgentCompletionItem=e.ChatAgentResolvedVariable=e.ChatAgentRequest=e.ChatResponseProgress=e.ChatResponsePart=e.ChatResponseReferencePart=e.ChatResponseCommandButtonPart=e.ChatResponseProgressPart=e.ChatResponseAnchorPart=e.ChatResponseFilesPart=e.ChatResponseMarkdownPart=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.LanguageModelMessage=e.ChatInlineFollowup=e.ChatFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.$dO=e.$cO=e.MarkdownString=e.$bO=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Location=e.Range=e.Selection=void 0;var E;(function(be){function Fe(Z){const{selectionStartLineNumber:Ee,selectionStartColumn:Ne,positionLineNumber:Qe,positionColumn:Ge}=Z,at=new o.$3L(Ee-1,Ne-1),yt=new o.$3L(Qe-1,Ge-1);return new o.$5L(at,yt)}be.to=Fe;function ae(Z){const{anchor:Ee,active:Ne}=Z;return{selectionStartLineNumber:Ee.line+1,selectionStartColumn:Ee.character+1,positionLineNumber:Ne.line+1,positionColumn:Ne.character+1}}be.from=ae})(E||(e.Selection=E={}));var w;(function(be){function Fe(Z){if(!Z)return;const{start:Ee,end:Ne}=Z;return{startLineNumber:Ee.line+1,startColumn:Ee.character+1,endLineNumber:Ne.line+1,endColumn:Ne.character+1}}be.from=Fe;function ae(Z){if(!Z)return;const{startLineNumber:Ee,startColumn:Ne,endLineNumber:Qe,endColumn:Ge}=Z;return new o.$4L(Ee-1,Ne-1,Qe-1,Ge-1)}be.to=ae})(w||(e.Range=w={}));var m;(function(be){function Fe(Z){return{uri:Z.uri,range:w.from(Z.range)}}be.from=Fe;function ae(Z){return new o.$bM($.URI.revive(Z.uri),w.to(Z.range))}be.to=ae})(m||(e.Location=m={}));var I;(function(be){function Fe(ae){switch(ae){case 1:return o.StandardTokenType.Comment;case 0:return o.StandardTokenType.Other;case 3:return o.StandardTokenType.RegEx;case 2:return o.StandardTokenType.String}}be.to=Fe})(I||(e.TokenType=I={}));var d;(function(be){function Fe(Z){return new o.$3L(Z.lineNumber-1,Z.column-1)}be.to=Fe;function ae(Z){return{lineNumber:Z.line+1,column:Z.character+1}}be.from=ae})(d||(e.Position=d={}));var y;(function(be){function Fe(Ee,Ne,Qe){return(0,S.$Hb)((0,S.$3b)(Ee).map(Ge=>ae(Ge,Ne,Qe)))}be.from=Fe;function ae(Ee,Ne,Qe){if(typeof Ee=="string")return{$serialized:!0,language:Ee,isBuiltin:Qe?.isBuiltin};if(Ee)return{$serialized:!0,language:Ee.language,scheme:Z(Ee.scheme,Ne),pattern:X.from(Ee.pattern)??void 0,exclusive:Ee.exclusive,notebookType:Ee.notebookType,isBuiltin:Qe?.isBuiltin}}function Z(Ee,Ne){return Ne&&typeof Ee=="string"?Ne.transformOutgoingScheme(Ee):Ee}})(y||(e.DocumentSelector=y={}));var b;(function(be){function Fe(Z){switch(Z){case o.DiagnosticTag.Unnecessary:return 1;case o.DiagnosticTag.Deprecated:return 2}}be.from=Fe;function ae(Z){switch(Z){case 1:return o.DiagnosticTag.Unnecessary;case 2:return o.DiagnosticTag.Deprecated;default:return}}be.to=ae})(b||(e.DiagnosticTag=b={}));var A;(function(be){function Fe(Z){let Ee;return Z.code&&((0,v.$Sf)(Z.code)||(0,v.$Wf)(Z.code)?Ee=String(Z.code):Ee={value:String(Z.code.value),target:Z.code.target}),{...w.from(Z.range),message:Z.message,source:Z.source,code:Ee,severity:G.from(Z.severity),relatedInformation:Z.relatedInformation&&Z.relatedInformation.map(T.from),tags:Array.isArray(Z.tags)?(0,S.$Hb)(Z.tags.map(b.from)):void 0}}be.from=Fe;function ae(Z){const Ee=new o.$dM(w.to(Z),Z.message,G.to(Z.severity));return Ee.source=Z.source,Ee.code=(0,v.$Sf)(Z.code)?Z.code:Z.code?.value,Ee.relatedInformation=Z.relatedInformation&&Z.relatedInformation.map(T.to),Ee.tags=Z.tags&&(0,S.$Hb)(Z.tags.map(b.to)),Ee}be.to=ae})(A||(e.Diagnostic=A={}));var T;(function(be){function Fe(Z){return{...w.from(Z.location.range),message:Z.message,resource:Z.location.uri}}be.from=Fe;function ae(Z){return new o.$cM(new o.$bM(Z.resource,w.to(Z)),Z.message)}be.to=ae})(T||(e.DiagnosticRelatedInformation=T={}));var G;(function(be){function Fe(Z){switch(Z){case o.DiagnosticSeverity.Error:return t.MarkerSeverity.Error;case o.DiagnosticSeverity.Warning:return t.MarkerSeverity.Warning;case o.DiagnosticSeverity.Information:return t.MarkerSeverity.Info;case o.DiagnosticSeverity.Hint:return t.MarkerSeverity.Hint}return t.MarkerSeverity.Error}be.from=Fe;function ae(Z){switch(Z){case t.MarkerSeverity.Info:return o.DiagnosticSeverity.Information;case t.MarkerSeverity.Warning:return o.DiagnosticSeverity.Warning;case t.MarkerSeverity.Error:return o.DiagnosticSeverity.Error;case t.MarkerSeverity.Hint:return o.DiagnosticSeverity.Hint;default:return o.DiagnosticSeverity.Error}}be.to=ae})(G||(e.DiagnosticSeverity=G={}));var W;(function(be){function Fe(Z){return typeof Z=="number"&&Z>=o.ViewColumn.One?Z-1:Z===o.ViewColumn.Beside?p.$qD:p.$pD}be.from=Fe;function ae(Z){if(typeof Z=="number"&&Z>=0)return Z+1;throw new Error("invalid 'EditorGroupColumn'")}be.to=ae})(W||(e.ViewColumn=W={}));function U(be){return typeof be.range<"u"}function C(be){return be.length===0?!0:!!U(be[0])}e.$bO=C;var O;(function(be){function Fe(Ge){return Ge.map(be.from)}be.fromMany=Fe;function ae(Ge){return Ge&&typeof Ge=="object"&&typeof Ge.language=="string"&&typeof Ge.value=="string"}function Z(Ge){let at;if(ae(Ge)){const{language:At,value:Zt}=Ge;at={value:"```"+At+`
`+Zt+"\n```\n"}}else o.$qM.isMarkdownString(Ge)?at={value:Ge.value,isTrusted:Ge.isTrusted,supportThemeIcons:Ge.supportThemeIcons,supportHtml:Ge.supportHtml,baseUri:Ge.baseUri}:typeof Ge=="string"?at={value:Ge}:at={value:""};const yt=Object.create(null);at.uris=yt;const Wt=At=>{try{let Zt=$.URI.parse(At,!0);Zt=Zt.with({query:Ee(Zt.query,yt)}),yt[At]=Zt}catch{}return""},Et=new f.marked.Renderer;return Et.link=Wt,Et.image=At=>typeof At=="string"?Wt(R.$Ak(At).href):"",(0,f.marked)(at.value,{renderer:Et}),at}be.from=Z;function Ee(Ge,at){if(!Ge)return Ge;let yt;try{yt=(0,D.$Mh)(Ge)}catch{}if(!yt)return Ge;let Wt=!1;return yt=(0,k.$Jn)(yt,Et=>{if($.URI.isUri(Et)){const At=`__uri_${Math.random().toString(16).slice(2,8)}`;return at[At]=Et,Wt=!0,At}else return}),Wt?JSON.stringify(yt):Ge}function Ne(Ge){const at=new o.$qM(Ge.value,Ge.supportThemeIcons);return at.isTrusted=Ge.isTrusted,at.supportHtml=Ge.supportHtml,at.baseUri=Ge.baseUri?$.URI.from(Ge.baseUri):void 0,at}be.to=Ne;function Qe(Ge){if(Ge)return typeof Ge=="string"?Ge:be.from(Ge)}be.fromStrict=Qe})(O||(e.MarkdownString=O={}));function V(be){return C(be)?be.map(Fe=>({range:w.from(Fe.range),hoverMessage:Array.isArray(Fe.hoverMessage)?O.fromMany(Fe.hoverMessage):Fe.hoverMessage?O.from(Fe.hoverMessage):void 0,renderOptions:Fe.renderOptions})):be.map(Fe=>({range:w.from(Fe)}))}e.$cO=V;function re(be){return typeof be>"u"?be:typeof be=="string"?$.URI.file(be):be}e.$dO=re;var ue;(function(be){function Fe(ae){return typeof ae>"u"?ae:{contentText:ae.contentText,contentIconPath:ae.contentIconPath?re(ae.contentIconPath):void 0,border:ae.border,borderColor:ae.borderColor,fontStyle:ae.fontStyle,fontWeight:ae.fontWeight,textDecoration:ae.textDecoration,color:ae.color,backgroundColor:ae.backgroundColor,margin:ae.margin,width:ae.width,height:ae.height}}be.from=Fe})(ue||(e.ThemableDecorationAttachmentRenderOptions=ue={}));var ye;(function(be){function Fe(ae){return typeof ae>"u"?ae:{backgroundColor:ae.backgroundColor,outline:ae.outline,outlineColor:ae.outlineColor,outlineStyle:ae.outlineStyle,outlineWidth:ae.outlineWidth,border:ae.border,borderColor:ae.borderColor,borderRadius:ae.borderRadius,borderSpacing:ae.borderSpacing,borderStyle:ae.borderStyle,borderWidth:ae.borderWidth,fontStyle:ae.fontStyle,fontWeight:ae.fontWeight,textDecoration:ae.textDecoration,cursor:ae.cursor,color:ae.color,opacity:ae.opacity,letterSpacing:ae.letterSpacing,gutterIconPath:ae.gutterIconPath?re(ae.gutterIconPath):void 0,gutterIconSize:ae.gutterIconSize,overviewRulerColor:ae.overviewRulerColor,before:ae.before?ue.from(ae.before):void 0,after:ae.after?ue.from(ae.after):void 0}}be.from=Fe})(ye||(e.ThemableDecorationRenderOptions=ye={}));var De;(function(be){function Fe(ae){if(typeof ae>"u")return ae;switch(ae){case o.DecorationRangeBehavior.OpenOpen:return 0;case o.DecorationRangeBehavior.ClosedClosed:return 1;case o.DecorationRangeBehavior.OpenClosed:return 2;case o.DecorationRangeBehavior.ClosedOpen:return 3}}be.from=Fe})(De||(e.DecorationRangeBehavior=De={}));var he;(function(be){function Fe(ae){return{isWholeLine:ae.isWholeLine,rangeBehavior:ae.rangeBehavior?De.from(ae.rangeBehavior):void 0,overviewRulerLane:ae.overviewRulerLane,light:ae.light?ye.from(ae.light):void 0,dark:ae.dark?ye.from(ae.dark):void 0,backgroundColor:ae.backgroundColor,outline:ae.outline,outlineColor:ae.outlineColor,outlineStyle:ae.outlineStyle,outlineWidth:ae.outlineWidth,border:ae.border,borderColor:ae.borderColor,borderRadius:ae.borderRadius,borderSpacing:ae.borderSpacing,borderStyle:ae.borderStyle,borderWidth:ae.borderWidth,fontStyle:ae.fontStyle,fontWeight:ae.fontWeight,textDecoration:ae.textDecoration,cursor:ae.cursor,color:ae.color,opacity:ae.opacity,letterSpacing:ae.letterSpacing,gutterIconPath:ae.gutterIconPath?re(ae.gutterIconPath):void 0,gutterIconSize:ae.gutterIconSize,overviewRulerColor:ae.overviewRulerColor,before:ae.before?ue.from(ae.before):void 0,after:ae.after?ue.from(ae.after):void 0}}be.from=Fe})(he||(e.DecorationRenderOptions=he={}));var ve;(function(be){function Fe(Z){return{text:Z.newText,eol:Z.newEol&&it.from(Z.newEol),range:w.from(Z.range)}}be.from=Fe;function ae(Z){const Ee=new o.$9L(w.to(Z.range),Z.text);return Ee.newEol=typeof Z.eol>"u"?void 0:it.to(Z.eol),Ee}be.to=ae})(ve||(e.TextEdit=ve={}));var se;(function(be){function Fe(Z,Ee){const Ne={edits:[]};if(Z instanceof o.$_L){const Qe=new g.$Bc;for(const Ge of Z._allEntries())Ge._type===1&&$.URI.isUri(Ge.to)&&Ge.from===void 0&&Qe.add(Ge.to);for(const Ge of Z._allEntries())if(Ge._type===1){let at;Ge.options?.contents&&(ArrayBuffer.isView(Ge.options.contents)?at={type:"base64",value:(0,F.$Me)(F.$se.wrap(Ge.options.contents))}:at={type:"dataTransferItem",id:Ge.options.contents._itemId}),Ne.edits.push({oldResource:Ge.from,newResource:Ge.to,options:{...Ge.options,contents:at},metadata:Ge.metadata})}else Ge._type===2?Ne.edits.push({resource:Ge.uri,textEdit:ve.from(Ge.edit),versionId:Qe.has(Ge.uri)?void 0:Ee?.getTextDocumentVersion(Ge.uri),metadata:Ge.metadata}):Ge._type===6?Ne.edits.push({resource:Ge.uri,textEdit:{range:w.from(Ge.range),text:Ge.edit.value,insertAsSnippet:!0},versionId:Qe.has(Ge.uri)?void 0:Ee?.getTextDocumentVersion(Ge.uri),metadata:Ge.metadata}):Ge._type===3?Ne.edits.push({metadata:Ge.metadata,resource:Ge.uri,cellEdit:Ge.edit,notebookMetadata:Ge.notebookMetadata,notebookVersionId:Ee?.getNotebookDocumentVersion(Ge.uri)}):Ge._type===5&&Ne.edits.push({metadata:Ge.metadata,resource:Ge.uri,notebookVersionId:Ee?.getNotebookDocumentVersion(Ge.uri),cellEdit:{editType:1,index:Ge.index,count:Ge.count,cells:Ge.cells.map(Tt.from)}})}return Ne}be.from=Fe;function ae(Z){const Ee=new o.$_L,Ne=new g.$Ac;for(const Qe of Z.edits)if(Qe.textEdit){const Ge=Qe,at=$.URI.revive(Ge.resource),yt=w.to(Ge.textEdit.range),Wt=Ge.textEdit.text,Et=Ge.textEdit.insertAsSnippet;let At;Et?At=o.$$L.replace(yt,new o.$aM(Wt)):At=o.$9L.replace(yt,Wt);const Zt=Ne.get(at);Zt?Zt.push(At):Ne.set(at,[At])}else Ee.renameFile($.URI.revive(Qe.oldResource),$.URI.revive(Qe.newResource),Qe.options);for(const[Qe,Ge]of Ne)Ee.set(Qe,Ge);return Ee}be.to=ae})(se||(e.WorkspaceEdit=se={}));var $e;(function(be){const Fe=Object.create(null);Fe[o.SymbolKind.File]=0,Fe[o.SymbolKind.Module]=1,Fe[o.SymbolKind.Namespace]=2,Fe[o.SymbolKind.Package]=3,Fe[o.SymbolKind.Class]=4,Fe[o.SymbolKind.Method]=5,Fe[o.SymbolKind.Property]=6,Fe[o.SymbolKind.Field]=7,Fe[o.SymbolKind.Constructor]=8,Fe[o.SymbolKind.Enum]=9,Fe[o.SymbolKind.Interface]=10,Fe[o.SymbolKind.Function]=11,Fe[o.SymbolKind.Variable]=12,Fe[o.SymbolKind.Constant]=13,Fe[o.SymbolKind.String]=14,Fe[o.SymbolKind.Number]=15,Fe[o.SymbolKind.Boolean]=16,Fe[o.SymbolKind.Array]=17,Fe[o.SymbolKind.Object]=18,Fe[o.SymbolKind.Key]=19,Fe[o.SymbolKind.Null]=20,Fe[o.SymbolKind.EnumMember]=21,Fe[o.SymbolKind.Struct]=22,Fe[o.SymbolKind.Event]=23,Fe[o.SymbolKind.Operator]=24,Fe[o.SymbolKind.TypeParameter]=25;function ae(Ee){return typeof Fe[Ee]=="number"?Fe[Ee]:6}be.from=ae;function Z(Ee){for(const Ne in Fe)if(Fe[Ne]===Ee)return Number(Ne);return o.SymbolKind.Property}be.to=Z})($e||(e.SymbolKind=$e={}));var ee;(function(be){function Fe(Z){switch(Z){case o.SymbolTag.Deprecated:return 1}}be.from=Fe;function ae(Z){switch(Z){case 1:return o.SymbolTag.Deprecated}}be.to=ae})(ee||(e.SymbolTag=ee={}));var Q;(function(be){function Fe(Z){return{name:Z.name,kind:$e.from(Z.kind),tags:Z.tags&&Z.tags.map(ee.from),containerName:Z.containerName,location:Ce.from(Z.location)}}be.from=Fe;function ae(Z){const Ee=new o.$hM(Z.name,$e.to(Z.kind),Z.containerName,Ce.to(Z.location));return Ee.tags=Z.tags&&Z.tags.map(ee.to),Ee}be.to=ae})(Q||(e.WorkspaceSymbol=Q={}));var q;(function(be){function Fe(Z){const Ee={name:Z.name||"!!MISSING: name!!",detail:Z.detail,range:w.from(Z.range),selectionRange:w.from(Z.selectionRange),kind:$e.from(Z.kind),tags:Z.tags?.map(ee.from)??[]};return Z.children&&(Ee.children=Z.children.map(Fe)),Ee}be.from=Fe;function ae(Z){const Ee=new o.$iM(Z.name,Z.detail,$e.to(Z.kind),w.to(Z.range),w.to(Z.selectionRange));return(0,S.$Lb)(Z.tags)&&(Ee.tags=Z.tags.map(ee.to)),Z.children&&(Ee.children=Z.children.map(ae)),Ee}be.to=ae})(q||(e.DocumentSymbol=q={}));var ne;(function(be){function Fe(Z){const Ee=new o.$mM($e.to(Z.kind),Z.name,Z.detail||"",$.URI.revive(Z.uri),w.to(Z.range),w.to(Z.selectionRange));return Ee._sessionId=Z._sessionId,Ee._itemId=Z._itemId,Ee}be.to=Fe;function ae(Z,Ee,Ne){if(Ee=Ee??Z._sessionId,Ne=Ne??Z._itemId,Ee===void 0||Ne===void 0)throw new Error("invalid item");return{_sessionId:Ee,_itemId:Ne,name:Z.name,detail:Z.detail,kind:$e.from(Z.kind),uri:Z.uri,range:w.from(Z.range),selectionRange:w.from(Z.selectionRange),tags:Z.tags?.map(ee.from)}}be.from=ae})(ne||(e.CallHierarchyItem=ne={}));var Se;(function(be){function Fe(ae){return new o.$nM(ne.to(ae.from),ae.fromRanges.map(Z=>w.to(Z)))}be.to=Fe})(Se||(e.CallHierarchyIncomingCall=Se={}));var Te;(function(be){function Fe(ae){return new o.$oM(ne.to(ae.to),ae.fromRanges.map(Z=>w.to(Z)))}be.to=Fe})(Te||(e.CallHierarchyOutgoingCall=Te={}));var Ce;(function(be){function Fe(Z){return{range:Z.range&&w.from(Z.range),uri:Z.uri}}be.from=Fe;function ae(Z){return new o.$bM($.URI.revive(Z.uri),w.to(Z.range))}be.to=ae})(Ce||(e.location=Ce={}));var we;(function(be){function Fe(Z){const Ee=Z,Ne=Z;return{originSelectionRange:Ee.originSelectionRange?w.from(Ee.originSelectionRange):void 0,uri:Ee.targetUri?Ee.targetUri:Ne.uri,range:w.from(Ee.targetRange?Ee.targetRange:Ne.range),targetSelectionRange:Ee.targetSelectionRange?w.from(Ee.targetSelectionRange):void 0}}be.from=Fe;function ae(Z){return{targetUri:$.URI.revive(Z.uri),targetRange:w.to(Z.range),targetSelectionRange:Z.targetSelectionRange?w.to(Z.targetSelectionRange):void 0,originSelectionRange:Z.originSelectionRange?w.to(Z.originSelectionRange):void 0}}be.to=ae})(we||(e.DefinitionLink=we={}));var ge;(function(be){function Fe(Z){return{range:w.from(Z.range),contents:O.fromMany(Z.contents)}}be.from=Fe;function ae(Z){return new o.$eM(Z.contents.map(O.to),w.to(Z.range))}be.to=ae})(ge||(e.Hover=ge={}));var J;(function(be){function Fe(Z){return{range:w.from(Z.range),expression:Z.expression}}be.from=Fe;function ae(Z){return new o.$$M(w.to(Z.range),Z.expression)}be.to=ae})(J||(e.EvaluatableExpression=J={}));var x;(function(be){function Fe(Z){if(Z instanceof o.$_M)return{type:"text",range:w.from(Z.range),text:Z.text};if(Z instanceof o.$aN)return{type:"variable",range:w.from(Z.range),variableName:Z.variableName,caseSensitiveLookup:Z.caseSensitiveLookup};if(Z instanceof o.$bN)return{type:"expression",range:w.from(Z.range),expression:Z.expression};throw new Error("Unknown 'InlineValue' type")}be.from=Fe;function ae(Z){switch(Z.type){case"text":return{range:w.to(Z.range),text:Z.text};case"variable":return{range:w.to(Z.range),variableName:Z.variableName,caseSensitiveLookup:Z.caseSensitiveLookup};case"expression":return{range:w.to(Z.range),expression:Z.expression}}}be.to=ae})(x||(e.InlineValue=x={}));var le;(function(be){function Fe(Z){return{frameId:Z.frameId,stoppedLocation:w.from(Z.stoppedLocation)}}be.from=Fe;function ae(Z){return new o.$cN(Z.frameId,w.to(Z.stoppedLocation))}be.to=ae})(le||(e.InlineValueContext=le={}));var de;(function(be){function Fe(Z){return{range:w.from(Z.range),kind:Z.kind}}be.from=Fe;function ae(Z){return new o.$fM(w.to(Z.range),Z.kind)}be.to=ae})(de||(e.DocumentHighlight=de={}));var Pe;(function(be){function Fe(Z){return{uri:Z.uri,highlights:Z.highlights.map(de.from)}}be.from=Fe;function ae(Z){return new o.$gM($.URI.revive(Z.uri),Z.highlights.map(de.to))}be.to=ae})(Pe||(e.MultiDocumentHighlight=Pe={}));var me;(function(be){function Fe(ae){switch(ae){case 1:return o.CompletionTriggerKind.TriggerCharacter;case 2:return o.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return o.CompletionTriggerKind.Invoke}}be.to=Fe})(me||(e.CompletionTriggerKind=me={}));var Ie;(function(be){function Fe(ae){return{triggerKind:me.to(ae.triggerKind),triggerCharacter:ae.triggerCharacter}}be.to=Fe})(Ie||(e.CompletionContext=Ie={}));var Me;(function(be){function Fe(Z){switch(Z){case o.CompletionItemTag.Deprecated:return 1}}be.from=Fe;function ae(Z){switch(Z){case 1:return o.CompletionItemTag.Deprecated}}be.to=ae})(Me||(e.CompletionItemTag=Me={}));var ze;(function(be){const Fe=new Map([[o.CompletionItemKind.Method,0],[o.CompletionItemKind.Function,1],[o.CompletionItemKind.Constructor,2],[o.CompletionItemKind.Field,3],[o.CompletionItemKind.Variable,4],[o.CompletionItemKind.Class,5],[o.CompletionItemKind.Interface,7],[o.CompletionItemKind.Struct,6],[o.CompletionItemKind.Module,8],[o.CompletionItemKind.Property,9],[o.CompletionItemKind.Unit,12],[o.CompletionItemKind.Value,13],[o.CompletionItemKind.Constant,14],[o.CompletionItemKind.Enum,15],[o.CompletionItemKind.EnumMember,16],[o.CompletionItemKind.Keyword,17],[o.CompletionItemKind.Snippet,27],[o.CompletionItemKind.Text,18],[o.CompletionItemKind.Color,19],[o.CompletionItemKind.File,20],[o.CompletionItemKind.Reference,21],[o.CompletionItemKind.Folder,23],[o.CompletionItemKind.Event,10],[o.CompletionItemKind.Operator,11],[o.CompletionItemKind.TypeParameter,24],[o.CompletionItemKind.Issue,26],[o.CompletionItemKind.User,25]]);function ae(Ne){return Fe.get(Ne)??9}be.from=ae;const Z=new Map([[0,o.CompletionItemKind.Method],[1,o.CompletionItemKind.Function],[2,o.CompletionItemKind.Constructor],[3,o.CompletionItemKind.Field],[4,o.CompletionItemKind.Variable],[5,o.CompletionItemKind.Class],[7,o.CompletionItemKind.Interface],[6,o.CompletionItemKind.Struct],[8,o.CompletionItemKind.Module],[9,o.CompletionItemKind.Property],[12,o.CompletionItemKind.Unit],[13,o.CompletionItemKind.Value],[14,o.CompletionItemKind.Constant],[15,o.CompletionItemKind.Enum],[16,o.CompletionItemKind.EnumMember],[17,o.CompletionItemKind.Keyword],[27,o.CompletionItemKind.Snippet],[18,o.CompletionItemKind.Text],[19,o.CompletionItemKind.Color],[20,o.CompletionItemKind.File],[21,o.CompletionItemKind.Reference],[23,o.CompletionItemKind.Folder],[10,o.CompletionItemKind.Event],[11,o.CompletionItemKind.Operator],[24,o.CompletionItemKind.TypeParameter],[25,o.CompletionItemKind.User],[26,o.CompletionItemKind.Issue]]);function Ee(Ne){return Z.get(Ne)??o.CompletionItemKind.Property}be.to=Ee})(ze||(e.CompletionItemKind=ze={}));var N;(function(be){function Fe(ae,Z){const Ee=new o.$wM(ae.label);return Ee.insertText=ae.insertText,Ee.kind=ze.to(ae.kind),Ee.tags=ae.tags?.map(Me.to),Ee.detail=ae.detail,Ee.documentation=R.$uk(ae.documentation)?O.to(ae.documentation):ae.documentation,Ee.sortText=ae.sortText,Ee.filterText=ae.filterText,Ee.preselect=ae.preselect,Ee.commitCharacters=ae.commitCharacters,s.$6s.isIRange(ae.range)?Ee.range=w.to(ae.range):typeof ae.range=="object"&&(Ee.range={inserting:w.to(ae.range.insert),replacing:w.to(ae.range.replace)}),Ee.keepWhitespace=typeof ae.insertTextRules>"u"?!1:!!(ae.insertTextRules&1),typeof ae.insertTextRules<"u"&&ae.insertTextRules&4?Ee.insertText=new o.$aM(ae.insertText):(Ee.insertText=ae.insertText,Ee.textEdit=Ee.range instanceof o.$4L?new o.$9L(Ee.range,Ee.insertText):void 0),ae.additionalTextEdits&&ae.additionalTextEdits.length>0&&(Ee.additionalTextEdits=ae.additionalTextEdits.map(Ne=>ve.to(Ne))),Ee.command=Z&&ae.command?Z.fromInternal(ae.command):void 0,Ee}be.to=Fe})(N||(e.CompletionItem=N={}));var z;(function(be){function Fe(Z){if(typeof Z.label!="string"&&!Array.isArray(Z.label))throw new TypeError("Invalid label");return{label:Z.label,documentation:O.fromStrict(Z.documentation)}}be.from=Fe;function ae(Z){return{label:Z.label,documentation:R.$uk(Z.documentation)?O.to(Z.documentation):Z.documentation}}be.to=ae})(z||(e.ParameterInformation=z={}));var K;(function(be){function Fe(Z){return{label:Z.label,documentation:O.fromStrict(Z.documentation),parameters:Array.isArray(Z.parameters)?Z.parameters.map(z.from):[],activeParameter:Z.activeParameter}}be.from=Fe;function ae(Z){return{label:Z.label,documentation:R.$uk(Z.documentation)?O.to(Z.documentation):Z.documentation,parameters:Array.isArray(Z.parameters)?Z.parameters.map(z.to):[],activeParameter:Z.activeParameter}}be.to=ae})(K||(e.SignatureInformation=K={}));var H;(function(be){function Fe(Z){return{activeSignature:Z.activeSignature,activeParameter:Z.activeParameter,signatures:Array.isArray(Z.signatures)?Z.signatures.map(K.from):[]}}be.from=Fe;function ae(Z){return{activeSignature:Z.activeSignature,activeParameter:Z.activeParameter,signatures:Array.isArray(Z.signatures)?Z.signatures.map(K.to):[]}}be.to=ae})(H||(e.SignatureHelp=H={}));var te;(function(be){function Fe(ae,Z){const Ee=new o.$vM(d.to(Z.position),typeof Z.label=="string"?Z.label:Z.label.map(oe.to.bind(void 0,ae)),Z.kind&&Oe.to(Z.kind));return Ee.textEdits=Z.textEdits&&Z.textEdits.map(ve.to),Ee.tooltip=R.$uk(Z.tooltip)?O.to(Z.tooltip):Z.tooltip,Ee.paddingLeft=Z.paddingLeft,Ee.paddingRight=Z.paddingRight,Ee}be.to=Fe})(te||(e.InlayHint=te={}));var oe;(function(be){function Fe(ae,Z){const Ee=new o.$uM(Z.label);return Ee.tooltip=R.$uk(Z.tooltip)?O.to(Z.tooltip):Z.tooltip,c.Command.is(Z.command)&&(Ee.command=ae.fromInternal(Z.command)),Z.location&&(Ee.location=Ce.to(Z.location)),Ee}be.to=Fe})(oe||(e.InlayHintLabelPart=oe={}));var Oe;(function(be){function Fe(Z){return Z}be.from=Fe;function ae(Z){return Z}be.to=ae})(Oe||(e.InlayHintKind=Oe={}));var Ve;(function(be){function Fe(Z){return{range:w.from(Z.range),url:Z.target,tooltip:Z.tooltip}}be.from=Fe;function ae(Z){let Ee;if(Z.url)try{Ee=typeof Z.url=="string"?$.URI.parse(Z.url,!0):$.URI.revive(Z.url)}catch{}return new o.$BM(w.to(Z.range),Ee)}be.to=ae})(Ve||(e.DocumentLink=Ve={}));var He;(function(be){function Fe(Z){const Ee=new o.$EM(Z.label);return Z.textEdit&&(Ee.textEdit=ve.to(Z.textEdit)),Z.additionalTextEdits&&(Ee.additionalTextEdits=Z.additionalTextEdits.map(Ne=>ve.to(Ne))),Ee}be.to=Fe;function ae(Z){return{label:Z.label,textEdit:Z.textEdit?ve.from(Z.textEdit):void 0,additionalTextEdits:Z.additionalTextEdits?Z.additionalTextEdits.map(Ee=>ve.from(Ee)):void 0}}be.from=ae})(He||(e.ColorPresentation=He={}));var xe;(function(be){function Fe(Z){return new o.$CM(Z[0],Z[1],Z[2],Z[3])}be.to=Fe;function ae(Z){return[Z.red,Z.green,Z.blue,Z.alpha]}be.from=ae})(xe||(e.Color=xe={}));var tt;(function(be){function Fe(Z){return{range:w.from(Z.range)}}be.from=Fe;function ae(Z){return new o.$lM(w.to(Z.range))}be.to=ae})(tt||(e.SelectionRange=tt={}));var lt;(function(be){function Fe(ae){switch(ae){case 2:return o.TextDocumentSaveReason.AfterDelay;case 1:return o.TextDocumentSaveReason.Manual;case 3:case 4:return o.TextDocumentSaveReason.FocusOut}}be.to=Fe})(lt||(e.TextDocumentSaveReason=lt={}));var rt;(function(be){function Fe(Z){switch(Z){case o.TextEditorLineNumbersStyle.Off:return 0;case o.TextEditorLineNumbersStyle.Relative:return 2;case o.TextEditorLineNumbersStyle.Interval:return 3;case o.TextEditorLineNumbersStyle.On:default:return 1}}be.from=Fe;function ae(Z){switch(Z){case 0:return o.TextEditorLineNumbersStyle.Off;case 2:return o.TextEditorLineNumbersStyle.Relative;case 3:return o.TextEditorLineNumbersStyle.Interval;case 1:default:return o.TextEditorLineNumbersStyle.On}}be.to=ae})(rt||(e.TextEditorLineNumbersStyle=rt={}));var it;(function(be){function Fe(Z){if(Z===o.EndOfLine.CRLF)return 1;if(Z===o.EndOfLine.LF)return 0}be.from=Fe;function ae(Z){if(Z===1)return o.EndOfLine.CRLF;if(Z===0)return o.EndOfLine.LF}be.to=ae})(it||(e.EndOfLine=it={}));var ot;(function(be){function Fe(ae){if(typeof ae=="object")return ae.viewId;switch(ae){case o.ProgressLocation.SourceControl:return 3;case o.ProgressLocation.Window:return 10;case o.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}be.from=Fe})(ot||(e.ProgressLocation=ot={}));var Be;(function(be){function Fe(Z){const Ee={start:Z.start+1,end:Z.end+1};return Z.kind&&(Ee.kind=et.from(Z.kind)),Ee}be.from=Fe;function ae(Z){const Ee={start:Z.start-1,end:Z.end-1};return Z.kind&&(Ee.kind=et.to(Z.kind)),Ee}be.to=ae})(Be||(e.FoldingRange=Be={}));var et;(function(be){function Fe(Z){if(Z)switch(Z){case o.FoldingRangeKind.Comment:return c.$Wt.Comment;case o.FoldingRangeKind.Imports:return c.$Wt.Imports;case o.FoldingRangeKind.Region:return c.$Wt.Region}}be.from=Fe;function ae(Z){if(Z)switch(Z.value){case c.$Wt.Comment.value:return o.FoldingRangeKind.Comment;case c.$Wt.Imports.value:return o.FoldingRangeKind.Imports;case c.$Wt.Region.value:return o.FoldingRangeKind.Region}}be.to=ae})(et||(e.FoldingRangeKind=et={}));var Y;(function(be){function Fe(ae){if(ae)return{pinned:typeof ae.preview=="boolean"?!ae.preview:void 0,inactive:ae.background,preserveFocus:ae.preserveFocus,selection:typeof ae.selection=="object"?w.from(ae.selection):void 0,override:typeof ae.override=="boolean"?r.$SE.id:void 0}}be.from=Fe})(Y||(e.TextEditorOpenOptions=Y={}));var X;(function(be){function Fe(Ne){return Ne instanceof o.$YM?Ne.toJSON():typeof Ne=="string"?Ne:ae(Ne)||Z(Ne)?new o.$YM(Ne.baseUri??Ne.base,Ne.pattern).toJSON():Ne}be.from=Fe;function ae(Ne){const Qe=Ne;return Qe?$.URI.isUri(Qe.baseUri)&&typeof Qe.pattern=="string":!1}function Z(Ne){const Qe=Ne;return Qe?typeof Qe.base=="string"&&typeof Qe.pattern=="string":!1}function Ee(Ne){return typeof Ne=="string"?Ne:new o.$YM($.URI.revive(Ne.baseUri),Ne.pattern)}be.to=Ee})(X||(e.GlobPattern=X={}));var pe;(function(be){function Fe(ae){if(ae){if(Array.isArray(ae))return ae.map(Fe);if(typeof ae=="string")return ae;{const Z=ae;return{language:Z.language,scheme:Z.scheme,pattern:X.from(Z.pattern),exclusive:Z.exclusive,notebookType:Z.notebookType}}}else return}be.from=Fe})(pe||(e.LanguageSelector=pe={}));var We;(function(be){function Fe(Z){return!!Z&&typeof Z=="object"&&"documents"in Z&&Array.isArray(Z.documents)&&Z.documents.every(Ee=>Array.isArray(Ee)&&Ee.every(Ne=>Ne&&typeof Ne=="object"&&"uri"in Ne&&$.URI.isUri(Ne.uri)&&"version"in Ne&&typeof Ne.version=="number"&&"ranges"in Ne&&Array.isArray(Ne.ranges)&&Ne.ranges.every(Qe=>Qe instanceof o.$4L)))}be.is=Fe;function ae(Z){return{documents:Z.documents.map(Ee=>Ee.map(Ne=>({uri:$.URI.from(Ne.uri),version:Ne.version,ranges:Ne.ranges.map(Qe=>w.from(Qe))})))}}be.from=ae})(We||(e.MappedEditsContext=We={}));var Xe;(function(be){function Fe(Z){return{start:Z.start,end:Z.end}}be.from=Fe;function ae(Z){return new o.$pN(Z.start,Z.end)}be.to=ae})(Xe||(e.NotebookRange=Xe={}));var st;(function(be){function Fe(Z){return{timing:typeof Z.runStartTime=="number"&&typeof Z.runEndTime=="number"?{startTime:Z.runStartTime,endTime:Z.runEndTime}:void 0,executionOrder:Z.executionOrder,success:Z.lastRunSuccess}}be.to=Fe;function ae(Z){return{lastRunSuccess:Z.success,runStartTime:Z.timing?.startTime,runEndTime:Z.timing?.endTime,executionOrder:Z.executionOrder}}be.from=ae})(st||(e.NotebookCellExecutionSummary=st={}));var Le;(function(be){function Fe(ae){if(ae===a.NotebookCellExecutionState.Unconfirmed)return o.NotebookCellExecutionState.Pending;if(ae===a.NotebookCellExecutionState.Pending)return;if(ae===a.NotebookCellExecutionState.Executing)return o.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${ae}`)}be.to=Fe})(Le||(e.NotebookCellExecutionState=Le={}));var Dt;(function(be){function Fe(Z){switch(Z){case o.NotebookCellKind.Markup:return a.CellKind.Markup;case o.NotebookCellKind.Code:default:return a.CellKind.Code}}be.from=Fe;function ae(Z){switch(Z){case a.CellKind.Markup:return o.NotebookCellKind.Markup;case a.CellKind.Code:default:return o.NotebookCellKind.Code}}be.to=ae})(Dt||(e.NotebookCellKind=Dt={}));var Ht;(function(be){function Fe(Z){const Ee={metadata:Z.metadata??Object.create(null),cells:[]};for(const Ne of Z.cells)o.$qN.validate(Ne),Ee.cells.push(Tt.from(Ne));return Ee}be.from=Fe;function ae(Z){const Ee=new o.$rN(Z.cells.map(Tt.to));return(0,v.$6f)(Z.metadata)||(Ee.metadata=Z.metadata),Ee}be.to=ae})(Ht||(e.NotebookData=Ht={}));var Tt;(function(be){function Fe(Z){return{cellKind:Dt.from(Z.kind),language:Z.languageId,mime:Z.mime,source:Z.value,metadata:Z.metadata,internalMetadata:st.from(Z.executionSummary??{}),outputs:Z.outputs?Z.outputs.map(Xt.from):[]}}be.from=Fe;function ae(Z){return new o.$qN(Dt.to(Z.cellKind),Z.source,Z.language,Z.mime,Z.outputs?Z.outputs.map(Xt.to):void 0,Z.metadata,Z.internalMetadata?st.to(Z.internalMetadata):void 0)}be.to=ae})(Tt||(e.NotebookCellData=Tt={}));var Qt;(function(be){function Fe(Z){return{mime:Z.mime,valueBytes:F.$se.wrap(Z.data)}}be.from=Fe;function ae(Z){return new o.$sN(Z.valueBytes.buffer,Z.mime)}be.to=ae})(Qt||(e.NotebookCellOutputItem=Qt={}));var Xt;(function(be){function Fe(Z){return{outputId:Z.id,items:Z.items.map(Qt.from),metadata:Z.metadata}}be.from=Fe;function ae(Z){const Ee=Z.items.map(Qt.to);return new o.$tN(Ee,Z.outputId,Z.metadata)}be.to=ae})(Xt||(e.NotebookCellOutput=Xt={}));var It;(function(be){function Fe(Ee){return Z(Ee)?{include:X.from(Ee.include)??void 0,exclude:X.from(Ee.exclude)??void 0}:X.from(Ee)??void 0}be.from=Fe;function ae(Ee){return Z(Ee)?{include:X.to(Ee.include),exclude:X.to(Ee.exclude)}:X.to(Ee)}be.to=ae;function Z(Ee){const Ne=Ee;return Ne?!(0,v.$2f)(Ne.include)&&!(0,v.$2f)(Ne.exclude):!1}})(It||(e.NotebookExclusiveDocumentPattern=It={}));var Kt;(function(be){function Fe(ae,Z,Ee){const Ne=typeof ae.command=="string"?{title:"",command:ae.command}:ae.command;return{alignment:ae.alignment===o.NotebookCellStatusBarAlignment.Left?1:2,command:Z.toInternal(Ne,Ee),text:ae.text,tooltip:ae.tooltip,accessibilityInformation:ae.accessibilityInformation,priority:ae.priority}}be.from=Fe})(Kt||(e.NotebookStatusBarItem=Kt={}));var Gt;(function(be){function Fe(ae,Z,Ee){const Ne=typeof ae.command=="string"?{title:"",command:ae.command}:ae.command;return{command:Z.toInternal(Ne,Ee),label:ae.label,description:ae.description,detail:ae.detail,documentation:ae.documentation}}be.from=Fe})(Gt||(e.NotebookKernelSourceAction=Gt={}));var xt;(function(be){function Fe(ae){return{transientOutputs:ae?.transientOutputs??!1,transientCellMetadata:ae?.transientCellMetadata??{},transientDocumentMetadata:ae?.transientDocumentMetadata??{},cellContentMetadata:ae?.cellContentMetadata??{}}}be.from=Fe})(xt||(e.NotebookDocumentContentOptions=xt={}));var ii;(function(be){function Fe(Z){return{uri:Z.uri,provides:Z.provides}}be.from=Fe;function ae(Z){return new o.$vN($.URI.revive(Z.uri),Z.provides)}be.to=ae})(ii||(e.NotebookRendererScript=ii={}));var Ye;(function(be){function Fe(Z){return{message:O.fromStrict(Z.message)||"",type:0,expected:Z.expectedOutput,actual:Z.actualOutput,contextValue:Z.contextValue,location:Z.location&&{range:w.from(Z.location.range),uri:Z.location.uri}}}be.from=Fe;function ae(Z){const Ee=new o.$BN(typeof Z.message=="string"?Z.message:O.to(Z.message));return Ee.actualOutput=Z.actual,Ee.expectedOutput=Z.expected,Ee.contextValue=Z.contextValue,Ee.location=Z.location?Ce.to(Z.location):void 0,Ee}be.to=ae})(Ye||(e.TestMessage=Ye={}));var Nt;(function(be){be.namespace=i.$UK,be.denamespace=i.$VK})(Nt||(e.TestTag=Nt={}));var _t;(function(be){function Fe(Z){const Ee=(0,n.$aO)(Z).controllerId;return{extId:h.$QK.fromExtHostTestItem(Z,Ee).toString(),label:Z.label,uri:$.URI.revive(Z.uri),busy:Z.busy,tags:Z.tags.map(Ne=>Nt.namespace(Ee,Ne.id)),range:s.$6s.lift(w.from(Z.range)),description:Z.description||null,sortText:Z.sortText||null,error:Z.error&&O.fromStrict(Z.error)||null}}be.from=Fe;function ae(Z){return{parent:void 0,error:void 0,id:h.$QK.fromString(Z.extId).localId,label:Z.label,uri:$.URI.revive(Z.uri),tags:(Z.tags||[]).map(Ee=>{const{tagId:Ne}=Nt.denamespace(Ee);return new o.$CN(Ne)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:w.to(Z.range||void 0),canResolveChildren:!1,busy:Z.busy,description:Z.description||void 0,sortText:Z.sortText||void 0}}be.toPlain=ae})(_t||(e.TestItem=_t={})),function(be){function Fe(Z){return{id:Z.id}}be.from=Fe;function ae(Z){return new o.$CN(Z.id)}be.to=ae}(Nt||(e.TestTag=Nt={}));var ft;(function(be){const Fe=(Z,Ee)=>{const Ne=[];for(const[Ge,at]of Ee)h.$QK.compare(at.item.extId,Ge)===2&&(Ee.delete(Ge),Ne.push(at));const Qe={..._t.toPlain(Z.item),parent:void 0,taskStates:Z.tasks.map(Ge=>({state:Ge.state,duration:Ge.duration,messages:Ge.messages.filter(at=>at.type===0).map(Ye.to)})),children:Ne.map(Ge=>Fe(Ge,Ee))};for(const Ge of Qe.children)Ge.parent=Qe;return Qe};function ae(Z){const Ee=[],Ne=new Map;for(const Qe of Z.items){Ne.set(Qe.item.extId,Qe);const Ge=h.$QK.root(Qe.item.extId);Z.request.targets.some(at=>at.controllerId===Ge&&at.testIds.includes(Qe.item.extId))&&Ee.push(Qe)}return{completedAt:Z.completedAt,results:Ee.map(Qe=>Fe(Qe,Ne))}}be.to=ae})(ft||(e.TestResults=ft={}));var vt;(function(be){function Fe(Ne){return{covered:Ne.covered,total:Ne.total}}function ae(Ne){return"line"in Ne?d.from(Ne):w.from(Ne)}function Z(Ne){return"branches"in Ne?{count:Ne.executed,location:ae(Ne.location),type:1,branches:Ne.branches.length?Ne.branches.map(Qe=>({count:Qe.executed,location:Qe.location&&ae(Qe.location),label:Qe.label})):void 0}:{type:0,name:Ne.name,count:Ne.executed,location:ae(Ne.location)}}be.fromDetailed=Z;function Ee(Ne){return{uri:Ne.uri,statement:Fe(Ne.statementCoverage),branch:Ne.branchCoverage&&Fe(Ne.branchCoverage),declaration:Ne.declarationCoverage&&Fe(Ne.declarationCoverage),details:Ne.detailedCoverage?.map(Z)}}be.fromFile=Ee})(vt||(e.TestCoverage=vt={}));var ei;(function(be){function Fe(ae){switch(ae){case 1:return o.CodeActionTriggerKind.Invoke;case 2:return o.CodeActionTriggerKind.Automatic}}be.to=Fe})(ei||(e.CodeActionTriggerKind=ei={}));var Bt;(function(be){function Fe(Z){const Ee=new o.$IN($e.to(Z.kind),Z.name,Z.detail||"",$.URI.revive(Z.uri),w.to(Z.range),w.to(Z.selectionRange));return Ee._sessionId=Z._sessionId,Ee._itemId=Z._itemId,Ee}be.to=Fe;function ae(Z,Ee,Ne){if(Ee=Ee??Z._sessionId,Ne=Ne??Z._itemId,Ee===void 0||Ne===void 0)throw new Error("invalid item");return{_sessionId:Ee,_itemId:Ne,kind:$e.from(Z.kind),name:Z.name,detail:Z.detail??"",uri:Z.uri,range:w.from(Z.range),selectionRange:w.from(Z.selectionRange),tags:Z.tags?.map(ee.from)}}be.from=ae})(Bt||(e.TypeHierarchyItem=Bt={}));var jt;(function(be){function Fe(ae){if(ae)return{value:ae.value,tooltip:ae.tooltip}}be.from=Fe})(jt||(e.ViewBadge=jt={}));var dt;(function(be){function Fe(Ne,Qe,Ge){const at=Qe.fileData;return at?new o.$RM(new o.$SM(at.name,$.URI.revive(at.uri),at.id,(0,L.$db)(()=>Ge(at.id)))):Ne===M.$qs.uriList&&Qe.uriListData?new o.$QM(Ee(Qe.uriListData)):new o.$QM(Qe.asString)}be.to=Fe;async function ae(Ne,Qe){const Ge=await Qe.asString();if(Ne===M.$qs.uriList)return{asString:Ge,fileData:void 0,uriListData:Z(Ge)};const at=Qe.asFile();return{asString:Ge,fileData:at?{name:at.name,uri:at.uri,id:at._itemId??at.id}:void 0}}be.from=ae;function Z(Ne){return P.$Ct.split(Ne).map(Qe=>{if(Qe.startsWith("#"))return Qe;try{return $.URI.parse(Qe)}catch{}return Qe})}function Ee(Ne){return P.$Ct.create(Ne.map(Qe=>typeof Qe=="string"?Qe:$.URI.revive(Qe)))}})(dt||(e.DataTransferItem=dt={}));var Rt;(function(be){function Fe(Z,Ee){const Ne=Z.items.map(([Qe,Ge])=>[Qe,dt.to(Qe,Ge,Ee)]);return new o.$TM(Ne)}be.toDataTransfer=Fe;async function ae(Z){const Ee={items:[]},Ne=[];for(const[Qe,Ge]of Z)Ne.push((async()=>{Ee.items.push([Qe,await dt.from(Qe,Ge)])})());return await Promise.all(Ne),Ee}be.from=ae})(Rt||(e.DataTransfer=Rt={}));var ti;(function(be){function Fe(Z,Ee){return{kind:"reply",agentId:Z.participant??Ee?.agentId??"",subCommand:Z.command??Ee?.command,message:Z.prompt,title:Z.label}}be.from=Fe;function ae(Z){return{prompt:Z.message,label:Z.title,participant:Z.agentId,command:Z.subCommand}}be.to=ae})(ti||(e.ChatFollowup=ti={}));var Yt;(function(be){function Fe(ae){return"commandId"in ae?{kind:"command",title:ae.title??"",commandId:ae.commandId??"",when:ae.when??"",args:ae.args}:{kind:"reply",message:ae.message,title:ae.title,tooltip:ae.tooltip}}be.from=Fe})(Yt||(e.ChatInlineFollowup=Yt={}));var Ke;(function(be){function Fe(Z){switch(Z.role){case 0:return new o.$3N(Z.content);case 1:return new o.$4N(Z.content);case 2:return new o.$5N(Z.content)}}be.to=Fe;function ae(Z){if(Z instanceof o.$3N)return{role:0,content:Z.content};if(Z instanceof o.$4N)return{role:1,content:Z.content};if(Z instanceof o.$5N)return{role:2,content:Z.content};throw new Error("Invalid LanguageModelMessage")}be.from=ae})(Ke||(e.LanguageModelMessage=Ke={}));var Ft;(function(be){function Fe(Ee){const Ne={};for(const Qe of Object.keys(Ee))Ne[Qe]=Ee[Qe].map(be.to);return Ne}be.objectTo=Fe;function ae(Ee){return{level:zt.to(Ee.level),kind:Ee.kind,value:(0,$.$vc)(Ee.value)?$.URI.revive(Ee.value):Ee.value,description:Ee.description}}be.to=ae;function Z(Ee){return{level:zt.from(Ee.level),kind:Ee.kind,value:Ee.value,description:Ee.description}}be.from=Z})(Ft||(e.ChatVariable=Ft={}));var zt;(function(be){function Fe(Z){switch(Z){case"short":return o.ChatVariableLevel.Short;case"medium":return o.ChatVariableLevel.Medium;case"full":default:return o.ChatVariableLevel.Full}}be.to=Fe;function ae(Z){switch(Z){case o.ChatVariableLevel.Short:return"short";case o.ChatVariableLevel.Medium:return"medium";case o.ChatVariableLevel.Full:default:return"full"}}be.from=ae})(zt||(e.ChatVariableLevel=zt={}));var ni;(function(be){function Fe(ae){switch(ae){case 1:return o.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return o.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return o.InteractiveEditorResponseFeedbackKind.Undone;case 3:return o.InteractiveEditorResponseFeedbackKind.Accepted;case 4:return o.InteractiveEditorResponseFeedbackKind.Bug}}be.to=Fe})(ni||(e.InteractiveEditorResponseFeedbackKind=ni={}));var gt;(function(be){function Fe(Z){return{kind:"markdownContent",content:O.from(Z.value)}}be.to=Fe;function ae(Z){return new o.$UN(O.to(Z.content))}be.from=ae})(gt||(e.ChatResponseMarkdownPart=gt={}));var Lt;(function(be){function Fe(Z){const{value:Ee,baseUri:Ne}=Z;function Qe(Ge,at){return Ge.map(yt=>{const Wt=$.URI.joinPath(at,yt.name);return{label:yt.name,uri:Wt,children:yt.children&&Qe(yt.children,Wt)}})}return{kind:"treeData",treeData:{label:(0,l.$Og)(Ne),uri:Ne,children:Qe(Ee,Ne)}}}be.to=Fe;function ae(Z){const Ee=(0,D.$Nh)(Z.treeData);function Ne(at){return at.map(yt=>({name:yt.label,children:yt.children&&Ne(yt.children)}))}const Qe=Ee.uri,Ge=Ee.children?Ne(Ee.children):[];return new o.$VN(Ge,Qe)}be.from=ae})(Lt||(e.ChatResponseFilesPart=Lt={}));var Ct;(function(be){function Fe(Z){return{kind:"inlineReference",name:Z.title,inlineReference:$.URI.isUri(Z.value)?Z.value:m.from(Z.value)}}be.to=Fe;function ae(Z){const Ee=(0,D.$Nh)(Z);return new o.$WN($.URI.isUri(Ee.inlineReference)?Ee.inlineReference:m.to(Ee.inlineReference),Z.name)}be.from=ae})(Ct||(e.ChatResponseAnchorPart=Ct={}));var Ut;(function(be){function Fe(Z){return{kind:"progressMessage",content:O.from(Z.value)}}be.to=Fe;function ae(Z){return new o.$XN(Z.content.value)}be.from=ae})(Ut||(e.ChatResponseProgressPart=Ut={}));var ri;(function(be){function Fe(Z,Ee,Ne){return{kind:"command",command:Ee.toInternal(Z.value,Ne)??{command:Z.value.command,title:Z.value.title}}}be.to=Fe;function ae(Z,Ee){return new o.$YN(Ee.fromInternal(Z.command)??{command:Z.command.id,title:Z.command.title})}be.from=ae})(ri||(e.ChatResponseCommandButtonPart=ri={}));var Ot;(function(be){function Fe(Z){return{kind:"reference",reference:$.URI.isUri(Z.value)?Z.value:m.from(Z.value)}}be.to=Fe;function ae(Z){const Ee=(0,D.$Nh)(Z);return new o.$ZN($.URI.isUri(Ee.reference)?Ee.reference:m.to(Ee.reference))}be.from=ae})(Ot||(e.ChatResponseReferencePart=Ot={}));var Vt;(function(be){function Fe(Ee){return Ee instanceof o.$UN?gt.to(Ee):Ee instanceof o.$WN?Ct.to(Ee):Ee instanceof o.$ZN?Ot.to(Ee):Ee instanceof o.$XN?Ut.to(Ee):Ee instanceof o.$VN?Lt.to(Ee):{kind:"content",content:""}}be.to=Fe;function ae(Ee,Ne){switch(Ee.kind){case"reference":return Ot.from(Ee);case"markdownContent":case"inlineReference":case"progressMessage":case"treeData":case"command":return Z(Ee,Ne)}}be.from=ae;function Z(Ee,Ne){switch(Ee.kind){case"markdownContent":return gt.from(Ee);case"inlineReference":return Ct.from(Ee);case"progressMessage":return;case"treeData":return Lt.from(Ee);case"command":return ri.from(Ee,Ne)}}be.fromContent=Z})(Vt||(e.ChatResponsePart=Vt={}));var Pt;(function(be){function Fe(Ee,Ne){return"markdownContent"in Ne?((0,u.$VF)(Ee,"chatParticipantAdditions"),{content:O.from(Ne.markdownContent),kind:"markdownContent"}):"content"in Ne?"vulnerabilities"in Ne&&Ne.vulnerabilities?((0,u.$VF)(Ee,"chatParticipantAdditions"),{content:Ne.content,vulnerabilities:Ne.vulnerabilities,kind:"vulnerability"}):typeof Ne.content=="string"?{content:Ne.content,kind:"content"}:((0,u.$VF)(Ee,"chatParticipantAdditions"),{content:O.from(Ne.content),kind:"markdownContent"}):"documents"in Ne?{documents:Ne.documents.map(Qe=>({uri:Qe.uri,version:Qe.version,ranges:Qe.ranges.map(Ge=>w.from(Ge))})),kind:"usedContext"}:"reference"in Ne?{reference:"uri"in Ne.reference?{uri:Ne.reference.uri,range:w.from(Ne.reference.range)}:Ne.reference,kind:"reference"}:"inlineReference"in Ne?{inlineReference:"uri"in Ne.inlineReference?{uri:Ne.inlineReference.uri,range:w.from(Ne.inlineReference.range)}:Ne.inlineReference,name:Ne.title,kind:"inlineReference"}:"participant"in Ne?((0,u.$VF)(Ee,"chatParticipantAdditions"),{agentName:Ne.participant,command:Ne.command,kind:"agentDetection"}):"message"in Ne?{content:O.from(Ne.message),kind:"progressMessage"}:void 0}be.from=Fe;function ae(Ee){switch(Ee.kind){case"markdownContent":case"inlineReference":case"treeData":return be.to(Ee);case"content":return{content:Ee.content};case"usedContext":return{documents:Ee.documents.map(Ne=>({uri:$.URI.revive(Ne.uri),version:Ne.version,ranges:Ne.ranges.map(Qe=>w.to(Qe))}))};case"reference":return{reference:(0,$.$vc)(Ee.reference)?$.URI.revive(Ee.reference):m.to(Ee.reference)};case"agentDetection":return;case"progressMessage":return{message:Ee.content.value};case"vulnerability":return{content:Ee.content,vulnerabilities:Ee.vulnerabilities};default:return}}be.to=ae;function Z(Ee,Ne){switch(Ee.kind){case"markdownContent":return{content:Ee.content.value};case"inlineReference":return{inlineReference:(0,$.$vc)(Ee.inlineReference)?$.URI.revive(Ee.inlineReference):m.to(Ee.inlineReference),title:Ee.name};case"command":return{command:Ne.fromInternal(Ee.command)??{command:Ee.command.id,title:Ee.command.title}};default:return}}be.toProgressContent=Z})(Pt||(e.ChatResponseProgress=Pt={}));var kt;(function(be){function Fe(ae){return{prompt:ae.message,command:ae.command,variables:ae.variables.variables.map($t.to)}}be.to=Fe})(kt||(e.ChatAgentRequest=kt={}));var $t;(function(be){function Fe(ae){return{name:ae.name,range:[ae.range.start,ae.range.endExclusive],values:ae.values.map(Ft.to)}}be.to=Fe})($t||(e.ChatAgentResolvedVariable=$t={}));var St;(function(be){function Fe(ae){return{label:ae.label,values:ae.values.map(Ft.from),insertText:ae.insertText,detail:ae.detail,documentation:ae.documentation}}be.from=Fe})(St||(e.ChatAgentCompletionItem=St={}));var wt;(function(be){function Fe(ae){return{errorDetails:ae.errorDetails,metadata:ae.metadata}}be.to=Fe})(wt||(e.ChatAgentResult=wt={}));var li;(function(be){function Fe(ae,Z,Ee){if(Z.action.kind==="vote")return;const Ne=wt.to(ae);return Z.action.kind==="command"?{action:{kind:"command",commandButton:Pt.toProgressContent(Z.action.commandButton,Ee)},result:Ne}:Z.action.kind==="followUp"?{action:{kind:"followUp",followup:ti.to(Z.action.followup)},result:Ne}:{action:Z.action,result:Ne}}be.to=Fe})(li||(e.ChatAgentUserActionEvent=li={}));var Jt;(function(be){function Fe(ae,Z,Ee){return"terminalCommand"in ae?{terminalCommand:ae.terminalCommand,shouldExecute:ae.shouldExecute}:"uri"in ae?{uri:ae.uri}:Z.toInternal(ae,Ee)}be.from=Fe})(Jt||(e.TerminalQuickFix=Jt={}));var $i;(function(be){function Fe(ae,Z){return{id:Z,label:ae.label,description:ae.description,canEdit:ae.canEdit,collapsibleState:ae.collapsibleState||0,contextValue:ae.contextValue}}be.from=Fe})($i||(e.DebugTreeItem=$i={}))}),define(Re[247],Ae([1,0,3,17,8]),function(fe,e,S,F,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qhc=void 0;let L=class{constructor(g,f){this.a=g.getProxy(S.$ZL.MainThreadBulkEdits),this.b={getTextDocumentVersion:D=>f.getDocument(D)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(g,f,D){const M=P.WorkspaceEdit.from(g,this.b);return this.a.$tryApplyWorkspaceEdit(M,void 0,D?.isRefactoring??!1)}};e.$Qhc=L,e.$Qhc=L=Ze([qe(0,F.$eO)],L)}),define(Re[248],Ae([1,0,18,11,34,5,51,6,64,16,2,158,20,3,8,7,207,23]),function(fe,e,S,F,P,L,R,g,f,D,M,k,l,v,$,s,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Shc=void 0;class n{constructor(i,p,u,o,E,w){this.j=i,this.k=p,this.l=u,this.m=o,this.n=E,this.o=w,this.b=f.$1d.create(!1),this.d=!1}close(){this.d=!0}get timings(){return{firstProgress:this.g,totalElapsed:this.b.elapsed()}}get apiObject(){if(!this.i){let p=function(o){if(i.d){const E=new Error("Response stream has been closed");throw Error.captureStackTrace(E,o),E}};const i=this;this.b.reset();const u=o=>{typeof this.g>"u"&&"content"in o&&(this.g=this.b.elapsed()),this.l.$handleProgressChunk(this.k.requestId,o)};this.i={markdown(o){p(this.markdown);const E=new s.$UN(o),w=$.ChatResponseMarkdownPart.to(E);return u(w),this},filetree(o,E){p(this.filetree);const w=new s.$VN(o,E),m=$.ChatResponseFilesPart.to(w);return u(m),this},anchor(o,E){p(this.anchor);const w=new s.$WN(o,E),m=$.ChatResponseAnchorPart.to(w);return u(m),this},button(o){p(this.anchor);const E=new s.$YN(o),w=$.ChatResponseCommandButtonPart.to(E,i.n,i.o);return u(w),this},progress(o){p(this.progress);const E=new s.$XN(o),w=$.ChatResponseProgressPart.to(E);return u(w),this},reference(o){p(this.reference);const E=new s.$ZN(o),w=$.ChatResponseReferencePart.to(E);return u(w),this},push(o){p(this.push);const E=$.ChatResponsePart.to(o);return u(E),this},report(o){if(p(this.report),"placeholder"in o&&"resolvedContent"in o)return;const E=$.ChatResponseProgress.from(i.j,o);if(!E){i.m.error("Unknown progress type: "+JSON.stringify(o));return}return u(E),this}}}return this.i}}class r{static{this.b=0}constructor(i,p,u){this.j=p,this.k=u,this.d=new Map,this.i=new g.$3c,this.g=i.getProxy(v.$ZL.MainThreadChatAgents2)}createChatAgent(i,p,u){const o=r.b++,E=new a(i,p,this.g,o,u);return this.d.set(o,E),this.g.$registerAgent(o,i.identifier,p,{}),E.apiAgent}async $invokeAgent(i,p,u,o){const E=this.d.get(i);if(!E)throw new Error(`[CHAT](${i}) CANNOT invoke agent because the agent is not registered`);let w=this.i.get(p.sessionId);w||(w=new g.$Sc,this.i.set(p.sessionId,w));const m=new n(E.extension,p,this.g,this.j,this.k.converter,w);try{const I=await this.l(p.agentId,u),d=E.invoke($.ChatAgentRequest.to(p),{history:I},m.apiObject,o);return await(0,F.$5g)(Promise.resolve(d).then(y=>{if(y?.metadata)try{JSON.stringify(y.metadata)}catch(b){const A=`result.metadata MUST be JSON.stringify-able. Got error: ${b.message}`;return this.j.error(`[${E.extension.identifier.value}] [@${E.id}] ${A}`,E.extension),{errorDetails:{message:A},timings:m.timings}}return{errorDetails:y?.errorDetails,timings:m.timings,metadata:y?.metadata}}),o)}catch(I){return this.j.error(I,E.extension),{errorDetails:{message:(0,k.localize)(0,null,(0,P.$2i)(I)),responseIsIncomplete:!0}}}finally{m.close()}}async l(i,p){const u=[];for(const o of p.history){const E=$.ChatAgentResult.to(o.result),w=i===o.request.agentId?E:{...E,metadata:void 0};u.push(new s.$1N(o.request.message,o.request.command,o.request.variables.variables.map($.ChatAgentResolvedVariable.to),{extensionId:"",name:o.request.agentId}));const m=(0,S.$Hb)(o.response.map(I=>$.ChatResponsePart.fromContent(I,this.k.converter)));u.push(new s.$2N(m,w,{extensionId:"",name:o.request.agentId},o.request.command))}return u}$releaseSession(i){this.i.deleteAndDispose(i)}async $provideSlashCommands(i,p,u){const o=this.d.get(i);if(!o)return[];const E=await this.l(o.id,p);try{return await o.provideSlashCommands({history:E},u)}catch(w){const m=(0,P.$2i)(w);return this.j.error(`[${o.extension.identifier.value}] [@${o.id}] Error while providing slash commands: ${m}`),[]}}async $provideFollowups(i,p,u,o){const E=this.d.get(p);if(!E)return Promise.resolve([]);const w=$.ChatAgentResult.to(u);return(await E.provideFollowups(w,o)).filter(m=>{const I=!m.participant||R.Iterable.some(this.d.values(),d=>d.id===m.participant&&l.$wm.equals(d.extension.identifier,E.extension.identifier));return I||this.j.warn(`[@${E.id}] ChatFollowup refers to an invalid participant: ${m.participant}`),I}).map(m=>$.ChatFollowup.from(m,i))}$acceptFeedback(i,p,u,o){const E=this.d.get(i);if(!E)return;const w=$.ChatAgentResult.to(p);let m;switch(u){case c.InteractiveSessionVoteDirection.Down:m=s.ChatResultFeedbackKind.Unhelpful;break;case c.InteractiveSessionVoteDirection.Up:m=s.ChatResultFeedbackKind.Helpful;break}E.acceptFeedback(Object.freeze(o?{result:w,kind:m,reportIssue:o}:{result:w,kind:m}))}$acceptAction(i,p,u){const o=this.d.get(i);if(!o||u.action.kind==="vote")return;const E=$.ChatAgentUserActionEvent.to(p,u,this.k.converter);E&&o.acceptAction(Object.freeze(E))}async $invokeCompletionProvider(i,p,u){const o=this.d.get(i);return o?(await o.invokeCompletionProvider(p,u)).map($.ChatAgentCompletionItem.from):[]}async $provideWelcomeMessage(i,p){const u=this.d.get(i);if(u)return await u.provideWelcomeMessage(p)}async $provideSampleQuestions(i,p){const u=this.d.get(i);if(u)return(await u.provideSampleQuestions(p)).map(o=>$.ChatFollowup.from(o,void 0))}}e.$Shc=r;class a{constructor(i,p,u,o,E){this.extension=i,this.id=p,this.y=u,this.z=o,this.A=E,this.q=new L.$5d,this.s=new L.$5d}acceptFeedback(i){this.q.fire(i)}acceptAction(i){this.s.fire(i)}async invokeCompletionProvider(i,p){return this.u?await this.u.provider.provideCompletionItems(i,p)??[]:[]}async provideSlashCommands(i,p){if(!this.b)return[];const u=await this.b.provideCommands(i,p);return u?u.map(o=>("isSticky2"in o&&(0,t.$VF)(this.extension,"chatParticipantAdditions"),{name:o.name,description:o.description??"",followupPlaceholder:o.isSticky2?.placeholder,isSticky:o.isSticky2?.isSticky??o.isSticky,sampleRequest:o.sampleRequest})):[]}async provideFollowups(i,p){if(!this.d)return[];const u=await this.d.provideFollowups(i,p);return u?u.filter(o=>!(o&&"commandId"in o)).filter(o=>!(o&&"message"in o)):[]}async provideWelcomeMessage(i){if(!this.w)return[];const p=await this.w.provideWelcomeMessage(i);return p?p.map(u=>typeof u=="string"?u:$.MarkdownString.from(u)):[]}async provideSampleQuestions(i){if(!this.w||!this.w.provideSampleQuestions)return[];const p=await this.w.provideSampleQuestions(i);return p||[]}get apiAgent(){let i=!1,p=!1;const u=()=>{i||p||(p=!0,queueMicrotask(()=>{this.y.$updateAgent(this.z,{description:this.g??"",fullName:this.i,icon:this.j?this.j instanceof M.URI?this.j:"light"in this.j?this.j.light:void 0:void 0,iconDark:this.j&&"dark"in this.j?this.j.dark:void 0,themeIcon:this.j instanceof s.$WM?this.j:void 0,hasSlashCommands:this.b!==void 0,hasFollowups:this.d!==void 0,isDefault:this.k,isSecondary:this.p,helpTextPrefix:!this.l||typeof this.l=="string"?this.l:$.MarkdownString.from(this.l),helpTextVariablesPrefix:!this.m||typeof this.m=="string"?this.m:$.MarkdownString.from(this.m),helpTextPostfix:!this.n||typeof this.n=="string"?this.n:$.MarkdownString.from(this.n),sampleRequest:this.o,supportIssueReporting:this.t,isSticky:this.x}),p=!1}))},o=this;return{get name(){return o.id},get description(){return o.g??""},set description(E){o.g=E,u()},get fullName(){return(0,t.$VF)(o.extension,"defaultChatParticipant"),o.i??o.extension.displayName??o.extension.name},set fullName(E){(0,t.$VF)(o.extension,"defaultChatParticipant"),o.i=E,u()},get iconPath(){return o.j},set iconPath(E){o.j=E,u()},get requestHandler(){return o.A},set requestHandler(E){(0,D.$3f)(typeof E=="function","Invalid request handler"),o.A=E},get commandProvider(){return o.b},set commandProvider(E){o.b=E,u()},get followupProvider(){return o.d},set followupProvider(E){o.d=E,u()},get isDefault(){return(0,t.$VF)(o.extension,"defaultChatParticipant"),o.k},set isDefault(E){(0,t.$VF)(o.extension,"defaultChatParticipant"),o.k=E,u()},get helpTextPrefix(){return(0,t.$VF)(o.extension,"defaultChatParticipant"),o.l},set helpTextPrefix(E){if((0,t.$VF)(o.extension,"defaultChatParticipant"),!o.k)throw new Error("helpTextPrefix is only available on the default chat agent");o.l=E,u()},get helpTextVariablesPrefix(){return(0,t.$VF)(o.extension,"defaultChatParticipant"),o.m},set helpTextVariablesPrefix(E){if((0,t.$VF)(o.extension,"defaultChatParticipant"),!o.k)throw new Error("helpTextVariablesPrefix is only available on the default chat agent");o.m=E,u()},get helpTextPostfix(){return(0,t.$VF)(o.extension,"defaultChatParticipant"),o.n},set helpTextPostfix(E){if((0,t.$VF)(o.extension,"defaultChatParticipant"),!o.k)throw new Error("helpTextPostfix is only available on the default chat agent");o.n=E,u()},get isSecondary(){return(0,t.$VF)(o.extension,"defaultChatParticipant"),o.p},set isSecondary(E){(0,t.$VF)(o.extension,"defaultChatParticipant"),o.p=E,u()},get sampleRequest(){return o.o},set sampleRequest(E){o.o=E,u()},get supportIssueReporting(){return(0,t.$VF)(o.extension,"chatParticipantAdditions"),o.t},set supportIssueReporting(E){(0,t.$VF)(o.extension,"chatParticipantAdditions"),o.t=E,u()},get onDidReceiveFeedback(){return o.q.event},set participantVariableProvider(E){if((0,t.$VF)(o.extension,"chatParticipantAdditions"),o.u=E,E){if(!E.triggerCharacters.length)throw new Error("triggerCharacters are required");o.y.$registerAgentCompletionsProvider(o.z,E.triggerCharacters)}else o.y.$unregisterAgentCompletionsProvider(o.z)},get participantVariableProvider(){return(0,t.$VF)(o.extension,"chatParticipantAdditions"),o.u},set welcomeMessageProvider(E){(0,t.$VF)(o.extension,"defaultChatParticipant"),o.w=E,u()},get welcomeMessageProvider(){return(0,t.$VF)(o.extension,"defaultChatParticipant"),o.w},onDidPerformAction:(0,t.$UF)(this.extension,"chatParticipantAdditions")?this.s.event:void 0,get isSticky(){return o.x},set isSticky(E){o.x=E,u()},dispose(){i=!0,o.b=void 0,o.d=void 0,o.q.dispose(),o.y.$unregisterAgent(o.z)}}}invoke(i,p,u,o){return this.A(i,p,u,o)}}}),define(Re[249],Ae([1,0,22,6,3,8,99,20,11,5,159,104,34]),function(fe,e,S,F,P,L,R,g,f,D,M,k,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Thc=void 0;class v{constructor(t,n){this.option=t,this.stream=new f.$Hh,this.stream=n??new f.$Hh}}class ${constructor(t,n){this.cts=n,this.a=new Map,this.b=new f.$Hh,this.c=!1;const r=this;this.apiObject={result:t,stream:r.b.asyncIterable},t.then(()=>{for(const a of this.d())a.resolve()}).catch(a=>{a instanceof Error||(a=new Error((0,l.$2i)(a),{cause:a}));for(const h of this.d())h.reject(a)}).finally(()=>{this.c=!0})}*d(){if(this.a.size>0)for(const[,t]of this.a)yield t.stream;else yield this.b}handleFragment(t){if(this.c)return;let n=this.a.get(t.index);n||(this.a.size===0?n=new v(t.index,this.b):n=new v(t.index),this.a.set(t.index,n)),n.stream.emitOne(t.part)}}class s{static{this.a=1}constructor(t,n,r){this.j=n,this.k=r,this.c=new D.$5d,this.d=new D.$5d,this.onDidChangeProviders=this.d.event,this.f=new Map,this.g=new Set,this.h=new g.$ym,this.i=new Map,this.b=t.getProxy(P.$ZL.MainThreadChatProvider)}dispose(){this.c.dispose(),this.d.dispose()}registerLanguageModel(t,n,r,a){const h=s.a++;this.f.set(h,{extension:t.identifier,provider:r});let i;return a.auth&&(i={providerLabel:t.displayName||t.name,accountLabel:typeof a.auth=="object"?a.auth.label:void 0}),this.b.$registerProvider(h,n,{extension:t.identifier,model:a.name??"",auth:i}),(0,F.$Rc)(()=>{this.f.delete(h),this.b.$unregisterProvider(h)})}async $provideLanguageModelResponse(t,n,r,a,h,i){const p=this.f.get(t);if(!p)return;const u=new R.$Hv(async o=>{if(i.isCancellationRequested){this.j.warn(`[CHAT](${p.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}this.b.$handleProgressChunk(n,{index:o.index,part:o.part})});return p.provider.provideLanguageModelResponse2(a.map(L.LanguageModelMessage.to),h,g.$wm.toKey(r),u,i)}$updateLanguageModels(t){const n=[],r=[];if(t.added)for(const a of t.added)this.g.add(a),n.push(a);if(t.removed)for(const a of t.removed){this.g.delete(a),r.push(a);for(const[h,i]of this.i)i.languageModelId===a&&(i.res.cts.cancel(),this.i.delete(h))}this.d.fire(Object.freeze({added:Object.freeze(n),removed:Object.freeze(r)}))}getLanguageModelIds(){return Array.from(this.g)}$updateModelAccesslist(t){const n=new Array;for(const{from:r,to:a,enabled:h}of t){const i=this.h.get(r)??new g.$xm;if(i.has(a)!==h){h?i.add(a):i.delete(a),this.h.set(r,i);const u={from:r,to:a};n.push(u),this.c.fire(u)}}}async requestLanguageModelAccess(t,n,r){const a=t.identifier,h=r?.justification,i=await this.b.$prepareChatAccess(a,n,h);if(!i)throw new Error(`Language model '${n}' NOT found`);this.m(a,i)&&await this.l(t,{identifier:i.extension,displayName:i.auth.providerLabel},h);const p=this;return{get model(){return i.model},get isRevoked(){return p.m(a,i)&&!p.h.get(a)?.has(i.extension)||!p.g.has(n)},get onDidChangeAccess(){const u=D.Event.filter(p.d.event,E=>E.removed.includes(n)),o=D.Event.filter(p.c.event,E=>g.$wm.equals(E.from,a)&&g.$wm.equals(E.to,i.extension));return D.Event.signal(D.Event.any(u,o))},makeChatRequest(u,o,E){if(p.m(a,i)&&!p.h.get(a)?.has(i.extension))throw new Error("Access to chat has been revoked");if(!p.g.has(n))throw new Error("Language Model has been removed");const w=new S.$ce(E),m=Math.random()*1e6|0,I=p.b.$fetchResponse(a,n,m,u.map(L.LanguageModelMessage.from),o??{},w.token),d=new $(I,w);return p.i.set(m,{languageModelId:n,res:d}),I.finally(()=>{p.i.delete(m),w.dispose()}),d.apiObject}}}async $handleResponseFragment(t,n){const r=this.i.get(t);r&&r.res.handleFragment(n)}async l(t,n,r){const a=k.$6K+n.identifier.value;if(!await this.k.getSession(t,a,[],{silent:!0}))try{const i=r?(0,M.localize)(0,null,n.displayName,r):(0,M.localize)(1,null,n.displayName);await this.k.getSession(t,a,[],{forceNewSession:{detail:i}})}catch{throw new Error("Access to language models has not been granted")}this.$updateModelAccesslist([{from:t.identifier,to:n.identifier,enabled:!0}])}m(t,n){return!!n.auth&&!g.$wm.equals(n.extension,t)}}e.$Thc=s}),define(Re[250],Ae([1,0,15,6,3,8,7,23]),function(fe,e,S,F,P,L,R,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uhc=void 0;class f{static{this.a=0}constructor(k){this.b=new Map,this.c=k.getProxy(P.$ZL.MainThreadChatVariables)}async $resolveVariable(k,l,v,$){const s=this.b.get(k);if(s)try{if(s.resolver.resolve2){(0,g.$VF)(s.extension,"chatParticipantAdditions");const c=new D(l,this.c),t=await s.resolver.resolve2(s.data.name,{prompt:v},c.apiObject,$);if(t)return t.map(L.ChatVariable.from)}else{const c=await s.resolver.resolve(s.data.name,{prompt:v},$);if(c)return c.map(L.ChatVariable.from)}}catch(c){(0,S.$2)(c)}}registerVariableResolver(k,l,v,$){const s=f.a++;return this.b.set(s,{extension:k,data:{name:l,description:v},resolver:$}),this.c.$registerVariable(s,{name:l,description:v}),(0,F.$Rc)(()=>{this.b.delete(s),this.c.$unregisterVariable(s)})}}e.$Uhc=f;class D{constructor(k,l){this.c=k,this.d=l,this.a=!1}close(){this.a=!0}get apiObject(){if(!this.b){let l=function($){if(k.a){const s=new Error("Response stream has been closed");throw Error.captureStackTrace(s,$),s}};const k=this,v=$=>{this.d.$handleProgressChunk(this.c,$)};this.b={progress($){l(this.progress);const s=new R.$XN($),c=L.ChatResponseProgressPart.to(s);return v(c),this},reference($){l(this.reference);const s=new R.$ZN($),c=L.ChatResponseReferencePart.to(s);return v(c),this},push($){l(this.push);const s=L.ChatResponsePart.to($);return v(s),this}}}return this.b}}}),define(Re[251],Ae([1,0,11,68,5,6,2,86,20,8,7,3,23]),function(fe,e,S,F,P,L,R,g,f,D,M,k,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yhc=void 0;function v($,s,c){const t=$.getProxy(k.$ZL.MainThreadComments);class n{static{this.a=0}constructor(){this.b=new Map,this.c=new f.$ym,s.registerArgumentProcessor({processArgument:w=>{if(w&&w.$mid===6){const m=this.b.get(w.handle);return m?m.value:w}else if(w&&w.$mid===7){const m=this.b.get(w.commentControlHandle);if(!m)return w;const I=m.getCommentThread(w.commentThreadHandle);return I?I.value:w}else if(w&&(w.$mid===9||w.$mid===8)){const m=this.b.get(w.thread.commentControlHandle);if(!m)return w;const I=m.getCommentThread(w.thread.commentThreadHandle);return I?w.$mid===8?I.value:{thread:I.value,text:w.text}:w}else if(w&&w.$mid===10){const m=this.b.get(w.thread.commentControlHandle);if(!m)return w;const I=m.getCommentThread(w.thread.commentThreadHandle);if(!I)return w;const d=w.commentUniqueId,y=I.getCommentByUniqueId(d);return y||w}else if(w&&w.$mid===11){const m=this.b.get(w.thread.commentControlHandle);if(!m)return w;const I=m.getCommentThread(w.thread.commentThreadHandle);if(!I)return w;const d=w.text,y=w.commentUniqueId,b=I.getCommentByUniqueId(y);return b?(typeof b.body=="string"?b.body=d:b.body=new M.$qM(d),b):w}return w}})}createCommentController(w,m,I){const d=n.a++,y=new a(w,d,m,I);this.b.set(y.handle,y);const b=this.c.get(w.identifier)||[];return b.push(y),this.c.set(w.identifier,b),y.value}async $createCommentThreadTemplate(w,m,I){const d=this.b.get(w);d&&d.$createCommentThreadTemplate(m,I)}async $setActiveComment(w,m){const I=this.b.get(w);I&&I.$setActiveComment(m??void 0)}async $updateCommentThreadTemplate(w,m,I){const d=this.b.get(w);d&&d.$updateCommentThreadTemplate(m,I)}$deleteCommentThread(w,m){this.b.get(w)?.$deleteCommentThread(m)}$provideCommentingRanges(w,m,I){const d=this.b.get(w);if(!d||!d.commentingRangeProvider)return Promise.resolve(void 0);const y=c.getDocument(R.URI.revive(m));return(0,S.$9g)(async()=>{const b=await d.commentingRangeProvider.provideCommentingRanges(y,I);let A;return Array.isArray(b)?A={ranges:b,fileComments:!1}:b?A={ranges:b.ranges||[],fileComments:b.fileComments||!1}:A=b??void 0,A}).then(b=>{let A;return b&&(A={ranges:b.ranges.map(T=>D.Range.from(T)),fileComments:b.fileComments}),A})}$toggleReaction(w,m,I,d,y){const b=this.b.get(w);return!b||!b.reactionHandler?Promise.resolve(void 0):(0,S.$9g)(()=>{const A=b.getCommentThread(m);if(A){const T=A.getCommentByUniqueId(d.uniqueIdInThread);if(b!==void 0&&T&&b.reactionHandler)return b.reactionHandler(T,p(y))}return Promise.resolve(void 0)})}}class r{static{this.a=0}set threadId(w){this.n=w}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(w){(w===void 0!=(this.p===void 0)||!w||!this.p||!w.isEqual(this.p))&&(this.p=w,this.b.range=w,this.c.fire())}get range(){return this.p}set canReply(w){this.d!==w&&(this.d=w,this.b.canReply=w,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(w){this.e=w,this.b.label=w,this.c.fire()}get contextValue(){return this.f}set contextValue(w){this.f=w,this.b.contextValue=w,this.c.fire()}get comments(){return this.q}set comments(w){this.q=w,this.b.comments=w,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(w){this.g=w,this.b.collapsibleState=w,this.c.fire()}get state(){return this.h}set state(w){this.h=w,this.b.state=w,this.c.fire()}get isDisposed(){return this.j}constructor(w,m,I,d,y,b,A,T){this.m=m,this.n=I,this.o=d,this.p=y,this.q=b,this.extensionDescription=A,this.r=T,this.handle=r.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new P.$5d,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new L.$Uc,this.l.value=new L.$Sc,this.n===void 0&&(this.n=`${w}.${this.handle}`),t.$createCommentThread(m,this.handle,this.n,this.o,D.Range.from(this.p),A.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=b,this.i.push({dispose:()=>{t.$deleteCommentThread(m,this.handle)}});const G=this;this.value={get uri(){return G.uri},get range(){return G.range},set range(W){G.range=W},get comments(){return G.comments},set comments(W){G.comments=W},get collapsibleState(){return G.collapsibleState},set collapsibleState(W){G.collapsibleState=W},get canReply(){return G.canReply},set canReply(W){G.canReply=W},get contextValue(){return G.contextValue},set contextValue(W){G.contextValue=W},get label(){return G.label},set label(W){G.label=W},get state(){return G.state},set state(W){G.state=W},dispose:()=>{G.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new L.$Sc);const w=I=>Object.prototype.hasOwnProperty.call(this.b,I),m={};w("range")&&(m.range=D.Range.from(this.p)),w("label")&&(m.label=this.label),w("contextValue")&&(m.contextValue=this.contextValue??null),w("comments")&&(m.comments=this.q.map(I=>h(this,I,this.k,this.extensionDescription))),w("collapsibleState")&&(m.collapseState=u(this.g)),w("canReply")&&(m.canReply=this.canReply),w("state")&&(m.state=o(this.h)),w("isTemplate")&&(m.isTemplate=this.r),this.b={},t.$updateCommentThread(this.m,this.handle,this.n,this.o,m)}getCommentByUniqueId(w){for(const m of this.k){const I=m[0],d=m[1];if(w===d)return I}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(w=>w.dispose())}}Ze([(0,F.$Jh)(100)],r.prototype,"eventuallyUpdateCommentThread",null);class a{get id(){return this.j}get label(){return this.k}get handle(){return this.i}get commentingRangeProvider(){return this.b}set commentingRangeProvider(w){this.b=w,t.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(w){this.c=w,t.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!w})}get options(){return this.d}set options(w){this.d=w,t.$updateCommentControllerFeatures(this.handle,{options:this.d})}get activeComment(){return(0,l.$VF)(this.h,"activeComment"),this.e}get activeCommentThread(){return(0,l.$VF)(this.h,"activeComment"),this.f}constructor(w,m,I,d){this.h=w,this.i=m,this.j=I,this.k=d,this.a=new Map,t.$registerCommentController(this.handle,I,d,this.h.identifier.value);const y=this;this.value=Object.freeze({id:y.id,label:y.label,get options(){return y.options},set options(b){y.options=b},get commentingRangeProvider(){return y.commentingRangeProvider},set commentingRangeProvider(b){y.commentingRangeProvider=b},get reactionHandler(){return y.reactionHandler},set reactionHandler(b){y.reactionHandler=b},get activeCommentThread(){return y.activeCommentThread},createCommentThread(b,A,T){return y.createCommentThread(b,A,T).value},dispose:()=>{y.dispose()}}),this.g=[],this.g.push({dispose:()=>{t.$unregisterCommentController(this.handle)}})}createCommentThread(w,m,I){m===void 0&&(0,l.$VF)(this.h,"fileComments");const d=new r(this.id,this.handle,void 0,w,m,I,this.h,!1);return this.a.set(d.handle,d),d}$setActiveComment(w){if(!w){this.e=void 0,this.f=void 0;return}const m=this.a.get(w.commentThreadHandle);m&&(this.e=w.uniqueIdInThread?m.getCommentByUniqueId(w.uniqueIdInThread):void 0,this.f=m)}$createCommentThreadTemplate(w,m){const I=new r(this.id,this.handle,void 0,R.URI.revive(w),D.Range.to(m),[],this.h,!0);return I.collapsibleState=g.CommentThreadCollapsibleState.Expanded,this.a.set(I.handle,I),I}$updateCommentThreadTemplate(w,m){const I=this.a.get(w);I&&(I.range=D.Range.to(m))}$deleteCommentThread(w){this.a.get(w)?.dispose(),this.a.delete(w)}getCommentThread(w){return this.a.get(w)}dispose(){this.a.forEach(w=>{w.dispose()}),this.g.forEach(w=>w.dispose())}}function h(E,w,m,I){let d=m.get(w);return d||(d=++E.commentHandle,m.set(w,d)),w.state!==void 0&&(0,l.$VF)(I,"commentsDraftState"),w.reactions?.some(y=>y.reactors!==void 0)&&(0,l.$VF)(I,"commentReactor"),{mode:w.mode,contextValue:w.contextValue,uniqueIdInThread:d,body:typeof w.body=="string"?w.body:D.MarkdownString.from(w.body),userName:w.author.name,userIconPath:w.author.iconPath,label:w.label,commentReactions:w.reactions?w.reactions.map(y=>i(y)):void 0,state:w.state,timestamp:w.timestamp?.toJSON()}}function i(E){return{label:E.label,iconPath:E.iconPath?D.$dO(E.iconPath):void 0,count:E.count,hasReacted:E.authorHasReacted,reactors:E.reactors&&E.reactors.length>0&&typeof E.reactors[0]!="string"?E.reactors.map(w=>w.name):E.reactors}}function p(E){return{label:E.label||"",count:E.count||0,iconPath:E.iconPath?R.URI.revive(E.iconPath):"",authorHasReacted:E.hasReacted||!1,reactors:E.reactors?.map(w=>({name:w}))}}function u(E){if(E!==void 0)switch(E){case M.CommentThreadCollapsibleState.Expanded:return g.CommentThreadCollapsibleState.Expanded;case M.CommentThreadCollapsibleState.Collapsed:return g.CommentThreadCollapsibleState.Collapsed}return g.CommentThreadCollapsibleState.Collapsed}function o(E){if(E!==void 0)switch(E){case M.CommentThreadState.Unresolved:return g.CommentThreadState.Unresolved;case M.CommentThreadState.Resolved:return g.CommentThreadState.Resolved}return g.CommentThreadState.Unresolved}return new n}e.$Yhc=v}),define(Re[252],Ae([1,0,22,97,6,12,25,2,8,62,74,3,7]),function(fe,e,S,F,P,L,R,g,f,D,M,k,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eic=void 0;class v{constructor(p,u){this.document=p,this.b=u,this.a=1,this.c=new M.$Dhc("custom documents")}addEdit(p){return this.c.add([p])}async undo(p,u){await this.f(p).undo(),u||this.disposeBackup()}async redo(p,u){await this.f(p).redo(),u||this.disposeBackup()}disposeEdits(p){for(const u of p)this.c.delete(u)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const p=h(this.document.uri)+this.a++;return(0,R.$Rg)(this.b,p)}updateBackup(p){this.d?.delete(),this.d=p}disposeBackup(){this.d?.delete(),this.d=void 0}f(p){const u=this.c.get(p,0);if(!u)throw new Error("No edit found");return u}}class ${constructor(){this.a=new Map}get(p,u){return this.a.get(this.b(p,u))}add(p,u,o){const E=this.b(p,u.uri);if(this.a.has(E))throw new Error(`Document already exists for viewType:${p} resource:${u.uri}`);const w=new v(u,o);return this.a.set(E,w),w}delete(p,u){const o=this.b(p,u.uri);this.a.delete(o)}b(p,u){return`${p}@@@${u}`}}var s;(function(i){i[i.Text=0]="Text",i[i.Custom=1]="Custom"})(s||(s={}));class c{constructor(){this.a=new Map}addTextProvider(p,u,o){return this.b(0,p,u,o)}addCustomProvider(p,u,o){return this.b(1,p,u,o)}get(p){return this.a.get(p)}b(p,u,o,E){if(this.a.has(u))throw new Error(`Provider for viewType:${u} already registered`);return this.a.set(u,{type:p,extension:o,provider:E}),new l.$2L(()=>this.a.delete(u))}}class t{constructor(p,u,o,E,w){this.d=u,this.f=o,this.g=E,this.h=w,this.b=new c,this.c=new $,this.a=p.getProxy(k.$ZL.MainThreadCustomEditors)}registerCustomEditorProvider(p,u,o,E){const w=new P.$Sc;return r(o)?(w.add(this.b.addTextProvider(u,p,o)),this.a.$registerTextEditorProvider((0,D.$bic)(p),u,E.webviewOptions||{},{supportsMove:!!o.moveCustomTextEditor},(0,D.$_hc)(p))):(w.add(this.b.addCustomProvider(u,p,o)),n(o)&&w.add(o.onDidChangeCustomDocument(m=>{const I=this.i(u,m.document.uri);if(a(m)){const d=I.addEdit(m);this.a.$onDidEdit(m.document.uri,u,d,m.label)}else this.a.$onContentChange(m.document.uri,u)})),this.a.$registerCustomEditorProvider((0,D.$bic)(p),u,E.webviewOptions||{},!!E.supportsMultipleEditorsPerDocument,(0,D.$_hc)(p))),l.$2L.from(w,new l.$2L(()=>{this.a.$unregisterEditorProvider(u)}))}async $createCustomDocument(p,u,o,E,w){const m=this.b.get(u);if(!m)throw new Error(`No provider found for '${u}'`);if(m.type!==1)throw new Error(`Invalid provide type for '${u}'`);const I=g.URI.revive(p),d=await m.provider.openCustomDocument(I,{backupId:o,untitledDocumentData:E?.buffer},w);let y;return n(m.provider)&&this.f&&(y=this.f.workspaceValue(m.extension)??this.f.globalValue(m.extension)),this.c.add(u,d,y),{editable:n(m.provider)}}async $disposeCustomDocument(p,u){const o=this.b.get(u);if(!o)throw new Error(`No provider found for '${u}'`);if(o.type!==1)throw new Error(`Invalid provider type for '${u}'`);const E=g.URI.revive(p),{document:w}=this.i(u,E);this.c.delete(u,w),w.dispose()}async $resolveCustomEditor(p,u,o,E,w,m){const I=this.b.get(o);if(!I)throw new Error(`No provider found for '${o}'`);const d=f.ViewColumn.to(w),y=this.g.createNewWebview(u,E.contentOptions,I.extension),b=this.h.createNewWebviewPanel(u,o,E.title,d,E.options,y,E.active),A=g.URI.revive(p);switch(I.type){case 1:{const{document:T}=this.i(o,A);return I.provider.resolveCustomEditor(T,b,m)}case 0:{const T=this.d.getDocument(A);return I.provider.resolveCustomTextEditor(T,b,m)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(p,u,o){this.i(u,p).disposeEdits(o)}async $onMoveCustomEditor(p,u,o){const E=this.b.get(o);if(!E)throw new Error(`No provider found for '${o}'`);if(!E.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${o}'`);const w=this.h.getWebviewPanel(p);if(!w)throw new Error("No webview found");const m=g.URI.revive(u),I=this.d.getDocument(m);await E.provider.moveCustomTextEditor(I,w,S.CancellationToken.None)}async $undo(p,u,o,E){return this.i(u,p).undo(o,E)}async $redo(p,u,o,E){return this.i(u,p).redo(o,E)}async $revert(p,u,o){const E=this.i(u,p);await this.j(u).revertCustomDocument(E.document,o),E.disposeBackup()}async $onSave(p,u,o){const E=this.i(u,p);await this.j(u).saveCustomDocument(E.document,o),E.disposeBackup()}async $onSaveAs(p,u,o,E){const w=this.i(u,p);return this.j(u).saveCustomDocumentAs(w.document,g.URI.revive(o),E)}async $backup(p,u,o){const E=this.i(u,p),m=await this.j(u).backupCustomDocument(E.document,{destination:E.getNewBackupUri()},o);return E.updateBackup(m),m.id}i(p,u){const o=this.c.get(p,g.URI.revive(u));if(!o)throw new Error("No custom document found");return o}j(p){const o=this.b.get(p)?.provider;if(!o||!n(o))throw new Error("Custom document is not editable");return o}}e.$eic=t;function n(i){return!!i.onDidChangeCustomDocument}function r(i){return typeof i.resolveCustomTextEditor=="function"}function a(i){return typeof i.undo=="function"&&typeof i.redo=="function"}function h(i){const p=i.scheme===L.Schemas.file||i.scheme===L.Schemas.untitled?i.fsPath:i.toString();return(0,F.$5i)(p)+""}}),define(Re[253],Ae([1,0,160,98,2,3,7,8,5,14,28,43]),function(fe,e,S,F,P,L,R,g,f,D,M,k){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.$Lhc=e.$Khc=void 0;class v{#e;#t;#i;constructor(c,t,n,r,a,h,i,p){this.d=c,this.e=t,this.f=n,this.g=r,this.h=a,this.c=!1,this.f=Math.max(r,n),this.#i=new M.$Ac(u=>h.getComparisonKey(u)),this.#e=i,this.#t=p}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(c,t){if(!c){this.clear();return}this.j();let n=[];if(P.URI.isUri(c)){if(!t){this.delete(c);return}this.#i.set(c,t.slice()),n=[c]}else if(Array.isArray(c)){n=[];let h;c=[...c].sort(v.k);for(const i of c){const[p,u]=i;if((!h||p.toString()!==h.toString())&&(h&&this.#i.get(h).length===0&&this.#i.delete(h),h=p,n.push(p),this.#i.set(p,[])),u)this.#i.get(p)?.push(...u);else{const o=this.#i.get(p);o&&(o.length=0)}}}if(this.#t.fire(n),!this.#e)return;const r=[];let a=0;for(const h of n){let i=[];const p=this.#i.get(h);if(p)if(p.length>this.g){i=[];const u=[R.DiagnosticSeverity.Error,R.DiagnosticSeverity.Warning,R.DiagnosticSeverity.Information,R.DiagnosticSeverity.Hint];e:for(let o=0;o<4;o++)for(const E of p)if(E.severity===u[o]&&i.push({...g.Diagnostic.from(E),modelVersionId:this.h(h)})===this.g)break e;i.push({severity:F.MarkerSeverity.Info,message:(0,S.localize)(0,null,p.length-this.g),startLineNumber:i[i.length-1].startLineNumber,startColumn:i[i.length-1].startColumn,endLineNumber:i[i.length-1].endLineNumber,endColumn:i[i.length-1].endColumn})}else i=p.map(u=>({...g.Diagnostic.from(u),modelVersionId:this.h(h)}));if(r.push([h,i]),a+=i.length,a>this.f)break}this.#e.$changeMany(this.e,r)}delete(c){this.j(),this.#t.fire([c]),this.#i.delete(c),this.#e?.$changeMany(this.e,[[c,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(c,t){this.j();for(const[n,r]of this)c.call(t,n,r,this)}*[Symbol.iterator](){this.j();for(const c of this.#i.keys())yield[c,this.get(c)]}get(c){this.j();const t=this.#i.get(c);return Array.isArray(t)?Object.freeze(t.slice(0)):[]}has(c){return this.j(),Array.isArray(this.#i.get(c))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(c,t){return c[0].toString()<t[0].toString()?-1:c[0].toString()>t[0].toString()?1:0}}e.$Khc=v;let $=class{static{l=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*l.d}static _mapper(c){const t=new M.$Ac;for(const n of c)t.set(n,n);return{uris:Object.freeze(Array.from(t.values()))}}constructor(c,t,n,r){this.j=t,this.k=n,this.l=r,this.g=new Map,this.h=new f.$9d({merge:a=>a.flat(),delay:50}),this.onDidChangeDiagnostics=f.Event.map(this.h.event,l._mapper),this.f=c.getProxy(L.$ZL.MainThreadDiagnostics)}createDiagnosticCollection(c,t){const{g:n,f:r,h:a,j:h,k:i,l:p}=this,u=new class{$changeMany(w,m){r.$changeMany(w,m),h.trace("[DiagnosticCollection] change many (extension, owner, uris)",c.value,w,m.length===0?"CLEARING":m)}$clear(w){r.$clear(w),h.trace("[DiagnosticCollection] remove all (extension, owner)",c.value,w)}dispose(){r.dispose()}};let o;if(!t)t="_generated_diagnostic_collection_name_#"+l.c++,o=t;else if(!n.has(t))o=t;else{this.j.warn(`DiagnosticCollection with name '${t}' does already exist.`);do o=t+l.c++;while(n.has(o))}return new class extends v{constructor(){super(t,o,l.e,l.d,w=>p.getDocument(w)?.version,i.extUri,u,a),n.set(o,this)}dispose(){super.dispose(),n.delete(o)}}}getDiagnostics(c){if(c)return this.m(c);{const t=new Map,n=[];for(const r of this.g.values())r.forEach((a,h)=>{let i=t.get(a.toString());typeof i>"u"&&(i=n.length,t.set(a.toString(),i),n.push([a,[]])),n[i][1]=n[i][1].concat(...h)});return n}}m(c){let t=[];for(const n of this.g.values())n.has(c)&&(t=t.concat(n.get(c)));return t}$acceptMarkersChange(c){if(!this.n){const t="_generated_mirror",n=new v(t,t,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,r=>{},this.k.extUri,void 0,this.h);this.g.set(t,n),this.n=n}for(const[t,n]of c)this.n.set(P.URI.revive(t),n.map(g.Diagnostic.to))}};e.$Lhc=$,e.$Lhc=$=l=Ze([qe(1,D.$yj),qe(2,k.$Jhc)],$)}),define(Re[254],Ae([1,0,2,15,7,8,187]),function(fe,e,S,F,P,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sic=void 0;class g{constructor(D,M,k,l={timeout:1500,errors:3}){this.c=D,this.d=M,this.f=k,this.g=l,this.a=new R.$4c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(D){return(M,k,l)=>{const $={dispose:this.a.push([M,k,D])};return Array.isArray(l)&&l.push($),$}}async $participateInSave(D,M){const k=S.URI.revive(D);let l=!1;const v=setTimeout(()=>l=!0,this.g.timeout),$=[];try{for(const s of[...this.a]){if(l)break;const c=this.d.getDocument(k),t=await this.h(s,{document:c,reason:L.TextDocumentSaveReason.to(M)});$.push(t)}}finally{clearTimeout(v)}return $}h([D,M,k],l){const v=this.b.get(D);return typeof v=="number"&&v>this.g.errors?Promise.resolve(!1):this.i(k,D,M,l).then(()=>!0,$=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' threw ERROR`),this.c.error($),!($ instanceof Error)||$.message!=="concurrent_edits"){const s=this.b.get(D);this.b.set(D,s?s+1:1),typeof s=="number"&&s>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(D,M,k,l){const v=[],$=Date.now(),{document:s,reason:c}=l,{version:t}=s,n=Object.freeze({document:s,reason:c,waitUntil(r){if(Object.isFrozen(v))throw(0,F.$8)("waitUntil can not be called async");v.push(Promise.resolve(r))}});try{M.apply(k,[n])}catch(r){return Promise.reject(r)}return Object.freeze(v),new Promise((r,a)=>{const h=setTimeout(()=>a(new Error("timeout")),this.g.timeout);return Promise.all(v).then(i=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${D.identifier.value}' finished after ${Date.now()-$}ms`),clearTimeout(h),r(i)}).catch(i=>{clearTimeout(h),a(i)})}).then(r=>{const a={edits:[]};for(const h of r)if(Array.isArray(h)&&h.every(i=>i instanceof P.$9L))for(const{newText:i,newEol:p,range:u}of h)a.edits.push({resource:s.uri,versionId:void 0,textEdit:{range:u&&L.Range.from(u),text:i,eol:p&&L.EndOfLine.from(p)}});if(a.edits.length!==0)return t===s.version?this.f.$tryApplyWorkspaceEdit(a):Promise.reject(new Error("concurrent_edits"))})}}e.$Sic=g}),define(Re[255],Ae([1,0,5,6,2,3,109,8,16,26,7]),function(fe,e,S,F,P,L,R,g,f,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mhc=void 0;class k{constructor(v,$){this.a=new S.$5d,this.b=new S.$5d,this.c=new S.$5d,this.d=new S.$5d,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new F.$Sc,this.h=new Map,this.f=v.getProxy(L.$ZL.MainThreadDocuments),this.g=$,this.g.onDidRemoveDocuments(s=>{for(const c of s)this.b.fire(c.document)},void 0,this.e),this.g.onDidAddDocuments(s=>{for(const c of s)this.a.fire(c.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(v){if(!v)return;const $=this.g.getDocument(v);if($)return $}getDocument(v){const $=this.getDocumentData(v);if(!$?.document)throw new Error(`Unable to retrieve document from URI '${v}'`);return $.document}ensureDocumentData(v){const $=this.g.getDocument(v);if($)return Promise.resolve($);let s=this.h.get(v.toString());return s||(s=this.f.$tryOpenDocument(v).then(c=>{this.h.delete(v.toString());const t=P.URI.revive(c);return(0,f.$4f)(this.g.getDocument(t))},c=>(this.h.delete(v.toString()),Promise.reject(c))),this.h.set(v.toString(),s)),s}createDocumentData(v){return this.f.$tryCreateDocument(v).then($=>P.URI.revive($))}$acceptModelLanguageChanged(v,$){const s=P.URI.revive(v),c=this.g.getDocument(s);if(!c)throw new Error("unknown document");this.b.fire(c.document),c._acceptLanguageId($),this.a.fire(c.document)}$acceptModelSaved(v){const $=P.URI.revive(v),s=this.g.getDocument($);if(!s)throw new Error("unknown document");this.$acceptDirtyStateChanged(v,!1),this.d.fire(s.document)}$acceptDirtyStateChanged(v,$){const s=P.URI.revive(v),c=this.g.getDocument(s);if(!c)throw new Error("unknown document");c._acceptIsDirty($),this.c.fire({document:c.document,contentChanges:[],reason:void 0})}$acceptModelChanged(v,$,s){const c=P.URI.revive(v),t=this.g.getDocument(c);if(!t)throw new Error("unknown document");t._acceptIsDirty(s),t.onEvents($);let n;$.isUndoing?n=M.TextDocumentChangeReason.Undo:$.isRedoing&&(n=M.TextDocumentChangeReason.Redo),this.c.fire((0,D.$In)({document:t.document,contentChanges:$.changes.map(r=>({range:g.Range.to(r.range),rangeOffset:r.rangeOffset,rangeLength:r.rangeLength,text:r.text})),reason:n}))}setWordDefinitionFor(v,$){(0,R.$gO)(v,$)}}e.$Mhc=k}),define(Re[65],Ae([1,0,256,5,16,2,4,3,17,8,7]),function(fe,e,S,F,P,L,R,g,f,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gic=e.$fic=void 0,e.$fic=(0,R.$ei)("IExtHostEditorTabs");class k{constructor(c,t,n){this.e=n,this.d=t,this.acceptDtoUpdate(c)}get apiObject(){if(!this.a){const c=this,t={get isActive(){return c.b.id===c.e()},get label(){return c.b.label},get input(){return c.c},get isDirty(){return c.b.isDirty},get isPinned(){return c.b.isPinned},get isPreview(){return c.b.isPreview},get group(){return c.d.apiObject}};this.a=Object.freeze(t)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(c){this.b=c,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new M.$JN(L.URI.revive(this.b.input.uri));case 2:return new M.$KN(L.URI.revive(this.b.input.original),L.URI.revive(this.b.input.modified));case 3:return new M.$LN(L.URI.revive(this.b.input.base),L.URI.revive(this.b.input.input1),L.URI.revive(this.b.input.input2),L.URI.revive(this.b.input.result));case 6:return new M.$MN(L.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new M.$NN(this.b.input.viewType);case 4:return new M.$ON(L.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new M.$PN(L.URI.revive(this.b.input.original),L.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new M.$QN;case 9:return new M.$RN(L.URI.revive(this.b.input.uri),L.URI.revive(this.b.input.inputBoxUri));case 10:return new M.$SN(this.b.input.providerId);default:return}}}class l{constructor(c,t){this.c=[],this.d="",this.b=c,this.e=t;for(const n of c.tabs)n.isActive&&(this.d=n.id),this.c.push(new k(n,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const c=this,t={get isActive(){return c.b.groupId===c.e()},get viewColumn(){return D.ViewColumn.to(c.b.viewColumn)},get activeTab(){return c.c.find(n=>n.tabId===c.d)?.apiObject},get tabs(){return Object.freeze(c.c.map(n=>n.apiObject))}};this.a=Object.freeze(t)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(c){this.b=c}acceptTabOperation(c){if(c.kind===0){const n=new k(c.tabDto,this,()=>this.activeTabId());return this.c.splice(c.index,0,n),c.tabDto.isActive&&(this.d=n.tabId),n}else if(c.kind===1){const n=this.c.splice(c.index,1)[0];if(!n)throw new Error(`Tab close updated received for index ${c.index} which does not exist`);return n.tabId===this.d&&(this.d=""),n}else if(c.kind===3){if(c.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const n=this.c.splice(c.oldIndex,1)[0];if(!n)throw new Error(`Tab move updated received for index ${c.oldIndex} which does not exist`);return this.c.splice(c.index,0,n),n}const t=this.c.find(n=>n.tabId===c.tabDto.id);if(!t)throw new Error("INVALID tab");return c.tabDto.isActive?this.d=c.tabDto.id:this.d===c.tabDto.id&&!c.tabDto.isActive&&(this.d=""),t.acceptDtoUpdate(c.tabDto),t}activeTabId(){return this.d}}let v=class{constructor(c){this.b=new F.$5d,this.c=new F.$5d,this.e=[],this.a=c.getProxy(g.$ZL.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const c=this,t={onDidChangeTabGroups:c.c.event,onDidChangeTabs:c.b.event,get all(){return Object.freeze(c.e.map(n=>n.apiObject))},get activeTabGroup(){const n=c.d;return(0,P.$4f)(c.e.find(a=>a.groupId===n)?.apiObject)},close:async(n,r)=>{const a=Array.isArray(n)?n:[n];return a.length?$(a[0])?this.j(a,r):this.i(a,r):!0}};this.f=Object.freeze(t)}return this.f}$acceptEditorTabModel(c){const t=new Set(this.e.map(u=>u.groupId)),n=new Set(c.map(u=>u.groupId)),r=(0,S.$L)(t,n),a=this.e.filter(u=>r.removed.includes(u.groupId)).map(u=>u.apiObject),h=[],i=[];this.e=c.map(u=>{const o=new l(u,()=>this.d);return r.added.includes(o.groupId)?h.push(o.apiObject):i.push(o.apiObject),o});const p=(0,P.$4f)(c.find(u=>u.isActive===!0)?.groupId);p!==void 0&&this.d!==p&&(this.d=p),this.c.fire(Object.freeze({opened:h,closed:a,changed:i}))}$acceptTabGroupUpdate(c){const t=this.e.find(n=>n.groupId===c.groupId);if(!t)throw new Error("Update Group IPC call received before group creation.");t.acceptGroupDtoUpdate(c),c.isActive&&(this.d=c.groupId),this.c.fire(Object.freeze({changed:[t.apiObject],opened:[],closed:[]}))}$acceptTabOperation(c){const t=this.e.find(r=>r.groupId===c.groupId);if(!t)throw new Error("Update Tabs IPC call received before group creation.");const n=t.acceptTabOperation(c);switch(c.kind){case 0:this.b.fire(Object.freeze({opened:[n.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[n.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[n.apiObject]}));return}}g(c){for(const t of this.e)for(const n of t.tabs)if(n.apiObject===c)return n}h(c){return this.e.find(t=>t.apiObject===c)}async i(c,t){const n=[];for(const r of c){const a=this.g(r);if(!a)throw new Error("Tab close: Invalid tab not found!");n.push(a.tabId)}return this.a.$closeTab(n,t)}async j(c,t){const n=[];for(const r of c){const a=this.h(r);if(!a)throw new Error("Group close: Invalid group not found!");n.push(a.groupId)}return this.a.$closeGroup(n,t)}};e.$gic=v,e.$gic=v=Ze([qe(0,f.$eO)],v);function $(s){return s.tabs!==void 0}}),define(Re[257],Ae([1,0,2,3,6,7,8,299,13,24,23,53]),function(fe,e,S,F,P,L,R,g,f,D,M,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uic=void 0;class l{constructor(){this.a=[]}add(s){this.b=void 0,this.a.push(s)}delete(s){const c=this.a.indexOf(s);c>=0&&(this.a.splice(c,1),this.b=void 0)}c(){if(!this.b){const s=this.a.sort(),c=[];let t,n,r=14,a=14;for(const h of s){let i=t?(0,f.$lf)(t,h):0;for(i===0?n=1:n=a;i<h.length;i++)i+1===h.length?(r=a,a=9):a+=1,c.push([n,h.toUpperCase().charCodeAt(i),a]),c.push([n,h.toLowerCase().charCodeAt(i),a]),n=a;t=h,a=r}c.push([9,58,10]),c.push([10,47,12]),this.b=new g.$41(c)}}provideDocumentLinks(s){this.c();const c=[],t=g.$51.computeLinks({getLineContent(n){return s.lineAt(n-1).text},getLineCount(){return s.lineCount}},this.b);for(const n of t){const r=R.DocumentLink.to(n);r.target&&c.push(r)}return c}}class v{constructor(s,c){this.i=c,this.b=new l,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=s.getProxy(F.$ZL.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(s,c,t,n={}){if(v.j(t),this.d.has(c))throw new Error(`a provider for the scheme '${c}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(s,"*",this.b));const r=this.h++;this.b.add(c),this.d.add(c),this.c.set(r,t);let a=2;n.isCaseSensitive&&(a+=1024),n.isReadonly&&(a+=2048),typeof t.copy=="function"&&(a+=8),typeof t.open=="function"&&typeof t.close=="function"&&typeof t.read=="function"&&typeof t.write=="function"&&((0,M.$VF)(s,"fsChunks"),a+=4);let h;n.isReadonly&&(0,k.$uk)(n.isReadonly)&&n.isReadonly.value!==""&&(h={value:n.isReadonly.value,isTrusted:n.isReadonly.isTrusted,supportThemeIcons:n.isReadonly.supportThemeIcons,supportHtml:n.isReadonly.supportHtml,baseUri:n.isReadonly.baseUri,uris:n.isReadonly.uris}),this.a.$registerFileSystemProvider(r,c,a,h).catch(p=>{console.error(`FAILED to register filesystem provider of ${s.identifier.value}-extension for the scheme ${c}`),console.error(p)});const i=t.onDidChangeFile(p=>{const u=[];for(const o of p){const{uri:E,type:w}=o;if(E.scheme!==c)continue;let m;switch(w){case L.FileChangeType.Changed:m=0;break;case L.FileChangeType.Created:m=1;break;case L.FileChangeType.Deleted:m=2;break;default:throw new Error("Unknown FileChangeType")}u.push({resource:E,type:m})}this.a.$onFileSystemChange(r,u)});return(0,P.$Rc)(()=>{i.dispose(),this.b.delete(c),this.d.delete(c),this.c.delete(r),this.a.$unregisterProvider(r)})}static j(s){if(!s)throw new Error("MISSING provider");if(typeof s.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof s.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof s.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof s.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof s.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof s.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof s.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof s.rename!="function")throw new Error("Provider does NOT implement rename")}static k(s){const{type:c,ctime:t,mtime:n,size:r,permissions:a}=s;return{type:c,ctime:t,mtime:n,size:r,permissions:a}}$stat(s,c){return Promise.resolve(this.l(s).stat(S.URI.revive(c))).then(t=>v.k(t))}$readdir(s,c){return Promise.resolve(this.l(s).readDirectory(S.URI.revive(c)))}$readFile(s,c){return Promise.resolve(this.l(s).readFile(S.URI.revive(c))).then(t=>D.$se.wrap(t))}$writeFile(s,c,t,n){return Promise.resolve(this.l(s).writeFile(S.URI.revive(c),t.buffer,n))}$delete(s,c,t){return Promise.resolve(this.l(s).delete(S.URI.revive(c),t))}$rename(s,c,t,n){return Promise.resolve(this.l(s).rename(S.URI.revive(c),S.URI.revive(t),n))}$copy(s,c,t,n){const r=this.l(s);if(!r.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(r.copy(S.URI.revive(c),S.URI.revive(t),n))}$mkdir(s,c){return Promise.resolve(this.l(s).createDirectory(S.URI.revive(c)))}$watch(s,c,t,n){const r=this.l(s).watch(S.URI.revive(t),n);this.f.set(c,r)}$unwatch(s,c){const t=this.f.get(c);t&&(t.dispose(),this.f.delete(c))}$open(s,c,t){const n=this.l(s);if(!n.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(n.open(S.URI.revive(c),t))}$close(s,c){const t=this.l(s);if(!t.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(t.close(c))}$read(s,c,t,n){const r=this.l(s);if(!r.read)throw new Error('FileSystemProvider does not implement "read"');const a=D.$se.alloc(n);return Promise.resolve(r.read(c,t,a.buffer,0,n)).then(h=>a.slice(0,h))}$write(s,c,t,n){const r=this.l(s);if(!r.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(r.write(c,t,n.buffer,0,n.byteLength))}l(s){const c=this.c.get(s);if(!c){const t=new Error;throw t.name="ENOPRO",t.message="no provider",t}return c}}e.$Uic=v}),define(Re[258],Ae([1,0,5,35,2,3,8,7,40]),function(fe,e,S,F,P,L,R,g,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vic=void 0;class D{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(v,$,s,c,t,n){this.a=Math.random(),this.b=new S.$5d,this.c=new S.$5d,this.d=new S.$5d,this.h=0,n?.ignoreCreateEvents&&(this.h+=1),n?.ignoreChangeEvents&&(this.h+=2),n?.ignoreDeleteEvents&&(this.h+=4);const r=(0,F.$Xj)(t),a=typeof t=="string",h=n?.correlate,i=c(p=>{if(!(typeof p.session=="number"&&p.session!==this.a)&&!(h&&typeof p.session>"u")){if(!n?.ignoreCreateEvents)for(const u of p.created){const o=P.URI.revive(u);r(o.fsPath)&&(!a||$.getWorkspaceFolder(o))&&this.b.fire(o)}if(!n?.ignoreChangeEvents)for(const u of p.changed){const o=P.URI.revive(u);r(o.fsPath)&&(!a||$.getWorkspaceFolder(o))&&this.c.fire(o)}if(!n?.ignoreDeleteEvents)for(const u of p.deleted){const o=P.URI.revive(u);r(o.fsPath)&&(!a||$.getWorkspaceFolder(o))&&this.d.fire(o)}}});this.g=g.$2L.from(this.i(v,s,t,n,n?.correlate),this.b,this.c,this.d,i)}i(v,$,s,c,t){const n=g.$2L.from();if(typeof s=="string")return n;const r=v.getProxy(L.$ZL.MainThreadFileSystemEventService);let a=!1;return(s.pattern.includes(F.$Tj)||s.pattern.includes(F.$Uj))&&(a=!0),r.$watch($.identifier.value,this.a,s.baseUri,{recursive:a,excludes:c?.excludes??[]},!!t),g.$2L.from({dispose:()=>r.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class M{constructor(v){this.a=v,this.session=this.a.session,this.b=new f.$V(()=>this.a.created.map(P.URI.revive)),this.c=new f.$V(()=>this.a.changed.map(P.URI.revive)),this.d=new f.$V(()=>this.a.deleted.map(P.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class k{constructor(v,$,s){this.j=v,this.k=$,this.l=s,this.a=new S.$5d,this.b=new S.$5d,this.c=new S.$5d,this.d=new S.$5d,this.g=new S.$7d,this.h=new S.$7d,this.i=new S.$7d,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(v,$,s,c){return new D(this.j,v,$,this.a.event,R.GlobPattern.from(s),c)}$onFileEvent(v){this.a.fire(new M(v))}$onDidRunFileOperation(v,$){switch(v){case 2:this.b.fire(Object.freeze({files:$.map(s=>({oldUri:P.URI.revive(s.source),newUri:P.URI.revive(s.target)}))}));break;case 1:this.d.fire(Object.freeze({files:$.map(s=>P.URI.revive(s.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:$.map(s=>P.URI.revive(s.target))}));break;default:}}getOnWillRenameFileEvent(v){return this.m(v,this.g)}getOnWillCreateFileEvent(v){return this.m(v,this.h)}getOnWillDeleteFileEvent(v){return this.m(v,this.i)}m(v,$){return(s,c,t)=>{const n=function(a){s.call(c,a)};return n.extension=v,$.event(n,void 0,t)}}async $onWillRunFileOperation(v,$,s,c){switch(v){case 2:return await this.n(this.g,{files:$.map(t=>({oldUri:P.URI.revive(t.source),newUri:P.URI.revive(t.target)}))},s,c);case 1:return await this.n(this.i,{files:$.map(t=>P.URI.revive(t.target))},s,c);case 0:case 3:return await this.n(this.h,{files:$.map(t=>P.URI.revive(t.target))},s,c)}}async n(v,$,s,c){const t=new Set,n=[];if(await v.fireAsync($,c,async(a,h)=>{const i=Date.now(),p=await Promise.resolve(a);p instanceof g.$_L&&(n.push([h.extension,p]),t.add(h.extension.displayName??h.extension.identifier.value)),Date.now()-i>s&&this.k.warn("SLOW file-participant",h.extension.identifier)}),c.isCancellationRequested||n.length===0)return;const r={edits:[]};for(const[,a]of n){const{edits:h}=R.WorkspaceEdit.from(a,{getTextDocumentVersion:i=>this.l.getDocument(i)?.version,getNotebookDocumentVersion:()=>{}});r.edits=r.edits.concat(h)}return{edit:r,extensionNames:Array.from(t)}}}e.$Vic=k}),define(Re[259],Ae([1,0,18,11,22,15,88,6,26,64,13,16,2,29,300,86,95,162,20,8,7,23,74,3]),function(fe,e,S,F,P,L,R,g,f,D,M,k,l,v,$,s,c,t,n,r,a,h,i,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nhc=void 0;class u{constructor(N,z){this.d=N,this.e=z}async provideDocumentSymbols(N,z){const K=this.d.getDocument(N),H=await this.e.provideDocumentSymbols(K,z);if(!(0,S.$Kb)(H))return H[0]instanceof a.$iM?H.map(r.DocumentSymbol.from):u.f(H)}static f(N){N=N.slice(0).sort((H,te)=>{let oe=H.location.range.start.compareTo(te.location.range.start);return oe===0&&(oe=te.location.range.end.compareTo(H.location.range.end)),oe});const z=[],K=[];for(const H of N){const te={name:H.name||"!!MISSING: name!!",kind:r.SymbolKind.from(H.kind),tags:H.tags?.map(r.SymbolTag.from)||[],detail:"",containerName:H.containerName,range:r.Range.from(H.location.range),selectionRange:r.Range.from(H.location.range),children:[]};for(;;){if(K.length===0){K.push(te),z.push(te);break}const oe=K[K.length-1];if(v.$6s.containsRange(oe.range,te.range)&&!v.$6s.equalsRange(oe.range,te.range)){oe.children?.push(te),K.push(te);break}K.pop()}}return z}}class o{constructor(N,z,K,H,te,oe){this.f=N,this.g=z,this.h=K,this.j=H,this.k=te,this.l=oe,this.d=new i.$Dhc("CodeLens"),this.e=new Map}async provideCodeLenses(N,z){const K=this.f.getDocument(N),H=await this.h.provideCodeLenses(K,z);if(!H||z.isCancellationRequested)return;const te=this.d.add(H),oe=new g.$Sc;this.e.set(te,oe);const Oe={cacheId:te,lenses:[]};for(let Ve=0;Ve<H.length;Ve++)Oe.lenses.push({cacheId:[te,Ve],range:r.Range.from(H[Ve].range),command:this.g.toInternal(H[Ve].command,oe)});return Oe}async resolveCodeLens(N,z){const K=N.cacheId&&this.d.get(...N.cacheId);if(!K)return;let H;if(typeof this.h.resolveCodeLens!="function"||K.isResolved?H=K:H=await this.h.resolveCodeLens(K,z),H||(H=K),z.isCancellationRequested)return;const te=N.cacheId&&this.e.get(N.cacheId[0]);if(te){if(!H.command){const oe=new Error("INVALID code lens resolved, lacks command: "+this.j.identifier.value);this.k.onExtensionError(this.j.identifier,oe),this.l.error(oe);return}return N.command=this.g.toInternal(H.command,te),N}}releaseCodeLenses(N){this.e.get(N)?.dispose(),this.e.delete(N),this.d.delete(N)}}function E(ze){return Array.isArray(ze)?ze.map(r.DefinitionLink.from):ze?[r.DefinitionLink.from(ze)]:[]}class w{constructor(N,z){this.d=N,this.e=z}async provideDefinition(N,z,K){const H=this.d.getDocument(N),te=r.Position.to(z),oe=await this.e.provideDefinition(H,te,K);return E(oe)}}class m{constructor(N,z){this.d=N,this.e=z}async provideDeclaration(N,z,K){const H=this.d.getDocument(N),te=r.Position.to(z),oe=await this.e.provideDeclaration(H,te,K);return E(oe)}}class I{constructor(N,z){this.d=N,this.e=z}async provideImplementation(N,z,K){const H=this.d.getDocument(N),te=r.Position.to(z),oe=await this.e.provideImplementation(H,te,K);return E(oe)}}class d{constructor(N,z){this.d=N,this.e=z}async provideTypeDefinition(N,z,K){const H=this.d.getDocument(N),te=r.Position.to(z),oe=await this.e.provideTypeDefinition(H,te,K);return E(oe)}}class y{constructor(N,z){this.d=N,this.e=z}async provideHover(N,z,K){const H=this.d.getDocument(N),te=r.Position.to(z),oe=await this.e.provideHover(H,te,K);if(!(!oe||(0,S.$Kb)(oe.contents)))return oe.range||(oe.range=H.getWordRangeAtPosition(te)),oe.range||(oe.range=new a.$4L(te,te)),r.Hover.from(oe)}}class b{constructor(N,z){this.d=N,this.e=z}async provideEvaluatableExpression(N,z,K){const H=this.d.getDocument(N),te=r.Position.to(z),oe=await this.e.provideEvaluatableExpression(H,te,K);if(oe)return r.EvaluatableExpression.from(oe)}}class A{constructor(N,z){this.d=N,this.e=z}async provideInlineValues(N,z,K,H){const te=this.d.getDocument(N),oe=await this.e.provideInlineValues(te,r.Range.to(z),r.InlineValueContext.to(K),H);if(Array.isArray(oe))return oe.map(Oe=>r.InlineValue.from(Oe))}}class T{constructor(N,z){this.d=N,this.e=z}async provideDocumentHighlights(N,z,K){const H=this.d.getDocument(N),te=r.Position.to(z),oe=await this.e.provideDocumentHighlights(H,te,K);if(Array.isArray(oe))return oe.map(r.DocumentHighlight.from)}}class G{constructor(N,z){this.d=N,this.e=z}async provideMultiDocumentHighlights(N,z,K,H){const te=this.d.getDocument(N),oe=K.map(He=>this.d.getDocument(He)),Oe=r.Position.to(z),Ve=await this.e.provideMultiDocumentHighlights(te,Oe,oe,H);if(Array.isArray(Ve))return Ve.map(r.MultiDocumentHighlight.from)}}class W{constructor(N,z){this.d=N,this.e=z}async provideLinkedEditingRanges(N,z,K){const H=this.d.getDocument(N),te=r.Position.to(z),oe=await this.e.provideLinkedEditingRanges(H,te,K);if(oe&&Array.isArray(oe.ranges))return{ranges:(0,S.$Hb)(oe.ranges.map(r.Range.from)),wordPattern:oe.wordPattern}}}class U{constructor(N,z){this.d=N,this.e=z}async provideReferences(N,z,K,H){const te=this.d.getDocument(N),oe=r.Position.to(z),Oe=await this.e.provideReferences(te,oe,K,H);if(Array.isArray(Oe))return Oe.map(r.location.from)}}class C{static{this.d=1e3}constructor(N,z,K,H,te,oe,Oe){this.g=N,this.h=z,this.j=K,this.k=H,this.l=te,this.m=oe,this.n=Oe,this.e=new i.$Dhc("CodeAction"),this.f=new Map}async provideCodeActions(N,z,K,H){const te=this.g.getDocument(N),oe=$.$8s.isISelection(z)?r.Selection.to(z):r.Range.to(z),Oe=[];for(const rt of this.j.getDiagnostics(N))if(oe.intersection(rt.range)&&Oe.push(rt)>C.d)break;const Ve={diagnostics:Oe,only:K.only?new a.$kM(K.only):void 0,triggerKind:r.CodeActionTriggerKind.to(K.trigger)},He=await this.k.provideCodeActions(te,oe,Ve,H);if(!(0,S.$Lb)(He)||H.isCancellationRequested)return;const xe=this.e.add(He),tt=new g.$Sc;this.f.set(xe,tt);const lt=[];for(let rt=0;rt<He.length;rt++){const it=He[rt];if(it)if(C.o(it))this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),lt.push({_isSynthetic:!0,title:it.title,command:this.h.toInternal(it,tt)});else{Ve.only&&(it.kind?Ve.only.contains(it.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Ve.only.value} 'requested but returned code action is of kind '${it.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Ve.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`));const ot=it.ranges??[];lt.push({cacheId:[xe,rt],title:it.title,command:it.command&&this.h.toInternal(it.command,tt),diagnostics:it.diagnostics&&it.diagnostics.map(r.Diagnostic.from),edit:it.edit&&r.WorkspaceEdit.from(it.edit,void 0),kind:it.kind&&it.kind.value,isPreferred:it.isPreferred,isAI:(0,h.$UF)(this.m,"codeActionAI")?it.isAI:!1,ranges:(0,h.$UF)(this.m,"codeActionRanges")?(0,S.$Hb)(ot.map(r.Range.from)):void 0,disabled:it.disabled?.reason})}}return{cacheId:xe,actions:lt}}async resolveCodeAction(N,z){const[K,H]=N,te=this.e.get(K,H);if(!te||C.o(te))return{};if(!this.k.resolveCodeAction)return{};const oe=await this.k.resolveCodeAction(te,z)??te;let Oe;oe.edit&&(Oe=r.WorkspaceEdit.from(oe.edit,void 0));let Ve;if(oe.command){const He=this.f.get(K);He&&(Ve=this.h.toInternal(oe.command,He))}return{edit:Oe,command:Ve}}releaseCodeActions(N){this.f.get(N)?.dispose(),this.f.delete(N),this.e.delete(N)}static o(N){return typeof N.command=="string"&&typeof N.title=="string"}}class O{static toInternalProviderId(N,z){return N+"."+z}constructor(N,z,K,H,te){this.d=N,this.e=z,this.f=K,this.g=H,this.h=te}async prepareDocumentPaste(N,z,K,H){if(!this.f.prepareDocumentPaste)return;const te=this.e.getDocument(N),oe=z.map(He=>r.Range.to(He)),Oe=r.DataTransfer.toDataTransfer(K,()=>{throw new L.$$});if(await this.f.prepareDocumentPaste(te,oe,Oe,H),H.isCancellationRequested)return;const Ve=Array.from(Oe).filter(([,He])=>!(He instanceof a.$QM));return r.DataTransfer.from(Ve)}async providePasteEdits(N,z,K,H,te){if(!this.f.provideDocumentPasteEdits)return;const oe=this.e.getDocument(z),Oe=K.map(xe=>r.Range.to(xe)),Ve=r.DataTransfer.toDataTransfer(H,async xe=>(await this.d.$resolvePasteFileData(this.g,N,xe)).buffer),He=await this.f.provideDocumentPasteEdits(oe,Oe,Ve,te);if(He)return{label:He.label??(0,t.localize)(0,null,this.h.displayName||this.h.name),detail:this.h.displayName||this.h.name,yieldTo:He.yieldTo?.map(xe=>"mimeType"in xe?xe:{providerId:O.toInternalProviderId(xe.extensionId,xe.providerId)}),insertText:typeof He.insertText=="string"?He.insertText:{snippet:He.insertText.value},additionalEdit:He.additionalEdit?r.WorkspaceEdit.from(He.additionalEdit,void 0):void 0}}}class V{constructor(N,z){this.d=N,this.e=z}async provideDocumentFormattingEdits(N,z,K){const H=this.d.getDocument(N),te=await this.e.provideDocumentFormattingEdits(H,z,K);if(Array.isArray(te))return te.map(r.TextEdit.from)}}class re{constructor(N,z){this.d=N,this.e=z}async provideDocumentRangeFormattingEdits(N,z,K,H){const te=this.d.getDocument(N),oe=r.Range.to(z),Oe=await this.e.provideDocumentRangeFormattingEdits(te,oe,K,H);if(Array.isArray(Oe))return Oe.map(r.TextEdit.from)}async provideDocumentRangesFormattingEdits(N,z,K,H){(0,k.$3f)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const te=this.d.getDocument(N),oe=z.map(r.Range.to),Oe=await this.e.provideDocumentRangesFormattingEdits(te,oe,K,H);if(Array.isArray(Oe))return Oe.map(r.TextEdit.from)}}class ue{constructor(N,z){this.d=N,this.e=z,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(N,z,K,H,te){const oe=this.d.getDocument(N),Oe=r.Position.to(z),Ve=await this.e.provideOnTypeFormattingEdits(oe,Oe,K,H,te);if(Array.isArray(Ve))return Ve.map(r.TextEdit.from)}}class ye{constructor(N,z){this.e=N,this.f=z,this.d=new i.$Dhc("WorkspaceSymbols")}async provideWorkspaceSymbols(N,z){const K=await this.e.provideWorkspaceSymbols(N,z);if(!(0,S.$Lb)(K))return{symbols:[]};const H=this.d.add(K),te={cacheId:H,symbols:[]};for(let oe=0;oe<K.length;oe++){const Oe=K[oe];if(!Oe||!Oe.name){this.f.warn("INVALID SymbolInformation",Oe);continue}te.symbols.push({...r.WorkspaceSymbol.from(Oe),cacheId:[H,oe]})}return te}async resolveWorkspaceSymbol(N,z){if(typeof this.e.resolveWorkspaceSymbol!="function"||!N.cacheId)return N;const K=this.d.get(...N.cacheId);if(K){const H=await this.e.resolveWorkspaceSymbol(K,z);return H&&(0,f.$Kn)(N,r.WorkspaceSymbol.from(H),!0)}}releaseWorkspaceSymbols(N){this.d.delete(N)}}class De{static supportsResolving(N){return typeof N.prepareRename=="function"}constructor(N,z,K){this.d=N,this.e=z,this.f=K}async provideRenameEdits(N,z,K,H){const te=this.d.getDocument(N),oe=r.Position.to(z);try{const Oe=await this.e.provideRenameEdits(te,oe,K,H);return Oe?r.WorkspaceEdit.from(Oe):void 0}catch(Oe){const Ve=De.g(Oe);return Ve?{rejectReason:Ve,edits:void 0}:Promise.reject(Oe)}}async resolveRenameLocation(N,z,K){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const H=this.d.getDocument(N),te=r.Position.to(z);try{const oe=await this.e.prepareRename(H,te,K);let Oe,Ve;if(a.$4L.isRange(oe)?(Oe=oe,Ve=H.getText(oe)):(0,k.$Uf)(oe)&&(Oe=oe.range,Ve=oe.placeholder),!Oe||!Ve)return;if(Oe.start.line>te.line||Oe.end.line<te.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:r.Range.from(Oe),text:Ve}}catch(oe){const Oe=De.g(oe);return Oe?{rejectReason:Oe,range:void 0,text:void 0}:Promise.reject(oe)}}static g(N){return typeof N=="string"?N:N instanceof Error&&typeof N.message=="string"?N.message:void 0}}class he{constructor(N,z,K){this.d=N,this.e=z,this.f=K}async provideNewSymbolNames(N,z,K){const H=this.d.getDocument(N),te=r.Range.to(z);try{const oe=await this.e.provideNewSymbolNames(H,te,K);return oe?oe.map(Oe=>typeof Oe=="string"?{newSymbolName:Oe}:{newSymbolName:Oe.newSymbolName,tags:Oe.tags}):void 0}catch(oe){this.f.error(he.g(oe)??JSON.stringify(oe,null,"	"));return}}static g(N){return typeof N=="string"?N:N instanceof Error&&typeof N.message=="string"?N.message:void 0}}class ve{constructor(N,z){this.resultId=N,this.tokens=z}}class se{constructor(N,z){this.f=N,this.g=z,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(N,z,K){const H=this.f.getDocument(N),te=z!==0?this.d.get(z):null;let oe=typeof te?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(H,te.resultId,K):await this.g.provideDocumentSemanticTokens(H,K);return te&&this.d.delete(z),oe?(oe=se.h(oe),this.o(se.n(te,oe),oe)):null}async releaseDocumentSemanticColoring(N){this.d.delete(N)}static h(N){return se.j(N)?se.k(N)?N:new a.$iN(new Uint32Array(N.data),N.resultId):se.l(N)?se.m(N)?N:new a.$kN(N.edits.map(z=>new a.$jN(z.start,z.deleteCount,z.data?new Uint32Array(z.data):z.data)),N.resultId):N}static j(N){return N&&!!N.data}static k(N){return N.data instanceof Uint32Array}static l(N){return N&&Array.isArray(N.edits)}static m(N){for(const z of N.edits)if(!(z.data instanceof Uint32Array))return!1;return!0}static n(N,z){if(!se.j(z)||!N||!N.tokens)return z;const K=N.tokens,H=K.length,te=z.data,oe=te.length;let Oe=0;const Ve=Math.min(H,oe);for(;Oe<Ve&&K[Oe]===te[Oe];)Oe++;if(Oe===H&&Oe===oe)return new a.$kN([],z.resultId);let He=0;const xe=Ve-Oe;for(;He<xe&&K[H-He-1]===te[oe-He-1];)He++;return new a.$kN([{start:Oe,deleteCount:H-Oe-He,data:te.subarray(Oe,oe-He)}],z.resultId)}o(N,z){if(se.j(N)){const K=this.e++;return this.d.set(K,new ve(N.resultId,N.data)),(0,c.$8_)({id:K,type:"full",data:N.data})}if(se.l(N)){const K=this.e++;return se.j(z)?this.d.set(K,new ve(z.resultId,z.data)):this.d.set(K,new ve(N.resultId)),(0,c.$8_)({id:K,type:"delta",deltas:(N.edits||[]).map(H=>({start:H.start,deleteCount:H.deleteCount,data:H.data}))})}return null}}class $e{constructor(N,z){this.d=N,this.e=z}async provideDocumentRangeSemanticTokens(N,z,K){const H=this.d.getDocument(N),te=await this.e.provideDocumentRangeSemanticTokens(H,r.Range.to(z),K);return te?this.f(te):null}f(N){return(0,c.$8_)({id:0,type:"full",data:N.data})}}class ee{static supportsResolving(N){return typeof N.resolveCompletionItem=="function"}constructor(N,z,K,H,te){this.f=N,this.g=z,this.h=K,this.j=H,this.k=te,this.d=new i.$Dhc("CompletionItem"),this.e=new Map}async provideCompletionItems(N,z,K,H){const te=this.f.getDocument(N),oe=r.Position.to(z),Oe=te.getWordRangeAtPosition(oe)||new a.$4L(oe,oe),Ve=Oe.with({end:oe}),He=new D.$1d,xe=await this.h.provideCompletionItems(te,oe,H,r.CompletionContext.to(K));if(!xe||H.isCancellationRequested)return;const tt=Array.isArray(xe)?new a.$xM(xe):xe,lt=ee.supportsResolving(this.h)?this.d.add(tt.items):this.d.add([]),rt=new g.$Sc;this.e.set(lt,rt);const it=[],ot={x:lt,b:it,a:{replace:r.Range.from(Oe),insert:r.Range.from(Ve)},c:tt.isIncomplete||void 0,d:He.elapsed()};for(let Be=0;Be<tt.items.length;Be++){const et=tt.items[Be],Y=this.l(et,[lt,Be],Ve,Oe);it.push(Y)}return ot}async resolveCompletionItem(N,z){if(typeof this.h.resolveCompletionItem!="function")return;const K=this.d.get(...N);if(!K)return;const H=this.l(K,N),te=await this.h.resolveCompletionItem(K,z);if(!te)return;const oe=this.l(te,N);return(H.h!==oe.h||H.i!==oe.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(H.n!==oe.n||H.o!==oe.o||!(0,f.$Ln)(H.p,oe.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...H,d:oe.d,c:oe.c,l:oe.l,h:oe.h,i:oe.i,n:oe.n,o:oe.o,p:oe.p}}releaseCompletionItems(N){this.e.get(N)?.dispose(),this.e.delete(N),this.d.delete(N)}l(N,z,K,H){const te=this.e.get(z[0]);if(!te)throw Error("DisposableStore is missing...");const oe=this.g.toInternal(N.command,te),Oe={x:z,a:N.label,b:N.kind!==void 0?r.CompletionItemKind.from(N.kind):void 0,m:N.tags&&N.tags.map(r.CompletionItemTag.from),c:N.detail,d:typeof N.documentation>"u"?void 0:r.MarkdownString.fromStrict(N.documentation),e:N.sortText!==N.label?N.sortText:void 0,f:N.filterText!==N.label?N.filterText:void 0,g:N.preselect||void 0,i:N.keepWhitespace?1:0,k:N.commitCharacters?.join(""),l:N.additionalTextEdits&&N.additionalTextEdits.map(r.TextEdit.from),n:oe?.$ident,o:oe?.id,p:oe?.$ident?void 0:oe?.arguments};N.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Oe.h=N.textEdit.newText):typeof N.insertText=="string"?Oe.h=N.insertText:N.insertText instanceof a.$aM&&(Oe.h=N.insertText.value,Oe.i|=4);let Ve;return N.textEdit?Ve=N.textEdit.range:N.range&&(Ve=N.range),a.$4L.isRange(Ve)?Oe.j=r.Range.from(Ve):Ve&&(!K?.isEqual(Ve.inserting)||!H?.isEqual(Ve.replacing))&&(Oe.j={insert:r.Range.from(Ve.inserting),replace:r.Range.from(Ve.replacing)}),Oe}}class Q{async provideInlineCompletions(N,z,K,H){}disposeCompletions(N){}handleDidShowCompletionItem(N,z,K){}handlePartialAccept(N,z,K){}}class q extends Q{constructor(N,z,K,H){super(),this.f=N,this.g=z,this.h=K,this.j=H,this.d=new Se,this.e=(0,h.$UF)(this.f,"inlineCompletionsAdditions"),this.k={[s.InlineCompletionTriggerKind.Automatic]:a.InlineCompletionTriggerKind.Automatic,[s.InlineCompletionTriggerKind.Explicit]:a.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,h.$UF)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(N,z,K,H){const te=this.g.getDocument(N),oe=r.Position.to(z),Oe=await this.h.provideInlineCompletionItems(te,oe,{selectedCompletionInfo:K.selectedSuggestionInfo?{range:r.Range.to(K.selectedSuggestionInfo.range),text:K.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[K.triggerKind]},H);if(!Oe||H.isCancellationRequested)return;const Ve=Array.isArray(Oe)?Oe:Oe.items,He=this.e?Array.isArray(Oe)?[]:Oe.commands||[]:[],xe=this.e&&!Array.isArray(Oe)?Oe.enableForwardStability:void 0;let tt;return{pid:this.d.createReferenceId({dispose(){tt?.dispose()},items:Ve}),items:Ve.map((rt,it)=>{let ot;rt.command&&(tt||(tt=new g.$Sc),ot=this.j.toInternal(rt.command,tt));const Be=rt.insertText;return{insertText:typeof Be=="string"?Be:{snippet:Be.value},filterText:rt.filterText,range:rt.range?r.Range.from(rt.range):void 0,command:ot,idx:it,completeBracketPairs:this.e?rt.completeBracketPairs:!1}}),commands:He.map(rt=>(tt||(tt=new g.$Sc),this.j.toInternal(rt,tt))),suppressSuggestions:!1,enableForwardStability:xe}}disposeCompletions(N){this.d.disposeReferenceId(N)?.dispose()}handleDidShowCompletionItem(N,z,K){const H=this.d.get(N)?.items[z];H&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(H,K)}handlePartialAccept(N,z,K){const H=this.d.get(N)?.items[z];H&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&this.h.handleDidPartiallyAcceptCompletionItem(H,K)}}class ne{async provideInlineEdits(N,z,K){const H=this.f.getDocument(N),te=await this.g.provideInlineEdit(H,{triggerKind:this.e[z.triggerKind]},K);if(!te||K.isCancellationRequested)return;let oe;const Oe=this.d.createReferenceId({dispose(){oe?.dispose()},item:te});let Ve;te.accepted&&(oe||(oe=new g.$Sc),Ve=this.h.toInternal(te.accepted,oe));let He;return te.rejected&&(oe||(oe=new g.$Sc),He=this.h.toInternal(te.rejected,oe)),{pid:Oe,text:te.text,range:r.Range.from(te.range),accepted:Ve,rejected:He}}disposeEdit(N){this.d.disposeReferenceId(N)?.dispose()}constructor(N,z,K,H){this.f=z,this.g=K,this.h=H,this.d=new Se,this.e={[s.InlineEditTriggerKind.Automatic]:a.InlineEditTriggerKind.Automatic,[s.InlineEditTriggerKind.Invoke]:a.InlineEditTriggerKind.Invoke}}}class Se{constructor(){this.d=new Map,this.e=1}createReferenceId(N){const z=this.e++;return this.d.set(z,N),z}disposeReferenceId(N){const z=this.d.get(N);return this.d.delete(N),z}get(N){return this.d.get(N)}}class Te{constructor(N,z){this.e=N,this.f=z,this.d=new i.$Dhc("SignatureHelp")}async provideSignatureHelp(N,z,K,H){const te=this.e.getDocument(N),oe=r.Position.to(z),Oe=this.g(K),Ve=await this.f.provideSignatureHelp(te,oe,H,Oe);if(Ve){const He=this.d.add([Ve]);return{...r.SignatureHelp.from(Ve),id:He}}}g(N){let z;if(N.activeSignatureHelp){const K=r.SignatureHelp.to(N.activeSignatureHelp),H=this.d.get(N.activeSignatureHelp.id,0);H?(z=H,z.activeSignature=K.activeSignature,z.activeParameter=K.activeParameter):z=K}return{...N,activeSignatureHelp:z}}releaseSignatureHelp(N){this.d.delete(N)}}class Ce{constructor(N,z,K,H,te){this.f=N,this.g=z,this.h=K,this.j=H,this.k=te,this.d=new i.$Dhc("InlayHints"),this.e=new Map}async provideInlayHints(N,z,K){const H=this.f.getDocument(N),te=r.Range.to(z),oe=await this.h.provideInlayHints(H,te,K);if(!Array.isArray(oe)||oe.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(z)}`);return}if(K.isCancellationRequested)return;const Oe=this.d.add(oe);this.e.set(Oe,new g.$Sc);const Ve={hints:[],cacheId:Oe};for(let He=0;He<oe.length;He++)this.l(oe[He],te)&&Ve.hints.push(this.m(oe[He],[Oe,He]));return this.j.trace(`[InlayHints] ${Ve.hints.length} inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(z)}`),Ve}async resolveInlayHint(N,z){if(typeof this.h.resolveInlayHint!="function")return;const K=this.d.get(...N);if(!K)return;const H=await this.h.resolveInlayHint(K,z);if(H&&this.l(H))return this.m(H,N)}releaseHints(N){this.e.get(N)?.dispose(),this.e.delete(N),this.d.delete(N)}l(N,z){return N.label.length===0||Array.isArray(N.label)&&N.label.every(K=>K.value.length===0)?(console.log("INVALID inlay hint, empty label",N),!1):!(z&&!z.contains(N.position))}m(N,z){const K=this.e.get(z[0]);if(!K)throw Error("DisposableStore is missing...");const H={label:"",cacheId:z,tooltip:r.MarkdownString.fromStrict(N.tooltip),position:r.Position.from(N.position),textEdits:N.textEdits&&N.textEdits.map(r.TextEdit.from),kind:N.kind&&r.InlayHintKind.from(N.kind),paddingLeft:N.paddingLeft,paddingRight:N.paddingRight};if(typeof N.label=="string")H.label=N.label;else{const te=[];H.label=te;for(const oe of N.label){if(!oe.value){console.warn("INVALID inlay hint, empty label part",this.k.identifier.value);continue}const Oe={label:oe.value,tooltip:r.MarkdownString.fromStrict(oe.tooltip)};a.$bM.isLocation(oe.location)&&(Oe.location=r.location.from(oe.location)),oe.command&&(Oe.command=this.g.toInternal(oe.command,K)),te.push(Oe)}}return H}}class we{constructor(N,z){this.e=N,this.f=z,this.d=new i.$Dhc("DocumentLink")}async provideLinks(N,z){const K=this.e.getDocument(N),H=await this.f.provideDocumentLinks(K,z);if(!(!Array.isArray(H)||H.length===0)&&!z.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:H.filter(we.g).map(r.DocumentLink.from)};{const te=this.d.add(H),oe={links:[],cacheId:te};for(let Oe=0;Oe<H.length;Oe++){if(!we.g(H[Oe]))continue;const Ve=r.DocumentLink.from(H[Oe]);Ve.cacheId=[te,Oe],oe.links.push(Ve)}return oe}}}static g(N){return N.target&&N.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(N,z){if(typeof this.f.resolveDocumentLink!="function")return;const K=this.d.get(...N);if(!K)return;const H=await this.f.resolveDocumentLink(K,z);if(!(!H||!we.g(H)))return r.DocumentLink.from(H)}releaseLinks(N){this.d.delete(N)}}class ge{constructor(N,z){this.d=N,this.e=z}async provideColors(N,z){const K=this.d.getDocument(N),H=await this.e.provideDocumentColors(K,z);return Array.isArray(H)?H.map(oe=>({color:r.Color.from(oe.color),range:r.Range.from(oe.range)})):[]}async provideColorPresentations(N,z,K){const H=this.d.getDocument(N),te=r.Range.to(z.range),oe=r.Color.to(z.color),Oe=await this.e.provideColorPresentations(oe,{document:H,range:te},K);if(Array.isArray(Oe))return Oe.map(r.ColorPresentation.from)}}class J{constructor(N,z){this.d=N,this.e=z}async provideFoldingRanges(N,z,K){const H=this.d.getDocument(N),te=await this.e.provideFoldingRanges(H,z,K);if(Array.isArray(te))return te.map(r.FoldingRange.from)}}class x{constructor(N,z,K){this.d=N,this.e=z,this.f=K}async provideSelectionRanges(N,z,K){const H=this.d.getDocument(N),te=z.map(r.Position.to),oe=await this.e.provideSelectionRanges(H,te,K);if(!(0,S.$Lb)(oe))return[];if(oe.length!==te.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Oe=[];for(let Ve=0;Ve<te.length;Ve++){const He=[];Oe.push(He);let xe=te[Ve],tt=oe[Ve];for(;;){if(!tt.range.contains(xe))throw new Error("INVALID selection range, must contain the previous range");if(He.push(r.SelectionRange.from(tt)),!tt.parent)break;xe=tt.range,tt=tt.parent}}return Oe}}class le{constructor(N,z){this.f=N,this.g=z,this.d=new R.$jO(""),this.e=new Map}async prepareSession(N,z,K){const H=this.f.getDocument(N),te=r.Position.to(z),oe=await this.g.prepareCallHierarchy(H,te,K);if(!oe)return;const Oe=this.d.nextId();return this.e.set(Oe,new Map),Array.isArray(oe)?oe.map(Ve=>this.h(Oe,Ve)):[this.h(Oe,oe)]}async provideCallsTo(N,z,K){const H=this.j(N,z);if(!H)throw new Error("missing call hierarchy item");const te=await this.g.provideCallHierarchyIncomingCalls(H,K);if(te)return te.map(oe=>({from:this.h(N,oe.from),fromRanges:oe.fromRanges.map(Oe=>r.Range.from(Oe))}))}async provideCallsFrom(N,z,K){const H=this.j(N,z);if(!H)throw new Error("missing call hierarchy item");const te=await this.g.provideCallHierarchyOutgoingCalls(H,K);if(te)return te.map(oe=>({to:this.h(N,oe.to),fromRanges:oe.fromRanges.map(Oe=>r.Range.from(Oe))}))}releaseSession(N){this.e.delete(N)}h(N,z){const K=this.e.get(N),H=r.CallHierarchyItem.from(z,N,K.size.toString(36));return K.set(H._itemId,z),H}j(N,z){return this.e.get(N)?.get(z)}}class de{constructor(N,z){this.f=N,this.g=z,this.d=new R.$jO(""),this.e=new Map}async prepareSession(N,z,K){const H=this.f.getDocument(N),te=r.Position.to(z),oe=await this.g.prepareTypeHierarchy(H,te,K);if(!oe)return;const Oe=this.d.nextId();return this.e.set(Oe,new Map),Array.isArray(oe)?oe.map(Ve=>this.h(Oe,Ve)):[this.h(Oe,oe)]}async provideSupertypes(N,z,K){const H=this.j(N,z);if(!H)throw new Error("missing type hierarchy item");const te=await this.g.provideTypeHierarchySupertypes(H,K);if(te)return te.map(oe=>this.h(N,oe))}async provideSubtypes(N,z,K){const H=this.j(N,z);if(!H)throw new Error("missing type hierarchy item");const te=await this.g.provideTypeHierarchySubtypes(H,K);if(te)return te.map(oe=>this.h(N,oe))}releaseSession(N){this.e.delete(N)}h(N,z){const K=this.e.get(N),H=r.TypeHierarchyItem.from(z,N,K.size.toString(36));return K.set(H._itemId,z),H}j(N,z){return this.e.get(N)?.get(z)}}class Pe{static toInternalProviderId(N,z){return N+"."+z}constructor(N,z,K,H,te){this.d=N,this.e=z,this.f=K,this.g=H,this.h=te}async provideDocumentOnDropEdits(N,z,K,H,te){const oe=this.e.getDocument(z),Oe=r.Position.to(K),Ve=r.DataTransfer.toDataTransfer(H,async xe=>(await this.d.$resolveDocumentOnDropFileData(this.g,N,xe)).buffer),He=await this.f.provideDocumentDropEdits(oe,Oe,Ve,te);if(He)return{label:He.label??(0,t.localize)(1,null,this.h.displayName||this.h.name),yieldTo:He.yieldTo?.map(xe=>"mimeType"in xe?xe:{providerId:Pe.toInternalProviderId(xe.extensionId,xe.providerId)}),insertText:typeof He.insertText=="string"?He.insertText:{snippet:He.insertText.value},additionalEdit:He.additionalEdit?r.WorkspaceEdit.from(He.additionalEdit,void 0):void 0}}}class me{constructor(N,z){this.d=N,this.e=z}async provideMappedEdits(N,z,K,H){const te=l.URI.revive(N),oe=this.d.getDocument(te),Oe=K.documents.map(xe=>xe.map(tt=>({uri:l.URI.revive(tt.uri),version:tt.version,ranges:tt.ranges.map(lt=>r.Range.to(lt))}))),Ve={documents:Oe,selections:Oe[0]?.[0]?.ranges??[]},He=await this.e.provideMappedEdits(oe,z,Ve,H);return He?r.WorkspaceEdit.from(He):null}}class Ie{constructor(N,z){this.adapter=N,this.extension=z}}class Me{static{this.d=0}constructor(N,z,K,H,te,oe,Oe,Ve){this.g=z,this.h=K,this.j=H,this.k=te,this.l=oe,this.m=Oe,this.n=Ve,this.f=new Map,this.e=N.getProxy(p.$ZL.MainThreadLanguageFeatures)}o(N,z){return r.DocumentSelector.from(N,this.g,z)}p(N){return new a.$2L(()=>{this.f.delete(N),this.e.$unregister(N)})}q(){return Me.d++}async s(N,z,K,H,te,oe=!1){const Oe=this.f.get(N);if(!Oe||!(Oe.adapter instanceof z))return H;const Ve=Date.now();oe||this.l.trace(`[${Oe.extension.identifier.value}] INVOKE provider '${K.toString().replace(/[\r\n]/g,"")}'`);const He=K(Oe.adapter,Oe.extension);return Promise.resolve(He).catch(xe=>{(0,L.$4)(xe)||(this.l.error(`[${Oe.extension.identifier.value}] provider FAILED`),this.l.error(xe),this.n.onExtensionError(Oe.extension.identifier,xe))}).finally(()=>{oe||this.l.trace(`[${Oe.extension.identifier.value}] provider DONE after ${Date.now()-Ve}ms`)}),P.CancellationToken.isCancellationToken(te)?(0,F.$6g)(He,te):He}t(N,z){const K=this.q();return this.f.set(K,new Ie(N,z)),K}static u(N){return N.displayName||N.name}registerDocumentSymbolProvider(N,z,K,H){const te=this.t(new u(this.h,K),N),oe=H&&H.label||Me.u(N);return this.e.$registerDocumentSymbolProvider(te,this.o(z,N),oe),this.p(te)}$provideDocumentSymbols(N,z,K){return this.s(N,u,H=>H.provideDocumentSymbols(l.URI.revive(z),K),void 0,K)}registerCodeLensProvider(N,z,K){const H=this.q(),te=typeof K.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(H,new Ie(new o(this.h,this.j.converter,K,N,this.n,this.l),N)),this.e.$registerCodeLensSupport(H,this.o(z,N),te);let oe=this.p(H);if(te!==void 0){const Oe=K.onDidChangeCodeLenses(Ve=>this.e.$emitCodeLensEvent(te));oe=a.$2L.from(oe,Oe)}return oe}$provideCodeLenses(N,z,K){return this.s(N,o,H=>H.provideCodeLenses(l.URI.revive(z),K),void 0,K)}$resolveCodeLens(N,z,K){return this.s(N,o,H=>H.resolveCodeLens(z,K),void 0,void 0)}$releaseCodeLenses(N,z){this.s(N,o,K=>Promise.resolve(K.releaseCodeLenses(z)),void 0,void 0)}registerDefinitionProvider(N,z,K){const H=this.t(new w(this.h,K),N);return this.e.$registerDefinitionSupport(H,this.o(z,N)),this.p(H)}$provideDefinition(N,z,K,H){return this.s(N,w,te=>te.provideDefinition(l.URI.revive(z),K,H),[],H)}registerDeclarationProvider(N,z,K){const H=this.t(new m(this.h,K),N);return this.e.$registerDeclarationSupport(H,this.o(z,N)),this.p(H)}$provideDeclaration(N,z,K,H){return this.s(N,m,te=>te.provideDeclaration(l.URI.revive(z),K,H),[],H)}registerImplementationProvider(N,z,K){const H=this.t(new I(this.h,K),N);return this.e.$registerImplementationSupport(H,this.o(z,N)),this.p(H)}$provideImplementation(N,z,K,H){return this.s(N,I,te=>te.provideImplementation(l.URI.revive(z),K,H),[],H)}registerTypeDefinitionProvider(N,z,K){const H=this.t(new d(this.h,K),N);return this.e.$registerTypeDefinitionSupport(H,this.o(z,N)),this.p(H)}$provideTypeDefinition(N,z,K,H){return this.s(N,d,te=>te.provideTypeDefinition(l.URI.revive(z),K,H),[],H)}registerHoverProvider(N,z,K,H){const te=this.t(new y(this.h,K),N);return this.e.$registerHoverProvider(te,this.o(z,N)),this.p(te)}$provideHover(N,z,K,H){return this.s(N,y,te=>te.provideHover(l.URI.revive(z),K,H),void 0,H)}registerEvaluatableExpressionProvider(N,z,K,H){const te=this.t(new b(this.h,K),N);return this.e.$registerEvaluatableExpressionProvider(te,this.o(z,N)),this.p(te)}$provideEvaluatableExpression(N,z,K,H){return this.s(N,b,te=>te.provideEvaluatableExpression(l.URI.revive(z),K,H),void 0,H)}registerInlineValuesProvider(N,z,K,H){const te=typeof K.onDidChangeInlineValues=="function"?this.q():void 0,oe=this.t(new A(this.h,K),N);this.e.$registerInlineValuesProvider(oe,this.o(z,N),te);let Oe=this.p(oe);if(te!==void 0){const Ve=K.onDidChangeInlineValues(He=>this.e.$emitInlineValuesEvent(te));Oe=a.$2L.from(Oe,Ve)}return Oe}$provideInlineValues(N,z,K,H,te){return this.s(N,A,oe=>oe.provideInlineValues(l.URI.revive(z),K,H,te),void 0,te)}registerDocumentHighlightProvider(N,z,K){const H=this.t(new T(this.h,K),N);return this.e.$registerDocumentHighlightProvider(H,this.o(z,N)),this.p(H)}registerMultiDocumentHighlightProvider(N,z,K){const H=this.t(new G(this.h,K),N);return this.e.$registerMultiDocumentHighlightProvider(H,this.o(z,N)),this.p(H)}$provideDocumentHighlights(N,z,K,H){return this.s(N,T,te=>te.provideDocumentHighlights(l.URI.revive(z),K,H),void 0,H)}$provideMultiDocumentHighlights(N,z,K,H,te){return this.s(N,G,oe=>oe.provideMultiDocumentHighlights(l.URI.revive(z),K,H.map(Oe=>l.URI.revive(Oe)),te),void 0,te)}registerLinkedEditingRangeProvider(N,z,K){const H=this.t(new W(this.h,K),N);return this.e.$registerLinkedEditingRangeProvider(H,this.o(z,N)),this.p(H)}$provideLinkedEditingRanges(N,z,K,H){return this.s(N,W,async te=>{const oe=await te.provideLinkedEditingRanges(l.URI.revive(z),K,H);if(oe)return{ranges:oe.ranges,wordPattern:oe.wordPattern?Me.w(oe.wordPattern):void 0}},void 0,H)}registerReferenceProvider(N,z,K){const H=this.t(new U(this.h,K),N);return this.e.$registerReferenceSupport(H,this.o(z,N)),this.p(H)}$provideReferences(N,z,K,H,te){return this.s(N,U,oe=>oe.provideReferences(l.URI.revive(z),K,H,te),void 0,te)}registerCodeActionProvider(N,z,K,H){const te=new g.$Sc,oe=this.t(new C(this.h,this.j.converter,this.k,K,this.l,N,this.m),N);return this.e.$registerQuickFixSupport(oe,this.o(z,N),{providedKinds:H?.providedCodeActionKinds?.map(Oe=>Oe.value),documentation:H?.documentation?.map(Oe=>({kind:Oe.kind.value,command:this.j.converter.toInternal(Oe.command,te)}))},Me.u(N),!!K.resolveCodeAction),te.add(this.p(oe)),te}$provideCodeActions(N,z,K,H,te){return this.s(N,C,oe=>oe.provideCodeActions(l.URI.revive(z),K,H,te),void 0,te)}$resolveCodeAction(N,z,K){return this.s(N,C,H=>H.resolveCodeAction(z,K),{},void 0)}$releaseCodeActions(N,z){this.s(N,C,K=>Promise.resolve(K.releaseCodeActions(z)),void 0,void 0)}registerDocumentFormattingEditProvider(N,z,K){const H=this.t(new V(this.h,K),N);return this.e.$registerDocumentFormattingSupport(H,this.o(z,N),N.identifier,N.displayName||N.name),this.p(H)}$provideDocumentFormattingEdits(N,z,K,H){return this.s(N,V,te=>te.provideDocumentFormattingEdits(l.URI.revive(z),K,H),void 0,H)}registerDocumentRangeFormattingEditProvider(N,z,K){const H=typeof K.provideDocumentRangesFormattingEdits=="function",te=this.t(new re(this.h,K),N);return this.e.$registerRangeFormattingSupport(te,this.o(z,N),N.identifier,N.displayName||N.name,H),this.p(te)}$provideDocumentRangeFormattingEdits(N,z,K,H,te){return this.s(N,re,oe=>oe.provideDocumentRangeFormattingEdits(l.URI.revive(z),K,H,te),void 0,te)}$provideDocumentRangesFormattingEdits(N,z,K,H,te){return this.s(N,re,oe=>oe.provideDocumentRangesFormattingEdits(l.URI.revive(z),K,H,te),void 0,te)}registerOnTypeFormattingEditProvider(N,z,K,H){const te=this.t(new ue(this.h,K),N);return this.e.$registerOnTypeFormattingSupport(te,this.o(z,N),H,N.identifier),this.p(te)}$provideOnTypeFormattingEdits(N,z,K,H,te,oe){return this.s(N,ue,Oe=>Oe.provideOnTypeFormattingEdits(l.URI.revive(z),K,H,te,oe),void 0,oe)}registerWorkspaceSymbolProvider(N,z){const K=this.t(new ye(z,this.l),N);return this.e.$registerNavigateTypeSupport(K,typeof z.resolveWorkspaceSymbol=="function"),this.p(K)}$provideWorkspaceSymbols(N,z,K){return this.s(N,ye,H=>H.provideWorkspaceSymbols(z,K),{symbols:[]},K)}$resolveWorkspaceSymbol(N,z,K){return this.s(N,ye,H=>H.resolveWorkspaceSymbol(z,K),void 0,void 0)}$releaseWorkspaceSymbols(N,z){this.s(N,ye,K=>K.releaseWorkspaceSymbols(z),void 0,void 0)}registerRenameProvider(N,z,K){const H=this.t(new De(this.h,K,this.l),N);return this.e.$registerRenameSupport(H,this.o(z,N),De.supportsResolving(K)),this.p(H)}$provideRenameEdits(N,z,K,H,te){return this.s(N,De,oe=>oe.provideRenameEdits(l.URI.revive(z),K,H,te),void 0,te)}$resolveRenameLocation(N,z,K,H){return this.s(N,De,te=>te.resolveRenameLocation(l.URI.revive(z),K,H),void 0,H)}registerNewSymbolNamesProvider(N,z,K){const H=this.t(new he(this.h,K,this.l),N);return this.e.$registerNewSymbolNamesProvider(H,this.o(z,N)),this.p(H)}$provideNewSymbolNames(N,z,K,H){return this.s(N,he,te=>te.provideNewSymbolNames(l.URI.revive(z),K,H),void 0,H)}registerDocumentSemanticTokensProvider(N,z,K,H){const te=this.t(new se(this.h,K),N),oe=typeof K.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(te,this.o(z,N),H,oe);let Oe=this.p(te);if(oe){const Ve=K.onDidChangeSemanticTokens(He=>this.e.$emitDocumentSemanticTokensEvent(oe));Oe=a.$2L.from(Oe,Ve)}return Oe}$provideDocumentSemanticTokens(N,z,K,H){return this.s(N,se,te=>te.provideDocumentSemanticTokens(l.URI.revive(z),K,H),null,H)}$releaseDocumentSemanticTokens(N,z){this.s(N,se,K=>K.releaseDocumentSemanticColoring(z),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(N,z,K,H){const te=this.t(new $e(this.h,K),N);return this.e.$registerDocumentRangeSemanticTokensProvider(te,this.o(z,N),H),this.p(te)}$provideDocumentRangeSemanticTokens(N,z,K,H){return this.s(N,$e,te=>te.provideDocumentRangeSemanticTokens(l.URI.revive(z),K,H),null,H)}registerCompletionItemProvider(N,z,K,H){const te=this.t(new ee(this.h,this.j.converter,K,this.m,N),N);return this.e.$registerCompletionsProvider(te,this.o(z,N),H,ee.supportsResolving(K),N.identifier),this.p(te)}$provideCompletionItems(N,z,K,H,te){return this.s(N,ee,oe=>oe.provideCompletionItems(l.URI.revive(z),K,H,te),void 0,te)}$resolveCompletionItem(N,z,K){return this.s(N,ee,H=>H.resolveCompletionItem(z,K),void 0,K)}$releaseCompletionItems(N,z){this.s(N,ee,K=>K.releaseCompletionItems(z),void 0,void 0)}registerInlineCompletionsProvider(N,z,K,H){const te=new q(N,this.h,K,this.j.converter),oe=this.t(te,N);return this.e.$registerInlineCompletionsSupport(oe,this.o(z,N),te.supportsHandleEvents,n.$wm.toKey(N.identifier.value),H?.yieldTo?.map(Oe=>n.$wm.toKey(Oe))||[]),this.p(oe)}$provideInlineCompletions(N,z,K,H,te){return this.s(N,Q,oe=>oe.provideInlineCompletions(l.URI.revive(z),K,H,te),void 0,te)}$handleInlineCompletionDidShow(N,z,K,H){this.s(N,Q,async te=>{te.handleDidShowCompletionItem(z,K,H)},void 0,void 0)}$handleInlineCompletionPartialAccept(N,z,K,H){this.s(N,Q,async te=>{te.handlePartialAccept(z,K,H)},void 0,void 0)}$freeInlineCompletionsList(N,z){this.s(N,Q,async K=>{K.disposeCompletions(z)},void 0,void 0)}registerInlineEditProvider(N,z,K){const H=new ne(N,this.h,K,this.j.converter),te=this.t(H,N);return this.e.$registerInlineEditProvider(te,this.o(z,N),N.identifier),this.p(te)}$provideInlineEdit(N,z,K,H){return this.s(N,ne,te=>te.provideInlineEdits(l.URI.revive(z),K,H),void 0,H)}$freeInlineEdit(N,z){this.s(N,ne,async K=>{K.disposeEdit(z)},void 0,void 0)}registerSignatureHelpProvider(N,z,K,H){const te=Array.isArray(H)?{triggerCharacters:H,retriggerCharacters:[]}:H,oe=this.t(new Te(this.h,K),N);return this.e.$registerSignatureHelpProvider(oe,this.o(z,N),te),this.p(oe)}$provideSignatureHelp(N,z,K,H,te){return this.s(N,Te,oe=>oe.provideSignatureHelp(l.URI.revive(z),K,H,te),void 0,te)}$releaseSignatureHelp(N,z){this.s(N,Te,K=>K.releaseSignatureHelp(z),void 0,void 0)}registerInlayHintsProvider(N,z,K){const H=typeof K.onDidChangeInlayHints=="function"?this.q():void 0,te=this.t(new Ce(this.h,this.j.converter,K,this.l,N),N);this.e.$registerInlayHintsProvider(te,this.o(z,N),typeof K.resolveInlayHint=="function",H,Me.u(N));let oe=this.p(te);if(H!==void 0){const Oe=K.onDidChangeInlayHints(Ve=>this.e.$emitInlayHintsEvent(H));oe=a.$2L.from(oe,Oe)}return oe}$provideInlayHints(N,z,K,H){return this.s(N,Ce,te=>te.provideInlayHints(l.URI.revive(z),K,H),void 0,H)}$resolveInlayHint(N,z,K){return this.s(N,Ce,H=>H.resolveInlayHint(z,K),void 0,K)}$releaseInlayHints(N,z){this.s(N,Ce,K=>K.releaseHints(z),void 0,void 0)}registerDocumentLinkProvider(N,z,K){const H=this.t(new we(this.h,K),N);return this.e.$registerDocumentLinkProvider(H,this.o(z,N),typeof K.resolveDocumentLink=="function"),this.p(H)}$provideDocumentLinks(N,z,K){return this.s(N,we,H=>H.provideLinks(l.URI.revive(z),K),void 0,K,z.scheme==="output")}$resolveDocumentLink(N,z,K){return this.s(N,we,H=>H.resolveLink(z,K),void 0,void 0,!0)}$releaseDocumentLinks(N,z){this.s(N,we,K=>K.releaseLinks(z),void 0,void 0,!0)}registerColorProvider(N,z,K){const H=this.t(new ge(this.h,K),N);return this.e.$registerDocumentColorProvider(H,this.o(z,N)),this.p(H)}$provideDocumentColors(N,z,K){return this.s(N,ge,H=>H.provideColors(l.URI.revive(z),K),[],K)}$provideColorPresentations(N,z,K,H){return this.s(N,ge,te=>te.provideColorPresentations(l.URI.revive(z),K,H),void 0,H)}registerFoldingRangeProvider(N,z,K){const H=this.q(),te=typeof K.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(H,new Ie(new J(this.h,K),N)),this.e.$registerFoldingRangeProvider(H,this.o(z,N),N.identifier,te);let oe=this.p(H);if(te!==void 0){const Oe=K.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(te));oe=a.$2L.from(oe,Oe)}return oe}$provideFoldingRanges(N,z,K,H){return this.s(N,J,te=>te.provideFoldingRanges(l.URI.revive(z),K,H),void 0,H)}registerSelectionRangeProvider(N,z,K){const H=this.t(new x(this.h,K,this.l),N);return this.e.$registerSelectionRangeProvider(H,this.o(z,N)),this.p(H)}$provideSelectionRanges(N,z,K,H){return this.s(N,x,te=>te.provideSelectionRanges(l.URI.revive(z),K,H),[],H)}registerCallHierarchyProvider(N,z,K){const H=this.t(new le(this.h,K),N);return this.e.$registerCallHierarchyProvider(H,this.o(z,N)),this.p(H)}$prepareCallHierarchy(N,z,K,H){return this.s(N,le,te=>Promise.resolve(te.prepareSession(l.URI.revive(z),K,H)),void 0,H)}$provideCallHierarchyIncomingCalls(N,z,K,H){return this.s(N,le,te=>te.provideCallsTo(z,K,H),void 0,H)}$provideCallHierarchyOutgoingCalls(N,z,K,H){return this.s(N,le,te=>te.provideCallsFrom(z,K,H),void 0,H)}$releaseCallHierarchy(N,z){this.s(N,le,K=>Promise.resolve(K.releaseSession(z)),void 0,void 0)}registerTypeHierarchyProvider(N,z,K){const H=this.t(new de(this.h,K),N);return this.e.$registerTypeHierarchyProvider(H,this.o(z,N)),this.p(H)}$prepareTypeHierarchy(N,z,K,H){return this.s(N,de,te=>Promise.resolve(te.prepareSession(l.URI.revive(z),K,H)),void 0,H)}$provideTypeHierarchySupertypes(N,z,K,H){return this.s(N,de,te=>te.provideSupertypes(z,K,H),void 0,H)}$provideTypeHierarchySubtypes(N,z,K,H){return this.s(N,de,te=>te.provideSubtypes(z,K,H),void 0,H)}$releaseTypeHierarchy(N,z){this.s(N,de,K=>Promise.resolve(K.releaseSession(z)),void 0,void 0)}registerDocumentOnDropEditProvider(N,z,K,H){const te=this.q();this.f.set(te,new Ie(new Pe(this.e,this.h,K,te,N),N));const oe=(0,h.$UF)(N,"dropMetadata")&&H?Pe.toInternalProviderId(N.identifier.value,H.id):void 0;return this.e.$registerDocumentOnDropEditProvider(te,this.o(z,N),oe,(0,h.$UF)(N,"dropMetadata")?H:void 0),this.p(te)}$provideDocumentOnDropEdits(N,z,K,H,te,oe){return this.s(N,Pe,Oe=>Promise.resolve(Oe.provideDocumentOnDropEdits(z,l.URI.revive(K),H,te,oe)),void 0,void 0)}registerMappedEditsProvider(N,z,K){const H=this.t(new me(this.h,K),N);return this.e.$registerMappedEditsProvider(H,this.o(z,N)),this.p(H)}$provideMappedEdits(N,z,K,H,te){return this.s(N,me,oe=>Promise.resolve(oe.provideMappedEdits(z,K,H,te)),null,te)}registerDocumentPasteEditProvider(N,z,K,H){const te=this.q();this.f.set(te,new Ie(new O(this.e,this.h,K,te,N),N));const oe=O.toInternalProviderId(N.identifier.value,H.id);return this.e.$registerPasteEditProvider(te,this.o(z,N),oe,{supportsCopy:!!K.prepareDocumentPaste,supportsPaste:!!K.provideDocumentPasteEdits,copyMimeTypes:H.copyMimeTypes,pasteMimeTypes:H.pasteMimeTypes}),this.p(te)}$prepareDocumentPaste(N,z,K,H,te){return this.s(N,O,oe=>oe.prepareDocumentPaste(l.URI.revive(z),K,H,te),void 0,te)}$providePasteEdits(N,z,K,H,te,oe){return this.s(N,O,Oe=>Oe.providePasteEdits(z,l.URI.revive(K),H,te,oe),void 0,oe)}static w(N){return{pattern:N.source,flags:N.flags}}static y(N){return{decreaseIndentPattern:Me.w(N.decreaseIndentPattern),increaseIndentPattern:Me.w(N.increaseIndentPattern),indentNextLinePattern:N.indentNextLinePattern?Me.w(N.indentNextLinePattern):void 0,unIndentedLinePattern:N.unIndentedLinePattern?Me.w(N.unIndentedLinePattern):void 0}}static z(N){return{beforeText:Me.w(N.beforeText),afterText:N.afterText?Me.w(N.afterText):void 0,previousLineText:N.previousLineText?Me.w(N.previousLineText):void 0,action:N.action}}static B(N){return N.map(Me.z)}static C(N){return{open:N.open,close:N.close,notIn:N.notIn?N.notIn.map(z=>a.SyntaxTokenType.toString(z)):void 0}}static D(N){return N.map(Me.C)}setLanguageConfiguration(N,z,K){const{wordPattern:H}=K;if(H&&(0,M.$8e)(H))throw new Error(`Invalid language configuration: wordPattern '${H}' is not allowed to match the empty string.`);H?this.h.setWordDefinitionFor(z,H):this.h.setWordDefinitionFor(z,void 0),K.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",N,"Do not use."),K.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",N,"Do not use.");const te=this.q(),oe={comments:K.comments,brackets:K.brackets,wordPattern:K.wordPattern?Me.w(K.wordPattern):void 0,indentationRules:K.indentationRules?Me.y(K.indentationRules):void 0,onEnterRules:K.onEnterRules?Me.B(K.onEnterRules):void 0,__electricCharacterSupport:K.__electricCharacterSupport,__characterPairSupport:K.__characterPairSupport,autoClosingPairs:K.autoClosingPairs?Me.D(K.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(te,z,oe),this.p(te)}$setWordDefinitions(N){for(const z of N)this.h.setWordDefinitionFor(z.languageId,new RegExp(z.regexSource,z.regexFlags))}}e.$Nhc=Me}),define(Re[260],Ae([1,0,3,8,7,32,11,6,23]),function(fe,e,S,F,P,L,R,g,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ajc=void 0;class D{constructor(k,l,v,$){this.c=l,this.d=v,this.e=$,this.b=[],this.f=0,this.g=new Set,this.a=k.getProxy(S.$ZL.MainThreadLanguages)}$acceptLanguageIds(k){this.b=k}async getLanguages(){return this.b.slice(0)}async changeLanguage(k,l){await this.a.$changeLanguage(k,l);const v=this.c.getDocumentData(k);if(!v)throw new Error(`document '${k.toString()}' NOT found`);return v.document}async tokenAtPosition(k,l){const v=k.version,$=F.Position.from(l),s=await this.a.$tokensAtPosition(k.uri,$),c={type:P.StandardTokenType.Other,range:k.getWordRangeAtPosition(l)??new P.$4L(l.line,l.character,l.line,l.character)};if(!s)return c;const t={range:F.Range.to(s.range),type:F.TokenType.to(s.type)};return!t.range.contains(l)||v!==k.version?c:t}createLanguageStatusItem(k,l,v){const $=this.f++,s=this.a,c=this.g,t=`${k.identifier.value}/${l}`;if(c.has(t))throw new Error(`LanguageStatusItem with id '${l}' ALREADY exists`);c.add(t);const n={selector:v,id:l,name:k.displayName??k.name,severity:P.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let r;const a=new g.$Sc,h=()=>{if(r?.dispose(),!c.has(t)){console.warn(`LanguageStatusItem (${l}) from ${k.identifier.value} has been disposed and CANNOT be updated anymore`);return}r=(0,R.$gh)(()=>{a.clear(),this.a.$setLanguageStatus($,{id:t,name:n.name??k.displayName??k.name,source:k.displayName??k.name,selector:F.DocumentSelector.from(n.selector,this.e),label:n.text,detail:n.detail??"",severity:n.severity===P.LanguageStatusSeverity.Error?L.default.Error:n.severity===P.LanguageStatusSeverity.Warning?L.default.Warning:L.default.Info,command:n.command&&this.d.toInternal(n.command,a),accessibilityInfo:n.accessibilityInformation,busy:n.busy})},0)},i={dispose(){a.dispose(),r?.dispose(),s.$removeLanguageStatus($),c.delete(t)},get id(){return n.id},get name(){return n.name},set name(p){n.name=p,h()},get selector(){return n.selector},set selector(p){n.selector=p,h()},get text(){return n.text},set text(p){n.text=p,h()},set text2(p){(0,f.$VF)(k,"languageStatusText"),n.text=p,h()},get text2(){return(0,f.$VF)(k,"languageStatusText"),n.text},get detail(){return n.detail},set detail(p){n.detail=p,h()},get severity(){return n.severity},set severity(p){n.severity=p,h()},get accessibilityInformation(){return n.accessibilityInformation},set accessibilityInformation(p){n.accessibilityInformation=p,h()},get command(){return n.command},set command(p){n.command=p,h()},get busy(){return n.busy},set busy(p){n.busy=p,h()}};return h(),i}}e.$ajc=D}),define(Re[261],Ae([1,0,12,2,8,7,83]),function(fe,e,S,F,P,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yic=e.$Xic=void 0;class g{constructor(k,l,v,$){this.start=k,this.deletedCount=l,this.deletedItems=v,this.items=$}asApiEvent(){return{range:new L.$pN(this.start,this.start+this.deletedCount),addedCells:this.items.map(k=>k.apiCell),removedCells:this.deletedItems}}}class f{static asModelAddData(k){return{EOL:k.eol,lines:k.source,languageId:k.language,uri:k.uri,isDirty:!1,versionId:1}}constructor(k,l,v){this.notebook=k,this.h=l,this.j=v,this.handle=v.handle,this.uri=F.URI.revive(v.uri),this.cellKind=v.cellKind,this.a=v.outputs.map(P.NotebookCellOutput.to),this.e=v.internalMetadata??{},this.b=Object.freeze(v.metadata??{}),this.d=Object.freeze(P.NotebookCellExecutionSummary.to(v.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const k=this,l=this.h.getDocument(this.uri);if(!l)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const v={get index(){return k.notebook.getCellIndex(k)},notebook:k.notebook.apiNotebook,kind:P.NotebookCellKind.to(this.j.cellKind),document:l.document,get mime(){return k.g},set mime($){k.g=$},get outputs(){return k.a.slice(0)},get metadata(){return k.b},get executionSummary(){return k.d}};this.f=Object.freeze(v)}return this.f}setOutputs(k){this.a=k.map(P.NotebookCellOutput.to)}setOutputItems(k,l,v){const $=v.map(P.NotebookCellOutputItem.to),s=this.a.find(c=>c.id===k);if(s&&(l||(s.items.length=0),s.items.push(...$),s.items.length>1&&s.items.every(c=>R.$3J(c.mime)))){const c=new Map,t=[];s.items.forEach(n=>{let r;c.has(n.mime)?r=c.get(n.mime):(r=[],c.set(n.mime,r),t.push(n.mime)),r.push(n.data)}),s.items.length=0,t.forEach(n=>{const r=R.$4J(c.get(n));s.items.push({mime:n,data:r.data.buffer})})}}setMetadata(k){this.b=Object.freeze(k)}setInternalMetadata(k){this.e=k,this.d=Object.freeze(P.NotebookCellExecutionSummary.to(k))}setMime(k){}}e.$Xic=f;class D{static{this.a=0}constructor(k,l,v,$,s){this.k=k,this.l=l,this.m=v,this.uri=$,this.handle=D.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=s.viewType,this.f=Object.freeze(s.metadata??Object.create(null)),this.r([[0,0,s.cells]],!0,void 0),this.g=s.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const k=this,l={get uri(){return k.uri},get version(){return k.g},get notebookType(){return k.d},get isDirty(){return k.h},get isUntitled(){return k.uri.scheme===S.Schemas.untitled},get isClosed(){return k.j},get metadata(){return k.f},get cellCount(){return k.b.length},cellAt(v){return v=k.n(v),k.b[v].apiCell},getCells(v){return(v?k.p(v):k.b).map(s=>s.apiCell)},save(){return k.q()}};this.e=Object.freeze(l)}return this.e}acceptDocumentPropertiesChanged(k){k.metadata&&(this.f=Object.freeze({...this.f,...k.metadata}))}acceptDirty(k){this.h=k}acceptModelChanged(k,l,v){this.g=k.versionId,this.h=l,this.acceptDocumentPropertiesChanged({metadata:v});const $={notebook:this.apiNotebook,metadata:v,cellChanges:[],contentChanges:[]},s=[];for(const t of k.rawEvents)t.kind===R.NotebookCellsChangeType.ModelChange?this.r(t.changes,!1,$.contentChanges):t.kind===R.NotebookCellsChangeType.Move?this.s(t.index,t.length,t.newIdx,$.contentChanges):t.kind===R.NotebookCellsChangeType.Output?(this.t(t.index,t.outputs),s.push({cell:this.b[t.index].apiCell,outputs:this.b[t.index].apiCell.outputs})):t.kind===R.NotebookCellsChangeType.OutputItem?(this.u(t.index,t.outputId,t.append,t.outputItems),s.push({cell:this.b[t.index].apiCell,outputs:this.b[t.index].apiCell.outputs})):t.kind===R.NotebookCellsChangeType.ChangeCellLanguage?(this.v(t.index,t.language),s.push({cell:this.b[t.index].apiCell,document:this.b[t.index].apiCell.document})):t.kind===R.NotebookCellsChangeType.ChangeCellContent?s.push({cell:this.b[t.index].apiCell,document:this.b[t.index].apiCell.document}):t.kind===R.NotebookCellsChangeType.ChangeCellMime?this.w(t.index,t.mime):t.kind===R.NotebookCellsChangeType.ChangeCellMetadata?(this.x(t.index,t.metadata),s.push({cell:this.b[t.index].apiCell,metadata:this.b[t.index].apiCell.metadata})):t.kind===R.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(t.index,t.internalMetadata),s.push({cell:this.b[t.index].apiCell,executionSummary:this.b[t.index].apiCell.executionSummary}));const c=new Map;for(let t=0;t<s.length;t++){const n=s[t],r=c.get(n.cell);if(r===void 0){const a=$.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...n});c.set(n.cell,a-1)}else $.cellChanges[r]={...$.cellChanges[r],...n}}return Object.freeze($),Object.freeze($.cellChanges),Object.freeze($.contentChanges),$}n(k){return k=k|0,k<0?0:k>=this.b.length?this.b.length-1:k}o(k){let l=k.start|0,v=k.end|0;return l<0&&(l=0),v>this.b.length&&(v=this.b.length),k.with({start:l,end:v})}p(k){k=this.o(k);const l=[];for(let v=k.start;v<k.end;v++)l.push(this.b[v]);return l}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(k,l,v){if(this.j)return;const $=[],s=[],c=[];if(k.reverse().forEach(t=>{const r=t[2].map(i=>{const p=new f(this,this.l,i);return l||s.push(f.asModelAddData(i)),p}),a=new g(t[0],t[1],[],r),h=this.b.splice(t[0],t[1],...r);for(const i of h)c.push(i.uri),a.deletedItems.push(i.apiCell);$.push(a)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:s,removedDocuments:c}),v)for(const t of $)v.push(t.asApiEvent())}s(k,l,v,$){const s=this.b.splice(k,l);this.b.splice(v,0,...s);const c=[new g(k,l,s.map(t=>t.apiCell),[]),new g(v,0,[],s)];for(const t of c)$.push(t.asApiEvent())}t(k,l){this.b[k].setOutputs(l)}u(k,l,v,$){this.b[k].setOutputItems(l,v,$)}v(k,l){const v=this.b[k];v.apiCell.document.languageId!==l&&this.m.$acceptModelLanguageChanged(v.uri,l)}w(k,l){const v=this.b[k];v.apiCell.mime=l}x(k,l){this.b[k].setMetadata(l)}y(k,l){this.b[k].setInternalMetadata(l)}getCellFromApiCell(k){return this.b.find(l=>l.apiCell===k)}getCellFromIndex(k){return this.b[k]}getCell(k){return this.b.find(l=>l.handle===k)}getCellIndex(k){return this.b.indexOf(k)}}e.$Yic=D}),define(Re[262],Ae([1,0,5,2,8,7]),function(fe,e,S,F,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cjc=void 0;class R{constructor(f,D,M,k={timeout:1500,errors:3}){this.b=f,this.c=D,this.d=M,this.f=k,this.a=new S.$7d}dispose(){}getOnWillSaveNotebookDocumentEvent(f){return(D,M,k)=>{const l=function($){D.call(M,$)};return l.extension=f,this.a.event(l,void 0,k)}}async $participateInSave(f,D,M){const k=F.URI.revive(f),l=this.c.getNotebookDocument(k);if(!l)throw new Error("Unable to resolve notebook document");const v=[];if(await this.a.fireAsync({notebook:l.apiNotebook,reason:P.TextDocumentSaveReason.to(D)},M,async(s,c)=>{const t=Date.now(),n=await await Promise.resolve(s);Date.now()-t>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",c.extension.identifier),!M.isCancellationRequested&&n&&(n instanceof L.$_L?v.push(n):this.b.warn("onWillSaveNotebookDocument-listener from extension",c.extension.identifier,"ignored due to invalid data"))}),M.isCancellationRequested)return!1;if(v.length===0)return!0;const $={edits:[]};for(const s of v){const{edits:c}=P.WorkspaceEdit.from(s);$.edits=$.edits.concat(c)}return this.d.$tryApplyWorkspaceEdit($)}}e.$cjc=R}),define(Re[110],Ae([1,0,15,8,7]),function(fe,e,S,F,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zic=void 0;class L{static{this.apiEditorsToExtHost=new WeakMap}constructor(g,f,D,M,k,l){this.id=g,this.f=f,this.notebookData=D,this.a=[],this.b=[],this.d=!1,this.a=k,this.b=M,this.c=l}get apiEditor(){if(!this.e){const g=this;this.e={get notebook(){return g.notebookData.apiNotebook},get selection(){return g.a[0]},set selection(f){this.selections=[f]},get selections(){return g.a},set selections(f){if(!Array.isArray(f)||!f.every(P.$pN.isNotebookRange))throw(0,S.$7)("selections");g.a=f,g.g(f)},get visibleRanges(){return g.b},revealRange(f,D){g.f.$tryRevealRange(g.id,F.NotebookRange.from(f),D??P.NotebookEditorRevealType.Default)},get viewColumn(){return g.c}},L.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(g){this.d=g}_acceptVisibleRanges(g){this.b=g}_acceptSelections(g){this.a=g}g(g){this.f.$trySetSelections(this.id,g.map(F.NotebookRange.from))}_acceptViewColumn(g){this.c=g}}e.$Zic=L}),define(Re[263],Ae([1,0,5,14,8]),function(fe,e,S,F,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ejc=void 0;let L=class{constructor(g,f){this.c=g,this.d=f,this.a=new S.$5d,this.b=new S.$5d,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(g,f){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",g,f);const D=this.d.getEditorById(g);f.visibleRanges&&D._acceptVisibleRanges(f.visibleRanges.ranges.map(P.NotebookRange.to)),f.selections&&D._acceptSelections(f.selections.selections.map(P.NotebookRange.to)),f.visibleRanges&&this.b.fire({notebookEditor:D.apiEditor,visibleRanges:D.apiEditor.visibleRanges}),f.selections&&this.a.fire(Object.freeze({notebookEditor:D.apiEditor,selections:D.apiEditor.selections}))}$acceptEditorViewColumns(g){for(const f in g)this.d.getEditorById(f)._acceptViewColumn(P.ViewColumn.to(g[f]))}};e.$ejc=L,e.$ejc=L=Ze([qe(0,F.$yj)],L)}),define(Re[264],Ae([1,0,5,3,110]),function(fe,e,S,F,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hjc=void 0;class L{constructor(g,f){this.c=f,this.a=new Map,this.b=g.getProxy(F.$ZL.MainThreadNotebookRenderers)}$postRendererMessage(g,f,D){const M=this.c.getEditorById(g);this.a.get(f)?.fire({editor:M.apiEditor,message:D})}createRendererMessaging(g,f){if(!g.contributes?.notebookRenderer?.some(M=>M.id===f))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${f})`);return{onDidReceiveMessage:(M,k,l)=>this.d(f).event(M,k,l),postMessage:(M,k)=>{P.$Zic.apiEditorsToExtHost.has(M)&&([M,k]=[k,M]);const l=k&&P.$Zic.apiEditorsToExtHost.get(k);return this.b.$postMessage(l?.id,f,M)}}}d(g){let f=this.a.get(g);return f||(f=new S.$5d({onDidRemoveLastListener:()=>{f?.dispose(),this.a.delete(g)}}),this.a.set(g,f),f)}}e.$hjc=L}),define(Re[265],Ae([1,0,8,99,22,68,15]),function(fe,e,S,F,P,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ljc=void 0;class g{constructor(k){this.b=0,this.c=new Map,this.a=k}async withProgress(k,l,v){const $=this.b++,{title:s,location:c,cancellable:t}=l,n={label:k.displayName||k.name,id:k.identifier.value};return this.a.$startProgress($,{location:S.ProgressLocation.from(c),title:s,source:n,cancellable:t},k.isUnderDevelopment?void 0:k.identifier.value).catch(R.$2),this.d($,v,!!t)}d(k,l,v){let $;v&&($=new P.$ce,this.c.set(k,$));const s=t=>{this.a.$progressEnd(t),this.c.delete(t),$?.dispose()};let c;try{c=l(new D(this.a,k),v&&$?$.token:P.CancellationToken.None)}catch(t){throw s(k),t}return c.then(t=>s(k),t=>s(k)),c}$acceptProgressCanceled(k){const l=this.c.get(k);l&&(l.cancel(),this.c.delete(k))}}e.$ljc=g;function f(M,k){return M.message=k.message,typeof k.increment=="number"&&(typeof M.increment=="number"?M.increment+=k.increment:M.increment=k.increment),M}class D extends F.$Hv{constructor(k,l){super(v=>this.throttledReport(v)),this.c=k,this.d=l}throttledReport(k){this.c.$progressReport(this.d,k)}}Ze([(0,L.$Kh)(100,(M,k)=>f(M,k),()=>Object.create(null))],D.prototype,"throttledReport",null)}),define(Re[266],Ae([1,0,2,3,11,8]),function(fe,e,S,F,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mjc=void 0;class R{static{this.a=0}constructor(f,D){this.d=D,this.c=new Map,this.b=f.getProxy(F.$ZL.MainThreadQuickDiff)}$provideOriginalResource(f,D,M){const k=S.URI.revive(D),l=this.c.get(f);return l?(0,P.$9g)(()=>l.provideOriginalResource(k,M)).then(v=>v||null):Promise.resolve(null)}registerQuickDiffProvider(f,D,M,k){const l=R.a++;return this.c.set(l,D),this.b.$registerQuickDiffProvider(l,L.DocumentSelector.from(f,this.d),M,k),{dispose:()=>{this.b.$unregisterQuickDiffProvider(l),this.c.delete(l)}}}}e.$mjc=R}),define(Re[267],Ae([1,0,22,5,6,3,2,7,15,18,32,41,23,8]),function(fe,e,S,F,P,L,R,g,f,D,M,k,l,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$njc=void 0;function $(s,c,t){const n=s.getProxy(L.$ZL.MainThreadQuickOpen);class r{constructor(m,I){this.e=new Map,this.f=0,this.a=m,this.b=I}showQuickPick(m,I,d,y=S.CancellationToken.None){this.c=void 0;const b=Promise.resolve(I),A=++this.f,T=n.$show(A,{title:d?.title,placeHolder:d?.placeHolder,matchOnDescription:d?.matchOnDescription,matchOnDetail:d?.matchOnDetail,ignoreFocusLost:d?.ignoreFocusOut,canPickMany:d?.canPickMany},y),G={},W=T.then(()=>G);return Promise.race([W,b]).then(U=>{if(U===G)return;const C=(0,l.$UF)(m,"quickPickItemTooltip");return b.then(O=>{const V=[];for(let re=0;re<O.length;re++){const ue=O[re];if(typeof ue=="string")V.push({label:ue,handle:re});else if(ue.kind===g.QuickPickItemKind.Separator)V.push({type:"separator",label:ue.label});else{ue.tooltip&&!C&&console.warn(`Extension '${m.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${m.identifier.value}`);const ye=ue.iconPath?u(ue.iconPath):void 0;V.push({label:ue.label,iconPath:ye?.iconPath,iconClass:ye?.iconClass,description:ue.description,detail:ue.detail,picked:ue.picked,alwaysShow:ue.alwaysShow,tooltip:C?v.MarkdownString.fromStrict(ue.tooltip):void 0,handle:re})}}return d&&typeof d.onDidSelectItem=="function"&&(this.c=re=>{d.onDidSelectItem(O[re])}),n.$setItems(A,V),T.then(re=>{if(typeof re=="number")return O[re];if(Array.isArray(re))return re.map(ue=>O[ue])})})}).then(void 0,U=>{if(!(0,f.$4)(U))return n.$setError(A,U),Promise.reject(U)})}$onItemSelected(m){this.c?.(m)}showInput(m,I=S.CancellationToken.None){return this.d=m?.validateInput,n.$input(m,typeof this.d=="function",I).then(void 0,d=>{if(!(0,f.$4)(d))return Promise.reject(d)})}async $validateInput(m){if(!this.d)return;const I=await this.d(m);if(!I||typeof I=="string")return I;let d;switch(I.severity){case g.InputBoxValidationSeverity.Info:d=M.default.Info;break;case g.InputBoxValidationSeverity.Warning:d=M.default.Warning;break;case g.InputBoxValidationSeverity.Error:d=M.default.Error;break;default:d=I.message?M.default.Error:M.default.Ignore;break}return{content:I.message,severity:d}}async showWorkspaceFolderPick(m,I=S.CancellationToken.None){const d=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[m]);if(!d)return;const y=await this.a.getWorkspaceFolders2();if(y)return y.find(b=>b.uri.toString()===d.uri.toString())}createQuickPick(m){const I=new o(m,()=>this.e.delete(I._id));return this.e.set(I._id,I),I}createInputBox(m){const I=new E(m,()=>this.e.delete(I._id));return this.e.set(I._id,I),I}$onDidChangeValue(m,I){this.e.get(m)?._fireDidChangeValue(I)}$onDidAccept(m){this.e.get(m)?._fireDidAccept()}$onDidChangeActive(m,I){const d=this.e.get(m);d instanceof o&&d._fireDidChangeActive(I)}$onDidChangeSelection(m,I){const d=this.e.get(m);d instanceof o&&d._fireDidChangeSelection(I)}$onDidTriggerButton(m,I){this.e.get(m)?._fireDidTriggerButton(I)}$onDidTriggerItemButton(m,I,d){const y=this.e.get(m);y instanceof o&&y._fireDidTriggerItemButton(I,d)}$onDidHide(m){this.e.get(m)?._fireDidHide()}}class a{static{this.a=1}constructor(m,I){this.x=m,this.y=I,this._id=o.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new F.$5d,this.q=new F.$5d,this.r=new F.$5d,this.s=new F.$5d,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(m){this.b=m,this.z({title:m})}get step(){return this.c}set step(m){this.c=m,this.z({step:m})}get totalSteps(){return this.d}set totalSteps(m){this.d=m,this.z({totalSteps:m})}get enabled(){return this.g}set enabled(m){this.g=m,this.z({enabled:m})}get busy(){return this.j}set busy(m){this.j=m,this.z({busy:m})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(m){this.k=m,this.z({ignoreFocusOut:m})}get value(){return this.l}set value(m){this.l=m,this.z({value:m})}get placeholder(){return this.m}set placeholder(m){this.m=m,this.z({placeholder:m})}get buttons(){return this.n}set buttons(m){this.n=m.slice(),this.o.clear(),m.forEach((I,d)=>{const y=I===g.$mN.Back?-1:d;this.o.set(y,I)}),this.z({buttons:m.map((I,d)=>({...u(I.iconPath),tooltip:I.tooltip,handle:I===g.$mN.Back?-1:d}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(m){this.l=m,this.q.fire(m)}_fireDidTriggerButton(m){const I=this.o.get(m);I&&this.r.fire(I)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,P.$Oc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),n.$dispose(this._id))}z(m){if(!this.v){for(const I of Object.keys(m)){const d=m[I];this.u[I]=d===void 0?null:d}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){n.$createOrUpdate(this.u),this.u={id:this._id}}}function h(w){if(w instanceof g.$WM)return{id:w.id};const m=p(w),I=i(w);return{dark:typeof m=="string"?R.URI.file(m):m,light:typeof I=="string"?R.URI.file(I):I}}function i(w){return typeof w=="object"&&"light"in w?w.light:w}function p(w){return typeof w=="object"&&"dark"in w?w.dark:w}function u(w){const m=h(w);let I,d;return"id"in m?d=k.ThemeIcon.asClassName(m):I=m,{iconPath:I,iconClass:d}}class o extends a{constructor(m,I){super(m.identifier,I),this.O=m,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new F.$5d,this.L=[],this.M=new F.$5d,this.N=new F.$5d,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(m){this.B=m.slice(),this.C.clear(),this.D.clear(),m.forEach((y,b)=>{this.C.set(b,y),this.D.set(y,b)});const I=(0,l.$UF)(this.O,"quickPickItemTooltip"),d=[];for(let y=0;y<m.length;y++){const b=m[y];if(b.kind===g.QuickPickItemKind.Separator)d.push({type:"separator",label:b.label});else{b.tooltip&&!I&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const A=b.iconPath?u(b.iconPath):void 0;d.push({handle:y,label:b.label,iconPath:A?.iconPath,iconClass:A?.iconClass,description:b.description,detail:b.detail,picked:b.picked,alwaysShow:b.alwaysShow,tooltip:I?v.MarkdownString.fromStrict(b.tooltip):void 0,buttons:b.buttons?.map((T,G)=>({...u(T.iconPath),tooltip:T.tooltip,handle:G}))})}}this.z({items:d})}get canSelectMany(){return this.E}set canSelectMany(m){this.E=m,this.z({canSelectMany:m})}get matchOnDescription(){return this.F}set matchOnDescription(m){this.F=m,this.z({matchOnDescription:m})}get matchOnDetail(){return this.G}set matchOnDetail(m){this.G=m,this.z({matchOnDetail:m})}get sortByLabel(){return this.H}set sortByLabel(m){this.H=m,this.z({sortByLabel:m})}get keepScrollPosition(){return this.I}set keepScrollPosition(m){this.I=m,this.z({keepScrollPosition:m})}get activeItems(){return this.J}set activeItems(m){this.J=m.filter(I=>this.D.has(I)),this.z({activeItems:this.J.map(I=>this.D.get(I))})}get selectedItems(){return this.L}set selectedItems(m){this.L=m.filter(I=>this.D.has(I)),this.z({selectedItems:this.L.map(I=>this.D.get(I))})}_fireDidChangeActive(m){const I=(0,D.$Hb)(m.map(d=>this.C.get(d)));this.J=I,this.K.fire(I)}_fireDidChangeSelection(m){const I=(0,D.$Hb)(m.map(d=>this.C.get(d)));this.L=I,this.M.fire(I)}_fireDidTriggerItemButton(m,I){const d=this.C.get(m);if(!d||!d.buttons||!d.buttons.length)return;const y=d.buttons[I];y&&this.N.fire({button:y,item:d})}}class E extends a{constructor(m,I){super(m.identifier,I),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(m){this.B=m,this.z({password:m})}get prompt(){return this.C}set prompt(m){this.C=m,this.z({prompt:m})}get valueSelection(){return this.D}set valueSelection(m){this.D=m,this.z({valueSelection:m})}get validationMessage(){return this.E}set validationMessage(m){this.E=m,m?typeof m=="string"?this.z({validationMessage:m,severity:M.default.Error}):this.z({validationMessage:m.message,severity:m.severity??M.default.Error}):this.z({validationMessage:void 0,severity:M.default.Ignore})}}return new r(c,t)}e.$njc=$}),define(Re[268],Ae([1,0,2,5,68,6,11,3,18,139,14,20,41,8,23,12,21]),function(fe,e,S,F,P,L,R,g,f,D,M,k,l,v,$,s,c){"use strict";var t;Object.defineProperty(e,"__esModule",{value:!0}),e.$pjc=e.$ojc=void 0;function n(A){return A instanceof S.URI}function r(A,T){return A.scheme===s.Schemas.file&&T.scheme===s.Schemas.file&&c.$k?A.toString()===T.toString():A.toString().toLowerCase()===T.toString().toLowerCase()}function a(A){if(A)return typeof A.iconPath=="string"?S.URI.file(A.iconPath):S.URI.isUri(A.iconPath)||l.ThemeIcon.isThemeIcon(A.iconPath)?A.iconPath:void 0}function h(A){if(A.icon){if(S.URI.isUri(A.icon))return A.icon;if(l.ThemeIcon.isThemeIcon(A.icon))return A.icon;{const T=A.icon;return{light:T.light,dark:T.dark}}}else return}function i(A,T){if(!A.iconPath&&!T.iconPath)return 0;if(A.iconPath){if(!T.iconPath)return 1}else return-1;const G=typeof A.iconPath=="string"?A.iconPath:S.URI.isUri(A.iconPath)?A.iconPath.fsPath:A.iconPath.id,W=typeof T.iconPath=="string"?T.iconPath:S.URI.isUri(T.iconPath)?T.iconPath.fsPath:T.iconPath.id;return(0,D.$4q)(G,W)}function p(A,T){let G=0;if(A.strikeThrough!==T.strikeThrough)return A.strikeThrough?1:-1;if(A.faded!==T.faded)return A.faded?1:-1;if(A.tooltip!==T.tooltip)return(A.tooltip||"").localeCompare(T.tooltip||"");if(G=i(A,T),G!==0)return G;if(A.light&&T.light)G=i(A.light,T.light);else{if(A.light)return 1;if(T.light)return-1}if(G!==0)return G;if(A.dark&&T.dark)G=i(A.dark,T.dark);else{if(A.dark)return 1;if(T.dark)return-1}return G}function u(A,T){if(A.command!==T.command)return A.command<T.command?-1:1;if(A.title!==T.title)return A.title<T.title?-1:1;if(A.tooltip!==T.tooltip){if(A.tooltip!==void 0&&T.tooltip!==void 0)return A.tooltip<T.tooltip?-1:1;if(A.tooltip!==void 0)return 1;if(T.tooltip!==void 0)return-1}if(A.arguments===T.arguments)return 0;if(A.arguments)if(T.arguments){if(A.arguments.length!==T.arguments.length)return A.arguments.length-T.arguments.length}else return 1;else return-1;for(let G=0;G<A.arguments.length;G++){const W=A.arguments[G],U=T.arguments[G];if(W!==U&&!(n(W)&&n(U)&&r(W,U)))return W<U?-1:1}return 0}function o(A,T){let G=(0,D.$4q)(A.resourceUri.fsPath,T.resourceUri.fsPath,!0);if(G!==0)return G;if(A.command&&T.command)G=u(A.command,T.command);else{if(A.command)return 1;if(T.command)return-1}if(G!==0)return G;if(A.decorations&&T.decorations)G=p(A.decorations,T.decorations);else{if(A.decorations)return 1;if(T.decorations)return-1}if(A.multiFileDiffEditorModifiedUri&&T.multiFileDiffEditorModifiedUri)G=(0,D.$4q)(A.multiFileDiffEditorModifiedUri.fsPath,T.multiFileDiffEditorModifiedUri.fsPath,!0);else{if(A.multiFileDiffEditorModifiedUri)return 1;if(T.multiFileDiffEditorModifiedUri)return-1}if(A.multiDiffEditorOriginalUri&&T.multiDiffEditorOriginalUri)G=(0,D.$4q)(A.multiDiffEditorOriginalUri.fsPath,T.multiDiffEditorOriginalUri.fsPath,!0);else{if(A.multiDiffEditorOriginalUri)return 1;if(T.multiDiffEditorOriginalUri)return-1}return G}function E(A,T){for(let G=0;G<A.length;G++)if(A[G]!==T[G])return!1;return!0}function w(A,T){return A.command===T.command&&A.title===T.title&&A.tooltip===T.tooltip&&(A.arguments&&T.arguments?E(A.arguments,T.arguments):A.arguments===T.arguments)}function m(A,T){return(0,f.$ub)(A,T,w)}class I{#e;#t;get value(){return this.d}set value(T){T=T??"",this.#e.$setInputBoxValue(this.l,T),this.n(T)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(T){this.#e.$setInputBoxPlaceholder(this.l,T),this.f=T}get validateInput(){return(0,$.$VF)(this.k,"scmValidation"),this.g}set validateInput(T){if((0,$.$VF)(this.k,"scmValidation"),T&&typeof T!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=T,this.#e.$setValidationProviderIsEnabled(this.l,!!T)}get enabled(){return this.h}set enabled(T){T=!!T,this.h!==T&&(this.h=T,this.#e.$setInputBoxEnablement(this.l,T))}get visible(){return this.j}set visible(T){T=!!T,this.j!==T&&(this.j=T,this.#e.$setInputBoxVisibility(this.l,T))}get document(){return(0,$.$VF)(this.k,"scmTextDocument"),this.#t.getDocument(this.m)}constructor(T,G,W,U,C){this.k=T,this.l=U,this.m=C,this.d="",this.e=new F.$5d,this.f="",this.h=!0,this.j=!0,this.#t=G,this.#e=W}showValidationMessage(T,G){(0,$.$VF)(this.k,"scmValidation"),this.#e.$showValidationMessage(this.l,T,G)}$onInputBoxValueChange(T){this.n(T)}n(T){this.d=T,this.e.fire(T)}}e.$ojc=I;class d{static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(T){this.v=T,this.q.$updateGroupLabel(this.t,this.handle,T)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(T){this.p=T,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(T){this.f=[...T],this.k.fire()}constructor(T,G,W,U,C,O,V){this.q=T,this.s=G,this.t=W,this.u=U,this.v=C,this.multiDiffEditorEnableViewChanges=O,this.w=V,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new F.$5d,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new F.$5d,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=d.d++}getResourceState(T){return this.g.get(T)}$executeResourceCommand(T,G){const W=this.h.get(T);return W?(0,R.$9g)(()=>this.s.executeCommand(W.command,...W.arguments||[],G)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const T=[...this.f].sort(o),W=(0,f.$Db)(this.o,T,o).map(O=>{const V=O.toInsert.map(re=>{const ue=this.e++;this.g.set(ue,re);const ye=re.resourceUri;let De;if(re.command)if(re.command.command==="vscode.open"||re.command.command==="vscode.diff"||re.command.command==="vscode.changes"){const ge=new L.$Sc;De=this.s.converter.toInternal(re.command,ge),this.j.set(ue,ge)}else this.h.set(ue,re.command);const he=(0,$.$UF)(this.w,"scmMultiDiffEditor"),ve=he?re.multiDiffEditorOriginalUri:void 0,se=he?re.multiFileDiffEditorModifiedUri:void 0,$e=a(re.decorations),ee=re.decorations&&a(re.decorations.light)||$e,Q=re.decorations&&a(re.decorations.dark)||$e,q=[ee,Q],ne=re.decorations&&re.decorations.tooltip||"",Se=re.decorations&&!!re.decorations.strikeThrough,Te=re.decorations&&!!re.decorations.faded,Ce=re.contextValue||"";return{rawResource:[ue,ye,q,ne,Se,Te,Ce,De,ve,se],handle:ue}});return{start:O.start,deleteCount:O.deleteCount,toInsert:V}}),U=W.map(({start:O,deleteCount:V,toInsert:re})=>[O,V,re.map(ue=>ue.rawResource)]),C=W.reverse();for(const{start:O,deleteCount:V,toInsert:re}of C){const ue=re.map(De=>De.handle),ye=this.n.splice(O,V,...ue);for(const De of ye)this.g.delete(De),this.h.delete(De),this.j.get(De)?.dispose(),this.j.delete(De)}return this.o=T,U}dispose(){this.l=!0,this.m.fire()}}class y{static{this.d=0}#e;get id(){return this.z}get label(){return this.A}get rootUri(){return this.B}get inputBox(){return this.f}get count(){return this.g}set count(T){this.g!==T&&(this.g=T,this.#e.$updateSourceControl(this.w,{count:T}))}get quickDiffProvider(){return this.h}set quickDiffProvider(T){this.h=T;let G;(0,$.$UF)(this.x,"quickDiffProvider")&&(G=T?.label),this.#e.$updateSourceControl(this.w,{hasQuickDiffProvider:!!T,quickDiffLabel:G})}get historyProvider(){return(0,$.$VF)(this.x,"scmHistoryProvider"),this.j}set historyProvider(T){(0,$.$VF)(this.x,"scmHistoryProvider"),this.j=T,this.k.value=new L.$Sc,this.#e.$updateSourceControl(this.w,{hasHistoryProvider:!!T}),T&&this.k.value.add(T.onDidChangeCurrentHistoryItemGroup(()=>{this.l=T?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.w,this.l)}))}get commitTemplate(){return this.m}set commitTemplate(T){T!==this.m&&(this.m=T,this.#e.$updateSourceControl(this.w,{commitTemplate:T}))}get acceptInputCommand(){return this.o}set acceptInputCommand(T){this.n.value=new L.$Sc,this.o=T;const G=this.y.converter.toInternal(T,this.n.value);this.#e.$updateSourceControl(this.w,{acceptInputCommand:G})}get actionButton(){return(0,$.$VF)(this.x,"scmActionButton"),this.q}set actionButton(T){(0,$.$VF)(this.x,"scmActionButton"),this.p.value=new L.$Sc,this.q=T;const G=T!==void 0?{command:this.y.converter.toInternal(T.command,this.p.value),secondaryCommands:T.secondaryCommands?.map(W=>W.map(U=>this.y.converter.toInternal(U,this.p.value))),description:T.description,enabled:T.enabled}:void 0;this.#e.$updateSourceControl(this.w,{actionButton:G??null})}get statusBarCommands(){return this.t}set statusBarCommands(T){if(this.t&&T&&m(this.t,T))return;this.s.value=new L.$Sc,this.t=T;const G=(T||[]).map(W=>this.y.converter.toInternal(W,this.s.value));this.#e.$updateSourceControl(this.w,{statusBarCommands:G})}get selected(){return this.u}constructor(T,G,W,U,C,O,V){this.x=T,this.y=U,this.z=C,this.A=O,this.B=V,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new L.$Uc,this.m=void 0,this.n=new L.$Uc,this.o=void 0,this.p=new L.$Uc,this.s=new L.$Uc,this.t=void 0,this.u=!1,this.v=new F.$5d,this.onDidChangeSelection=this.v.event,this.w=y.d++,this.C=new Map,this.D=new Set,this.#e=W;const re=S.URI.from({scheme:s.Schemas.vscodeSourceControl,path:`${C}/scm${this.w}/input`,query:V?`rootUri=${encodeURIComponent(V.toString())}`:void 0});this.f=new I(T,G,this.#e,this.w,re),this.#e.$registerSourceControl(this.w,C,O,V,re)}createResourceGroup(T,G,W){const U=(0,$.$UF)(this.x,"scmMultiDiffEditor")&&W?.multiDiffEditorEnableViewChanges===!0,C=new d(this.#e,this.y,this.w,T,G,U,this.x),O=F.Event.once(C.onDidDispose)(()=>this.C.delete(C));return this.C.set(C,O),this.eventuallyAddResourceGroups(),C}eventuallyAddResourceGroups(){const T=[],G=[];for(const[W,U]of this.C){U.dispose();const C=W.onDidUpdateResourceStates(()=>{this.D.add(W),this.eventuallyUpdateResourceStates()});F.Event.once(W.onDidDispose)(()=>{this.D.delete(W),C.dispose(),this.e.delete(W.handle),this.#e.$unregisterGroup(this.w,W.handle)}),T.push([W.handle,W.id,W.label,W.features,W.multiDiffEditorEnableViewChanges]);const O=W._takeResourceStateSnapshot();O.length>0&&G.push([W.handle,O]),this.e.set(W.handle,W)}this.#e.$registerGroups(this.w,T,G),this.C.clear()}eventuallyUpdateResourceStates(){const T=[];this.D.forEach(G=>{const W=G._takeResourceStateSnapshot();W.length!==0&&T.push([G.handle,W])}),T.length>0&&this.#e.$spliceResourceStates(this.w,T),this.D.clear()}getResourceGroup(T){return this.e.get(T)}setSelectionState(T){this.u=T,this.v.fire(T)}dispose(){this.n.dispose(),this.p.dispose(),this.s.dispose(),this.e.forEach(T=>T.dispose()),this.#e.$unregisterSourceControl(this.w)}}Ze([(0,P.$Jh)(100)],y.prototype,"eventuallyAddResourceGroups",null),Ze([(0,P.$Jh)(100)],y.prototype,"eventuallyUpdateResourceStates",null);let b=class{static{t=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(T,G,W,U){this.l=G,this.m=W,this.n=U,this.g=new Map,this.h=new k.$ym,this.j=new F.$5d,this.e=T.getProxy(g.$ZL.MainThreadSCM),this.f=T.getProxy(g.$ZL.MainThreadTelemetry),G.registerArgumentProcessor({processArgument:C=>{if(C&&C.$mid===3){const O=this.g.get(C.sourceControlHandle);if(!O)return C;const V=O.getResourceGroup(C.groupHandle);return V?V.getResourceState(C.handle):C}else if(C&&C.$mid===4){const O=this.g.get(C.sourceControlHandle);return O?O.getResourceGroup(C.groupHandle):C}else if(C&&C.$mid===5){const O=this.g.get(C.handle);return O||C}return C}})}createSourceControl(T,G,W,U){this.n.trace("ExtHostSCM#createSourceControl",T.identifier.value,G,W,U),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:T.identifier.value});const C=t.d++,O=new y(T,this.m,this.e,this.l,G,W,U);this.g.set(C,O);const V=this.h.get(T.identifier)||[];return V.push(O),this.h.set(T.identifier,V),O}getLastInputBox(T){this.n.trace("ExtHostSCM#getLastInputBox",T.identifier.value);const G=this.h.get(T.identifier),W=G&&G[G.length-1];return W&&W.inputBox}$provideOriginalResource(T,G,W){const U=S.URI.revive(G);this.n.trace("ExtHostSCM#$provideOriginalResource",T,U.toString());const C=this.g.get(T);return!C||!C.quickDiffProvider||!C.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,R.$9g)(()=>C.quickDiffProvider.provideOriginalResource(U,W)).then(O=>O||null)}$onInputBoxValueChange(T,G){this.n.trace("ExtHostSCM#$onInputBoxValueChange",T);const W=this.g.get(T);return W&&W.inputBox.$onInputBoxValueChange(G),Promise.resolve(void 0)}$executeResourceCommand(T,G,W,U){this.n.trace("ExtHostSCM#$executeResourceCommand",T,G,W);const C=this.g.get(T);if(!C)return Promise.resolve(void 0);const O=C.getResourceGroup(G);return O?O.$executeResourceCommand(W,U):Promise.resolve(void 0)}$validateInput(T,G,W){this.n.trace("ExtHostSCM#$validateInput",T);const U=this.g.get(T);return!U||!U.inputBox.validateInput?Promise.resolve(void 0):(0,R.$9g)(()=>U.inputBox.validateInput(G,W)).then(C=>{if(!C)return Promise.resolve(void 0);const O=v.MarkdownString.fromStrict(C.message);return O?Promise.resolve([O,C.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(T){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",T),T!==void 0&&this.g.get(T)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=T,Promise.resolve(void 0)}async $resolveHistoryItemGroupCommonAncestor(T,G,W,U){return await this.g.get(T)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(G,W,U)??void 0}async $provideHistoryItems(T,G,W,U){return(await this.g.get(T)?.historyProvider?.provideHistoryItems(G,W,U))?.map(V=>({...V,icon:h(V)}))??void 0}async $provideHistoryItemSummary(T,G,W,U){const C=this.g.get(T)?.historyProvider;if(typeof C?.provideHistoryItemSummary!="function")return;const O=await C.provideHistoryItemSummary(G,W,U);return O?{...O,icon:h(O)}:void 0}async $provideHistoryItemChanges(T,G,W,U){return await this.g.get(T)?.historyProvider?.provideHistoryItemChanges(G,W,U)??void 0}};e.$pjc=b,e.$pjc=b=t=Ze([qe(3,M.$yj)],b)}),define(Re[269],Ae([1,0,3,8,2]),function(fe,e,S,F,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qjc=void 0;class L{static{this.a=0}constructor(g,f){this.d=f,this.c=new Map,this.b=g.getProxy(S.$ZL.MainThreadShare)}async $provideShare(g,f,D){return await this.c.get(g)?.provideShare({selection:F.Range.to(f.selection),resourceUri:P.URI.revive(f.resourceUri)},D)??void 0}registerShareProvider(g,f){const D=L.a++;return this.c.set(D,f),this.b.$registerShareProvider(D,F.DocumentSelector.from(g,this.d),f.id,f.label,f.priority),{dispose:()=>{this.b.$unregisterShareProvider(D),this.c.delete(D)}}}}e.$qjc=L}),define(Re[270],Ae([1,0,7,3,165,6,8,16]),function(fe,e,S,F,P,L,R,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tjc=e.$sjc=void 0;class f{static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new S.$XM("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new S.$XM("statusBarItem.warningForeground")]])}#e;#t;constructor(l,v,$,s,c,t=S.StatusBarAlignment.Left,n){if(this.i=!1,this.k="",this.q=new L.$Sc,this.#e=l,this.#t=v,c&&s){this.c=(0,S.$AM)(s.identifier,c);const r=$.get(this.c);r&&(t=r.alignLeft?S.StatusBarAlignment.Left:S.StatusBarAlignment.Right,n=r.priority,this.j=!0,this.name=r.name,this.text=r.text,this.tooltip=r.tooltip,this.command=r.command,this.accessibilityInformation=r.accessibilityInformation)}else this.c=String(f.a++);this.e=s,this.f=c,this.g=t,this.h=this.u(n)}u(l){if((0,g.$Wf)(l))return l===Number.POSITIVE_INFINITY?Number.MAX_VALUE:l===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:l}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(l){this.k=l,this.v()}set name(l){this.m=l,this.v()}set tooltip(l){this.l=l,this.v()}set color(l){this.n=l,this.v()}set backgroundColor(l){l&&!f.b.has(l.id)&&(l=void 0),this.o=l,this.v()}set command(l){this.r?.fromApi!==l&&(this.p&&this.q.add(this.p),this.p=new L.$Sc,typeof l=="string"?this.r={fromApi:l,internal:this.#t.toInternal({title:"",command:l},this.p)}:l?this.r={fromApi:l,internal:this.#t.toInternal(l,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(l){this.t=l,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let l;this.e?this.f?l=`${this.e.identifier.value}.${this.f}`:l=this.e.identifier.value:l=this.f;let v;this.m?v=this.m:v=(0,P.localize)(0,null,this.e.displayName||this.e.name);let $=this.n;this.o&&($=f.b.get(this.o.id));const s=R.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,l,this.e?.identifier.value,v,this.k,s,this.r?.internal,$,this.o,this.g===S.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$sjc=f;class D{constructor(l){this.b=[],this.a=l.createStatusBarEntry(void 0,"status.extensionMessage",S.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,P.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(l){const v={message:l};return this.b.unshift(v),this.c(),new S.$2L(()=>{const $=this.b.indexOf(v);$>=0&&(this.b.splice($,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class M{constructor(l,v){this.e=new Map,this.a=l.getProxy(F.$ZL.MainThreadStatusBar),this.b=v,this.c=new D(this)}$acceptStaticEntries(l){for(const v of l)this.e.set(v.entryId,v)}createStatusBarEntry(l,v,$,s){return new f(this.a,this.b,this.e,l,v,$,s)}setStatusBarMessage(l,v){const $=this.c.setMessage(l);let s;return typeof v=="number"?s=setTimeout(()=>$.dispose(),v):typeof v<"u"&&v.then(()=>$.dispose(),()=>$.dispose()),new S.$2L(()=>{$.dispose(),clearTimeout(s)})}}e.$tjc=M}),define(Re[111],Ae([1,0,29,103,48,75,60,8,2]),function(fe,e,S,F,P,L,R,g,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tO=e.$sO=e.$rO=e.$qO=void 0;const D=(r,a,h,i)=>{let p=a;return{enumerable:!0,configurable:!1,get(){return p},set(u){if(!h(p,u)){const o=p;p=u,r.listener?.(i(u,o))}}}},M=(r,a)=>r===a,k={range:(r,a)=>r===a?!0:!r||!a?!1:r.isEqual(a),label:M,description:M,sortText:M,busy:M,error:M,canResolveChildren:M,tags:(r,a)=>!(r.length!==a.length||r.some(h=>!a.find(i=>h.id===i.id)))},l=r=>a=>({op:4,update:r(a)}),v=(r,a)=>({range:(()=>{let h;const i=l(p=>({range:S.$6s.lift(g.Range.from(p))}));return{enumerable:!0,configurable:!1,get(){return h},set(p){r.listener?.({op:6}),k.range(h,p)||(h=p,r.listener?.(i(p)))}}})(),label:D(r,a,k.label,l(h=>({label:h}))),description:D(r,void 0,k.description,l(h=>({description:h}))),sortText:D(r,void 0,k.sortText,l(h=>({sortText:h}))),canResolveChildren:D(r,!1,k.canResolveChildren,h=>({op:2,state:h})),busy:D(r,!1,k.busy,l(h=>({busy:h}))),error:D(r,void 0,k.error,l(h=>({error:g.MarkdownString.fromStrict(h)||null}))),tags:D(r,[],k.tags,(h,i)=>({op:1,new:h.map(g.TestTag.from),old:i.map(g.TestTag.from)}))}),$=r=>{const a=P.$QK.fromString(r.extId),h=new c(a.controllerId,a.localId,r.label,f.URI.revive(r.uri)||void 0);return h.range=g.Range.to(r.range||void 0),h.description=r.description||void 0,h.sortText=r.sortText||void 0,h.tags=r.tags.map(i=>g.TestTag.to({id:(0,R.$VK)(i).tagId})),h},s=r=>{let a;for(const h of r.tests){const i=$(h.item);(0,F.$aO)(i).parent=a,a=i}return a};e.$qO=s;class c{constructor(a,h,i,p){if(h.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(h)} symbol`);const u=(0,F.$_N)(this,a);Object.defineProperties(this,{id:{value:h,enumerable:!0,writable:!1},uri:{value:p,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return u.parent instanceof t?void 0:u.parent}},children:{value:(0,L.$$N)(u,F.$aO,c),enumerable:!0,writable:!1},...v(u,i)})}}e.$rO=c;class t extends c{constructor(a,h){super(a,a,h,void 0),this._isRoot=!0}}e.$sO=t;class n extends L.$7N{constructor(a,h,i){super({controllerId:a,getDocumentVersion:p=>p&&i.getDocument(p)?.version,getApiFor:F.$aO,getChildren:p=>p.children,root:new t(a,h),toITestItem:g.TestItem.from})}}e.$tO=n}),define(Re[31],Ae([1,0,16,7,8,26,3,18,14,52,29,91,2,6,4,17,111,24,49,34,64,58,61,33]),function(fe,e,S,F,P,L,R,g,f,D,M,k,l,v,$,s,c,t,n,r,a,h,i,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EO=e.$DO=e.$CO=e.$BO=e.$AO=e.$zO=void 0;let u=class{#e;#t;#i;constructor(d,y,b){this.b=new Map,this.c=new Map,this.#e=d.getProxy(R.$ZL.MainThreadCommands),this.d=y,this.#i=b,this.#t=d.getProxy(R.$ZL.MainThreadTelemetry),this.converter=new o(this,A=>{const T=this.c.get(A);return T?.result===w.Void?T:void 0},y),this.f=[{processArgument(A){return(0,D.$Nh)(A)}},{processArgument(A){return(0,L.$Jn)(A,function(T){if(M.$6s.isIRange(T))return P.Range.to(T);if(k.$5s.isIPosition(T))return P.Position.to(T);if(M.$6s.isIRange(T.range)&&l.URI.isUri(T.uri))return P.location.to(T);if(T instanceof t.$se)return T.buffer.buffer;if(!Array.isArray(T))return T})}}]}registerArgumentProcessor(d){this.f.push(d)}registerApiCommand(d){const y=this.registerCommand(!1,d.id,async(...b)=>{const A=d.args.map((G,W)=>{if(!G.validate(b[W]))throw new Error(`Invalid argument '${G.name}' when running '${d.id}', received: ${typeof b[W]=="object"?JSON.stringify(b[W],null,"	"):b[W]} `);return G.convert(b[W])}),T=await this.executeCommand(d.internalId,...A);return d.result.convert(T,b,this.converter)},void 0,{description:d.description,args:d.args,returns:d.result.description});return this.c.set(d.id,d),new F.$2L(()=>{y.dispose(),this.c.delete(d.id)})}registerCommand(d,y,b,A,T,G){if(this.d.trace("ExtHostCommands#registerCommand",y),!y.trim().length)throw new Error("invalid id");if(this.b.has(y))throw new Error(`command '${y}' already exists`);return this.b.set(y,{callback:b,thisArg:A,metadata:T,extension:G}),d&&this.#e.$registerCommand(y),new F.$2L(()=>{this.b.delete(y)&&d&&this.#e.$unregisterCommand(y)})}executeCommand(d,...y){return this.d.trace("ExtHostCommands#executeCommand",d),this.g(d,y,!0)}async g(d,y,b){if(this.b.has(d))return this.#e.$fireCommandActivationEvent(d),this.h(d,y,!1);{let A=!1;const T=(0,L.$Jn)(y,function(G){if(G instanceof F.$3L)return P.Position.from(G);if(G instanceof F.$4L)return P.Range.from(G);if(G instanceof F.$bM)return P.location.from(G);if(F.$pN.isNotebookRange(G))return P.NotebookRange.from(G);if(G instanceof ArrayBuffer)return A=!0,t.$se.wrap(new Uint8Array(G));if(G instanceof Uint8Array)return A=!0,t.$se.wrap(G);if(G instanceof t.$se)return A=!0,G;if(!Array.isArray(G))return G});try{const G=await this.#e.$executeCommand(d,A?new n.$6v(T):T,b);return(0,D.$Nh)(G)}catch(G){if(G instanceof Error&&G.message==="$executeCommand:retry")return this.g(d,y,!1);throw G}}}async h(d,y,b){const A=this.b.get(d);if(!A)throw new Error("Unknown command");const{callback:T,thisArg:G,metadata:W}=A;if(W?.args)for(let C=0;C<W.args.length;C++)try{(0,S.$0f)(y[C],W.args[C].constraint)}catch{throw new Error(`Running the contributed command: '${d}' failed. Illegal argument '${W.args[C].name}' - ${W.args[C].description}`)}const U=a.$1d.create();try{return await T.apply(G,y)}catch(C){if(d===this.converter.delegatingCommandId){const O=this.converter.getActualCommand(...y);O&&(d=O.command)}if(this.d.error(C,d,A.extension?.identifier),!b)throw C;if(A.extension?.identifier){const O=this.#i.onExtensionError(A.extension.identifier,C);this.d.trace("forwarded error to extension?",O,A.extension?.identifier)}throw new class extends Error{constructor(){super((0,r.$2i)(C)),this.id=d,this.source=A.extension?.displayName??A.extension?.name}}}finally{this.j(A,d,U.elapsed())}}j(d,y,b){d.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:d.extension.identifier.value,id:new h.$Wo(y),duration:b})}$executeContributedCommand(d,...y){this.d.trace("ExtHostCommands#$executeContributedCommand",d);const b=this.b.get(d);return b?(y=y.map(A=>this.f.reduce((T,G)=>G.processArgument(T,b.extension?.identifier),A)),this.h(d,y,!0)):Promise.reject(new Error(`Contributed command '${d}' does not exist.`))}getCommands(d=!1){return this.d.trace("ExtHostCommands#getCommands",d),this.#e.$getCommands().then(y=>(d&&(y=y.filter(b=>b[0]!=="_")),y))}$getContributedCommandMetadata(){const d=Object.create(null);for(const[y,b]of this.b){const{metadata:A}=b;A&&(d[y]=A)}return Promise.resolve(d)}};e.$zO=u,e.$zO=u=Ze([qe(0,s.$eO),qe(1,f.$yj),qe(2,i.$yO)],u),e.$AO=(0,$.$ei)("IExtHostCommands");class o{constructor(d,y,b){this.d=d,this.f=y,this.g=b,this.delegatingCommandId=`__vsc${(0,p.$Ag)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(d,y){if(!d)return;const b={$ident:void 0,id:d.command,title:d.title,tooltip:d.tooltip};if(!d.command)return b;const A=this.f(d.command);if(A)b.id=A.internalId,b.arguments=A.args.map((T,G)=>T.convert(d.arguments&&d.arguments[G]));else if((0,g.$Lb)(d.arguments)){const T=`${d.command} /${++this.c}`;this.b.set(T,d),y.add((0,v.$Rc)(()=>{this.b.delete(T),this.g.trace("CommandsConverter#DISPOSE",T)})),b.$ident=T,b.id=this.delegatingCommandId,b.arguments=[T],this.g.trace("CommandsConverter#CREATE",d.command,T)}return b}fromInternal(d){return typeof d.$ident=="string"?this.b.get(d.$ident):{command:d.id,title:d.title,arguments:d.arguments}}getActualCommand(...d){return this.b.get(d[0])}h(...d){const y=this.getActualCommand(...d);return this.g.trace("CommandsConverter#EXECUTE",d[0],y?y.command:"MISSING"),y?this.d.executeCommand(y.command,...y.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${d[0]}`)}}e.$BO=o;class E{static{this.Uri=new E("uri","Uri of a text document",d=>l.URI.isUri(d),d=>d)}static{this.Position=new E("position","A position in a text document",d=>F.$3L.isPosition(d),P.Position.from)}static{this.Range=new E("range","A range in a text document",d=>F.$4L.isRange(d),P.Range.from)}static{this.Selection=new E("selection","A selection in a text document",d=>F.$5L.isSelection(d),P.Selection.from)}static{this.Number=new E("number","",d=>typeof d=="number",d=>d)}static{this.String=new E("string","",d=>typeof d=="string",d=>d)}static{this.StringArray=E.Arr(E.String)}static Arr(d){return new E(`${d.name}_array`,`Array of ${d.name}, ${d.description}`,y=>Array.isArray(y)&&y.every(b=>d.validate(b)),y=>y.map(b=>d.convert(b)))}static{this.CallHierarchyItem=new E("item","A call hierarchy item",d=>d instanceof F.$mM,P.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new E("item","A type hierarchy item",d=>d instanceof F.$IN,P.TypeHierarchyItem.from)}static{this.TestItem=new E("testItem","A VS Code TestItem",d=>d instanceof c.$rO,P.TestItem.from)}constructor(d,y,b,A){this.name=d,this.description=y,this.validate=b,this.convert=A}optional(){return new E(this.name,`(optional) ${this.description}`,d=>d==null||this.validate(d),d=>d===void 0?void 0:d===null?null:this.convert(d))}with(d,y){return new E(d??this.name,y??this.description,this.validate,this.convert)}}e.$CO=E;class w{static{this.Void=new w("no result",d=>d)}constructor(d,y){this.description=d,this.convert=y}}e.$DO=w;class m{constructor(d,y,b,A,T){this.id=d,this.internalId=y,this.description=b,this.args=A,this.result=T}}e.$EO=m}),define(Re[271],Ae([1,0,18,12,2,86,95,36,31,8,7]),function(fe,e,S,F,P,L,R,g,f,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ohc=void 0;const k=[new f.$EO("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[f.$CO.Uri,f.$CO.Position],new f.$DO("A promise that resolves to an array of DocumentHighlight-instances.",v(D.DocumentHighlight.to))),new f.$EO("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[f.$CO.Uri],new f.$DO("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(s,c)=>{if((0,S.$Kb)(s))return;class t extends M.$hM{static to(r){const a=new t(r.name,D.SymbolKind.to(r.kind),r.containerName||"",new M.$bM(c[0],D.Range.to(r.range)));return a.detail=r.detail,a.range=a.location.range,a.selectionRange=D.Range.to(r.selectionRange),a.children=r.children?r.children.map(t.to):[],a}}return s.map(t.to)})),new f.$EO("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[f.$CO.Uri,new f.$CO("options","Formatting options",s=>!0,s=>s)],new f.$DO("A promise that resolves to an array of TextEdits.",v(D.TextEdit.to))),new f.$EO("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[f.$CO.Uri,f.$CO.Range,new f.$CO("options","Formatting options",s=>!0,s=>s)],new f.$DO("A promise that resolves to an array of TextEdits.",v(D.TextEdit.to))),new f.$EO("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[f.$CO.Uri,f.$CO.Position,new f.$CO("ch","Trigger character",s=>typeof s=="string",s=>s),new f.$CO("options","Formatting options",s=>!0,s=>s)],new f.$DO("A promise that resolves to an array of TextEdits.",v(D.TextEdit.to))),new f.$EO("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[f.$CO.Uri,f.$CO.Position],new f.$DO("A promise that resolves to an array of Location or LocationLink instances.",$)),new f.$EO("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[f.$CO.Uri,f.$CO.Position],new f.$DO("A promise that resolves to an array of Location or LocationLink instances.",$)),new f.$EO("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[f.$CO.Uri,f.$CO.Position],new f.$DO("A promise that resolves to an array of Location or LocationLink instances.",$)),new f.$EO("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[f.$CO.Uri,f.$CO.Position],new f.$DO("A promise that resolves to an array of Location or LocationLink instances.",$)),new f.$EO("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[f.$CO.Uri,f.$CO.Position],new f.$DO("A promise that resolves to an array of Location-instances.",v(D.location.to))),new f.$EO("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[f.$CO.Uri,f.$CO.Position],new f.$DO("A promise that resolves to an array of Hover-instances.",v(D.Hover.to))),new f.$EO("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[f.$CO.Uri,new f.$CO("position","A position in a text document",s=>Array.isArray(s)&&s.every(c=>M.$3L.isPosition(c)),s=>s.map(D.Position.from))],new f.$DO("A promise that resolves to an array of ranges.",s=>s.map(c=>{let t;for(const n of c.reverse())t=new M.$lM(D.Range.to(n),t);return t}))),new f.$EO("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[f.$CO.String.with("query","Search string")],new f.$DO("A promise that resolves to an array of SymbolInformation-instances.",s=>s.map(D.WorkspaceSymbol.to))),new f.$EO("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[f.$CO.Uri,f.$CO.Position],new f.$DO("A promise that resolves to an array of CallHierarchyItem-instances",s=>s.map(D.CallHierarchyItem.to))),new f.$EO("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[f.$CO.CallHierarchyItem],new f.$DO("A promise that resolves to an array of CallHierarchyIncomingCall-instances",s=>s.map(D.CallHierarchyIncomingCall.to))),new f.$EO("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[f.$CO.CallHierarchyItem],new f.$DO("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",s=>s.map(D.CallHierarchyOutgoingCall.to))),new f.$EO("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[f.$CO.Uri,f.$CO.Position],new f.$DO("A promise that resolves to a range and placeholder text.",s=>{if(s)return{range:D.Range.to(s.range),placeholder:s.text}})),new f.$EO("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[f.$CO.Uri,f.$CO.Position,f.$CO.String.with("newName","The new symbol name")],new f.$DO("A promise that resolves to a WorkspaceEdit.",s=>{if(s){if(s.rejectReason)throw new Error(s.rejectReason);return D.WorkspaceEdit.to(s)}})),new f.$EO("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[f.$CO.Uri,f.$CO.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new f.$DO("A promise that resolves to an array of DocumentLink-instances.",s=>s.map(D.DocumentLink.to))),new f.$EO("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[f.$CO.Uri],new f.$DO("A promise that resolves to SemanticTokensLegend.",s=>{if(s)return new M.$gN(s.tokenTypes,s.tokenModifiers)})),new f.$EO("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[f.$CO.Uri],new f.$DO("A promise that resolves to SemanticTokens.",s=>{if(!s)return;const c=(0,R.$9_)(s);if(c.type==="full")return new M.$iN(c.data,void 0)})),new f.$EO("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[f.$CO.Uri,f.$CO.Range.optional()],new f.$DO("A promise that resolves to SemanticTokensLegend.",s=>{if(s)return new M.$gN(s.tokenTypes,s.tokenModifiers)})),new f.$EO("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[f.$CO.Uri,f.$CO.Range],new f.$DO("A promise that resolves to SemanticTokens.",s=>{if(!s)return;const c=(0,R.$9_)(s);if(c.type==="full")return new M.$iN(c.data,void 0)})),new f.$EO("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[f.$CO.Uri,f.$CO.Position,f.$CO.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),f.$CO.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new f.$DO("A promise that resolves to a CompletionList-instance.",(s,c,t)=>{if(!s)return new M.$xM([]);const n=s.suggestions.map(r=>D.CompletionItem.to(r,t));return new M.$xM(n,s.incomplete)})),new f.$EO("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[f.$CO.Uri,f.$CO.Position,f.$CO.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new f.$DO("A promise that resolves to SignatureHelp.",s=>{if(s)return D.SignatureHelp.to(s)})),new f.$EO("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[f.$CO.Uri,f.$CO.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new f.$DO("A promise that resolves to an array of CodeLens-instances.",(s,c,t)=>v(n=>new M.$pM(D.Range.to(n.range),n.command&&t.fromInternal(n.command)))(s))),new f.$EO("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[f.$CO.Uri,new f.$CO("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",s=>M.$4L.isRange(s),s=>M.$5L.isSelection(s)?D.Selection.from(s):D.Range.from(s)),f.$CO.String.with("kind","Code action kind to return code actions for").optional(),f.$CO.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new f.$DO("A promise that resolves to an array of Command-instances.",(s,c,t)=>v(n=>{if(n._isSynthetic){if(!n.command)throw new Error("Synthetic code actions must have a command");return t.fromInternal(n.command)}else{const r=new M.$jM(n.title,n.kind?new M.$kM(n.kind):void 0);return n.edit&&(r.edit=D.WorkspaceEdit.to(n.edit)),n.command&&(r.command=t.fromInternal(n.command)),r.isPreferred=n.isPreferred,r}})(s))),new f.$EO("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[f.$CO.Uri],new f.$DO("A promise that resolves to an array of ColorInformation objects.",s=>s?s.map(c=>new M.$DM(D.Range.to(c.range),D.Color.to(c.color))):[])),new f.$EO("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new f.$CO("color","The color to show and insert",s=>s instanceof M.$CM,D.Color.from),new f.$CO("context","Context object with uri and range",s=>!0,s=>({uri:s.uri,range:D.Range.from(s.range)}))],new f.$DO("A promise that resolves to an array of ColorPresentation objects.",s=>s?s.map(D.ColorPresentation.to):[])),new f.$EO("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[f.$CO.Uri,f.$CO.Range],new f.$DO("A promise that resolves to an array of Inlay objects",(s,c,t)=>s.map(D.InlayHint.to.bind(void 0,t)))),new f.$EO("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[f.$CO.Uri],new f.$DO("A promise that resolves to an array of FoldingRange objects",(s,c)=>{if(s)return s.map(D.FoldingRange.to)})),new f.$EO("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new f.$DO("A promise that resolves to an array of NotebookContentProvider static info objects.",v(s=>({viewType:s.viewType,displayName:s.displayName,options:{transientOutputs:s.options.transientOutputs,transientCellMetadata:s.options.transientCellMetadata,transientDocumentMetadata:s.options.transientDocumentMetadata},filenamePattern:s.filenamePattern.map(c=>D.NotebookExclusiveDocumentPattern.to(c))})))),new f.$EO("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[f.$CO.Uri,f.$CO.Range,new f.$CO("context","An InlineValueContext",s=>s&&typeof s.frameId=="number"&&s.stoppedLocation instanceof M.$4L,s=>D.InlineValueContext.from(s))],new f.$DO("A promise that resolves to an array of InlineValue objects",s=>s.map(D.InlineValue.to))),new f.$EO("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new f.$CO("uriOrString","Uri-instance or string (only http/https)",s=>P.URI.isUri(s)||typeof s=="string"&&(0,F.$pg)(s,F.Schemas.http,F.Schemas.https),s=>s),new f.$CO("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",s=>s===void 0||typeof s=="number"||typeof s=="object",s=>s&&(typeof s=="number"?[D.ViewColumn.from(s),void 0]:[D.ViewColumn.from(s.viewColumn),D.TextEditorOpenOptions.from(s)])).optional(),f.$CO.String.with("label","").optional()],f.$DO.Void),new f.$EO("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[f.$CO.Uri.with("resource","Resource to open"),f.$CO.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new f.$CO("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",s=>s===void 0||typeof s=="number"||typeof s=="object",s=>s&&(typeof s=="number"?[D.ViewColumn.from(s),void 0]:[D.ViewColumn.from(s.viewColumn),D.TextEditorOpenOptions.from(s)])).optional()],f.$DO.Void),new f.$EO("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[f.$CO.Uri.with("left","Left-hand side resource of the diff editor"),f.$CO.Uri.with("right","Right-hand side resource of the diff editor"),f.$CO.String.with("title","Human readable title for the diff editor").optional(),new f.$CO("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",s=>s===void 0||typeof s=="object",s=>s&&[D.ViewColumn.from(s.viewColumn),D.TextEditorOpenOptions.from(s)]).optional()],f.$DO.Void),new f.$EO("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[f.$CO.String.with("title","Human readable title for the changes editor"),new f.$CO("resourceList","List of resources to compare",s=>{for(const c of s){if(c.length!==3)return!1;const[t,n,r]=c;if(!P.URI.isUri(t)||!P.URI.isUri(n)&&n!==void 0&&n!==null||!P.URI.isUri(r)&&r!==void 0&&r!==null)return!1}return!0},s=>s)],f.$DO.Void),new f.$EO("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[f.$CO.Uri,f.$CO.Position],new f.$DO("A promise that resolves to an array of TypeHierarchyItem-instances",s=>s.map(D.TypeHierarchyItem.to))),new f.$EO("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[f.$CO.TypeHierarchyItem],new f.$DO("A promise that resolves to an array of TypeHierarchyItem-instances",s=>s.map(D.TypeHierarchyItem.to))),new f.$EO("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[f.$CO.TypeHierarchyItem],new f.$DO("A promise that resolves to an array of TypeHierarchyItem-instances",s=>s.map(D.TypeHierarchyItem.to))),new f.$EO("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[f.$CO.TestItem],f.$DO.Void),new f.$EO("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[f.$CO.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],f.$DO.Void),new f.$EO("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[f.$CO.String.with("name","The context key name"),new f.$CO("value","The context key value",()=>!0,s=>s)],f.$DO.Void),new f.$EO("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[f.$CO.Uri,f.$CO.StringArray,new f.$CO("MappedEditsContext","Mapped Edits Context",s=>D.MappedEditsContext.is(s),s=>D.MappedEditsContext.from(s))],new f.$DO("A promise that resolves to a workspace edit or null",s=>s?D.WorkspaceEdit.to(s):null))];class l{static register(c){k.forEach(c.registerApiCommand,c),this.a(c)}static a(c){c.registerCommand(!1,"_validateWhenClauses",g.$dj)}}e.$Ohc=l;function v(s){return c=>{if(Array.isArray(c))return c.map(s)}}function $(s){if(!Array.isArray(s))return;const c=[];for(const t of s)L.$St(t)?c.push(D.DefinitionLink.to(t)):c.push(D.location.to(t));return c}}),define(Re[272],Ae([1,0,11,6,2,3,31,8,7]),function(fe,e,S,F,P,L,R,g,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wic=void 0;class D{static{this.a=0}constructor(v,$){this.extension=v,this.provider=$,this.handle=D.a++}}class M{constructor(v){this.session=v,this.responses=[]}}class k{static{this.a=0}constructor(v,$,s,c){this.f=s,this.g=c,this.b=new Map,this.d=new Map,this.e=v.getProxy(L.$ZL.MainThreadInlineChat),$.registerApiCommand(new R.$EO("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new R.$CO("Run arguments","",t=>!0,t=>{if(t)return{initialRange:t.initialRange?g.Range.from(t.initialRange):void 0,initialSelection:f.$5L.isSelection(t.initialSelection)?g.Selection.from(t.initialSelection):void 0,message:t.message,autoSend:t.autoSend,position:t.position?g.Position.from(t.position):void 0}})],R.$DO.Void))}registerProvider(v,$,s){const c=new D(v,$);return this.b.set(c.handle,c),this.e.$registerInteractiveEditorProvider(c.handle,s?.label??v.displayName??v.name,v.identifier.value,typeof $.handleInteractiveEditorResponseFeedback=="function",typeof $.provideFollowups=="function",s?.supportReportIssue??!1),(0,F.$Rc)(()=>{this.e.$unregisterInteractiveEditorProvider(c.handle),this.b.delete(c.handle)})}async $prepareSession(v,$,s,c){const t=this.b.get(v);if(!t){this.g.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const n=this.f.getDocument(P.URI.revive($)),r=g.Selection.to(s),a=await t.provider.prepareInteractiveEditorSession({document:n,selection:r},c);if(!a)return;if(a.wholeRange&&!a.wholeRange.contains(r))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const h=k.a++;return this.d.set(h,new M(a)),{id:h,placeholder:a.placeholder,input:a.input,slashCommands:a.slashCommands?.map(i=>({command:i.command,detail:i.detail,refer:i.refer,executeImmediately:i.executeImmediately})),wholeRange:g.Range.from(a.wholeRange),message:a.message}}async $provideResponse(v,$,s,c){const t=this.b.get(v);if(!t)return;const n=this.d.get($.id);if(!n)return;const r={prompt:s.prompt,selection:g.Selection.to(s.selection),wholeRange:g.Range.to(s.wholeRange),attempt:s.attempt,live:s.live,previewDocument:this.f.getDocument(P.URI.revive(s.previewDocument)),withIntentDetection:s.withIntentDetection};let a=!1;const h={report:async I=>{if(!s.live&&I.edits?.length)throw new Error("Progress reporting is only supported for live sessions");a||c.isCancellationRequested||await this.e.$handleProgressChunk(s.requestId,{message:I.message,edits:I.edits?.map(g.TextEdit.from),editsShouldBeInstant:I.editsShouldBeInstant,slashCommand:I.slashCommand?.command,markdownFragment:f.$qM.isMarkdownString(I.content)?I.content.value:I.content})}},i=Promise.resolve(t.provider.provideInteractiveEditorResponse(n.session,r,h,c));let p;try{p=await(0,S.$5g)(i,c)}finally{a=!0}if(!p)return;const u=n.responses.push(p)-1,o={wholeRange:g.Range.from(p.wholeRange),placeholder:p.placeholder};if(!k.h(p))return{...o,id:u,type:"editorEdit",message:g.MarkdownString.from(p.contents),edits:[]};const{edits:E,contents:w}=p,m=w!==void 0?g.MarkdownString.from(w):void 0;return E instanceof f.$_L?{...o,id:u,type:"bulkEdit",edits:g.WorkspaceEdit.from(E),message:m}:{...o,id:u,type:"editorEdit",edits:E.map(g.TextEdit.from),message:m}}async $provideFollowups(v,$,s,c){const t=this.b.get(v),n=this.d.get($),r=n?.responses[s];if(t&&r&&t.provider.provideFollowups){const a=Promise.resolve(t.provider.provideFollowups(n.session,r,c));return(await(0,S.$5g)(a,c))?.map(g.ChatInlineFollowup.from)}}$handleFeedback(v,$,s,c){const t=this.b.get(v),n=this.d.get($),r=n?.responses[s];if(t&&r){const a=g.InteractiveEditorResponseFeedbackKind.to(c);t.provider.handleInteractiveEditorResponseFeedback?.(n.session,r,a)}}$releaseSession(v,$){}static h(v){return typeof v=="object"&&typeof v.edits=="object"}}e.$Wic=k}),define(Re[273],Ae([1,0,2,31]),function(fe,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0ic=void 0;class P{constructor(R,g,f,D,M){this.a=g,this.b=f,this.c=D;const k=new F.$EO("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new F.$CO("showOptions","Show Options",l=>!0,l=>l),new F.$CO("resource","Interactive resource Uri",l=>!0,l=>l),new F.$CO("controllerId","Notebook controller Id",l=>!0,l=>l),new F.$CO("title","Interactive editor title",l=>!0,l=>l)],new F.$DO("Notebook and input URI",l=>{if(M.debug("[ExtHostInteractive] open iw with notebook editor id",l.notebookEditorId),l.notebookEditorId!==void 0){const v=this.a.getEditorById(l.notebookEditorId);return M.debug("[ExtHostInteractive] notebook editor found",v.id),{notebookUri:S.URI.revive(l.notebookUri),inputUri:S.URI.revive(l.inputUri),notebookEditor:v.apiEditor}}return M.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",l.notebookUri,l.inputUri),{notebookUri:S.URI.revive(l.notebookUri),inputUri:S.URI.revive(l.inputUri)}}));this.c.registerApiCommand(k)}$willAddInteractiveDocument(R,g,f,D){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:g,lines:[""],languageId:f,uri:R,isDirty:!1,versionId:1}]})}$willRemoveInteractiveDocument(R,g){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[R]})}}e.$0ic=P}),define(Re[274],Ae([1,0,18,11,22,5,6,28,2,20,14,3,31,8,7,76,211,23,49,212]),function(fe,e,S,F,P,L,R,g,f,D,M,k,l,v,$,s,c,t,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gjc=e.$fjc=void 0;let a=class{constructor(m,I,d,y,b){this.m=I,this.n=d,this.o=y,this.q=b,this.b=new g.$Ac,this.c=new g.$Ac,this.f=new Map,this.g=0,this.h=new Map,this.i=0,this.j=new Map,this.k=0,this.l=new L.$5d,this.onDidChangeNotebookCellExecutionState=this.l.event,this.r=0,this.s={},this.a=m.getProxy(k.$ZL.MainThreadNotebookKernels);const A=new l.$EO("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new l.$CO("options","Select kernel options",G=>!0,G=>{if(G&&"notebookEditor"in G&&"id"in G){const W=this.n.getIdByEditor(G.notebookEditor);return{id:G.id,extension:G.extension,notebookEditorId:W}}else if(G&&"notebookEditor"in G){const W=this.n.getIdByEditor(G.notebookEditor);if(W===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${G.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:W}}return G})],l.$DO.Void),T=new l.$EO("vscode.executeNotebookVariableProvider","_executeNotebookVariableProvider","Execute notebook variable provider",[l.$CO.Uri],new l.$DO("A promise that resolves to an array of variables",(G,W)=>G.map(U=>({name:U.name,value:U.value,type:U.type,editable:!1}))));this.o.registerApiCommand(A),this.o.registerApiCommand(T)}createNotebookController(m,I,d,y,b,A){for(const $e of this.j.values())if($e.controller.id===I&&D.$wm.equals(m.identifier,$e.extensionId))throw new Error(`notebook controller with id '${I}' ALREADY exist`);const T=this.k++,G=this;this.q.trace(`NotebookController[${T}], CREATED by ${m.identifier.value}, ${I}`);const W=()=>console.warn(`NO execute handler from notebook controller '${V.id}' of extension: '${m.identifier}'`);let U=!1;const C=new L.$5d,O=new L.$5d,V={id:E(m.identifier,I),notebookType:d,extensionId:m.identifier,extensionLocation:m.extensionLocation,label:y||m.identifier.value,preloads:A?A.map(v.NotebookRendererScript.from):[]};let re=b??W,ue,ye;this.a.$addKernel(T,V).catch($e=>{console.log($e),U=!0});let De=0;const he=()=>{if(U)return;const $e=++De;Promise.resolve().then(()=>{$e===De&&this.a.$updateKernel(T,V)})},ve=new g.$Ac,se={get id(){return I},get notebookType(){return V.notebookType},onDidChangeSelectedNotebooks:C.event,get label(){return V.label},set label($e){V.label=$e??m.displayName??m.name,he()},get detail(){return V.detail??""},set detail($e){V.detail=$e,he()},get description(){return V.description??""},set description($e){V.description=$e,he()},get supportedLanguages(){return V.supportedLanguages},set supportedLanguages($e){V.supportedLanguages=$e,he()},get supportsExecutionOrder(){return V.supportsExecutionOrder??!1},set supportsExecutionOrder($e){V.supportsExecutionOrder=$e,he()},get rendererScripts(){return V.preloads?V.preloads.map(v.NotebookRendererScript.to):[]},get executeHandler(){return re},set executeHandler($e){re=$e??W},get interruptHandler(){return ue},set interruptHandler($e){ue=$e,V.supportsInterrupt=!!$e,he()},set variableProvider($e){(0,t.$VF)(m,"notebookVariableProvider"),ye=$e,V.hasVariableProvider=!!$e,$e?.onDidChangeVariables(ee=>G.a.$variablesUpdated(ee.uri)),he()},get variableProvider(){return ye},createNotebookCellExecution($e){if(U)throw new Error("notebook controller is DISPOSED");if(!ve.has($e.notebook.uri))throw G.q.trace(`NotebookController[${T}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ve.keys()).map(ee=>ee.toString())),new Error(`notebook controller is NOT associated to notebook: ${$e.notebook.uri.toString()}`);return G._createNotebookCellExecution($e,E(m.identifier,this.id))},createNotebookExecution($e){if((0,t.$VF)(m,"notebookExecution"),U)throw new Error("notebook controller is DISPOSED");if(!ve.has($e.uri))throw G.q.trace(`NotebookController[${T}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ve.keys()).map(ee=>ee.toString())),new Error(`notebook controller is NOT associated to notebook: ${$e.uri.toString()}`);return G._createNotebookExecution($e,E(m.identifier,this.id))},dispose:()=>{U||(this.q.trace(`NotebookController[${T}], DISPOSED`),U=!0,this.j.delete(T),C.dispose(),O.dispose(),this.a.$removeKernel(T))},updateNotebookAffinity($e,ee){ee===$.NotebookControllerAffinity2.Hidden&&(0,t.$VF)(m,"notebookControllerAffinityHidden"),G.a.$updateNotebookPriority(T,$e.uri,ee)},onDidReceiveMessage:O.event,postMessage($e,ee){return(0,t.$VF)(m,"notebookMessaging"),G.a.$postMessage(T,ee&&G.n.getIdByEditor(ee),$e)},asWebviewUri($e){return(0,t.$VF)(m,"notebookMessaging"),(0,s.$Axb)($e,G.m.remote)}};return this.j.set(T,{extensionId:m.identifier,controller:se,onDidReceiveMessage:O,onDidChangeSelection:C,associatedNotebooks:ve}),se}getIdByController(m){for(const[I,d]of this.j)if(d.controller===m)return E(d.extensionId,m.id);return null}createNotebookControllerDetectionTask(m,I){const d=this.g++,y=this;this.q.trace(`NotebookControllerDetectionTask[${d}], CREATED by ${m.identifier.value}`),this.a.$addKernelDetectionTask(d,I);const b={dispose:()=>{this.f.delete(d),y.a.$removeKernelDetectionTask(d)}};return this.f.set(d,b),b}registerKernelSourceActionProvider(m,I,d){const y=this.i++,b=typeof d.onDidChangeNotebookKernelSourceActions=="function"?y:void 0,A=this;this.h.set(y,d),this.q.trace(`NotebookKernelSourceActionProvider[${y}], CREATED by ${m.identifier.value}`),this.a.$addKernelSourceActionProvider(y,y,I);let T;return b!==void 0&&(T=d.onDidChangeNotebookKernelSourceActions(G=>this.a.$emitNotebookKernelSourceActionsChangeEvent(b))),{dispose:()=>{this.h.delete(y),A.a.$removeKernelSourceActionProvider(y,y),T?.dispose()}}}async $provideKernelSourceActions(m,I){const d=this.h.get(m);if(d){const y=new R.$Sc;return(await d.provideNotebookKernelSourceActions(I)??[]).map(A=>v.NotebookKernelSourceAction.from(A,this.o.converter,y))}return[]}$acceptNotebookAssociation(m,I,d){const y=this.j.get(m);if(y){const b=this.n.getNotebookDocument(f.URI.revive(I));d?y.associatedNotebooks.set(b.uri,!0):y.associatedNotebooks.delete(b.uri),this.q.trace(`NotebookController[${m}] ASSOCIATE notebook`,b.uri.toString(),d),y.onDidChangeSelection.fire({selected:d,notebook:b.apiNotebook})}}async $executeCells(m,I,d){const y=this.j.get(m);if(!y)return;const b=this.n.getNotebookDocument(f.URI.revive(I)),A=[];for(const T of d){const G=b.getCell(T);G&&A.push(G.apiCell)}try{this.q.trace(`NotebookController[${m}] EXECUTE cells`,b.uri.toString(),A.length),await y.controller.executeHandler.call(y.controller,A,b.apiNotebook,y.controller)}catch(T){this.q.error(`NotebookController[${m}] execute cells FAILED`,T),console.error(T)}}async $cancelCells(m,I,d){const y=this.j.get(m);if(!y)return;const b=this.n.getNotebookDocument(f.URI.revive(I));if(y.controller.interruptHandler)await y.controller.interruptHandler.call(y.controller,b.apiNotebook);else for(const A of d){const T=b.getCell(A);T&&this.b.get(T.uri)?.cancel()}if(y.controller.interruptHandler){const A=this.c.get(b.uri);d.length&&Array.isArray(A)&&A.length&&A.forEach(T=>T.dispose())}}async $provideVariables(m,I,d,y,b,A,T){const G=this.j.get(m);if(!G)return;const W=this.n.getNotebookDocument(f.URI.revive(d)),U=G.controller.variableProvider;if(!U)return;let C;if(y!==void 0){if(C=this.s[y],!C)return}else this.s={};const O=b==="named"?$.NotebookVariablesRequestKind.Named:$.NotebookVariablesRequestKind.Indexed,V=U.provideVariables(W.apiNotebook,C,O,A,T);let re=0;for await(const ue of V){if(T.isCancellationRequested)return;const ye={id:this.r++,name:ue.variable.name,value:ue.variable.value,type:ue.variable.type,hasNamedChildren:ue.hasNamedChildren,indexedChildrenCount:ue.indexedChildrenCount,extensionId:G.extensionId.value};if(this.s[ye.id]=ue.variable,this.a.$receiveVariable(I,ye),re++>=r.$Zgb)return}}$acceptKernelMessageFromRenderer(m,I,d){const y=this.j.get(m);if(!y)return;const b=this.n.getEditorById(I);y.onDidReceiveMessage.fire(Object.freeze({editor:b.apiEditor,message:d}))}$cellExecutionChanged(m,I,d){const b=this.n.getNotebookDocument(f.URI.revive(m)).getCell(I);if(b){const A=d?v.NotebookCellExecutionState.to(d):$.NotebookCellExecutionState.Idle;A!==void 0&&this.l.fire({cell:b.apiCell,state:A})}}_createNotebookCellExecution(m,I){if(m.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const y=this.n.getNotebookDocument(m.notebook.uri).getCellFromApiCell(m);if(!y)throw new Error("invalid cell");if(this.b.has(y.uri))throw new Error(`duplicate execution for ${y.uri}`);const b=new i(I,y,this.a);this.b.set(y.uri,b);const A=b.onDidChangeState(()=>{b.state===h.Resolved&&(b.dispose(),A.dispose(),this.b.delete(y.uri))});return b.asApiObject()}_createNotebookExecution(m,I){const d=this.n.getNotebookDocument(m.uri),y=m.getCells().find(T=>{const G=d.getCellFromApiCell(T);return G&&this.b.has(G.uri)});if(y)throw new Error(`duplicate cell execution for ${y.document.uri}`);if(this.c.has(d.uri))throw new Error(`duplicate notebook execution for ${d.uri}`);const b=new u(I,d,this.a),A=b.onDidChangeState(()=>{b.state===p.Resolved&&(b.dispose(),A.dispose(),this.c.delete(d.uri))});return this.c.set(d.uri,[b,A]),b.asApiObject()}};e.$fjc=a,e.$fjc=a=Ze([qe(4,M.$yj)],a);var h;(function(w){w[w.Init=0]="Init",w[w.Started=1]="Started",w[w.Resolved=2]="Resolved"})(h||(h={}));class i extends R.$Tc{static{this.a=0}get state(){return this.f}constructor(m,I,d){super(),this.m=I,this.n=d,this.b=i.a++,this.c=new L.$5d,this.onDidChangeState=this.c.event,this.f=h.Init,this.g=this.B(new P.$ce),this.h=new o(10,y=>this.s(y)),this.j=I.internalMetadata.executionOrder,this.n.$createExecution(this.b,m,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(m){await this.h.addItem(m)}async s(m){const I=Array.isArray(m)?m:[m];return this.n.$updateExecution(this.b,new n.$6v(I))}t(){if(this.f===h.Init)throw new Error("Must call start before modifying cell output");if(this.f===h.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(m){let I=this.m;if(m&&(I=this.m.notebook.getCellFromApiCell(m)),!I)throw new Error("INVALID cell");return I.handle}y(m){return m.map(I=>{const d=$.$tN.ensureUniqueMimeTypes(I.items,!0);return d===I.items?v.NotebookCellOutput.from(I):v.NotebookCellOutput.from({items:d,id:I.id,metadata:I.metadata})})}async z(m,I,d){const y=this.w(I),b=this.y((0,S.$3b)(m));return this.r({editType:c.CellExecutionUpdateType.Output,cellHandle:y,append:d,outputs:b})}async C(m,I,d){return m=$.$tN.ensureUniqueMimeTypes((0,S.$3b)(m),!0),this.r({editType:c.CellExecutionUpdateType.OutputItems,items:m.map(v.NotebookCellOutputItem.from),outputId:I.id,append:d})}asApiObject(){const m=this;return Object.freeze({get token(){return m.g.token},get cell(){return m.m.apiCell},get executionOrder(){return m.j},set executionOrder(d){m.j=d,m.s([{editType:c.CellExecutionUpdateType.ExecutionState,executionOrder:m.j}])},start(d){if(m.f===h.Resolved||m.f===h.Started)throw new Error("Cannot call start again");m.f=h.Started,m.c.fire(),m.s({editType:c.CellExecutionUpdateType.ExecutionState,runStartTime:d})},end(d,y){if(m.f===h.Resolved)throw new Error("Cannot call resolve twice");m.f=h.Resolved,m.c.fire(),m.h.flush(),m.n.$completeExecution(m.b,new n.$6v({runEndTime:y,lastRunSuccess:d}))},clearOutput(d){return m.t(),m.z([],d,!1)},appendOutput(d,y){return m.t(),m.z(d,y,!0)},replaceOutput(d,y){return m.t(),m.z(d,y,!1)},appendOutputItems(d,y){return m.t(),m.C(d,y,!0)},replaceOutputItems(d,y){return m.t(),m.C(d,y,!1)}})}}var p;(function(w){w[w.Init=0]="Init",w[w.Started=1]="Started",w[w.Resolved=2]="Resolved"})(p||(p={}));class u extends R.$Tc{static{this.a=0}get state(){return this.f}constructor(m,I,d){super(),this.h=I,this.j=d,this.b=u.a++,this.c=new L.$5d,this.onDidChangeState=this.c.event,this.f=p.Init,this.g=this.B(new P.$ce),this.j.$createNotebookExecution(this.b,m,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===p.Resolved||this.f===p.Started)throw new Error("Cannot call start again");this.f=p.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===p.Resolved)throw new Error("Cannot call resolve twice");this.f=p.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class o{constructor(m,I){this.f=m,this.g=I,this.a=[],this.b=Date.now()}addItem(m){return this.a.push(m),this.c||(this.c=new F.$Bh,this.b=Date.now(),(0,F.$fh)(this.f).then(()=>this.flush())),Date.now()-this.b>this.f?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const m=this.c;this.c=void 0;const I=this.a;return this.a=[],this.g(I).finally(()=>m.complete())}}function E(w,m){return`${w.value}/${m}`}e.$gjc=E}),define(Re[66],Ae([1,0,5,3,4,2,17,6,7,167,15,195,22,33,196,41,11,8,31]),function(fe,e,S,F,P,L,R,g,f,D,M,k,l,v,$,s,c,t,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uic=e.$tic=e.$sic=e.$ric=void 0,e.$ric=(0,P.$ei)("IExtHostTerminalService");class r{constructor(d,y,b,A){this.l=d,this._id=y,this.m=b,this.n=A,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.m=Object.freeze(this.m),this.b=new Promise(G=>this.f=G);const T=this;this.value={get name(){return T.n||""},get processId(){return T.b},get creationOptions(){return T.m},get exitStatus(){return T.h},get state(){return T.j},get selection(){return T.k},sendText(G,W=!0){T.q(),T.l.$sendText(T._id,G,W)},show(G){T.q(),T.l.$show(T._id,G)},hide(){T.q(),T.l.$hide(T._id)},dispose(){T.a||(T.a=!0,T.l.$dispose(T._id))},get dimensions(){if(!(T.d===void 0||T.g===void 0))return{columns:T.d,rows:T.g}}}}async create(d,y){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.l.$createTerminal(this._id,{name:d.name,shellPath:d.shellPath??void 0,shellArgs:d.shellArgs??void 0,cwd:d.cwd??y?.cwd??void 0,env:d.env??void 0,icon:E(d.iconPath)??void 0,color:s.ThemeColor.isThemeColor(d.color)?d.color.id:void 0,initialText:d.message??void 0,strictEnv:d.strictEnv??void 0,hideFromUser:d.hideFromUser??void 0,isFeatureTerminal:y?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:y?.useShellEnvironment??void 0,location:y?.location||this.o(d.location,y?.resolvedExtHostIdentifier),isTransient:d.isTransient??void 0})}async createExtensionTerminal(d,y,b,A,T){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.l.$createTerminal(this._id,{name:this.n,isExtensionCustomPtyTerminal:!0,icon:A,color:s.ThemeColor.isThemeColor(T)?T.id:void 0,location:y?.location||this.o(d,b),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}o(d,y){return typeof d=="object"?"parentTerminal"in d&&d.parentTerminal&&y?{parentTerminal:y}:"viewColumn"in d?{viewColumn:t.ViewColumn.from(d.viewColumn),preserveFocus:d.preserveFocus}:void 0:d}q(){if(this.a)throw new Error("Terminal has already been disposed")}set name(d){this.n=d}setExitStatus(d,y){this.h=Object.freeze({code:d,reason:y})}setDimensions(d,y){return d===this.d&&y===this.g||d===0||y===0?!1:(this.d=d,this.g=y,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}setSelection(d){this.k=d}_setProcessId(d){this.f?(this.f(d),this.f=void 0):this.b.then(y=>{y!==d&&(this.b=Promise.resolve(d))})}}e.$sic=r;class a{get onProcessReady(){return this.b.event}constructor(d){this.g=d,this.id=0,this.shouldPersist=!1,this.a=new S.$5d,this.onProcessData=this.a.event,this.b=new S.$5d,this.d=new S.$5d,this.onDidChangeProperty=this.d.event,this.f=new S.$5d,this.onProcessExit=this.f.event}refreshProperty(d){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${d}`)}updateProperty(d,y){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${d}, value: ${y}`)}async start(){}shutdown(){this.g.close()}input(d){this.g.handleInput?.(d)}resize(d,y){this.g.setDimensions?.({columns:d,rows:y})}clearBuffer(){}async processBinary(d){}acknowledgeDataEvent(d){}async setUnicodeVersion(d){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(d){this.g.onDidWrite(y=>this.a.fire(y)),this.g.onDidClose?.((y=void 0)=>{this.f.fire(y===void 0?void 0:y)}),this.g.onDidOverrideDimensions?.(y=>{y&&this.d.fire({type:"overrideDimensions",value:{cols:y.columns,rows:y.rows}})}),this.g.onDidChangeName?.(y=>{this.d.fire({type:"title",value:y})}),this.g.open(d||void 0),d&&this.g.setDimensions?.(d),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let h=1,i=class extends g.$Tc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(d=>d.value)}constructor(d,y,b){super(),this.Q=y,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new g.$Uc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new S.$5d,this.onDidCloseTerminal=this.H.event,this.I=new S.$5d,this.onDidOpenTerminal=this.I.event,this.J=new S.$5d,this.onDidChangeActiveTerminal=this.J.event,this.L=new S.$5d,this.onDidChangeTerminalDimensions=this.L.event,this.M=new S.$5d,this.onDidChangeTerminalState=this.M.event,this.N=new S.$5d,this.onDidChangeShell=this.N.event,this.O=new S.$5d({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new S.$5d({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=b.getProxy(F.$ZL.MainThreadTerminalService),this.y=new $.$Gtb(this.a.$sendProcessData),this.a.$registerProcessSupport(d),this.Q.registerArgumentProcessor({processArgument:A=>{const T=G=>{const W=G;return this.W(W.instanceId)?.value};switch(A?.$mid){case 15:return T(A);default:{if(Array.isArray(A))for(let G=0;G<A.length&&A[G].$mid===15;G++)A[G]=T(A[G]);return A}}}}),this.B({dispose:()=>{for(const[A,T]of this.g)T.shutdown(!0)}})}getDefaultShell(d){return(d?this.u:this.s)?.path||""}getDefaultShellArgs(d){return(d?this.u:this.s)?.args||[]}createExtensionTerminal(d,y){const b=new r(this.a,(0,v.$Ag)(),d,d.name),A=new a(d.pty);return b.createExtensionTerminal(d.location,y,this.R(d,y).resolvedExtHostIdentifier,E(d.iconPath),w(d.color)).then(T=>{const G=this.S(T,A);this.h[T]=G}),this.f.push(b),b.value}R(d,y){if(y=y||{},d.location&&typeof d.location=="object"&&"parentTerminal"in d.location){const b=d.location.parentTerminal;if(b){const A=this.f.find(T=>T.value===b);A&&(y.resolvedExtHostIdentifier=A._id)}}else d.location&&typeof d.location!="object"?y.location=d.location:y.location&&typeof y.location=="object"&&"splitActiveTerminal"in y.location&&(y.location={splitActiveTerminal:!0});return y}attachPtyToTerminal(d,y){if(!this.W(d))throw new Error(`Cannot resolve terminal with id ${d} for virtual process`);const A=new a(y),T=this.S(d,A);this.h[d]=T}async $acceptActiveTerminalChanged(d){const y=this.b;if(d===null){this.b=void 0,y!==this.b&&this.J.fire(this.b);return}const b=this.W(d);b&&(this.b=b,y!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(d,y){const b=this.W(d);b&&this.O.fire({terminal:b.value,data:y})}async $acceptTerminalDimensions(d,y,b){const A=this.W(d);A&&A.setDimensions(y,b)&&this.L.fire({terminal:A.value,dimensions:A.value.dimensions})}async $acceptDidExecuteCommand(d,y){const b=this.W(d);b&&this.P.fire({terminal:b.value,...y})}async $acceptTerminalMaximumDimensions(d,y,b){this.g.get(d)?.resize(y,b)}async $acceptTerminalTitleChange(d,y){const b=this.W(d);b&&(b.name=y)}async $acceptTerminalClosed(d,y,b){const A=this.Y(this.f,d);if(A!==null){const T=this.f.splice(A,1)[0];T.setExitStatus(y,b),this.H.fire(T.value)}}$acceptTerminalOpened(d,y,b,A){if(y){const W=this.Y(this.f,y);if(W!==null){this.f[W]._id=d,this.I.fire(this.terminals[W]),this.f[W].isOpen=!0;return}}const T={name:A.name,shellPath:A.executable,shellArgs:A.args,cwd:typeof A.cwd=="string"?A.cwd:L.URI.revive(A.cwd),env:A.env,hideFromUser:A.hideFromUser},G=new r(this.a,d,T,b);this.f.push(G),this.I.fire(G.value),G.isOpen=!0}async $acceptTerminalProcessId(d,y){this.W(d)?._setProcessId(y)}async $startExtensionTerminal(d,y){const b=this.W(d);if(!b)return{message:(0,D.localize)(0,null,d)};b.isOpen||await new Promise(T=>{const G=this.onDidOpenTerminal(async W=>{W===b.value&&(G.dispose(),T())})});const A=this.g.get(d);A?A.startSendingEvents(y):this.j[d]={initialDimensions:y}}S(d,y){const b=new g.$Sc;b.add(y.onProcessReady(T=>this.a.$sendProcessReady(d,T.pid,T.cwd,T.windowsPty))),b.add(y.onDidChangeProperty(T=>this.a.$sendProcessProperty(d,T))),this.y.startBuffering(d,y.onProcessData),b.add(y.onProcessExit(T=>this.U(d,T))),this.g.set(d,y);const A=this.j[d];return A&&y instanceof a&&(y.startSendingEvents(A.initialDimensions),delete this.j[d]),b}$acceptProcessAckDataEvent(d,y){this.g.get(d)?.acknowledgeDataEvent(y)}$acceptProcessInput(d,y){this.g.get(d)?.input(y)}$acceptTerminalInteraction(d){const y=this.W(d);y?.setInteractedWith()&&this.M.fire(y.value)}$acceptTerminalSelection(d,y){this.W(d)?.setSelection(y)}$acceptProcessResize(d,y,b){try{this.g.get(d)?.resize(y,b)}catch(A){if(A.code!=="EPIPE"&&A.code!=="ERR_IPC_CHANNEL_CLOSED")throw A}}$acceptProcessShutdown(d,y){this.g.get(d)?.shutdown(y)}$acceptProcessRequestInitialCwd(d){this.g.get(d)?.getInitialCwd().then(y=>this.a.$sendProcessProperty(d,{type:"initialCwd",value:y}))}$acceptProcessRequestCwd(d){this.g.get(d)?.getCwd().then(y=>this.a.$sendProcessProperty(d,{type:"cwd",value:y}))}$acceptProcessRequestLatency(d){return Promise.resolve(d)}registerLinkProvider(d){return this.z.add(d),this.z.size===1&&this.a.$startLinkProvider(),new f.$2L(()=>{this.z.delete(d),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(d,y,b){if(this.C.has(y))throw new Error(`Terminal profile provider "${y}" already registered`);return this.C.set(y,b),this.a.$registerProfileProvider(y,d.identifier.value),new f.$2L(()=>{this.C.delete(y),this.a.$unregisterProfileProvider(y)})}registerTerminalQuickFixProvider(d,y,b){if(this.D.has(d))throw new Error(`Terminal quick fix provider "${d}" is already registered`);return this.D.set(d,b),this.a.$registerQuickFixProvider(d,y),new f.$2L(()=>{this.D.delete(d),this.a.$unregisterQuickFixProvider(d)})}async $provideTerminalQuickFixes(d,y){const b=new l.$ce().token;if(b.isCancellationRequested)return;const A=this.D.get(d);if(!A)return;const T=await A.provideTerminalQuickFixes(y,b);if(T===null||Array.isArray(T)&&T.length===0)return;const G=new g.$Sc;if(this.w.value=G,!Array.isArray(T))return T?t.TerminalQuickFix.from(T,this.Q.converter,G):void 0;const W=[];for(const U of T){const C=t.TerminalQuickFix.from(U,this.Q.converter,G);C&&W.push(C)}return W}async $createContributedProfileTerminal(d,y){const b=new l.$ce().token;let A=await this.C.get(d)?.provideTerminalProfile(b);if(!b.isCancellationRequested){if(A&&!("options"in A)&&(A={options:A}),!A||!("options"in A))throw new Error(`No terminal profile options provided for id "${d}"`);if("pty"in A.options){this.createExtensionTerminal(A.options,y);return}this.createTerminalFromOptions(A.options,y)}}async $provideLinks(d,y){const b=this.W(d);if(!b)return[];this.F.delete(d),this.G.get(d)?.dispose(!0);const T=new l.$ce;this.G.set(d,T);const G=[],W={terminal:b.value,line:y},U=[];for(const V of this.z)U.push(c.Promises.withAsyncBody(async re=>{T.token.onCancellationRequested(()=>re({provider:V,links:[]}));const ue=await V.provideTerminalLinks(W,T.token)||[];T.token.isCancellationRequested||re({provider:V,links:ue})}));const C=await Promise.all(U);if(T.token.isCancellationRequested)return[];const O=new Map;for(const V of C)V&&V.links.length>0&&G.push(...V.links.map(re=>{const ue={id:h++,startIndex:re.startIndex,length:re.length,label:re.tooltip};return O.set(ue.id,{provider:V.provider,link:re}),ue}));return this.F.set(d,O),G}$activateLink(d,y){const b=this.F.get(d)?.get(y);b&&b.provider.handleTerminalLink(b.link)}U(d,y){this.y.stopBuffering(d),this.g.delete(d),delete this.j[d];const b=this.h[d];b&&(b.dispose(),delete this.h[d]),this.a.$sendProcessExit(d,y)}W(d){return this.X(this.f,d)}X(d,y){const b=this.Y(d,y);return b!==null?d[b]:null}Y(d,y){const b=d.findIndex(A=>A._id===y);return b===-1?null:b}getEnvironmentVariableCollection(d){let y=this.n.get(d.identifier.value);return y||(y=new p,this.$(d.identifier.value,y)),y.getScopedEnvironmentVariableCollection(void 0)}Z(d,y){const b=(0,k.$Xr)(y.map),A=(0,k.$Yr)(y.descriptionMap);this.a.$setEnvironmentVariableCollection(d,y.persistent,b.length===0?void 0:b,A)}$initEnvironmentVariableCollections(d){d.forEach(y=>{const b=y[0],A=new p(y[1]);this.$(b,A)})}$acceptDefaultProfile(d,y){const b=this.s;this.s=d,this.u=y,b?.path!==d.path&&this.N.fire(d.path)}$(d,y){this.n.set(d,y),y.onDidChangeCollection(()=>{this.Z(d,y)})}};e.$tic=i,e.$tic=i=Ze([qe(1,n.$AO),qe(2,R.$eO)],i);class p{get persistent(){return this.b}set persistent(d){this.b=d,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(d){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new S.$5d,this.map=new Map(d)}getScopedEnvironmentVariableCollection(d){const y=this.h(d);let b=this.a.get(y);return b||(b=new u(this,d),this.a.set(y,b),b.onDidChangeCollection(()=>this.d.fire())),b}replace(d,y,b,A){this.f(d,{value:y,type:f.EnvironmentVariableMutatorType.Replace,options:b??{applyAtProcessCreation:!0},scope:A})}append(d,y,b,A){this.f(d,{value:y,type:f.EnvironmentVariableMutatorType.Append,options:b??{applyAtProcessCreation:!0},scope:A})}prepend(d,y,b,A){this.f(d,{value:y,type:f.EnvironmentVariableMutatorType.Prepend,options:b??{applyAtProcessCreation:!0},scope:A})}f(d,y){if(y.options&&y.options.applyAtProcessCreation===!1&&!y.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const b=this.g(d,y.scope),A=this.map.get(b),T=y.options?{applyAtProcessCreation:y.options.applyAtProcessCreation??!1,applyAtShellIntegration:y.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!A||A.value!==y.value||A.type!==y.type||A.options?.applyAtProcessCreation!==T.applyAtProcessCreation||A.options?.applyAtShellIntegration!==T.applyAtShellIntegration||A.scope?.workspaceFolder?.index!==y.scope?.workspaceFolder?.index){const G=this.g(d,y.scope),W={variable:d,...y,options:T};this.map.set(G,W),this.d.fire()}}get(d,y){const b=this.g(d,y),A=this.map.get(b);return A?m(A):void 0}g(d,y){const b=this.h(y);return b.length?`${d}:::${b}`:d}h(d){return this.j(d?.workspaceFolder)??""}j(d){return d?d.uri.toString():void 0}getVariableMap(d){const y=new Map;for(const[b,A]of this.map)this.h(A.scope)===this.h(d)&&y.set(A.variable,m(A));return y}delete(d,y){const b=this.g(d,y);this.map.delete(b),this.d.fire()}clear(d){if(d?.workspaceFolder){for(const[y,b]of this.map)b.scope?.workspaceFolder?.index===d.workspaceFolder.index&&this.map.delete(y);this.k(d)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(d,y){const b=this.h(y),A=this.descriptionMap.get(b);if(!A||A.description!==d){let T;typeof d=="string"?T=d:T=d?.value.split(`

`)[0];const G={description:T,scope:y};this.descriptionMap.set(b,G),this.d.fire()}}getDescription(d){const y=this.h(d);return this.descriptionMap.get(y)?.description}k(d){const y=this.h(d);this.descriptionMap.delete(y)}}class u{get persistent(){return this.b.persistent}set persistent(d){this.b.persistent=d}get onDidChangeCollection(){return this.a&&this.a.event}constructor(d,y){this.b=d,this.d=y,this.a=new S.$5d}getScoped(d){return this.b.getScopedEnvironmentVariableCollection(d)}replace(d,y,b){this.b.replace(d,y,b,this.d)}append(d,y,b){this.b.append(d,y,b,this.d)}prepend(d,y,b){this.b.prepend(d,y,b,this.d)}get(d){return this.b.get(d,this.d)}forEach(d,y){this.b.getVariableMap(this.d).forEach((b,A)=>d.call(y,A,b,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(d){this.b.delete(d,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(d){this.b.setDescription(d,this.d)}get description(){return this.b.getDescription(this.d)}}let o=class extends i{constructor(d,y){super(!1,d,y)}createTerminal(d,y,b){throw new M.$_}createTerminalFromOptions(d,y){throw new M.$_}};e.$uic=o,e.$uic=o=Ze([qe(0,n.$AO),qe(1,R.$eO)],o);function E(I){if(!(!I||typeof I=="string"))return"id"in I?{id:I.id,color:I.color}:I}function w(I){return s.ThemeColor.isThemeColor(I)?I:void 0}function m(I){const d={...I};return delete d.scope,d.options=d.options??void 0,delete d.variable,d}}),define(Re[275],Ae([1,0,11,24,22,5,246,97,6,26,16,33,14,3,17,111,8,7,48,75,60,23]),function(fe,e,S,F,P,L,R,g,f,D,M,k,l,v,$,s,c,t,n,r,a,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ajc=e.$zjc=e.$yjc=e.$xjc=void 0;let i=class extends f.$Tc{constructor(U,C,O,V){super(),this.w=V,this.f=this.B(new L.$5d),this.g=new Map,this.s=this.B(new L.$5d),this.onResultsChanged=this.f.event,this.results=[],this.h=U.getProxy(v.$ZL.MainThreadTesting),this.m=new b(this.h),this.j=new E(this.h,C),O.registerArgumentProcessor({processArgument:re=>{switch(re?.$mid){case 16:{const ue=re,ye=ue.tests[ue.tests.length-1].item.extId;return this.g.get(n.$QK.root(ye))?.collection.tree.get(ye)?.actual??(0,s.$qO)(re)}case 18:{const{extId:ue,message:ye}=re;return{test:this.g.get(n.$QK.root(ue))?.collection.tree.get(ue)?.actual,message:c.TestMessage.to(ye)}}default:return re}}}),O.registerCommand(!1,"testing.getExplorerSelection",async()=>{const re=await O.executeCommand("_testing.getExplorerSelection"),ue=ye=>{const De=this.g.get(n.$QK.root(ye));if(De)return n.$QK.isRoot(ye)?De.controller:De.collection.tree.get(ye)?.actual};return{include:re?.include.map(ue).filter(M.$1f)||[],exclude:re?.exclude.map(ue).filter(M.$1f)||[]}})}createTestController(U,C,O,V){if(this.g.has(C))throw new Error(`Attempt to insert a duplicate controller with ID "${C}"`);const re=new f.$Sc,ue=re.add(new s.$tO(C,O,this.w));ue.root.label=O;const ye=new Map,De=new Set,he=this.h,ve={items:ue.root.children,get label(){return O},set label($e){O=$e,ue.root.label=$e,he.$updateController(C,{label:O})},get refreshHandler(){return V},set refreshHandler($e){V=$e,he.$updateController(C,{canRefresh:!!$e})},get id(){return C},createRunProfile:($e,ee,Q,q,ne,Se)=>{let Te=(0,g.$5i)($e);for(;ye.has(Te);)Te++;return new T(this.h,ye,De,this.s.event,C,Te,$e,ee,Q,q,ne,Se)},createTestItem($e,ee,Q){return new s.$rO(C,$e,ee,Q)},createTestRun:($e,ee,Q=!0)=>this.j.createTestRun(U,C,ue,$e,ee,Q),invalidateTestResults:$e=>{if($e===void 0)this.h.$markTestRetired(void 0);else{const ee=$e instanceof Array?$e:[$e];this.h.$markTestRetired(ee.map(Q=>n.$QK.fromExtHostTestItem(Q,C).toString()))}},set resolveHandler($e){ue.resolveHandler=$e},get resolveHandler(){return ue.resolveHandler},dispose:()=>{re.dispose()}};he.$registerTestController(C,O,!!V),re.add((0,f.$Rc)(()=>he.$unregisterTestController(C)));const se={controller:ve,collection:ue,profiles:ye,extension:U,activeProfiles:De};return this.g.set(C,se),re.add((0,f.$Rc)(()=>this.g.delete(C))),re.add(ue.onDidGenerateDiff($e=>he.$publishDiff(C,$e.map(a.TestsDiffOp.serialize)))),ve}createTestObserver(){return this.m.checkout()}async runTests(U,C=P.CancellationToken.None){const O=w(U);if(!O)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const V=this.g.get(O.controllerId);if(!V)throw new Error("Controller not found");await this.h.$runTests({isUiTriggered:!1,targets:[{testIds:U.include?.map(re=>n.$QK.fromExtHostTestItem(re,V.collection.root.id).toString())??[V.collection.root.id],profileGroup:G[O.kind],profileId:O.profileId,controllerId:O.controllerId}],exclude:U.exclude?.map(re=>re.id)},C)}$syncTests(){for(const{collection:U}of this.g.values())U.flushDiff();return Promise.resolve()}async $provideFileCoverage(U,C,O){return await this.j.getCoverageReport(U,C)?.provideFileCoverage(O)??[]}async $resolveFileCoverage(U,C,O,V){return await this.j.getCoverageReport(U,C)?.resolveFileCoverage(O,V)??[]}$configureRunProfile(U,C){this.g.get(U)?.profiles.get(C)?.configureHandler?.()}$setDefaultRunProfiles(U){const C=new Map;for(const[O,V]of Object.entries(U)){const re=this.g.get(O);if(!re)continue;const ue=new Map,ye=V.filter(he=>!re.activeProfiles.has(he)),De=[...re.activeProfiles].filter(he=>!V.includes(he));for(const he of ye)ue.set(he,!0),re.activeProfiles.add(he);for(const he of De)ue.set(he,!1),re.activeProfiles.delete(he);ue.size&&C.set(O,ue)}this.s.fire(C)}async $refreshTests(U,C){await this.g.get(U)?.controller.refreshHandler?.(C)}$publishTestResults(U){this.results=Object.freeze(U.map(C=>(0,D.$In)(c.TestResults.to(C))).concat(this.results).sort((C,O)=>O.completedAt-C.completedAt).slice(0,32)),this.f.fire()}async $expandTest(U,C){const O=this.g.get(n.$QK.fromString(U).controllerId)?.collection;O&&(await O.expand(U,C<0?1/0:C),O.flushDiff())}$acceptDiff(U){this.m.applyDiff(U.map(C=>a.TestsDiffOp.deserialize({asCanonicalUri:O=>O},C)))}async $runControllerTests(U,C){return Promise.all(U.map(O=>this.y(O,!1,C)))}async $startContinuousRun(U,C){const O=new P.$ce(C),V=await Promise.all(U.map(re=>this.y(re,!0,O.token)));return!C.isCancellationRequested&&!V.some(re=>re.error)&&await new Promise(re=>C.onCancellationRequested(re)),O.dispose(!0),V}async y(U,C,O){const V=this.g.get(U.controllerId);if(!V)return{};const{collection:re,profiles:ue,extension:ye}=V,De=ue.get(U.profileId);if(!De)return{};const he=U.testIds.map(ee=>re.tree.get(ee)).filter(M.$1f),ve=U.excludeExtIds.map(ee=>V.collection.tree.get(ee)).filter(M.$1f).filter(ee=>he.some(Q=>Q.fullId.compare(ee.fullId)===2));if(!he.length)return{};const se=new t.$AN(he.some(ee=>ee.actual instanceof s.$sO)?void 0:he.map(ee=>ee.actual),ve.map(ee=>ee.actual),De,C),$e=(0,a.$SK)(U)&&this.j.prepareForMainThreadTestRun(se,m.fromInternal(U,V.collection),ye,O);try{return await De.runHandler(se,O),{}}catch(ee){return{error:String(ee)}}finally{$e&&($e.hasRunningTasks&&!O.isCancellationRequested&&await L.Event.toPromise($e.onEnd),$e.dispose())}}$cancelExtensionTestRun(U){U===void 0?this.j.cancelAllRuns():this.j.cancelRunById(U)}};e.$xjc=i,e.$xjc=i=Ze([qe(0,$.$eO),qe(1,l.$yj)],i);const p=1e4;var u;(function(W){W[W.Running=0]="Running",W[W.Cancelling=1]="Cancelling",W[W.Ended=2]="Ended"})(u||(u={}));class o extends f.$Tc{get hasRunningTasks(){return this.f.size>0}get id(){return this.s.id}constructor(U,C,O,V,re){super(),this.s=U,this.w=C,this.y=O,this.z=V,this.c=0,this.f=new Map,this.g=new Set,this.j=this.B(new L.$5d),this.m=this.B(new L.$5d),this.onDidCoverage=this.m.event,this.onEnd=this.j.event,this.h=this.B(new P.$ce(re));const ue=this.B(new S.$qh(()=>this.C(),p));this.B(this.h.token.onCancellationRequested(()=>ue.schedule()))}cancel(){this.c===0?(this.h.cancel(),this.c=1):this.c===1&&this.C()}createRun(U){const C=this.s.id,O=this.s.controllerId,V=(0,k.$Ag)(),re=this.y,ue=this.m;let ye;const De=$e=>(ee,...Q)=>{if(ve){this.z.warn(`Setting the state of test "${ee.id}" is a no-op after the run ends.`);return}this.s.isIncluded(ee)&&(this.F(ee),$e(ee,...Q))},he=($e,ee)=>{const Q=ee instanceof Array?ee.map(c.TestMessage.from):[c.TestMessage.from(ee)];if($e.uri&&$e.range){const q={range:c.Range.from($e.range),uri:$e.uri};for(const ne of Q)ne.location=ne.location||q}this.w.$appendTestMessagesInRun(C,V,n.$QK.fromExtHostTestItem($e,O).toString(),Q)};let ve=!1;const se={isPersisted:this.s.isPersisted,token:this.h.token,name:U,get coverageProvider(){return ye?.provider},set coverageProvider($e){(0,h.$VF)(re,"testCoverage"),ye=$e&&new I($e),ue.fire({taskId:V,runId:C,coverage:ye})},enqueued:De($e=>{this.w.$updateTestStateInRun(C,V,n.$QK.fromExtHostTestItem($e,O).toString(),1)}),skipped:De($e=>{this.w.$updateTestStateInRun(C,V,n.$QK.fromExtHostTestItem($e,O).toString(),5)}),started:De($e=>{this.w.$updateTestStateInRun(C,V,n.$QK.fromExtHostTestItem($e,O).toString(),2)}),errored:De(($e,ee,Q)=>{he($e,ee),this.w.$updateTestStateInRun(C,V,n.$QK.fromExtHostTestItem($e,O).toString(),6,Q)}),failed:De(($e,ee,Q)=>{he($e,ee),this.w.$updateTestStateInRun(C,V,n.$QK.fromExtHostTestItem($e,O).toString(),4,Q)}),passed:De(($e,ee)=>{this.w.$updateTestStateInRun(C,V,n.$QK.fromExtHostTestItem($e,this.s.controllerId).toString(),3,ee)}),appendOutput:($e,ee,Q)=>{ve||(Q&&(this.s.isIncluded(Q)?this.F(Q):Q=void 0),this.w.$appendOutputToRun(C,V,F.$se.fromString($e),ee&&c.location.from(ee),Q&&n.$QK.fromExtHostTestItem(Q,O).toString()))},end:()=>{ve||(ve=!0,this.w.$finishedTestRunTask(C,V),this.f.delete(V),this.f.size||this.D())}};return this.f.set(V,{run:se}),this.w.$startedTestRunTask(C,{id:V,name:U,running:!0}),se}C(){for(const{run:U}of this.f.values())U.end()}D(){this.c!==2&&(this.c=2,this.j.fire())}F(U){if(!(U instanceof s.$rO))throw new r.$9N(U.id);if(this.g.has(n.$QK.fromExtHostTestItem(U,this.s.controllerId).toString()))return;const C=[],O=this.s.colllection.root;for(;;){const V=c.TestItem.from(U);if(C.unshift(V),this.g.has(V.extId)||(this.g.add(V.extId),U===O))break;U=U.parent||O}this.w.$addTestsToRun(this.s.controllerId,this.s.id,C)}dispose(){this.D(),super.dispose()}}class E{get trackers(){return this.c.values()}constructor(U,C){this.g=U,this.h=C,this.c=new Map,this.f=[]}getCoverageReport(U,C){return this.f.find(O=>O.runId===U)?.coverage.get(C)}prepareForMainThreadTestRun(U,C,O,V){return this.j(U,C,O,V)}cancelRunById(U){for(const C of this.c.values())if(C.id===U){C.cancel();return}}cancelAllRuns(){for(const U of this.c.values())U.cancel()}createTestRun(U,C,O,V,re,ue){const ye=this.c.get(V);if(ye)return ye.createRun(re);const De=m.fromPublic(C,O,V,ue),he=w(V);this.g.$startedExtensionTestRun({controllerId:C,continuous:!!V.continuous,profile:he&&{group:G[he.kind],id:he.profileId},exclude:V.exclude?.map(se=>n.$QK.fromExtHostTestItem(se,O.root.id).toString())??[],id:De.id,include:V.include?.map(se=>n.$QK.fromExtHostTestItem(se,O.root.id).toString())??[O.root.id],persist:ue});const ve=this.j(V,De,U);return L.Event.once(ve.onEnd)(()=>{this.g.$finishedExtensionTestRun(De.id),ve.dispose()}),ve.createRun(re)}j(U,C,O,V){const re=new o(C,this.g,O,this.h,V);this.c.set(U,re);let ue;const ye=re.onDidCoverage(({runId:De,taskId:he,coverage:ve})=>{ue||(ue={runId:De,coverage:new Map},this.f.unshift(ue),this.f.length>a.$XK&&this.f.pop()),ue.coverage.set(he,ve),this.g.$signalCoverageAvailable(De,he,!!ve)});return L.Event.once(re.onEnd)(()=>{this.c.delete(U),ye.dispose()}),re}}e.$yjc=E;const w=W=>{if(W.profile){if(!(W.profile instanceof T))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return W.profile}};class m{static fromPublic(U,C,O,V){return new m(U,(0,k.$Ag)(),O.include?.map(re=>n.$QK.fromExtHostTestItem(re,U).toString())??[U],O.exclude?.map(re=>n.$QK.fromExtHostTestItem(re,U).toString())??[],V,C)}static fromInternal(U,C){return new m(U.controllerId,U.runId,U.testIds,U.excludeExtIds,!0,C)}constructor(U,C,O,V,re,ue){this.controllerId=U,this.id=C,this.isPersisted=re,this.colllection=ue,this.c=O.map(ye=>ye+"\0"),this.f=V.map(ye=>ye+"\0")}isIncluded(U){const C=n.$QK.fromExtHostTestItem(U,this.controllerId).toString()+"\0";for(const O of this.f)if(C===O||C.startsWith(O))return!1;for(const O of this.c)if(C===O||C.startsWith(O))return!0;return!1}}e.$zjc=m;class I{constructor(U){this.provider=U}async provideFileCoverage(U){this.c||(this.c=(async()=>this.provider.provideFileCoverage(U))());try{return(await this.c)?.map(c.TestCoverage.fromFile)??[]}catch(C){throw this.c=void 0,C}}async resolveFileCoverage(U,C){const O=await this.c;let V=O?.[U];return!this.provider||!O||!V?[]:(V.detailedCoverage||(V=O[U]=await this.provider.resolveFileCoverage?.(V,C)??V),V.detailedCoverage?.map(c.TestCoverage.fromDetailed)??[])}}class d{get isEmpty(){return this.c.size===0&&this.g.size===0&&this.f.size===0}constructor(U){this.j=U,this.c=new Set,this.f=new Set,this.g=new Set,this.h=new Set}add(U){this.c.add(U)}update(U){Object.assign(U.revived,c.TestItem.toPlain(U.item)),this.c.has(U)||this.f.add(U)}remove(U){if(this.c.has(U)){this.c.delete(U);return}this.f.delete(U);const C=n.$QK.parentId(U.item.extId);if(C&&this.h.has(C.toString())){this.h.add(U.item.extId);return}this.g.add(U)}getChangeEvent(){const{c:U,f:C,g:O}=this;return{get added(){return[...U].map(V=>V.revived)},get updated(){return[...C].map(V=>V.revived)},get removed(){return[...O].map(V=>V.revived)}}}complete(){this.isEmpty||this.j.fire(this.getChangeEvent())}}class y extends a.$YK{constructor(){super(...arguments),this.s=new L.$5d,this.onDidChangeTests=this.s.event}get rootTests(){return this.g}getMirroredTestDataById(U){return this.f.get(U)}getMirroredTestDataByReference(U){return this.f.get(U.id)}w(U,C){return{...U,revived:c.TestItem.toPlain(U.item),depth:C?C.depth+1:0,children:new Set}}v(){return new d(this.s)}}class b{constructor(U){this.f=U}checkout(){this.c||(this.c=this.g());const U=this.c;return U.observers++,{onDidChangeTest:U.tests.onDidChangeTests,get tests(){return[...U.tests.rootTests].map(C=>C.revived)},dispose:(0,R.$db)(()=>{--U.observers===0&&(this.f.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(U){return this.c?.tests.getMirroredTestDataByReference(U)}applyDiff(U){this.c?.tests.apply(U)}g(){const U=new y({asCanonicalUri:C=>C});return this.f.$subscribeToDiffs(),{observers:0,tests:U}}}const A=(W,U,C,O)=>{C?Object.assign(C,O):U.$updateTestRunConfig(W.controllerId,W.profileId,O)};class T{#e;#t;#i;#n;#s;get label(){return this.f}set label(U){U!==this.f&&(this.f=U,A(this,this.#e,this.#n,{label:U}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(U){U!==this.g&&(this.g=U,A(this,this.#e,this.#n,{supportsContinuousRun:U}))}get isDefault(){return this.#t.has(this.profileId)}set isDefault(U){U!==this.isDefault&&(U?this.#t.add(this.profileId):this.#t.delete(this.profileId),A(this,this.#e,this.#n,{isDefault:U}))}get tag(){return this._tag}set tag(U){U?.id!==this._tag?.id&&(this._tag=U,A(this,this.#e,this.#n,{tag:U?c.TestTag.namespace(this.controllerId,U.id):null}))}get configureHandler(){return this.c}set configureHandler(U){U!==this.c&&(this.c=U,A(this,this.#e,this.#n,{hasConfigurationHandler:!!U}))}get onDidChangeDefault(){return L.Event.chain(this.#i,U=>U.map(C=>C.get(this.controllerId)?.get(this.profileId)).filter(M.$1f))}constructor(U,C,O,V,re,ue,ye,De,he,ve=!1,se=void 0,$e=!1){this.controllerId=re,this.profileId=ue,this.f=ye,this.kind=De,this.runHandler=he,this._tag=se,this.g=$e,this.#e=U,this.#s=C,this.#t=O,this.#i=V,C.set(ue,this);const ee=G[De];if(typeof ee!="number")throw new Error(`Unknown TestRunProfile.group ${De}`);ve&&O.add(ue),this.#n={profileId:ue,controllerId:re,tag:se?c.TestTag.namespace(this.controllerId,se.id):null,label:ye,group:ee,isDefault:ve,hasConfigurationHandler:!1,supportsContinuousRun:$e},queueMicrotask(()=>{this.#n&&(this.#e.$publishTestRunProfile(this.#n),this.#n=void 0)})}dispose(){this.#s?.delete(this.profileId)&&(this.#s=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId)),this.#n=void 0}}e.$Ajc=T;const G={[t.TestRunProfileKind.Coverage]:8,[t.TestRunProfileKind.Debug]:4,[t.TestRunProfileKind.Run]:2}}),define(Re[112],Ae([1,0,55,15,88,8,7]),function(fe,e,S,F,P,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nO=e.$mO=e.$lO=void 0;class g{static{this.c=new P.$jO("TextEditorDecorationType")}constructor(l,v,$){const s=g.c.nextId();l.$registerTextEditorDecorationType(v.identifier,s,L.DecorationRenderOptions.from($)),this.value=Object.freeze({key:s,dispose(){l.$removeTextEditorDecorationType(s)}})}}e.$lO=g;class f{constructor(l,v){this.g=[],this.h=void 0,this.j=!1,this.c=l,this.d=l.version,this.e=v.undoStopBefore,this.f=v.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(l,v){this.k();let $=null;if(l instanceof R.$3L)$=new R.$4L(l,l);else if(l instanceof R.$4L)$=l;else throw new Error("Unrecognized location");this.l($,v,!1)}insert(l,v){this.k(),this.l(new R.$4L(l,l),v,!0)}delete(l){this.k();let v=null;if(l instanceof R.$4L)v=l;else throw new Error("Unrecognized location");this.l(v,null,!0)}l(l,v,$){const s=this.c.validateRange(l);this.g.push({range:s,text:v,forceMoveMarkers:$})}setEndOfLine(l){if(this.k(),l!==R.EndOfLine.LF&&l!==R.EndOfLine.CRLF)throw(0,F.$7)("endOfLine");this.h=l}}class D{constructor(l,v,$,s){this.c=l,this.d=v,this._accept($),this.e=s;const c=this;this.value={get tabSize(){return c.f},set tabSize(t){c.n(t)},get indentSize(){return c.g},set indentSize(t){c.p(t)},get insertSpaces(){return c.j},set insertSpaces(t){c.s(t)},get cursorStyle(){return c.k},set cursorStyle(t){c.t(t)},get lineNumbers(){return c.l},set lineNumbers(t){c.u(t)}}}_accept(l){this.f=l.tabSize,this.g=l.indentSize,this.h=l.originalIndentSize,this.j=l.insertSpaces,this.k=l.cursorStyle,this.l=L.TextEditorLineNumbersStyle.to(l.lineNumbers)}m(l){if(l==="auto")return"auto";if(typeof l=="number"){const v=Math.floor(l);return v>0?v:null}if(typeof l=="string"){const v=parseInt(l,10);return isNaN(v)?null:v>0?v:null}return null}n(l){const v=this.m(l);if(v!==null){if(typeof v=="number"){if(this.f===v)return;this.f=v}this.v("setTabSize",this.c.$trySetOptions(this.d,{tabSize:v}))}}o(l){if(l==="tabSize")return"tabSize";if(typeof l=="number"){const v=Math.floor(l);return v>0?v:null}if(typeof l=="string"){const v=parseInt(l,10);return isNaN(v)?null:v>0?v:null}return null}p(l){const v=this.o(l);if(v!==null){if(typeof v=="number"){if(this.h===v)return;this.g=v,this.h=v}this.v("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:v}))}}q(l){return l==="auto"?"auto":l==="false"?!1:!!l}s(l){const v=this.q(l);if(typeof v=="boolean"){if(this.j===v)return;this.j=v}this.v("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:v}))}t(l){this.k!==l&&(this.k=l,this.v("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:l})))}u(l){this.l!==l&&(this.l=l,this.v("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:L.TextEditorLineNumbersStyle.from(l)})))}assign(l){const v={};let $=!1;if(typeof l.tabSize<"u"){const s=this.m(l.tabSize);s==="auto"?($=!0,v.tabSize=s):typeof s=="number"&&this.f!==s&&(this.f=s,$=!0,v.tabSize=s)}if(typeof l.indentSize<"u"){const s=this.o(l.indentSize);s==="tabSize"?($=!0,v.indentSize=s):typeof s=="number"&&this.h!==s&&(this.g=s,this.h=s,$=!0,v.indentSize=s)}if(typeof l.insertSpaces<"u"){const s=this.q(l.insertSpaces);s==="auto"?($=!0,v.insertSpaces=s):this.j!==s&&(this.j=s,$=!0,v.insertSpaces=s)}typeof l.cursorStyle<"u"&&this.k!==l.cursorStyle&&(this.k=l.cursorStyle,$=!0,v.cursorStyle=l.cursorStyle),typeof l.lineNumbers<"u"&&this.l!==l.lineNumbers&&(this.l=l.lineNumbers,$=!0,v.lineNumbers=L.TextEditorLineNumbersStyle.from(l.lineNumbers)),$&&this.v("setOptions",this.c.$trySetOptions(this.d,v))}v(l,v){v.catch($=>{this.e.warn(`ExtHostTextEditorOptions '${l}' failed:'`),this.e.warn($)})}}e.$mO=D;class M{constructor(l,v,$,s,c,t,n,r){this.id=l,this.j=v,this.k=$,this.g=!1,this.h=new Set,this.c=c,this.d=new D(this.j,this.id,t,$),this.e=n,this.f=r;const a=this;this.value=Object.freeze({get document(){return s.value},set document(h){throw new F.$9("document")},get selection(){return a.c&&a.c[0]},set selection(h){if(!(h instanceof R.$5L))throw(0,F.$7)("selection");a.c=[h],a.l()},get selections(){return a.c},set selections(h){if(!Array.isArray(h)||h.some(i=>!(i instanceof R.$5L)))throw(0,F.$7)("selections");a.c=h,a.l()},get visibleRanges(){return a.e},set visibleRanges(h){throw new F.$9("visibleRanges")},get options(){return a.d.value},set options(h){a.g||a.d.assign(h)},get viewColumn(){return a.f},set viewColumn(h){throw new F.$9("viewColumn")},edit(h,i={undoStopBefore:!0,undoStopAfter:!0}){if(a.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const p=new f(s.value,i);return h(p),a.m(p)},insertSnippet(h,i,p={undoStopBefore:!0,undoStopAfter:!0}){if(a.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let u;if(!i||Array.isArray(i)&&i.length===0)u=a.c.map(o=>L.Range.from(o));else if(i instanceof R.$3L){const{lineNumber:o,column:E}=L.Position.from(i);u=[{startLineNumber:o,startColumn:E,endLineNumber:o,endColumn:E}]}else if(i instanceof R.$4L)u=[L.Range.from(i)];else{u=[];for(const o of i)if(o instanceof R.$4L)u.push(L.Range.from(o));else{const{lineNumber:E,column:w}=L.Position.from(o);u.push({startLineNumber:E,startColumn:w,endLineNumber:E,endColumn:w})}}return v.$tryInsertSnippet(l,s.value.version,h.value,u,p)},setDecorations(h,i){const p=i.length===0;p&&!a.h.has(h.key)||(p?a.h.delete(h.key):a.h.add(h.key),a.n(()=>{if(L.$bO(i))return v.$trySetDecorations(l,h.key,L.$cO(i));{const u=new Array(4*i.length);for(let o=0,E=i.length;o<E;o++){const w=i[o];u[4*o]=w.start.line+1,u[4*o+1]=w.start.character+1,u[4*o+2]=w.end.line+1,u[4*o+3]=w.end.character+1}return v.$trySetDecorationsFast(l,h.key,u)}}))},revealRange(h,i){a.n(()=>v.$tryRevealRange(l,L.Range.from(h),i||R.TextEditorRevealType.Default))},show(h){v.$tryShowEditor(l,L.ViewColumn.from(h))},hide(){v.$tryHideEditor(l)}})}dispose(){(0,S.ok)(!this.g),this.g=!0}_acceptOptions(l){(0,S.ok)(!this.g),this.d._accept(l)}_acceptVisibleRanges(l){(0,S.ok)(!this.g),this.e=l}_acceptViewColumn(l){(0,S.ok)(!this.g),this.f=l}_acceptSelections(l){(0,S.ok)(!this.g),this.c=l}async l(){const l=this.c.map(L.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,l)),this.value}m(l){const v=l.finalize();if(v.edits.length===0&&!v.setEndOfLine)return Promise.resolve(!0);const $=v.edits.map(c=>c.range);$.sort((c,t)=>c.end.line===t.end.line?c.end.character===t.end.character?c.start.line===t.start.line?c.start.character-t.start.character:c.start.line-t.start.line:c.end.character-t.end.character:c.end.line-t.end.line);for(let c=0,t=$.length-1;c<t;c++){const n=$[c].end;if($[c+1].start.isBefore(n))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const s=v.edits.map(c=>({range:L.Range.from(c.range),text:c.text,forceMoveMarkers:c.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,v.documentVersionId,s,{setEndOfLine:typeof v.setEndOfLine=="number"?L.EndOfLine.from(v.setEndOfLine):void 0,undoStopBefore:v.undoStopBefore,undoStopAfter:v.undoStopAfter})}n(l){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):l().then(()=>this,v=>(v instanceof Error&&v.name==="DISPOSED"||this.k.warn(v),null))}}e.$nO=M}),define(Re[67],Ae([1,0,55,5,6,2,4,3,109,17,112,8,14,28,12,51,40]),function(fe,e,S,F,P,L,R,g,f,D,M,k,l,v,$,s,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pO=e.$oO=void 0;class t{constructor(a){this.value=a,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let n=class{constructor(a,h){this.h=a,this.i=h,this.a=null,this.b=new Map,this.c=new v.$Ac,this.d=new F.$5d,this.e=new F.$5d,this.f=new F.$5d,this.g=new F.$5d,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(a){this.acceptDocumentsAndEditorsDelta(a)}acceptDocumentsAndEditorsDelta(a){const h=[],i=[],p=[];if(a.removedDocuments)for(const u of a.removedDocuments){const o=L.URI.revive(u),E=this.c.get(o);E?.unref()&&(this.c.delete(o),h.push(E.value))}if(a.addedDocuments)for(const u of a.addedDocuments){const o=L.URI.revive(u.uri);let E=this.c.get(o);if(E&&o.scheme!==$.Schemas.vscodeNotebookCell&&o.scheme!==$.Schemas.vscodeInteractiveInput)throw new Error(`document '${o} already exists!'`);E||(E=new t(new f.$hO(this.h.getProxy(g.$ZL.MainThreadDocuments),o,u.lines,u.EOL,u.versionId,u.languageId,u.isDirty)),this.c.set(o,E),i.push(E.value)),E.ref()}if(a.removedEditors)for(const u of a.removedEditors){const o=this.b.get(u);this.b.delete(u),o&&p.push(o)}if(a.addedEditors)for(const u of a.addedEditors){const o=L.URI.revive(u.documentUri);S.ok(this.c.has(o),`document '${o}' does not exist`),S.ok(!this.b.has(u.id),`editor '${u.id}' already exists!`);const E=this.c.get(o).value,w=new M.$nO(u.id,this.h.getProxy(g.$ZL.MainThreadTextEditors),this.i,new c.$V(()=>E.document),u.selections.map(k.Selection.to),u.options,u.visibleRanges.map(m=>k.Range.to(m)),typeof u.editorPosition=="number"?k.ViewColumn.to(u.editorPosition):void 0);this.b.set(u.id,w)}a.newActiveEditor!==void 0&&(S.ok(a.newActiveEditor===null||this.b.has(a.newActiveEditor),`active editor '${a.newActiveEditor}' does not exist`),this.a=a.newActiveEditor),(0,P.$Oc)(h),(0,P.$Oc)(p),a.removedDocuments&&this.e.fire(h),a.addedDocuments&&this.d.fire(i),(a.removedEditors||a.addedEditors)&&this.f.fire(this.allEditors().map(u=>u.value)),a.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(a){return this.c.get(a)?.value}allDocuments(){return s.Iterable.map(this.c.values(),a=>a.value)}getEditor(a){return this.b.get(a)}activeEditor(a){if(!this.a)return;const h=this.b.get(this.a);return a?h:h?.value}allEditors(){return[...this.b.values()]}};e.$oO=n,e.$oO=n=Ze([qe(0,D.$eO),qe(1,l.$yj)],n),e.$pO=(0,R.$ei)("IExtHostDocumentsAndEditors")}),define(Re[276],Ae([1,0,18,5,3,112,8,7]),function(fe,e,S,F,P,L,R,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Whc=void 0;class f{constructor(M,k){this.i=k,this.a=new F.$5d,this.b=new F.$5d,this.c=new F.$5d,this.d=new F.$5d,this.f=new F.$5d,this.g=new F.$5d,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=M.getProxy(P.$ZL.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(l=>this.g.fire(l)),this.i.onDidChangeActiveTextEditor(l=>this.f.fire(l))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(M){const k=this.i.allEditors();return M?k:k.map(l=>l.value)}async showTextDocument(M,k,l){let v;typeof k=="number"?v={position:R.ViewColumn.from(k),preserveFocus:l}:typeof k=="object"?v={position:R.ViewColumn.from(k.viewColumn),preserveFocus:k.preserveFocus,selection:typeof k.selection=="object"?R.Range.from(k.selection):void 0,pinned:typeof k.preview=="boolean"?!k.preview:void 0}:v={preserveFocus:!1};const $=await this.h.$tryShowTextDocument(M.uri,v),s=$&&this.i.getEditor($);if(s)return s.value;throw $?new Error(`Could NOT open editor for "${M.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${M.uri.toString()}".`)}createTextEditorDecorationType(M,k){return new L.$lO(this.h,M,k).value}$acceptEditorPropertiesChanged(M,k){const l=this.i.getEditor(M);if(!l)throw new Error("unknown text editor");if(k.options&&l._acceptOptions(k.options),k.selections){const v=k.selections.selections.map(R.Selection.to);l._acceptSelections(v)}if(k.visibleRanges){const v=S.$Hb(k.visibleRanges.map(R.Range.to));l._acceptVisibleRanges(v)}if(k.options&&this.b.fire({textEditor:l.value,options:{...k.options,lineNumbers:R.TextEditorLineNumbersStyle.to(k.options.lineNumbers)}}),k.selections){const v=g.TextEditorSelectionChangeKind.fromValue(k.selections.source),$=k.selections.selections.map(R.Selection.to);this.a.fire({textEditor:l.value,selections:$,kind:v})}if(k.visibleRanges){const v=S.$Hb(k.visibleRanges.map(R.Range.to));this.c.fire({textEditor:l.value,visibleRanges:v})}}$acceptEditorPositionData(M){for(const k in M){const l=this.i.getEditor(k);if(!l)throw new Error("Unknown text editor");const v=R.ViewColumn.to(M[k]);l.value.viewColumn!==v&&(l._acceptViewColumn(v),this.d.fire({textEditor:l.value,viewColumn:v}))}}getDiffInformation(M){return Promise.resolve(this.h.$getDiffInformation(M))}}e.$Whc=f}),define(Re[277],Ae([1,0,2,4,3,6,7,8,20,16]),function(fe,e,S,F,P,L,R,g,f,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Djc=e.$Cjc=void 0,e.$Cjc=(0,F.$ei)("IExtHostTimeline");class M{constructor(v,$){this.b=new Map,this.c=new Map,this.a=v.getProxy(P.$ZL.MainThreadTimeline),$.registerArgumentProcessor({processArgument:(s,c)=>{if(s&&s.$mid===12)if(this.b.get(s.source)&&f.$wm.equals(c,this.b.get(s.source)?.extension)){const t=s.uri===void 0?void 0:S.URI.revive(s.uri);return this.c.get(s.source)?.get(k(t))?.get(s.handle)}else return;return s}})}async $getTimeline(v,$,s,c){return this.b.get(v)?.provider.provideTimeline(S.URI.revive($),s,c)}registerTimelineProvider(v,$,s,c){const t=new L.$Sc,n=this.d($.id,c,t).bind(this);let r;$.onDidChange&&(r=$.onDidChange(h=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...h,id:$.id}),this));const a=this.c;return this.f({...$,scheme:v,onDidChange:void 0,async provideTimeline(h,i,p){i?.resetCache&&(t.clear(),a.get($.id)?.clear());const u=await $.provideTimeline(h,i,p);if(u==null)return;const o=n(h,i);return{...u,source:$.id,items:u.items.map(o)}},dispose(){for(const h of a.values())h.get($.id)?.clear();r?.dispose(),t.dispose()}},s)}d(v,$,s){return(c,t)=>{let n;if(t?.cacheResults){let r=this.c.get(v);r===void 0&&(r=new Map,this.c.set(v,r));const a=k(c);n=r.get(a),n===void 0&&(n=new Map,r.set(a,n))}return r=>{const{iconPath:a,...h}=r,i=`${v}|${r.id??r.timestamp}`;n?.set(i,r);let p,u,o;r.iconPath&&(a instanceof R.$WM?o={id:a.id,color:a.color}:S.URI.isUri(a)?(p=a,u=a):{light:p,dark:u}=a);let E;return R.$qM.isMarkdownString(h.tooltip)?E=g.MarkdownString.from(h.tooltip):(0,D.$Sf)(h.tooltip)?E=h.tooltip:R.$qM.isMarkdownString(h.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),E=g.MarkdownString.from(h.detail)):(0,D.$Sf)(h.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),E=h.detail),{...h,id:h.id??void 0,handle:i,source:v,command:r.command?$.toInternal(r.command,s):void 0,icon:p,iconDark:u,themeIcon:o,tooltip:E,accessibilityInformation:r.accessibilityInformation}}}}f(v,$){if(this.b.get(v.id))throw new Error(`Timeline Provider ${v.id} already exists.`);return this.a.$registerTimelineProvider({id:v.id,label:v.label,scheme:v.scheme}),this.b.set(v.id,{provider:v,extension:$}),(0,L.$Rc)(()=>{for(const c of this.c.values())c.get(v.id)?.clear();this.b.delete(v.id),this.a.$unregisterTimelineProvider(v.id),v.dispose()})}}e.$Djc=M;function k(l){return l?.toString()}}),define(Re[278],Ae([1,0,168,25,2,5,6,206,11,7,16,18,8,53,22,133,23]),function(fe,e,S,F,P,L,R,g,f,D,M,k,l,v,$,s,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ejc=void 0;function t(a,h){if((0,M.$Sf)(a))return{label:a};if(a&&typeof a=="object"&&typeof a.label=="string"){let i;return Array.isArray(a.highlights)&&(i=a.highlights.filter(p=>p.length===2&&typeof p[0]=="number"&&typeof p[1]=="number"),i=i.length?i:void 0),{label:a.label,highlights:i}}}class n extends R.$Tc{constructor(h,i,p){super(),this.f=h,this.g=i,this.h=p,this.a=new Map,this.b=new s.$C9;function u(o){return o&&o.$treeViewId&&(o.$treeItemHandle||o.$selectedTreeItems||o.$focusedTreeItem)}i.registerArgumentProcessor({processArgument:o=>u(o)?this.r(o):Array.isArray(o)&&o.length>0?o.map(E=>u(E)?this.r(E):E):o})}registerTreeDataProvider(h,i,p){const u=this.createTreeView(h,{treeDataProvider:i},p);return{dispose:()=>u.dispose()}}createTreeView(h,i,p){if(!i||!i.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const u=i.dragAndDropController?.dropMimeTypes??[],o=i.dragAndDropController?.dragMimeTypes??[],E=!!i.dragAndDropController?.handleDrag,w=!!i.dragAndDropController?.handleDrop,m=this.m(h,i,p),I={showCollapseAll:!!i.showCollapseAll,canSelectMany:!!i.canSelectMany,dropMimeTypes:u,dragMimeTypes:o,hasHandleDrag:E,hasHandleDrop:w,manuallyManageCheckboxes:!!i.manageCheckboxStateManually},d=this.f.$registerTreeViewDataProvider(h,I),y={get onDidCollapseElement(){return m.onDidCollapseElement},get onDidExpandElement(){return m.onDidExpandElement},get selection(){return m.selectedElements},get onDidChangeSelection(){return m.onDidChangeSelection},get activeItem(){return(0,c.$VF)(p,"treeViewActiveItem"),m.focusedElement},get onDidChangeActiveItem(){return(0,c.$VF)(p,"treeViewActiveItem"),m.onDidChangeActiveItem},get visible(){return m.visible},get onDidChangeVisibility(){return m.onDidChangeVisibility},get onDidChangeCheckboxState(){return m.onDidChangeCheckboxState},get message(){return m.message},set message(b){(0,v.$uk)(b)&&(0,c.$VF)(p,"treeViewMarkdownMessage"),m.message=b},get title(){return m.title},set title(b){m.title=b},get description(){return m.description},set description(b){m.description=b},get badge(){return m.badge},set badge(b){b!==void 0&&D.ViewBadge.isViewBadge(b)?m.badge={value:Math.floor(Math.abs(b.value)),tooltip:b.tooltip}:b===void 0&&(m.badge=void 0)},reveal:(b,A)=>m.reveal(b,A),dispose:async()=>{await d,this.a.delete(h),m.dispose()}};return this.B(y),y}$getChildren(h,i){const p=this.a.get(h);return p?p.getChildren(i):Promise.reject(new g.$oF(h))}async $handleDrop(h,i,p,u,o,E,w,m){const I=this.a.get(h);if(!I)return Promise.reject(new g.$oF(h));const d=l.DataTransfer.toDataTransfer(p,async y=>(await this.f.$resolveDropFileData(h,i,y)).buffer);return w===h&&m&&await this.j(d,I,m,o,E),I.onDrop(d,u,o)}async j(h,i,p,u,o){const E=this.b.removeDragOperationTransfer(o);if(E)(await E)?.forEach((w,m)=>{w&&h.set(m,w)});else if(o&&i.handleDrag){const w=i.handleDrag(p,h,u);this.b.addDragOperationTransfer(o,w),await w}return h}async $handleDrag(h,i,p,u){const o=this.a.get(h);if(!o)return Promise.reject(new g.$oF(h));const E=await this.j(new D.$TM,o,i,u,p);if(!(!E||u.isCancellationRequested))return l.DataTransfer.from(E)}async $hasResolve(h){const i=this.a.get(h);if(!i)throw new g.$oF(h);return i.hasResolve}$resolve(h,i,p){const u=this.a.get(h);if(!u)throw new g.$oF(h);return u.resolveTreeItem(i,p)}$setExpanded(h,i,p){const u=this.a.get(h);if(!u)throw new g.$oF(h);u.setExpanded(i,p)}$setSelectionAndFocus(h,i,p){const u=this.a.get(h);if(!u)throw new g.$oF(h);u.setSelectionAndFocus(i,p)}$setVisible(h,i){const p=this.a.get(h);if(!p){if(!i)return;throw new g.$oF(h)}p.setVisible(i)}$changeCheckboxState(h,i){const p=this.a.get(h);if(!p)throw new g.$oF(h);p.setCheckboxState(i)}m(h,i,p){const u=this.B(new r(h,i,this.f,this.g.converter,this.h,p));return this.a.set(h,u),u}r(h){const i=this.a.get(h.$treeViewId);return i&&"$treeItemHandle"in h?i.getExtensionElement(h.$treeItemHandle):i&&"$focusedTreeItem"in h&&h.$focusedTreeItem?i.focusedElement:null}}e.$Ejc=n;class r extends R.$Tc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(h=>this.getExtensionElement(h)).filter(h=>!(0,M.$2f)(h))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(h,i,p,u,o,E){if(super(),this.I=h,this.J=p,this.L=u,this.M=o,this.N=E,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new L.$5d),this.onDidExpandElement=this.u.event,this.w=this.B(new L.$5d),this.onDidCollapseElement=this.w.event,this.y=this.B(new L.$5d),this.onDidChangeSelection=this.y.event,this.z=this.B(new L.$5d),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new L.$5d),this.onDidChangeVisibility=this.C.event,this.D=this.B(new L.$5d),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new L.$5d),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new $.$ce,E.contributes&&E.contributes.views)for(const d in E.contributes.views)for(const y of E.contributes.views[d])y.id===h&&(this.P=y.name);this.f=i.treeDataProvider,this.g=i.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(d=>this.F.fire({message:!1,element:d})));let w,m;const I=L.Event.debounce(this.F.event,(d,y)=>(d||(d={message:!1,elements:[]}),y.element!==!1&&(w||(w=new Promise(b=>m=b),this.G=this.G.then(()=>w)),Array.isArray(y.element)?d.elements.push(...y.element):d.elements.push(y.element)),y.message&&(d.message=!0),d),200,!0);this.B(I(({message:d,elements:y})=>{y.length&&(this.H=this.H.then(()=>{const b=m;return w=null,this.$(y).then(()=>b())})),d&&this.J.$setMessage(this.I,l.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(h){const i=h?this.getExtensionElement(h):void 0;if(h&&!i)return this.M.error(`No tree item with id '${h}' found.`),Promise.resolve([]);let p=this.X(h);return p||(p=await this.Y(i)),p?p.map(u=>u.item):void 0}getExtensionElement(h){return this.j.get(h)}reveal(h,i){i=i||{select:!0,focus:!1};const p=(0,M.$2f)(i.select)?!0:i.select,u=(0,M.$2f)(i.focus)?!1:i.focus,o=(0,M.$2f)(i.expand)?!1:i.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):h?this.G.then(()=>this.S(h)).then(E=>this.W(h,E[E.length-1]).then(w=>this.J.$reveal(this.I,{item:w.item,parentChain:E.map(m=>m.item)},{select:p,focus:u,expand:o})),E=>this.M.error(E)):this.J.$reveal(this.I,void 0,{select:p,focus:u,expand:o})}get message(){return this.O}set message(h){this.O=h,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(h){this.P=h,this.J.$setTitle(this.I,h,this.Q)}get description(){return this.Q}set description(h){this.Q=h,this.J.$setTitle(this.I,this.P,h)}get badge(){return this.R}set badge(h){this.R?.value===h?.value&&this.R?.tooltip===h?.tooltip||(this.R=l.ViewBadge.from(h),this.J.$setBadge(this.I,h))}setExpanded(h,i){const p=this.getExtensionElement(h);p&&(i?this.u.fire(Object.freeze({element:p})):this.w.fire(Object.freeze({element:p})))}setSelectionAndFocus(h,i){const p=!(0,k.$ub)(this.s,h);this.s=h;const u=this.t!==i;this.t=i,p&&this.y.fire(Object.freeze({selection:this.selectedElements})),u&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(h){h!==this.r&&(this.r=h,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(h){const i=(await Promise.all(h.map(async p=>{const u=this.getExtensionElement(p.treeItemHandle);return u?{extensionItem:u,treeItem:await this.f.getTreeItem(u),newState:p.newState?D.TreeItemCheckboxState.Checked:D.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(p=>p!==void 0);i.forEach(p=>{p.treeItem.checkboxState=p.newState?D.TreeItemCheckboxState.Checked:D.TreeItemCheckboxState.Unchecked}),this.D.fire({items:i.map(p=>[p.extensionItem,p.newState])})}async handleDrag(h,i,p){const u=[];for(const o of h){const E=this.getExtensionElement(o);E&&u.push(E)}if(!(!this.g?.handleDrag||u.length===0))return await this.g.handleDrag(u,i,p),i}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(h,i,p){const u=i?this.getExtensionElement(i):void 0;if(!(!u&&i||!this.g?.handleDrop))return(0,f.$9g)(()=>this.g?.handleDrop?this.g.handleDrop(u,h,p):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(h,i){if(!this.f.resolveTreeItem)return;const p=this.j.get(h);if(p){const u=this.m.get(p);if(u){const o=await this.f.resolveTreeItem(u.extensionItem,p,i)??u.extensionItem;return this.hb(o),u.item.tooltip=this.eb(o.tooltip),u.item.command=this.fb(u.disposableStore,o.command),u.item}}}S(h){return this.U(h).then(i=>i?this.S(i).then(p=>this.W(i,p[p.length-1]).then(u=>(p.push(u),p))):Promise.resolve([]))}U(h){const i=this.m.get(h);return i?Promise.resolve(i.parent?this.j.get(i.parent.item.handle):void 0):(0,f.$9g)(()=>this.f.getParent(h))}W(h,i){const p=this.m.get(h);return p?Promise.resolve(p):(0,f.$9g)(()=>this.f.getTreeItem(h)).then(u=>this.kb(h,u,i,!0)).then(u=>this.getChildren(i?i.item.handle:void 0).then(()=>{const o=this.getExtensionElement(u);if(o){const E=this.m.get(o);if(E)return Promise.resolve(E)}throw new Error(`Cannot resolve tree item for element ${u} from extension ${this.N.identifier.value}`)}))}X(h){if(h){let i;if(typeof h=="string"){const p=this.getExtensionElement(h);i=p?this.m.get(p):void 0}else i=h;return i&&i.children||void 0}return this.h}async Y(h){this.rb(h);const i=new $.$ce(this.Z.token);try{const p=h?this.m.get(h):void 0,u=await this.f.getChildren(h);if(i.token.isCancellationRequested)return;const o=(0,k.$Hb)(u||[]),E=await Promise.all((0,k.$Hb)(o).map(m=>this.f.getTreeItem(m)));if(i.token.isCancellationRequested)return;const w=E.map((m,I)=>m?this.db(o[I],m,p):null);return(0,k.$Hb)(w)}finally{i.dispose()}}$(h){if(h.some(p=>!p))return this.Z.dispose(!0),this.Z=new $.$ce,this.tb(),this.J.$refresh(this.I);{const p=this.ab(h);if(p.length)return this.bb(p)}return Promise.resolve(void 0)}ab(h){const i=new Set,p=h.map(o=>this.m.get(o));for(const o of p)if(o&&!i.has(o.item.handle)){let E=o;for(;E&&E.parent&&p.findIndex(w=>E&&E.parent&&w&&w.item.handle===E.parent.item.handle)===-1;){const w=this.j.get(E.parent.item.handle);E=w?this.m.get(w):void 0}E&&!E.parent&&i.add(o.item.handle)}const u=[];return i.forEach(o=>{const E=this.j.get(o);if(E){const w=this.m.get(E);w&&(!w.parent||!i.has(w.parent.item.handle))&&u.push(o)}}),u}bb(h){const i={};return Promise.all(h.map(p=>this.cb(p).then(u=>{u&&(i[p]=u.item)}))).then(()=>Object.keys(i).length?this.J.$refresh(this.I,i):void 0)}cb(h){const i=this.getExtensionElement(h);if(i){const p=this.m.get(i);if(p)return this.rb(i),(0,f.$9g)(()=>this.f.getTreeItem(i)).then(u=>{if(u){const o=this.ib(i,u,p.parent);return this.pb(i,o,p,p.parent),p.dispose(),o}return null})}return Promise.resolve(null)}db(h,i,p){const u=this.ib(h,i,p);if(i.id&&this.j.has(u.item.handle))throw new Error((0,S.localize)(0,null,i.id));return this.ob(h,u),this.qb(u,p),u}eb(h){return D.$qM.isMarkdownString(h)?l.MarkdownString.from(h):h}fb(h,i){return i?{...this.L.toInternal(i,h),originalId:i.command}:void 0}gb(h){if(h.checkboxState===void 0)return;let i,p,u;return typeof h.checkboxState=="number"?i=h.checkboxState:(i=h.checkboxState.state,p=h.checkboxState.tooltip,u=h.checkboxState.accessibilityInformation),{isChecked:i===D.TreeItemCheckboxState.Checked,tooltip:p,accessibilityInformation:u}}hb(h){if(!D.$OM.isTreeItem(h,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(h,i,p){this.hb(i);const u=this.B(new R.$Sc),o=this.kb(h,i,p),E=this.lb(i);return{item:{handle:o,parentHandle:p?p.item.handle:void 0,label:t(i.label,this.N),description:i.description,resourceUri:i.resourceUri,tooltip:this.eb(i.tooltip),command:this.fb(u,i.command),contextValue:i.contextValue,icon:E,iconDark:this.mb(i)||E,themeIcon:this.jb(i),collapsibleState:(0,M.$2f)(i.collapsibleState)?D.TreeItemCollapsibleState.None:i.collapsibleState,accessibilityInformation:i.accessibilityInformation,checkbox:this.gb(i)},extensionItem:i,parent:p,children:void 0,disposableStore:u,dispose(){u.dispose()}}}jb(h){return h.iconPath instanceof D.$WM?h.iconPath:void 0}kb(h,{id:i,label:p,resourceUri:u},o,E){if(i)return`${r.b}/${i}`;const w=t(p,this.N),m=o?o.item.handle:r.a;let I=w?w.label:u?(0,F.$Og)(u):"";I=I.indexOf("/")!==-1?I.replace("/","//"):I;const d=this.m.has(h)?this.m.get(h).item.handle:void 0,y=this.X(o)||[];let b,A=0;do{if(b=`${m}/${A}:${I}`,E||!this.j.has(b)||d===b)break;A++}while(A<=y.length);return b}lb(h){if(h.iconPath&&!(h.iconPath instanceof D.$WM))return typeof h.iconPath=="string"||P.URI.isUri(h.iconPath)?this.nb(h.iconPath):this.nb(h.iconPath.light)}mb(h){if(h.iconPath&&!(h.iconPath instanceof D.$WM)&&h.iconPath.dark)return this.nb(h.iconPath.dark)}nb(h){return P.URI.isUri(h)?h:P.URI.file(h)}ob(h,i){this.j.set(i.item.handle,h),this.m.set(h,i)}pb(h,i,p,u){this.j.delete(i.item.handle),this.m.delete(h),i.item.handle!==p.item.handle&&this.j.delete(p.item.handle),this.ob(h,i);const o=this.X(u)||[],E=o.filter(w=>w.item.handle===p.item.handle)[0];E&&o.splice(o.indexOf(E),1,i)}qb(h,i){i?(i.children||(i.children=[]),i.children.push(h)):(this.h||(this.h=[]),this.h.push(h))}rb(h){if(h){const i=this.m.get(h);if(i){if(i.children)for(const p of i.children){const u=this.j.get(p.item.handle);u&&this.sb(u)}i.children=void 0}}else this.tb()}sb(h){const i=this.m.get(h);if(i){if(i.children)for(const p of i.children){const u=this.j.get(p.item.handle);u&&this.sb(u)}this.m.delete(h),this.j.delete(i.item.handle),i.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(h=>h.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(Re[279],Ae([1,0,5,6,2,33,8,62,3,7]),function(fe,e,S,F,P,L,R,g,f,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dic=void 0;class M extends F.$Tc{#e;#t;#i;#n;#s;#r;#a;#o;#c;#u;#l;#d;#h;constructor($,s,c,t){super(),this.#o=void 0,this.#c=!0,this.#l=!1,this.#d=this.B(new S.$5d),this.onDidDispose=this.#d.event,this.#h=this.B(new S.$5d),this.onDidChangeViewState=this.#h.event,this.#e=$,this.#t=s,this.#n=c,this.#i=t.viewType,this.#s=t.panelOptions,this.#o=t.viewColumn,this.#r=t.title,this.#u=t.active}dispose(){this.#l||(this.#l=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#n.dispose(),super.dispose())}get webview(){return this.c(),this.#n}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#r}set title($){this.c(),this.#r!==$&&(this.#r=$,this.#t.$setTitle(this.#e,$))}get iconPath(){return this.c(),this.#a}set iconPath($){this.c(),this.#a!==$&&(this.#a=$,this.#t.$setIconPath(this.#e,P.URI.isUri($)?{light:$,dark:$}:$))}get options(){return this.#s}get viewColumn(){if(this.c(),!(typeof this.#o=="number"&&this.#o<0))return this.#o}get active(){return this.c(),this.#u}get visible(){return this.c(),this.#c}_updateViewState($){this.#l||(this.active!==$.active||this.visible!==$.visible||this.viewColumn!==$.viewColumn)&&(this.#u=$.active,this.#c=$.visible,this.#o=$.viewColumn,this.#h.fire({webviewPanel:this}))}reveal($,s){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof $>"u"?void 0:R.ViewColumn.from($),preserveFocus:!!s})}c(){if(this.#l)throw new Error("Webview is disposed")}}class k extends F.$Tc{static c(){return(0,L.$Ag)()}constructor($,s,c){super(),this.j=s,this.m=c,this.g=new Map,this.h=new Map,this.f=$.getProxy(f.$ZL.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach($=>$.dispose()),this.g.clear()}createWebviewPanel($,s,c,t,n={}){const r=typeof t=="object"?t.viewColumn:t,a={viewColumn:R.ViewColumn.from(r),preserveFocus:typeof t=="object"&&!!t.preserveFocus},h=(0,g.$_hc)($),i=k.c();this.f.$createWebviewPanel((0,g.$bic)($),i,s,{title:c,panelOptions:l(n),webviewOptions:(0,g.$cic)($,this.m,n),serializeBuffersForPostMessage:h},a);const p=this.j.createNewWebview(i,n,$);return this.createNewWebviewPanel(i,s,c,r,n,p,!0)}$onDidChangeWebviewPanelViewStates($){const s=Object.keys($);s.sort((c,t)=>{const n=$[c],r=$[t];return n.active?1:r.active?-1:+n.visible-+r.visible});for(const c of s){const t=this.getWebviewPanel(c);if(!t)continue;const n=$[c];t._updateViewState({active:n.active,visible:n.visible,viewColumn:R.ViewColumn.to(n.position)})}}async $onDidDisposeWebviewPanel($){this.getWebviewPanel($)?.dispose(),this.g.delete($),this.j.deleteWebview($)}registerWebviewPanelSerializer($,s,c){if(this.h.has(s))throw new Error(`Serializer for '${s}' already registered`);return this.h.set(s,{serializer:c,extension:$}),this.f.$registerSerializer(s,{serializeBuffersForPostMessage:(0,g.$_hc)($)}),new D.$2L(()=>{this.h.delete(s),this.f.$unregisterSerializer(s)})}async $deserializeWebviewPanel($,s,c,t){const n=this.h.get(s);if(!n)throw new Error(`No serializer found for '${s}'`);const{serializer:r,extension:a}=n,h=this.j.createNewWebview($,c.webviewOptions,a),i=this.createNewWebviewPanel($,s,c.title,t,c.panelOptions,h,c.active);await r.deserializeWebviewPanel(i,c.state)}createNewWebviewPanel($,s,c,t,n,r,a){const h=new M($,this.f,r,{viewType:s,title:c,viewColumn:t,panelOptions:n,active:a});return this.g.set($,h),h}getWebviewPanel($){return this.g.get($)}}e.$dic=k;function l(v){return{enableFindWidget:v.enableFindWidget,retainContextWhenHidden:v.retainContextWhenHidden}}}),define(Re[280],Ae([1,0,5,6,62,8,3,7]),function(fe,e,S,F,P,L,R,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hjc=void 0;class f extends F.$Tc{#e;#t;#i;#n;#s;#r;#a;#o;#c;constructor(k,l,v,$,s,c){super(),this.#s=!1,this.#u=this.B(new S.$5d),this.onDidChangeVisibility=this.#u.event,this.#l=this.B(new S.$5d),this.onDidDispose=this.#l.event,this.#i=v,this.#a=$,this.#e=k,this.#t=l,this.#n=s,this.#r=c}dispose(){this.#s||(this.#s=!0,this.#l.fire(),this.#n.dispose(),super.dispose())}#u;#l;get title(){return this.a(),this.#a}set title(k){this.a(),this.#a!==k&&(this.#a=k,this.#t.$setWebviewViewTitle(this.#e,k))}get description(){return this.a(),this.#o}set description(k){this.a(),this.#o!==k&&(this.#o=k,this.#t.$setWebviewViewDescription(this.#e,k))}get visible(){return this.#r}get webview(){return this.#n}get viewType(){return this.#i}_setVisible(k){k===this.#r||this.#s||(this.#r=k,this.#u.fire())}get badge(){return this.a(),this.#c}set badge(k){this.a(),!(k?.value===this.#c?.value&&k?.tooltip===this.#c?.tooltip)&&(this.#c=L.ViewBadge.from(k),this.#t.$setWebviewViewBadge(this.#e,k))}show(k){this.a(),this.#t.$show(this.#e,!!k)}a(){if(this.#s)throw new Error("Webview is disposed")}}class D{constructor(k,l){this.d=l,this.b=new Map,this.c=new Map,this.a=k.getProxy(R.$ZL.MainThreadWebviewViews)}registerWebviewViewProvider(k,l,v,$){if(this.b.has(l))throw new Error(`View provider for '${l}' already registered`);return this.b.set(l,{provider:v,extension:k}),this.a.$registerWebviewViewProvider((0,P.$bic)(k),l,{retainContextWhenHidden:$?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,P.$_hc)(k)}),new g.$2L(()=>{this.b.delete(l),this.a.$unregisterWebviewViewProvider(l)})}async $resolveWebviewView(k,l,v,$,s){const c=this.b.get(l);if(!c)throw new Error(`No view provider found for '${l}'`);const{provider:t,extension:n}=c,r=this.d.createNewWebview(k,{},n),a=new f(k,this.a,l,v,r,!0);this.c.set(k,a),await t.resolveWebviewView(a,{state:$},s)}async $onDidChangeWebviewViewVisibility(k,l){this.e(k)._setVisible(l)}async $disposeWebviewView(k){const l=this.e(k);this.c.delete(k),l.dispose(),this.d.deleteWebview(k)}e(k){const l=this.c.get(k);if(!l)throw new Error("No webview found");return l}}e.$Hjc=D}),define(Re[281],Ae([1,0,5,30,36,4]),function(fe,e,S,F,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jL=e.$iL=e.OutputChannelUpdateMode=e.$hL=e.$gL=e.$fL=e.$eL=e.$dL=e.$cL=e.$bL=e.$aL=e.$_K=e.$$K=void 0,e.$$K="text/x-code-output",e.$_K="output",e.$aL="Log",e.$bL="text/x-code-log-output",e.$cL="log",e.$dL="workbench.panel.output",e.$eL=new P.$vj("inOutput",!1),e.$fL=new P.$vj("activeLogOutput",!1),e.$gL=new P.$vj("outputView.scrollLock",!1),e.$hL=(0,L.$ei)("outputService");var R;(function(f){f[f.Append=1]="Append",f[f.Replace=2]="Replace",f[f.Clear=3]="Clear"})(R||(e.OutputChannelUpdateMode=R={})),e.$iL={OutputChannels:"workbench.contributions.outputChannels"};class g{constructor(){this.a=new Map,this.b=new S.$5d,this.onDidRegisterChannel=this.b.event,this.c=new S.$5d,this.onDidRemoveChannel=this.c.event}registerChannel(D){this.a.has(D.id)||(this.a.set(D.id,D),this.b.fire(D.id))}getChannels(){const D=[];return this.a.forEach(M=>D.push(M)),D}getChannel(D){return this.a.get(D)}removeChannel(D){this.a.delete(D),this.c.fire(D)}}F.$Tn.add(e.$iL.OutputChannels,new g),e.$jL=new P.$vj("activeOutputChannel","")}),define(Re[113],Ae([1,0,3,4,17,20,14,281,63,27,43,137,24,16,42,5,6]),function(fe,e,S,F,P,L,R,g,f,D,M,k,l,v,$,s,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jjc=e.$ijc=void 0;class t extends R.$Ej{get disposed(){return this.n}constructor(h,i,p,u,o){super(),this.id=h,this.name=i,this.r=p,this.s=u,this.extension=o,this.m=0,this.n=!1,this.visible=!1,this.setLevel(p.getLevel()),this.B(p.onDidChangeLogLevel(E=>this.setLevel(E)))}get logLevel(){return this.getLevel()}appendLine(h){this.append(h+`
`)}append(h){this.info(h)}clear(){const h=this.m;this.r.flush(),this.s.$update(this.id,g.OutputChannelUpdateMode.Clear,h)}replace(h){const i=this.m;this.info(h),this.s.$update(this.id,g.OutputChannelUpdateMode.Replace,i),this.visible&&this.r.flush()}show(h,i){this.r.flush(),this.s.$reveal(this.id,!!(typeof h=="boolean"?h:i))}hide(){this.s.$close(this.id)}g(h,i){this.m+=l.$se.fromString(i).byteLength,(0,R.log)(this.r,h,i),this.visible&&(this.r.flush(),this.s.$update(this.id,g.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class n extends t{appendLine(h){this.append(h)}}let r=class{constructor(h,i,p,u,o,E){this.i=i,this.j=p,this.k=u,this.l=o,this.m=E,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=h.getProxy(S.$ZL.MainThreadOutputService),this.b=this.k.extUri.joinPath(i.logsLocation,`output_logging_${(0,k.$Im)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(h){this.h=h;for(const[i,p]of this.g)p.visible=i===this.h}createOutputChannel(h,i,p){if(h=h.trim(),!h)throw new Error("illegal argument `name`. must not be falsy");const u=typeof i=="object"&&i.log,o=(0,v.$Sf)(i)?i:void 0;if((0,v.$Sf)(o)&&!o.trim())throw new Error("illegal argument `languageId`. must not be empty");let E;const w=this.i.environment.extensionLogLevel?.find(([I])=>L.$wm.equals(p.identifier,I))?.[1];w&&(E=(0,R.$Oj)(w));const m=u?this.o(h,E,p):this.n(h,o,p);return m.then(I=>{this.g.set(I.id,I),I.visible=I.id===this.h}),u?this.r(h,E??this.m.getLevel(),m):this.q(h,m)}async n(h,i,p){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const u=await this.c,o=this.k.extUri.joinPath(u,`${this.f++}-${h.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),E=this.l.createLogger(o,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),w=await this.a.$register(h,o,i,p.identifier.value);return new t(w,h,E,this.a,p)}async o(h,i,p){const u=await this.p(p),o=h.replace(/[\\/:\*\?"<>\|]/g,""),E=this.k.extUri.joinPath(u,`${o}.log`),w=`${p.identifier.value}.${o}`,m=this.l.createLogger(E,{id:w,name:h,logLevel:i,extensionId:p.identifier.value});return new n(w,h,m,this.a,p)}p(h){let i=this.d.get(h.identifier.value);if(!i){const p=this.k.extUri.joinPath(this.i.logsLocation,h.identifier.value);this.d.set(h.identifier.value,i=(async()=>{try{await this.j.value.createDirectory(p)}catch(u){if((0,$.$Rk)(u)!==$.FileSystemProviderErrorCode.FileExists)throw u}return p})())}return i}q(h,i){let p=!1;const u=()=>{if(p)throw new Error("Channel has been closed")};return{get name(){return h},append(o){u(),i.then(E=>E.append(o))},appendLine(o){u(),i.then(E=>E.appendLine(o))},clear(){u(),i.then(o=>o.clear())},replace(o){u(),i.then(E=>E.replace(o))},show(o,E){u(),i.then(w=>w.show(o,E))},hide(){u(),i.then(o=>o.hide())},dispose(){p=!0,i.then(o=>o.dispose())}}}r(h,i,p){const u=new c.$Sc,o=()=>{if(u.isDisposed)throw new Error("Channel has been closed")},E=u.add(new s.$5d);function w(m){i=m,E.fire(m)}return p.then(m=>{u.add(m),m.logLevel!==i&&w(m.logLevel),u.add(m.onDidChangeLogLevel(I=>w(I)))}),{...this.q(h,p),get logLevel(){return i},onDidChangeLogLevel:E.event,trace(m,...I){o(),p.then(d=>d.trace(m,...I))},debug(m,...I){o(),p.then(d=>d.debug(m,...I))},info(m,...I){o(),p.then(d=>d.info(m,...I))},warn(m,...I){o(),p.then(d=>d.warn(m,...I))},error(m,...I){o(),p.then(d=>d.error(m,...I))},dispose(){u.dispose()}}}};e.$ijc=r,e.$ijc=r=Ze([qe(0,P.$eO),qe(1,D.$uO),qe(2,f.$8hc),qe(3,M.$Jhc),qe(4,R.$zj),qe(5,R.$yj)],r),e.$jjc=(0,F.$ei)("IExtHostOutputService")}),define(Re[114],Ae([1,0,4,11]),function(fe,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ym=e.$Xm=void 0,e.$Xm=(0,S.$ei)("remoteAgentService"),e.$Ym=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(P){let L=1/0;for(let g=0;g<this.maxSampleCount;g++){const f=await P.getRoundTripTime();if(f===void 0)return;L=Math.min(L,f/2),await(0,F.$fh)(this.sampleDelay)}this.average.push(L),this.average.length>this.maxAverageCount&&this.average.shift();let R;return this.initial.length<this.maxInitialCount?this.initial.push(L):R=this.initial.reduce((g,f)=>g+f,0)/this.initial.length,this.lastMeasurement={initial:R,current:L,average:this.average.reduce((g,f)=>g+f,0)/this.average.length,high:typeof R>"u"?!1:L>this.highLatencyMaxThreshold||L>this.highLatencyMinThreshold&&L>R*this.highLatencyMultiple},this.lastMeasurement}}}),define(Re[282],Ae([1,0,171,56,30,47,46,6,5,114,21,26,11]),function(fe,e,S,F,P,L,R,g,f,D,M,k,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MI=e.$LI=e.$KI=e.$JI=e.$II=e.$HI=e.$GI=void 0,e.$GI=Object.freeze({id:"application",order:100,title:(0,S.localize)(0,null),type:"object"}),e.$HI=Object.freeze({id:"workbench",order:7,title:(0,S.localize)(1,null),type:"object"}),e.$II=Object.freeze({id:"security",scope:1,title:(0,S.localize)(2,null),type:"object",order:7}),e.$JI=Object.freeze({id:"problems",title:(0,S.localize)(3,null),type:"object",order:101}),e.$KI={ConfigurationMigration:"base.contributions.configuration.migration"};class v{constructor(){this.migrations=[],this.a=new f.$5d,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(n){this.migrations.push(...n)}}const $=new v;P.$Tn.add(e.$KI.ConfigurationMigration,$);let s=class extends g.$Tc{static{this.ID="workbench.contrib.configurationMigration"}constructor(n,r){super(),this.a=n,this.b=r,this.B(this.b.onDidChangeWorkspaceFolders(async a=>{for(const h of a.added)await this.f(h,$.migrations)})),this.c($.migrations),this.B($.onDidRegisterConfigurationMigration(a=>this.c(a)))}async c(n){await this.f(void 0,n);for(const r of this.b.getWorkspace().folders)await this.f(r,n)}async f(n,r){await Promise.all([r.map(a=>this.g(a,n?.uri))])}async g(n,r){const a=this.a.inspect(n.key,{resource:r}),h=this.b.getWorkbenchState()===3?[["user",2],["userLocal",3],["userRemote",4],["workspace",5],["workspaceFolder",6]]:[["user",2],["userLocal",3],["userRemote",4],["workspace",5]];for(const[i,p]of h){const u=a[i];if(!u)continue;const o=[];if(u.value!==void 0){const E=await this.h(n,i,u.value,r,void 0);for(const w of E??[])o.push([w,[]])}for(const{identifiers:E,value:w}of u.overrides??[])if(w!==void 0){const m=await this.h(n,i,w,r,E);for(const I of m??[])o.push([I,E])}o.length&&await Promise.allSettled(o.map(async([[E,w],m])=>this.a.updateValue(E,w.value,{resource:r,overrideIdentifiers:m},p)))}}async h(n,r,a,h,i){const p=o=>{const w=this.a.inspect(o,{resource:h})[r];if(w)return i?w.overrides?.find(({identifiers:m})=>(0,k.$Ln)(m,i))?.value:w.value},u=await n.migrateFn(a,p);return Array.isArray(u)?u:[[n.key,u]]}};e.$LI=s,e.$LI=s=Ze([qe(0,R.$Ki),qe(1,L.$ni)],s);let c=class extends g.$Tc{static{this.ID="workbench.contrib.dynamicWorkbenchSecurityConfiguration"}constructor(n){super(),this.b=n,this.a=new l.$Bh,this.ready=this.a.p,this.c()}async c(){try{await this.f()}finally{this.a.complete()}}async f(){if(!M.$i&&(await this.b.getEnvironment())?.os!==1)return;P.$Tn.as(F.$Yn.Configuration).registerConfiguration({...e.$II,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,S.localize)(4,null)},default:[],markdownDescription:(0,S.localize)(5,null),scope:2},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,S.localize)(6,null),scope:2}}})}};e.$MI=c,e.$MI=c=Ze([qe(0,D.$Xm)],c)}),define(Re[283],Ae([1,0,35,12,19,25,179,282,56,4,30]),function(fe,e,S,F,P,L,R,g,f,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1eb=e.$Zeb=e.ResolvedStatus=e.RegisteredEditorPriority=e.$Yeb=e.$Xeb=void 0,e.$Xeb=(0,D.$ei)("editorResolverService"),e.$Yeb="workbench.editorAssociations";const k=M.$Tn.as(f.$Yn.Configuration),l={...g.$HI,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,R.localize)(0,null),additionalProperties:{type:"string"}}}};k.registerConfiguration(l);var v;(function(t){t.builtin="builtin",t.option="option",t.exclusive="exclusive",t.default="default"})(v||(e.RegisteredEditorPriority=v={}));var $;(function(t){t[t.ABORT=1]="ABORT",t[t.NONE=2]="NONE"})($||(e.ResolvedStatus=$={}));function s(t){switch(t){case v.exclusive:return 5;case v.default:return 4;case v.builtin:return 3;case v.option:default:return 1}}e.$Zeb=s;function c(t,n){if(new Set([F.Schemas.extension,F.Schemas.webviewPanel,F.Schemas.vscodeWorkspaceTrust,F.Schemas.vscodeSettings]).has(n.scheme))return!1;const h=typeof t=="string"&&t.indexOf(P.$gc.sep)>=0?`${n.scheme}:${n.path}`:(0,L.$Og)(n);return S.$Wj(typeof t=="string"?t.toLowerCase():t,h.toLowerCase())}e.$1eb=c}),define(Re[284],Ae([1,0,45,12,19,21,25,2,4,200,47,218,114]),function(fe,e,S,F,P,L,R,g,f,D,M,k,l){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.$CL=e.$BL=void 0,e.$BL=(0,f.$ei)("pathService");let $=v=class{constructor(c,t,n,r){this.d=c,this.e=t,this.f=n,this.g=r,this.a=(async()=>(await this.e.getEnvironment())?.os||L.OS)(),this.b=(async()=>{const a=await this.e.getEnvironment();return this.c=a?.userHome??c})()}hasValidBasename(c,t,n){return typeof t=="string"||typeof t>"u"?this.a.then(r=>this.h(c,r,t)):this.h(c,t,n)}h(c,t,n){return c.scheme===F.Schemas.file||c.scheme===F.Schemas.vscodeRemote?(0,S.$dg)(n??(0,R.$Og)(c),t===1):!0}get defaultUriScheme(){return v.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(c,t){if(c.remoteAuthority)return F.Schemas.vscodeRemote;const n=(0,D.$yL)(t.getWorkspace());if(n)return n;const r=t.getWorkspace().folders[0];if(r)return r.uri.scheme;const a=t.getWorkspace().configuration;return a?a.scheme:F.Schemas.file}userHome(c){return c?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(c=>c===1?P.$fc:P.$gc)}async fileURI(c){let t="";if(await this.a===1&&(c=c.replace(/\\/g,"/")),c[0]==="/"&&c[1]==="/"){const r=c.indexOf("/",2);r===-1?(t=c.substring(2),c="/"):(t=c.substring(2,r),c=c.substring(r)||"/")}return g.URI.from({scheme:F.Schemas.file,authority:t,path:c,query:"",fragment:""})}};e.$CL=$,e.$CL=$=v=Ze([qe(1,l.$Xm),qe(2,k.$kL),qe(3,M.$ni)],$)}),define(Re[115],Ae([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$dK=e.$cK=void 0;class S{constructor(R,g){this.line=R,this.character=g}isBefore(R){return!1}isBeforeOrEqual(R){return!1}isAfter(R){return!1}isAfterOrEqual(R){return!1}isEqual(R){return!1}compareTo(R){return 0}translate(R,g){return new S(0,0)}with(R){return new S(0,0)}}e.$cK=S;class F{constructor(R,g,f,D){this.isEmpty=!1,this.isSingleLine=!1,this.start=new S(R,g),this.end=new S(f,D)}contains(R){return!1}isEqual(R){return!1}intersection(R){}union(R){return new F(0,0,0,0)}with(R){return new F(0,0,0,0)}}e.$dK=F;var P;(function(L){L[L.Information=1]="Information",L[L.Warning=2]="Warning"})(P||(e.TextSearchCompleteMessageType=P={}))}),define(Re[44],Ae([1,0,18,35,26,45,13,4,19,15,115,11]),function(fe,e,S,F,P,L,R,g,f,D,M,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EK=e.$DK=e.$CK=e.$BK=e.$AK=e.$zK=e.$yK=e.$xK=e.$wK=e.$vK=e.$uK=e.$tK=e.SearchErrorCode=e.$sK=e.$rK=e.SearchSortOrder=e.ViewMode=e.$qK=e.$pK=e.$oK=e.$nK=e.SearchCompletionExitCode=e.$mK=e.$lK=e.$kK=e.QueryType=e.SearchProviderType=e.$jK=e.$iK=e.$hK=e.$gK=e.$fK=e.$eK=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return M.TextSearchCompleteMessageType}}),e.$eK="workbench.view.search",e.$fK="workbench.panel.search",e.$gK="workbench.view.search",e.$hK="search-result",e.$iK="search.exclude";const l="\u27EA ",v=" characters skipped \u27EB",$=(l.length+v.length+5)*2;e.$jK=(0,g.$ei)("searchService");var s;(function(he){he[he.file=0]="file",he[he.text=1]="text"})(s||(e.SearchProviderType=s={}));var c;(function(he){he[he.File=1]="File",he[he.Text=2]="Text"})(c||(e.QueryType=c={}));function t(he){return!!he.preview}e.$kK=t;function n(he){return!!he.resource}e.$lK=n;function r(he){return!!he.message}e.$mK=r;var a;(function(he){he[he.Normal=0]="Normal",he[he.NewSearchStarted=1]="NewSearchStarted"})(a||(e.SearchCompletionExitCode=a={}));class h{constructor(ve){this.resource=ve,this.results=[]}}e.$nK=h;class i{constructor(ve,se,$e,ee){this.ranges=se,this.webviewIndex=ee;const Q=Array.isArray(se)?se:[se];if($e&&$e.matchLines===1&&p(Q)){ve=(0,R.$Lf)(ve,$e.matchLines);let q="",ne=0,Se=0;const Te=Math.floor($e.charsPerLine/5),Ce=[];for(const we of Q){const ge=Math.max(we.startColumn-Te,0),J=we.startColumn+$e.charsPerLine;if(ge>Se+Te+$){const x=l+(ge-Se)+v;q+=x+ve.slice(ge,J),ne+=ge-(Se+x.length)}else q+=ve.slice(Se,J);Ce.push(new o(0,we.startColumn-ne,we.endColumn-ne)),Se=J}this.preview={text:q,matches:Array.isArray(this.ranges)?Ce:Ce[0]}}else{const q=Array.isArray(se)?se[0].startLineNumber:se.startLineNumber;this.preview={text:ve,matches:(0,S.$2b)(se,ne=>new u(ne.startLineNumber-q,ne.startColumn,ne.endLineNumber-q,ne.endColumn))}}}}e.$oK=i;function p(he){const ve=he[0].startLineNumber;for(const se of he)if(se.startLineNumber!==ve||se.endLineNumber!==ve)return!1;return!0}class u{constructor(ve,se,$e,ee){this.startLineNumber=ve,this.startColumn=se,this.endLineNumber=$e,this.endColumn=ee}}e.$pK=u;class o extends u{constructor(ve,se,$e){super(ve,se,ve,$e)}}e.$qK=o;var E;(function(he){he.List="list",he.Tree="tree"})(E||(e.ViewMode=E={}));var w;(function(he){he.Default="default",he.FileNames="fileNames",he.Type="type",he.Modified="modified",he.CountDescending="countDescending",he.CountAscending="countAscending"})(w||(e.SearchSortOrder=w={}));function m(he,ve=!0){const se=he&&he.files&&he.files.exclude,$e=ve&&he&&he.search&&he.search.exclude;if(!se&&!$e)return;if(!se||!$e)return se||$e;let ee=Object.create(null);return ee=P.$Kn(ee,P.$Hn(se)),ee=P.$Kn(ee,P.$Hn($e),!0),ee}e.$rK=m;function I(he,ve){return he.excludePattern&&F.$Wj(he.excludePattern,ve)?!1:he.includePattern||he.usingSearchPaths?he.includePattern&&F.$Wj(he.includePattern,ve)?!0:he.usingSearchPaths?!!he.folderQueries&&he.folderQueries.some(se=>{const $e=se.folder.fsPath;if(L.$fg(ve,$e)){const ee=f.$lc($e,ve);return!se.includePattern||!!F.$Wj(se.includePattern,ee)}else return!1}):!1:!0}e.$sK=I;var d;(function(he){he[he.unknownEncoding=1]="unknownEncoding",he[he.regexParseError=2]="regexParseError",he[he.globParseError=3]="globParseError",he[he.invalidLiteral=4]="invalidLiteral",he[he.rgProcessError=5]="rgProcessError",he[he.other=6]="other",he[he.canceled=7]="canceled"})(d||(e.SearchErrorCode=d={}));class y extends Error{constructor(ve,se){super(ve),this.code=se}}e.$tK=y;function b(he){const ve=he.message;if((0,D.$4)(he))return new y(ve,d.canceled);try{const se=JSON.parse(ve);return new y(se.message,se.code)}catch{return new y(ve,d.other)}}e.$uK=b;function A(he){const ve={message:he.message,code:he.code};return new Error(JSON.stringify(ve))}e.$vK=A;function T(he){return he.type==="error"?!0:he.type==="success"}e.$wK=T;function G(he){return he.type==="success"}e.$xK=G;function W(he){return!!he.path}e.$yK=W;function U(he,ve,se=!0){const $e=he.searchPath?he.searchPath:he.relativePath;return se?(0,R.$If)($e,ve):F.$Wj(ve,$e)}e.$zK=U;class C{constructor(ve){this.path=ve,this.results=[]}addMatch(ve){this.results.push(ve)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$AK=C;function O(he,ve){const se={...he||{},...ve||{}};return Object.keys(se).filter($e=>{const ee=se[$e];return typeof ee=="boolean"&&ee})}e.$BK=O;class V{constructor(ve,se){this.c=null,this.a={...ve.excludePattern||{},...se.excludePattern||{}},this.b=F.$Xj(this.a);let $e=ve.includePattern;se.includePattern&&($e?$e={...$e,...se.includePattern}:$e=se.includePattern),$e&&(this.c=F.$Xj($e))}matchesExcludesSync(ve,se,$e){return!!(this.b&&this.b(ve,se,$e))}includedInQuerySync(ve,se,$e){return!(this.b&&this.b(ve,se,$e)||this.c&&!this.c(ve,se,$e))}includedInQuery(ve,se,$e){const ee=this.b(ve,se,$e),Q=()=>this.c?!!this.c(ve,se,$e):!0;return(0,k.$3g)(ee)?ee.then(q=>q?!1:Q()):Q()}hasSiblingExcludeClauses(){return re(this.a)}}e.$CK=V;function re(he){for(const ve in he)if(typeof he[ve]!="boolean")return!0;return!1}function ue(he){if(!he)return;let ve;return se=>(ve||(ve=(he()||Promise.resolve([])).then($e=>$e?De($e):{})),ve.then($e=>!!$e[se]))}e.$DK=ue;function ye(he){if(!he)return;let ve;return se=>{if(!ve){const $e=he();ve=$e?De($e):{}}return!!ve[se]}}e.$EK=ye;function De(he){const ve={};for(const se of he)ve[se]=!0;return ve}}),define(Re[37],Ae([1,0,18,11,22,5,6,50,12,123,25,13,2,170,4,14,189,47,43,27,17,8,7,59,44,3,52]),function(fe,e,S,F,P,L,R,g,f,D,M,k,l,v,$,s,c,t,n,r,a,h,i,p,u,o,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3hc=e.$2hc=void 0;function w(G,W,U){return new M.$Gg(C=>y(C,U)).isEqual(G,W)}function m(G,W,U){return w(G.uri,W.uri,U)?0:(0,k.$cf)(G.uri.toString(),W.uri.toString())}function I(G,W,U){return G.index!==W.index?G.index<W.index?-1:1:w(G.uri,W.uri,U)?(0,k.$cf)(G.name,W.name):(0,k.$cf)(G.uri.toString(),W.uri.toString())}function d(G,W,U,C){const O=G.slice(0).sort((re,ue)=>U(re,ue,C)),V=W.slice(0).sort((re,ue)=>U(re,ue,C));return(0,S.$Eb)(O,V,(re,ue)=>U(re,ue,C))}function y(G,W){const U=W.getCapabilities(G.scheme);return!(U&&U&1024)}class b extends t.$xi{static toExtHostWorkspace(W,U,C,O){if(!W)return{workspace:null,added:[],removed:[]};const{id:V,name:re,folders:ue,configuration:ye,transient:De,isUntitled:he}=W,ve=[],se=U;U?ue.forEach((q,ne)=>{const Se=l.URI.revive(q.uri),Te=b.o(C||U,Se,O);Te?(Te.name=q.name,Te.index=q.index,ve.push(Te)):ve.push({uri:Se,name:q.name,index:ne})}):ve.push(...ue.map(({uri:q,name:ne,index:Se})=>({uri:l.URI.revive(q),name:ne,index:Se}))),ve.sort((q,ne)=>q.index<ne.index?-1:1);const $e=new b(V,re,ve,!!De,ye?l.URI.revive(ye):null,!!he,q=>y(q,O)),{added:ee,removed:Q}=d(se?se.workspaceFolders:[],$e.workspaceFolders,m,O);return{workspace:$e,added:ee,removed:Q}}static o(W,U,C){for(let O=0;O<W.folders.length;O++){const V=W.workspaceFolders[O];if(w(V.uri,U,C))return V}}constructor(W,U,C,O,V,re,ue){super(W,C.map(ye=>new t.$yi(ye)),O,V,ue),this.t=U,this.u=re,this.q=[],this.s=g.$ki.forUris(ue),C.forEach(ye=>{this.q.push(ye),this.s.set(ye.uri,ye)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(W,U){return U&&this.s.get(W)&&(W=(0,M.$Qg)(W)),this.s.findSubstr(W)}resolveWorkspaceFolder(W){return this.s.get(W)}}let A=class{constructor(W,U,C,O,V){this.c=new L.$5d,this.onDidChangeWorkspace=this.c.event,this.g=new L.$5d,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.A=0,this.B=new L.$7d,this.C=new Map,this.h=O,this.s=C,this.t=V,this.j=new D.$hm,this.k=new F.$dh,this.o=W.getProxy(o.$ZL.MainThreadWorkspace),this.q=W.getProxy(o.$ZL.MainThreadMessageService);const re=U.workspace;this.l=re?new b(re.id,re.name,[],!!re.transient,re.configuration?l.URI.revive(re.configuration):null,!!re.isUntitled,ue=>y(ue,C)):void 0}$initializeWorkspace(W,U){this.v=U,this.$acceptWorkspaceData(W),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?l.URI.from({scheme:f.Schemas.untitled,path:(0,M.$Og)((0,M.$Qg)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(W,U,C,...O){const V=[];if(Array.isArray(O)&&O.forEach(he=>{l.URI.isUri(he.uri)&&!V.some(ve=>w(ve.uri,he.uri,this.s))&&V.push({uri:he.uri,name:he.name||(0,M.$Ng)(he.uri)})}),this.n||[U,C].some(he=>typeof he!="number"||he<0)||C===0&&V.length===0)return!1;const re=this.x?this.x.workspaceFolders:[];if(U+C>re.length)return!1;const ue=re.slice(0);ue.splice(U,C,...V.map(he=>({uri:he.uri,name:he.name||(0,M.$Ng)(he.uri),index:void 0})));for(let he=0;he<ue.length;he++){const ve=ue[he];if(ue.some((se,$e)=>$e!==he&&w(ve.uri,se.uri,this.s)))return!1}ue.forEach((he,ve)=>he.index=ve);const{added:ye,removed:De}=d(re,ue,I,this.s);if(ye.length===0&&De.length===0)return!1;if(this.o){const he=W.displayName||W.name;this.o.$updateWorkspaceFolders(he,U,C,V).then(void 0,ve=>{this.n=void 0;const se={source:{identifier:W.identifier,label:W.displayName||W.name}};this.q.$showMessage(c.Severity.Error,(0,v.localize)(0,null,he,ve.toString()),se,[])})}return this.y(ue),!0}getWorkspaceFolder(W,U){if(this.x)return this.x.getWorkspaceFolder(W,U)}async getWorkspaceFolder2(W,U){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(W,U)}async resolveWorkspaceFolder(W){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(W)}getPath(){if(!this.x)return;const{folders:W}=this.x;if(W.length!==0)return W[0].uri.fsPath}getRelativePath(W,U){let C,O="";if(typeof W=="string"?(C=l.URI.file(W),O=W):typeof W<"u"&&(C=W,O=W.fsPath),!C)return O;const V=this.getWorkspaceFolder(C,!0);if(!V)return O;typeof U>"u"&&this.x&&(U=this.x.folders.length>1);let re=(0,M.$Tg)(V.uri,C);return U&&V.name&&(re=`${V.name}/${re}`),re}y(W){this.x&&(this.n=b.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:W,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(W){const{workspace:U,added:C,removed:O}=b.toExtHostWorkspace(W,this.l,this.n,this.s);this.l=U||void 0,this.n=void 0,this.c.fire(Object.freeze({added:C,removed:O}))}findFiles(W,U,C,O,V=P.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${O.value}, entryPoint: findFiles`);let re="",ue=!0;return U===null?ue=!1:U!==void 0&&(typeof U=="string"?re=U:re=U.pattern),this.z(W,void 0,{exclude:re,maxResults:C,useDefaultExcludes:ue,useDefaultSearchExcludes:!1,useIgnoreFiles:!1},V)}findFiles2(W,U={},C,O=P.CancellationToken.None){return this.h.trace(`extHostWorkspace#findFiles2: fileSearch, extension: ${C.value}, entryPoint: findFiles2`),this.z(void 0,W,U,O)}async z(W,U,C,O=P.CancellationToken.None){if(O&&O.isCancellationRequested)return Promise.resolve([]);const V=typeof C.exclude=="string"?C.exclude:C.exclude?C.exclude.pattern:void 0,re={ignoreSymlinks:typeof C.followSymlinks=="boolean"?!C.followSymlinks:void 0,disregardIgnoreFiles:typeof C.useIgnoreFiles=="boolean"?!C.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof C.useGlobalIgnoreFiles=="boolean"?!C.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof C.useParentIgnoreFiles=="boolean"?!C.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof C.useDefaultExcludes=="boolean"?!C.useDefaultExcludes:!1,disregardSearchExcludeSettings:typeof C.useDefaultSearchExcludes=="boolean"?!C.useDefaultSearchExcludes:!1,maxResults:C.maxResults,excludePattern:V,shouldGlobSearch:typeof C.fuzzy=="boolean"?!C.fuzzy:!0,_reason:"startFileSearch"};let ue;if(W){const{includePattern:ye,folder:De}=T(h.GlobPattern.from(W));ue=De,re.includePattern=ye}else{const{includePattern:ye,folder:De}=T(h.GlobPattern.from(U));ue=De,re.filePattern=ye}return this.o.$startFileSearch(ue??null,re,O).then(ye=>Array.isArray(ye)?ye.map(De=>l.URI.revive(De)):[])}async findTextInFiles(W,U,C,O,V=P.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${O.value}, entryPoint: findTextInFiles`);const re=this.j.getNext(),ue=typeof U.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:U.previewOptions,{includePattern:ye,folder:De}=T(h.GlobPattern.from(U.include)),he=typeof U.exclude=="string"?U.exclude:U.exclude?U.exclude.pattern:void 0,ve={ignoreSymlinks:typeof U.followSymlinks=="boolean"?!U.followSymlinks:void 0,disregardIgnoreFiles:typeof U.useIgnoreFiles=="boolean"?!U.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof U.useGlobalIgnoreFiles=="boolean"?!U.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof U.useParentIgnoreFiles=="boolean"?!U.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof U.useDefaultExcludes=="boolean"?!U.useDefaultExcludes:!0,fileEncoding:U.encoding,maxResults:U.maxResults,previewOptions:ue,afterContext:U.afterContext,beforeContext:U.beforeContext,includePattern:ye,excludePattern:he},se=!1;if(this.u[re]=$e=>{if(se)return;const ee=l.URI.revive($e.resource);$e.results.forEach(Q=>{const q=(0,E.$Nh)(Q);(0,u.$kK)(q)?C({uri:ee,preview:{text:q.preview.text,matches:(0,S.$2b)(q.preview.matches,ne=>new i.$4L(ne.startLineNumber,ne.startColumn,ne.endLineNumber,ne.endColumn))},ranges:(0,S.$2b)(q.ranges,ne=>new i.$4L(ne.startLineNumber,ne.startColumn,ne.endLineNumber,ne.endColumn))}):C({uri:ee,text:q.text,lineNumber:q.lineNumber})})},V.isCancellationRequested)return{};try{const $e=await this.o.$startTextSearch(W,De??null,ve,re,V);return delete this.u[re],$e||{}}catch($e){throw delete this.u[re],$e}}$handleTextSearchResult(W,U){this.u[U]?.(W)}async save(W){const U=await this.o.$save(W,{saveAs:!1});return l.URI.revive(U)}async saveAs(W){const U=await this.o.$save(W,{saveAs:!0});return l.URI.revive(U)}saveAll(W){return this.o.$saveAll(W)}resolveProxy(W){return this.o.$resolveProxy(W)}loadCertificates(){return this.o.$loadCertificates()}get trusted(){return this.v}requestWorkspaceTrust(W){return this.o.$requestWorkspaceTrust(W)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(W,U){if(this.w.has(W))throw new Error(`A provider has already been registered for scheme ${W}`);this.w.set(W,U);const C=this.t.transformOutgoingScheme(W),O=this.A++;return this.o.$registerEditSessionIdentityProvider(O,C),(0,R.$Rc)(()=>{this.w.delete(W),this.o.$unregisterEditSessionIdentityProvider(O)})}async $getEditSessionIdentifier(W,U){this.h.info("Getting edit session identifier for workspaceFolder",W);const C=await this.resolveWorkspaceFolder(l.URI.revive(W));if(!C){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",C);const O=this.w.get(C.uri.scheme);if(this.h.info(`Provider for scheme ${C.uri.scheme} is defined: `,!!O),!O)return;const V=await O.provideEditSessionIdentity(C,U);if(this.h.info("Provider returned edit session identifier: ",V),!!V)return V}async $provideEditSessionIdentityMatch(W,U,C,O){this.h.info("Getting edit session identifier for workspaceFolder",W);const V=await this.resolveWorkspaceFolder(l.URI.revive(W));if(!V){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",V);const re=this.w.get(V.uri.scheme);if(this.h.info(`Provider for scheme ${V.uri.scheme} is defined: `,!!re),!re)return;const ue=await re.provideEditSessionIdentityMatch?.(U,C,O);if(this.h.info("Provider returned edit session identifier match result: ",ue),!!ue)return ue}getOnWillCreateEditSessionIdentityEvent(W){return(U,C,O)=>{const V=function(ue){U.call(C,ue)};return V.extension=W,this.B.event(V,void 0,O)}}async $onWillCreateEditSessionIdentity(W,U,C){const O=await this.resolveWorkspaceFolder(l.URI.revive(W));if(O===void 0)throw new Error("Unable to resolve workspace folder");await this.B.fireAsync({workspaceFolder:O},U,async(V,re)=>{const ue=Date.now();await Promise.resolve(V),Date.now()-ue>C&&this.h.warn("SLOW edit session create-participant",re.extension.identifier)}),U.isCancellationRequested}registerCanonicalUriProvider(W,U){if(this.C.has(W))throw new Error(`A provider has already been registered for scheme ${W}`);this.C.set(W,U);const C=this.t.transformOutgoingScheme(W),O=this.A++;return this.o.$registerCanonicalUriProvider(O,C),(0,R.$Rc)(()=>{this.C.delete(W),this.o.$unregisterCanonicalUriProvider(O)})}async provideCanonicalUri(W,U,C){const O=this.C.get(W.scheme);if(!O)return;const V=await O.provideCanonicalUri?.(l.URI.revive(W),U,C);if(V)return V}async $provideCanonicalUri(W,U,C){return this.provideCanonicalUri(l.URI.revive(W),{targetScheme:U},C)}};e.$2hc=A,e.$2hc=A=Ze([qe(0,a.$eO),qe(1,r.$uO),qe(2,n.$Jhc),qe(3,s.$yj),qe(4,p.$Zhc)],A),e.$3hc=(0,$.$ei)("IExtHostWorkspace");function T(G){let W,U;return G&&(typeof G=="string"?W=G:(W=G.pattern,U=l.URI.revive(G.baseUri))),{includePattern:W,folder:U}}}),define(Re[38],Ae([1,0,26,5,37,3,7,191,56,16,11,4,17,14,2]),function(fe,e,S,F,P,L,R,g,f,D,M,k,l,v,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6hc=e.$5hc=e.$4hc=void 0;function s(p,u){if(u){const o=u.split(".");let E=p;for(let w=0;E&&w<o.length;w++)E=E[o[w]];return E}}function c(p){return p instanceof $.URI}function t(p){return p&&p.uri instanceof $.URI&&p.languageId&&typeof p.languageId=="string"}function n(p){return p&&!p.uri&&p.languageId&&typeof p.languageId=="string"}function r(p){return p&&p.uri instanceof $.URI&&(!p.name||typeof p.name=="string")&&(!p.index||typeof p.index=="number")}function a(p){if(c(p))return{resource:p};if(t(p))return{resource:p.uri,overrideIdentifier:p.languageId};if(n(p))return{overrideIdentifier:p.languageId};if(r(p))return{resource:p.uri};if(p===null)return{resource:null}}let h=class{constructor(u,o,E){this.a=u.getProxy(L.$ZL.MainThreadConfiguration),this.c=o,this.b=E,this.d=new M.$dh,this.e=null}getConfigProvider(){return this.d.wait().then(u=>this.e)}$initializeConfiguration(u){this.e=new i(this.a,this.c,u,this.b),this.d.open()}$acceptConfigurationChanged(u,o){this.getConfigProvider().then(E=>E.$acceptConfigurationChanged(u,o))}};e.$4hc=h,e.$4hc=h=Ze([qe(0,l.$eO),qe(1,P.$3hc),qe(2,v.$yj)],h);class i{constructor(u,o,E,w){this.a=new F.$5d,this.b=u,this.f=w,this.c=o,this.e=g.$fo.parse(E),this.d=this.k(E.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(u,o){const E={data:this.e.toData(),workspace:this.c.workspace};this.e=g.$fo.parse(u),this.d=this.k(u.configurationScopes),this.a.fire(this.j(o,E))}getConfiguration(u,o,E){const w=a(o)||{},m=this.g(u?s(this.e.getValue(void 0,w,this.c.workspace),u):this.e.getValue(void 0,w,this.c.workspace));u&&this.h(u,w,E?.identifier);function I(y){if(y==null)return null;if(typeof y=="boolean")return y?2:5;switch(y){case R.ConfigurationTarget.Global:return 2;case R.ConfigurationTarget.Workspace:return 5;case R.ConfigurationTarget.WorkspaceFolder:return 6}}const d={has(y){return typeof s(m,y)<"u"},get:(y,b)=>{this.h(u?`${u}.${y}`:y,w,E?.identifier);let A=s(m,y);if(typeof A>"u")A=b;else{let T;const G=(W,U)=>{if((0,D.$Uf)(W)){let C;const O=()=>{T=T||(0,S.$Hn)(m),C=C||s(T,U)};return new Proxy(W,{get:(V,re)=>{if(typeof re=="string"&&re.toLowerCase()==="tojson")return O(),()=>C;if(T)return C=C||s(T,U),C[re];const ue=V[re];return typeof re=="string"?G(ue,`${U}.${re}`):ue},set:(V,re,ue)=>(O(),C&&(C[re]=ue),!0),deleteProperty:(V,re)=>(O(),C&&delete C[re],!0),defineProperty:(V,re,ue)=>(O(),C&&Object.defineProperty(C,re,ue),!0)})}return Array.isArray(W)?(0,S.$Hn)(W):W};A=G(A,y)}return A},update:(y,b,A,T)=>{y=u?`${u}.${y}`:y;const G=I(A);return b!==void 0?this.b.$updateConfigurationOption(G,y,b,w,T):this.b.$removeConfigurationOption(G,y,w,T)},inspect:y=>{y=u?`${u}.${y}`:y;const b=this.e.inspect(y,w,this.c.workspace);if(b)return{key:y,defaultValue:(0,S.$Hn)(b.policy?.value??b.default?.value),globalValue:(0,S.$Hn)(b.user?.value??b.application?.value),workspaceValue:(0,S.$Hn)(b.workspace?.value),workspaceFolderValue:(0,S.$Hn)(b.workspaceFolder?.value),defaultLanguageValue:(0,S.$Hn)(b.default?.override),globalLanguageValue:(0,S.$Hn)(b.user?.override??b.application?.override),workspaceLanguageValue:(0,S.$Hn)(b.workspace?.override),workspaceFolderLanguageValue:(0,S.$Hn)(b.workspaceFolder?.override),languageIds:(0,S.$Hn)(b.overrideIdentifiers)}}};return typeof m=="object"&&(0,S.$Kn)(d,m,!1),Object.freeze(d)}g(u){const o=E=>(0,D.$Uf)(E)?new Proxy(E,{get:(w,m)=>o(w[m]),set:(w,m,I)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(m)}' of object`)},deleteProperty:(w,m)=>{throw new Error(`TypeError: Cannot delete read only property '${String(m)}' of object`)},defineProperty:(w,m)=>{throw new Error(`TypeError: Cannot define property '${String(m)}' for a readonly object`)},setPrototypeOf:w=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):E;return o(u)}h(u,o,E){const w=f.$9n.test(u)?4:this.d.get(u),m=E?`[${E.value}] `:"";if(w===4){typeof o?.resource>"u"&&this.f.warn(`${m}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${u}', provide the URI of a resource or 'null' for any resource.`);return}if(w===3){o?.resource&&this.f.warn(`${m}Accessing a window scoped configuration for a resource is not expected. To associate '${u}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(u,o){const E=new g.$ho(u,o,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(w,m)=>E.affectsConfiguration(w,a(m))})}k(u){return u.reduce((o,E)=>(o.set(E[0],E[1]),o),new Map)}}e.$5hc=i,e.$6hc=(0,k.$ei)("IExtHostConfiguration")}),define(Re[116],Ae([1,0,2,11,5,3,7,37,67,38,22,66,17,27,4,12,21,14,78,223,15]),function(fe,e,S,F,P,L,R,g,f,D,M,k,l,v,$,s,c,t,n,r,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wjc=e.$vjc=e.$ujc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var h;(function(G){function W(C){if(C!=null)return C}G.from=W;function U(C){if(C!=null)return C}G.to=U})(h||(h={}));var i;(function(G){function W(C){if(C!=null)return C}G.from=W;function U(C){if(C!=null)return C}G.to=U})(i||(i={}));var p;(function(G){function W(C){if(C!=null)return C}G.from=W;function U(C){if(C!=null)return C}G.to=U})(p||(p={}));var u;(function(G){function W(O){if(O){const V=O;return V&&!!V.process}else return!1}G.is=W;function U(O){if(O==null)return;const V={process:O.process,args:O.args};return O.options&&(V.options=p.from(O.options)),V}G.from=U;function C(O){if(O!=null)return new R.$KM(O.process,O.args,O.options)}G.to=C})(u||(u={}));var o;(function(G){function W(C){if(C!=null)return C}G.from=W;function U(C){if(C!=null)return C}G.to=U})(o||(o={}));var E;(function(G){function W(O){if(O){const V=O;return V&&(!!V.commandLine||!!V.command)}else return!1}G.is=W;function U(O){if(O==null)return;const V={};return O.commandLine!==void 0?V.commandLine=O.commandLine:(V.command=O.command,V.args=O.args),O.options&&(V.options=o.from(O.options)),V}G.from=U;function C(O){if(!(O==null||O.command===void 0&&O.commandLine===void 0))return O.commandLine?new R.$LM(O.commandLine,O.options):new R.$LM(O.command,O.args?O.args:[],O.options)}G.to=C})(E||(E={}));var w;(function(G){function W(O){if(O){const V=O;return V&&V.customExecution==="customExecution"}else return!1}G.is=W;function U(O){return{customExecution:"customExecution"}}G.from=U;function C(O,V){return V.get(O)}G.to=C})(w||(e.CustomExecutionDTO=w={}));var m;(function(G){function W(U,C){let O;return U.scope!==void 0&&typeof U.scope!="number"?O=U.scope.uri:U.scope!==void 0&&typeof U.scope=="number"&&(U.scope===R.TaskScope.Workspace&&C&&C.workspaceFile?O=C.workspaceFile:O=r.$dH),{id:U._id,workspaceFolder:O}}G.from=W})(m||(e.TaskHandleDTO=m={}));var I;(function(G){function W(U){if(U!=null)return{_id:U.id,isDefault:U.isDefault}}G.from=W})(I||(I={}));var d;(function(G){function W(O,V){if(O==null)return[];const re=[];for(const ue of O){const ye=U(ue,V);ye&&re.push(ye)}return re}G.fromMany=W;function U(O,V){if(O==null)return;let re;O.execution instanceof R.$KM?re=u.from(O.execution):O.execution instanceof R.$LM?re=E.from(O.execution):O.execution&&O.execution instanceof R.$MM&&(re=w.from(O.execution));const ue=h.from(O.definition);let ye;return O.scope?typeof O.scope=="number"?ye=O.scope:ye=O.scope.uri:ye=R.TaskScope.Workspace,!ue||!ye?void 0:{_id:O._id,definition:ue,name:O.name,source:{extensionId:V.identifier.value,label:O.source,scope:ye},execution:re,isBackground:O.isBackground,group:I.from(O.group),presentationOptions:i.from(O.presentationOptions),problemMatchers:O.problemMatchers,hasDefinedMatchers:O.hasDefinedMatchers,runOptions:O.runOptions?O.runOptions:{reevaluateOnRerun:!0},detail:O.detail}}G.from=U;async function C(O,V,re){if(O==null)return;let ue;u.is(O.execution)?ue=u.to(O.execution):E.is(O.execution)?ue=E.to(O.execution):w.is(O.execution)&&(ue=w.to(O._id,re));const ye=h.to(O.definition);let De;if(O.source&&(O.source.scope!==void 0?typeof O.source.scope=="number"?De=O.source.scope:De=await V.resolveWorkspaceFolder(S.URI.revive(O.source.scope)):De=R.TaskScope.Workspace),!ye||!De)return;const he=new R.$NM(ye,De,O.name,O.source.label,ue,O.problemMatchers);return O.isBackground!==void 0&&(he.isBackground=O.isBackground),O.group!==void 0&&(he.group=R.$JM.from(O.group._id),he.group&&O.group.isDefault&&(he.group=new R.$JM(he.group.id,he.group.label),O.group.isDefault===!0&&(he.group.isDefault=O.group.isDefault))),O.presentationOptions&&(he.presentationOptions=i.to(O.presentationOptions)),O._id&&(he._id=O._id),O.detail&&(he.detail=O.detail),he}G.to=C})(d||(e.TaskDTO=d={}));var y;(function(G){function W(C){return C}G.from=W;function U(C){if(C)return Object.assign(Object.create(null),C)}G.to=U})(y||(y={}));class b{#e;constructor(W,U,C){this._id=U,this.a=C,this.#e=W}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(W){}fireDidEndProcess(W){}}let A=class{constructor(W,U,C,O,V,re,ue,ye){this.q=new P.$5d,this.r=new P.$5d,this.s=new P.$5d,this.u=new P.$5d,this.a=W.getProxy(L.$ZL.MainThreadTask),this.b=C,this.c=O,this.d=V,this.e=re,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=ue,this.g=ye,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(W,U,C){if(!C)return new R.$2L(()=>{});const O=this.x();return this.j.set(O,{type:U,provider:C,extension:W}),this.a.$registerTaskProvider(O,U),new R.$2L(()=>{this.j.delete(O),this.a.$unregisterTaskProvider(O)})}registerTaskSystem(W,U){this.a.$registerTaskSystem(W,U)}fetchTasks(W){return this.a.$fetchTasks(y.from(W)).then(async U=>{const C=[];for(const O of U){const V=await d.to(O,this.b,this.m);V&&C.push(V)}return C})}get taskExecutions(){const W=[];return this.k.forEach(U=>W.push(U)),W}terminateTask(W){if(!(W instanceof b))throw new Error("No valid task execution provided");return this.a.$terminateTask(W._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(W,U,C){const O=this.m.get(W.id);O&&(this.o.set(W.id,O),this.e.attachPtyToTerminal(U,await O.callback(C))),this.p=W.id,this.q.fire({execution:await this.z(W)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(W){if(!this.l.has(W.id))return;const U=await this.z(W);this.l.delete(W.id),this.k.delete(W.id),this.B(W),this.r.fire({execution:U})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(W){const U=await this.z(W.id);this.s.fire({execution:U,processId:W.processId})}get onDidEndTaskProcess(){return this.u.event}async $onDidEndTaskProcess(W){const U=await this.z(W.id);this.u.fire({execution:U,exitCode:W.exitCode})}$provideTasks(W,U){const C=this.j.get(W);if(!C)return Promise.reject(new Error("no handler found"));const O=[],V=(0,F.$9g)(()=>C.provider.provideTasks(M.CancellationToken.None)).then(re=>this.v(U,O,C,re));return new Promise(re=>{V.then(ue=>{Promise.all(O).then(()=>{re(ue)})})})}async $resolveTask(W,U){const C=this.j.get(W);if(!C)return Promise.reject(new Error("no handler found"));if(U.definition.type!==C.type)throw new Error(`Unexpected: Task of type [${U.definition.type}] cannot be resolved by provider of type [${C.type}].`);const O=await d.to(U,this.b,this.m);if(!O)throw new Error("Unexpected: Task cannot be resolved.");const V=await C.provider.resolveTask(O,M.CancellationToken.None);if(!V)return;this.A(V,C);const re=d.from(V,C.extension);if(!re)throw new Error("Unexpected: Task cannot be resolved.");if(V.definition!==O.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return w.is(re.execution)&&await this.y(re,V,!0),await this.w(re)}x(){return this.h++}async y(W,U,C){const O=await this.a.$createTaskId(W);!C&&!this.m.has(O)&&(this.n.add(O),this.o.set(O,U.execution)),this.m.set(O,U.execution)}async z(W,U){if(typeof W=="string"){const V=this.l.get(W);if(!V)throw new a.$bb("Unexpected: The specified task is missing an execution");return V}const C=this.l.get(W.id);if(C)return C;let O;return U?O=Promise.resolve(new b(this,W.id,U)):O=d.to(W.task,this.b,this.m).then(V=>{if(!V)throw new a.$bb("Unexpected: Task does not exist.");return new b(this,W.id,V)}),this.l.set(W.id,O),O.then(V=>(this.k.set(W.id,V),V))}A(W,U){W._deprecated&&this.g.report("Task.constructor",U.extension,"Use the Task constructor that takes a `scope` instead.")}B(W){this.o.get(W.id)&&this.o.delete(W.id),this.n.has(W.id)&&this.p!==W.id&&(this.m.delete(W.id),this.n.delete(W.id));const C=this.n.values();let O=C.next();for(;!O.done;)!this.o.has(O.value)&&this.p!==O.value&&(this.m.delete(O.value),this.n.delete(O.value)),O=C.next()}};e.$ujc=A,e.$ujc=A=Ze([qe(0,l.$eO),qe(1,v.$uO),qe(2,g.$3hc),qe(3,f.$pO),qe(4,D.$6hc),qe(5,k.$ric),qe(6,t.$yj),qe(7,n.$Fhc)],A);let T=class extends A{constructor(W,U,C,O,V,re,ue,ye){super(W,U,C,O,V,re,ue,ye),this.registerTaskSystem(s.Schemas.vscodeRemote,{scheme:s.Schemas.vscodeRemote,authority:"",platform:c.$h(0)})}async executeTask(W,U){if(!U.execution)throw new Error("Tasks to execute must include an execution");const C=d.from(U,W);if(C===void 0)throw new Error("Task is not valid");if(w.is(C.execution))await this.y(C,U,!1);else throw new a.$_;const O=await this.z(await this.a.$getTaskExecution(C),U);return this.a.$executeTask(C).catch(V=>{throw new Error(V)}),O}v(W,U,C,O){const V=[];if(O)for(const re of O){if(this.A(re,C),!re.definition||!W[re.definition.type]){const ye=re.source?re.source:"No task source";this.f.warn(`The task [${ye}, ${re.name}] uses an undefined task type. The task will be ignored in the future.`)}const ue=d.from(re,C.extension);ue&&w.is(ue.execution)?(V.push(ue),U.push(this.y(ue,re,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:V,extension:C.extension}}async w(W){if(w.is(W.execution))return W;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(W,U){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(W,U,C){}};e.$vjc=T,e.$vjc=T=Ze([qe(0,l.$eO),qe(1,v.$uO),qe(2,g.$3hc),qe(3,f.$pO),qe(4,D.$6hc),qe(5,k.$ric),qe(6,t.$yj),qe(7,n.$Fhc)],T),e.$wjc=(0,$.$ei)("IExtHostTask")}),define(Re[285],Ae([1,0,44,29]),function(fe,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MK=e.$LK=e.$KK=void 0;function P(R){return"cellResults"in R}e.$KK=P,e.$LK="rawCell#";function L(R,g){let f=-1;const D=[];let M=[];return R.forEach(l=>{l.range.startLineNumber!==f&&M.length>0&&(D.push([...M]),M=[]),M.push(l),f=l.range.endLineNumber}),M.length>0&&D.push([...M]),D.map(l=>{const v=[],$=l[0].range.startLineNumber,s=l[l.length-1].range.endLineNumber;for(let c=$;c<=s;c++)v.push(g.getLineContent(c));return new S.$oK(v.join(`
`)+`
`,l.map(c=>new F.$6s(c.range.startLineNumber-1,c.range.startColumn-1,c.range.endLineNumber-1,c.range.endColumn-1)))})}e.$MK=L}),define(Re[286],Ae([1,0,164,24,5,6,28,13,16,2,42,74,3,31,8,7,49,261,110,26,12,213,285,283]),function(fe,e,S,F,P,L,R,g,f,D,M,k,l,v,$,s,c,t,n,r,a,h,i,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9ic=void 0;class u{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(E=>E.apiEditor)}constructor(E,w,m,I,d,y){this.q=m,this.r=I,this.s=d,this.t=y,this.f=new Map,this.g=new R.$Ac,this.h=new Map,this.j=new P.$5d,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new P.$5d,this.onDidOpenNotebookDocument=this.m.event,this.n=new P.$5d,this.onDidCloseNotebookDocument=this.n.event,this.o=new P.$5d,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new k.$Dhc("NotebookCellStatusBarCache"),this.w=0,this.x=new Map,this.b=E.getProxy(l.$ZL.MainThreadNotebook),this.c=E.getProxy(l.$ZL.MainThreadNotebookDocuments),this.d=E.getProxy(l.$ZL.MainThreadNotebookEditors),this.i=w.converter,w.registerArgumentProcessor({processArgument:b=>{if(b&&b.$mid===13){const A=b.notebookEditor?.notebookUri,T=b.cell.handle,W=this.g.get(A)?.getCell(T);if(W)return W.apiCell}if(b&&b.$mid===14){const A=b.uri,T=this.g.get(A);if(T)return T.apiNotebook}return b}}),u.B(w)}getEditorById(E){const w=this.h.get(E);if(!w)throw new Error(`unknown text editor: ${E}. known editors: ${[...this.h.keys()]} `);return w}getIdByEditor(E){for(const[w,m]of this.h)if(m.apiEditor===E)return w}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(E,w){const m=this.g.get(E);if(!m&&!w)throw new Error(`NO notebook document for '${E}'`);return m}static u(E,w){if(!w)return;const m=w.filenamePattern.map(I=>$.NotebookExclusiveDocumentPattern.from(I)).filter(I=>I!==void 0);if(w.filenamePattern&&!m){console.warn(`Notebook content provider view options file name pattern is invalid ${w.filenamePattern}`);return}return{extension:E.identifier,providerDisplayName:E.displayName||E.name,displayName:w.displayName,filenamePattern:m,exclusive:w.exclusive||!1}}registerNotebookCellStatusBarItemProvider(E,w,m){const I=u.a++,d=typeof m.onDidChangeCellStatusBarItems=="function"?u.a++:void 0;this.f.set(I,m),this.b.$registerNotebookCellStatusBarItemProvider(I,d,w);let y;return d!==void 0&&(y=m.onDidChangeCellStatusBarItems(b=>this.b.$emitCellStatusBarEvent(d))),new s.$2L(()=>{this.f.delete(I),this.b.$unregisterNotebookCellStatusBarItemProvider(I,d),y?.dispose()})}async createNotebookDocument(E){const w=await this.c.$tryCreateNotebook({viewType:E.viewType,content:E.content&&$.NotebookData.from(E.content)});return D.URI.revive(w)}async openNotebookDocument(E){const w=this.g.get(E);if(w)return w.apiNotebook;const m=await this.c.$tryOpenNotebook(E),I=this.g.get(D.URI.revive(m));return(0,f.$4f)(I?.apiNotebook)}async showNotebookDocument(E,w){D.URI.isUri(E)&&(E=await this.openNotebookDocument(E));let m;typeof w=="object"?m={position:$.ViewColumn.from(w.viewColumn),preserveFocus:w.preserveFocus,selections:w.selections&&w.selections.map($.NotebookRange.from),pinned:typeof w.preview=="boolean"?!w.preview:void 0}:m={preserveFocus:!1};const I=await this.d.$tryShowNotebookDocument(E.uri,E.notebookType,m),d=I&&this.h.get(I)?.apiEditor;if(d)return d;throw I?new Error(`Could NOT open editor for "${E.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${E.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(E,w,m,I){const d=this.f.get(E),y=D.URI.revive(w),b=this.g.get(y);if(!b||!d)return;const A=b.getCellFromIndex(m);if(!A)return;const T=await d.provideCellStatusBarItems(A.apiCell,I);if(!T)return;const G=new L.$Sc,W=this.p.add([G]),C=(Array.isArray(T)?T:[T]).map(O=>$.NotebookStatusBarItem.from(O,this.i,G));return{cacheId:W,items:C}}$releaseNotebookCellStatusBarItems(E){this.p.delete(E)}registerNotebookSerializer(E,w,m,I,d){if((0,g.$Se)(w))throw new Error("viewType cannot be empty or just whitespace");const y=this.w++;return this.x.set(y,{viewType:w,serializer:m,options:I}),this.b.$registerNotebookSerializer(y,{id:E.identifier,location:E.extensionLocation},w,$.NotebookDocumentContentOptions.from(I),u.u(E,d)),(0,L.$Rc)(()=>{this.b.$unregisterNotebookSerializer(y)})}async $dataToNotebook(E,w,m){const I=this.x.get(E);if(!I)throw new Error("NO serializer found");const d=await I.serializer.deserializeNotebook(w.buffer,m);return new c.$6v($.NotebookData.from(d))}async $notebookToData(E,w,m){const I=this.x.get(E);if(!I)throw new Error("NO serializer found");const d=await I.serializer.serializeNotebook($.NotebookData.to(w.value),m);return F.$se.wrap(d)}async $saveNotebook(E,w,m,I,d){const y=D.URI.revive(w),b=this.x.get(E);if(!b)throw new Error("NO serializer found");const A=this.g.get(y);if(!A)throw new Error("Document NOT found");if(A.versionId!==m)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(y.scheme))throw new M.$Wk((0,S.localize)(0,null,this.z(y)),6);await this.y(y,I);const T={metadata:(0,r.$Pn)(A.apiNotebook.metadata,O=>!(b.options?.transientDocumentMetadata??{})[O]),cells:[]};for(const O of A.apiNotebook.getCells()){const V=new s.$qN(O.kind,O.document.getText(),O.document.languageId,O.mime,b.options?.transientOutputs?[]:[...O.outputs],O.metadata,O.executionSummary);V.metadata=(0,r.$Pn)(O.metadata,re=>!(b.options?.transientCellMetadata??{})[re]),T.cells.push(V)}const G=await b.serializer.serializeNotebook(T,d);await this.s.value.writeFile(y,G);const W=this.s.getFileSystemProviderExtUri(y.scheme),U=await this.s.value.stat(y);return{name:W.basename(y),isFile:(U.type&M.FileType.File)!==0,isDirectory:(U.type&M.FileType.Directory)!==0,isSymbolicLink:(U.type&M.FileType.SymbolicLink)!==0,mtime:U.mtime,ctime:U.ctime,size:U.size,readonly:!!((U.permissions??0)&M.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(y.scheme),locked:!!((U.permissions??0)&M.FilePermission.Locked),etag:M.$8k({mtime:U.mtime,size:U.size}),children:void 0}}async $searchInNotebooks(E,w,m,I,d){const y=this.x.get(E)?.serializer;if(!y)return{limitHit:!1,results:[]};const b=new R.$Bc;await(async(U,C,O)=>{await Promise.all(U.map(async V=>await Promise.all(V.filenamePatterns.map(re=>{const ue={_reason:O._reason,folderQueries:O.folderQueries,includePattern:O.includePattern,excludePattern:O.excludePattern,maxResults:O.maxResults,type:1,filePattern:re};return this.t.doInternalFileSearchWithCustomCallback(ue,C,ye=>{ye.forEach(De=>{b.has(De)||I.some(ve=>V.isFromSettings&&!ve.isFromSettings?!1:ve.filenamePatterns.some(se=>(0,p.$1eb)(se,De)))||b.add(De)})}).catch(ye=>{if(ye.code==="ENOENT")return console.warn("Could not find notebook search results, ignoring notebook results."),{limitHit:!1,messages:[]};throw ye})}))))})(m,d,w);const T=new R.$Ac;let G=!1;const W=Array.from(b).map(async U=>{const C=[];try{if(d.isCancellationRequested)return;if(w.maxResults&&[...T.values()].reduce((ue,ye)=>ue+ye.cellResults.length,0)>w.maxResults){G=!0;return}const O=[],V=this.g.get(U);if(V)V.apiNotebook.getCells().forEach(ye=>O.push({input:ye.document.getText(),outputs:ye.outputs.flatMap(De=>De.items.map(he=>he.data.toString()))}));else{const ue=await this.s.value.readFile(U),ye=F.$se.fromString(ue.toString()),De=await y.deserializeNotebook(ye.buffer,d);if(d.isCancellationRequested)return;$.NotebookData.from(De).cells.forEach(ve=>O.push({input:ve.source,outputs:ve.outputs.flatMap(se=>se.items.map($e=>$e.valueBytes.toString()))}))}if(d.isCancellationRequested)return;O.forEach((ue,ye)=>{const De=w.contentPattern.pattern,he=new h.$mTb(ue.input,void 0,ue.outputs),ve=he.findInInputs(De),se=he.findInOutputs(De),$e=se.flatMap(ee=>(0,i.$MK)(ee.matches,ee.textBuffer)).map((ee,Q)=>(ee.webviewIndex=Q,ee));if(ve.length>0||se.length>0){const ee={index:ye,contentResults:(0,i.$MK)(ve,he.inputTextBuffer),webviewResults:$e};C.push(ee)}});const re={resource:U,cellResults:C};T.set(U,re);return}catch{return}});return await Promise.all(W),{limitHit:G,results:[...T.values()]}}async y(E,w){const m=await this.s.value.stat(E);if(typeof w?.mtime=="number"&&typeof w.etag=="string"&&w.etag!==M.$7k&&typeof m.mtime=="number"&&typeof m.size=="number"&&w.mtime<m.mtime&&w.etag!==M.$8k({mtime:w.mtime,size:m.size}))throw new M.$Wk((0,S.localize)(1,null),3,w)}z(E){return E.scheme===a.Schemas.file?E.fsPath:E.toString()}A(E,w,m){if(this.h.has(w))throw new Error(`editor with id ALREADY EXSIST: ${w}`);const I=new n.$Zic(w,this.d,E,m.visibleRanges.map($.NotebookRange.to),m.selections.map($.NotebookRange.to),typeof m.viewColumn=="number"?$.ViewColumn.to(m.viewColumn):void 0);this.h.set(w,I)}$acceptDocumentAndEditorsDelta(E){if(E.value.removedDocuments)for(const m of E.value.removedDocuments){const I=D.URI.revive(m),d=this.g.get(I);d&&(d.dispose(),this.g.delete(I),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:d.apiNotebook.getCells().map(y=>y.document.uri)}),this.n.fire(d.apiNotebook));for(const y of this.h.values())y.notebookData.uri.toString()===I.toString()&&this.h.delete(y.id)}if(E.value.addedDocuments){const m=[];for(const I of E.value.addedDocuments){const d=D.URI.revive(I.uri);if(this.g.has(d))throw new Error(`adding EXISTING notebook ${d} `);const y=new t.$Yic(this.c,this.q,this.r,d,I);m.push(...I.cells.map(b=>t.$Xic.asModelAddData(b))),this.g.get(d)?.dispose(),this.g.set(d,y),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:m}),this.m.fire(y.apiNotebook)}}if(E.value.addedEditors)for(const m of E.value.addedEditors){if(this.h.has(m.id))return;const I=D.URI.revive(m.documentUri),d=this.g.get(I);d&&this.A(d,m.id,m)}const w=[];if(E.value.removedEditors)for(const m of E.value.removedEditors){const I=this.h.get(m);I&&(this.h.delete(m),this.k?.id===I.id&&(this.k=void 0),w.push(I))}if(E.value.visibleEditors){this.l=E.value.visibleEditors.map(I=>this.h.get(I)).filter(I=>!!I);const m=new Set;this.l.forEach(I=>m.add(I.id));for(const I of this.h.values()){const d=m.has(I.id);I._acceptVisibility(d)}this.l=[...this.h.values()].map(I=>I).filter(I=>I.visible),this.o.fire(this.visibleNotebookEditors)}E.value.newActiveEditor===null?this.k=void 0:E.value.newActiveEditor&&(this.h.get(E.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${E.value.newActiveEditor}`),this.k=this.h.get(E.value.newActiveEditor)),E.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static B(E){const w=v.$CO.String.with("notebookType","A notebook type"),m=new v.$EO("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[w,new v.$CO("data","Bytes to convert to data",d=>d instanceof Uint8Array,d=>F.$se.wrap(d))],new v.$DO("Notebook Data",d=>$.NotebookData.to(d.value))),I=new v.$EO("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[w,new v.$CO("NotebookData","Notebook data to convert to bytes",d=>!0,d=>new c.$6v($.NotebookData.from(d)))],new v.$DO("Bytes",d=>d.buffer));E.registerApiCommand(m),E.registerApiCommand(I)}}e.$9ic=u}),define(Re[287],Ae([1,0,19,22,34,35,25,64,44]),function(fe,e,S,F,P,L,R,g,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1ic=void 0;class D{constructor(l,v,$){this.k=l,this.l=v,this.o=$,this.e=!1,this.f=0,this.g=!1,this.a=l.filePattern,this.b=l.includePattern&&L.$Xj(l.includePattern),this.c=l.maxResults||void 0,this.d=l.exists,this.h=new Set,this.j=l.excludePattern&&L.$Xj(l.excludePattern)}cancel(){this.g=!0,this.h.forEach(l=>l.cancel()),this.h=new Set}search(l){const v=this.k.folderQueries||[];return new Promise(($,s)=>{const c=t=>{this.f++,l(t)};if(this.g)return $({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(t=>{const n=t.toString(),r=S.$nc(n);this.j&&this.j(n,r)||this.v(c,{base:t,basename:r})}),Promise.all(v.map(t=>this.p(t,c))).then(t=>{$({limitHit:this.e,stats:t[0]||void 0})},t=>{s(new Error((0,P.$2i)(t)))})})}async p(l,v){const $=new F.$ce,s=this.q(l),c=this.r(),t=new f.$CK(this.k,l),n=!t.hasSiblingExcludeClauses();let r;try{this.h.add($),r=g.$1d.create();const a=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},s,$.token),h=r.elapsed(),i=g.$1d.create();return this.g&&!this.e||(a&&a.forEach(p=>{const u=S.$gc.relative(l.folder.path,p.path);if(n){const o=S.$nc(p.path);this.v(v,{base:l.folder,relativePath:u,basename:o});return}this.s(c,l.folder,u,v)}),this.g&&!this.e)?null:(this.u(c,t,v),{providerTime:h,postProcessTime:i.elapsed()})}finally{$.dispose(),this.h.delete($)}}q(l){const v=(0,f.$BK)(this.k.includePattern,l.includePattern),$=(0,f.$BK)(this.k.excludePattern,l.excludePattern);return{folder:l.folder,excludes:$,includes:v,useIgnoreFiles:!l.disregardIgnoreFiles,useGlobalIgnoreFiles:!l.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!l.disregardParentIgnoreFiles,followSymlinks:!l.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const l={rootEntries:[],pathToEntries:Object.create(null)};return l.pathToEntries["."]=l.rootEntries,l}s({pathToEntries:l},v,$,s){if($===this.a){const t=S.$nc(this.a);this.v(s,{base:v,relativePath:this.a,basename:t})}function c(t){const n=S.$nc(t),r=S.$mc(t);let a=l[r];a||(a=l[r]=[],c(r)),a.push({base:v,relativePath:t,basename:n})}c($)}u({rootEntries:l,pathToEntries:v},$,s){const c=this,t=this.a;function n(r){const a=(0,f.$EK)(()=>r.map(h=>h.basename));for(let h=0,i=r.length;h<i;h++){const p=r[h],{relativePath:u,basename:o}=p;if($.matchesExcludesSync(u,o,t!==o?a:void 0))continue;const E=v[u];if(E)n(E);else{if(u===t)continue;c.v(s,p)}if(c.e)break}}n(l)}v(l,v){(!this.b||v.relativePath&&this.b(v.relativePath,v.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||l(v))}}class M{constructor(){this.b=new Map}static{this.a=512}fileSearch(l,v,$,s){const c=this.c(l.cacheKey),t=new D(l,v,c&&c.token);let n=0;const r=a=>{n+=a.length,$(a.map(h=>this.d(h)))};return this.e(t,M.a,r,s).then(a=>({limitHit:a.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:n,detailStats:a.stats}}))}clearCache(l){this.c(l)?.cancel()}c(l){if(l)return this.b.has(l)||this.b.set(l,new F.$ce),this.b.get(l)}d(l){return l.relativePath?{resource:R.$Rg(l.base,l.relativePath)}:{resource:l.base}}e(l,v,$,s){const c=s.onCancellationRequested(()=>{l.cancel()}),t=r=>{r&&(n.push(r),v>0&&n.length>=v&&($(n),n=[]))};let n=[];return l.search(t).then(r=>(n.length&&$(n),c.dispose(),r),r=>(n.length&&$(n),c.dispose(),Promise.reject(r)))}}e.$1ic=M}),define(Re[288],Ae([1,0,18,256,35,94,28,12,19,25,13,16,2,93,181,46,14,47,105,284,44]),function(fe,e,S,F,P,L,R,g,f,D,M,k,l,v,$,s,c,t,n,r,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EL=e.$DL=void 0;let h=class{constructor(y,b,A,T,G){this.a=y,this.b=b,this.c=A,this.d=T,this.e=G}text(y,b,A={}){y=this.f(y,A);const T=this.a.getValue(),G=b&&b.some(U=>!this.a.getValue({resource:U}).search.useRipgrep);return{...this.h(b?.map(t.$zi),A),type:2,contentPattern:y,previewOptions:A.previewOptions,maxFileSize:A.maxFileSize,usePCRE2:T.search.usePCRE2||G||!1,beforeContext:A.beforeContext,afterContext:A.afterContext,userDisabledExcludesAndIgnoreFiles:A.disregardExcludeSettings&&A.disregardIgnoreFiles}}f(y,b){const A=this.a.getValue();y.isRegExp&&(y.pattern=y.pattern.replace(/\r?\n/g,"\\n"));const T={...y,wordSeparators:A.editor.wordSeparators};return this.j(y,b)&&(T.isCaseSensitive=!0),this.k(y)&&(T.isMultiline=!0),b.notebookSearchConfig?.includeMarkupInput&&(T.notebookInfo||(T.notebookInfo={}),T.notebookInfo.isInNotebookMarkdownInput=b.notebookSearchConfig.includeMarkupInput),b.notebookSearchConfig?.includeMarkupPreview&&(T.notebookInfo||(T.notebookInfo={}),T.notebookInfo.isInNotebookMarkdownPreview=b.notebookSearchConfig.includeMarkupPreview),b.notebookSearchConfig?.includeCodeInput&&(T.notebookInfo||(T.notebookInfo={}),T.notebookInfo.isInNotebookCellInput=b.notebookSearchConfig.includeCodeInput),b.notebookSearchConfig?.includeOutput&&(T.notebookInfo||(T.notebookInfo={}),T.notebookInfo.isInNotebookCellOutput=b.notebookSearchConfig.includeOutput),T}file(y,b={}){return{...this.h(y,b),type:1,filePattern:b.filePattern?b.filePattern.trim():b.filePattern,exists:b.exists,sortByScore:b.sortByScore,cacheKey:b.cacheKey,shouldGlobMatchFilePattern:b.shouldGlobSearch}}g(y,b){return y?(y=Array.isArray(y)?y.map(E):E(y),b?this.parseSearchPaths(y):{pattern:p(...Array.isArray(y)?y:[y])}):{}}h(y=[],b={}){const A=this.g(b.includePattern,b.expandPatterns),T=this.g(b.excludePattern,b.expandPatterns),G=y.length>1,W=(A.searchPaths&&A.searchPaths.length?A.searchPaths.map(O=>this.q(O,b,T)):y.map(O=>this.r(O,b,T,G))).filter(O=>!!O),U={_reason:b._reason,folderQueries:W,usingSearchPaths:!!(A.searchPaths&&A.searchPaths.length),extraFileResources:b.extraFileResources,excludePattern:T.pattern,includePattern:A.pattern,onlyOpenEditors:b.onlyOpenEditors,maxResults:b.maxResults};if(b.onlyOpenEditors){const O=S.$Hb(S.$Rb(this.c.groups.map(ue=>ue.editors.map(ye=>ye.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(O));const V=O.filter(ue=>(0,a.$sK)(U,ue.fsPath)),re=this.i(V);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(re)),{...U,...re}}const C=b.extraFileResources&&b.extraFileResources.filter(O=>(0,a.$sK)(U,O.fsPath));return U.extraFileResources=C&&C.length?C:void 0,U}i(y){const b=[],A=new R.$Ac,T={};let G=!1;return y.forEach(W=>{if(W.scheme===g.Schemas.walkThrough)return;if((0,D.$Vg)(W)){const C=this.b.getWorkspaceFolder(W)?.uri??W.with({path:f.$mc(W.fsPath)});let O=A.get(C);O||(G=!0,O={folder:C,includePattern:{}},b.push(O),A.set(C,O));const V=f.$lc(C.fsPath,W.fsPath);(0,k.$4f)(O.includePattern)[V.replace(/\\/g,"/")]=!0}else W.fsPath&&(G=!0,T[W.fsPath]=!0)}),{folderQueries:b,includePattern:T,usingSearchPaths:!0,excludePattern:G?void 0:{"**/*":!0}}}j(y,b){if(b.isSmartCase){if(y.isRegExp){if(M.$Jf(y.pattern,!0))return!0}else if(M.$Jf(y.pattern))return!0}return!!y.isCaseSensitive}k(y){return y.isMultiline||y.isRegExp&&(0,v.$dC)(y.pattern)||y.pattern.indexOf(`
`)>=0?!0:!!y.isMultiline}parseSearchPaths(y){const b=re=>f.$ic(re)||/^\.\.?([\/\\]|$)/.test(re),T=(Array.isArray(y)?y:u(y)).map(re=>{const ue=this.e.resolvedUserHome;return ue?(0,L.$$v)(re,ue.scheme===g.Schemas.file?ue.fsPath:ue.path):re}),G=F.$K(T,re=>b(re)?"searchPaths":"exprSegments"),W=(G.exprSegments||[]).map(re=>M.$4e(re,"/")).map(re=>M.$4e(re,"\\")).map(re=>(re[0]==="."&&(re="*"+re),o(re))),U={},C=this.m(G.searchPaths||[]);C&&C.length&&(U.searchPaths=C);const O=S.$Rb(W),V=p(...O);return V&&(U.pattern=V),U}l(y,b){return b.disregardExcludeSettings?void 0:(0,a.$rK)(y,!b.disregardSearchExcludeSettings)}m(y){if(!y||!y.length)return[];const b=y.flatMap(T=>{let{pathPortion:G,globPortion:W}=i(T);return W&&(W=w(W)),this.n(G).flatMap(C=>this.o(C,W))}),A=new Map;return b.forEach(T=>{const G=T.searchPath.toString(),W=A.get(G);W?T.pattern&&(W.pattern=W.pattern||{},W.pattern[T.pattern]=!0):A.set(G,{searchPath:T.searchPath,pattern:T.pattern?p(T.pattern):void 0})}),Array.from(A.values())}n(y){if(f.$ic(y)){const b=this.b.getWorkspace().folders;return b[0]&&b[0].uri.scheme!==g.Schemas.file?[{searchPath:b[0].uri.with({path:y})}]:[{searchPath:l.URI.file(f.$hc(y))}]}if(this.b.getWorkbenchState()===2){const b=this.b.getWorkspace().folders[0].uri;if(y=E(y),y.startsWith("../")||y===".."){const T=f.$gc.resolve(b.path,y);return[{searchPath:b.with({path:T})}]}const A=w(y);return[{searchPath:b,pattern:A}]}else{if(y==="./"||y===".\\")return[];{const b=y.replace(/^\.[\/\\]/,""),T=this.b.getWorkspace().folders.map(G=>{const W=b.match(new RegExp(`^${M.$Xe(G.name)}(?:/(.*)|$)`));return W?{match:W,folder:G}:null}).filter(k.$1f);if(T.length)return T.map(G=>{const W=G.match[1];return{searchPath:G.folder.uri,pattern:W&&w(W)}});{const G=y.match(/\.[\/\\](.+)[\/\\]?/),W=G?G[1]:y,U=$.localize(0,null,W);throw new Error(U)}}}}o(y,b){const A=y.pattern&&b?`${y.pattern}/${b}`:y.pattern||b,T=[{searchPath:y.searchPath,pattern:A}];return A&&!A.endsWith("**")&&T.push({searchPath:y.searchPath,pattern:A+"/**"}),T}q(y,b,A){const T=this.r((0,t.$zi)(y.searchPath),b,A,!1);return T?{...T,includePattern:y.pattern}:null}r(y,b,A,T){let G;const W=l.URI.isUri(y)?y:y.uri;if(A.searchPaths){const re=A.searchPaths.filter(ue=>(0,D.$Kg)(ue.searchPath,W))[0];if(re&&!re.pattern)return null;re&&(G=re.pattern)}const U=this.a.getValue({resource:W}),O={...this.l(U,b)||{},...G||{}},V=l.URI.isUri(y)?(0,D.$Og)(y):y.name;return{folder:W,folderName:T?V:void 0,excludePattern:Object.keys(O).length>0?O:void 0,fileEncoding:U.files&&U.files.encoding,disregardIgnoreFiles:typeof b.disregardIgnoreFiles=="boolean"?b.disregardIgnoreFiles:!U.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof b.disregardGlobalIgnoreFiles=="boolean"?b.disregardGlobalIgnoreFiles:!U.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof b.disregardParentIgnoreFiles=="boolean"?b.disregardParentIgnoreFiles:!U.search.useParentIgnoreFiles,ignoreSymlinks:typeof b.ignoreSymlinks=="boolean"?b.ignoreSymlinks:!U.search.followSymlinks}}};e.$DL=h,e.$DL=h=Ze([qe(0,s.$Ki),qe(1,t.$ni),qe(2,n.$kD),qe(3,c.$yj),qe(4,r.$BL)],h);function i(d){const y=d.match(/[\*\{\}\(\)\[\]\?]/);if(y){const b=y.index,A=d.substr(0,b).match(/[/|\\][^/\\]*$/);if(A){let T=d.substr(0,A.index);return T.match(/[/\\]/)||(T+="/"),{pathPortion:T,globPortion:d.substr((A.index||0)+1)}}}return{pathPortion:d}}function p(...d){return d.length?d.reduce((y,b)=>(y[b]=!0,y),Object.create(null)):void 0}function u(d){return P.$Vj(d,",").map(y=>y.trim()).filter(y=>!!y.length)}function o(d){return[`**/${d}/**`,`**/${d}`].map(b=>b.replace(/\*\*\/\*\*/g,"**"))}function E(d){return d.replace(/\\/g,"/")}function w(d){return E(d).replace(/^\.\//,"").replace(/\/+$/g,"")}function m(d){return d.replace(/([?*[\]])/g,"[$1]")}function I(d,y){d=S.$Mb(d,T=>T.toString());const b=[],A=y.getWorkspace();return d&&d.forEach(T=>{let G;if(y.getWorkbenchState()===2)G=(0,D.$Tg)(A.folders[0].uri,T),G&&G!=="."&&(G="./"+G);else{const W=y.getWorkspaceFolder(T);if(W){const U=W.name;if(A.folders.filter(O=>O.name===U).length===1){const O=(0,D.$Tg)(W.uri,T);O===""?G=`./${W.name}`:G=`./${W.name}/${O}`}else G=T.fsPath}}G&&b.push(m(G))}),b}e.$EL=I}),define(Re[289],Ae([1,0,25,2,22,15,4,288,44,47,11]),function(fe,e,S,F,P,L,R,g,f,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nub=e.$mub=void 0;const k=7e3;function l(c,t){const n=t.activationEvents;if(!n)return Promise.resolve(void 0);const r=[],a=[];for(const E of n)if(/^workspaceContains:/.test(E)){const w=E.substr(18);w.indexOf("*")>=0||w.indexOf("?")>=0||c.forceUsingSearch?a.push(w):r.push(w)}if(r.length===0&&a.length===0)return Promise.resolve(void 0);const{promise:h,resolve:i}=(0,M.$0g)(),p=E=>i({activationEvent:E}),u=Promise.all(r.map(E=>v(c,E,p))).then(()=>{}),o=$(c,t.identifier,a,p);return Promise.all([u,o]).then(()=>{i(void 0)}),h}e.$mub=l;async function v(c,t,n){for(const r of c.folders)if(await c.exists(S.$Rg(F.URI.revive(r),t))){n(`workspaceContains:${t}`);return}}async function $(c,t,n,r){if(n.length===0)return Promise.resolve(void 0);const a=new P.$ce,h=c.checkExists(c.folders,n,a.token),i=setTimeout(async()=>{a.cancel(),c.logService.info(`Not activating extension '${t.value}': Timed out while searching for 'workspaceContains' pattern ${n.join(",")}`)},k);let p=!1;try{p=await h}catch(u){L.$4(u)||L.$1(u)}a.dispose(),clearTimeout(i),p&&r(`workspaceContains:${n.join(",")}`)}function s(c,t,n,r){const a=c.get(R.$di),h=c.get(f.$jK),p=a.createInstance(g.$DL).file(t.map(u=>(0,D.$zi)(F.URI.revive(u))),{_reason:"checkExists",includePattern:n,exists:!0});return h.fileSearch(p,r).then(u=>!!u.limitHit,u=>L.$4(u)?!1:Promise.reject(u))}e.$nub=s}),define(Re[39],Ae([1,0,161,19,87,25,11,6,50,2,14,3,38,219,82,37,23,106,15,20,24,202,7,100,4,27,84,17,71,85,66,5,289,81,204,12,79,64,21,80]),function(fe,e,S,F,P,L,R,g,f,D,M,k,l,v,$,s,c,t,n,r,a,h,i,p,u,o,E,w,m,I,d,y,b,A,T,G,W,U,C,O){"use strict";var V;Object.defineProperty(e,"__esModule",{value:!0}),e.$Gic=e.$Fic=e.$Eic=e.$Dic=e.$Cic=void 0,e.$Cic=(0,u.$ei)("IHostUtils");let re=V=class extends g.$Tc{constructor(Q,q,ne,Se,Te,Ce,we,ge,J,x,le,de){super(),this.X=de,this.a=this.B(new y.$5d),this.onDidChangeRemoteConnectionData=this.a.event,this.U=!1,this.c=q,this.g=ne,this.f=we,this.j=Se,this.m=Te,this.s=Ce,this.t=J,this.u=x,this.w=le,this.y=this.g.getProxy(k.$ZL.MainThreadWorkspace),this.z=this.g.getProxy(k.$ZL.MainThreadTelemetry),this.C=this.g.getProxy(k.$ZL.MainThreadExtensionService),this.D=new R.$dh,this.F=new R.$dh,this.G=new R.$dh,this.H=new R.$dh,this.I=new $e(this.f.extensions.activationEvents),this.L=new t.$D9b(this.I,this.f.extensions.allExtensions);const Pe=new r.$xm(this.f.extensions.myExtensions);this.J=new t.$D9b(this.I,ve(this.L,Pe)),C.$t&&(this.s.info(`Creating extension host with the following global extensions: ${De(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${De(this.J)}`)),this.M=new $.$nic(this.g,this.s),this.N=new A.$vic(this.g),this.O=ge,this.h=Q.createChild(new m.$ci([$.$oic,this.M],[A.$wic,this.N])),this.P=this.B(new v.$mic(this.J,this.L,{onExtensionActivationError:(me,Ie,Me)=>{this.C.$onExtensionActivationError(me,n.$3(Ie),Me)},actualActivateExtension:async(me,Ie)=>{if(t.$D9b.isHostExtension(me,this.J,this.L))return await this.C.$activateExtension(me,Ie),new v.$lic;const Me=this.J.getExtensionDescription(me);return this.db(Me,Ie)}},this.s)),this.Q=null,this.R=Object.create(null),this.S=!1,this.W=this.f.remote.connectionData}getRemoteConnectionData(){return this.W}async initialize(){try{await this.tb(),this.D.open(),await this.j.waitForInitializeCall(),P.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.rb()}catch(Q){n.$1(Q)}}async Y(){this.O.onWillDeactivateAll();let Q=[];try{Q=this.J.getAllExtensionDescriptions().map(Te=>Te.identifier).filter(Te=>this.isActivated(Te)).map(Te=>this.cb(Te))}catch{}await Promise.all(Q)}terminate(Q,q=0){if(this.U)return;this.U=!0,this.s.info(`Extension host terminating: ${Q}`),this.s.flush(),this.u.dispose(),this.P.dispose(),n.setUnexpectedErrorHandler(Se=>{this.s.error(Se)}),this.g.dispose();const ne=this.Y();Promise.race([(0,R.$fh)(5e3),ne]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${q}`):this.s.info(`Extension host exiting with code ${q}`),this.s.flush(),this.s.dispose(),this.c.exit(q)})}isActivated(Q){return this.G.isOpen()?this.P.isActivated(Q):!1}async getExtension(Q){const q=await this.C.$getExtension(Q);return q&&{...q,identifier:new r.$wm(q.identifier.value),extensionLocation:D.URI.revive(q.extensionLocation)}}Z(Q,q){return this.P.activateByEvent(Q,q)}$(Q,q){return this.P.activateById(Q,q)}activateByIdWithErrors(Q,q){return this.$(Q,q).then(()=>{const ne=this.P.getActivatedExtension(Q);if(ne.activationFailed)return Promise.reject(ne.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(Q=>this.J)}getExtensionExports(Q){if(this.G.isOpen())return this.P.getActivatedExtension(Q).exports;try{return this.P.getActivatedExtension(Q).exports}catch{return null}}async ab(Q){if(Q.scheme===G.Schemas.file&&this.c.fsRealpath){const q=await this.c.fsRealpath(Q.fsPath);return D.URI.file(q)}return Q}async getExtensionPathIndex(){return this.Q||(this.Q=this.bb(this.J.getAllExtensionDescriptions()).then(Q=>new se(Q))),this.Q}async bb(Q){const q=f.$ki.forUris(ne=>L.$Ig.ignorePathCasing(ne));return await Promise.all(Q.map(async ne=>{if(this.ub(ne)){const Se=await this.ab(ne.extensionLocation);q.set(Se,ne)}})),q}cb(Q){let q=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(Q))return q;const ne=this.P.getActivatedExtension(Q);if(!ne)return q;try{typeof ne.module.deactivate=="function"&&(q=Promise.resolve(ne.module.deactivate()).then(void 0,Se=>(this.s.error(Se),Promise.resolve(void 0))))}catch(Se){this.s.error(`An error occurred when deactivating the extension '${Q.value}':`),this.s.error(Se)}try{(0,g.$Oc)(ne.subscriptions)}catch(Se){this.s.error(`An error occurred when deactivating the subscriptions for extension '${Q.value}':`),this.s.error(Se)}return q}async db(Q,q){return this.f.remote.isRemote?this.C.$onWillActivateExtension(Q.identifier):await this.C.$onWillActivateExtension(Q.identifier),this.fb(Q,q).then(ne=>{const Se=ne.activationTimes;return this.C.$onDidActivateExtension(Q.identifier,Se.codeLoadingTime,Se.activateCallTime,Se.activateResolvedTime,q),this.eb(Q,q,"success",Se),ne},ne=>{throw this.eb(Q,q,"failure"),ne})}eb(Q,q,ne,Se){const Te=ye(Q,q);this.z.$publicLog2("extensionActivationTimes",{...Te,...Se||{},outcome:ne})}fb(Q,q){const ne=ye(Q,q);this.z.$publicLog2("activatePlugin",ne);const Se=this.ub(Q);if(!Se)return Promise.resolve(new v.$kic(v.$hic.NONE));this.s.info(`ExtensionService#_doActivateExtension ${Q.identifier.value}, startup: ${q.startup}, activationEvent: '${q.activationEvent}'${Q.identifier.value!==q.extensionId.value?`, root cause: ${q.extensionId.value}`:""}`),this.s.flush();const Te=new v.$iic(q.startup);return Promise.all([this.vb(Q,(0,L.$Rg)(Q.extensionLocation,Se),Te),this.gb(Q)]).then(Ce=>(P.mark(`code/extHost/willActivateExtension/${Q.identifier.value}`),V.hb(this.s,Q.identifier,Ce[0],Ce[1],Te))).then(Ce=>(P.mark(`code/extHost/didActivateExtension/${Q.identifier.value}`),Ce))}gb(Q){const q=new h.$qic(Q,this.M),ne=new h.$pic(Q.identifier.value,!1,this.M),Se=new T.$xic(Q,this.N),Te=Q.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?i.ExtensionMode.Test:i.ExtensionMode.Development:i.ExtensionMode.Production,Ce=this.f.remote.isRemote?i.ExtensionKind.Workspace:i.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${Q.identifier.value}`),Promise.all([q.whenReady,ne.whenReady,this.O.whenReady]).then(()=>{const we=this;let ge,J;const x=(0,c.$UF)(Q,"ipc")?this.f.messagePorts?.get(r.$wm.toKey(Q.identifier)):void 0;return Object.freeze({globalState:q,workspaceState:ne,secrets:Se,subscriptions:[],get extensionUri(){return Q.extensionLocation},get extensionPath(){return Q.extensionLocation.fsPath},asAbsolutePath(le){return F.$jc(Q.extensionLocation.fsPath,le)},get storagePath(){return we.O.workspaceValue(Q)?.fsPath},get globalStoragePath(){return we.O.globalValue(Q).fsPath},get logPath(){return F.$jc(we.f.logsLocation.fsPath,Q.identifier.value)},get logUri(){return D.URI.joinPath(we.f.logsLocation,Q.identifier.value)},get storageUri(){return we.O.workspaceValue(Q)},get globalStorageUri(){return we.O.globalValue(Q)},get extensionMode(){return Te},get extension(){return ge===void 0&&(ge=new he(we,Q.identifier,Q,Ce,!1)),ge},get extensionRuntime(){return(0,c.$VF)(Q,"extensionRuntime"),we.extensionRuntime},get environmentVariableCollection(){return we.u.getEnvironmentVariableCollection(Q)},get messagePassingProtocol(){if(!J){if(!x)return;const le=y.Event.buffer(y.Event.fromDOMEventEmitter(x,"message",de=>de.data));x.start(),J={onDidReceiveMessage:le,postMessage:x.postMessage.bind(x)}}return J}})})}static hb(Q,q,ne,Se,Te){return ne=ne||{activate:void 0,deactivate:void 0},this.ib(Q,q,ne,Se,Te).then(Ce=>new v.$jic(!1,null,Te.build(),ne,Ce,Se.subscriptions))}static ib(Q,q,ne,Se,Te){if(typeof ne.activate=="function")try{Te.activateCallStart(),Q.trace(`ExtensionService#_callActivateOptional ${q.value}`);const Ce=typeof global=="object"?global:self,we=ne.activate.apply(Ce,[Se]);return Te.activateCallStop(),Te.activateResolveStart(),Promise.resolve(we).then(ge=>(Te.activateResolveStop(),ge))}catch(Ce){return Promise.reject(Ce)}else return Promise.resolve(ne)}jb(Q,q){this.$(Q.identifier,{startup:!1,extensionId:Q.identifier,activationEvent:q}).then(void 0,ne=>{this.s.error(ne)})}kb(Q,q=0){const Se=Date.now();(0,C.$B)(()=>{for(let Te=q;Te<Q.length;Te+=1){const Ce=Q[Te];for(const we of Ce.activationEvents??[])if(we==="onStartupFinished")if(Date.now()-Se>50){this.kb(Q,Te);break}else this.jb(Ce,we)}})}lb(){this.C.$setPerformanceMarks(P.getMarks()),this.m.getConfigProvider().then(Q=>{const q=Q.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),ne=this.J.getAllExtensionDescriptions();if(q)this.kb(ne);else for(const Se of ne)if(Se.activationEvents)for(const Te of Se.activationEvents)Te==="onStartupFinished"&&this.jb(Se,Te)})}mb(){const Q=this.Z("*",!0).then(void 0,Ce=>{this.s.error(Ce)});this.B(this.j.onDidChangeWorkspace(Ce=>this.nb(Ce.added)));const q=this.j.workspace?this.j.workspace.folders:[],ne=this.nb(q),Se=this.pb(),Te=Promise.all([Se,Q,ne]).then(()=>{});return Promise.race([Te,(0,R.$fh)(1e4)]).then(()=>{this.lb()}),Te}nb(Q){return Q.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(q=>this.ob(Q,q))).then(()=>{})}async ob(Q,q){if(this.isActivated(q.identifier))return;const ne=!this.f.remote.isRemote&&!!this.f.remote.authority,Se={logService:this.s,folders:Q.map(Ce=>Ce.uri),forceUsingSearch:ne||!this.c.fsExists,exists:Ce=>this.c.fsExists(Ce.fsPath),checkExists:(Ce,we,ge)=>this.y.$checkExists(Ce,we,ge)},Te=await(0,b.$mub)(Se,q);if(Te)return this.$(q.identifier,{startup:!0,extensionId:q.identifier,activationEvent:Te.activationEvent}).then(void 0,Ce=>this.s.error(Ce))}async pb(){if(this.f.remote.authority)return this.Z(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.qb()}catch(Q){throw console.error(Q),Q}}async qb(){const{extensionDevelopmentLocationURI:Q,extensionTestsLocationURI:q}=this.f.environment;if(!Q||!q)throw new Error(S.localize(0,null));const ne=await this.vb(null,q,new v.$iic(!1));if(!ne||typeof ne.run!="function")throw new Error(S.localize(1,null,q.toString()));return new Promise((Se,Te)=>{const Ce=(J,x)=>{J?(C.$t&&this.s.error("Test runner called back with error",J),Te(J)):(C.$t&&(x?this.s.info(`Test runner called back with ${x} failures.`):this.s.info("Test runner called back with successful outcome.")),Se(typeof x=="number"&&x>0?1:0))},we=(0,L.$Fg)(q),ge=ne.run(we,Ce);ge&&ge.then&&ge.then(()=>{C.$t&&this.s.info("Test runner finished successfully."),Se(0)}).catch(J=>{C.$t&&this.s.error("Test runner finished with error",J),Te(J instanceof Error&&J.stack?J.stack:String(J))})})}rb(){if(this.S)throw new Error("Extension host is already started!");return this.S=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,R.$fh)(1e3)])).then(()=>this.mb()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(Q,q){return this.R[Q]=q,(0,g.$Rc)(()=>{delete this.R[Q]})}async getRemoteExecServer(Q){const{resolver:q}=await this.sb(Q);return q?.resolveExecServer?.(Q,{resolveAttempt:0})}async sb(Q){const q=Q.indexOf("+");if(q===-1)throw new i.$8L("Not an authority that can be resolved!",p.RemoteAuthorityResolverErrorCode.InvalidAuthority);const ne=Q.substr(0,q);return await this.D.wait(),await this.Z(`onResolveRemoteAuthority:${ne}`,!1),{authorityPrefix:ne,resolver:this.R[ne]}}async $resolveAuthority(Q,q){const ne=U.$1d.create(!1),Se=()=>`[resolveAuthority(${(0,p.$kl)(Q)},${q})][${ne.elapsed()}ms] `,Te=N=>this.s.info(`${Se()}${N}`),Ce=N=>this.s.warn(`${Se()}${N}`),we=(N,z=void 0)=>this.s.error(`${Se()}${N}`,z),ge=N=>{if(N instanceof i.$8L)return{type:"error",error:{code:N._code,message:N._message,detail:N._detail}};throw N},J=async N=>{Te(`activating resolver for ${N}...`);const{resolver:z,authorityPrefix:K}=await this.sb(N);if(!z)throw we(`no resolver for ${K}`),new i.$8L(`No remote extension installed to resolve ${K}.`,p.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:z,authorityPrefix:K,remoteAuthority:N}},x=Q.split(/@|%40/g).reverse();Te(`activating remote resolvers ${x.join(" -> ")}`);let le;try{le=await Promise.all(x.map(J)).catch(async N=>{if(!(N instanceof i.$8L)||N._code!==p.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw N;return Ce(`resolving nested authorities failed: ${N.message}`),[await J(Q)]})}catch(N){return ge(N)}const de=new R.$ph;de.cancelAndSet(()=>Te("waiting..."),1e3);let Pe,me;for(const[N,{authorityPrefix:z,resolver:K,remoteAuthority:H}]of le.entries())try{if(N===le.length-1)Te("invoking final resolve()..."),P.mark(`code/extHost/willResolveAuthority/${z}`),Pe=await K.resolve(H,{resolveAttempt:q,execServer:me}),P.mark(`code/extHost/didResolveAuthorityOK/${z}`),Te("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(K,i.$7L.isManagedResolvedAuthority(Pe)?Pe:void 0));else{if(Te(`invoking resolveExecServer() for ${H}`),P.mark(`code/extHost/willResolveExecServer/${z}`),me=await K.resolveExecServer?.(H,{resolveAttempt:q,execServer:me}),!me)throw new i.$8L(`Exec server was not available for ${H}`,p.RemoteAuthorityResolverErrorCode.NoResolverFound);P.mark(`code/extHost/didResolveExecServerOK/${z}`)}}catch(te){return P.mark(`code/extHost/didResolveAuthorityError/${z}`),we("returned an error",te),de.dispose(),ge(te)}de.dispose();const Ie={environmentTunnels:Pe.environmentTunnels,features:Pe.tunnelFeatures?{elevation:Pe.tunnelFeatures.elevation,privacyOptions:Pe.tunnelFeatures.privacyOptions,protocol:Pe.tunnelFeatures.protocol===void 0?!0:Pe.tunnelFeatures.protocol}:void 0},Me={extensionHostEnv:Pe.extensionHostEnv,isTrusted:Pe.isTrusted,authenticationSession:Pe.authenticationSessionForInitializingExtensions?{id:Pe.authenticationSessionForInitializingExtensions.id,providerId:Pe.authenticationSessionForInitializingExtensions.providerId}:void 0};Te(`returned ${i.$7L.isManagedResolvedAuthority(Pe)?"managed authority":`${Pe.host}:${Pe.port}`}`);let ze;if(i.$7L.isManagedResolvedAuthority(Pe)){const N=q;this.X.setFactory(N,Pe.makeConnection),ze={authority:Q,connectTo:new p.$hl(N),connectionToken:Pe.connectionToken}}else ze={authority:Q,connectTo:new p.$il(Pe.host,Pe.port),connectionToken:Pe.connectionToken};return{type:"ok",value:{authority:ze,options:Me,tunnelInformation:Ie}}}async $getCanonicalURI(Q,q){this.s.info(`$getCanonicalURI invoked for authority (${(0,p.$kl)(Q)})`);const{resolver:ne}=await this.sb(Q);if(!ne)return null;const Se=D.URI.revive(q);if(typeof ne.getCanonicalURI>"u")return Se;const Te=await(0,R.$9g)(()=>ne.getCanonicalURI(Se));return Te||Se}$startExtensionHost(Q){Q.toAdd.forEach(Se=>Se.extensionLocation=D.URI.revive(Se.extensionLocation));const{globalRegistry:q,myExtensions:ne}=ue(this.I,this.L,this.J,Q);return this.L.set(q.getAllExtensionDescriptions()),this.J.set(ne),C.$t&&(this.s.info(`$startExtensionHost: global extensions: ${De(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${De(this.J)}`)),this.rb()}$activateByEvent(Q,q){return q===1?this.D.wait().then(ne=>this.Z(Q,!1)):this.G.wait().then(ne=>this.Z(Q,!1))}async $activate(Q,q){return await this.G.wait(),this.J.getExtensionDescription(Q)?(await this.$(Q,q),!0):!1}async $deltaExtensions(Q){Q.toAdd.forEach(Ce=>Ce.extensionLocation=D.URI.revive(Ce.extensionLocation));const{globalRegistry:q,myExtensions:ne}=ue(this.I,this.L,this.J,Q),Se=await this.bb(ne);return(await this.getExtensionPathIndex()).setSearchTree(Se),this.L.set(q.getAllExtensionDescriptions()),this.J.set(ne),C.$t&&(this.s.info(`$deltaExtensions: global extensions: ${De(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${De(this.J)}`)),Promise.resolve(void 0)}async $test_latency(Q){return Q}async $test_up(Q){return Q.byteLength}async $test_down(Q){const q=a.$se.alloc(Q),ne=Math.random()%256;for(let Se=0;Se<Q;Se++)q.writeUInt8(ne,Se);return q}async $updateRemoteConnectionData(Q){this.W=Q,this.a.fire()}};e.$Dic=re,e.$Dic=re=V=Ze([qe(0,u.$di),qe(1,e.$Cic),qe(2,w.$eO),qe(3,s.$3hc),qe(4,l.$6hc),qe(5,M.$yj),qe(6,o.$uO),qe(7,E.$9hc),qe(8,I.$pAb),qe(9,d.$ric),qe(10,W.$zic),qe(11,O.$Aic)],re);function ue(ee,Q,q,ne){ee.addActivationEvents(ne.addActivationEvents);const Se=new t.$D9b(ee,Q.getAllExtensionDescriptions());Se.deltaExtensions(ne.toAdd,ne.toRemove);const Te=new r.$xm(q.getAllExtensionDescriptions().map(we=>we.identifier));for(const we of ne.myToRemove)Te.delete(we);for(const we of ne.myToAdd)Te.add(we);const Ce=ve(Se,Te);return{globalRegistry:Se,myExtensions:Ce}}function ye(ee,Q){return{id:ee.identifier.value,name:ee.name,extensionVersion:ee.version,publisherDisplayName:ee.publisher,activationEvents:ee.activationEvents?ee.activationEvents.join(","):null,isBuiltin:ee.isBuiltin,reason:Q.activationEvent,reasonId:Q.extensionId.value}}function De(ee){return ee.getAllExtensionDescriptions().map(Q=>Q.identifier.value).join(",")}e.$Eic=(0,u.$ei)("IExtHostExtensionService");class he{#e;#t;#i;constructor(Q,q,ne,Se,Te){this.#e=Q,this.#t=q,this.#i=ne.identifier,this.id=ne.identifier.value,this.extensionUri=ne.extensionLocation,this.extensionPath=F.$hc((0,L.$Fg)(ne.extensionLocation)),this.packageJSON=ne,this.extensionKind=Se,this.isFromDifferentExtensionHost=Te}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$Fic=he;function ve(ee,Q){return ee.getAllExtensionDescriptions().filter(q=>Q.has(q.identifier))}class se{constructor(Q){this.a=Q}setSearchTree(Q){this.a=Q}findSubstr(Q){return this.a.findSubstr(Q)}forEach(Q){return this.a.forEach(Q)}}e.$Gic=se;class $e{constructor(Q){this.a=new r.$ym,this.addActivationEvents(Q)}readActivationEvents(Q){return this.a.get(Q.identifier)??[]}addActivationEvents(Q){for(const q of Object.keys(Q))this.a.set(q,Q[q])}}}),define(Re[290],Ae([1,0,87,2,3,38,23,20,17,27,4,39,14,13]),function(fe,e,S,F,P,L,R,g,f,D,M,k,l,v){"use strict";var $;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ojc=void 0;let s=class{constructor(a,h,i,p,u,o,E){this.c=a,this.d=h,this.e=i,this.f=p,this.g=u,this.h=o,this.i=E,this.a=new Map,this.b=[]}async install(){this.j(),S.mark("code/extHost/willWaitForConfig");const a=await this.f.getConfigProvider();S.mark("code/extHost/didWaitForConfig");const h=await this.g.getExtensionPathIndex();this.register(new t(this.c,h,this.d,a,this.i)),this.register(this.e.createInstance(c)),this.h.remote.isRemote&&this.register(this.e.createInstance(n,h,this.h.environment.appUriScheme))}register(a){if("nodeModuleName"in a)if(Array.isArray(a.nodeModuleName))for(const h of a.nodeModuleName)this.a.set(h,a);else this.a.set(a.nodeModuleName,a);typeof a.alternativeModuleName=="function"&&this.b.push(h=>a.alternativeModuleName(h))}};e.$Ojc=s,e.$Ojc=s=Ze([qe(2,M.$di),qe(3,L.$6hc),qe(4,k.$Eic),qe(5,D.$uO),qe(6,l.$yj)],s);let c=class{static{$=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(a){if(a.environment.appRoot&&$.a.size){const h=(0,v.$Xe)(this.c(a.environment.appRoot.fsPath)),i="[a-z0-9_.-]",p=`@${i}+\\/${i}+|${i}+`,u="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${h}/${u}\\/)(${p})(.*)$`,"i")}}alternativeModuleName(a){if(!this.b)return;const h=this.b.exec(this.c(a));if(!h)return;const[,i,p,u]=h,o=$.a.get(p);if(o!==void 0)return console.warn(`${p} as been renamed to ${o}, please update your imports`),i+o+u}c(a){return a.replace(/\\/g,"/")}};c=$=Ze([qe(0,D.$uO)],c);class t{constructor(a,h,i,p,u){this.c=a,this.d=h,this.e=i,this.f=p,this.g=u,this.nodeModuleName="vscode",this.a=new g.$ym}load(a,h){const i=this.d.findSubstr(h);if(i){let p=this.a.get(i.identifier);return p||(p=this.c(i,this.e,this.f),this.a.set(i.identifier,p)),p}if(!this.b){let p="";this.d.forEach((u,o)=>p+=`	${o} -> ${u.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${h}. These are the extension path mappings: 
${p}`),this.b=this.c(R.$PF,this.e,this.f)}return this.b}}let n=class{constructor(a,h,i){this.e=a,this.f=h,this.nodeModuleName=["open","opn"],this.d=i.getProxy(P.$ZL.MainThreadTelemetry);const p=i.getProxy(P.$ZL.MainThreadWindow);this.c=(u,o)=>{const E=F.URI.parse(u);return o?this.g(u,o):E.scheme==="http"||E.scheme==="https"?p.$openUri(E,u,{allowTunneling:!0}):E.scheme==="mailto"||E.scheme===this.f?p.$openUri(E,u,{}):this.g(u,o)}}load(a,h,i){const p=this.e.findSubstr(h);return p&&(this.a=p.identifier.value,this.h()),this.b=i(a),this.c}g(a,h){return this.i(),this.b(a,h)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};n=Ze([qe(2,f.$eO)],n)}),define(Re[117],Ae([1,0,40,6,19,73,4,67,65,39,7,37,216,38]),function(fe,e,S,F,P,L,R,g,f,D,M,k,l,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Iic=e.$Hic=void 0,e.$Hic=(0,R.$ei)("IExtHostVariableResolverProvider");class $ extends l.$fP{constructor(t,n,r,a,h,i,p){function u(){if(r){const o=r.activeEditor();if(o)return o.document.uri;const E=a.tabGroups.all.find(w=>w.isActive)?.activeTab;if(E!==void 0){if(E.input instanceof M.$KN||E.input instanceof M.$PN)return E.input.modified;if(E.input instanceof M.$JN||E.input instanceof M.$ON||E.input instanceof M.$MN)return E.input.uri}}}super({getFolderUri:o=>{const E=i.folders.filter(w=>w.name===o);if(E&&E.length>0)return E[0].uri},getWorkspaceFolderCount:()=>i.folders.length,getConfigurationValue:(o,E)=>h.getConfiguration(void 0,o).get(E),getAppRoot:()=>L.cwd(),getExecPath:()=>L.env.VSCODE_EXEC_PATH,getFilePath:()=>{const o=u();if(o)return P.$hc(o.fsPath)},getWorkspaceFolderPathForFile:()=>{if(n){const o=u();if(o){const E=n.getWorkspaceFolder(o);if(E)return P.$hc(E.uri.fsPath)}}},getSelectedText:()=>{if(r){const o=r.activeEditor();if(o&&!o.selection.isEmpty)return o.document.getText(o.selection)}},getLineNumber:()=>{if(r){const o=r.activeEditor();if(o)return String(o.selection.end.line+1)}},getExtension:o=>t.getExtension(o)},void 0,p?Promise.resolve(p):void 0,Promise.resolve(L.env))}}let s=class extends F.$Tc{constructor(t,n,r,a,h){super(),this.b=t,this.c=n,this.g=r,this.h=a,this.j=h,this.a=new S.$V(async()=>{const i=await this.h.getConfigProvider(),u={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async o=>{u.folders=await this.c.getWorkspaceFolders2()||[]})),new $(this.b,this.c,this.g,this.j,i,u,this.m())})}getResolver(){return this.a.value}m(){}};e.$Iic=s,e.$Iic=s=Ze([qe(0,D.$Eic),qe(1,k.$3hc),qe(2,g.$pO),qe(3,v.$6hc),qe(4,f.$fic)],s)}),define(Re[118],Ae([1,0,11,5,2,20,4,3,65,39,17,7,37,208,210,38,117,6,41,31,8]),function(fe,e,S,F,P,L,R,g,f,D,M,k,l,v,$,s,c,t,n,r,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nic=e.$Mic=e.$Lic=e.$Kic=e.$Jic=void 0,e.$Jic=(0,R.$ei)("IExtHostDebugService");let h=class{get onDidStartDebugSession(){return this.n.event}get onDidTerminateDebugSession(){return this.o.event}get onDidChangeActiveDebugSession(){return this.q.event}get activeDebugSession(){return this.u?.api}get onDidReceiveDebugSessionCustomEvent(){return this.w.event}get activeDebugConsole(){return this.y.value}constructor(m,I,d,y,b,A,T){this.N=I,this.O=d,this.P=y,this.Q=b,this.R=A,this.S=T,this.m=new Map,this.F=0,this.G=new Map,this.H=new Map,this.I=new WeakMap,this.J=new Map,this.L=new Map,this.M=0,this.d=0,this.f=[],this.g=0,this.h=[],this.j=0,this.k=[],this.D=new Map,this.E=new Map,this.n=new F.$5d,this.o=new F.$5d,this.q=new F.$5d,this.w=new F.$5d,this.l=m.getProxy(g.$ZL.MainThreadDebugService),this.A=new F.$5d,this.C=new F.$5d,this.y=new p(this.l),this.z=new Map,this.O.getExtensionRegistry().then(G=>{G.onDidChange(W=>{this.V(G)}),this.V(G)})}async $getVisualizerTreeItem(m,I){const d=this.W(I);if(!d)return;const y=await this.H.get(m)?.getTreeItem?.(d);return y?this.U(m,y):void 0}registerDebugVisualizationTree(m,I,d){const y=L.$wm.toKey(m.identifier),b=this.jb(y,I);if(this.G.has(b))throw new Error(`A debug visualization provider with id '${I}' is already registered`);return this.H.set(b,d),this.l.$registerDebugVisualizerTree(b,!!d.editItem),(0,t.$Rc)(()=>{this.l.$unregisterDebugVisualizerTree(b),this.H.delete(I)})}async $getVisualizerTreeItemChildren(m,I){const d=this.J.get(I)?.item;return d?(await this.H.get(m)?.getChildren?.(d))?.map(b=>this.U(m,b))||[]:[]}async $editVisualizerTreeItem(m,I){const d=this.J.get(m);if(!d)return;const y=await this.H.get(d.provider)?.editItem?.(d.item,I);return this.U(d.provider,y||d.item)}$disposeVisualizedTree(m){const I=this.J.get(m);if(!I)return;const d=[I.children];for(const y of d)if(y)for(const b of y)d.push(this.J.get(b)?.children),this.J.delete(b)}U(m,I){let d=this.I.get(I);return d||(d=this.F++,this.I.set(I,d),this.J.set(d,{provider:m,item:I})),a.DebugTreeItem.from(I,d)}asDebugSourceUri(m,I){const d=m;if(typeof d.sourceReference=="number"&&d.sourceReference>0){let y=`debug:${encodeURIComponent(d.path||"")}`,b="?";return I&&(y+=`${b}session=${encodeURIComponent(I.id)}`,b="&"),y+=`${b}ref=${d.sourceReference}`,P.URI.parse(y)}else{if(d.path)return P.URI.file(d.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}V(m){const I=[];for(const d of m.getAllExtensionDescriptions())if(d.contributes){const y=d.contributes.debuggers;if(y&&y.length>0)for(const b of y)(0,$.$tG)(b)&&I.push(b.type)}this.l.$registerDebugTypes(I)}get stackFrameFocus(){return this.B}get onDidChangeStackFrameFocus(){return this.C.event}get onDidChangeBreakpoints(){return this.A.event}get breakpoints(){const m=[];return this.z.forEach(I=>m.push(I)),m}async $resolveDebugVisualizer(m,I){const d=this.L.get(m);if(!d)throw new Error(`No debug visualizer found with id '${m}'`);let{v:y,provider:b,extensionId:A}=d;if(y.visualization||(y=await b.resolveDebugVisualization?.(y,I)||y,d.v=y),!y.visualization)throw new Error(`No visualization returned from resolveDebugVisualization in '${b}'`);return this.kb(A,y.visualization)}async $executeDebugVisualizerCommand(m){const I=this.L.get(m);if(!I)throw new Error(`No debug visualizer found with id '${m}'`);const d=I.v.visualization;d&&"command"in d&&this.S.executeCommand(d.command,...d.arguments||[])}W(m){const I=this.m.get(m.sessionId);return I&&{session:I.api,variable:m.variable,containerId:m.containerId,frameId:m.frameId,threadId:m.threadId}}async $provideDebugVisualizers(m,I,d,y){const b=this.W(d),A=this.jb(m,I),T=this.G.get(A);if(!b||!T)return[];const G=await T.provideDebugVisualization(b,y);return G?G.map(W=>{const U=++this.M;this.L.set(U,{v:W,provider:T,extensionId:m});const C=W.iconPath?this.lb(W.iconPath):void 0;return{id:U,name:W.name,iconClass:C?.iconClass,iconPath:C?.iconPath,visualization:this.kb(m,W.visualization)}}):[]}$disposeDebugVisualizers(m){for(const I of m)this.L.delete(I)}registerDebugVisualizationProvider(m,I,d){if(!m.contributes?.debugVisualizers?.some(A=>A.id===I))throw new Error(`Extensions may only call registerDebugVisualizationProvider() for renderers they contribute (got ${I})`);const y=L.$wm.toKey(m.identifier),b=this.jb(y,I);if(this.G.has(b))throw new Error(`A debug visualization provider with id '${I}' is already registered`);return this.G.set(b,d),this.l.$registerDebugVisualizer(y,I),(0,t.$Rc)(()=>{this.l.$unregisterDebugVisualizer(y,I),this.G.delete(I)})}addBreakpoints(m){const I=m.filter(b=>{const A=b.id;return this.z.has(A)?!1:(this.z.set(A,b),!0)});this.gb(I,[],[]);const d=[],y=new Map;for(const b of I)if(b instanceof k.$2M){let A=y.get(b.location.uri.toString());A||(A={type:"sourceMulti",uri:b.location.uri,lines:[]},y.set(b.location.uri.toString(),A),d.push(A)),A.lines.push({id:b.id,enabled:b.enabled,condition:b.condition,hitCondition:b.hitCondition,logMessage:b.logMessage,line:b.location.range.start.line,character:b.location.range.start.character,mode:b.mode})}else b instanceof k.$3M&&d.push({type:"function",id:b.id,enabled:b.enabled,hitCondition:b.hitCondition,logMessage:b.logMessage,condition:b.condition,functionName:b.functionName,mode:b.mode});return this.l.$registerBreakpoints(d)}removeBreakpoints(m){const I=m.filter(A=>this.z.delete(A.id));this.gb([],I,[]);const d=I.filter(A=>A instanceof k.$2M).map(A=>A.id),y=I.filter(A=>A instanceof k.$3M).map(A=>A.id),b=I.filter(A=>A instanceof k.$4M).map(A=>A.id);return this.l.$unregisterBreakpoints(d,y,b)}startDebugging(m,I,d){return this.l.$startDebugging(m?m.uri:void 0,I,{parentSessionID:d.parentSession?d.parentSession.id:void 0,lifecycleManagedByParent:d.lifecycleManagedByParent,repl:d.consoleMode===k.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:d.noDebug,compact:d.compact,suppressSaveBeforeStart:d.suppressSaveBeforeStart,suppressDebugStatusbar:d.suppressDebugStatusbar??d.debugUI?.simple,suppressDebugToolbar:d.suppressDebugToolbar??d.debugUI?.simple,suppressDebugView:d.suppressDebugView??d.debugUI?.simple})}stopDebugging(m){return this.l.$stopDebugging(m?m.id:void 0)}registerDebugConfigurationProvider(m,I,d){if(!I)return new k.$2L(()=>{});const y=this.d++;return this.f.push({type:m,handle:y,provider:I}),this.l.$registerDebugConfigurationProvider(m,d,!!I.provideDebugConfigurations,!!I.resolveDebugConfiguration,!!I.resolveDebugConfigurationWithSubstitutedVariables,y),new k.$2L(()=>{this.f=this.f.filter(b=>b.provider!==I),this.l.$unregisterDebugConfigurationProvider(y)})}registerDebugAdapterDescriptorFactory(m,I,d){if(!d)return new k.$2L(()=>{});if(!this.cb(m,I))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${I}' debugger.`);if(this.$(I))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const y=this.g++;return this.h.push({type:I,handle:y,factory:d}),this.l.$registerDebugAdapterDescriptorFactory(I,y),new k.$2L(()=>{this.h=this.h.filter(b=>b.factory!==d),this.l.$unregisterDebugAdapterDescriptorFactory(y)})}registerDebugAdapterTrackerFactory(m,I){if(!I)return new k.$2L(()=>{});const d=this.j++;return this.k.push({type:m,handle:d,factory:I}),new k.$2L(()=>{this.k=this.k.filter(y=>y.factory!==I)})}async $runInTerminal(m,I){return Promise.resolve(void 0)}async $substituteVariables(m,I){let d;const y=await this.ib(m);return y&&(d={uri:y.uri,name:y.name,index:y.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.R.getResolver()).resolveAnyAsync(d,I)}X(m,I){if(m.type==="implementation")return new o(m.implementation)}Y(){}async $startDASession(m,I){const d=this,y=await this.hb(I);return this.eb(this.$(y.type),y).then(b=>{if(!b)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${y.type}' (extension might have failed to activate)`);const A=this.Z(b),T=this.X(A,y);if(!T)throw new Error(`Couldn't create a debug adapter for type '${y.type}'.`);const G=T;return this.D.set(m,G),this.db(y).then(W=>(W&&this.E.set(m,W),G.onMessage(async U=>{if(U.type==="request"&&U.command==="handshake"){const C=U,O={type:"response",seq:0,command:C.command,request_seq:C.seq,success:!0};this.K||(this.K=this.Y());try{if(this.K){const V=await this.K.sign(C.arguments.value);O.body={signature:V},G.sendResponse(O)}else throw new Error("no signer")}catch(V){O.success=!1,O.message=V.message,G.sendResponse(O)}}else W&&W.onDidSendMessage&&W.onDidSendMessage(U),U=(0,$.$yG)(U,!0),d.l.$acceptDAMessage(m,U)}),G.onError(U=>{W&&W.onError&&W.onError(U),this.l.$acceptDAError(m,U.name,U.message,U.stack)}),G.onExit(U=>{W&&W.onExit&&W.onExit(U??void 0,void 0),this.l.$acceptDAExit(m,U??void 0,void 0)}),W&&W.onWillStartSession&&W.onWillStartSession(),G.startSession()))})}$sendDAMessage(m,I){I=(0,$.$xG)(I,!1);const d=this.E.get(m);d&&d.onWillReceiveMessage&&d.onWillReceiveMessage(I),this.D.get(m)?.sendMessage(I)}$stopDASession(m){const I=this.E.get(m);this.E.delete(m),I&&I.onWillStopSession&&I.onWillStopSession();const d=this.D.get(m);return this.D.delete(m),d?d.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(m){const I=[],d=[],y=[];if(m.added)for(const b of m.added){const A=b.id;if(A&&!this.z.has(A)){let T;if(b.type==="function")T=new k.$3M(b.functionName,b.enabled,b.condition,b.hitCondition,b.logMessage,b.mode);else if(b.type==="data")T=new k.$4M(b.label,b.dataId,b.canPersist,b.enabled,b.hitCondition,b.condition,b.logMessage,b.mode);else{const G=P.URI.revive(b.uri);T=new k.$2M(new k.$bM(G,new k.$3L(b.line,b.character)),b.enabled,b.condition,b.hitCondition,b.logMessage,b.mode)}(0,k.$ZM)(T,A),this.z.set(A,T),I.push(T)}}if(m.removed)for(const b of m.removed){const A=this.z.get(b);A&&(this.z.delete(b),d.push(A))}if(m.changed){for(const b of m.changed)if(b.id){const A=this.z.get(b.id);if(A){if(A instanceof k.$3M&&b.type==="function"){const T=A;T.enabled=b.enabled,T.condition=b.condition,T.hitCondition=b.hitCondition,T.logMessage=b.logMessage,T.functionName=b.functionName}else if(A instanceof k.$2M&&b.type==="source"){const T=A;T.enabled=b.enabled,T.condition=b.condition,T.hitCondition=b.hitCondition,T.logMessage=b.logMessage,T.location=new k.$bM(P.URI.revive(b.uri),new k.$3L(b.line,b.character))}y.push(A)}}}this.gb(I,d,y)}async $acceptStackFrameFocus(m){let I;const d=m.sessionId?await this.hb(m.sessionId):void 0;if(!d)throw new Error("no DebugSession found for debug focus context");m.kind==="thread"?I=new k.$0M(d.api,m.threadId):I=new k.$9M(d.api,m.threadId,m.frameId),this.B=I,this.C.fire(this.B)}$provideDebugConfigurations(m,I,d){return(0,S.$9g)(async()=>{const y=this.bb(m);if(!y)throw new Error("no DebugConfigurationProvider found");if(!y.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const b=await this.ib(I);return y.provideDebugConfigurations(b,d)}).then(y=>{if(!y)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return y})}$resolveDebugConfiguration(m,I,d,y){return(0,S.$9g)(async()=>{const b=this.bb(m);if(!b)throw new Error("no DebugConfigurationProvider found");if(!b.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const A=await this.ib(I);return b.resolveDebugConfiguration(A,d,y)})}$resolveDebugConfigurationWithSubstitutedVariables(m,I,d,y){return(0,S.$9g)(async()=>{const b=this.bb(m);if(!b)throw new Error("no DebugConfigurationProvider found");if(!b.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const A=await this.ib(I);return b.resolveDebugConfigurationWithSubstitutedVariables(A,d,y)})}async $provideDebugAdapter(m,I){const d=this.ab(m);if(!d)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const y=await this.hb(I);return this.eb(d,y).then(b=>{if(!b)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${y.type}'`);return this.Z(b)})}async $acceptDebugSessionStarted(m){const I=await this.hb(m);this.n.fire(I.api)}async $acceptDebugSessionTerminated(m){const I=await this.hb(m);I&&(this.o.fire(I.api),this.m.delete(I.id))}async $acceptDebugSessionActiveChanged(m){this.u=m?await this.hb(m):void 0,this.q.fire(this.u?.api)}async $acceptDebugSessionNameChanged(m,I){(await this.hb(m))?._acceptNameChanged(I)}async $acceptDebugSessionCustomEvent(m,I){const y={session:(await this.hb(m)).api,event:I.event,body:I.body};this.w.fire(y)}Z(m){if(m instanceof k.$5M)return{type:"executable",command:m.command,args:m.args,options:m.options};if(m instanceof k.$6M)return{type:"server",port:m.port,host:m.host};if(m instanceof k.$7M)return{type:"pipeServer",path:m.path};if(m instanceof k.$8M)return{type:"implementation",implementation:m.implementation};throw new Error("convertToDto unexpected type")}$(m){const I=this.h.filter(d=>d.type===m);if(I.length>0)return I[0].factory}ab(m){const I=this.h.filter(d=>d.handle===m);if(I.length>0)return I[0].factory}bb(m){const I=this.f.filter(d=>d.handle===m);if(I.length>0)return I[0].provider}cb(m,I){if(m.contributes){const d=m.contributes.debuggers;if(d&&d.length>0){for(const y of d)if(y.label&&y.type&&y.type===I)return!0}}return!1}db(m){const d=m.configuration.type,y=this.k.filter(b=>b.type===d||b.type==="*").map(b=>(0,S.$9g)(()=>b.factory.createDebugAdapterTracker(m.api)).then(A=>A,A=>null));return Promise.race([Promise.all(y).then(b=>{const A=b.filter(T=>!!T);if(A.length>0)return new u(A)}),new Promise(b=>setTimeout(()=>b(void 0),1e3))]).catch(b=>{})}async eb(m,I){const d=I.configuration.debugServer;if(typeof d=="number")return Promise.resolve(new k.$6M(d));if(m){const b=await this.O.getExtensionRegistry();return(0,S.$9g)(()=>m.createDebugAdapterDescriptor(I.api,this.fb(I,b))).then(A=>{if(A)return A})}const y=await this.O.getExtensionRegistry();return Promise.resolve(this.fb(I,y))}fb(m,I){}gb(m,I,d){(m.length>0||I.length>0||d.length>0)&&this.A.fire(Object.freeze({added:m,removed:I,changed:d}))}async hb(m){if(m)if(typeof m=="string"){const I=this.m.get(m);if(I)return I}else{let I=this.m.get(m.id);if(!I){const d=await this.ib(m.folderUri),y=m.parent?this.m.get(m.parent):void 0;I=new i(this.l,m.id,m.type,m.name,d,m.configuration,y?.api),this.m.set(I.id,I),this.l.$sessionCached(I.id)}return I}throw new Error("cannot find session")}ib(m){if(m){const I=P.URI.revive(m);return this.N.resolveWorkspaceFolder(I)}return Promise.resolve(void 0)}jb(m,I){return`${m}\0${I}`}kb(m,I){if(I){if("title"in I&&"command"in I)return{type:0};if("treeId"in I)return{type:1,id:`${m}\0${I.treeId}`};throw new Error("Unsupported debug visualization type")}}lb(m){const I=this.mb(m);let d,y;return"id"in I?y=n.ThemeIcon.asClassName(I):d=I,{iconPath:d,iconClass:y}}mb(m){if(m instanceof k.$WM)return{id:m.id};const I=typeof m=="object"&&"dark"in m?m.dark:m,d=typeof m=="object"&&"light"in m?m.light:m;return{dark:typeof I=="string"?P.URI.file(I):I,light:typeof d=="string"?P.URI.file(d):d}}};e.$Kic=h,e.$Kic=h=Ze([qe(0,M.$eO),qe(1,l.$3hc),qe(2,D.$Eic),qe(3,s.$6hc),qe(4,f.$fic),qe(5,c.$Hic),qe(6,r.$AO)],h);class i{constructor(m,I,d,y,b,A,T){this.f=m,this.g=I,this.h=d,this.j=y,this.k=b,this.l=A,this.m=T}get api(){const m=this;return this.d??=Object.freeze({id:m.g,type:m.h,get name(){return m.j},set name(I){m.j=I,m.f.$setDebugSessionName(m.g,I)},parentSession:m.m,workspaceFolder:m.k,configuration:m.l,customRequest(I,d){return m.f.$customDebugAdapterRequest(m.g,I,d)},getDebugProtocolBreakpoint(I){return m.f.$getDebugProtocolBreakpoint(m.g,I.id)}})}get id(){return this.g}get type(){return this.h}_acceptNameChanged(m){this.j=m}get configuration(){return this.l}}e.$Lic=i;class p{constructor(m){this.value=Object.freeze({append(I){m.$appendDebugConsole(I)},appendLine(I){this.append(I+`
`)}})}}e.$Mic=p;class u{constructor(m){this.d=m}onWillStartSession(){this.d.forEach(m=>m.onWillStartSession?m.onWillStartSession():void 0)}onWillReceiveMessage(m){this.d.forEach(I=>I.onWillReceiveMessage?I.onWillReceiveMessage(m):void 0)}onDidSendMessage(m){this.d.forEach(I=>I.onDidSendMessage?I.onDidSendMessage(m):void 0)}onWillStopSession(){this.d.forEach(m=>m.onWillStopSession?m.onWillStopSession():void 0)}onError(m){this.d.forEach(I=>I.onError?I.onError(m):void 0)}onExit(m,I){this.d.forEach(d=>d.onExit?d.onExit(m,I):void 0)}}class o extends v.$Fnb{constructor(m){super(),this.h=m,m.onDidSendMessage(I=>{this.acceptMessage(I)})}startSession(){return Promise.resolve(void 0)}sendMessage(m){this.h.handleMessage(m)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let E=class extends h{constructor(m,I,d,y,b,A,T){super(m,I,d,y,b,A,T)}};e.$Nic=E,e.$Nic=E=Ze([qe(0,M.$eO),qe(1,l.$3hc),qe(2,D.$Eic),qe(3,s.$6hc),qe(4,f.$fic),qe(5,c.$Hic),qe(6,r.$AO)],E)}),define(Re[291],Ae([1,0,15,87,2,3,237,14,54,71,27,186,17,59,39,61]),function(fe,e,S,F,P,L,R,g,f,D,M,k,l,v,$,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qjc=e.$Pjc=void 0;class c{static async installEarlyHandler(r){Error.stackTraceLimit=100;const a=r.get(g.$yj),i=r.get(l.$eO).getProxy(L.$ZL.MainThreadErrors);S.setUnexpectedErrorHandler(p=>{a.error(p);const u=S.$3(p);i.$onUnexpectedError(u)})}static async installFullHandler(r){const a=r.get(g.$yj),h=r.get(l.$eO),i=r.get($.$Eic),p=r.get(s.$yO),u=h.getProxy(L.$ZL.MainThreadExtensionService),o=h.getProxy(L.$ZL.MainThreadErrors),E=await i.getExtensionPathIndex(),w=new WeakMap;function m(y,b){if(w.has(y))return w.get(y).stack;let A="",T,G;for(const U of b)A+=`
	at ${U.toString()}`,G=U.getFileName(),!T&&G&&(T=E.findSubstr(P.URI.file(G)));const W=`${y.name||"Error"}: ${y.message||""}${A}`;return w.set(y,{extensionIdentifier:T?.identifier,stack:W}),W}const I=Symbol("prepareStackTrace wrapped");let d=m;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return d},set(y){if(y===m||!y||y[I]){d=y||m;return}d=function(b,A){return m(b,A),y.call(Error,b,A)},Object.assign(d,{[I]:!0})}}),S.setUnexpectedErrorHandler(y=>{a.error(y);const b=S.$3(y),A=w.get(y);if(!A?.extensionIdentifier){o.$onUnexpectedError(b);return}u.$onExtensionRuntimeError(A.extensionIdentifier,b);const T=p.onExtensionError(A.extensionIdentifier,y);a.trace("forwarded error to extension?",T,A)})}}e.$Pjc=c;class t{constructor(r,a,h,i,p){this.a=h,this.b=new R.$L9b(r,null,i),a=t.e(a,this.b);const u=new D.$ci(...(0,f.$$r)());u.set(M.$uO,{_serviceBrand:void 0,...a,messagePorts:p}),u.set(l.$eO,new l.$fO(this.b)),u.set(v.$Zhc,new v.$1hc(i)),u.set($.$Cic,h);const o=new k.$Pq(u,!0);o.invokeFunction(c.installEarlyHandler),this.d=o.invokeFunction(E=>E.get(g.$yj)),F.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",a),this.c=o.invokeFunction(E=>E.get($.$Eic)),this.c.initialize(),o.invokeFunction(c.installFullHandler)}async asBrowserUri(r){const a=this.b.getProxy(L.$ZL.MainThreadExtensionService);return P.URI.revive(await a.$asBrowserUri(r))}terminate(r){this.c.terminate(r)}static e(r,a){r.extensions.allExtensions.forEach(i=>{i.extensionLocation=P.URI.revive(a.transformIncomingURIs(i.extensionLocation))}),r.environment.appRoot=P.URI.revive(a.transformIncomingURIs(r.environment.appRoot));const h=r.environment.extensionDevelopmentLocationURI;return h&&(r.environment.extensionDevelopmentLocationURI=h.map(i=>P.URI.revive(a.transformIncomingURIs(i)))),r.environment.extensionTestsLocationURI=P.URI.revive(a.transformIncomingURIs(r.environment.extensionTestsLocationURI)),r.environment.globalStorageHome=P.URI.revive(a.transformIncomingURIs(r.environment.globalStorageHome)),r.environment.workspaceStorageHome=P.URI.revive(a.transformIncomingURIs(r.environment.workspaceStorageHome)),r.environment.extensionTelemetryLogResource=P.URI.revive(a.transformIncomingURIs(r.environment.extensionTelemetryLogResource)),r.nlsBaseUrl=P.URI.revive(a.transformIncomingURIs(r.nlsBaseUrl)),r.logsLocation=P.URI.revive(a.transformIncomingURIs(r.logsLocation)),r.workspace=a.transformIncomingURIs(r.workspace),r}}e.$Qjc=t}),define(Re[292],Ae([1,0,18,11,22,34,12,19,25,2,44]),function(fe,e,S,F,P,L,R,g,f,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5ic=e.$4ic=e.$3ic=e.$2ic=void 0;class k{constructor(n,r,a,h){this.d=n,this.e=r,this.f=a,this.g=h,this.a=null,this.b=!1,this.c=0}search(n,r){const a=this.d.folderQueries||[],h=new P.$ce(r);return new Promise((i,p)=>{this.a=new v(n);let u=!1;const o=(E,w)=>{if(!u&&!this.b){const m=this.h(E);s(E)&&typeof this.d.maxResults=="number"&&this.c+m>this.d.maxResults&&(this.b=!0,u=!0,h.cancel(),E=this.j(E,this.d.maxResults-this.c));const I=this.h(E);this.c+=I,(I>0||!s(E))&&this.a.add(E,w)}};Promise.all(a.map((E,w)=>this.k(E,m=>o(m,w),h.token))).then(E=>{h.dispose(),this.a.flush();const w=E.some(m=>!!m&&!!m.limitHit);i({limitHit:this.b||w,messages:(0,S.$Rb)(E.map(m=>m?.message?Array.isArray(m.message)?m.message:[m.message]:[])),stats:{type:this.g}})},E=>{h.dispose();const w=(0,L.$2i)(E);p(new Error(w))})})}h(n){return s(n)?Array.isArray(n.ranges)?n.ranges.length:1:0}j(n,r){const a=Array.isArray(n.ranges)?n.ranges:[n.ranges],h=Array.isArray(n.preview.matches)?n.preview.matches:[n.preview.matches];return{ranges:a.slice(0,r),preview:{matches:h.slice(0,r),text:n.preview.text},uri:n.uri}}async k(n,r,a){const h=new M.$CK(this.d,n),i=[],p={report:E=>{if(!this.l(E))return;const w=n.folder.scheme===R.Schemas.file?(0,M.$DK)(()=>this.f.readdir(f.$Qg(E.uri))):void 0,m=f.$Tg(n.folder,E.uri);if(m){const I=h.includedInQuery(m,g.$nc(m),w);(0,F.$3g)(I)?i.push(I.then(d=>{d&&r(E)})):I&&r(E)}}},u=this.n(n),o=await this.e.provideTextSearchResults(l(this.d.contentPattern),u,p,a);return i.length&&await Promise.all(i),o}l(n){if(s(n)){if(Array.isArray(n.ranges)){if(!Array.isArray(n.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(n.preview.matches.length!==n.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(n.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(n){const r=(0,M.$BK)(this.d.includePattern,n.includePattern),a=(0,M.$BK)(this.d.excludePattern,n.excludePattern),h={folder:D.URI.from(n.folder),excludes:a,includes:r,useIgnoreFiles:!n.disregardIgnoreFiles,useGlobalIgnoreFiles:!n.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!n.disregardParentIgnoreFiles,followSymlinks:!n.ignoreSymlinks,encoding:n.fileEncoding&&this.f.toCanonicalName(n.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return h.usePCRE2=this.d.usePCRE2,h}}e.$2ic=k;function l(t){return{isCaseSensitive:t.isCaseSensitive||!1,isRegExp:t.isRegExp||!1,isWordMatch:t.isWordMatch||!1,isMultiline:t.isMultiline||!1,pattern:t.pattern}}class v{constructor(n){this.e=n,this.b=-1,this.d=null,this.a=new c(512,r=>this.g(r))}add(n,r){this.d&&(this.b!==r||!f.$Kg(this.c,n.uri))&&(this.f(),this.d=null),this.d||(this.b=r,this.d={resource:n.uri,results:[]}),this.d.results.push($(n))}f(){const n=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,n)}flush(){this.f(),this.a.flush()}g(n){this.e(n)}}e.$3ic=v;function $(t){return s(t)?{preview:{matches:(0,S.$2b)(t.preview.matches,n=>({startLineNumber:n.start.line,startColumn:n.start.character,endLineNumber:n.end.line,endColumn:n.end.character})),text:t.preview.text},ranges:(0,S.$2b)(t.ranges,n=>({startLineNumber:n.start.line,startColumn:n.start.character,endLineNumber:n.end.line,endColumn:n.end.character}))}:{text:t.text,lineNumber:t.lineNumber}}function s(t){return!!t.preview}e.$4ic=s;class c{static{this.a=4e3}static{this.b=50}constructor(n,r){this.g=n,this.h=r,this.c=0,this.d=[],this.e=0}addItem(n,r){n&&this.j(n,r)}addItems(n,r){n&&this.k(n,r)}j(n,r){this.d.push(n),this.e+=r,this.l()}k(n,r){this.d=this.d.concat(n),this.e+=r,this.l()}l(){this.c<c.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},c.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$5ic=c}),define(Re[119],Ae([1,0,6,3,4,287,17,59,14,2,292]),function(fe,e,S,F,P,L,R,g,f,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8ic=e.$7ic=e.$6ic=void 0,e.$6ic=(0,P.$ei)("IExtHostSearch");let k=class{constructor(s,c,t){this.k=s,this.l=c,this.n=t,this.c=this.k.getProxy(F.$ZL.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new L.$1ic}o(s){return this.l.transformOutgoingScheme(s)}registerTextSearchProvider(s,c){if(this.g.has(s))throw new Error(`a text search provider for the scheme '${s}' is already registered`);this.g.add(s);const t=this.d++;return this.e.set(t,c),this.c.$registerTextSearchProvider(t,this.o(s)),(0,S.$Rc)(()=>{this.g.delete(s),this.e.delete(t),this.c.$unregisterProvider(t)})}registerFileSearchProvider(s,c){if(this.i.has(s))throw new Error(`a file search provider for the scheme '${s}' is already registered`);this.i.add(s);const t=this.d++;return this.h.set(t,c),this.c.$registerFileSearchProvider(t,this.o(s)),(0,S.$Rc)(()=>{this.i.delete(s),this.h.delete(t),this.c.$unregisterProvider(t)})}$provideFileSearchResults(s,c,t,n){const r=l(t),a=this.h.get(s);if(a)return this.j.fileSearch(r,a,h=>{this.c.$handleFileMatch(s,c,h.map(i=>i.resource))},n);throw new Error("unknown provider: "+s)}async doInternalFileSearchWithCustomCallback(s,c,t){return{messages:[]}}$clearCache(s){return this.j.clearCache(s),Promise.resolve(void 0)}$provideTextSearchResults(s,c,t,n){const r=this.e.get(s);if(!r||!r.provideTextSearchResults)throw new Error(`Unknown provider ${s}`);const a=l(t);return this.q(a,r).search(i=>this.c.$handleTextMatch(s,c,i),n)}$enableExtensionHostSearch(){}q(s,c){return new M.$2ic(s,c,{readdir:t=>Promise.resolve([]),toCanonicalName:t=>t},"textSearchProvider")}};e.$7ic=k,e.$7ic=k=Ze([qe(0,R.$eO),qe(1,g.$Zhc),qe(2,f.$yj)],k);function l($){return{...$,folderQueries:$.folderQueries&&$.folderQueries.map(v),extraFileResources:$.extraFileResources&&$.extraFileResources.map(s=>D.URI.revive(s))}}e.$8ic=l;function v($){return{...$,folder:D.URI.revive($.folder)}}}),define(Re[293],Ae([1,0,22,15,5,6,12,32,2,147,143,131,92,20,42,14,57,58,199,3,240,271,78,241,247,225,248,249,250,226,214,31,251,38,252,118,108,253,228,242,254,255,67,65,243,39,257,63,258,43,27,272,273,244,229,259,260,79,80,231,286,262,203,263,274,264,113,232,265,266,267,17,268,119,81,269,233,270,82,84,116,61,66,275,276,245,277,278,85,8,7,234,59,235,62,279,280,107,37,209,77,23,115]),function(fe,e,S,F,P,L,R,g,f,D,M,k,l,v,$,s,c,t,n,r,a,h,i,p,u,o,E,w,m,I,d,y,b,A,T,G,W,U,C,O,V,re,ue,ye,De,he,ve,se,$e,ee,Q,q,ne,Se,Te,Ce,we,ge,J,x,le,de,Pe,me,Ie,Me,ze,N,z,K,H,te,oe,Oe,Ve,He,xe,tt,lt,rt,it,ot,Be,et,Y,X,pe,We,Xe,st,Le,Dt,Ht,Tt,Qt,Xt,It,Kt,Gt,xt,ii,Ye,Nt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kjc=void 0;function _t(ft){const vt=ft.get(Q.$uO),ei=ft.get(ee.$Jhc),Bt=ft.get(se.$8hc),jt=ft.get(he.$Eic),dt=ft.get(Gt.$3hc),Rt=ft.get(ot.$yO),ti=ft.get(A.$6hc),Yt=ft.get(Ht.$Zhc),Ke=ft.get(te.$eO),Ft=ft.get(lt.$oic),zt=ft.get(rt.$9hc),ni=ft.get(s.$zj),gt=ft.get(s.$yj),Lt=ft.get(Xe.$pAb),Ct=ft.get(i.$Fhc),Ut=ft.get(Kt.$Jjc),ri=ft.get(Ve.$wic),Ot=ft.get(ye.$fic),Vt=ft.get(J.$Aic);Ke.set(r.$1L.ExtHostFileSystemInfo,ei),Ke.set(r.$1L.ExtHostLogLevelServiceShape,ni),Ke.set(r.$1L.ExtHostWorkspace,dt),Ke.set(r.$1L.ExtHostConfiguration,ti),Ke.set(r.$1L.ExtHostExtensionService,jt),Ke.set(r.$1L.ExtHostStorage,Ft),Ke.set(r.$1L.ExtHostTunnelService,Lt),Ke.set(r.$1L.ExtHostWindow,Ut),Ke.set(r.$1L.ExtHostSecretState,ri),Ke.set(r.$1L.ExtHostTelemetry,Rt),Ke.set(r.$1L.ExtHostEditorTabs,Ot),Ke.set(r.$1L.ExtHostManagedSockets,Vt);const Pt=Ke.set(r.$1L.ExtHostDecorations,ft.get(W.$Pic)),kt=Ke.set(r.$1L.ExtHostDocumentsAndEditors,ft.get(ue.$pO)),$t=Ke.set(r.$1L.ExtHostCommands,ft.get(y.$AO)),St=Ke.set(r.$1L.ExtHostTerminalService,ft.get(Be.$ric)),wt=Ke.set(r.$1L.ExtHostDebugService,ft.get(G.$Jic)),li=Ke.set(r.$1L.ExtHostSearch,ft.get(Oe.$6ic)),Jt=Ke.set(r.$1L.ExtHostTask,ft.get(it.$wjc)),$i=Ke.set(r.$1L.ExtHostOutputService,ft.get(ze.$jjc)),be=Ke.set(r.$1L.ExtHostLocalization,ft.get(ge.$zic)),Fe=Ke.set(r.$1L.ExtHostUrls,new Tt.$Gjc(Ke)),ae=Ke.set(r.$1L.ExtHostDocuments,new re.$Mhc(Ke,kt)),Z=Ke.set(r.$1L.ExtHostDocumentContentProviders,new O.$Ric(Ke,kt,gt)),Ee=Ke.set(r.$1L.ExtHostDocumentSaveParticipant,new V.$Sic(gt,ae,Ke.getProxy(r.$ZL.MainThreadBulkEdits))),Ne=Ke.set(r.$1L.ExtHostNotebook,new le.$9ic(Ke,$t,kt,ae,Bt,li)),Qe=Ke.set(r.$1L.ExtHostNotebookDocuments,new Pe.$djc(Ne)),Ge=Ke.set(r.$1L.ExtHostNotebookEditors,new me.$ejc(gt,Ne)),at=Ke.set(r.$1L.ExtHostNotebookKernels,new Ie.$fjc(Ke,vt,Ne,$t,gt)),yt=Ke.set(r.$1L.ExtHostNotebookRenderers,new Me.$hjc(Ke,Ne)),Wt=Ke.set(r.$1L.ExtHostNotebookDocumentSaveParticipant,new de.$cjc(gt,Ne,Ke.getProxy(r.$ZL.MainThreadBulkEdits))),Et=Ke.set(r.$1L.ExtHostEditors,new Y.$Whc(Ke,kt)),At=Ke.set(r.$1L.ExtHostTreeViews,new We.$Ejc(Ke.getProxy(r.$ZL.MainThreadTreeViews),$t,gt)),Zt=Ke.set(r.$1L.ExtHostEditorInsets,new d.$Xhc(Ke.getProxy(r.$ZL.MainThreadEditorInsets),Et,vt.remote)),pi=Ke.set(r.$1L.ExtHostDiagnostics,new U.$Lhc(Ke,gt,ei,kt)),vi=Ke.set(r.$1L.ExtHostLanguages,new we.$ajc(Ke,ae,$t.converter,Yt)),ht=Ke.set(r.$1L.ExtHostLanguageFeatures,new Ce.$Nhc(Ke,Yt,ae,$t,pi,gt,Ct,Rt)),Xi=Ke.set(r.$1L.ExtHostFileSystem,new ve.$Uic(Ke,ht)),ai=Ke.set(r.$1L.ExtHostFileSystemEventService,new $e.$Vic(Ke,gt,kt)),fi=Ke.set(r.$1L.ExtHostQuickOpen,(0,H.$njc)(Ke,dt,$t)),yi=Ke.set(r.$1L.ExtHostSCM,new oe.$pjc(Ke,$t,ae,gt)),Ri=Ke.set(r.$1L.ExtHostQuickDiff,new K.$mjc(Ke,Yt)),Yi=Ke.set(r.$1L.ExtHostShare,new He.$qjc(Ke,Yt)),hn=Ke.set(r.$1L.ExtHostComments,(0,b.$Yhc)(Ke,$t,ae)),Ai=Ke.set(r.$1L.ExtHostProgress,new z.$ljc(Ke.getProxy(r.$ZL.MainThreadProgress))),Mi=Ke.set(r.$1L.ExtHostLabelService,new Te.$_ic(Ke)),Ei=Ke.set(r.$1L.ExtHostTheming,new X.$Bjc(Ke)),gi=Ke.set(r.$1L.ExtHostAuthentication,new p.$Phc(Ke)),xi=Ke.set(r.$1L.ExtHostTimeline,new pe.$Djc(Ke,$t)),Di=Ke.set(r.$1L.ExtHostWebviews,new Qt.$aic(Ke,vt.remote,dt,gt,Ct)),ki=Ke.set(r.$1L.ExtHostWebviewPanels,new Xt.$dic(Ke,Di,dt)),_i=Ke.set(r.$1L.ExtHostCustomEditors,new T.$eic(Ke,ae,zt,Di,ki)),dn=Ke.set(r.$1L.ExtHostWebviewViews,new It.$Hjc(Ke,Di)),bi=Ke.set(r.$1L.ExtHostTesting,new et.$xjc(Ke,gt,$t,kt)),Fi=Ke.set(r.$1L.ExtHostUriOpeners,new Dt.$Fjc(Ke)),Li=Ke.set(r.$1L.ExtHostProfileContentHandlers,new N.$kjc(Ke));Ke.set(r.$1L.ExtHostInteractive,new ne.$0ic(Ke,Ne,kt,$t,gt));const fn=Ke.set(r.$1L.ExtHostInlineChat,new q.$Wic(Ke,$t,ae,gt)),Si=Ke.set(r.$1L.ExtHostChatProvider,new w.$Thc(Ke,gt,gi)),en=Ke.set(r.$1L.ExtHostChatAgents2,new E.$Shc(Ke,gt,$t)),gn=Ke.set(r.$1L.ExtHostChatVariables,new m.$Uhc(Ke)),wi=Ke.set(r.$1L.ExtHostChat,new o.$Rhc(Ke)),Oi=Ke.set(r.$1L.ExtHostAiRelatedInformation,new a.$Ehc(Ke)),tn=Ke.set(r.$1L.ExtHostAiEmbeddingVector,new De.$Tic(Ke)),Ti=Ke.set(r.$1L.ExtHostIssueReporter,new Se.$$ic(Ke)),nn=Ke.set(r.$1L.ExtHostStatusBar,new tt.$tjc(Ke,$t.converter)),Ni=Ke.set(r.$1L.ExtHostSpeech,new xe.$rjc(Ke)),rn=Object.values(r.$1L);Ke.assertRegistered(rn);const hi=new u.$Qhc(Ke,kt),Ii=new I.$Vhc(Ke),ji=new x.$bjc(Ke,gt),si=new C.$Qic(Ke);return h.$Ohc.register($t),function(je,ci,zi){function nt(_){return(ce,Ue,ct)=>{const bt=_(Mt=>{try{ce.call(Ue,Mt)}catch(Ji){F.$2(new Error(`[ExtensionListenerError] Extension '${je.identifier.value}' FAILED to handle event: ${Ji.toString()}`,{cause:Ji})),Rt.onExtensionError(je.identifier,Ji)}});return ct?.push(bt),bt}}const pt=function(){let _=!je.isUnderDevelopment;function ce(){_||(gt.info(`Extension '${je.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),_=!0)}return function Ue(ct){if(Array.isArray(ct))ct.forEach(Ue);else if(typeof ct=="string")ce();else{const bt=ct;typeof bt.scheme>"u"&&ce(),typeof bt.exclusive=="boolean"&&(0,Ye.$VF)(je,"documentFiltersExclusive")}return ct}}(),mn={getSession(_,ce,Ue){return gi.getSession(je,_,ce,Ue)},getSessions(_,ce){return(0,Ye.$VF)(je,"authGetSessions"),gi.getSessions(je,_,ce)},async hasSession(_,ce){return(0,Ye.$VF)(je,"authSession"),!!await gi.getSession(je,_,ce,{silent:!0})},get onDidChangeSessions(){return nt(gi.onDidChangeSessions)},registerAuthenticationProvider(_,ce,Ue,ct){return gi.registerAuthenticationProvider(_,ce,Ue,ct)}},sn={registerCommand(_,ce,Ue){return $t.registerCommand(!0,_,ce,Ue,void 0,je)},registerTextEditorCommand(_,ce,Ue){return $t.registerCommand(!0,_,(...ct)=>{const bt=Et.getActiveTextEditor();if(!bt){gt.warn("Cannot execute "+_+" because there is no active text editor.");return}return bt.edit(Mt=>{ce.apply(Ue,[bt,Mt,...ct])}).then(Mt=>{Mt||gt.warn("Edits from command "+_+" were not applied.")},Mt=>{gt.warn("An error occurred while running command "+_,Mt)})},void 0,void 0,je)},registerDiffInformationCommand:(_,ce,Ue)=>((0,Ye.$VF)(je,"diffCommand"),$t.registerCommand(!0,_,async(...ct)=>{const bt=kt.activeEditor(!0);if(!bt){gt.warn("Cannot execute "+_+" because there is no active text editor.");return}const Mt=await Et.getDiffInformation(bt.id);ce.apply(Ue,[Mt,...ct])},void 0,void 0,je)),executeCommand(_,...ce){return $t.executeCommand(_,...ce)},getCommands(_=!1){return $t.getCommands(_)}},Ui={get machineId(){return vt.telemetryInfo.machineId},get sessionId(){return vt.telemetryInfo.sessionId},get language(){return vt.environment.appLanguage},get appName(){return vt.environment.appName},get appRoot(){return vt.environment.appRoot?.fsPath??""},get appHost(){return vt.environment.appHost},get uriScheme(){return vt.environment.appUriScheme},get clipboard(){return Ii.value},get shell(){return St.getDefaultShell(!1)},get onDidChangeShell(){return nt(St.onDidChangeShell)},get isTelemetryEnabled(){return Rt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return nt(Rt.onDidChangeTelemetryEnabled)},get telemetryConfiguration(){return(0,Ye.$VF)(je,"telemetry"),Rt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Ye.$VF)(je,"telemetry"),nt(Rt.onDidChangeTelemetryConfiguration)},get isNewAppInstall(){return(0,ot.$xO)(vt.telemetryInfo.firstSessionDate)},createTelemetryLogger(_,ce){return ot.$wO.validateSender(_),Rt.instantiateLogger(je,_,ce)},openExternal(_,ce){return Ut.openUri(_,{allowTunneling:!!vt.remote.authority,allowContributedOpeners:ce?.allowContributedOpeners})},async asExternalUri(_){if(_.scheme===vt.environment.appUriScheme)return Fe.createAppUri(_);try{return await Ut.asExternalUri(_,{allowTunneling:!!vt.remote.authority})}catch(ce){if((0,R.$og)(_,R.Schemas.http)||(0,R.$og)(_,R.Schemas.https))return _;throw ce}},get remoteName(){return(0,c.$ml)(vt.remote.authority)},get remoteAuthority(){return(0,Ye.$VF)(je,"resolvers"),vt.remote.authority},get uiKind(){return vt.uiKind},get logLevel(){return gt.getLevel()},get onDidChangeLogLevel(){return nt(gt.onDidChangeLogLevel)},registerIssueUriRequestHandler(_){return(0,Ye.$VF)(je,"handleIssueUri"),Ti.registerIssueUriRequestHandler(je,_)},registerIssueDataProvider(_){return(0,Ye.$VF)(je,"handleIssueUri"),Ti.registerIssueDataProvider(je,_)},get appQuality(){return(0,Ye.$VF)(je,"resolvers"),vt.quality},get appCommit(){return(0,Ye.$VF)(je,"resolvers"),vt.commit}};vt.environment.extensionTestsLocationURI||Object.freeze(Ui);const $n={createTestController(_,ce,Ue){return bi.createTestController(je,_,ce,Ue)},createTestObserver(){return(0,Ye.$VF)(je,"testObserver"),bi.createTestObserver()},runTests(_){return(0,Ye.$VF)(je,"testObserver"),bi.runTests(_)},get onDidChangeTestResults(){return(0,Ye.$VF)(je,"testObserver"),nt(bi.onResultsChanged)},get testResults(){return(0,Ye.$VF)(je,"testObserver"),bi.results}},Ci=vt.remote.isRemote?Le.ExtensionKind.Workspace:Le.ExtensionKind.UI,on={getExtension(_,ce){(0,Ye.$UF)(je,"extensionsAny")||(ce=!1);const Ue=ci.mine.getExtensionDescription(_);if(Ue)return new he.$Fic(jt,je.identifier,Ue,Ci,!1);if(ce){const ct=ci.all.getExtensionDescription(_);if(ct)return new he.$Fic(jt,je.identifier,ct,Ci,!0)}},get all(){const _=[];for(const ce of ci.mine.getAllExtensionDescriptions())_.push(new he.$Fic(jt,je.identifier,ce,Ci,!1));return _},get allAcrossExtensionHosts(){(0,Ye.$VF)(je,"extensionsAny");const _=new v.$xm(ci.mine.getAllExtensionDescriptions().map(Ue=>Ue.identifier)),ce=[];for(const Ue of ci.all.getAllExtensionDescriptions()){const ct=!_.has(Ue.identifier);ce.push(new he.$Fic(jt,je.identifier,Ue,Ci,ct))}return ce},get onDidChange(){return(0,Ye.$UF)(je,"extensionsAny")?nt(P.Event.any(ci.mine.onDidChange,ci.all.onDidChange)):nt(ci.mine.onDidChange)}},Bi={createDiagnosticCollection(_){return pi.createDiagnosticCollection(je.identifier,_)},get onDidChangeDiagnostics(){return nt(pi.onDidChangeDiagnostics)},getDiagnostics:_=>pi.getDiagnostics(_),getLanguages(){return vi.getLanguages()},setTextDocumentLanguage(_,ce){return vi.changeLanguage(_.uri,ce)},match(_,ce){const Ue=st.LanguageSelector.from(_);let ct;return(0,M.$Nt)(Ue)&&(ct=Ne.notebookDocuments.find(bt=>bt.apiNotebook.getCells().find(Mt=>Mt.document===ce))?.apiNotebook),(0,M.$Mt)(Ue,ce.uri,ce.languageId,!0,ct?.uri,ct?.notebookType)},registerCodeActionsProvider(_,ce,Ue){return ht.registerCodeActionProvider(je,pt(_),ce,Ue)},registerDocumentPasteEditProvider(_,ce,Ue){return(0,Ye.$VF)(je,"documentPaste"),ht.registerDocumentPasteEditProvider(je,pt(_),ce,Ue)},registerCodeLensProvider(_,ce){return ht.registerCodeLensProvider(je,pt(_),ce)},registerDefinitionProvider(_,ce){return ht.registerDefinitionProvider(je,pt(_),ce)},registerDeclarationProvider(_,ce){return ht.registerDeclarationProvider(je,pt(_),ce)},registerImplementationProvider(_,ce){return ht.registerImplementationProvider(je,pt(_),ce)},registerTypeDefinitionProvider(_,ce){return ht.registerTypeDefinitionProvider(je,pt(_),ce)},registerHoverProvider(_,ce){return ht.registerHoverProvider(je,pt(_),ce,je.identifier)},registerEvaluatableExpressionProvider(_,ce){return ht.registerEvaluatableExpressionProvider(je,pt(_),ce,je.identifier)},registerInlineValuesProvider(_,ce){return ht.registerInlineValuesProvider(je,pt(_),ce,je.identifier)},registerDocumentHighlightProvider(_,ce){return ht.registerDocumentHighlightProvider(je,pt(_),ce)},registerMultiDocumentHighlightProvider(_,ce){return ht.registerMultiDocumentHighlightProvider(je,pt(_),ce)},registerLinkedEditingRangeProvider(_,ce){return ht.registerLinkedEditingRangeProvider(je,pt(_),ce)},registerReferenceProvider(_,ce){return ht.registerReferenceProvider(je,pt(_),ce)},registerRenameProvider(_,ce){return ht.registerRenameProvider(je,pt(_),ce)},registerNewSymbolNamesProvider(_,ce){return(0,Ye.$VF)(je,"newSymbolNamesProvider"),ht.registerNewSymbolNamesProvider(je,pt(_),ce)},registerDocumentSymbolProvider(_,ce,Ue){return ht.registerDocumentSymbolProvider(je,pt(_),ce,Ue)},registerWorkspaceSymbolProvider(_){return ht.registerWorkspaceSymbolProvider(je,_)},registerDocumentFormattingEditProvider(_,ce){return ht.registerDocumentFormattingEditProvider(je,pt(_),ce)},registerDocumentRangeFormattingEditProvider(_,ce){return ht.registerDocumentRangeFormattingEditProvider(je,pt(_),ce)},registerOnTypeFormattingEditProvider(_,ce,Ue,...ct){return ht.registerOnTypeFormattingEditProvider(je,pt(_),ce,[Ue].concat(ct))},registerDocumentSemanticTokensProvider(_,ce,Ue){return ht.registerDocumentSemanticTokensProvider(je,pt(_),ce,Ue)},registerDocumentRangeSemanticTokensProvider(_,ce,Ue){return ht.registerDocumentRangeSemanticTokensProvider(je,pt(_),ce,Ue)},registerSignatureHelpProvider(_,ce,Ue,...ct){return typeof Ue=="object"?ht.registerSignatureHelpProvider(je,pt(_),ce,Ue):ht.registerSignatureHelpProvider(je,pt(_),ce,typeof Ue>"u"?[]:[Ue,...ct])},registerCompletionItemProvider(_,ce,...Ue){return ht.registerCompletionItemProvider(je,pt(_),ce,Ue)},registerInlineCompletionItemProvider(_,ce,Ue){return ce.handleDidShowCompletionItem&&(0,Ye.$VF)(je,"inlineCompletionsAdditions"),ce.handleDidPartiallyAcceptCompletionItem&&(0,Ye.$VF)(je,"inlineCompletionsAdditions"),Ue&&(0,Ye.$VF)(je,"inlineCompletionsAdditions"),ht.registerInlineCompletionsProvider(je,pt(_),ce,Ue)},registerInlineEditProvider(_,ce){return(0,Ye.$VF)(je,"inlineEdit"),ht.registerInlineEditProvider(je,pt(_),ce)},registerDocumentLinkProvider(_,ce){return ht.registerDocumentLinkProvider(je,pt(_),ce)},registerColorProvider(_,ce){return ht.registerColorProvider(je,pt(_),ce)},registerFoldingRangeProvider(_,ce){return ht.registerFoldingRangeProvider(je,pt(_),ce)},registerSelectionRangeProvider(_,ce){return ht.registerSelectionRangeProvider(je,_,ce)},registerCallHierarchyProvider(_,ce){return ht.registerCallHierarchyProvider(je,_,ce)},registerTypeHierarchyProvider(_,ce){return ht.registerTypeHierarchyProvider(je,_,ce)},setLanguageConfiguration:(_,ce)=>ht.setLanguageConfiguration(je,_,ce),getTokenInformationAtPosition(_,ce){return(0,Ye.$VF)(je,"tokenInformation"),vi.tokenAtPosition(_,ce)},registerInlayHintsProvider(_,ce){return ht.registerInlayHintsProvider(je,_,ce)},createLanguageStatusItem(_,ce){return vi.createLanguageStatusItem(je,_,ce)},registerDocumentDropEditProvider(_,ce,Ue){return ht.registerDocumentOnDropEditProvider(je,_,ce,(0,Ye.$UF)(je,"dropMetadata")?Ue:void 0)}},an={get activeTextEditor(){return Et.getActiveTextEditor()},get visibleTextEditors(){return Et.getVisibleTextEditors()},get activeTerminal(){return St.activeTerminal},get terminals(){return St.terminals},async showTextDocument(_,ce,Ue){f.URI.isUri(_)&&_.scheme===R.Schemas.vscodeRemote&&!_.authority&&Ct.report("workspace.showTextDocument",je,"A URI of 'vscode-remote' scheme requires an authority.");const ct=await(f.URI.isUri(_)?Promise.resolve(Vi.openTextDocument(_)):Promise.resolve(_));return Et.showTextDocument(ct,ce,Ue)},createTextEditorDecorationType(_){return Et.createTextEditorDecorationType(je,_)},onDidChangeActiveTextEditor(_,ce,Ue){return nt(Et.onDidChangeActiveTextEditor)(_,ce,Ue)},onDidChangeVisibleTextEditors(_,ce,Ue){return nt(Et.onDidChangeVisibleTextEditors)(_,ce,Ue)},onDidChangeTextEditorSelection(_,ce,Ue){return nt(Et.onDidChangeTextEditorSelection)(_,ce,Ue)},onDidChangeTextEditorOptions(_,ce,Ue){return nt(Et.onDidChangeTextEditorOptions)(_,ce,Ue)},onDidChangeTextEditorVisibleRanges(_,ce,Ue){return nt(Et.onDidChangeTextEditorVisibleRanges)(_,ce,Ue)},onDidChangeTextEditorViewColumn(_,ce,Ue){return nt(Et.onDidChangeTextEditorViewColumn)(_,ce,Ue)},onDidCloseTerminal(_,ce,Ue){return nt(St.onDidCloseTerminal)(_,ce,Ue)},onDidOpenTerminal(_,ce,Ue){return nt(St.onDidOpenTerminal)(_,ce,Ue)},onDidChangeActiveTerminal(_,ce,Ue){return nt(St.onDidChangeActiveTerminal)(_,ce,Ue)},onDidChangeTerminalDimensions(_,ce,Ue){return(0,Ye.$VF)(je,"terminalDimensions"),nt(St.onDidChangeTerminalDimensions)(_,ce,Ue)},onDidChangeTerminalState(_,ce,Ue){return nt(St.onDidChangeTerminalState)(_,ce,Ue)},onDidWriteTerminalData(_,ce,Ue){return(0,Ye.$VF)(je,"terminalDataWriteEvent"),nt(St.onDidWriteTerminalData)(_,ce,Ue)},onDidExecuteTerminalCommand(_,ce,Ue){return(0,Ye.$VF)(je,"terminalExecuteCommandEvent"),nt(St.onDidExecuteTerminalCommand)(_,ce,Ue)},get state(){return Ut.getState(je)},onDidChangeWindowState(_,ce,Ue){return nt(Ut.onDidChangeWindowState)(_,ce,Ue)},showInformationMessage(_,...ce){return ji.showMessage(je,g.default.Info,_,ce[0],ce.slice(1))},showWarningMessage(_,...ce){return ji.showMessage(je,g.default.Warning,_,ce[0],ce.slice(1))},showErrorMessage(_,...ce){return ji.showMessage(je,g.default.Error,_,ce[0],ce.slice(1))},showQuickPick(_,ce,Ue){return fi.showQuickPick(je,_,ce,Ue)},showWorkspaceFolderPick(_){return fi.showWorkspaceFolderPick(_)},showInputBox(_,ce){return fi.showInput(_,ce)},showOpenDialog(_){return si.showOpenDialog(je,_)},showSaveDialog(_){return si.showSaveDialog(_)},createStatusBarItem(_,ce,Ue){let ct,bt,Mt;return typeof _=="string"?(ct=_,bt=ce,Mt=Ue):(bt=_,Mt=ce),nn.createStatusBarEntry(je,ct,bt,Mt)},setStatusBarMessage(_,ce){return nn.setStatusBarMessage(_,ce)},withScmProgress(_){return Ct.report("window.withScmProgress",je,"Use 'withProgress' instead."),Ai.withProgress(je,{location:Le.ProgressLocation.SourceControl},(ce,Ue)=>_({report(ct){}}))},withProgress(_,ce){return Ai.withProgress(je,_,ce)},createOutputChannel(_,ce){return $i.createOutputChannel(_,ce,je)},createWebviewPanel(_,ce,Ue,ct){return ki.createWebviewPanel(je,_,ce,Ue,ct)},createWebviewTextEditorInset(_,ce,Ue,ct){return(0,Ye.$VF)(je,"editorInsets"),Zt.createWebviewEditorInset(_,ce,Ue,ct,je)},createTerminal(_,ce,Ue){return typeof _=="object"?"pty"in _?St.createExtensionTerminal(_):St.createTerminalFromOptions(_):St.createTerminal(_,ce,Ue)},registerTerminalLinkProvider(_){return St.registerLinkProvider(_)},registerTerminalProfileProvider(_,ce){return St.registerProfileProvider(je,_,ce)},registerTerminalQuickFixProvider(_,ce){return(0,Ye.$VF)(je,"terminalQuickFixProvider"),St.registerTerminalQuickFixProvider(_,je.identifier.value,ce)},registerTreeDataProvider(_,ce){return At.registerTreeDataProvider(_,ce,je)},createTreeView(_,ce){return At.createTreeView(_,ce,je)},registerWebviewPanelSerializer:(_,ce)=>ki.registerWebviewPanelSerializer(je,_,ce),registerCustomEditorProvider:(_,ce,Ue={})=>_i.registerCustomEditorProvider(je,_,ce,Ue),registerFileDecorationProvider(_){return Pt.registerFileDecorationProvider(_,je)},registerUriHandler(_){return Fe.registerUriHandler(je,_)},createQuickPick(){return fi.createQuickPick(je)},createInputBox(){return fi.createInputBox(je)},get activeColorTheme(){return Ei.activeColorTheme},onDidChangeActiveColorTheme(_,ce,Ue){return nt(Ei.onDidChangeActiveColorTheme)(_,ce,Ue)},registerWebviewViewProvider(_,ce,Ue){return dn.registerWebviewViewProvider(je,_,ce,Ue?.webviewOptions)},get activeNotebookEditor(){return Ne.activeNotebookEditor},onDidChangeActiveNotebookEditor(_,ce,Ue){return nt(Ne.onDidChangeActiveNotebookEditor)(_,ce,Ue)},get visibleNotebookEditors(){return Ne.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return nt(Ne.onDidChangeVisibleNotebookEditors)},onDidChangeNotebookEditorSelection(_,ce,Ue){return nt(Ge.onDidChangeNotebookEditorSelection)(_,ce,Ue)},onDidChangeNotebookEditorVisibleRanges(_,ce,Ue){return nt(Ge.onDidChangeNotebookEditorVisibleRanges)(_,ce,Ue)},showNotebookDocument(_,ce){return Ne.showNotebookDocument(_,ce)},registerExternalUriOpener(_,ce,Ue){return(0,Ye.$VF)(je,"externalUriOpener"),Fi.registerExternalUriOpener(je.identifier,_,ce,Ue)},registerProfileContentHandler(_,ce){return(0,Ye.$VF)(je,"profileContentHandlers"),Li.registerProfileContentHandler(je,_,ce)},registerQuickDiffProvider(_,ce,Ue,ct){return(0,Ye.$VF)(je,"quickDiffProvider"),Ri.registerQuickDiffProvider(pt(_),ce,Ue,ct)},get tabGroups(){return Ot.tabGroups},registerShareProvider(_,ce){return(0,Ye.$VF)(je,"shareProvider"),Yi.registerShareProvider(pt(_),ce)}},Vi={get rootPath(){return Ct.report("workspace.rootPath",je,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),dt.getPath()},set rootPath(_){throw new F.$9("rootPath")},getWorkspaceFolder(_){return dt.getWorkspaceFolder(_)},get workspaceFolders(){return dt.getWorkspaceFolders()},get name(){return dt.name},set name(_){throw new F.$9("name")},get workspaceFile(){return dt.workspaceFile},set workspaceFile(_){throw new F.$9("workspaceFile")},updateWorkspaceFolders:(_,ce,...Ue)=>dt.updateWorkspaceFolders(je,_,ce||0,...Ue),onDidChangeWorkspaceFolders:function(_,ce,Ue){return nt(dt.onDidChangeWorkspace)(_,ce,Ue)},asRelativePath:(_,ce)=>dt.getRelativePath(_,ce),findFiles:(_,ce,Ue,ct)=>dt.findFiles(_,ce,Ue,je.identifier,ct),findFiles2:(_,ce,Ue)=>((0,Ye.$VF)(je,"findFiles2"),dt.findFiles2(_,ce,je.identifier,Ue)),findTextInFiles:(_,ce,Ue,ct)=>{(0,Ye.$VF)(je,"findTextInFiles");let bt,Mt;return typeof ce=="object"?(bt=ce,Mt=Ue):(bt={},Mt=ce,ct=Ue),dt.findTextInFiles(_,bt||{},Mt,je.identifier,ct)},save:_=>dt.save(_),saveAs:_=>dt.saveAs(_),saveAll:_=>dt.saveAll(_),applyEdit(_,ce){return hi.applyWorkspaceEdit(_,je,ce)},createFileSystemWatcher:(_,ce,Ue,ct)=>{let bt;return typeof ce=="boolean"?bt={ignoreCreateEvents:!!ce,ignoreChangeEvents:!!Ue,ignoreDeleteEvents:!!ct,correlate:!1}:ce&&((0,Ye.$VF)(je,"createFileSystemWatcher"),bt={...ce,correlate:!0}),ai.createFileSystemWatcher(dt,je,_,bt)},get textDocuments(){return ae.getAllDocumentData().map(_=>_.document)},set textDocuments(_){throw new F.$9("textDocuments")},openTextDocument(_){let ce;const Ue=_;if(typeof _=="string")ce=Promise.resolve(f.URI.file(_));else if(f.URI.isUri(_))ce=Promise.resolve(_);else if(!Ue||typeof Ue=="object")ce=ae.createDocumentData(Ue);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ce.then(ct=>(ct.scheme===R.Schemas.vscodeRemote&&!ct.authority&&Ct.report("workspace.openTextDocument",je,"A URI of 'vscode-remote' scheme requires an authority."),ae.ensureDocumentData(ct).then(bt=>bt.document)))},onDidOpenTextDocument:(_,ce,Ue)=>nt(ae.onDidAddDocument)(_,ce,Ue),onDidCloseTextDocument:(_,ce,Ue)=>nt(ae.onDidRemoveDocument)(_,ce,Ue),onDidChangeTextDocument:(_,ce,Ue)=>nt(ae.onDidChangeDocument)(_,ce,Ue),onDidSaveTextDocument:(_,ce,Ue)=>nt(ae.onDidSaveDocument)(_,ce,Ue),onWillSaveTextDocument:(_,ce,Ue)=>nt(Ee.getOnWillSaveTextDocumentEvent(je))(_,ce,Ue),get notebookDocuments(){return Ne.notebookDocuments.map(_=>_.apiNotebook)},async openNotebookDocument(_,ce){let Ue;if(f.URI.isUri(_))Ue=_,await Ne.openNotebookDocument(_);else if(typeof _=="string")Ue=f.URI.revive(await Ne.createNotebookDocument({viewType:_,content:ce}));else throw new Error("Invalid arguments");return Ne.getNotebookDocument(Ue).apiNotebook},onDidSaveNotebookDocument(_,ce,Ue){return nt(Qe.onDidSaveNotebookDocument)(_,ce,Ue)},onDidChangeNotebookDocument(_,ce,Ue){return nt(Qe.onDidChangeNotebookDocument)(_,ce,Ue)},onWillSaveNotebookDocument(_,ce,Ue){return nt(Wt.getOnWillSaveNotebookDocumentEvent(je))(_,ce,Ue)},get onDidOpenNotebookDocument(){return nt(Ne.onDidOpenNotebookDocument)},get onDidCloseNotebookDocument(){return nt(Ne.onDidCloseNotebookDocument)},registerNotebookSerializer(_,ce,Ue,ct){return Ne.registerNotebookSerializer(je,_,ce,Ue,(0,Ye.$UF)(je,"notebookLiveShare")?ct:void 0)},onDidChangeConfiguration:(_,ce,Ue)=>nt(zi.onDidChangeConfiguration)(_,ce,Ue),getConfiguration(_,ce){return ce=arguments.length===1?void 0:ce,zi.getConfiguration(_,ce,je)},registerTextDocumentContentProvider(_,ce){return Z.registerTextDocumentContentProvider(_,ce)},registerTaskProvider:(_,ce)=>(Ct.report("window.registerTaskProvider",je,"Use the corresponding function on the 'tasks' namespace instead"),Jt.registerTaskProvider(je,_,ce)),registerFileSystemProvider(_,ce,Ue){return(0,L.$Qc)(Xi.registerFileSystemProvider(je,_,ce,Ue),Bt.addFileSystemProvider(_,ce,Ue))},get fs(){return Bt.value},registerFileSearchProvider:(_,ce)=>((0,Ye.$VF)(je,"fileSearchProvider"),li.registerFileSearchProvider(_,ce)),registerTextSearchProvider:(_,ce)=>((0,Ye.$VF)(je,"textSearchProvider"),li.registerTextSearchProvider(_,ce)),registerRemoteAuthorityResolver:(_,ce)=>((0,Ye.$VF)(je,"resolvers"),jt.registerRemoteAuthorityResolver(_,ce)),registerResourceLabelFormatter:_=>((0,Ye.$VF)(je,"resolvers"),Mi.$registerResourceLabelFormatter(_)),getRemoteExecServer:_=>((0,Ye.$VF)(je,"resolvers"),jt.getRemoteExecServer(_)),onDidCreateFiles:(_,ce,Ue)=>nt(ai.onDidCreateFile)(_,ce,Ue),onDidDeleteFiles:(_,ce,Ue)=>nt(ai.onDidDeleteFile)(_,ce,Ue),onDidRenameFiles:(_,ce,Ue)=>nt(ai.onDidRenameFile)(_,ce,Ue),onWillCreateFiles:(_,ce,Ue)=>nt(ai.getOnWillCreateFileEvent(je))(_,ce,Ue),onWillDeleteFiles:(_,ce,Ue)=>nt(ai.getOnWillDeleteFileEvent(je))(_,ce,Ue),onWillRenameFiles:(_,ce,Ue)=>nt(ai.getOnWillRenameFileEvent(je))(_,ce,Ue),openTunnel:_=>((0,Ye.$VF)(je,"tunnels"),Lt.openTunnel(je,_).then(ce=>{if(!ce)throw new Error("cannot open tunnel");return ce})),get tunnels(){return(0,Ye.$VF)(je,"tunnels"),Lt.getTunnels()},onDidChangeTunnels:(_,ce,Ue)=>((0,Ye.$VF)(je,"tunnels"),nt(Lt.onDidChangeTunnels)(_,ce,Ue)),registerPortAttributesProvider:(_,ce)=>((0,Ye.$VF)(je,"portsAttributes"),Lt.registerPortsAttributesProvider(_,ce)),registerTunnelProvider:(_,ce)=>((0,Ye.$VF)(je,"tunnelFactory"),Lt.registerTunnelProvider(_,ce)),registerTimelineProvider:(_,ce)=>((0,Ye.$VF)(je,"timeline"),xi.registerTimelineProvider(_,ce,je.identifier,$t.converter)),get isTrusted(){return dt.trusted},requestWorkspaceTrust:_=>((0,Ye.$VF)(je,"workspaceTrust"),dt.requestWorkspaceTrust(_)),onDidGrantWorkspaceTrust:(_,ce,Ue)=>nt(dt.onDidGrantWorkspaceTrust)(_,ce,Ue),registerEditSessionIdentityProvider:(_,ce)=>((0,Ye.$VF)(je,"editSessionIdentityProvider"),dt.registerEditSessionIdentityProvider(_,ce)),onWillCreateEditSessionIdentity:(_,ce,Ue)=>((0,Ye.$VF)(je,"editSessionIdentityProvider"),nt(dt.getOnWillCreateEditSessionIdentityEvent(je))(_,ce,Ue)),registerCanonicalUriProvider:(_,ce)=>((0,Ye.$VF)(je,"canonicalUriProvider"),dt.registerCanonicalUriProvider(_,ce)),getCanonicalUri:(_,ce,Ue)=>((0,Ye.$VF)(je,"canonicalUriProvider"),dt.provideCanonicalUri(_,ce,Ue))},cn={get inputBox(){return Ct.report("scm.inputBox",je,"Use 'SourceControl.inputBox' instead"),yi.getLastInputBox(je)},createSourceControl(_,ce,Ue){return yi.createSourceControl(je,_,ce,Ue)}},pn={createCommentController(_,ce){return hn.createCommentController(je,_,ce)}},vn={get activeDebugSession(){return wt.activeDebugSession},get activeDebugConsole(){return wt.activeDebugConsole},get breakpoints(){return wt.breakpoints},get stackFrameFocus(){return wt.stackFrameFocus},registerDebugVisualizationProvider(_,ce){return(0,Ye.$VF)(je,"debugVisualization"),wt.registerDebugVisualizationProvider(je,_,ce)},registerDebugVisualizationTreeProvider(_,ce){return(0,Ye.$VF)(je,"debugVisualization"),wt.registerDebugVisualizationTree(je,_,ce)},onDidStartDebugSession(_,ce,Ue){return nt(wt.onDidStartDebugSession)(_,ce,Ue)},onDidTerminateDebugSession(_,ce,Ue){return nt(wt.onDidTerminateDebugSession)(_,ce,Ue)},onDidChangeActiveDebugSession(_,ce,Ue){return nt(wt.onDidChangeActiveDebugSession)(_,ce,Ue)},onDidReceiveDebugSessionCustomEvent(_,ce,Ue){return nt(wt.onDidReceiveDebugSessionCustomEvent)(_,ce,Ue)},onDidChangeBreakpoints(_,ce,Ue){return nt(wt.onDidChangeBreakpoints)(_,ce,Ue)},onDidChangeStackFrameFocus(_,ce,Ue){return(0,Ye.$VF)(je,"debugFocus"),nt(wt.onDidChangeStackFrameFocus)(_,ce,Ue)},registerDebugConfigurationProvider(_,ce,Ue){return wt.registerDebugConfigurationProvider(_,ce,Ue||xt.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(_,ce){return wt.registerDebugAdapterDescriptorFactory(je,_,ce)},registerDebugAdapterTrackerFactory(_,ce){return wt.registerDebugAdapterTrackerFactory(_,ce)},startDebugging(_,ce,Ue){return!Ue||typeof Ue=="object"&&"configuration"in Ue?wt.startDebugging(_,ce,{parentSession:Ue}):wt.startDebugging(_,ce,Ue||{})},stopDebugging(_){return wt.stopDebugging(_)},addBreakpoints(_){return wt.addBreakpoints(_)},removeBreakpoints(_){return wt.removeBreakpoints(_)},asDebugSourceUri(_,ce){return wt.asDebugSourceUri(_,ce)}},un={registerTaskProvider:(_,ce)=>Jt.registerTaskProvider(je,_,ce),fetchTasks:_=>Jt.fetchTasks(_),executeTask:_=>Jt.executeTask(je,_),get taskExecutions(){return Jt.taskExecutions},onDidStartTask:(_,ce,Ue)=>nt(Jt.onDidStartTask)(_,ce,Ue),onDidEndTask:(_,ce,Ue)=>nt(Jt.onDidEndTask)(_,ce,Ue),onDidStartTaskProcess:(_,ce,Ue)=>nt(Jt.onDidStartTaskProcess)(_,ce,Ue),onDidEndTaskProcess:(_,ce,Ue)=>nt(Jt.onDidEndTaskProcess)(_,ce,Ue)},ln={createNotebookController(_,ce,Ue,ct,bt){return at.createNotebookController(je,_,ce,Ue,ct,(0,Ye.$UF)(je,"notebookMessaging")?bt:void 0)},registerNotebookCellStatusBarItemProvider:(_,ce)=>Ne.registerNotebookCellStatusBarItemProvider(je,_,ce),createRendererMessaging(_){return yt.createRendererMessaging(je,_)},createNotebookControllerDetectionTask(_){return(0,Ye.$VF)(je,"notebookKernelSource"),at.createNotebookControllerDetectionTask(je,_)},registerKernelSourceActionProvider(_,ce){return(0,Ye.$VF)(je,"notebookKernelSource"),at.registerKernelSourceActionProvider(je,_,ce)},onDidChangeNotebookCellExecutionState(_,ce,Ue){return(0,Ye.$VF)(je,"notebookCellExecutionState"),nt(at.onDidChangeNotebookCellExecutionState)(_,ce,Ue)}},Wi={t(..._){if(typeof _[0]=="string"){const ce=_.shift(),Ue=!_||typeof _[0]!="object"?_:_[0];return be.getMessage(je.identifier.value,{message:ce,args:Ue})}return be.getMessage(je.identifier.value,_[0])},get bundle(){return be.getBundle(je.identifier.value)},get uri(){return be.getBundleUri(je.identifier.value)}},qi={_version:1,registerInteractiveEditorSessionProvider(_,ce){return(0,Ye.$VF)(je,"interactive"),fn.registerProvider(je,_,ce)},registerInteractiveSessionProvider(_,ce){return(0,Ye.$VF)(je,"interactive"),wi.registerChatProvider(je,_,ce)},sendInteractiveRequestToProvider(_,ce){return(0,Ye.$VF)(je,"interactive"),wi.sendInteractiveRequestToProvider(_,ce)},transferChatSession(_,ce){return(0,Ye.$VF)(je,"interactive"),wi.transferChatSession(_,ce)}},Hi={getRelatedInformation(_,ce){return(0,Ye.$VF)(je,"aiRelatedInformation"),Oi.getRelatedInformation(je,_,ce)},registerRelatedInformationProvider(_,ce){return(0,Ye.$VF)(je,"aiRelatedInformation"),Oi.registerRelatedInformationProvider(je,_,ce)},registerEmbeddingVectorProvider(_,ce){return(0,Ye.$VF)(je,"aiRelatedInformation"),tn.registerEmbeddingVectorProvider(je,_,ce)}},Pi={registerChatResponseProvider(_,ce,Ue){return(0,Ye.$VF)(je,"chatProvider"),Si.registerLanguageModel(je,_,ce,Ue)},registerChatVariableResolver(_,ce,Ue){return(0,Ye.$VF)(je,"chatVariableResolver"),gn.registerVariableResolver(je,_,ce,Ue)},registerMappedEditsProvider(_,ce){return(0,Ye.$VF)(je,"mappedEditsProvider"),ht.registerMappedEditsProvider(je,_,ce)},createChatParticipant(_,ce){return(0,Ye.$VF)(je,"chatParticipant"),en.createChatAgent(je,_,ce)}},Ki={requestLanguageModelAccess(_,ce){return(0,Ye.$VF)(je,"languageModels"),Si.requestLanguageModelAccess(je,_,ce)},get languageModels(){return(0,Ye.$VF)(je,"languageModels"),Si.getLanguageModelIds()},onDidChangeLanguageModels:(_,ce,Ue)=>((0,Ye.$VF)(je,"languageModels"),Si.onDidChangeProviders(_,ce,Ue))},Gi={registerSpeechProvider(_,ce){return(0,Ye.$VF)(je,"speech"),Ni.registerProvider(je.identifier,_,ce)}};return{version:vt.version,ai:Hi,authentication:mn,commands:sn,comments:pn,chat:Pi,debug:vn,env:Ui,extensions:on,interactive:qi,l10n:Wi,languages:Bi,lm:Ki,notebooks:ln,scm:cn,speech:Gi,tasks:un,tests:$n,window:an,workspace:Vi,Breakpoint:Le.$1M,TerminalOutputAnchor:Le.TerminalOutputAnchor,ChatResultFeedbackKind:Le.ChatResultFeedbackKind,ChatVariableLevel:Le.ChatVariableLevel,ChatCompletionItem:Le.$TN,CallHierarchyIncomingCall:Le.$nM,CallHierarchyItem:Le.$mM,CallHierarchyOutgoingCall:Le.$oM,CancellationError:F.$5,CancellationTokenSource:S.$ce,CandidatePortSource:r.CandidatePortSource,CodeAction:Le.$jM,CodeActionKind:Le.$kM,CodeActionTriggerKind:Le.CodeActionTriggerKind,CodeLens:Le.$pM,Color:Le.$CM,ColorInformation:Le.$DM,ColorPresentation:Le.$EM,ColorThemeKind:Le.ColorThemeKind,CommentMode:Le.CommentMode,CommentState:Le.CommentState,CommentThreadCollapsibleState:Le.CommentThreadCollapsibleState,CommentThreadState:Le.CommentThreadState,CompletionItem:Le.$wM,CompletionItemKind:Le.CompletionItemKind,CompletionItemTag:Le.CompletionItemTag,CompletionList:Le.$xM,CompletionTriggerKind:Le.CompletionTriggerKind,ConfigurationTarget:Le.ConfigurationTarget,CustomExecution:Le.$MM,DebugAdapterExecutable:Le.$5M,DebugAdapterInlineImplementation:Le.$8M,DebugAdapterNamedPipeServer:Le.$7M,DebugAdapterServer:Le.$6M,DebugConfigurationProviderTriggerKind:xt.DebugConfigurationProviderTriggerKind,DebugConsoleMode:Le.DebugConsoleMode,DebugVisualization:Le.$lN,DecorationRangeBehavior:Le.DecorationRangeBehavior,Diagnostic:Le.$dM,DiagnosticRelatedInformation:Le.$cM,DiagnosticSeverity:Le.DiagnosticSeverity,DiagnosticTag:Le.DiagnosticTag,Disposable:Le.$2L,DocumentHighlight:Le.$fM,DocumentHighlightKind:Le.DocumentHighlightKind,MultiDocumentHighlight:Le.$gM,DocumentLink:Le.$BM,DocumentSymbol:Le.$iM,EndOfLine:Le.EndOfLine,EnvironmentVariableMutatorType:Le.EnvironmentVariableMutatorType,EvaluatableExpression:Le.$$M,InlineValueText:Le.$_M,InlineValueVariableLookup:Le.$aN,InlineValueEvaluatableExpression:Le.$bN,InlineCompletionTriggerKind:Le.InlineCompletionTriggerKind,EventEmitter:P.$5d,ExtensionKind:Le.ExtensionKind,ExtensionMode:Le.ExtensionMode,ExternalUriOpenerPriority:Le.ExternalUriOpenerPriority,FileChangeType:Le.FileChangeType,FileDecoration:Le.$nN,FileDecoration2:Le.$nN,FileSystemError:Le.$eN,FileType:$.FileType,FilePermission:$.FilePermission,FoldingRange:Le.$fN,FoldingRangeKind:Le.FoldingRangeKind,FunctionBreakpoint:Le.$3M,InlineCompletionItem:Le.$yM,InlineCompletionList:Le.$zM,Hover:Le.$eM,IndentAction:k.IndentAction,Location:Le.$bM,MarkdownString:Le.$qM,OverviewRulerLane:l.OverviewRulerLane,ParameterInformation:Le.$rM,PortAutoForwardAction:Le.PortAutoForwardAction,Position:Le.$3L,ProcessExecution:Le.$KM,ProgressLocation:Le.ProgressLocation,QuickInputButtons:Le.$mN,Range:Le.$4L,RelativePattern:Le.$YM,Selection:Le.$5L,SelectionRange:Le.$lM,SemanticTokens:Le.$iN,SemanticTokensBuilder:Le.$hN,SemanticTokensEdit:Le.$jN,SemanticTokensEdits:Le.$kN,SemanticTokensLegend:Le.$gN,ShellExecution:Le.$LM,ShellQuoting:Le.ShellQuoting,SignatureHelp:Le.$tM,SignatureHelpTriggerKind:Le.SignatureHelpTriggerKind,SignatureInformation:Le.$sM,SnippetString:Le.$aM,SourceBreakpoint:Le.$2M,StandardTokenType:Le.StandardTokenType,StatusBarAlignment:Le.StatusBarAlignment,SymbolInformation:Le.$hM,SymbolKind:Le.SymbolKind,SymbolTag:Le.SymbolTag,Task:Le.$NM,TaskGroup:Le.$JM,TaskPanelKind:Le.TaskPanelKind,TaskRevealKind:Le.TaskRevealKind,TaskScope:Le.TaskScope,TerminalLink:Le.$FM,TerminalQuickFixTerminalCommand:Le.$HM,TerminalQuickFixOpener:Le.$GM,TerminalLocation:Le.TerminalLocation,TerminalProfile:Le.$IM,TerminalExitReason:Le.TerminalExitReason,TextDocumentSaveReason:Le.TextDocumentSaveReason,TextEdit:Le.$9L,SnippetTextEdit:Le.$$L,TextEditorCursorStyle:D.TextEditorCursorStyle,TextEditorLineNumbersStyle:Le.TextEditorLineNumbersStyle,TextEditorRevealType:Le.TextEditorRevealType,TextEditorSelectionChangeKind:Le.TextEditorSelectionChangeKind,SyntaxTokenType:Le.SyntaxTokenType,TextDocumentChangeReason:Le.TextDocumentChangeReason,ThemeColor:Le.$XM,ThemeIcon:Le.$WM,TreeItem:Le.$OM,TreeItemCheckboxState:Le.TreeItemCheckboxState,TreeItemCollapsibleState:Le.TreeItemCollapsibleState,TypeHierarchyItem:Le.$IN,UIKind:ii.UIKind,Uri:f.URI,ViewColumn:Le.ViewColumn,WorkspaceEdit:Le.$_L,DocumentDropEdit:Le.$UM,DocumentPasteEdit:Le.$VM,InlayHint:Le.$vM,InlayHintLabelPart:Le.$uM,InlayHintKind:Le.InlayHintKind,RemoteAuthorityResolverError:Le.$8L,ResolvedAuthority:Le.$6L,ManagedResolvedAuthority:Le.$7L,SourceControlInputBoxValidationType:Le.SourceControlInputBoxValidationType,ExtensionRuntime:Le.ExtensionRuntime,TimelineItem:Le.$xN,NotebookRange:Le.$pN,NotebookCellKind:Le.NotebookCellKind,NotebookCellExecutionState:Le.NotebookCellExecutionState,NotebookCellData:Le.$qN,NotebookData:Le.$rN,NotebookRendererScript:Le.$vN,NotebookCellStatusBarAlignment:Le.NotebookCellStatusBarAlignment,NotebookEditorRevealType:Le.NotebookEditorRevealType,NotebookCellOutput:Le.$tN,NotebookCellOutputItem:Le.$sN,NotebookCellStatusBarItem:Le.$uN,NotebookControllerAffinity:Le.NotebookControllerAffinity,NotebookControllerAffinity2:Le.NotebookControllerAffinity2,NotebookEdit:Le.$0L,NotebookKernelSourceAction:Le.$wN,NotebookVariablesRequestKind:Le.NotebookVariablesRequestKind,PortAttributes:Le.$zN,LinkedEditingRanges:Le.$yN,TestResultState:Le.TestResultState,TestRunRequest:Le.$AN,TestMessage:Le.$BN,TestTag:Le.$CN,TestRunProfileKind:Le.TestRunProfileKind,TextSearchCompleteMessageType:Nt.TextSearchCompleteMessageType,DataTransfer:Le.$TM,DataTransferItem:Le.$PM,CoveredCount:Le.$DN,FileCoverage:Le.$EN,StatementCoverage:Le.$FN,BranchCoverage:Le.$GN,DeclarationCoverage:Le.$HN,FunctionCoverage:Le.$HN,WorkspaceTrustState:Le.WorkspaceTrustState,LanguageStatusSeverity:Le.LanguageStatusSeverity,QuickPickItemKind:Le.QuickPickItemKind,InputBoxValidationSeverity:Le.InputBoxValidationSeverity,TabInputText:Le.$JN,TabInputTextDiff:Le.$KN,TabInputTextMerge:Le.$LN,TabInputCustom:Le.$MN,TabInputNotebook:Le.$ON,TabInputNotebookDiff:Le.$PN,TabInputWebview:Le.$NN,TabInputTerminal:Le.$QN,TabInputInteractiveWindow:Le.$RN,TabInputChat:Le.$SN,TelemetryTrustedValue:t.$Wo,LogLevel:s.LogLevel,EditSessionIdentityMatch:n.EditSessionIdentityMatch,InteractiveSessionVoteDirection:Le.InteractiveSessionVoteDirection,ChatCopyKind:Le.ChatCopyKind,InteractiveEditorResponseFeedbackKind:Le.InteractiveEditorResponseFeedbackKind,StackFrameFocus:Le.$9M,ThreadFocus:Le.$0M,RelatedInformationType:Le.RelatedInformationType,SpeechToTextStatus:Le.SpeechToTextStatus,KeywordRecognitionStatus:Le.KeywordRecognitionStatus,ChatResponseMarkdownPart:Le.$UN,ChatResponseFileTreePart:Le.$VN,ChatResponseAnchorPart:Le.$WN,ChatResponseProgressPart:Le.$XN,ChatResponseReferencePart:Le.$ZN,ChatResponseCommandButtonPart:Le.$YN,ChatRequestTurn:Le.$1N,ChatResponseTurn:Le.$2N,LanguageModelSystemMessage:Le.$3N,LanguageModelUserMessage:Le.$4N,LanguageModelAssistantMessage:Le.$5N,NewSymbolName:Le.$dN,NewSymbolNameTag:Le.NewSymbolNameTag,InlineEdit:Le.$6N,InlineEditTriggerKind:Le.InlineEditTriggerKind}}}e.$Kjc=_t}),define(Re[294],Ae([1,0,54,113,37,108,38,31,67,66,116,118,119,82,85,78,107,63,43,81,61,65,230,14,117,79,80]),function(fe,e,S,F,P,L,R,g,f,D,M,k,l,v,$,s,c,t,n,r,a,h,i,p,u,o,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,S.$0r)(o.$zic,o.$yic,1),(0,S.$0r)(p.$zj,i.$Ljc,1),(0,S.$0r)(s.$Fhc,s.$Ghc,1),(0,S.$0r)(g.$AO,g.$zO,0),(0,S.$0r)(R.$6hc,R.$4hc,0),(0,S.$0r)(t.$8hc,t.$7hc,0),(0,S.$0r)(k.$Jic,k.$Nic,0),(0,S.$0r)(L.$Pic,L.$Oic,0),(0,S.$0r)(f.$pO,f.$oO,0),(0,S.$0r)(E.$Aic,E.$Bic,0),(0,S.$0r)(n.$Jhc,n.$Ihc,0),(0,S.$0r)(F.$jjc,F.$ijc,1),(0,S.$0r)(l.$6ic,l.$7ic,0),(0,S.$0r)(v.$oic,v.$nic,0),(0,S.$0r)(M.$wjc,M.$vjc,0),(0,S.$0r)(D.$ric,D.$uic,0),(0,S.$0r)($.$pAb,$.$qAb,0),(0,S.$0r)(c.$Jjc,c.$Ijc,0),(0,S.$0r)(P.$3hc,P.$2hc,0),(0,S.$0r)(r.$wic,r.$vic,0),(0,S.$0r)(a.$yO,a.$vO,0),(0,S.$0r)(h.$fic,h.$gic,0),(0,S.$0r)(u.$Hic,u.$Iic,0)}),define(Re[295],Ae([1,0,293,39,2,290,7,11,236]),function(fe,e,S,F,P,L,R,g,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vlc=void 0;class D extends L.$Ojc{j(){}getModule(v,$){for(const s of this.b){const c=s(v);if(c){v=c;break}}if(this.a.has(v))return this.a.get(v).load(v,$,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class M extends F.$Dic{constructor(){super(...arguments),this.extensionRuntime=R.ExtensionRuntime.Webworker}async tb(){this.h.createInstance(f.$Ulc);const v=this.h.invokeFunction(S.$Kjc);this.r=this.h.createInstance(D,v,{mine:this.J,all:this.L}),await this.r.install(),performance.mark("code/extHost/didInitAPI"),await this.zb()}ub(v){return v.browser}async vb(v,$,s){$=$.with({path:k($.path,".js")});const c=v?.identifier.value;c&&performance.mark(`code/extHost/willFetchExtensionCode/${c}`);const t=P.URI.revive(await this.C.$asBrowserUri($)),n=await fetch(t.toString(!0));if(c&&performance.mark(`code/extHost/didFetchExtensionCode/${c}`),n.status!==200)throw new Error(n.statusText);const r=await n.text(),a=`${$.toString(!0)}#vscode-extension`,h=`${r}
//# sourceURL=${a}`;let i;try{i=new Function("module","exports","require",h)}catch(E){throw console.error(c?`Loading code for extension ${c} failed: ${E.message}`:`Loading code failed: ${E.message}`),console.error(`${$.toString(!0)}${typeof E.line=="number"?` line ${E.line}`:""}${typeof E.column=="number"?` column ${E.column}`:""}`),console.error(E),E}v&&await this.w.initializeLocalizedMessages(v);const p={},u={exports:p},o=E=>{const w=this.r.getModule(E,$);if(w===void 0)throw new Error(`Cannot load module '${E}'`);return w};try{return s.codeLoadingStart(),c&&performance.mark(`code/extHost/willLoadExtensionCode/${c}`),i(u,p,o),u.exports!==p?u.exports:p}finally{c&&performance.mark(`code/extHost/didLoadExtensionCode/${c}`),s.codeLoadingStop()}}async $setRemoteEnvironment(v){}async zb(v=5e3){if(!this.f.environment.isExtensionDevelopmentDebug)return;const $=Date.now()+v;for(;Date.now()<$&&!("__jsDebugIsReady"in globalThis);)await(0,g.$fh)(10)}}e.$Vlc=M;function k(l,v){return l.endsWith(v)?l:l+v}}),define(Re[296],Ae([1,0,70,54,14,39,201,84,295]),function(fe,e,S,F,P,L,R,g,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,F.$0r)(P.$yj,new S.$bi(R.$Njc,[!0],!0)),(0,F.$0r)(L.$Eic,f.$Vlc,0),(0,F.$0r)(g.$9hc,g.$0hc,0)}),define(Re[301],Ae([1,0,24,5,77,291,238,19,87,12,2,294,296]),function(fe,e,S,F,P,L,R,g,f,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const k=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const l=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function v(i){return/^(file|vscode-remote):/i.test(i)}const $=fetch.bind(self);function s(i){self.fetch=async function(p,u){return p instanceof Request||v(String(p))&&(p=(await i(M.URI.parse(String(p)))).toString(!0)),$(p,u)},self.XMLHttpRequest=class extends XMLHttpRequest{open(p,u,o,E,w){(async()=>(v(u.toString())&&(u=(await i(M.URI.parse(u.toString()))).toString(!0)),super.open(p,u,o??!0,E,w)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const i=self.Worker;Worker=function(p,u){if(/^file:/i.test(p.toString()))p=D.$yg.uriToBrowserUri(M.URI.parse(p.toString())).toString(!0);else if(/^vscode-remote:/i.test(p.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const E=`(${function(d){function y(T){return typeof T=="string"||T instanceof URL?String(T).replace(/^file:\/\//i,"vscode-file://vscode-app"):T}const b=fetch.bind(self);self.fetch=function(T,G){return T instanceof Request?b(T,G):b(y(T),G)},self.XMLHttpRequest=class extends XMLHttpRequest{open(T,G,W,U,C){return super.open(T,y(G),W??!0,U,C)}};const A=importScripts.bind(self);self.importScripts=(...T)=>{A(...T.map(y))},A(d)}.toString()}('${p}'))`;u=u||{},u.name=`${name} -> ${u.name||g.$nc(p.toString())}`;const w=new Blob([E],{type:"application/javascript"}),m=URL.createObjectURL(w);return new i(m,u)}}else self.Worker=class extends R.$Wlc{constructor(i,p){super(l,i,{name:g.$nc(i.toString()),...p})}};const c=new class{constructor(){this.pid=void 0}exit(i){k()}};class t{constructor(){const p=new MessageChannel,u=new F.$5d;let o=!1;l(p.port2,[p.port2]),p.port1.onmessage=E=>{const{data:w}=E;if(!(w instanceof ArrayBuffer)){console.warn("UNKNOWN data received",w);return}const m=S.$se.wrap(new Uint8Array(w,0,w.byteLength));if((0,P.$Fm)(m,2)){o=!0,r("received terminate message from renderer");return}u.fire(m)},this.protocol={onMessage:u.event,send:E=>{if(!o){const w=E.buffer.buffer.slice(E.buffer.byteOffset,E.buffer.byteOffset+E.buffer.byteLength);p.port1.postMessage(w,[w])}}}}}function n(i){return new Promise(p=>{const u=i.onMessage(o=>{u.dispose();const E=JSON.parse(o.toString());i.send((0,P.$Em)(0)),p({protocol:i,initData:E})});i.send((0,P.$Em)(1))})}let r=i=>k();function a(i){return!!i&&typeof i=="object"&&i.type==="vscode.init"&&i.data instanceof Map}function h(){f.mark("code/extHost/willConnectToRenderer");const i=new t;return{onmessage(p){a(p)&&n(i.protocol).then(u=>{f.mark("code/extHost/didWaitForInitData");const o=new L.$Qjc(u.protocol,u.initData,c,null,p.data);s(E=>o.asBrowserUri(E)),r=E=>o.terminate(E)})}}}e.create=h})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/863d2581ecda6849923a2118d93a088b0745d9d6/core/vs/workbench/api/worker/extensionHostWorker.js.map
